﻿% ---------------------------------------------------------------------------
% File: afl.pl
% Content: abstract foundation layer (AFL) package for FLAME (refactored)
% Author: Amador Durán Toro
% Version: 3.0
% Date: 19/03/2015 (Día del Padre)
% ---------------------------------------------------------------------------

:- consult( 'sets.pl'                  ). % set toolkit
:- consult( 'bags.pl'                  ). % bag toolkit
:- consult( 'check_spl.pl'             ). % abstract SPL checking - comment for coverage analysis
:- consult( 'valid_product.pl'         ). % 01 - product validity
:- consult( 'why_not_valid_product.pl' ). % product invalidity explanation - comment for coverage analysis
:- consult( 'valid_configuration.pl'   ). % 02 - configuration validity
:- consult( 'full_configuration.pl'    ). % full configuration
:- consult( 'partial_configuration.pl' ). % partial configuration
:- consult( 'products.pl'              ). % 03 - products
:- consult( 'products_verbose.pl'      ). % products (verbose) - comment for coverage analysis
:- consult( 'number_of_products.pl'    ). % 04 - number of products
:- consult( 'void.pl'                  ). % 05 - void SPL
:- consult( 'equivalent.pl'            ). % 06 - equivalent relation
:- consult( 'specialization.pl'        ). % 07 - specialization relation
:- consult( 'generalization.pl'        ). % 08 - generalization relation
:- consult( 'arbitrary_edit.pl'        ). % 09 - arbitrary edit relation
:- consult( 'filter.pl'                ). % 10 - filter
:- consult( 'core_features.pl'         ). % 11 - core features
:- consult( 'dead_features.pl'         ). % 12 - dead features
:- consult( 'variant_features.pl'      ). % 13 - variant features
:- consult( 'unique_features.pl'       ). % 14 - unique features
:- consult( 'atomic_sets.pl'           ). % 15 - atomic sets
:- consult( 'commonality.pl'           ). % 16 - commonality indicator
:- consult( 'variability.pl'           ). % 17 - variability indicator
:- consult( 'partial_variability.pl'   ). % 18 - commonality indicator
:- consult( 'homogeneity.pl'           ). % 19, 20 - homogeneity indicators
