﻿% -----------------------------------------------------------------------------
% File: arbitrary_edit.pl
% Content: Arbitrary edit relation of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   _arbitrary_edit_ : SPL <-> SPL
%
% Prolog predicates
%   arbitrary_edit( spl( F1, M1 ), spl( F2, M2 ) )
%
% It checks if both SPLs are an arbitrary edit.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% arbitrary_edit( spl( F1, M1 ), spl( F2, M2 ) )
% It checks if both SPLs are an arbitrary edit of each other.
% -----------------------------------------------------------------------------

arbitrary_edit( spl( F1, M1 ), spl( F2, M2 ) ) :-
  not( equivalent( spl( F1, M1 ), spl( F2, M2 ) ) ),
  not( specialization( spl( F1, M1 ), spl( F2, M2 ) ) ),
  not( generalization( spl( F1, M1 ), spl( F2, M2 ) ) ).
