﻿% -----------------------------------------------------------------------------
% File: core_features.pl
% Content: Core features function of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   coreFeatures : SPL -> F Feature
%
% Prolog predicates
%   core_features( SPL, [ Feature ] )
%
% It computes the set of core features of an SPL.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% core_features( SPL, [ Feature ] )
% It computes the set of core features of an SPL
% -----------------------------------------------------------------------------

core_features( spl( F, M ), C ) :-
  products( spl( F, M ), PRDS ),
  intersection( PRDS, C ).
