﻿% -----------------------------------------------------------------------------
% File: dead_features.pl
% Content: Dead features function of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   deadFeatures : SPL -> F Feature
%
% Prolog predicates
%   dead_features( SPL, [ Feature ] )
%
% It computes the set of dead features of an SPL.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% dead_features( SPL, [ Feature ] )
% It computes the set of dead features of an SPL
% -----------------------------------------------------------------------------

dead_features( spl( F, M ), D ) :-
  products( spl( F, M ), PRDS ),
  union( PRDS, U ),
  subtract( F, U, D ).
