﻿% -----------------------------------------------------------------------------
% File: equivalent.pl
% Content: Equivalent relation of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   _equivalent_ : SPL <-> SPL
%
% Prolog predicates
%   equivalent( spl( F1, M1 ), spl( F2, M2 ) )
%
% It checks if both SPLs are equivalent.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% equivalent( spl( F1, M1 ), spl( F2, M2 ) )
% It checks if both SPLs are equivalent.
% -----------------------------------------------------------------------------

equivalent( spl( F1, M1 ), spl( F2, M2 ) ) :-
  products( spl( F1, M1 ), PRDS1 ),
  products( spl( F2, M2 ), PRDS2 ),
  equal_superset( PRDS1, PRDS2 ).
