% -----------------------------------------------------------------------------
% File: filter.pl
% Content: SPL filtering of FLAME
% Author: Amador Durán Toro
% Version: 2.0
% Date: 14/11/2013
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   filter : SPL x Configuration -> F Product
%
% Prolog predicates
%   filter( spl( Features, Model ), configuration( S, R ), Result )
%
% This predicate returns the set of products of the SPL according to the
% configuration.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% filter( spl( Features, Model ), configuration( S, R ), Result )
% It returns the set of products of the SPL according to the configuration.
% -----------------------------------------------------------------------------

filter( spl( F, M ), configuration( S, R ), RESULT ) :-
  products( spl( F, M ), PRDS ),
  findall( P, ( member( P, PRDS ), 
                valid_p_c( P, configuration( S, R ) ) ), RESULT ).
