﻿% -----------------------------------------------------------------------------
% File: number_of_products.pl
% Content: Number of products function of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   nop : SPL -> N
%
% Prolog predicates (public)
%   nop( spl( Features, Model ), N )
%
% It returns the number of products, i.e. the cardinality of the set of valid
% products.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% nop( spl( Features, Model ), NoP )
% It computes the number of products of an SPL.
% -----------------------------------------------------------------------------

nop( spl( F, M ), NOP ) :-
  products( spl( F, M ), PRDS ),
  length( PRDS, NOP ).
