﻿% -----------------------------------------------------------------------------
% File: partial_variability.pl
% Content: Partial variability indicator of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.1
% Date: 01/03/2015
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   pvariability : SPL -> R
%
% Prolog predicates
%   partial_variability( SPL, PV )
%
% It computes the partial variability of an SPL.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% partial_variability( SPL, V )
% It computes the partial variability of an SPL
% -----------------------------------------------------------------------------

partial_variability( spl( F, M ), 0 ) :-
  variant_features( spl( F, M ), [] ), !.

partial_variability( spl( F, M ), PV ) :-
  nop( spl( F, M ), N ),
  variant_features( spl( F, M ), VF ),
  length( VF, NOVF ),
  PV is N / ( 2**NOVF - 1 ).
