﻿% -----------------------------------------------------------------------------
% File: specialization.pl
% Content: Specialization relation of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   _specialization_ : SPL <-> SPL
%
% Prolog predicates
%   specialization( spl( F1, M1 ), spl( F2, M2 ) )
%
% It checks if the first SPL is a specialization of the second.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% specialization( spl( F1, M1 ), spl( F2, M2 ) )
% It checks if the first SPL is a specialization of the second.
% -----------------------------------------------------------------------------

specialization( spl( F1, M1 ), spl( F2, M2 ) ) :-
  products( spl( F1, M1 ), PRDS1 ),
  products( spl( F2, M2 ), PRDS2 ),
  proper_subset_superset( PRDS1, PRDS2 ).
