﻿% -----------------------------------------------------------------------------
% File: unique_features.pl
% Content: Unique features function of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   uniqueFeatures : SPL -> F Feature
%
% Prolog predicates
%   unique_features( SPL, [ Feature ] )
%
% It computes the set of unique features of an SPL.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% unique_features( SPL, [ Feature ] )
% It computes the set of unique features of an SPL
% -----------------------------------------------------------------------------

unique_features( spl( F, M ), RESULT ) :-
  products( spl( F, M ), PRDS ),
  findall( Fu, ( member( Fu, F ), unique( Fu, PRDS ) ), RESULT ).

unique( Fu, PRDS ) :-
  findall( P, ( member( P, PRDS ), member( Fu, P ) ), RESULT ),
  length( RESULT, 1 ).
