﻿% -----------------------------------------------------------------------------
% File: valid_product.pl
% Content: Valid product relation of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   _valid_     : Product <-> SPL
%
% Prolog predicates
%   valid( Product, spl( Features, Model ) )
%
% It checks if a product is valid for an SPL.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% valid( Product, spl( Features, Model ) )
% It checks if a product is valid for an SPL using the abstract predicate
% instance_of, that must redefined in the characteristic model layer.
% -----------------------------------------------------------------------------

valid( P, spl( F, M ) ) :-
  subset( P, F ),
  instance_of( P, M ).  % abstract predicate
