﻿% -----------------------------------------------------------------------------
% File: variability.pl
% Content: Variability indicator of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   variability : SPL -> R
%
% Prolog predicates
%   variability( SPL, V )
%
% It computes the (total) variability of an SPL.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% variability( SPL, V )
% It computes the (total) variability of an SPL
% -----------------------------------------------------------------------------

variability( spl( F, M ), V ) :-
  nop( spl( F, M ), N ),
  length( F, NOF ),
  V is N / ( 2**NOF - 1 ).
