﻿% -----------------------------------------------------------------------------
% File: variant_features.pl
% Content: Variant features function of FLAME (refactored)
% Author: Amador Durán Toro
% Version: 2.0
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   variantFeatures : SPL -> F Feature
%
% Prolog predicates
%   variant_features( SPL, [ Feature ] )
%
% It computes the set of variant features of an SPL.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% variant_features( SPL, [ Feature ] )
% It computes the set of variant features of an SPL
% -----------------------------------------------------------------------------

variant_features( spl( F, M ), V ) :-
  core_features( spl( F, M ), C ),
  dead_features( spl( F, M ), D ),
  subtract( F, C, VAUX ),
  subtract( VAUX, D, V ).
