﻿% -----------------------------------------------------------------------------
% File: void.pl
% Content: Void SPL predicate (refactored)
% Author: Amador Durán Toro
% Version: 2.1
% Date: 22/07/2014
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   void: P SPL
%
% Prolog predicates (public)
%   void( spl( Features, Model )
%
% It checks if an SPL is void, i.e. if its set of products is empty.
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% void( spl( Features, Model ) )
% It computes if the SPL is void (it always match with products).
% -----------------------------------------------------------------------------

void( spl( F, M ) ) :-
  products( spl( F, M ), PRDS ), !,
  PRDS = [].
