﻿% -----------------------------------------------------------------------------
% File: features.pl
% Content: BFM features-in-a-model function for FLAME
% Author: Amador Durán Toro
% Version: 2.0
% Date: 19/03/2015
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   features : Model -> F Feature
%
% Prolog predicates
%   features( Model, [ Feature ] )
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% features( Model, [ Feature ] )
% It computes the features in a BMF characteristic model
% -----------------------------------------------------------------------------

features( bfm( TREE, CTC ), F ) :-
  t_features( TREE, F1 ),
  for_each_union( x_features, CTC, F2 ),
  union( F1, F2, F ).
