﻿% -----------------------------------------------------------------------------
% File: x_features.pl
% Content: BFM features-in-a-model auxiliary function for FLAME
% Author: Amador Durán Toro
% Version: 2.0
% Date: 18/03/2015
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% Z definitions
%   xfeatures : CTC -> F Feature
%
% Prolog predicates
%   x_features( CTC, [ Feature ] )
% -----------------------------------------------------------------------------

% -----------------------------------------------------------------------------
% x_features( CTC, [ Feature ] )
% It computes the features in a CTC.
% -----------------------------------------------------------------------------

x_features( requires( F1, F2 ), F ) :-
  x_features( excludes( F1, F2 ), F ).

x_features( excludes( F1, F2 ), F ) :-
  x_feature_bag( excludes( F1, F2 ), B ),
  bag_domain( B, F ).

%x_features( excludes( F1, F2 ), F ) :-
%  union( [ F1 ], [ F2 ], F ).
