@echo off
REM -------------------------------------------------------------------------
REM File: BeTTy_run_tests.bat
REM Content: Script for running FLAME-BFM metamorphic tests
REM Author: Amador Durn Toro
REM Version: 1.1
REM Date: 15/09/2014
REM -------------------------------------------------------------------------
setlocal enabledelayedexpansion
chcp 850
cls
echo:
echo ---------------------------------------
echo  FLAME-BFM tests suite
echo  Generated by the BeTTy framework
echo  P. Trinidad ^& S. Segura ^& A. Durn
echo  ISA Group - U. of Seville (2015)
echo ---------------------------------------
echo:
choice /m "Do you want coverage analysis " /c YN /d Y /t 10
if !errorlevel!==1 (set coverage="true")
if !errorlevel!==2 (set coverage=)
if defined coverage (
  set preamble=BeTTy_00_preamble_coverage.pl
  set epilog=BeTTy_00_epilog_coverage.pl
)
if not defined coverage (
  set preamble=BeTTy_00_preamble.pl
  set epilog=BeTTy_00_epilog.pl
)
set errors_file=BeTTy_ouput.txt
set coverage_file=BeTTy_coverage.txt
echo:
if exist !errors_file! del !errors_file!
if defined coverage (
   if exist !coverage_file! del !coverage_file!
)
echo Test execution started at !time!, please wait...
echo:
for %%f in (*.plt) do (
  set consult_line=:- consult^(^'%%f^'^)
  if exist %%~nf_generated.pl del %%~nf_generated.pl  
  copy /y !preamble! %%~nf_generated.pl > nul
  echo !consult_line!.>>%%~nf_generated.pl
  type !epilog!>>%%~nf_generated.pl
  echo Running tests in %%f ...
  if defined coverage ( 
    swipl --quiet -s %%~nf_generated.pl >> !coverage_file! 2>> !errors_file!
  )
  if not defined coverage (
    swipl --quiet -s %%~nf_generated.pl 2>> !errors_file!  
  )
)
echo:
echo Test execution finished at !time!. 
echo:
if defined coverage (
  echo See !errors_file! and !coverage_file! for test and coverage results.
)
if not defined coverage (
  echo See !errors_file! for test results.
)
echo:
choice /m "Clean all generated auxiliary files " /c YN /d Y /t 10
if !errorlevel!==1 (
  echo:
  echo Deleting generated auxiliary files...
  for %%f in (*_generated.pl) do (
    del %%f
  )
)
if !errorlevel!==2 (
  echo:
  echo OK, keeping generated auxiliary files.
)
echo:
echo Thanks for using FLAME ^& BeTTy.
echo:
