% ---------------
% Auxiliary predicates to support true/false as a parameter.
% ---------------
isValidProduct(Product,Spl,true) :- !, valid(Product,Spl).
isValidProduct(Product,Spl,false) :-  !, not(valid(Product,Spl)).
% ---------------
spl_db( test_0,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f6 , f7 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(test_0,valid_products,[root,f1,f2,f3,f5,f6,f8,f9],false).


% ---------------
spl_db( test_1,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f2 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_1,valid_products,[root,f1,f5,f6],false).


% ---------------
spl_db( test_2,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_2,valid_products,[root,f3,f5,f6,f9,f2],false).


% ---------------
spl_db( test_3,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f1 , f5 ) ]
		)
	)
).

test_data(test_3,valid_products,[f1,f4,f5,f6,f8,f3],false).


% ---------------
spl_db( test_4,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(test_4,valid_products,[root,f4,f8],false).


% ---------------
spl_db( test_5,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f4, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(test_5,valid_products,[root,f2,f4,f8,f9],false).


% ---------------
spl_db( test_6,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_6,valid_products,[root,f5,f6],false).


% ---------------
spl_db( test_7,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_7,valid_products,[root,f1,f2,f3,f4,f6,f7],true).


% ---------------
spl_db( test_8,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_8,valid_products,[root,f1,f2,f6],false).


% ---------------
spl_db( test_9,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_9,valid_products,[f1,f3,f5,f7],false).


% ---------------
spl_db( test_10,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

test_data(test_10,valid_products,[root,f2,f4],false).


% ---------------
spl_db( test_11,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f7 , f6 ), requires( f8 , f4 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(test_11,valid_products,[root,f1,f3,f2],false).


% ---------------
spl_db( test_12,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(test_12,valid_products,[root,f1,f4,f6,f7],true).


% ---------------
spl_db( test_13,
	 spl( [ root, f1, f2, f5, f3, f9, f4, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_13,valid_products,[root,f1,f3,f4,f6,f7,f8],true).


% ---------------
spl_db( test_14,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_14,valid_products,[root,f1,f2,f4,f6,f7,f9],true).


% ---------------
spl_db( test_15,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_15,valid_products,[root,f2,f7],false).


% ---------------
spl_db( test_16,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f4, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_16,valid_products,[root,f3,f4],false).


% ---------------
spl_db( test_17,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_17,valid_products,[root,f1,f2,f3,f4],false).


% ---------------
spl_db( test_18,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(test_18,valid_products,[root,f3,f5,f7,f8],false).


% ---------------
spl_db( test_19,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_19,valid_products,[root,f1,f2,f7,f9],false).


% ---------------
spl_db( test_20,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f1 ), excludes( f5 , f9 ) ]
		)
	)
).

test_data(test_20,valid_products,[root,f3,f4,f7],false).


% ---------------
spl_db( test_21,
	 spl( [ root, f1, f8, f2, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f1 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_21,valid_products,[root,f2,f4],false).


% ---------------
spl_db( test_22,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_22,valid_products,[root,f1,f3,f4,f6,f8],false).


% ---------------
spl_db( test_23,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_23,valid_products,[root,f4,f5,f7],false).


% ---------------
spl_db( test_24,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_24,valid_products,[root,f1,f2,f4,f5,f7,f8],true).


% ---------------
spl_db( test_25,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
						mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_25,valid_products,[root,f1,f2,f3,f9],false).


% ---------------
spl_db( test_26,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_26,valid_products,[root,f3,f5],false).


% ---------------
spl_db( test_27,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_27,valid_products,[root,f4,f5,f6,f8],true).


% ---------------
spl_db( test_28,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_28,valid_products,[root,f2,f3,f5,f6,f9],true).


% ---------------
spl_db( test_29,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f6 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_29,valid_products,[root,f3,f5,f8],true).


% ---------------
spl_db( test_30,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_30,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_31,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_31,valid_products,[root,f1,f3,f4,f5,f8],false).


% ---------------
spl_db( test_32,
	 spl( [ root, f1, f3, f4, f5, f2, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_32,valid_products,[root,f1,f3,f4,f8],false).


% ---------------
spl_db( test_33,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_33,valid_products,[root,f1,f2,f5,f6,f7,f8],false).


% ---------------
spl_db( test_34,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_34,valid_products,[root,f1,f2,f5,f6,f8],false).


% ---------------
spl_db( test_35,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(test_35,valid_products,[root,f1,f3,f5,f7],false).


% ---------------
spl_db( test_36,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f7 , f1 ) ]
		)
	)
).

test_data(test_36,valid_products,[root,f2,f5,f7,f8],false).


% ---------------
spl_db( test_37,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(test_37,valid_products,[root],false).


% ---------------
spl_db( test_38,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_38,valid_products,[root,f1,f2,f3,f4,f5,f6,f8],false).


% ---------------
spl_db( test_39,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_39,valid_products,[root,f5,f8],false).


% ---------------
spl_db( test_40,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_40,valid_products,[root,f5,f7,f2],false).


% ---------------
spl_db( test_41,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f7 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_41,valid_products,[root,f2,f4,f5,f6],true).


% ---------------
spl_db( test_42,
	 spl( [ root, f1, f2, f5, f8, f6, f7, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f3 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_42,valid_products,[root,f1,f2,f3,f5,f7,f8],true).


% ---------------
spl_db( test_43,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_43,valid_products,[root,f1,f2,f4,f6],true).


% ---------------
spl_db( test_44,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_44,valid_products,[root,f1,f2,f3,f4,f6,f7],true).


% ---------------
spl_db( test_45,
	 spl( [ root, f1, f3, f7, f8, f9, f4, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(test_45,valid_products,[root,f1,f2,f3,f4,f7,f5],false).


% ---------------
spl_db( test_46,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f9 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_46,valid_products,[root,f1,f2,f3,f7,f8],false).


% ---------------
spl_db( test_47,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f7, [
						mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f8 , f3 ), excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_47,valid_products,[root,f1,f3,f4,f7,f8,f9],true).


% ---------------
spl_db( test_48,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_48,valid_products,[root,f4,f6,f8],false).


% ---------------
spl_db( test_49,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f8 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(test_49,valid_products,[f2,f4,f6,f8],false).


% ---------------
spl_db( test_50,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_50,valid_products,[root,f1,f2,f3,f6,f9],true).


% ---------------
spl_db( test_51,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f5 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_51,valid_products,[root,f1,f2,f3,f4,f5,f6,f8],true).


% ---------------
spl_db( test_52,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(test_52,valid_products,[f1,f2,f3,f5,f6,f9],false).


% ---------------
spl_db( test_53,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f7 ), requires( f3 , f6 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(test_53,valid_products,[root,f2,f3,f8],false).


% ---------------
spl_db( test_54,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(test_54,valid_products,[root,f1,f2,f3,f4,f5,f6],false).


% ---------------
spl_db( test_55,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f2, f3, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_55,valid_products,[root,f1,f4,f7],false).


% ---------------
spl_db( test_56,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(test_56,valid_products,[root,f2,f3,f5,f6],false).


% ---------------
spl_db( test_57,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(test_57,valid_products,[root,f1,f4,f5,f6,f7],true).


% ---------------
spl_db( test_58,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_58,valid_products,[root,f1,f6,f8],false).


% ---------------
spl_db( test_59,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(test_59,valid_products,[root,f1,f2,f4,f7],false).


% ---------------
spl_db( test_60,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_60,valid_products,[root,f2,f3,f6,f1],false).


% ---------------
spl_db( test_61,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f5 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_61,valid_products,[root,f1,f2,f3,f6,f8,f5],false).


% ---------------
spl_db( test_62,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_62,valid_products,[root,f1,f2,f3,f4,f6,f8,f7],false).


% ---------------
spl_db( test_63,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f8 , f4 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_63,valid_products,[root,f3,f4,f5,f6,f7,f8],false).


% ---------------
spl_db( test_64,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_64,valid_products,[root,f1,f3,f7,f8],false).


% ---------------
spl_db( test_65,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_65,valid_products,[root,f1,f2,f3,f4,f5,f9],true).


% ---------------
spl_db( test_66,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_66,valid_products,[root,f1,f4,f5,f6,f8,f7],false).


% ---------------
spl_db( test_67,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_67,valid_products,[root,f1,f4,f6],true).


% ---------------
spl_db( test_68,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f8 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_68,valid_products,[root,f2,f5,f9],false).


% ---------------
spl_db( test_69,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_69,valid_products,[root,f1,f3,f4,f5,f7],true).


% ---------------
spl_db( test_70,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_70,valid_products,[root,f5,f6,f4],false).


% ---------------
spl_db( test_71,
	 spl( [ root, f1, f2, f6, f3, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f2 , f7 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(test_71,valid_products,[root,f4,f7,f8,f9],false).


% ---------------
spl_db( test_72,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_72,valid_products,[root,f2,f4,f5,f6],false).


% ---------------
spl_db( test_73,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(test_73,valid_products,[root,f1,f6,f7,f8],false).


% ---------------
spl_db( test_74,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_74,valid_products,[root,f2,f4,f5,f6,f7],false).


% ---------------
spl_db( test_75,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f1 , f5 ) ]
		)
	)
).

test_data(test_75,valid_products,[root,f3,f4,f5,f6,f8,f2],false).


% ---------------
spl_db( test_76,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f4 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(test_76,valid_products,[root,f5,f7],false).


% ---------------
spl_db( test_77,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f3, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_77,valid_products,[root,f1,f2,f6,f7],false).


% ---------------
spl_db( test_78,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f6, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f6, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f8 , f3 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(test_78,valid_products,[root,f3,f4,f7,f9],false).


% ---------------
spl_db( test_79,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(test_79,valid_products,[root,f1,f4,f7,f8],false).


% ---------------
spl_db( test_80,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_80,valid_products,[root,f1,f2,f5,f6,f8,f7],false).


% ---------------
spl_db( test_81,
	 spl( [ root, f1, f2, f6, f9, f7, f3, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_81,valid_products,[f1,f4,f8,f2],false).


% ---------------
spl_db( test_82,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f7 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_82,valid_products,[root,f1,f2,f3,f4,f5,f7,f9],true).


% ---------------
spl_db( test_83,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

test_data(test_83,valid_products,[root,f1,f2,f3,f5,f6,f9],false).


% ---------------
spl_db( test_84,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f9 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(test_84,valid_products,[root,f1,f2,f3,f6,f9],false).


% ---------------
spl_db( test_85,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f8 ), requires( f1 , f8 ) ]
		)
	)
).

test_data(test_85,valid_products,[root,f2,f3,f4,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_86,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(test_86,valid_products,[root,f2,f4,f6],false).


% ---------------
spl_db( test_87,
	 spl( [ root, f1, f2, f6, f7, f3, f9, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
					optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f6 ), requires( f3 , f4 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(test_87,valid_products,[root,f1,f2,f3,f4,f9],false).


% ---------------
spl_db( test_88,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_88,valid_products,[root,f1,f3,f4,f5,f8,f9],true).


% ---------------
spl_db( test_89,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_89,valid_products,[root,f2,f3,f4,f5],false).


% ---------------
spl_db( test_90,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f3 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_90,valid_products,[root,f1,f2,f3,f4,f6,f8],true).


% ---------------
spl_db( test_91,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f6 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_91,valid_products,[root,f1,f2,f3,f6,f7],false).


% ---------------
spl_db( test_92,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_92,valid_products,[root,f2,f3,f4,f5,f8,f9],false).


% ---------------
spl_db( test_93,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_93,valid_products,[root,f1,f2,f4,f5,f9],false).


% ---------------
spl_db( test_94,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_94,valid_products,[root,f1],false).


% ---------------
spl_db( test_95,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f2, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_95,valid_products,[root,f1,f2,f3,f4,f6,f8],true).


% ---------------
spl_db( test_96,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_96,valid_products,[root,f1,f2,f3,f4,f5],false).


% ---------------
spl_db( test_97,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_97,valid_products,[root,f4,f7,f8],false).


% ---------------
spl_db( test_98,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_98,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_99,
	 spl( [ root, f1, f2, f3, f5, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f5 ), requires( f8 , f6 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_99,valid_products,[f1],false).


% ---------------
spl_db( test_100,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_100,valid_products,[root,f2,f4,f6],false).


% ---------------
spl_db( test_101,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f5 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_101,valid_products,[root,f3,f4,f9],false).


% ---------------
spl_db( test_102,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_102,valid_products,[root,f1,f2,f6],false).


% ---------------
spl_db( test_103,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(test_103,valid_products,[root,f6,f8,f5],false).


% ---------------
spl_db( test_104,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f9 ), requires( f4 , f1 ) ]
		)
	)
).

test_data(test_104,valid_products,[root,f1,f2,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_105,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f3 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_105,valid_products,[root,f1,f3,f8,f9],false).


% ---------------
spl_db( test_106,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_106,valid_products,[root,f2,f3,f4,f5],false).


% ---------------
spl_db( test_107,
	 spl( [ root, f1, f8, f2, f3, f4, f6, f9, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					one_or_more( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f8 , f3 ) ]
		)
	)
).

test_data(test_107,valid_products,[root,f8],false).


% ---------------
spl_db( test_108,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_108,valid_products,[root,f1,f2,f5,f7,f8],false).


% ---------------
spl_db( test_109,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f7, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(test_109,valid_products,[root,f2],false).


% ---------------
spl_db( test_110,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f5 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(test_110,valid_products,[root,f5],false).


% ---------------
spl_db( test_111,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(test_111,valid_products,[root,f2,f4,f7,f8,f5],false).


% ---------------
spl_db( test_112,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_112,valid_products,[f1,f3,f5,f2],false).


% ---------------
spl_db( test_113,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(test_113,valid_products,[f1,f2,f3,f4,f6,f8,f5,f7],false).


% ---------------
spl_db( test_114,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_114,valid_products,[root,f1,f2,f3,f8,f9],true).


% ---------------
spl_db( test_115,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(test_115,valid_products,[root,f1,f2,f3,f4,f6,f7],true).


% ---------------
spl_db( test_116,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_116,valid_products,[root,f1,f3,f4,f5,f6,f7,f8],false).


% ---------------
spl_db( test_117,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(test_117,valid_products,[root,f1,f3,f5,f6,f7,f9],true).


% ---------------
spl_db( test_118,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_118,valid_products,[root,f1,f2,f3,f4,f5,f6],false).


% ---------------
spl_db( test_119,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_119,valid_products,[root,f1,f2,f4,f5,f6,f8],true).


% ---------------
spl_db( test_120,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f9 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(test_120,valid_products,[root,f4],false).


% ---------------
spl_db( test_121,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f4 , f7 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_121,valid_products,[root,f4,f6,f7],false).


% ---------------
spl_db( test_122,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(test_122,valid_products,[root,f4,f7,f9],false).


% ---------------
spl_db( test_123,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_123,valid_products,[root,f3,f6,f8,f9],false).


% ---------------
spl_db( test_124,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(test_124,valid_products,[root,f3],false).


% ---------------
spl_db( test_125,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(test_125,valid_products,[root,f1,f2,f3,f4,f5,f6],true).


% ---------------
spl_db( test_126,
	 spl( [ root, f1, f8, f9, f2, f7, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_126,valid_products,[root,f1,f2,f4,f5,f6,f7,f8],true).


% ---------------
spl_db( test_127,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_127,valid_products,[f1,f3,f4,f5,f6,f8,f9],false).


% ---------------
spl_db( test_128,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f1 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_128,valid_products,[f2,f4,f6,f7,f3],false).


% ---------------
spl_db( test_129,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_129,valid_products,[f2,f4,f6,f8,f9],false).


% ---------------
spl_db( test_130,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f1 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(test_130,valid_products,[f1,f4,f5,f6,f7,f8,f9],false).


% ---------------
spl_db( test_131,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_131,valid_products,[root,f5,f8],false).


% ---------------
spl_db( test_132,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
						optional( feature( f8, [] ) ) ] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_132,valid_products,[root,f1,f2,f3,f4,f5,f6,f7],false).


% ---------------
spl_db( test_133,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f9, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_133,valid_products,[root,f2,f8,f3],false).


% ---------------
spl_db( test_134,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_134,valid_products,[root],false).


% ---------------
spl_db( test_135,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(test_135,valid_products,[root,f1,f2,f4,f5,f8,f9],false).


% ---------------
spl_db( test_136,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ), excludes( f9 , f1 ) ]
		)
	)
).

test_data(test_136,valid_products,[root,f1,f3,f4],false).


% ---------------
spl_db( test_137,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_137,valid_products,[root,f3,f6,f4],false).


% ---------------
spl_db( test_138,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_138,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_139,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f7 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(test_139,valid_products,[root,f1,f2,f4,f6,f7],true).


% ---------------
spl_db( test_140,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_140,valid_products,[root,f1,f2,f4,f6,f8,f9],true).


% ---------------
spl_db( test_141,
	 spl( [ root, f1, f3, f7, f8, f4, f5, f9, f6, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f6 , f3 ), excludes( f2 , f8 ) ]
		)
	)
).

test_data(test_141,valid_products,[root,f2],true).


% ---------------
spl_db( test_142,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(test_142,valid_products,[root,f2,f3,f4,f6,f8,f9,f7],false).


% ---------------
spl_db( test_143,
	 spl( [ root, f1, f2, f3, f5, f9, f4, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f2 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(test_143,valid_products,[root,f1,f2,f3,f4],false).


% ---------------
spl_db( test_144,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

test_data(test_144,valid_products,[root,f1,f3,f9,f2],false).


% ---------------
spl_db( test_145,
	 spl( [ root, f1, f2, f6, f3, f4, f5, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(test_145,valid_products,[root,f1,f2,f5,f7,f9,f8],false).


% ---------------
spl_db( test_146,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_146,valid_products,[root,f1,f2,f5,f8,f9],false).


% ---------------
spl_db( test_147,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_147,valid_products,[root,f1,f4,f7,f8,f6],false).


% ---------------
spl_db( test_148,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(test_148,valid_products,[root,f2,f3,f4,f5,f8,f9,f1],false).


% ---------------
spl_db( test_149,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(test_149,valid_products,[f1,f3,f4,f5,f6,f7],false).


% ---------------
spl_db( test_150,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_150,valid_products,[root,f1,f2,f3,f5,f7,f8],true).


% ---------------
spl_db( test_151,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_151,valid_products,[root,f2,f3,f5,f7],false).


% ---------------
spl_db( test_152,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f8 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_152,valid_products,[root,f4,f5,f6],true).


% ---------------
spl_db( test_153,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f5 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_153,valid_products,[f1,f2,f3,f5,f7],false).


% ---------------
spl_db( test_154,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f6, f5, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_154,valid_products,[root],false).


% ---------------
spl_db( test_155,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(test_155,valid_products,[root,f4,f6,f9],false).


% ---------------
spl_db( test_156,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_156,valid_products,[root,f4,f5,f6,f8],false).


% ---------------
spl_db( test_157,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f6 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_157,valid_products,[root,f2,f4,f6,f7,f8],false).


% ---------------
spl_db( test_158,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f3 , f4 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_158,valid_products,[root,f1,f2,f3,f4,f5,f8],true).


% ---------------
spl_db( test_159,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					optional( feature( f9, [] ) ) ] ), feature( f3, [] ), feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_159,valid_products,[root,f1,f5,f6,f7,f8],false).


% ---------------
spl_db( test_160,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_160,valid_products,[root,f1,f2,f4,f5,f6,f8],true).


% ---------------
spl_db( test_161,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f3, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f5, [
						mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_161,valid_products,[root,f3],false).


% ---------------
spl_db( test_162,
	 spl( [ root, f1, f4, f5, f8, f6, f7, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f7 ), requires( f2 , f3 ) ]
		)
	)
).

test_data(test_162,valid_products,[root,f1,f3,f4,f6,f7,f9],true).


% ---------------
spl_db( test_163,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_163,valid_products,[root,f2,f3,f4,f6,f8],false).


% ---------------
spl_db( test_164,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_164,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],false).


% ---------------
spl_db( test_165,
	 spl( [ root, f1, f8, f2, f7, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_165,valid_products,[root],false).


% ---------------
spl_db( test_166,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f4 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_166,valid_products,[root,f2,f5,f8],false).


% ---------------
spl_db( test_167,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_167,valid_products,[root,f1,f5],false).


% ---------------
spl_db( test_168,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_168,valid_products,[root,f4,f6,f8],true).


% ---------------
spl_db( test_169,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(test_169,valid_products,[root,f1,f4,f7,f9],false).


% ---------------
spl_db( test_170,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_170,valid_products,[root,f1,f6],false).


% ---------------
spl_db( test_171,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_171,valid_products,[root,f1,f2,f4,f5,f7,f8,f9],false).


% ---------------
spl_db( test_172,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(test_172,valid_products,[root,f2,f4,f7,f6],false).


% ---------------
spl_db( test_173,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f4 , f1 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(test_173,valid_products,[root,f1,f2,f3,f5,f6,f7,f8],true).


% ---------------
spl_db( test_174,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

test_data(test_174,valid_products,[root,f2,f3,f5,f8],false).


% ---------------
spl_db( test_175,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(test_175,valid_products,[root,f1,f4,f5],false).


% ---------------
spl_db( test_176,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_176,valid_products,[root,f1,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_177,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f3, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f2 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_177,valid_products,[root,f1,f2,f4,f5,f6,f9],false).


% ---------------
spl_db( test_178,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(test_178,valid_products,[root,f2,f4,f5,f6,f8],true).


% ---------------
spl_db( test_179,
	 spl( [ root, f1, f8, f9, f2, f4, f5, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_179,valid_products,[root,f1,f2,f3,f4,f5,f7,f8],true).


% ---------------
spl_db( test_180,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f8 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_180,valid_products,[root,f1,f2,f3,f6],false).


% ---------------
spl_db( test_181,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_181,valid_products,[root,f1,f2,f3,f5],false).


% ---------------
spl_db( test_182,
	 spl( [ root, f1, f2, f3, f5, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(test_182,valid_products,[root,f1,f2,f5],false).


% ---------------
spl_db( test_183,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(test_183,valid_products,[root,f1,f5,f7,f9],false).


% ---------------
spl_db( test_184,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_184,valid_products,[root,f1,f2,f3,f4,f6,f7,f8],true).


% ---------------
spl_db( test_185,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_185,valid_products,[f3,f4,f5,f6],false).


% ---------------
spl_db( test_186,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), requires( f2 , f5 ) ]
		)
	)
).

test_data(test_186,valid_products,[root,f1,f3,f8],false).


% ---------------
spl_db( test_187,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_187,valid_products,[root,f2,f4,f6,f8,f9],false).


% ---------------
spl_db( test_188,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f8 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_188,valid_products,[root,f2,f3,f4,f8,f9],false).


% ---------------
spl_db( test_189,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

test_data(test_189,valid_products,[root,f1,f3,f4,f8],false).


% ---------------
spl_db( test_190,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
						optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f5 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_190,valid_products,[root,f1,f2,f3,f6,f5],false).


% ---------------
spl_db( test_191,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_191,valid_products,[root,f2,f3,f7,f8,f9],false).


% ---------------
spl_db( test_192,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f3 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_192,valid_products,[root,f2,f3],false).


% ---------------
spl_db( test_193,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f2 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_193,valid_products,[root,f2,f3],false).


% ---------------
spl_db( test_194,
	 spl( [ root, f1, f2, f3, f8, f4, f7, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(test_194,valid_products,[root,f1,f5],false).


% ---------------
spl_db( test_195,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_195,valid_products,[root,f6],false).


% ---------------
spl_db( test_196,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f8 , f3 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(test_196,valid_products,[root],true).


% ---------------
spl_db( test_197,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_197,valid_products,[root,f1,f2,f4,f7,f8,f9],true).


% ---------------
spl_db( test_198,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f7 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(test_198,valid_products,[root,f1,f2,f4,f9],true).


% ---------------
spl_db( test_199,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_199,valid_products,[root],true).


% ---------------
spl_db( test_200,
	 spl( [ root, f1, f2, f7, f8, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_200,valid_products,[root,f1,f2,f4,f5,f6,f8],true).


% ---------------
spl_db( test_201,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f7 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(test_201,valid_products,[root,f1,f4,f5,f7],true).


% ---------------
spl_db( test_202,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(test_202,valid_products,[root,f2,f3,f4,f5,f8],true).


% ---------------
spl_db( test_203,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f3 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(test_203,valid_products,[root,f1,f2,f3,f4,f7,f8,f9],true).


% ---------------
spl_db( test_204,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_204,valid_products,[root,f3,f6,f7,f8],false).


% ---------------
spl_db( test_205,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(test_205,valid_products,[root,f5,f2],false).


% ---------------
spl_db( test_206,
	 spl( [ root, f1, f2, f5, f3, f8, f4, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(test_206,valid_products,[f1,f3,f8],false).


% ---------------
spl_db( test_207,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f6 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_207,valid_products,[root,f2,f4,f6],false).


% ---------------
spl_db( test_208,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f7 ), requires( f6 , f5 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_208,valid_products,[root,f1,f2,f3,f5],false).


% ---------------
spl_db( test_209,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_209,valid_products,[root,f2,f4,f7,f9],false).


% ---------------
spl_db( test_210,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_210,valid_products,[root,f2,f4,f5,f6,f8,f9],false).


% ---------------
spl_db( test_211,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_211,valid_products,[root,f3,f5,f8],false).


% ---------------
spl_db( test_212,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f3 , f8 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_212,valid_products,[root,f1,f2,f3,f4,f6],false).


% ---------------
spl_db( test_213,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_213,valid_products,[root,f1,f4,f5,f6,f7],false).


% ---------------
spl_db( test_214,
	 spl( [ root, f1, f2, f8, f9, f3, f7, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_214,valid_products,[root,f1,f2,f4],false).


% ---------------
spl_db( test_215,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_215,valid_products,[root,f1,f2,f5,f7,f8],true).


% ---------------
spl_db( test_216,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(test_216,valid_products,[root,f3,f4],false).


% ---------------
spl_db( test_217,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f5 , f9 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_217,valid_products,[root,f1,f3,f8,f6],false).


% ---------------
spl_db( test_218,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_218,valid_products,[root,f1,f5,f8,f9],false).


% ---------------
spl_db( test_219,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), excludes( f6 , f7 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(test_219,valid_products,[root,f3,f5,f8,f7,f9],false).


% ---------------
spl_db( test_220,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_220,valid_products,[root,f2,f4,f7,f8],false).


% ---------------
spl_db( test_221,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_221,valid_products,[root,f1,f3,f4,f7],false).


% ---------------
spl_db( test_222,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f4 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_222,valid_products,[root],false).


% ---------------
spl_db( test_223,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f1 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(test_223,valid_products,[root,f1,f3,f6,f2],false).


% ---------------
spl_db( test_224,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_224,valid_products,[root,f1,f3],false).


% ---------------
spl_db( test_225,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(test_225,valid_products,[root,f2,f4,f5,f7],false).


% ---------------
spl_db( test_226,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f1 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_226,valid_products,[root,f1,f2,f3,f4,f6,f7],false).


% ---------------
spl_db( test_227,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_227,valid_products,[root,f3],false).


% ---------------
spl_db( test_228,
	 spl( [ root, f1, f2, f4, f3, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_228,valid_products,[root,f2,f3,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_229,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_229,valid_products,[f2,f1],false).


% ---------------
spl_db( test_230,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f3 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(test_230,valid_products,[root,f1,f2,f3,f7],true).


% ---------------
spl_db( test_231,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_231,valid_products,[root,f1,f2,f4,f5,f8],true).


% ---------------
spl_db( test_232,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_232,valid_products,[root,f1,f2,f3,f4,f5,f8],true).


% ---------------
spl_db( test_233,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f6, f7, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_233,valid_products,[root,f1,f4,f7,f5],false).


% ---------------
spl_db( test_234,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(test_234,valid_products,[root,f1,f4,f6,f7],true).


% ---------------
spl_db( test_235,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

test_data(test_235,valid_products,[root,f1,f2,f4,f5,f6],false).


% ---------------
spl_db( test_236,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_236,valid_products,[f3,f4,f5,f6],false).


% ---------------
spl_db( test_237,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_237,valid_products,[root,f2,f3,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_238,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					optional( feature( f5, [
						optional( feature( f6, [
							optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_238,valid_products,[root,f2,f3,f5,f8,f9],false).


% ---------------
spl_db( test_239,
	 spl( [ root, f1, f2, f3, f6, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [
					optional( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_239,valid_products,[root,f1,f5,f9],false).


% ---------------
spl_db( test_240,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(test_240,valid_products,[f6,f8,f7],false).


% ---------------
spl_db( test_241,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f9 ), requires( f7 , f4 ) ]
		)
	)
).

test_data(test_241,valid_products,[root,f1,f2,f3,f4,f6,f7,f8,f9],true).


% ---------------
spl_db( test_242,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f4, f5, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_242,valid_products,[root,f2,f4,f7,f8],false).


% ---------------
spl_db( test_243,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_243,valid_products,[root,f2,f5,f6],true).


% ---------------
spl_db( test_244,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						only_one( [ feature( f4, [
							optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
								optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(test_244,valid_products,[root,f1,f2,f3,f4,f6,f7,f5],false).


% ---------------
spl_db( test_245,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_245,valid_products,[root,f1,f3,f4,f6,f7,f8],false).


% ---------------
spl_db( test_246,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(test_246,valid_products,[root,f2,f4,f6,f9,f7,f8],false).


% ---------------
spl_db( test_247,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
							mandatory( feature( f8, [
								optional( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_247,valid_products,[root,f1,f3,f4,f5,f8],false).


% ---------------
spl_db( test_248,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(test_248,valid_products,[root,f2,f3,f5,f6,f8,f9],false).


% ---------------
spl_db( test_249,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(test_249,valid_products,[root,f2,f3,f7,f8],true).


% ---------------
spl_db( test_250,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_250,valid_products,[root,f2,f3,f6,f8,f7],false).


% ---------------
spl_db( test_251,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f7 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_251,valid_products,[root,f1,f2,f3,f4,f7,f8,f9,f5,f6],false).


% ---------------
spl_db( test_252,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [
						optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(test_252,valid_products,[root],true).


% ---------------
spl_db( test_253,
	 spl( [ root, f1, f8, f2, f5, f6, f7, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f3 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(test_253,valid_products,[f1,f2,f3,f5,f6,f8,f4],false).


% ---------------
spl_db( test_254,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_254,valid_products,[root,f1,f2,f3,f4,f6,f9],true).


% ---------------
spl_db( test_255,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f3 , f7 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(test_255,valid_products,[root,f1,f2,f3,f4,f6,f7,f8,f5],false).


% ---------------
spl_db( test_256,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_256,valid_products,[root,f1,f2,f3,f4,f6,f9],true).


% ---------------
spl_db( test_257,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ), excludes( f9 , f6 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(test_257,valid_products,[root,f2,f3,f4,f6],false).


% ---------------
spl_db( test_258,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(test_258,valid_products,[f1,f2,f3,f4,f7],false).


% ---------------
spl_db( test_259,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_259,valid_products,[root,f1,f5,f7,f8,f9],false).


% ---------------
spl_db( test_260,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f8 ), requires( f6 , f2 ) ]
		)
	)
).

test_data(test_260,valid_products,[root,f1,f2,f3],true).


% ---------------
spl_db( test_261,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(test_261,valid_products,[root,f5],false).


% ---------------
spl_db( test_262,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

test_data(test_262,valid_products,[root,f1,f3,f6,f8,f7],false).


% ---------------
spl_db( test_263,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_263,valid_products,[root,f1,f3],false).


% ---------------
spl_db( test_264,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_264,valid_products,[root,f2,f4,f8,f9],false).


% ---------------
spl_db( test_265,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_265,valid_products,[root,f1,f7],false).


% ---------------
spl_db( test_266,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f3, f8, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f1 , f3 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(test_266,valid_products,[root,f1,f8],false).


% ---------------
spl_db( test_267,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_267,valid_products,[root,f2,f3,f5,f7,f8],false).


% ---------------
spl_db( test_268,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_268,valid_products,[root,f1,f5,f6,f7,f9],false).


% ---------------
spl_db( test_269,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_269,valid_products,[root,f2,f3,f5,f6,f7,f8],false).


% ---------------
spl_db( test_270,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f3 ), excludes( f3 , f6 ), requires( f6 , f8 ) ]
		)
	)
).

test_data(test_270,valid_products,[root,f1,f3,f4,f5,f6,f7],false).


% ---------------
spl_db( test_271,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f2 ), requires( f3 , f8 ), requires( f5 , f3 ) ]
		)
	)
).

test_data(test_271,valid_products,[root,f1,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_272,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f2 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(test_272,valid_products,[f1,f2,f4,f5,f6,f8],false).


% ---------------
spl_db( test_273,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [
					optional( feature( f6, [
						mandatory( feature( f7, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_273,valid_products,[root,f1,f3,f5],false).


% ---------------
spl_db( test_274,
	 spl( [ root, f1, f2, f4, f7, f8, f9, f5, f6, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f4, [
						optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f7 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_274,valid_products,[root,f1,f2,f4,f5,f9,f3],false).


% ---------------
spl_db( test_275,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_275,valid_products,[root,f1,f2],false).


% ---------------
spl_db( test_276,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_276,valid_products,[root,f1,f2,f3,f6,f9,f4],false).


% ---------------
spl_db( test_277,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_277,valid_products,[root,f4,f5,f8,f9],false).


% ---------------
spl_db( test_278,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(test_278,valid_products,[root,f8,f7],false).


% ---------------
spl_db( test_279,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(test_279,valid_products,[f4,f5,f6],false).


% ---------------
spl_db( test_280,
	 spl( [ root, f1, f5, f2, f9, f3, f4, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(test_280,valid_products,[root,f9],false).


% ---------------
spl_db( test_281,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f2, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(test_281,valid_products,[root,f8],false).


% ---------------
spl_db( test_282,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(test_282,valid_products,[root,f1,f2,f3,f4,f5,f7],true).


% ---------------
spl_db( test_283,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_283,valid_products,[root,f1,f3,f8],false).


% ---------------
spl_db( test_284,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

test_data(test_284,valid_products,[root,f1,f2,f3,f5,f6],true).


% ---------------
spl_db( test_285,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(test_285,valid_products,[root,f1,f2,f3,f4,f7],true).


% ---------------
spl_db( test_286,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_286,valid_products,[root,f2,f3,f4,f6],false).


% ---------------
spl_db( test_287,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f8 , f3 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(test_287,valid_products,[f1,f3,f4,f5],false).


% ---------------
spl_db( test_288,
	 spl( [ root, f1, f2, f5, f7, f8, f9, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f7, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(test_288,valid_products,[root,f1,f3,f5,f6],false).


% ---------------
spl_db( test_289,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(test_289,valid_products,[root,f1,f3,f4,f6,f7],false).


% ---------------
spl_db( test_290,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f5 ), requires( f9 , f1 ) ]
		)
	)
).

test_data(test_290,valid_products,[root,f1,f9],false).


% ---------------
spl_db( test_291,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_291,valid_products,[root,f1,f2],false).


% ---------------
spl_db( test_292,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_292,valid_products,[root,f1,f3,f4,f5,f7,f8],true).


% ---------------
spl_db( test_293,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

test_data(test_293,valid_products,[root,f2,f3,f4,f7],true).


% ---------------
spl_db( test_294,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f6 ), excludes( f1 , f7 ) ]
		)
	)
).

test_data(test_294,valid_products,[root,f3,f4,f5,f7],false).


% ---------------
spl_db( test_295,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_295,valid_products,[root,f1,f3,f8],false).


% ---------------
spl_db( test_296,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_296,valid_products,[root,f3,f6,f7],false).


% ---------------
spl_db( test_297,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_297,valid_products,[root,f1,f2,f3,f5,f6,f7,f8],true).


% ---------------
spl_db( test_298,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f3, f4, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

test_data(test_298,valid_products,[root,f1,f2,f3,f4,f8],true).


% ---------------
spl_db( test_299,
	 spl( [ root, f1, f5, f6, f8, f7, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_299,valid_products,[root,f1,f2,f4,f5,f7,f9],true).


% ---------------
spl_db( test_300,
	 spl( [ root, f1, f5, f2, f6, f8, f3, f7, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f3, [
				mandatory( feature( f7, [] ) ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_300,valid_products,[root,f1,f4,f5,f9],true).


% ---------------
spl_db( test_301,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f8 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_301,valid_products,[root,f1,f3,f5,f6,f7],true).


% ---------------
spl_db( test_302,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_302,valid_products,[root,f3,f5,f7,f6],false).


% ---------------
spl_db( test_303,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(test_303,valid_products,[root,f1,f2,f3,f7,f9],false).


% ---------------
spl_db( test_304,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_304,valid_products,[root,f1,f2,f4,f7,f9],false).


% ---------------
spl_db( test_305,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_305,valid_products,[root,f1,f5],false).


% ---------------
spl_db( test_306,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_306,valid_products,[root,f2,f4,f5,f6],false).


% ---------------
spl_db( test_307,
	 spl( [ root, f1, f8, f2, f7, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f8, [] ) ) ] ), feature( f2, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(test_307,valid_products,[root,f1],false).


% ---------------
spl_db( test_308,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f7 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_308,valid_products,[root,f2,f3,f6,f8,f7],false).


% ---------------
spl_db( test_309,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(test_309,valid_products,[root,f1,f3,f5,f6],false).


% ---------------
spl_db( test_310,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_310,valid_products,[f2,f3,f6,f7,f8],false).


% ---------------
spl_db( test_311,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_311,valid_products,[f3,f7,f2],false).


% ---------------
spl_db( test_312,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(test_312,valid_products,[root,f4,f6,f8,f9],false).


% ---------------
spl_db( test_313,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_313,valid_products,[root,f2,f3,f5],false).


% ---------------
spl_db( test_314,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(test_314,valid_products,[f3,f4,f5,f7,f2],false).


% ---------------
spl_db( test_315,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f7, [
							mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f1 , f7 ), excludes( f8 , f1 ), excludes( f4 , f1 ) ]
		)
	)
).

test_data(test_315,valid_products,[root,f2,f4,f5,f6],false).


% ---------------
spl_db( test_316,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_316,valid_products,[root,f1,f2,f4,f5,f9],true).


% ---------------
spl_db( test_317,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f8 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_317,valid_products,[f2,f3],false).


% ---------------
spl_db( test_318,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(test_318,valid_products,[root,f2,f4,f6],false).


% ---------------
spl_db( test_319,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_319,valid_products,[root,f5],false).


% ---------------
spl_db( test_320,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_320,valid_products,[root,f1,f3,f4,f5,f7,f9],false).


% ---------------
spl_db( test_321,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(test_321,valid_products,[root,f1,f4,f5,f8,f9],false).


% ---------------
spl_db( test_322,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

test_data(test_322,valid_products,[root,f1,f4,f6],false).


% ---------------
spl_db( test_323,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f2 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(test_323,valid_products,[root,f3,f7],true).


% ---------------
spl_db( test_324,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
							mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(test_324,valid_products,[root,f1,f2,f6,f7,f9],false).


% ---------------
spl_db( test_325,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f8 , f7 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(test_325,valid_products,[root,f1,f2,f3,f5,f9],false).


% ---------------
spl_db( test_326,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f3 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_326,valid_products,[f2,f3,f4,f6,f7,f8],false).


% ---------------
spl_db( test_327,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_327,valid_products,[root,f2,f6,f7,f8],false).


% ---------------
spl_db( test_328,
	 spl( [ root, f1, f2, f8, f3, f5, f7, f9, f6, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f5, [
						mandatory( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_328,valid_products,[root,f1,f3,f5],false).


% ---------------
spl_db( test_329,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

test_data(test_329,valid_products,[root,f1,f2,f4],false).


% ---------------
spl_db( test_330,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_330,valid_products,[root,f3,f6,f7,f8],false).


% ---------------
spl_db( test_331,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(test_331,valid_products,[root,f1,f2,f8],false).


% ---------------
spl_db( test_332,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f6 ), requires( f2 , f6 ) ]
		)
	)
).

test_data(test_332,valid_products,[root,f2,f3,f6,f7,f8],false).


% ---------------
spl_db( test_333,
	 spl( [ root, f1, f3, f5, f6, f7, f8, f9, f2, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_333,valid_products,[root,f1,f6,f7,f9],false).


% ---------------
spl_db( test_334,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_334,valid_products,[root,f4,f6,f7],false).


% ---------------
spl_db( test_335,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_335,valid_products,[f2,f4,f1],false).


% ---------------
spl_db( test_336,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(test_336,valid_products,[root,f1,f2,f3,f4,f5,f7,f9],true).


% ---------------
spl_db( test_337,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(test_337,valid_products,[f1,f2,f3,f5,f7,f8,f9],false).


% ---------------
spl_db( test_338,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f6 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_338,valid_products,[root,f3,f6,f7,f8],true).


% ---------------
spl_db( test_339,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_339,valid_products,[root,f1,f6,f8,f5],false).


% ---------------
spl_db( test_340,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_340,valid_products,[root,f4,f5,f6],false).


% ---------------
spl_db( test_341,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f5, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_341,valid_products,[root,f1,f2,f3,f4,f6,f7,f9],true).


% ---------------
spl_db( test_342,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f4 ), excludes( f2 , f7 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_342,valid_products,[root,f2,f4,f5,f7,f9],false).


% ---------------
spl_db( test_343,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(test_343,valid_products,[root,f5,f7,f4],false).


% ---------------
spl_db( test_344,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(test_344,valid_products,[root,f1,f3,f4,f6],false).


% ---------------
spl_db( test_345,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_345,valid_products,[root,f1,f2,f3,f5,f7],false).


% ---------------
spl_db( test_346,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(test_346,valid_products,[root,f1,f2,f3,f5,f8],false).


% ---------------
spl_db( test_347,
	 spl( [ root, f1, f8, f2, f5, f9, f6, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f9 , f3 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(test_347,valid_products,[root,f1,f8],false).


% ---------------
spl_db( test_348,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_348,valid_products,[root,f2,f4,f6,f8],false).


% ---------------
spl_db( test_349,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_349,valid_products,[root,f1,f2,f4,f5,f7],true).


% ---------------
spl_db( test_350,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f6 ), excludes( f4 , f1 ) ]
		)
	)
).

test_data(test_350,valid_products,[f1,f5,f6,f8,f9],false).


% ---------------
spl_db( test_351,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_351,valid_products,[root,f1,f2,f3,f5,f7,f8,f9],false).


% ---------------
spl_db( test_352,
	 spl( [ root, f1, f8, f2, f6, f7, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_352,valid_products,[root,f1,f3,f4],true).


% ---------------
spl_db( test_353,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_353,valid_products,[root,f1],false).


% ---------------
spl_db( test_354,
	 spl( [ root, f1, f2, f4, f5, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_354,valid_products,[root,f1,f2,f3,f5,f6,f8],true).


% ---------------
spl_db( test_355,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f5 , f4 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_355,valid_products,[root,f4],false).


% ---------------
spl_db( test_356,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_356,valid_products,[root,f4,f7],false).


% ---------------
spl_db( test_357,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_357,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8],true).


% ---------------
spl_db( test_358,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_358,valid_products,[root,f1,f2,f4,f6],false).


% ---------------
spl_db( test_359,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_359,valid_products,[root,f1,f2,f3,f4,f8,f9],true).


% ---------------
spl_db( test_360,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_360,valid_products,[root,f3,f7,f8,f9,f4,f6],false).


% ---------------
spl_db( test_361,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
						mandatory( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f9 ), requires( f2 , f3 ) ]
		)
	)
).

test_data(test_361,valid_products,[root,f1,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_362,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_362,valid_products,[root,f1,f3,f6,f8,f9],false).


% ---------------
spl_db( test_363,
	 spl( [ root, f1, f2, f3, f6, f8, f7, f4, f5, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_363,valid_products,[root,f1,f2,f4,f5],true).


% ---------------
spl_db( test_364,
	 spl( [ root, f1, f9, f2, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(test_364,valid_products,[root,f1,f3,f4,f5,f8,f9],true).


% ---------------
spl_db( test_365,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_365,valid_products,[root,f1,f5],false).


% ---------------
spl_db( test_366,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f6 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(test_366,valid_products,[root,f1,f6,f8,f9],false).


% ---------------
spl_db( test_367,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f1 ), excludes( f4 , f9 ), requires( f9 , f6 ) ]
		)
	)
).

test_data(test_367,valid_products,[f1,f6],false).


% ---------------
spl_db( test_368,
	 spl( [ root, f1, f2, f4, f6, f7, f8, f9, f5, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [
						mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_368,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_369,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

test_data(test_369,valid_products,[root,f2,f3,f5,f8,f9],true).


% ---------------
spl_db( test_370,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_370,valid_products,[root,f1,f2,f4],true).


% ---------------
spl_db( test_371,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(test_371,valid_products,[root,f1,f2,f3,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_372,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f5 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_372,valid_products,[root,f1,f2,f3,f5,f7,f8,f9],false).


% ---------------
spl_db( test_373,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_373,valid_products,[root,f3,f4,f5,f7,f9],false).


% ---------------
spl_db( test_374,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_374,valid_products,[root,f6],false).


% ---------------
spl_db( test_375,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_375,valid_products,[root,f1,f5,f6,f8],false).


% ---------------
spl_db( test_376,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(test_376,valid_products,[f1,f6,f7,f4],false).


% ---------------
spl_db( test_377,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_377,valid_products,[f1,f2,f3,f6],false).


% ---------------
spl_db( test_378,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_378,valid_products,[root,f1,f5,f6],false).


% ---------------
spl_db( test_379,
	 spl( [ root, f1, f6, f7, f2, f3, f4, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(test_379,valid_products,[root,f1,f2,f4,f8],false).


% ---------------
spl_db( test_380,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_380,valid_products,[root,f3,f9,f6,f7],false).


% ---------------
spl_db( test_381,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(test_381,valid_products,[root,f3,f5],false).


% ---------------
spl_db( test_382,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_382,valid_products,[root,f1,f2,f3,f6,f7,f9],true).


% ---------------
spl_db( test_383,
	 spl( [ root, f1, f2, f4, f3, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f4, [] ) ) ] ), feature( f3, [
					only_one( [ feature( f5, [
						mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_383,valid_products,[root,f1,f2,f4,f3],false).


% ---------------
spl_db( test_384,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f5 , f3 ) ]
		)
	)
).

test_data(test_384,valid_products,[root,f1,f2,f3,f4,f6,f7,f9],true).


% ---------------
spl_db( test_385,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f2 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_385,valid_products,[root],true).


% ---------------
spl_db( test_386,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_386,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8],true).


% ---------------
spl_db( test_387,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_387,valid_products,[root,f1,f2,f3,f5],true).


% ---------------
spl_db( test_388,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(test_388,valid_products,[root,f2,f3,f4,f5,f7,f8,f9],false).


% ---------------
spl_db( test_389,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f7, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(test_389,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_390,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(test_390,valid_products,[root,f1,f3,f5,f8,f9],false).


% ---------------
spl_db( test_391,
	 spl( [ root, f1, f4, f8, f9, f5, f6, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_391,valid_products,[root],false).


% ---------------
spl_db( test_392,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(test_392,valid_products,[root,f1,f2,f5,f9],false).


% ---------------
spl_db( test_393,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_393,valid_products,[f2,f3,f4,f6,f8],false).


% ---------------
spl_db( test_394,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(test_394,valid_products,[root,f1,f2,f3,f4,f7],false).


% ---------------
spl_db( test_395,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f4, f5, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_395,valid_products,[root,f1,f6],false).


% ---------------
spl_db( test_396,
	 spl( [ root, f1, f8, f2, f3, f6, f7, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_396,valid_products,[root,f1,f2,f3,f4,f6,f7,f8,f9],true).


% ---------------
spl_db( test_397,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_397,valid_products,[root,f1,f2,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_398,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_398,valid_products,[root,f1,f2,f3,f6,f8],true).


% ---------------
spl_db( test_399,
	 spl( [ root, f1, f9, f2, f6, f7, f3, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_399,valid_products,[root,f2,f4,f9],false).


% ---------------
spl_db( test_400,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_400,valid_products,[root,f2,f3,f5,f7,f8,f9],false).


% ---------------
spl_db( test_401,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_401,valid_products,[root,f2,f4,f5,f8,f9,f7],false).


% ---------------
spl_db( test_402,
	 spl( [ root, f1, f3, f4, f6, f7, f5, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_402,valid_products,[root,f1,f5,f8,f9,f4],false).


% ---------------
spl_db( test_403,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_403,valid_products,[root,f1,f2,f3,f4,f5,f7,f9,f8],false).


% ---------------
spl_db( test_404,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(test_404,valid_products,[root,f1,f2,f4,f6,f9],false).


% ---------------
spl_db( test_405,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_405,valid_products,[root,f2,f7],false).


% ---------------
spl_db( test_406,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_406,valid_products,[root,f1,f6],false).


% ---------------
spl_db( test_407,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_407,valid_products,[root,f1,f5,f8],false).


% ---------------
spl_db( test_408,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(test_408,valid_products,[root,f2,f1],false).


% ---------------
spl_db( test_409,
	 spl( [ root, f1, f3, f7, f9, f4, f8, f5, f6, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_409,valid_products,[root,f1,f4,f5,f8],true).


% ---------------
spl_db( test_410,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f6, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

test_data(test_410,valid_products,[root,f2,f8,f9],false).


% ---------------
spl_db( test_411,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(test_411,valid_products,[root,f3,f4,f6,f9],true).


% ---------------
spl_db( test_412,
	 spl( [ root, f1, f9, f2, f5, f6, f8, f7, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f3 , f1 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(test_412,valid_products,[root,f2,f6,f8,f9],false).


% ---------------
spl_db( test_413,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_413,valid_products,[root,f2,f3,f4,f5,f7],true).


% ---------------
spl_db( test_414,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_414,valid_products,[root,f1,f2,f5,f8,f6,f7],false).


% ---------------
spl_db( test_415,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_415,valid_products,[root,f4,f5],false).


% ---------------
spl_db( test_416,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_416,valid_products,[f2,f3,f4,f5,f7],false).


% ---------------
spl_db( test_417,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_417,valid_products,[root,f1,f2,f3,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_418,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_418,valid_products,[root,f2,f3,f7,f8,f9],false).


% ---------------
spl_db( test_419,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(test_419,valid_products,[root,f1,f2,f4,f8],true).


% ---------------
spl_db( test_420,
	 spl( [ root, f1, f6, f7, f2, f3, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_420,valid_products,[f3,f4,f5],false).


% ---------------
spl_db( test_421,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_421,valid_products,[root,f1,f3,f4,f6,f7],true).


% ---------------
spl_db( test_422,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(test_422,valid_products,[root,f2,f6,f7,f8,f9],false).


% ---------------
spl_db( test_423,
	 spl( [ root, f1, f4, f5, f2, f6, f8, f7, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_423,valid_products,[root,f1,f3,f4,f5,f9],true).


% ---------------
spl_db( test_424,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(test_424,valid_products,[root,f1,f2,f4,f6,f8,f9],true).


% ---------------
spl_db( test_425,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f7 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_425,valid_products,[root,f1,f3,f5,f8],false).


% ---------------
spl_db( test_426,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_426,valid_products,[root,f1,f2,f7,f8],false).


% ---------------
spl_db( test_427,
	 spl( [ root, f1, f8, f9, f2, f7, f3, f6, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_427,valid_products,[root,f1,f2,f4,f9],false).


% ---------------
spl_db( test_428,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
					optional( feature( f4, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f3 ), requires( f2 , f4 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_428,valid_products,[f1,f3],false).


% ---------------
spl_db( test_429,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_429,valid_products,[root,f1,f2,f6,f8,f5],false).


% ---------------
spl_db( test_430,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_430,valid_products,[root,f1,f2,f4,f5,f6,f9],true).


% ---------------
spl_db( test_431,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f5 , f3 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(test_431,valid_products,[f2,f6,f8,f9],false).


% ---------------
spl_db( test_432,
	 spl( [ root, f1, f6, f8, f7, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_432,valid_products,[root,f1,f2,f3,f6,f7],true).


% ---------------
spl_db( test_433,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(test_433,valid_products,[root,f4,f5,f7],false).


% ---------------
spl_db( test_434,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_434,valid_products,[root,f1,f2,f3,f4,f8,f7],false).


% ---------------
spl_db( test_435,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_435,valid_products,[root,f1,f4,f5,f6],false).


% ---------------
spl_db( test_436,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(test_436,valid_products,[root,f1,f3,f4,f5,f8],false).


% ---------------
spl_db( test_437,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f9 ), excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_437,valid_products,[root,f1,f4,f6],false).


% ---------------
spl_db( test_438,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f1 ), requires( f5 , f7 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_438,valid_products,[root,f1,f3,f5],false).


% ---------------
spl_db( test_439,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_439,valid_products,[root,f1,f5,f8],false).


% ---------------
spl_db( test_440,
	 spl( [ root, f1, f6, f8, f9, f2, f3, f4, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_440,valid_products,[root,f1,f3,f6,f4,f5],false).


% ---------------
spl_db( test_441,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_441,valid_products,[root,f3,f4],true).


% ---------------
spl_db( test_442,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

test_data(test_442,valid_products,[root,f2,f3,f8,f9,f7],false).


% ---------------
spl_db( test_443,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_443,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_444,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_444,valid_products,[root,f3,f4,f5,f8,f9],false).


% ---------------
spl_db( test_445,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_445,valid_products,[root,f2,f3,f4,f5,f6,f9],true).


% ---------------
spl_db( test_446,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_446,valid_products,[root,f1,f2,f4,f5,f6,f7,f8],false).


% ---------------
spl_db( test_447,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_447,valid_products,[root,f1,f3,f4,f9],true).


% ---------------
spl_db( test_448,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f9 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_448,valid_products,[root,f2,f3,f4,f5,f7,f9],true).


% ---------------
spl_db( test_449,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_449,valid_products,[root,f2,f3,f4,f6,f7,f9],true).


% ---------------
spl_db( test_450,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

test_data(test_450,valid_products,[root,f1,f2,f6,f7,f8,f4,f5],false).


% ---------------
spl_db( test_451,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_451,valid_products,[root,f2,f4,f7,f8,f9],false).


% ---------------
spl_db( test_452,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f7 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_452,valid_products,[root,f2,f4,f6,f8,f5],false).


% ---------------
spl_db( test_453,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_453,valid_products,[root,f1,f5,f6,f8],false).


% ---------------
spl_db( test_454,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_454,valid_products,[f1,f3,f4,f5,f9],false).


% ---------------
spl_db( test_455,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f6 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_455,valid_products,[f1,f4,f6,f7],false).


% ---------------
spl_db( test_456,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

test_data(test_456,valid_products,[root,f1,f4,f5,f8],true).


% ---------------
spl_db( test_457,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f7 , f2 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_457,valid_products,[root,f1,f6,f7],false).


% ---------------
spl_db( test_458,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_458,valid_products,[root,f2,f4,f8,f9],false).


% ---------------
spl_db( test_459,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f1 , f6 ), requires( f5 , f1 ) ]
		)
	)
).

test_data(test_459,valid_products,[root,f1,f2,f4,f5,f7,f9],false).


% ---------------
spl_db( test_460,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(test_460,valid_products,[root,f1,f2,f3,f4,f6,f7,f8],false).


% ---------------
spl_db( test_461,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
						mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f7 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_461,valid_products,[root,f1,f2,f4,f5,f6],false).


% ---------------
spl_db( test_462,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f4 ), excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_462,valid_products,[root,f1,f3,f5,f9,f4],false).


% ---------------
spl_db( test_463,
	 spl( [ root, f1, f3, f4, f5, f8, f9, f2, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_463,valid_products,[root,f1,f9,f8],false).


% ---------------
spl_db( test_464,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f2, f3, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f7 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_464,valid_products,[root,f1,f2,f4,f6,f9,f7],false).


% ---------------
spl_db( test_465,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(test_465,valid_products,[root,f2,f3,f4,f5,f7,f9],false).


% ---------------
spl_db( test_466,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f5 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(test_466,valid_products,[root,f1,f7,f8,f9],false).


% ---------------
spl_db( test_467,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_467,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8],true).


% ---------------
spl_db( test_468,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_468,valid_products,[root,f1,f2,f3,f6,f8,f9],true).


% ---------------
spl_db( test_469,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_469,valid_products,[root,f1,f2,f3,f4,f6,f7,f8],true).


% ---------------
spl_db( test_470,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_470,valid_products,[root,f1,f2,f3,f4,f5,f6,f9],true).


% ---------------
spl_db( test_471,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(test_471,valid_products,[root,f5,f9],true).


% ---------------
spl_db( test_472,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_472,valid_products,[root,f1,f2,f3,f6,f9],true).


% ---------------
spl_db( test_473,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_473,valid_products,[root,f1,f2,f3,f4,f5,f7,f9],true).


% ---------------
spl_db( test_474,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f2 , f3 ), requires( f5 , f6 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(test_474,valid_products,[root,f2],false).


% ---------------
spl_db( test_475,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f3 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(test_475,valid_products,[root,f2,f5,f9],false).


% ---------------
spl_db( test_476,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_476,valid_products,[f1,f5,f3],false).


% ---------------
spl_db( test_477,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f5 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(test_477,valid_products,[f1,f2,f3,f4],false).


% ---------------
spl_db( test_478,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f5 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(test_478,valid_products,[root,f2,f3,f4,f5,f7,f6],false).


% ---------------
spl_db( test_479,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_479,valid_products,[root,f3,f5,f6],false).


% ---------------
spl_db( test_480,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_480,valid_products,[f1,f4,f6,f5],false).


% ---------------
spl_db( test_481,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_481,valid_products,[root,f1,f4,f6,f7],false).


% ---------------
spl_db( test_482,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_482,valid_products,[f2,f3,f6,f4],false).


% ---------------
spl_db( test_483,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f6 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_483,valid_products,[f3,f4,f5,f7,f9,f8],false).


% ---------------
spl_db( test_484,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f4, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [
				optional( feature( f5, [
					optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_484,valid_products,[f1,f3,f2],false).


% ---------------
spl_db( test_485,
	 spl( [ root, f1, f2, f3, f5, f6, f8, f7, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f9 , f1 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(test_485,valid_products,[root,f1,f2,f3,f4,f5,f9,f8],false).


% ---------------
spl_db( test_486,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(test_486,valid_products,[root,f3,f7,f8],false).


% ---------------
spl_db( test_487,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_487,valid_products,[f3,f6,f8,f9],false).


% ---------------
spl_db( test_488,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_488,valid_products,[f3,f4,f7],false).


% ---------------
spl_db( test_489,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f2 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(test_489,valid_products,[root,f6,f7],false).


% ---------------
spl_db( test_490,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f6 , f1 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(test_490,valid_products,[f1,f4,f5,f6,f2],false).


% ---------------
spl_db( test_491,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f9 , f2 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(test_491,valid_products,[root,f1,f4,f5,f6,f7,f8,f9],false).


% ---------------
spl_db( test_492,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f2 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_492,valid_products,[root,f1,f2,f6,f7],false).


% ---------------
spl_db( test_493,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_493,valid_products,[f1,f2],false).


% ---------------
spl_db( test_494,
	 spl( [ root, f1, f5, f2, f3, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f4 , f7 ), excludes( f2 , f8 ) ]
		)
	)
).

test_data(test_494,valid_products,[root,f2,f3,f7],false).


% ---------------
spl_db( test_495,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_495,valid_products,[root,f2,f3,f4,f5,f6,f8,f7],false).


% ---------------
spl_db( test_496,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_496,valid_products,[root,f1,f4,f6,f8,f9],false).


% ---------------
spl_db( test_497,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_497,valid_products,[root,f3,f6],false).


% ---------------
spl_db( test_498,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f6 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(test_498,valid_products,[root,f2,f3,f4,f5,f9,f6],false).


% ---------------
spl_db( test_499,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_499,valid_products,[root,f3,f4],false).


% ---------------
spl_db( test_500,
	 spl( [ root, f1, f6, f2, f3, f9, f4, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_500,valid_products,[root,f1,f2,f4,f6,f8],true).


% ---------------
spl_db( test_501,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f7 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(test_501,valid_products,[root,f3,f4,f5,f8,f9],true).


% ---------------
spl_db( test_502,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_502,valid_products,[root,f1,f2,f3,f4,f5,f7,f8],true).


% ---------------
spl_db( test_503,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f2 , f1 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(test_503,valid_products,[root,f1,f2,f4,f5,f6,f7],true).


% ---------------
spl_db( test_504,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_504,valid_products,[root,f4,f6,f8,f9],false).


% ---------------
spl_db( test_505,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_505,valid_products,[root,f1,f3,f5,f6,f7,f8],true).


% ---------------
spl_db( test_506,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f3 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(test_506,valid_products,[root,f4,f5,f8,f9,f2],false).


% ---------------
spl_db( test_507,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_507,valid_products,[f1,f2,f4],false).


% ---------------
spl_db( test_508,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f3 , f5 ), excludes( f1 , f5 ) ]
		)
	)
).

test_data(test_508,valid_products,[root,f1,f2,f6,f8,f5],false).


% ---------------
spl_db( test_509,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(test_509,valid_products,[f5,f3],false).


% ---------------
spl_db( test_510,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f8, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_510,valid_products,[root,f2],false).


% ---------------
spl_db( test_511,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_511,valid_products,[root,f1,f3,f4,f6],false).


% ---------------
spl_db( test_512,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

test_data(test_512,valid_products,[f2,f4,f5,f6,f9,f1],false).


% ---------------
spl_db( test_513,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_513,valid_products,[root,f1,f2,f5,f7],true).


% ---------------
spl_db( test_514,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f1 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_514,valid_products,[f1,f5,f7,f8,f9],false).


% ---------------
spl_db( test_515,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_515,valid_products,[root,f4,f7],false).


% ---------------
spl_db( test_516,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f9 ) ]
		)
	)
).

test_data(test_516,valid_products,[root,f3,f5,f8,f9],false).


% ---------------
spl_db( test_517,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_517,valid_products,[root,f1,f2,f3,f4],true).


% ---------------
spl_db( test_518,
	 spl( [ root, f1, f2, f4, f5, f3, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f4 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(test_518,valid_products,[root,f1,f2,f3,f4,f5,f7,f8],false).


% ---------------
spl_db( test_519,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f6, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f3 ), requires( f7 , f4 ) ]
		)
	)
).

test_data(test_519,valid_products,[root,f1,f4,f9],false).


% ---------------
spl_db( test_520,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f8 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_520,valid_products,[root,f2,f3,f8],false).


% ---------------
spl_db( test_521,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_521,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8],true).


% ---------------
spl_db( test_522,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f8 , f6 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_522,valid_products,[root,f1,f2,f3,f5,f9],true).


% ---------------
spl_db( test_523,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f3 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(test_523,valid_products,[root,f9,f2,f4,f6,f8],false).


% ---------------
spl_db( test_524,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f7 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_524,valid_products,[root,f2,f3,f4,f5,f8],true).


% ---------------
spl_db( test_525,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f5 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(test_525,valid_products,[root,f2,f3,f5,f7,f8],false).


% ---------------
spl_db( test_526,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(test_526,valid_products,[root,f1,f2,f3,f4,f5,f6,f9],true).


% ---------------
spl_db( test_527,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_527,valid_products,[root,f1,f2,f4,f6],true).


% ---------------
spl_db( test_528,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_528,valid_products,[root,f1],false).


% ---------------
spl_db( test_529,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

test_data(test_529,valid_products,[root,f1,f3,f4,f5,f6,f7,f8],true).


% ---------------
spl_db( test_530,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_530,valid_products,[root,f1,f3,f6,f7,f5],false).


% ---------------
spl_db( test_531,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f2 ), excludes( f4 , f1 ) ]
		)
	)
).

test_data(test_531,valid_products,[root,f1,f2,f5],false).


% ---------------
spl_db( test_532,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(test_532,valid_products,[root,f3,f5,f6,f8],false).


% ---------------
spl_db( test_533,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f6 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_533,valid_products,[root,f1,f3,f4,f6],false).


% ---------------
spl_db( test_534,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f1 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_534,valid_products,[f1,f2,f4,f5,f8,f9,f6,f7],false).


% ---------------
spl_db( test_535,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(test_535,valid_products,[f1,f2,f3,f6,f7],false).


% ---------------
spl_db( test_536,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(test_536,valid_products,[f1,f4,f6,f3],false).


% ---------------
spl_db( test_537,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f3 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_537,valid_products,[root,f1,f5,f7,f9],false).


% ---------------
spl_db( test_538,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(test_538,valid_products,[root,f2,f4,f5,f1],false).


% ---------------
spl_db( test_539,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f3 ), requires( f9 , f6 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_539,valid_products,[root,f1,f5,f7,f3],false).


% ---------------
spl_db( test_540,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_540,valid_products,[root,f1,f3,f4,f5,f6,f7,f8],false).


% ---------------
spl_db( test_541,
	 spl( [ root, f1, f3, f4, f5, f7, f8, f9, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_541,valid_products,[f3,f4,f7,f6,f2],false).


% ---------------
spl_db( test_542,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_542,valid_products,[root,f2,f5,f6,f7,f8],false).


% ---------------
spl_db( test_543,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_543,valid_products,[root,f3,f8,f9],false).


% ---------------
spl_db( test_544,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f2 , f8 ) ]
		)
	)
).

test_data(test_544,valid_products,[root,f1,f2,f7],false).


% ---------------
spl_db( test_545,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f6 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(test_545,valid_products,[root,f1,f3,f4,f5,f7,f9],false).


% ---------------
spl_db( test_546,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_546,valid_products,[root,f2,f5],false).


% ---------------
spl_db( test_547,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

test_data(test_547,valid_products,[root,f2,f5,f7,f8,f9],false).


% ---------------
spl_db( test_548,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_548,valid_products,[f1,f3,f2],false).


% ---------------
spl_db( test_549,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_549,valid_products,[root,f1,f2,f4,f5,f6,f7,f8,f9],false).


% ---------------
spl_db( test_550,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f9 ), excludes( f1 , f5 ) ]
		)
	)
).

test_data(test_550,valid_products,[root,f1,f2,f4,f6,f7,f8,f9],false).


% ---------------
spl_db( test_551,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(test_551,valid_products,[root,f1,f8,f9],false).


% ---------------
spl_db( test_552,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_552,valid_products,[root,f2,f3,f7],false).


% ---------------
spl_db( test_553,
	 spl( [ root, f1, f3, f4, f5, f8, f6, f9, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

test_data(test_553,valid_products,[root,f1,f4,f6,f9,f8],false).


% ---------------
spl_db( test_554,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(test_554,valid_products,[root,f1,f2,f6,f8],false).


% ---------------
spl_db( test_555,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f7 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(test_555,valid_products,[root,f1,f2,f4,f8],false).


% ---------------
spl_db( test_556,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_556,valid_products,[root,f5,f6],false).


% ---------------
spl_db( test_557,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f2 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_557,valid_products,[root,f2,f7,f8,f9],false).


% ---------------
spl_db( test_558,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_558,valid_products,[root,f1,f2,f3,f5,f7,f8,f9],false).


% ---------------
spl_db( test_559,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f3 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(test_559,valid_products,[root,f1,f3,f9,f5,f6],false).


% ---------------
spl_db( test_560,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f6, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_560,valid_products,[root,f2,f3,f5],false).


% ---------------
spl_db( test_561,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_561,valid_products,[root,f1,f3,f4,f5],false).


% ---------------
spl_db( test_562,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f9 , f7 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_562,valid_products,[f3,f1],false).


% ---------------
spl_db( test_563,
	 spl( [ root, f1, f8, f2, f3, f4, f6, f7, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_563,valid_products,[root,f1,f4,f7,f8],false).


% ---------------
spl_db( test_564,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_564,valid_products,[root,f1,f2,f4],false).


% ---------------
spl_db( test_565,
	 spl( [ root, f1, f2, f3, f4, f6, f5, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ) ] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(test_565,valid_products,[root,f1,f4],false).


% ---------------
spl_db( test_566,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(test_566,valid_products,[root,f1,f2,f7],false).


% ---------------
spl_db( test_567,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_567,valid_products,[root,f3,f5,f8],false).


% ---------------
spl_db( test_568,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

test_data(test_568,valid_products,[root,f4,f5,f3],false).


% ---------------
spl_db( test_569,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_569,valid_products,[f2,f3,f4,f6,f5],false).


% ---------------
spl_db( test_570,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_570,valid_products,[root,f2,f4,f5,f6,f8],false).


% ---------------
spl_db( test_571,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_571,valid_products,[root,f4,f6,f8],false).


% ---------------
spl_db( test_572,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_572,valid_products,[root,f1,f3,f5,f7,f4],false).


% ---------------
spl_db( test_573,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f5 ), requires( f1 , f6 ) ]
		)
	)
).

test_data(test_573,valid_products,[root,f9,f2,f3,f6,f7,f8],false).


% ---------------
spl_db( test_574,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f5 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_574,valid_products,[root,f2,f5,f6,f7],false).


% ---------------
spl_db( test_575,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_575,valid_products,[root,f1,f2,f4,f5,f8,f3],false).


% ---------------
spl_db( test_576,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f4, f5, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_576,valid_products,[root,f4],false).


% ---------------
spl_db( test_577,
	 spl( [ root, f1, f4, f7, f9, f8, f5, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_577,valid_products,[root,f3],true).


% ---------------
spl_db( test_578,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_578,valid_products,[root,f1,f3,f5],false).


% ---------------
spl_db( test_579,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(test_579,valid_products,[root,f1,f3,f5,f6],false).


% ---------------
spl_db( test_580,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_580,valid_products,[root,f1,f3,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_581,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_581,valid_products,[f3,f5,f8],false).


% ---------------
spl_db( test_582,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f9 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_582,valid_products,[root,f1,f2,f4,f5,f6,f9],true).


% ---------------
spl_db( test_583,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

test_data(test_583,valid_products,[root,f6,f7],false).


% ---------------
spl_db( test_584,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_584,valid_products,[root,f1,f2,f3,f5,f6,f9],true).


% ---------------
spl_db( test_585,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(test_585,valid_products,[f2,f4,f5,f6,f7],false).


% ---------------
spl_db( test_586,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f2 ) ]
		)
	)
).

test_data(test_586,valid_products,[root,f3,f6,f8],false).


% ---------------
spl_db( test_587,
	 spl( [ root, f1, f2, f3, f6, f4, f9, f5, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(test_587,valid_products,[root,f1,f2,f3,f9],false).


% ---------------
spl_db( test_588,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f3, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(test_588,valid_products,[root,f1,f2,f5,f6,f7],true).


% ---------------
spl_db( test_589,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_589,valid_products,[root,f2,f3,f5,f7,f9],false).


% ---------------
spl_db( test_590,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_590,valid_products,[f1,f2,f3,f5,f9],false).


% ---------------
spl_db( test_591,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f9 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_591,valid_products,[root,f1,f2,f3,f4,f6,f7,f8],true).


% ---------------
spl_db( test_592,
	 spl( [ root, f1, f2, f8, f3, f7, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(test_592,valid_products,[root,f2,f3,f4,f5,f7,f8,f1],false).


% ---------------
spl_db( test_593,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_593,valid_products,[root,f8],false).


% ---------------
spl_db( test_594,
	 spl( [ root, f1, f3, f7, f8, f9, f4, f5, f6, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f2 , f3 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(test_594,valid_products,[root,f1,f2,f4,f6,f7,f8],false).


% ---------------
spl_db( test_595,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f9 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(test_595,valid_products,[root,f1,f2,f4,f8,f6],false).


% ---------------
spl_db( test_596,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_596,valid_products,[f1,f5,f9],false).


% ---------------
spl_db( test_597,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [
						optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_597,valid_products,[root,f1,f2,f3,f4,f5,f7,f6],false).


% ---------------
spl_db( test_598,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_598,valid_products,[root],true).


% ---------------
spl_db( test_599,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(test_599,valid_products,[root,f1,f2,f5,f8],false).


% ---------------
spl_db( test_600,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_600,valid_products,[root,f1,f3,f6,f7,f8],true).


% ---------------
spl_db( test_601,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_601,valid_products,[root,f3,f4,f7],false).


% ---------------
spl_db( test_602,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f2 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_602,valid_products,[root,f1,f2,f4,f9,f5,f6],false).


% ---------------
spl_db( test_603,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f9 ), requires( f2 , f7 ) ]
		)
	)
).

test_data(test_603,valid_products,[f6,f7],false).


% ---------------
spl_db( test_604,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_604,valid_products,[root,f1,f3,f4,f5,f6,f8],true).


% ---------------
spl_db( test_605,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(test_605,valid_products,[root,f1,f2,f3,f6,f8,f9],false).


% ---------------
spl_db( test_606,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_606,valid_products,[root,f4,f6,f8,f7],false).


% ---------------
spl_db( test_607,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_607,valid_products,[root,f2,f7,f9,f6],false).


% ---------------
spl_db( test_608,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_608,valid_products,[root,f1,f2,f3,f5,f6,f7,f9],true).


% ---------------
spl_db( test_609,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_609,valid_products,[f1,f2,f4,f5,f7,f3],false).


% ---------------
spl_db( test_610,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f1 ), excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_610,valid_products,[root,f1,f2,f4,f5,f9],true).


% ---------------
spl_db( test_611,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_611,valid_products,[root,f1,f2,f3,f4,f5,f7,f9],false).


% ---------------
spl_db( test_612,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(test_612,valid_products,[root],false).


% ---------------
spl_db( test_613,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

test_data(test_613,valid_products,[root,f2,f4],false).


% ---------------
spl_db( test_614,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f7 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(test_614,valid_products,[f2,f3,f4,f5,f7,f9,f6],false).


% ---------------
spl_db( test_615,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(test_615,valid_products,[root],true).


% ---------------
spl_db( test_616,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f7 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_616,valid_products,[f1,f5,f7,f2],false).


% ---------------
spl_db( test_617,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_617,valid_products,[root,f1,f2,f5,f7,f9],true).


% ---------------
spl_db( test_618,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(test_618,valid_products,[root,f1,f3,f4,f8],true).


% ---------------
spl_db( test_619,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_619,valid_products,[root,f1,f2,f3,f5,f6,f9],true).


% ---------------
spl_db( test_620,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_620,valid_products,[root,f3,f4,f7,f9],true).


% ---------------
spl_db( test_621,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f1 ), requires( f5 , f3 ) ]
		)
	)
).

test_data(test_621,valid_products,[root,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_622,
	 spl( [ root, f1, f8, f2, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_622,valid_products,[root,f4,f6,f9],false).


% ---------------
spl_db( test_623,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f4 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_623,valid_products,[root,f2,f4],false).


% ---------------
spl_db( test_624,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f9 ), excludes( f6 , f1 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_624,valid_products,[root,f2,f3,f6,f7,f1],false).


% ---------------
spl_db( test_625,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_625,valid_products,[root,f4,f5,f7,f2],false).


% ---------------
spl_db( test_626,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f5 ), excludes( f6 , f3 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(test_626,valid_products,[root,f3,f7,f9,f5],false).


% ---------------
spl_db( test_627,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_627,valid_products,[root,f1,f3,f4,f5,f7,f9],false).


% ---------------
spl_db( test_628,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f1 , f3 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(test_628,valid_products,[root,f1,f2,f4,f5,f6,f7,f8],false).


% ---------------
spl_db( test_629,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f2 , f8 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(test_629,valid_products,[root,f1,f2,f3,f5,f6],false).


% ---------------
spl_db( test_630,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f8 ), requires( f1 , f9 ) ]
		)
	)
).

test_data(test_630,valid_products,[root,f5,f7],false).


% ---------------
spl_db( test_631,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
							optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_631,valid_products,[root,f1,f2,f3,f5,f6,f8],true).


% ---------------
spl_db( test_632,
	 spl( [ root, f1, f2, f5, f9, f6, f8, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f4 ), requires( f6 , f7 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_632,valid_products,[root,f1,f4,f6,f7,f5],false).


% ---------------
spl_db( test_633,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(test_633,valid_products,[f4,f5,f6,f3],false).


% ---------------
spl_db( test_634,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f4, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_634,valid_products,[root,f7,f6],false).


% ---------------
spl_db( test_635,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(test_635,valid_products,[root,f1,f2,f3,f5,f8],false).


% ---------------
spl_db( test_636,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_636,valid_products,[root,f1,f2,f3,f5],true).


% ---------------
spl_db( test_637,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

test_data(test_637,valid_products,[root,f2,f3,f4,f5,f8],true).


% ---------------
spl_db( test_638,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_638,valid_products,[root,f1,f5],false).


% ---------------
spl_db( test_639,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f5 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_639,valid_products,[root,f1,f3,f7,f5],false).


% ---------------
spl_db( test_640,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f6 , f3 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(test_640,valid_products,[root,f1,f2,f3,f4,f6,f7,f8,f9],true).


% ---------------
spl_db( test_641,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_641,valid_products,[root,f1,f3,f4,f7],true).


% ---------------
spl_db( test_642,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f5, f6, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(test_642,valid_products,[root,f1,f4,f7],true).


% ---------------
spl_db( test_643,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f4 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_643,valid_products,[root,f1,f4,f5,f6,f7],true).


% ---------------
spl_db( test_644,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(test_644,valid_products,[root,f1,f2,f3,f5],false).


% ---------------
spl_db( test_645,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

test_data(test_645,valid_products,[root,f5,f6],false).


% ---------------
spl_db( test_646,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_646,valid_products,[root,f3],false).


% ---------------
spl_db( test_647,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_647,valid_products,[root,f1,f2,f3,f6,f7,f8,f4],false).


% ---------------
spl_db( test_648,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(test_648,valid_products,[root,f1,f4,f5,f9,f6],false).


% ---------------
spl_db( test_649,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f9 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(test_649,valid_products,[root,f1,f4,f8,f9],false).


% ---------------
spl_db( test_650,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_650,valid_products,[root,f1,f2,f3,f4,f6,f9],true).


% ---------------
spl_db( test_651,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f7 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_651,valid_products,[root,f1,f2,f3,f4,f8],false).


% ---------------
spl_db( test_652,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_652,valid_products,[root,f1,f2,f5],false).


% ---------------
spl_db( test_653,
	 spl( [ root, f1, f2, f3, f7, f4, f9, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f9 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_653,valid_products,[root,f1,f2,f4,f5,f9,f8],false).


% ---------------
spl_db( test_654,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(test_654,valid_products,[root,f1,f2,f4,f6,f7,f8],false).


% ---------------
spl_db( test_655,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_655,valid_products,[f2,f4,f6],false).


% ---------------
spl_db( test_656,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_656,valid_products,[root,f4,f6,f5],false).


% ---------------
spl_db( test_657,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(test_657,valid_products,[root,f2,f5,f6,f8,f4],false).


% ---------------
spl_db( test_658,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f6 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(test_658,valid_products,[root,f3,f6,f8],false).


% ---------------
spl_db( test_659,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f1 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(test_659,valid_products,[f1,f2,f5,f8,f3],false).


% ---------------
spl_db( test_660,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(test_660,valid_products,[f5,f6,f8,f4],false).


% ---------------
spl_db( test_661,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f3 , f4 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_661,valid_products,[root,f1,f2,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_662,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_662,valid_products,[root,f1,f4,f6,f7,f8,f9],false).


% ---------------
spl_db( test_663,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_663,valid_products,[f1,f3,f4,f6],false).


% ---------------
spl_db( test_664,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_664,valid_products,[root,f1,f2],false).


% ---------------
spl_db( test_665,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f1 , f3 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_665,valid_products,[root,f1,f4,f5,f7,f8,f9],false).


% ---------------
spl_db( test_666,
	 spl( [ root, f1, f7, f2, f3, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f7 ), requires( f1 , f6 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_666,valid_products,[root,f2,f3,f6,f7,f8],false).


% ---------------
spl_db( test_667,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(test_667,valid_products,[root,f1,f5,f7],false).


% ---------------
spl_db( test_668,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f5 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_668,valid_products,[root,f4,f7],false).


% ---------------
spl_db( test_669,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_669,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_670,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f9 , f4 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(test_670,valid_products,[root,f2,f4,f6,f5],false).


% ---------------
spl_db( test_671,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f9, [] ) ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f3 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(test_671,valid_products,[root,f2,f3,f6,f1],false).


% ---------------
spl_db( test_672,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f3 , f8 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_672,valid_products,[root,f1,f2,f3,f4,f7,f9],true).


% ---------------
spl_db( test_673,
	 spl( [ root, f1, f5, f6, f2, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [
					optional( feature( f6, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(test_673,valid_products,[root,f1,f2,f3,f5,f6,f7,f4],false).


% ---------------
spl_db( test_674,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_674,valid_products,[root,f1,f2,f4,f6,f7],false).


% ---------------
spl_db( test_675,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_675,valid_products,[f2,f3,f4,f6,f9],false).


% ---------------
spl_db( test_676,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(test_676,valid_products,[root,f3,f4,f5,f7,f9],false).


% ---------------
spl_db( test_677,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(test_677,valid_products,[root,f1,f2,f3,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_678,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f8 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_678,valid_products,[root,f3,f6,f7,f8,f9],false).


% ---------------
spl_db( test_679,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f7 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(test_679,valid_products,[root,f1,f7],false).


% ---------------
spl_db( test_680,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [
						optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_680,valid_products,[root,f1,f3,f5,f6,f7,f4],false).


% ---------------
spl_db( test_681,
	 spl( [ root, f1, f3, f5, f7, f6, f2, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f5, [
						mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f2 , f1 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_681,valid_products,[root,f1,f2,f5,f7],false).


% ---------------
spl_db( test_682,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_682,valid_products,[root,f1,f2,f3,f8,f9],true).


% ---------------
spl_db( test_683,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_683,valid_products,[root,f2,f4],false).


% ---------------
spl_db( test_684,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(test_684,valid_products,[root,f2,f6,f7,f8],false).


% ---------------
spl_db( test_685,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(test_685,valid_products,[root,f2,f3,f4,f6,f8,f9],false).


% ---------------
spl_db( test_686,
	 spl( [ root, f1, f4, f5, f2, f6, f8, f9, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

test_data(test_686,valid_products,[root,f1,f2,f4,f6,f7,f9],false).


% ---------------
spl_db( test_687,
	 spl( [ root, f1, f2, f7, f3, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f3 , f6 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(test_687,valid_products,[root,f1,f4,f5,f6,f9],true).


% ---------------
spl_db( test_688,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_688,valid_products,[root,f2,f7],false).


% ---------------
spl_db( test_689,
	 spl( [ root, f1, f2, f6, f3, f4, f7, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f3 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_689,valid_products,[f1,f2,f3,f5,f9],false).


% ---------------
spl_db( test_690,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_690,valid_products,[root,f1,f3,f5,f6,f7],false).


% ---------------
spl_db( test_691,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

test_data(test_691,valid_products,[root,f3,f4],false).


% ---------------
spl_db( test_692,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_692,valid_products,[f1,f2,f4,f6,f7],false).


% ---------------
spl_db( test_693,
	 spl( [ root, f1, f3, f4, f6, f7, f8, f9, f5, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_693,valid_products,[root,f1,f2,f4,f5,f8],true).


% ---------------
spl_db( test_694,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_694,valid_products,[root],false).


% ---------------
spl_db( test_695,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f6 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_695,valid_products,[f1,f5,f7,f6],false).


% ---------------
spl_db( test_696,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_696,valid_products,[root,f2,f4,f8],false).


% ---------------
spl_db( test_697,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_697,valid_products,[root,f1,f2,f3,f8,f9],true).


% ---------------
spl_db( test_698,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_698,valid_products,[root,f1,f2,f5],false).


% ---------------
spl_db( test_699,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ requires( f8 , f7 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(test_699,valid_products,[root,f1,f2,f4,f5,f6,f7],false).


% ---------------
spl_db( test_700,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f5 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(test_700,valid_products,[root,f1,f2,f6],false).


% ---------------
spl_db( test_701,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(test_701,valid_products,[root,f2,f3,f4],true).


% ---------------
spl_db( test_702,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f8 , f9 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(test_702,valid_products,[root,f2,f7,f9],false).


% ---------------
spl_db( test_703,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_703,valid_products,[root,f1,f2,f9],false).


% ---------------
spl_db( test_704,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f5 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(test_704,valid_products,[root,f1,f2,f3,f4,f5,f8,f6],false).


% ---------------
spl_db( test_705,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_705,valid_products,[root,f2,f4],false).


% ---------------
spl_db( test_706,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f4 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(test_706,valid_products,[root,f4,f8],false).


% ---------------
spl_db( test_707,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_707,valid_products,[root,f6],false).


% ---------------
spl_db( test_708,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_708,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_709,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_709,valid_products,[root,f4,f5,f6,f8,f7],false).


% ---------------
spl_db( test_710,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f5 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(test_710,valid_products,[root,f4,f5,f6],false).


% ---------------
spl_db( test_711,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_711,valid_products,[root,f1,f2,f4,f6,f8],false).


% ---------------
spl_db( test_712,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_712,valid_products,[root,f1,f2,f4,f6,f7,f9],false).


% ---------------
spl_db( test_713,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f6 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_713,valid_products,[root,f3,f4,f6,f9,f7],false).


% ---------------
spl_db( test_714,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f9 , f1 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_714,valid_products,[f2,f4,f1],false).


% ---------------
spl_db( test_715,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_715,valid_products,[f2,f1],false).


% ---------------
spl_db( test_716,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_716,valid_products,[root,f2,f3],false).


% ---------------
spl_db( test_717,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f7 , f4 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_717,valid_products,[root,f2,f4,f6,f8],true).


% ---------------
spl_db( test_718,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ requires( f7 , f4 ), requires( f1 , f6 ) ]
		)
	)
).

test_data(test_718,valid_products,[root,f1,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_719,
	 spl( [ root, f1, f2, f3, f6, f4, f7, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ) ] ), feature( f4, [
				mandatory( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_719,valid_products,[f1,f2,f3,f6],false).


% ---------------
spl_db( test_720,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f4 ), requires( f1 , f8 ) ]
		)
	)
).

test_data(test_720,valid_products,[root,f4,f6],false).


% ---------------
spl_db( test_721,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_721,valid_products,[root,f1,f2,f3],false).


% ---------------
spl_db( test_722,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

test_data(test_722,valid_products,[root,f1,f4,f5],false).


% ---------------
spl_db( test_723,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(test_723,valid_products,[root,f3,f4],false).


% ---------------
spl_db( test_724,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(test_724,valid_products,[f2,f3,f4,f6,f8,f7],false).


% ---------------
spl_db( test_725,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_725,valid_products,[root,f3,f6,f8,f9],false).


% ---------------
spl_db( test_726,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_726,valid_products,[root,f2,f6,f3],false).


% ---------------
spl_db( test_727,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_727,valid_products,[root,f2,f5,f6,f9,f3],false).


% ---------------
spl_db( test_728,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(test_728,valid_products,[root,f5],false).


% ---------------
spl_db( test_729,
	 spl( [ root, f1, f3, f5, f6, f8, f7, f4, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_729,valid_products,[root,f1,f4,f6,f8,f5],false).


% ---------------
spl_db( test_730,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_730,valid_products,[root,f1,f4],false).


% ---------------
spl_db( test_731,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(test_731,valid_products,[f1,f2,f3,f5,f7,f8,f9],false).


% ---------------
spl_db( test_732,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), requires( f6 , f5 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_732,valid_products,[root,f1,f2,f5,f8],false).


% ---------------
spl_db( test_733,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(test_733,valid_products,[root,f1,f4,f5,f6,f7],false).


% ---------------
spl_db( test_734,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_734,valid_products,[root,f1,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_735,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_735,valid_products,[root,f1,f2,f3,f4,f7,f8,f9],false).


% ---------------
spl_db( test_736,
	 spl( [ root, f1, f2, f6, f8, f9, f7, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_736,valid_products,[root,f2,f3,f8],false).


% ---------------
spl_db( test_737,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_737,valid_products,[root,f1,f2,f5,f6,f7,f9],true).


% ---------------
spl_db( test_738,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f4 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_738,valid_products,[f1,f3,f5,f8],false).


% ---------------
spl_db( test_739,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_739,valid_products,[root,f1,f2,f3,f5,f8],true).


% ---------------
spl_db( test_740,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f3 ), requires( f5 , f3 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_740,valid_products,[f1,f2],false).


% ---------------
spl_db( test_741,
	 spl( [ root, f1, f2, f5, f6, f8, f9, f7, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f7, [] ) ) ] ), feature( f3, [
					optional( feature( f4, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(test_741,valid_products,[root,f1,f5,f7],false).


% ---------------
spl_db( test_742,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f1 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_742,valid_products,[f1,f2,f4,f7,f3],false).


% ---------------
spl_db( test_743,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f7 ), requires( f8 , f3 ) ]
		)
	)
).

test_data(test_743,valid_products,[f3,f6,f8,f1],false).


% ---------------
spl_db( test_744,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f5 ), excludes( f2 , f8 ) ]
		)
	)
).

test_data(test_744,valid_products,[root,f1,f4,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_745,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_745,valid_products,[f2,f5,f6,f7,f8],false).


% ---------------
spl_db( test_746,
	 spl( [ root, f1, f7, f8, f2, f4, f5, f6, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f2, [
				mandatory( feature( f4, [
					one_or_more( [ feature( f5, [] ), feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(test_746,valid_products,[root,f1,f7,f8],true).


% ---------------
spl_db( test_747,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(test_747,valid_products,[root,f2,f4,f5,f6,f7],false).


% ---------------
spl_db( test_748,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f8 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_748,valid_products,[root,f1,f2,f3,f4,f6,f7,f9],true).


% ---------------
spl_db( test_749,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_749,valid_products,[root,f3],false).


% ---------------
spl_db( test_750,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_750,valid_products,[root,f2,f3,f4,f7,f8,f9],false).


% ---------------
spl_db( test_751,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(test_751,valid_products,[root,f1,f2,f5,f6,f7,f8],true).


% ---------------
spl_db( test_752,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_752,valid_products,[root,f1,f2,f6,f7,f8],false).


% ---------------
spl_db( test_753,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_753,valid_products,[root,f2,f6,f9],false).


% ---------------
spl_db( test_754,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_754,valid_products,[f6,f2],false).


% ---------------
spl_db( test_755,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

test_data(test_755,valid_products,[f1,f3,f4,f6,f7],false).


% ---------------
spl_db( test_756,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(test_756,valid_products,[root,f1,f7],false).


% ---------------
spl_db( test_757,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f6 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(test_757,valid_products,[root,f3,f4,f7,f6],false).


% ---------------
spl_db( test_758,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_758,valid_products,[root],false).


% ---------------
spl_db( test_759,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_759,valid_products,[root,f1,f4,f7],false).


% ---------------
spl_db( test_760,
	 spl( [ root, f1, f4, f5, f7, f8, f9, f6, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f9 , f6 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_760,valid_products,[root,f7,f8],false).


% ---------------
spl_db( test_761,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_761,valid_products,[root,f5,f7,f8],false).


% ---------------
spl_db( test_762,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

test_data(test_762,valid_products,[root,f2,f3,f4,f5,f6,f8],true).


% ---------------
spl_db( test_763,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ requires( f8 , f6 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_763,valid_products,[root,f1,f2,f3,f5,f6,f7,f8],true).


% ---------------
spl_db( test_764,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_764,valid_products,[root,f3,f4,f8,f9,f5],false).


% ---------------
spl_db( test_765,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f5 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_765,valid_products,[root,f1,f3,f4,f8,f9],false).


% ---------------
spl_db( test_766,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_766,valid_products,[root,f1,f2,f3,f4,f6,f8,f9],true).


% ---------------
spl_db( test_767,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_767,valid_products,[root,f1,f2,f4,f9,f3],false).


% ---------------
spl_db( test_768,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_768,valid_products,[root,f1,f2,f3,f6,f8,f9],false).


% ---------------
spl_db( test_769,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(test_769,valid_products,[root,f1,f2,f4,f5,f7,f8,f9],false).


% ---------------
spl_db( test_770,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f4 ), excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_770,valid_products,[root,f2,f3,f4,f8],true).


% ---------------
spl_db( test_771,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_771,valid_products,[root,f1,f2,f4,f6,f8,f7],false).


% ---------------
spl_db( test_772,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_772,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_773,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_773,valid_products,[root,f1,f3,f4,f5,f6,f8],true).


% ---------------
spl_db( test_774,
	 spl( [ root, f1, f8, f2, f3, f5, f7, f6, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f5, [
					mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_774,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_775,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_775,valid_products,[root,f1,f2,f3,f4,f5,f6,f8],true).


% ---------------
spl_db( test_776,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f5 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(test_776,valid_products,[root,f1,f2,f3,f4,f5,f6,f9,f7,f8],false).


% ---------------
spl_db( test_777,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_777,valid_products,[root,f1,f2,f6,f9],false).


% ---------------
spl_db( test_778,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_778,valid_products,[root,f1,f2,f3,f4,f6,f7,f9],true).


% ---------------
spl_db( test_779,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_779,valid_products,[root,f1,f3,f6,f8,f7],false).


% ---------------
spl_db( test_780,
	 spl( [ root, f1, f6, f2, f3, f4, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_780,valid_products,[root,f1,f2,f3,f4],false).


% ---------------
spl_db( test_781,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f2 , f3 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_781,valid_products,[root,f2,f4,f6,f8,f9],false).


% ---------------
spl_db( test_782,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f9 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_782,valid_products,[f1,f3,f4,f8,f9],false).


% ---------------
spl_db( test_783,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_783,valid_products,[root,f2,f4,f5,f6,f8,f7],false).


% ---------------
spl_db( test_784,
	 spl( [ root, f1, f5, f2, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f5, [] ) ) ] ), feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f9 , f2 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_784,valid_products,[root,f2,f4,f6],false).


% ---------------
spl_db( test_785,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(test_785,valid_products,[root,f2,f5,f6,f9],false).


% ---------------
spl_db( test_786,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_786,valid_products,[root,f1,f4,f5,f7],false).


% ---------------
spl_db( test_787,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_787,valid_products,[root,f1,f4,f5,f7,f8],false).


% ---------------
spl_db( test_788,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f4 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_788,valid_products,[root,f1,f2,f8,f9,f3,f4],false).


% ---------------
spl_db( test_789,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_789,valid_products,[root,f3,f5,f9],false).


% ---------------
spl_db( test_790,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f8 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_790,valid_products,[root,f3,f5,f6,f8,f9],false).


% ---------------
spl_db( test_791,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_791,valid_products,[root,f1,f3,f5,f8,f9],false).


% ---------------
spl_db( test_792,
	 spl( [ root, f1, f8, f9, f2, f4, f5, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_792,valid_products,[root,f2,f4],false).


% ---------------
spl_db( test_793,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_793,valid_products,[root,f4,f5,f9,f6,f7],false).


% ---------------
spl_db( test_794,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_794,valid_products,[root,f1],true).


% ---------------
spl_db( test_795,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f1 ), excludes( f7 , f9 ), requires( f6 , f1 ) ]
		)
	)
).

test_data(test_795,valid_products,[root,f1,f2,f3,f5],true).


% ---------------
spl_db( test_796,
	 spl( [ root, f1, f4, f7, f8, f5, f2, f3, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f3 , f8 ), excludes( f6 , f5 ) ]
		)
	)
).

test_data(test_796,valid_products,[root,f1,f2,f3,f4,f5,f7,f8],true).


% ---------------
spl_db( test_797,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_797,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_798,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_798,valid_products,[root,f2,f5,f6,f8,f9],true).


% ---------------
spl_db( test_799,
	 spl( [ root, f1, f6, f8, f2, f9, f3, f5, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_799,valid_products,[root,f1,f3,f7],false).


% ---------------
spl_db( test_800,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f2 ), excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_800,valid_products,[root,f1,f2,f4],false).


% ---------------
spl_db( test_801,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_801,valid_products,[root,f1,f2,f3,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_802,
	 spl( [ root, f1, f8, f2, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

test_data(test_802,valid_products,[root,f1,f3,f4,f7,f2],false).


% ---------------
spl_db( test_803,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(test_803,valid_products,[root,f2,f3,f7],false).


% ---------------
spl_db( test_804,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_804,valid_products,[root,f1,f2,f3,f4,f5,f7,f8],true).


% ---------------
spl_db( test_805,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(test_805,valid_products,[root,f2,f8],false).


% ---------------
spl_db( test_806,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f3, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f3 , f2 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_806,valid_products,[root,f2,f5,f6,f7],false).


% ---------------
spl_db( test_807,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_807,valid_products,[root,f1,f3,f5],false).


% ---------------
spl_db( test_808,
	 spl( [ root, f1, f8, f2, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_808,valid_products,[root,f2,f6,f9],false).


% ---------------
spl_db( test_809,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_809,valid_products,[root,f2,f5,f6],false).


% ---------------
spl_db( test_810,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f7 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_810,valid_products,[root,f1,f4,f5,f8],false).


% ---------------
spl_db( test_811,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(test_811,valid_products,[root,f2,f5,f6,f8],false).


% ---------------
spl_db( test_812,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(test_812,valid_products,[root,f4,f7],false).


% ---------------
spl_db( test_813,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_813,valid_products,[root,f1,f3,f4,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_814,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_814,valid_products,[root,f5],false).


% ---------------
spl_db( test_815,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f2 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_815,valid_products,[root,f1,f2,f3,f8,f9],false).


% ---------------
spl_db( test_816,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_816,valid_products,[root,f2,f5,f6,f7,f8],false).


% ---------------
spl_db( test_817,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_817,valid_products,[root,f2,f4,f5,f6,f8,f7],false).


% ---------------
spl_db( test_818,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_818,valid_products,[root,f2,f3,f6,f9],false).


% ---------------
spl_db( test_819,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_819,valid_products,[root,f1,f3,f5,f8],false).


% ---------------
spl_db( test_820,
	 spl( [ root, f1, f9, f2, f3, f7, f4, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f7, [] ) ) ] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_820,valid_products,[root,f1,f3],false).


% ---------------
spl_db( test_821,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(test_821,valid_products,[root,f1,f2,f3,f4,f5,f6,f7],false).


% ---------------
spl_db( test_822,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(test_822,valid_products,[root,f1,f4,f6,f8],false).


% ---------------
spl_db( test_823,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(test_823,valid_products,[root,f1,f2,f3,f4,f5,f6],true).


% ---------------
spl_db( test_824,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f9 , f6 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(test_824,valid_products,[root,f2,f7,f9],false).


% ---------------
spl_db( test_825,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(test_825,valid_products,[root,f2,f4,f6,f7,f8],false).


% ---------------
spl_db( test_826,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_826,valid_products,[root,f1,f2,f3,f5,f6,f7],true).


% ---------------
spl_db( test_827,
	 spl( [ root, f1, f2, f3, f4, f6, f8, f9, f7, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

test_data(test_827,valid_products,[root,f2,f4,f5,f7],true).


% ---------------
spl_db( test_828,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f6 ), excludes( f5 , f1 ) ]
		)
	)
).

test_data(test_828,valid_products,[root,f1,f2,f3,f6],true).


% ---------------
spl_db( test_829,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_829,valid_products,[root,f1,f2,f4,f5,f6],true).


% ---------------
spl_db( test_830,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_830,valid_products,[root,f1,f2,f3,f4,f5,f9],true).


% ---------------
spl_db( test_831,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_831,valid_products,[f1,f3,f6,f9,f5],false).


% ---------------
spl_db( test_832,
	 spl( [ root, f1, f8, f9, f2, f6, f7, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_832,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_833,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f8 , f9 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_833,valid_products,[root,f1,f2,f3,f4,f7],true).


% ---------------
spl_db( test_834,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(test_834,valid_products,[root,f1,f2,f3,f5,f8],true).


% ---------------
spl_db( test_835,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f3 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_835,valid_products,[root,f2,f3,f5,f6],false).


% ---------------
spl_db( test_836,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f2 , f3 ) ]
		)
	)
).

test_data(test_836,valid_products,[root,f1,f2,f5],false).


% ---------------
spl_db( test_837,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_837,valid_products,[root,f1,f5,f7],false).


% ---------------
spl_db( test_838,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_838,valid_products,[root,f1,f2,f6,f8,f9],false).


% ---------------
spl_db( test_839,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(test_839,valid_products,[root,f3,f4,f8],false).


% ---------------
spl_db( test_840,
	 spl( [ root, f1, f3, f8, f9, f2, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_840,valid_products,[root,f6,f7],false).


% ---------------
spl_db( test_841,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f2 ) ]
		)
	)
).

test_data(test_841,valid_products,[root,f2,f4,f5,f7,f3],false).


% ---------------
spl_db( test_842,
	 spl( [ root, f1, f3, f9, f4, f2, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f3 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(test_842,valid_products,[root,f1,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_843,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(test_843,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8],true).


% ---------------
spl_db( test_844,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(test_844,valid_products,[root,f1,f2,f3,f4,f6,f7,f8],false).


% ---------------
spl_db( test_845,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(test_845,valid_products,[root,f3,f4,f6,f8],false).


% ---------------
spl_db( test_846,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f4 , f8 ), requires( f2 , f8 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_846,valid_products,[root,f1,f3,f4,f5,f8,f6,f7],false).


% ---------------
spl_db( test_847,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_847,valid_products,[root,f1,f2,f3,f4,f6,f7,f8],false).


% ---------------
spl_db( test_848,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(test_848,valid_products,[root,f2,f4,f5,f9],false).


% ---------------
spl_db( test_849,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f8, [] ) ) ] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_849,valid_products,[root,f1,f2],false).


% ---------------
spl_db( test_850,
	 spl( [ root, f1, f8, f2, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_850,valid_products,[root,f1,f3,f6,f8],false).


% ---------------
spl_db( test_851,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f2 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(test_851,valid_products,[root,f3,f4,f5,f8],true).


% ---------------
spl_db( test_852,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ), excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_852,valid_products,[f1],false).


% ---------------
spl_db( test_853,
	 spl( [ root, f1, f4, f9, f5, f6, f2, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_853,valid_products,[root,f1,f3,f5],false).


% ---------------
spl_db( test_854,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_854,valid_products,[root,f1,f2,f3,f4,f6,f7],true).


% ---------------
spl_db( test_855,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(test_855,valid_products,[root,f4,f5,f6,f8,f9],false).


% ---------------
spl_db( test_856,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f5 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_856,valid_products,[root,f1,f2,f7],true).


% ---------------
spl_db( test_857,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_857,valid_products,[f2,f4,f8],false).


% ---------------
spl_db( test_858,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

test_data(test_858,valid_products,[root,f3,f5,f6,f7,f8],true).


% ---------------
spl_db( test_859,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f3 , f8 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(test_859,valid_products,[root,f1,f6],false).


% ---------------
spl_db( test_860,
	 spl( [ root, f1, f3, f9, f2, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_860,valid_products,[root,f1,f2,f4,f5,f6,f9],false).


% ---------------
spl_db( test_861,
	 spl( [ root, f1, f4, f5, f8, f6, f9, f2, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_861,valid_products,[root,f1,f2,f4,f5,f8],false).


% ---------------
spl_db( test_862,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_862,valid_products,[root,f5,f8],false).


% ---------------
spl_db( test_863,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_863,valid_products,[root,f1,f2,f4],false).


% ---------------
spl_db( test_864,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(test_864,valid_products,[root,f1,f2,f3,f4,f6],false).


% ---------------
spl_db( test_865,
	 spl( [ root, f1, f5, f6, f7, f2, f9, f3, f4, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_865,valid_products,[root,f1,f2,f7],false).


% ---------------
spl_db( test_866,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_866,valid_products,[root,f1,f2,f4,f5,f6,f9,f8],false).


% ---------------
spl_db( test_867,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f1 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(test_867,valid_products,[root,f1,f2,f3,f4,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_868,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(test_868,valid_products,[root,f1,f2,f3,f6,f8,f9],false).


% ---------------
spl_db( test_869,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

test_data(test_869,valid_products,[root,f1,f2,f3,f4,f5,f7,f8],true).


% ---------------
spl_db( test_870,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_870,valid_products,[root,f2,f3,f4,f5,f6,f7,f9,f8],false).


% ---------------
spl_db( test_871,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_871,valid_products,[root,f2,f3,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_872,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_872,valid_products,[root,f1,f2,f3,f4,f5,f6,f9,f7,f8],false).


% ---------------
spl_db( test_873,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f8 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_873,valid_products,[root,f2,f4,f6],true).


% ---------------
spl_db( test_874,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_874,valid_products,[root,f1,f2,f3,f5,f7,f8,f9],false).


% ---------------
spl_db( test_875,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f6, [] ) ), mandatory( feature( f7, [
							mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_875,valid_products,[root,f1,f2,f3,f4,f7,f8,f9],true).


% ---------------
spl_db( test_876,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(test_876,valid_products,[root,f1,f2,f4,f5,f7,f8,f9],true).


% ---------------
spl_db( test_877,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f4 ), requires( f5 , f7 ) ]
		)
	)
).

test_data(test_877,valid_products,[root,f1,f2,f3,f5,f6,f7,f8],true).


% ---------------
spl_db( test_878,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f3 ), requires( f2 , f4 ) ]
		)
	)
).

test_data(test_878,valid_products,[root,f1,f2,f3,f4,f7,f9],true).


% ---------------
spl_db( test_879,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_879,valid_products,[root,f2],false).


% ---------------
spl_db( test_880,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_880,valid_products,[root,f1,f2,f3,f6,f8],true).


% ---------------
spl_db( test_881,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(test_881,valid_products,[root,f1,f2,f4,f6,f7,f8,f9],true).


% ---------------
spl_db( test_882,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f6 ), requires( f2 , f8 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_882,valid_products,[root,f1,f7,f8,f9],false).


% ---------------
spl_db( test_883,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_883,valid_products,[root,f1,f2,f3,f5,f7,f8],true).


% ---------------
spl_db( test_884,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_884,valid_products,[root,f1,f2,f3,f4,f6,f8],true).


% ---------------
spl_db( test_885,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(test_885,valid_products,[root,f1,f3,f4,f5,f8],false).


% ---------------
spl_db( test_886,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_886,valid_products,[root,f1,f3,f4,f8],true).


% ---------------
spl_db( test_887,
	 spl( [ root, f1, f5, f2, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

test_data(test_887,valid_products,[root,f2,f6],false).


% ---------------
spl_db( test_888,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f1 , f3 ), excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_888,valid_products,[root],false).


% ---------------
spl_db( test_889,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f8 ), requires( f7 , f4 ) ]
		)
	)
).

test_data(test_889,valid_products,[root,f1,f2,f3,f5,f8],false).


% ---------------
spl_db( test_890,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f4 ), requires( f1 , f8 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(test_890,valid_products,[root,f2,f3,f5],false).


% ---------------
spl_db( test_891,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_891,valid_products,[root,f2,f8],false).


% ---------------
spl_db( test_892,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

test_data(test_892,valid_products,[root,f2,f3,f5,f6,f7,f8],false).


% ---------------
spl_db( test_893,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f6 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_893,valid_products,[root,f4,f5,f6,f8,f9],false).


% ---------------
spl_db( test_894,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_894,valid_products,[root,f2,f4,f5],false).


% ---------------
spl_db( test_895,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(test_895,valid_products,[root,f1,f2,f7],false).


% ---------------
spl_db( test_896,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f3 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(test_896,valid_products,[root,f2,f3,f4,f5,f6,f8,f9],false).


% ---------------
spl_db( test_897,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f3 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_897,valid_products,[root,f2,f4,f5,f6,f7,f8,f9],false).


% ---------------
spl_db( test_898,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_898,valid_products,[root,f1,f3,f4,f5,f6],true).


% ---------------
spl_db( test_899,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_899,valid_products,[root,f1,f3,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_900,
	 spl( [ root, f1, f4, f5, f6, f8, f9, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

test_data(test_900,valid_products,[root,f1,f2,f5,f6,f7,f8],true).


% ---------------
spl_db( test_901,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f7 ), requires( f2 , f6 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_901,valid_products,[root],true).


% ---------------
spl_db( test_902,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

test_data(test_902,valid_products,[root,f1,f2,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_903,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f9 , f1 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_903,valid_products,[root,f1,f2,f3,f5,f6,f7,f8,f9],true).


% ---------------
spl_db( test_904,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_904,valid_products,[root,f1,f2,f4,f5,f7,f9],true).


% ---------------
spl_db( test_905,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f5 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_905,valid_products,[root,f1,f2,f3,f5,f6],false).


% ---------------
spl_db( test_906,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), excludes( f1 , f4 ), requires( f9 , f1 ) ]
		)
	)
).

test_data(test_906,valid_products,[root,f1,f3,f8],false).


% ---------------
spl_db( test_907,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

test_data(test_907,valid_products,[root,f1,f3,f8],false).


% ---------------
spl_db( test_908,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_908,valid_products,[root,f1,f4,f6,f8],false).


% ---------------
spl_db( test_909,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_909,valid_products,[root,f2,f6,f8,f1],false).


% ---------------
spl_db( test_910,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(test_910,valid_products,[root,f3,f4],false).


% ---------------
spl_db( test_911,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_911,valid_products,[root,f1,f2,f3,f4,f8],true).


% ---------------
spl_db( test_912,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), excludes( f1 , f4 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_912,valid_products,[root,f1,f5,f8,f4],false).


% ---------------
spl_db( test_913,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f2 , f5 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(test_913,valid_products,[root,f1,f2,f3,f4,f6,f7,f8,f5],false).


% ---------------
spl_db( test_914,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_914,valid_products,[root,f2,f4,f5,f6,f8],false).


% ---------------
spl_db( test_915,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_915,valid_products,[root,f1,f3,f7],false).


% ---------------
spl_db( test_916,
	 spl( [ root, f1, f2, f7, f3, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_916,valid_products,[root,f1,f2,f5,f6,f7,f9],false).


% ---------------
spl_db( test_917,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(test_917,valid_products,[root,f1,f2,f4,f6],true).


% ---------------
spl_db( test_918,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_918,valid_products,[root,f1,f2,f4,f5,f6,f7,f9],true).


% ---------------
spl_db( test_919,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_919,valid_products,[root,f1,f2,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_920,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_920,valid_products,[root,f1,f3,f5,f6,f7,f8,f9],false).


% ---------------
spl_db( test_921,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_921,valid_products,[root,f2,f3,f6,f7,f8],false).


% ---------------
spl_db( test_922,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_922,valid_products,[root,f1,f2,f7,f9],true).


% ---------------
spl_db( test_923,
	 spl( [ root, f1, f3, f8, f4, f5, f6, f7, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f2 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(test_923,valid_products,[root,f1,f2,f4,f9],false).


% ---------------
spl_db( test_924,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f5, f6, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_924,valid_products,[root,f2,f3,f5,f6,f8],true).


% ---------------
spl_db( test_925,
	 spl( [ root, f1, f7, f2, f6, f3, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_925,valid_products,[root,f1,f2,f4,f6,f7,f9],true).


% ---------------
spl_db( test_926,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_926,valid_products,[root,f3,f6],false).


% ---------------
spl_db( test_927,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(test_927,valid_products,[root,f6,f9],false).


% ---------------
spl_db( test_928,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_928,valid_products,[root,f5],false).


% ---------------
spl_db( test_929,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_929,valid_products,[root,f2,f3,f7],false).


% ---------------
spl_db( test_930,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_930,valid_products,[f1,f3,f5,f8],false).


% ---------------
spl_db( test_931,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_931,valid_products,[root,f1,f3,f6],false).


% ---------------
spl_db( test_932,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_932,valid_products,[root,f1],false).


% ---------------
spl_db( test_933,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f5 , f9 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(test_933,valid_products,[root,f1,f2,f3,f5,f6,f7],false).


% ---------------
spl_db( test_934,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

test_data(test_934,valid_products,[root,f1,f2,f3,f4,f5,f8,f6],false).


% ---------------
spl_db( test_935,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_935,valid_products,[root,f2,f3,f4,f6],false).


% ---------------
spl_db( test_936,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_936,valid_products,[root,f1,f2,f4,f5],false).


% ---------------
spl_db( test_937,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f3 , f7 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_937,valid_products,[root,f1,f3,f5,f6,f8,f9],false).


% ---------------
spl_db( test_938,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_938,valid_products,[root,f1,f2,f3,f4,f6,f8,f9],false).


% ---------------
spl_db( test_939,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_939,valid_products,[root,f1,f2],false).


% ---------------
spl_db( test_940,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_940,valid_products,[root,f1,f2,f4,f7,f6],false).


% ---------------
spl_db( test_941,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f4 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_941,valid_products,[root,f1,f2,f3],false).


% ---------------
spl_db( test_942,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(test_942,valid_products,[root,f7],false).


% ---------------
spl_db( test_943,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f7 , f8 ), excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_943,valid_products,[root,f3,f4,f5,f8,f9],false).


% ---------------
spl_db( test_944,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f7, [
							optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f7 ), excludes( f6 , f5 ) ]
		)
	)
).

test_data(test_944,valid_products,[root,f1,f2,f3,f4,f6,f9],false).


% ---------------
spl_db( test_945,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_945,valid_products,[root,f1,f2,f6],false).


% ---------------
spl_db( test_946,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_946,valid_products,[root,f3,f5,f8],false).


% ---------------
spl_db( test_947,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_947,valid_products,[root,f3,f4,f6],false).


% ---------------
spl_db( test_948,
	 spl( [ root, f1, f6, f2, f7, f8, f9, f3, f5, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [
				optional( feature( f5, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_948,valid_products,[root,f2,f7,f8,f6],false).


% ---------------
spl_db( test_949,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

test_data(test_949,valid_products,[root,f1,f2,f3,f5,f6,f7,f9],true).


% ---------------
spl_db( test_950,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ), excludes( f8 , f6 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(test_950,valid_products,[root,f1,f2,f6,f7,f8,f9],false).


% ---------------
spl_db( test_951,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(test_951,valid_products,[root,f1,f7,f8],true).


% ---------------
spl_db( test_952,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f9 , f6 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_952,valid_products,[root,f1,f2,f3,f5,f7],false).


% ---------------
spl_db( test_953,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_953,valid_products,[root,f1,f2,f3,f4,f5,f7],true).


% ---------------
spl_db( test_954,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_954,valid_products,[f2,f4,f5,f6,f8],false).


% ---------------
spl_db( test_955,
	 spl( [ root, f1, f2, f5, f9, f6, f3, f4, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f1 ), excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_955,valid_products,[root,f2,f3,f5],false).


% ---------------
spl_db( test_956,
	 spl( [ root, f1, f4, f5, f2, f6, f9, f7, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), only_one( [ feature( f2, [
				only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f7 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_956,valid_products,[root,f2,f7,f5],false).


% ---------------
spl_db( test_957,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f3 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(test_957,valid_products,[f1,f2,f3,f4,f5,f8],false).


% ---------------
spl_db( test_958,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f6 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_958,valid_products,[root,f2,f7],false).


% ---------------
spl_db( test_959,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_959,valid_products,[root,f1,f2,f3,f7,f8,f9],false).


% ---------------
spl_db( test_960,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f3, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_960,valid_products,[root,f1,f3,f8],true).


% ---------------
spl_db( test_961,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_961,valid_products,[f1,f3],false).


% ---------------
spl_db( test_962,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f8 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_962,valid_products,[root,f2,f3,f4,f5,f6,f9],true).


% ---------------
spl_db( test_963,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(test_963,valid_products,[root,f1,f3,f6,f7],true).


% ---------------
spl_db( test_964,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_964,valid_products,[root,f1,f2,f3,f5,f7,f9],true).


% ---------------
spl_db( test_965,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_965,valid_products,[root,f3,f4,f5,f8],true).


% ---------------
spl_db( test_966,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

test_data(test_966,valid_products,[root,f1,f2,f3,f4,f5],false).


% ---------------
spl_db( test_967,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

test_data(test_967,valid_products,[root,f2,f3,f6,f7,f1],false).


% ---------------
spl_db( test_968,
	 spl( [ root, f1, f7, f9, f8, f2, f5, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(test_968,valid_products,[f1,f3,f7,f8,f9,f4],false).


% ---------------
spl_db( test_969,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_969,valid_products,[root,f1,f2,f6,f7,f3],false).


% ---------------
spl_db( test_970,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(test_970,valid_products,[root,f1,f2,f5,f9],false).


% ---------------
spl_db( test_971,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(test_971,valid_products,[root,f1,f2,f7],false).


% ---------------
spl_db( test_972,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_972,valid_products,[root,f4,f5,f6,f8,f9],true).


% ---------------
spl_db( test_973,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f3 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(test_973,valid_products,[root,f1,f4,f6,f3],false).


% ---------------
spl_db( test_974,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_974,valid_products,[root,f2,f3,f5,f6,f7,f4],false).


% ---------------
spl_db( test_975,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f2 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_975,valid_products,[root,f1,f4,f7,f8,f9],false).


% ---------------
spl_db( test_976,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_976,valid_products,[f1],false).


% ---------------
spl_db( test_977,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_977,valid_products,[f3,f2],false).


% ---------------
spl_db( test_978,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(test_978,valid_products,[root,f4,f7],false).


% ---------------
spl_db( test_979,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(test_979,valid_products,[root,f1,f3,f9],false).


% ---------------
spl_db( test_980,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_980,valid_products,[root,f1,f3,f4,f9,f5,f6,f7,f8],false).


% ---------------
spl_db( test_981,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_981,valid_products,[root,f1,f2,f3,f4,f5,f7,f8],true).


% ---------------
spl_db( test_982,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_982,valid_products,[f5,f7,f2],false).


% ---------------
spl_db( test_983,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_983,valid_products,[f3,f4,f5,f8,f2],false).


% ---------------
spl_db( test_984,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(test_984,valid_products,[f3,f4,f5,f7,f2],false).


% ---------------
spl_db( test_985,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), requires( f9 , f2 ) ]
		)
	)
).

test_data(test_985,valid_products,[root,f1,f2,f3,f7,f9,f5],false).


% ---------------
spl_db( test_986,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_986,valid_products,[root,f1,f2,f4],false).


% ---------------
spl_db( test_987,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_987,valid_products,[root,f4,f6,f8],false).


% ---------------
spl_db( test_988,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f9 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_988,valid_products,[root,f2,f3,f5,f7,f9],true).


% ---------------
spl_db( test_989,
	 spl( [ root, f1, f2, f4, f5, f8, f9, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f7 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(test_989,valid_products,[root,f1,f2,f3,f4,f5,f6,f9],true).


% ---------------
spl_db( test_990,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_990,valid_products,[root,f1,f3,f4,f5,f8,f9,f6,f7],false).


% ---------------
spl_db( test_991,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f6, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_991,valid_products,[root,f1,f2,f7,f8],true).


% ---------------
spl_db( test_992,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f8 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(test_992,valid_products,[root,f2,f3,f4,f5,f6],false).


% ---------------
spl_db( test_993,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(test_993,valid_products,[root,f2,f7],false).


% ---------------
spl_db( test_994,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f5 ), excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_994,valid_products,[root,f1,f4,f6,f7,f9],false).


% ---------------
spl_db( test_995,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_995,valid_products,[f1,f2,f4,f5,f6,f7,f9],false).


% ---------------
spl_db( test_996,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(test_996,valid_products,[root,f3],false).


% ---------------
spl_db( test_997,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_997,valid_products,[root,f1,f2,f4,f5,f6,f7],false).


% ---------------
spl_db( test_998,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

test_data(test_998,valid_products,[root,f1,f5,f6,f7,f8],false).


% ---------------
spl_db( test_999,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f2 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_999,valid_products,[f1,f2,f3,f4,f6],false).


% --------------- Test cases % ---------------
:- begin_tests(valid_products).

test(valid_products0) :-
	spl_db( test_0, Spl ),
	test_data( test_0, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products1) :-
	spl_db( test_1, Spl ),
	test_data( test_1, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products2) :-
	spl_db( test_2, Spl ),
	test_data( test_2, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products3) :-
	spl_db( test_3, Spl ),
	test_data( test_3, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products4) :-
	spl_db( test_4, Spl ),
	test_data( test_4, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products5) :-
	spl_db( test_5, Spl ),
	test_data( test_5, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products6) :-
	spl_db( test_6, Spl ),
	test_data( test_6, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products7) :-
	spl_db( test_7, Spl ),
	test_data( test_7, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products8) :-
	spl_db( test_8, Spl ),
	test_data( test_8, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products9) :-
	spl_db( test_9, Spl ),
	test_data( test_9, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products10) :-
	spl_db( test_10, Spl ),
	test_data( test_10, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products11) :-
	spl_db( test_11, Spl ),
	test_data( test_11, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products12) :-
	spl_db( test_12, Spl ),
	test_data( test_12, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products13) :-
	spl_db( test_13, Spl ),
	test_data( test_13, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products14) :-
	spl_db( test_14, Spl ),
	test_data( test_14, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products15) :-
	spl_db( test_15, Spl ),
	test_data( test_15, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products16) :-
	spl_db( test_16, Spl ),
	test_data( test_16, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products17) :-
	spl_db( test_17, Spl ),
	test_data( test_17, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products18) :-
	spl_db( test_18, Spl ),
	test_data( test_18, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products19) :-
	spl_db( test_19, Spl ),
	test_data( test_19, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products20) :-
	spl_db( test_20, Spl ),
	test_data( test_20, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products21) :-
	spl_db( test_21, Spl ),
	test_data( test_21, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products22) :-
	spl_db( test_22, Spl ),
	test_data( test_22, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products23) :-
	spl_db( test_23, Spl ),
	test_data( test_23, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products24) :-
	spl_db( test_24, Spl ),
	test_data( test_24, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products25) :-
	spl_db( test_25, Spl ),
	test_data( test_25, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products26) :-
	spl_db( test_26, Spl ),
	test_data( test_26, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products27) :-
	spl_db( test_27, Spl ),
	test_data( test_27, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products28) :-
	spl_db( test_28, Spl ),
	test_data( test_28, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products29) :-
	spl_db( test_29, Spl ),
	test_data( test_29, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products30) :-
	spl_db( test_30, Spl ),
	test_data( test_30, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products31) :-
	spl_db( test_31, Spl ),
	test_data( test_31, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products32) :-
	spl_db( test_32, Spl ),
	test_data( test_32, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products33) :-
	spl_db( test_33, Spl ),
	test_data( test_33, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products34) :-
	spl_db( test_34, Spl ),
	test_data( test_34, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products35) :-
	spl_db( test_35, Spl ),
	test_data( test_35, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products36) :-
	spl_db( test_36, Spl ),
	test_data( test_36, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products37) :-
	spl_db( test_37, Spl ),
	test_data( test_37, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products38) :-
	spl_db( test_38, Spl ),
	test_data( test_38, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products39) :-
	spl_db( test_39, Spl ),
	test_data( test_39, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products40) :-
	spl_db( test_40, Spl ),
	test_data( test_40, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products41) :-
	spl_db( test_41, Spl ),
	test_data( test_41, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products42) :-
	spl_db( test_42, Spl ),
	test_data( test_42, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products43) :-
	spl_db( test_43, Spl ),
	test_data( test_43, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products44) :-
	spl_db( test_44, Spl ),
	test_data( test_44, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products45) :-
	spl_db( test_45, Spl ),
	test_data( test_45, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products46) :-
	spl_db( test_46, Spl ),
	test_data( test_46, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products47) :-
	spl_db( test_47, Spl ),
	test_data( test_47, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products48) :-
	spl_db( test_48, Spl ),
	test_data( test_48, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products49) :-
	spl_db( test_49, Spl ),
	test_data( test_49, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products50) :-
	spl_db( test_50, Spl ),
	test_data( test_50, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products51) :-
	spl_db( test_51, Spl ),
	test_data( test_51, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products52) :-
	spl_db( test_52, Spl ),
	test_data( test_52, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products53) :-
	spl_db( test_53, Spl ),
	test_data( test_53, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products54) :-
	spl_db( test_54, Spl ),
	test_data( test_54, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products55) :-
	spl_db( test_55, Spl ),
	test_data( test_55, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products56) :-
	spl_db( test_56, Spl ),
	test_data( test_56, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products57) :-
	spl_db( test_57, Spl ),
	test_data( test_57, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products58) :-
	spl_db( test_58, Spl ),
	test_data( test_58, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products59) :-
	spl_db( test_59, Spl ),
	test_data( test_59, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products60) :-
	spl_db( test_60, Spl ),
	test_data( test_60, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products61) :-
	spl_db( test_61, Spl ),
	test_data( test_61, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products62) :-
	spl_db( test_62, Spl ),
	test_data( test_62, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products63) :-
	spl_db( test_63, Spl ),
	test_data( test_63, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products64) :-
	spl_db( test_64, Spl ),
	test_data( test_64, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products65) :-
	spl_db( test_65, Spl ),
	test_data( test_65, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products66) :-
	spl_db( test_66, Spl ),
	test_data( test_66, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products67) :-
	spl_db( test_67, Spl ),
	test_data( test_67, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products68) :-
	spl_db( test_68, Spl ),
	test_data( test_68, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products69) :-
	spl_db( test_69, Spl ),
	test_data( test_69, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products70) :-
	spl_db( test_70, Spl ),
	test_data( test_70, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products71) :-
	spl_db( test_71, Spl ),
	test_data( test_71, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products72) :-
	spl_db( test_72, Spl ),
	test_data( test_72, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products73) :-
	spl_db( test_73, Spl ),
	test_data( test_73, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products74) :-
	spl_db( test_74, Spl ),
	test_data( test_74, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products75) :-
	spl_db( test_75, Spl ),
	test_data( test_75, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products76) :-
	spl_db( test_76, Spl ),
	test_data( test_76, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products77) :-
	spl_db( test_77, Spl ),
	test_data( test_77, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products78) :-
	spl_db( test_78, Spl ),
	test_data( test_78, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products79) :-
	spl_db( test_79, Spl ),
	test_data( test_79, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products80) :-
	spl_db( test_80, Spl ),
	test_data( test_80, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products81) :-
	spl_db( test_81, Spl ),
	test_data( test_81, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products82) :-
	spl_db( test_82, Spl ),
	test_data( test_82, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products83) :-
	spl_db( test_83, Spl ),
	test_data( test_83, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products84) :-
	spl_db( test_84, Spl ),
	test_data( test_84, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products85) :-
	spl_db( test_85, Spl ),
	test_data( test_85, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products86) :-
	spl_db( test_86, Spl ),
	test_data( test_86, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products87) :-
	spl_db( test_87, Spl ),
	test_data( test_87, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products88) :-
	spl_db( test_88, Spl ),
	test_data( test_88, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products89) :-
	spl_db( test_89, Spl ),
	test_data( test_89, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products90) :-
	spl_db( test_90, Spl ),
	test_data( test_90, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products91) :-
	spl_db( test_91, Spl ),
	test_data( test_91, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products92) :-
	spl_db( test_92, Spl ),
	test_data( test_92, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products93) :-
	spl_db( test_93, Spl ),
	test_data( test_93, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products94) :-
	spl_db( test_94, Spl ),
	test_data( test_94, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products95) :-
	spl_db( test_95, Spl ),
	test_data( test_95, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products96) :-
	spl_db( test_96, Spl ),
	test_data( test_96, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products97) :-
	spl_db( test_97, Spl ),
	test_data( test_97, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products98) :-
	spl_db( test_98, Spl ),
	test_data( test_98, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products99) :-
	spl_db( test_99, Spl ),
	test_data( test_99, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products100) :-
	spl_db( test_100, Spl ),
	test_data( test_100, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products101) :-
	spl_db( test_101, Spl ),
	test_data( test_101, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products102) :-
	spl_db( test_102, Spl ),
	test_data( test_102, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products103) :-
	spl_db( test_103, Spl ),
	test_data( test_103, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products104) :-
	spl_db( test_104, Spl ),
	test_data( test_104, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products105) :-
	spl_db( test_105, Spl ),
	test_data( test_105, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products106) :-
	spl_db( test_106, Spl ),
	test_data( test_106, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products107) :-
	spl_db( test_107, Spl ),
	test_data( test_107, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products108) :-
	spl_db( test_108, Spl ),
	test_data( test_108, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products109) :-
	spl_db( test_109, Spl ),
	test_data( test_109, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products110) :-
	spl_db( test_110, Spl ),
	test_data( test_110, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products111) :-
	spl_db( test_111, Spl ),
	test_data( test_111, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products112) :-
	spl_db( test_112, Spl ),
	test_data( test_112, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products113) :-
	spl_db( test_113, Spl ),
	test_data( test_113, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products114) :-
	spl_db( test_114, Spl ),
	test_data( test_114, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products115) :-
	spl_db( test_115, Spl ),
	test_data( test_115, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products116) :-
	spl_db( test_116, Spl ),
	test_data( test_116, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products117) :-
	spl_db( test_117, Spl ),
	test_data( test_117, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products118) :-
	spl_db( test_118, Spl ),
	test_data( test_118, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products119) :-
	spl_db( test_119, Spl ),
	test_data( test_119, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products120) :-
	spl_db( test_120, Spl ),
	test_data( test_120, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products121) :-
	spl_db( test_121, Spl ),
	test_data( test_121, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products122) :-
	spl_db( test_122, Spl ),
	test_data( test_122, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products123) :-
	spl_db( test_123, Spl ),
	test_data( test_123, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products124) :-
	spl_db( test_124, Spl ),
	test_data( test_124, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products125) :-
	spl_db( test_125, Spl ),
	test_data( test_125, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products126) :-
	spl_db( test_126, Spl ),
	test_data( test_126, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products127) :-
	spl_db( test_127, Spl ),
	test_data( test_127, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products128) :-
	spl_db( test_128, Spl ),
	test_data( test_128, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products129) :-
	spl_db( test_129, Spl ),
	test_data( test_129, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products130) :-
	spl_db( test_130, Spl ),
	test_data( test_130, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products131) :-
	spl_db( test_131, Spl ),
	test_data( test_131, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products132) :-
	spl_db( test_132, Spl ),
	test_data( test_132, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products133) :-
	spl_db( test_133, Spl ),
	test_data( test_133, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products134) :-
	spl_db( test_134, Spl ),
	test_data( test_134, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products135) :-
	spl_db( test_135, Spl ),
	test_data( test_135, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products136) :-
	spl_db( test_136, Spl ),
	test_data( test_136, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products137) :-
	spl_db( test_137, Spl ),
	test_data( test_137, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products138) :-
	spl_db( test_138, Spl ),
	test_data( test_138, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products139) :-
	spl_db( test_139, Spl ),
	test_data( test_139, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products140) :-
	spl_db( test_140, Spl ),
	test_data( test_140, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products141) :-
	spl_db( test_141, Spl ),
	test_data( test_141, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products142) :-
	spl_db( test_142, Spl ),
	test_data( test_142, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products143) :-
	spl_db( test_143, Spl ),
	test_data( test_143, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products144) :-
	spl_db( test_144, Spl ),
	test_data( test_144, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products145) :-
	spl_db( test_145, Spl ),
	test_data( test_145, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products146) :-
	spl_db( test_146, Spl ),
	test_data( test_146, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products147) :-
	spl_db( test_147, Spl ),
	test_data( test_147, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products148) :-
	spl_db( test_148, Spl ),
	test_data( test_148, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products149) :-
	spl_db( test_149, Spl ),
	test_data( test_149, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products150) :-
	spl_db( test_150, Spl ),
	test_data( test_150, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products151) :-
	spl_db( test_151, Spl ),
	test_data( test_151, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products152) :-
	spl_db( test_152, Spl ),
	test_data( test_152, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products153) :-
	spl_db( test_153, Spl ),
	test_data( test_153, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products154) :-
	spl_db( test_154, Spl ),
	test_data( test_154, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products155) :-
	spl_db( test_155, Spl ),
	test_data( test_155, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products156) :-
	spl_db( test_156, Spl ),
	test_data( test_156, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products157) :-
	spl_db( test_157, Spl ),
	test_data( test_157, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products158) :-
	spl_db( test_158, Spl ),
	test_data( test_158, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products159) :-
	spl_db( test_159, Spl ),
	test_data( test_159, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products160) :-
	spl_db( test_160, Spl ),
	test_data( test_160, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products161) :-
	spl_db( test_161, Spl ),
	test_data( test_161, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products162) :-
	spl_db( test_162, Spl ),
	test_data( test_162, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products163) :-
	spl_db( test_163, Spl ),
	test_data( test_163, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products164) :-
	spl_db( test_164, Spl ),
	test_data( test_164, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products165) :-
	spl_db( test_165, Spl ),
	test_data( test_165, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products166) :-
	spl_db( test_166, Spl ),
	test_data( test_166, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products167) :-
	spl_db( test_167, Spl ),
	test_data( test_167, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products168) :-
	spl_db( test_168, Spl ),
	test_data( test_168, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products169) :-
	spl_db( test_169, Spl ),
	test_data( test_169, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products170) :-
	spl_db( test_170, Spl ),
	test_data( test_170, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products171) :-
	spl_db( test_171, Spl ),
	test_data( test_171, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products172) :-
	spl_db( test_172, Spl ),
	test_data( test_172, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products173) :-
	spl_db( test_173, Spl ),
	test_data( test_173, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products174) :-
	spl_db( test_174, Spl ),
	test_data( test_174, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products175) :-
	spl_db( test_175, Spl ),
	test_data( test_175, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products176) :-
	spl_db( test_176, Spl ),
	test_data( test_176, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products177) :-
	spl_db( test_177, Spl ),
	test_data( test_177, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products178) :-
	spl_db( test_178, Spl ),
	test_data( test_178, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products179) :-
	spl_db( test_179, Spl ),
	test_data( test_179, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products180) :-
	spl_db( test_180, Spl ),
	test_data( test_180, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products181) :-
	spl_db( test_181, Spl ),
	test_data( test_181, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products182) :-
	spl_db( test_182, Spl ),
	test_data( test_182, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products183) :-
	spl_db( test_183, Spl ),
	test_data( test_183, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products184) :-
	spl_db( test_184, Spl ),
	test_data( test_184, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products185) :-
	spl_db( test_185, Spl ),
	test_data( test_185, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products186) :-
	spl_db( test_186, Spl ),
	test_data( test_186, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products187) :-
	spl_db( test_187, Spl ),
	test_data( test_187, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products188) :-
	spl_db( test_188, Spl ),
	test_data( test_188, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products189) :-
	spl_db( test_189, Spl ),
	test_data( test_189, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products190) :-
	spl_db( test_190, Spl ),
	test_data( test_190, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products191) :-
	spl_db( test_191, Spl ),
	test_data( test_191, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products192) :-
	spl_db( test_192, Spl ),
	test_data( test_192, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products193) :-
	spl_db( test_193, Spl ),
	test_data( test_193, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products194) :-
	spl_db( test_194, Spl ),
	test_data( test_194, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products195) :-
	spl_db( test_195, Spl ),
	test_data( test_195, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products196) :-
	spl_db( test_196, Spl ),
	test_data( test_196, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products197) :-
	spl_db( test_197, Spl ),
	test_data( test_197, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products198) :-
	spl_db( test_198, Spl ),
	test_data( test_198, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products199) :-
	spl_db( test_199, Spl ),
	test_data( test_199, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products200) :-
	spl_db( test_200, Spl ),
	test_data( test_200, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products201) :-
	spl_db( test_201, Spl ),
	test_data( test_201, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products202) :-
	spl_db( test_202, Spl ),
	test_data( test_202, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products203) :-
	spl_db( test_203, Spl ),
	test_data( test_203, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products204) :-
	spl_db( test_204, Spl ),
	test_data( test_204, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products205) :-
	spl_db( test_205, Spl ),
	test_data( test_205, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products206) :-
	spl_db( test_206, Spl ),
	test_data( test_206, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products207) :-
	spl_db( test_207, Spl ),
	test_data( test_207, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products208) :-
	spl_db( test_208, Spl ),
	test_data( test_208, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products209) :-
	spl_db( test_209, Spl ),
	test_data( test_209, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products210) :-
	spl_db( test_210, Spl ),
	test_data( test_210, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products211) :-
	spl_db( test_211, Spl ),
	test_data( test_211, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products212) :-
	spl_db( test_212, Spl ),
	test_data( test_212, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products213) :-
	spl_db( test_213, Spl ),
	test_data( test_213, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products214) :-
	spl_db( test_214, Spl ),
	test_data( test_214, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products215) :-
	spl_db( test_215, Spl ),
	test_data( test_215, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products216) :-
	spl_db( test_216, Spl ),
	test_data( test_216, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products217) :-
	spl_db( test_217, Spl ),
	test_data( test_217, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products218) :-
	spl_db( test_218, Spl ),
	test_data( test_218, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products219) :-
	spl_db( test_219, Spl ),
	test_data( test_219, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products220) :-
	spl_db( test_220, Spl ),
	test_data( test_220, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products221) :-
	spl_db( test_221, Spl ),
	test_data( test_221, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products222) :-
	spl_db( test_222, Spl ),
	test_data( test_222, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products223) :-
	spl_db( test_223, Spl ),
	test_data( test_223, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products224) :-
	spl_db( test_224, Spl ),
	test_data( test_224, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products225) :-
	spl_db( test_225, Spl ),
	test_data( test_225, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products226) :-
	spl_db( test_226, Spl ),
	test_data( test_226, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products227) :-
	spl_db( test_227, Spl ),
	test_data( test_227, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products228) :-
	spl_db( test_228, Spl ),
	test_data( test_228, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products229) :-
	spl_db( test_229, Spl ),
	test_data( test_229, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products230) :-
	spl_db( test_230, Spl ),
	test_data( test_230, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products231) :-
	spl_db( test_231, Spl ),
	test_data( test_231, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products232) :-
	spl_db( test_232, Spl ),
	test_data( test_232, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products233) :-
	spl_db( test_233, Spl ),
	test_data( test_233, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products234) :-
	spl_db( test_234, Spl ),
	test_data( test_234, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products235) :-
	spl_db( test_235, Spl ),
	test_data( test_235, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products236) :-
	spl_db( test_236, Spl ),
	test_data( test_236, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products237) :-
	spl_db( test_237, Spl ),
	test_data( test_237, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products238) :-
	spl_db( test_238, Spl ),
	test_data( test_238, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products239) :-
	spl_db( test_239, Spl ),
	test_data( test_239, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products240) :-
	spl_db( test_240, Spl ),
	test_data( test_240, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products241) :-
	spl_db( test_241, Spl ),
	test_data( test_241, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products242) :-
	spl_db( test_242, Spl ),
	test_data( test_242, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products243) :-
	spl_db( test_243, Spl ),
	test_data( test_243, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products244) :-
	spl_db( test_244, Spl ),
	test_data( test_244, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products245) :-
	spl_db( test_245, Spl ),
	test_data( test_245, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products246) :-
	spl_db( test_246, Spl ),
	test_data( test_246, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products247) :-
	spl_db( test_247, Spl ),
	test_data( test_247, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products248) :-
	spl_db( test_248, Spl ),
	test_data( test_248, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products249) :-
	spl_db( test_249, Spl ),
	test_data( test_249, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products250) :-
	spl_db( test_250, Spl ),
	test_data( test_250, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products251) :-
	spl_db( test_251, Spl ),
	test_data( test_251, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products252) :-
	spl_db( test_252, Spl ),
	test_data( test_252, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products253) :-
	spl_db( test_253, Spl ),
	test_data( test_253, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products254) :-
	spl_db( test_254, Spl ),
	test_data( test_254, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products255) :-
	spl_db( test_255, Spl ),
	test_data( test_255, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products256) :-
	spl_db( test_256, Spl ),
	test_data( test_256, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products257) :-
	spl_db( test_257, Spl ),
	test_data( test_257, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products258) :-
	spl_db( test_258, Spl ),
	test_data( test_258, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products259) :-
	spl_db( test_259, Spl ),
	test_data( test_259, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products260) :-
	spl_db( test_260, Spl ),
	test_data( test_260, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products261) :-
	spl_db( test_261, Spl ),
	test_data( test_261, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products262) :-
	spl_db( test_262, Spl ),
	test_data( test_262, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products263) :-
	spl_db( test_263, Spl ),
	test_data( test_263, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products264) :-
	spl_db( test_264, Spl ),
	test_data( test_264, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products265) :-
	spl_db( test_265, Spl ),
	test_data( test_265, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products266) :-
	spl_db( test_266, Spl ),
	test_data( test_266, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products267) :-
	spl_db( test_267, Spl ),
	test_data( test_267, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products268) :-
	spl_db( test_268, Spl ),
	test_data( test_268, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products269) :-
	spl_db( test_269, Spl ),
	test_data( test_269, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products270) :-
	spl_db( test_270, Spl ),
	test_data( test_270, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products271) :-
	spl_db( test_271, Spl ),
	test_data( test_271, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products272) :-
	spl_db( test_272, Spl ),
	test_data( test_272, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products273) :-
	spl_db( test_273, Spl ),
	test_data( test_273, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products274) :-
	spl_db( test_274, Spl ),
	test_data( test_274, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products275) :-
	spl_db( test_275, Spl ),
	test_data( test_275, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products276) :-
	spl_db( test_276, Spl ),
	test_data( test_276, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products277) :-
	spl_db( test_277, Spl ),
	test_data( test_277, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products278) :-
	spl_db( test_278, Spl ),
	test_data( test_278, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products279) :-
	spl_db( test_279, Spl ),
	test_data( test_279, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products280) :-
	spl_db( test_280, Spl ),
	test_data( test_280, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products281) :-
	spl_db( test_281, Spl ),
	test_data( test_281, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products282) :-
	spl_db( test_282, Spl ),
	test_data( test_282, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products283) :-
	spl_db( test_283, Spl ),
	test_data( test_283, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products284) :-
	spl_db( test_284, Spl ),
	test_data( test_284, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products285) :-
	spl_db( test_285, Spl ),
	test_data( test_285, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products286) :-
	spl_db( test_286, Spl ),
	test_data( test_286, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products287) :-
	spl_db( test_287, Spl ),
	test_data( test_287, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products288) :-
	spl_db( test_288, Spl ),
	test_data( test_288, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products289) :-
	spl_db( test_289, Spl ),
	test_data( test_289, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products290) :-
	spl_db( test_290, Spl ),
	test_data( test_290, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products291) :-
	spl_db( test_291, Spl ),
	test_data( test_291, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products292) :-
	spl_db( test_292, Spl ),
	test_data( test_292, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products293) :-
	spl_db( test_293, Spl ),
	test_data( test_293, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products294) :-
	spl_db( test_294, Spl ),
	test_data( test_294, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products295) :-
	spl_db( test_295, Spl ),
	test_data( test_295, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products296) :-
	spl_db( test_296, Spl ),
	test_data( test_296, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products297) :-
	spl_db( test_297, Spl ),
	test_data( test_297, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products298) :-
	spl_db( test_298, Spl ),
	test_data( test_298, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products299) :-
	spl_db( test_299, Spl ),
	test_data( test_299, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products300) :-
	spl_db( test_300, Spl ),
	test_data( test_300, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products301) :-
	spl_db( test_301, Spl ),
	test_data( test_301, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products302) :-
	spl_db( test_302, Spl ),
	test_data( test_302, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products303) :-
	spl_db( test_303, Spl ),
	test_data( test_303, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products304) :-
	spl_db( test_304, Spl ),
	test_data( test_304, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products305) :-
	spl_db( test_305, Spl ),
	test_data( test_305, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products306) :-
	spl_db( test_306, Spl ),
	test_data( test_306, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products307) :-
	spl_db( test_307, Spl ),
	test_data( test_307, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products308) :-
	spl_db( test_308, Spl ),
	test_data( test_308, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products309) :-
	spl_db( test_309, Spl ),
	test_data( test_309, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products310) :-
	spl_db( test_310, Spl ),
	test_data( test_310, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products311) :-
	spl_db( test_311, Spl ),
	test_data( test_311, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products312) :-
	spl_db( test_312, Spl ),
	test_data( test_312, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products313) :-
	spl_db( test_313, Spl ),
	test_data( test_313, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products314) :-
	spl_db( test_314, Spl ),
	test_data( test_314, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products315) :-
	spl_db( test_315, Spl ),
	test_data( test_315, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products316) :-
	spl_db( test_316, Spl ),
	test_data( test_316, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products317) :-
	spl_db( test_317, Spl ),
	test_data( test_317, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products318) :-
	spl_db( test_318, Spl ),
	test_data( test_318, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products319) :-
	spl_db( test_319, Spl ),
	test_data( test_319, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products320) :-
	spl_db( test_320, Spl ),
	test_data( test_320, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products321) :-
	spl_db( test_321, Spl ),
	test_data( test_321, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products322) :-
	spl_db( test_322, Spl ),
	test_data( test_322, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products323) :-
	spl_db( test_323, Spl ),
	test_data( test_323, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products324) :-
	spl_db( test_324, Spl ),
	test_data( test_324, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products325) :-
	spl_db( test_325, Spl ),
	test_data( test_325, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products326) :-
	spl_db( test_326, Spl ),
	test_data( test_326, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products327) :-
	spl_db( test_327, Spl ),
	test_data( test_327, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products328) :-
	spl_db( test_328, Spl ),
	test_data( test_328, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products329) :-
	spl_db( test_329, Spl ),
	test_data( test_329, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products330) :-
	spl_db( test_330, Spl ),
	test_data( test_330, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products331) :-
	spl_db( test_331, Spl ),
	test_data( test_331, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products332) :-
	spl_db( test_332, Spl ),
	test_data( test_332, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products333) :-
	spl_db( test_333, Spl ),
	test_data( test_333, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products334) :-
	spl_db( test_334, Spl ),
	test_data( test_334, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products335) :-
	spl_db( test_335, Spl ),
	test_data( test_335, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products336) :-
	spl_db( test_336, Spl ),
	test_data( test_336, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products337) :-
	spl_db( test_337, Spl ),
	test_data( test_337, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products338) :-
	spl_db( test_338, Spl ),
	test_data( test_338, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products339) :-
	spl_db( test_339, Spl ),
	test_data( test_339, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products340) :-
	spl_db( test_340, Spl ),
	test_data( test_340, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products341) :-
	spl_db( test_341, Spl ),
	test_data( test_341, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products342) :-
	spl_db( test_342, Spl ),
	test_data( test_342, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products343) :-
	spl_db( test_343, Spl ),
	test_data( test_343, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products344) :-
	spl_db( test_344, Spl ),
	test_data( test_344, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products345) :-
	spl_db( test_345, Spl ),
	test_data( test_345, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products346) :-
	spl_db( test_346, Spl ),
	test_data( test_346, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products347) :-
	spl_db( test_347, Spl ),
	test_data( test_347, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products348) :-
	spl_db( test_348, Spl ),
	test_data( test_348, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products349) :-
	spl_db( test_349, Spl ),
	test_data( test_349, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products350) :-
	spl_db( test_350, Spl ),
	test_data( test_350, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products351) :-
	spl_db( test_351, Spl ),
	test_data( test_351, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products352) :-
	spl_db( test_352, Spl ),
	test_data( test_352, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products353) :-
	spl_db( test_353, Spl ),
	test_data( test_353, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products354) :-
	spl_db( test_354, Spl ),
	test_data( test_354, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products355) :-
	spl_db( test_355, Spl ),
	test_data( test_355, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products356) :-
	spl_db( test_356, Spl ),
	test_data( test_356, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products357) :-
	spl_db( test_357, Spl ),
	test_data( test_357, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products358) :-
	spl_db( test_358, Spl ),
	test_data( test_358, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products359) :-
	spl_db( test_359, Spl ),
	test_data( test_359, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products360) :-
	spl_db( test_360, Spl ),
	test_data( test_360, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products361) :-
	spl_db( test_361, Spl ),
	test_data( test_361, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products362) :-
	spl_db( test_362, Spl ),
	test_data( test_362, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products363) :-
	spl_db( test_363, Spl ),
	test_data( test_363, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products364) :-
	spl_db( test_364, Spl ),
	test_data( test_364, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products365) :-
	spl_db( test_365, Spl ),
	test_data( test_365, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products366) :-
	spl_db( test_366, Spl ),
	test_data( test_366, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products367) :-
	spl_db( test_367, Spl ),
	test_data( test_367, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products368) :-
	spl_db( test_368, Spl ),
	test_data( test_368, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products369) :-
	spl_db( test_369, Spl ),
	test_data( test_369, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products370) :-
	spl_db( test_370, Spl ),
	test_data( test_370, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products371) :-
	spl_db( test_371, Spl ),
	test_data( test_371, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products372) :-
	spl_db( test_372, Spl ),
	test_data( test_372, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products373) :-
	spl_db( test_373, Spl ),
	test_data( test_373, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products374) :-
	spl_db( test_374, Spl ),
	test_data( test_374, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products375) :-
	spl_db( test_375, Spl ),
	test_data( test_375, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products376) :-
	spl_db( test_376, Spl ),
	test_data( test_376, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products377) :-
	spl_db( test_377, Spl ),
	test_data( test_377, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products378) :-
	spl_db( test_378, Spl ),
	test_data( test_378, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products379) :-
	spl_db( test_379, Spl ),
	test_data( test_379, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products380) :-
	spl_db( test_380, Spl ),
	test_data( test_380, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products381) :-
	spl_db( test_381, Spl ),
	test_data( test_381, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products382) :-
	spl_db( test_382, Spl ),
	test_data( test_382, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products383) :-
	spl_db( test_383, Spl ),
	test_data( test_383, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products384) :-
	spl_db( test_384, Spl ),
	test_data( test_384, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products385) :-
	spl_db( test_385, Spl ),
	test_data( test_385, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products386) :-
	spl_db( test_386, Spl ),
	test_data( test_386, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products387) :-
	spl_db( test_387, Spl ),
	test_data( test_387, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products388) :-
	spl_db( test_388, Spl ),
	test_data( test_388, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products389) :-
	spl_db( test_389, Spl ),
	test_data( test_389, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products390) :-
	spl_db( test_390, Spl ),
	test_data( test_390, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products391) :-
	spl_db( test_391, Spl ),
	test_data( test_391, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products392) :-
	spl_db( test_392, Spl ),
	test_data( test_392, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products393) :-
	spl_db( test_393, Spl ),
	test_data( test_393, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products394) :-
	spl_db( test_394, Spl ),
	test_data( test_394, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products395) :-
	spl_db( test_395, Spl ),
	test_data( test_395, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products396) :-
	spl_db( test_396, Spl ),
	test_data( test_396, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products397) :-
	spl_db( test_397, Spl ),
	test_data( test_397, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products398) :-
	spl_db( test_398, Spl ),
	test_data( test_398, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products399) :-
	spl_db( test_399, Spl ),
	test_data( test_399, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products400) :-
	spl_db( test_400, Spl ),
	test_data( test_400, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products401) :-
	spl_db( test_401, Spl ),
	test_data( test_401, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products402) :-
	spl_db( test_402, Spl ),
	test_data( test_402, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products403) :-
	spl_db( test_403, Spl ),
	test_data( test_403, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products404) :-
	spl_db( test_404, Spl ),
	test_data( test_404, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products405) :-
	spl_db( test_405, Spl ),
	test_data( test_405, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products406) :-
	spl_db( test_406, Spl ),
	test_data( test_406, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products407) :-
	spl_db( test_407, Spl ),
	test_data( test_407, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products408) :-
	spl_db( test_408, Spl ),
	test_data( test_408, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products409) :-
	spl_db( test_409, Spl ),
	test_data( test_409, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products410) :-
	spl_db( test_410, Spl ),
	test_data( test_410, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products411) :-
	spl_db( test_411, Spl ),
	test_data( test_411, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products412) :-
	spl_db( test_412, Spl ),
	test_data( test_412, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products413) :-
	spl_db( test_413, Spl ),
	test_data( test_413, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products414) :-
	spl_db( test_414, Spl ),
	test_data( test_414, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products415) :-
	spl_db( test_415, Spl ),
	test_data( test_415, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products416) :-
	spl_db( test_416, Spl ),
	test_data( test_416, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products417) :-
	spl_db( test_417, Spl ),
	test_data( test_417, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products418) :-
	spl_db( test_418, Spl ),
	test_data( test_418, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products419) :-
	spl_db( test_419, Spl ),
	test_data( test_419, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products420) :-
	spl_db( test_420, Spl ),
	test_data( test_420, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products421) :-
	spl_db( test_421, Spl ),
	test_data( test_421, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products422) :-
	spl_db( test_422, Spl ),
	test_data( test_422, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products423) :-
	spl_db( test_423, Spl ),
	test_data( test_423, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products424) :-
	spl_db( test_424, Spl ),
	test_data( test_424, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products425) :-
	spl_db( test_425, Spl ),
	test_data( test_425, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products426) :-
	spl_db( test_426, Spl ),
	test_data( test_426, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products427) :-
	spl_db( test_427, Spl ),
	test_data( test_427, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products428) :-
	spl_db( test_428, Spl ),
	test_data( test_428, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products429) :-
	spl_db( test_429, Spl ),
	test_data( test_429, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products430) :-
	spl_db( test_430, Spl ),
	test_data( test_430, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products431) :-
	spl_db( test_431, Spl ),
	test_data( test_431, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products432) :-
	spl_db( test_432, Spl ),
	test_data( test_432, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products433) :-
	spl_db( test_433, Spl ),
	test_data( test_433, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products434) :-
	spl_db( test_434, Spl ),
	test_data( test_434, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products435) :-
	spl_db( test_435, Spl ),
	test_data( test_435, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products436) :-
	spl_db( test_436, Spl ),
	test_data( test_436, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products437) :-
	spl_db( test_437, Spl ),
	test_data( test_437, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products438) :-
	spl_db( test_438, Spl ),
	test_data( test_438, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products439) :-
	spl_db( test_439, Spl ),
	test_data( test_439, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products440) :-
	spl_db( test_440, Spl ),
	test_data( test_440, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products441) :-
	spl_db( test_441, Spl ),
	test_data( test_441, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products442) :-
	spl_db( test_442, Spl ),
	test_data( test_442, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products443) :-
	spl_db( test_443, Spl ),
	test_data( test_443, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products444) :-
	spl_db( test_444, Spl ),
	test_data( test_444, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products445) :-
	spl_db( test_445, Spl ),
	test_data( test_445, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products446) :-
	spl_db( test_446, Spl ),
	test_data( test_446, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products447) :-
	spl_db( test_447, Spl ),
	test_data( test_447, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products448) :-
	spl_db( test_448, Spl ),
	test_data( test_448, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products449) :-
	spl_db( test_449, Spl ),
	test_data( test_449, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products450) :-
	spl_db( test_450, Spl ),
	test_data( test_450, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products451) :-
	spl_db( test_451, Spl ),
	test_data( test_451, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products452) :-
	spl_db( test_452, Spl ),
	test_data( test_452, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products453) :-
	spl_db( test_453, Spl ),
	test_data( test_453, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products454) :-
	spl_db( test_454, Spl ),
	test_data( test_454, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products455) :-
	spl_db( test_455, Spl ),
	test_data( test_455, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products456) :-
	spl_db( test_456, Spl ),
	test_data( test_456, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products457) :-
	spl_db( test_457, Spl ),
	test_data( test_457, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products458) :-
	spl_db( test_458, Spl ),
	test_data( test_458, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products459) :-
	spl_db( test_459, Spl ),
	test_data( test_459, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products460) :-
	spl_db( test_460, Spl ),
	test_data( test_460, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products461) :-
	spl_db( test_461, Spl ),
	test_data( test_461, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products462) :-
	spl_db( test_462, Spl ),
	test_data( test_462, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products463) :-
	spl_db( test_463, Spl ),
	test_data( test_463, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products464) :-
	spl_db( test_464, Spl ),
	test_data( test_464, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products465) :-
	spl_db( test_465, Spl ),
	test_data( test_465, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products466) :-
	spl_db( test_466, Spl ),
	test_data( test_466, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products467) :-
	spl_db( test_467, Spl ),
	test_data( test_467, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products468) :-
	spl_db( test_468, Spl ),
	test_data( test_468, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products469) :-
	spl_db( test_469, Spl ),
	test_data( test_469, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products470) :-
	spl_db( test_470, Spl ),
	test_data( test_470, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products471) :-
	spl_db( test_471, Spl ),
	test_data( test_471, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products472) :-
	spl_db( test_472, Spl ),
	test_data( test_472, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products473) :-
	spl_db( test_473, Spl ),
	test_data( test_473, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products474) :-
	spl_db( test_474, Spl ),
	test_data( test_474, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products475) :-
	spl_db( test_475, Spl ),
	test_data( test_475, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products476) :-
	spl_db( test_476, Spl ),
	test_data( test_476, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products477) :-
	spl_db( test_477, Spl ),
	test_data( test_477, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products478) :-
	spl_db( test_478, Spl ),
	test_data( test_478, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products479) :-
	spl_db( test_479, Spl ),
	test_data( test_479, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products480) :-
	spl_db( test_480, Spl ),
	test_data( test_480, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products481) :-
	spl_db( test_481, Spl ),
	test_data( test_481, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products482) :-
	spl_db( test_482, Spl ),
	test_data( test_482, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products483) :-
	spl_db( test_483, Spl ),
	test_data( test_483, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products484) :-
	spl_db( test_484, Spl ),
	test_data( test_484, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products485) :-
	spl_db( test_485, Spl ),
	test_data( test_485, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products486) :-
	spl_db( test_486, Spl ),
	test_data( test_486, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products487) :-
	spl_db( test_487, Spl ),
	test_data( test_487, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products488) :-
	spl_db( test_488, Spl ),
	test_data( test_488, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products489) :-
	spl_db( test_489, Spl ),
	test_data( test_489, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products490) :-
	spl_db( test_490, Spl ),
	test_data( test_490, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products491) :-
	spl_db( test_491, Spl ),
	test_data( test_491, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products492) :-
	spl_db( test_492, Spl ),
	test_data( test_492, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products493) :-
	spl_db( test_493, Spl ),
	test_data( test_493, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products494) :-
	spl_db( test_494, Spl ),
	test_data( test_494, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products495) :-
	spl_db( test_495, Spl ),
	test_data( test_495, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products496) :-
	spl_db( test_496, Spl ),
	test_data( test_496, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products497) :-
	spl_db( test_497, Spl ),
	test_data( test_497, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products498) :-
	spl_db( test_498, Spl ),
	test_data( test_498, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products499) :-
	spl_db( test_499, Spl ),
	test_data( test_499, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products500) :-
	spl_db( test_500, Spl ),
	test_data( test_500, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products501) :-
	spl_db( test_501, Spl ),
	test_data( test_501, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products502) :-
	spl_db( test_502, Spl ),
	test_data( test_502, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products503) :-
	spl_db( test_503, Spl ),
	test_data( test_503, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products504) :-
	spl_db( test_504, Spl ),
	test_data( test_504, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products505) :-
	spl_db( test_505, Spl ),
	test_data( test_505, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products506) :-
	spl_db( test_506, Spl ),
	test_data( test_506, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products507) :-
	spl_db( test_507, Spl ),
	test_data( test_507, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products508) :-
	spl_db( test_508, Spl ),
	test_data( test_508, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products509) :-
	spl_db( test_509, Spl ),
	test_data( test_509, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products510) :-
	spl_db( test_510, Spl ),
	test_data( test_510, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products511) :-
	spl_db( test_511, Spl ),
	test_data( test_511, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products512) :-
	spl_db( test_512, Spl ),
	test_data( test_512, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products513) :-
	spl_db( test_513, Spl ),
	test_data( test_513, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products514) :-
	spl_db( test_514, Spl ),
	test_data( test_514, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products515) :-
	spl_db( test_515, Spl ),
	test_data( test_515, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products516) :-
	spl_db( test_516, Spl ),
	test_data( test_516, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products517) :-
	spl_db( test_517, Spl ),
	test_data( test_517, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products518) :-
	spl_db( test_518, Spl ),
	test_data( test_518, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products519) :-
	spl_db( test_519, Spl ),
	test_data( test_519, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products520) :-
	spl_db( test_520, Spl ),
	test_data( test_520, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products521) :-
	spl_db( test_521, Spl ),
	test_data( test_521, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products522) :-
	spl_db( test_522, Spl ),
	test_data( test_522, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products523) :-
	spl_db( test_523, Spl ),
	test_data( test_523, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products524) :-
	spl_db( test_524, Spl ),
	test_data( test_524, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products525) :-
	spl_db( test_525, Spl ),
	test_data( test_525, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products526) :-
	spl_db( test_526, Spl ),
	test_data( test_526, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products527) :-
	spl_db( test_527, Spl ),
	test_data( test_527, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products528) :-
	spl_db( test_528, Spl ),
	test_data( test_528, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products529) :-
	spl_db( test_529, Spl ),
	test_data( test_529, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products530) :-
	spl_db( test_530, Spl ),
	test_data( test_530, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products531) :-
	spl_db( test_531, Spl ),
	test_data( test_531, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products532) :-
	spl_db( test_532, Spl ),
	test_data( test_532, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products533) :-
	spl_db( test_533, Spl ),
	test_data( test_533, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products534) :-
	spl_db( test_534, Spl ),
	test_data( test_534, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products535) :-
	spl_db( test_535, Spl ),
	test_data( test_535, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products536) :-
	spl_db( test_536, Spl ),
	test_data( test_536, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products537) :-
	spl_db( test_537, Spl ),
	test_data( test_537, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products538) :-
	spl_db( test_538, Spl ),
	test_data( test_538, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products539) :-
	spl_db( test_539, Spl ),
	test_data( test_539, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products540) :-
	spl_db( test_540, Spl ),
	test_data( test_540, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products541) :-
	spl_db( test_541, Spl ),
	test_data( test_541, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products542) :-
	spl_db( test_542, Spl ),
	test_data( test_542, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products543) :-
	spl_db( test_543, Spl ),
	test_data( test_543, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products544) :-
	spl_db( test_544, Spl ),
	test_data( test_544, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products545) :-
	spl_db( test_545, Spl ),
	test_data( test_545, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products546) :-
	spl_db( test_546, Spl ),
	test_data( test_546, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products547) :-
	spl_db( test_547, Spl ),
	test_data( test_547, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products548) :-
	spl_db( test_548, Spl ),
	test_data( test_548, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products549) :-
	spl_db( test_549, Spl ),
	test_data( test_549, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products550) :-
	spl_db( test_550, Spl ),
	test_data( test_550, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products551) :-
	spl_db( test_551, Spl ),
	test_data( test_551, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products552) :-
	spl_db( test_552, Spl ),
	test_data( test_552, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products553) :-
	spl_db( test_553, Spl ),
	test_data( test_553, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products554) :-
	spl_db( test_554, Spl ),
	test_data( test_554, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products555) :-
	spl_db( test_555, Spl ),
	test_data( test_555, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products556) :-
	spl_db( test_556, Spl ),
	test_data( test_556, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products557) :-
	spl_db( test_557, Spl ),
	test_data( test_557, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products558) :-
	spl_db( test_558, Spl ),
	test_data( test_558, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products559) :-
	spl_db( test_559, Spl ),
	test_data( test_559, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products560) :-
	spl_db( test_560, Spl ),
	test_data( test_560, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products561) :-
	spl_db( test_561, Spl ),
	test_data( test_561, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products562) :-
	spl_db( test_562, Spl ),
	test_data( test_562, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products563) :-
	spl_db( test_563, Spl ),
	test_data( test_563, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products564) :-
	spl_db( test_564, Spl ),
	test_data( test_564, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products565) :-
	spl_db( test_565, Spl ),
	test_data( test_565, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products566) :-
	spl_db( test_566, Spl ),
	test_data( test_566, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products567) :-
	spl_db( test_567, Spl ),
	test_data( test_567, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products568) :-
	spl_db( test_568, Spl ),
	test_data( test_568, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products569) :-
	spl_db( test_569, Spl ),
	test_data( test_569, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products570) :-
	spl_db( test_570, Spl ),
	test_data( test_570, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products571) :-
	spl_db( test_571, Spl ),
	test_data( test_571, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products572) :-
	spl_db( test_572, Spl ),
	test_data( test_572, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products573) :-
	spl_db( test_573, Spl ),
	test_data( test_573, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products574) :-
	spl_db( test_574, Spl ),
	test_data( test_574, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products575) :-
	spl_db( test_575, Spl ),
	test_data( test_575, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products576) :-
	spl_db( test_576, Spl ),
	test_data( test_576, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products577) :-
	spl_db( test_577, Spl ),
	test_data( test_577, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products578) :-
	spl_db( test_578, Spl ),
	test_data( test_578, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products579) :-
	spl_db( test_579, Spl ),
	test_data( test_579, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products580) :-
	spl_db( test_580, Spl ),
	test_data( test_580, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products581) :-
	spl_db( test_581, Spl ),
	test_data( test_581, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products582) :-
	spl_db( test_582, Spl ),
	test_data( test_582, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products583) :-
	spl_db( test_583, Spl ),
	test_data( test_583, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products584) :-
	spl_db( test_584, Spl ),
	test_data( test_584, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products585) :-
	spl_db( test_585, Spl ),
	test_data( test_585, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products586) :-
	spl_db( test_586, Spl ),
	test_data( test_586, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products587) :-
	spl_db( test_587, Spl ),
	test_data( test_587, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products588) :-
	spl_db( test_588, Spl ),
	test_data( test_588, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products589) :-
	spl_db( test_589, Spl ),
	test_data( test_589, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products590) :-
	spl_db( test_590, Spl ),
	test_data( test_590, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products591) :-
	spl_db( test_591, Spl ),
	test_data( test_591, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products592) :-
	spl_db( test_592, Spl ),
	test_data( test_592, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products593) :-
	spl_db( test_593, Spl ),
	test_data( test_593, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products594) :-
	spl_db( test_594, Spl ),
	test_data( test_594, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products595) :-
	spl_db( test_595, Spl ),
	test_data( test_595, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products596) :-
	spl_db( test_596, Spl ),
	test_data( test_596, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products597) :-
	spl_db( test_597, Spl ),
	test_data( test_597, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products598) :-
	spl_db( test_598, Spl ),
	test_data( test_598, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products599) :-
	spl_db( test_599, Spl ),
	test_data( test_599, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products600) :-
	spl_db( test_600, Spl ),
	test_data( test_600, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products601) :-
	spl_db( test_601, Spl ),
	test_data( test_601, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products602) :-
	spl_db( test_602, Spl ),
	test_data( test_602, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products603) :-
	spl_db( test_603, Spl ),
	test_data( test_603, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products604) :-
	spl_db( test_604, Spl ),
	test_data( test_604, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products605) :-
	spl_db( test_605, Spl ),
	test_data( test_605, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products606) :-
	spl_db( test_606, Spl ),
	test_data( test_606, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products607) :-
	spl_db( test_607, Spl ),
	test_data( test_607, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products608) :-
	spl_db( test_608, Spl ),
	test_data( test_608, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products609) :-
	spl_db( test_609, Spl ),
	test_data( test_609, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products610) :-
	spl_db( test_610, Spl ),
	test_data( test_610, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products611) :-
	spl_db( test_611, Spl ),
	test_data( test_611, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products612) :-
	spl_db( test_612, Spl ),
	test_data( test_612, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products613) :-
	spl_db( test_613, Spl ),
	test_data( test_613, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products614) :-
	spl_db( test_614, Spl ),
	test_data( test_614, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products615) :-
	spl_db( test_615, Spl ),
	test_data( test_615, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products616) :-
	spl_db( test_616, Spl ),
	test_data( test_616, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products617) :-
	spl_db( test_617, Spl ),
	test_data( test_617, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products618) :-
	spl_db( test_618, Spl ),
	test_data( test_618, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products619) :-
	spl_db( test_619, Spl ),
	test_data( test_619, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products620) :-
	spl_db( test_620, Spl ),
	test_data( test_620, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products621) :-
	spl_db( test_621, Spl ),
	test_data( test_621, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products622) :-
	spl_db( test_622, Spl ),
	test_data( test_622, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products623) :-
	spl_db( test_623, Spl ),
	test_data( test_623, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products624) :-
	spl_db( test_624, Spl ),
	test_data( test_624, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products625) :-
	spl_db( test_625, Spl ),
	test_data( test_625, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products626) :-
	spl_db( test_626, Spl ),
	test_data( test_626, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products627) :-
	spl_db( test_627, Spl ),
	test_data( test_627, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products628) :-
	spl_db( test_628, Spl ),
	test_data( test_628, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products629) :-
	spl_db( test_629, Spl ),
	test_data( test_629, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products630) :-
	spl_db( test_630, Spl ),
	test_data( test_630, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products631) :-
	spl_db( test_631, Spl ),
	test_data( test_631, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products632) :-
	spl_db( test_632, Spl ),
	test_data( test_632, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products633) :-
	spl_db( test_633, Spl ),
	test_data( test_633, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products634) :-
	spl_db( test_634, Spl ),
	test_data( test_634, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products635) :-
	spl_db( test_635, Spl ),
	test_data( test_635, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products636) :-
	spl_db( test_636, Spl ),
	test_data( test_636, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products637) :-
	spl_db( test_637, Spl ),
	test_data( test_637, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products638) :-
	spl_db( test_638, Spl ),
	test_data( test_638, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products639) :-
	spl_db( test_639, Spl ),
	test_data( test_639, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products640) :-
	spl_db( test_640, Spl ),
	test_data( test_640, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products641) :-
	spl_db( test_641, Spl ),
	test_data( test_641, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products642) :-
	spl_db( test_642, Spl ),
	test_data( test_642, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products643) :-
	spl_db( test_643, Spl ),
	test_data( test_643, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products644) :-
	spl_db( test_644, Spl ),
	test_data( test_644, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products645) :-
	spl_db( test_645, Spl ),
	test_data( test_645, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products646) :-
	spl_db( test_646, Spl ),
	test_data( test_646, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products647) :-
	spl_db( test_647, Spl ),
	test_data( test_647, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products648) :-
	spl_db( test_648, Spl ),
	test_data( test_648, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products649) :-
	spl_db( test_649, Spl ),
	test_data( test_649, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products650) :-
	spl_db( test_650, Spl ),
	test_data( test_650, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products651) :-
	spl_db( test_651, Spl ),
	test_data( test_651, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products652) :-
	spl_db( test_652, Spl ),
	test_data( test_652, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products653) :-
	spl_db( test_653, Spl ),
	test_data( test_653, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products654) :-
	spl_db( test_654, Spl ),
	test_data( test_654, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products655) :-
	spl_db( test_655, Spl ),
	test_data( test_655, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products656) :-
	spl_db( test_656, Spl ),
	test_data( test_656, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products657) :-
	spl_db( test_657, Spl ),
	test_data( test_657, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products658) :-
	spl_db( test_658, Spl ),
	test_data( test_658, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products659) :-
	spl_db( test_659, Spl ),
	test_data( test_659, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products660) :-
	spl_db( test_660, Spl ),
	test_data( test_660, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products661) :-
	spl_db( test_661, Spl ),
	test_data( test_661, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products662) :-
	spl_db( test_662, Spl ),
	test_data( test_662, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products663) :-
	spl_db( test_663, Spl ),
	test_data( test_663, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products664) :-
	spl_db( test_664, Spl ),
	test_data( test_664, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products665) :-
	spl_db( test_665, Spl ),
	test_data( test_665, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products666) :-
	spl_db( test_666, Spl ),
	test_data( test_666, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products667) :-
	spl_db( test_667, Spl ),
	test_data( test_667, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products668) :-
	spl_db( test_668, Spl ),
	test_data( test_668, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products669) :-
	spl_db( test_669, Spl ),
	test_data( test_669, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products670) :-
	spl_db( test_670, Spl ),
	test_data( test_670, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products671) :-
	spl_db( test_671, Spl ),
	test_data( test_671, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products672) :-
	spl_db( test_672, Spl ),
	test_data( test_672, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products673) :-
	spl_db( test_673, Spl ),
	test_data( test_673, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products674) :-
	spl_db( test_674, Spl ),
	test_data( test_674, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products675) :-
	spl_db( test_675, Spl ),
	test_data( test_675, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products676) :-
	spl_db( test_676, Spl ),
	test_data( test_676, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products677) :-
	spl_db( test_677, Spl ),
	test_data( test_677, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products678) :-
	spl_db( test_678, Spl ),
	test_data( test_678, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products679) :-
	spl_db( test_679, Spl ),
	test_data( test_679, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products680) :-
	spl_db( test_680, Spl ),
	test_data( test_680, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products681) :-
	spl_db( test_681, Spl ),
	test_data( test_681, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products682) :-
	spl_db( test_682, Spl ),
	test_data( test_682, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products683) :-
	spl_db( test_683, Spl ),
	test_data( test_683, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products684) :-
	spl_db( test_684, Spl ),
	test_data( test_684, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products685) :-
	spl_db( test_685, Spl ),
	test_data( test_685, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products686) :-
	spl_db( test_686, Spl ),
	test_data( test_686, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products687) :-
	spl_db( test_687, Spl ),
	test_data( test_687, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products688) :-
	spl_db( test_688, Spl ),
	test_data( test_688, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products689) :-
	spl_db( test_689, Spl ),
	test_data( test_689, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products690) :-
	spl_db( test_690, Spl ),
	test_data( test_690, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products691) :-
	spl_db( test_691, Spl ),
	test_data( test_691, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products692) :-
	spl_db( test_692, Spl ),
	test_data( test_692, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products693) :-
	spl_db( test_693, Spl ),
	test_data( test_693, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products694) :-
	spl_db( test_694, Spl ),
	test_data( test_694, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products695) :-
	spl_db( test_695, Spl ),
	test_data( test_695, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products696) :-
	spl_db( test_696, Spl ),
	test_data( test_696, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products697) :-
	spl_db( test_697, Spl ),
	test_data( test_697, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products698) :-
	spl_db( test_698, Spl ),
	test_data( test_698, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products699) :-
	spl_db( test_699, Spl ),
	test_data( test_699, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products700) :-
	spl_db( test_700, Spl ),
	test_data( test_700, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products701) :-
	spl_db( test_701, Spl ),
	test_data( test_701, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products702) :-
	spl_db( test_702, Spl ),
	test_data( test_702, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products703) :-
	spl_db( test_703, Spl ),
	test_data( test_703, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products704) :-
	spl_db( test_704, Spl ),
	test_data( test_704, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products705) :-
	spl_db( test_705, Spl ),
	test_data( test_705, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products706) :-
	spl_db( test_706, Spl ),
	test_data( test_706, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products707) :-
	spl_db( test_707, Spl ),
	test_data( test_707, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products708) :-
	spl_db( test_708, Spl ),
	test_data( test_708, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products709) :-
	spl_db( test_709, Spl ),
	test_data( test_709, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products710) :-
	spl_db( test_710, Spl ),
	test_data( test_710, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products711) :-
	spl_db( test_711, Spl ),
	test_data( test_711, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products712) :-
	spl_db( test_712, Spl ),
	test_data( test_712, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products713) :-
	spl_db( test_713, Spl ),
	test_data( test_713, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products714) :-
	spl_db( test_714, Spl ),
	test_data( test_714, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products715) :-
	spl_db( test_715, Spl ),
	test_data( test_715, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products716) :-
	spl_db( test_716, Spl ),
	test_data( test_716, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products717) :-
	spl_db( test_717, Spl ),
	test_data( test_717, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products718) :-
	spl_db( test_718, Spl ),
	test_data( test_718, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products719) :-
	spl_db( test_719, Spl ),
	test_data( test_719, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products720) :-
	spl_db( test_720, Spl ),
	test_data( test_720, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products721) :-
	spl_db( test_721, Spl ),
	test_data( test_721, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products722) :-
	spl_db( test_722, Spl ),
	test_data( test_722, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products723) :-
	spl_db( test_723, Spl ),
	test_data( test_723, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products724) :-
	spl_db( test_724, Spl ),
	test_data( test_724, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products725) :-
	spl_db( test_725, Spl ),
	test_data( test_725, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products726) :-
	spl_db( test_726, Spl ),
	test_data( test_726, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products727) :-
	spl_db( test_727, Spl ),
	test_data( test_727, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products728) :-
	spl_db( test_728, Spl ),
	test_data( test_728, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products729) :-
	spl_db( test_729, Spl ),
	test_data( test_729, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products730) :-
	spl_db( test_730, Spl ),
	test_data( test_730, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products731) :-
	spl_db( test_731, Spl ),
	test_data( test_731, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products732) :-
	spl_db( test_732, Spl ),
	test_data( test_732, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products733) :-
	spl_db( test_733, Spl ),
	test_data( test_733, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products734) :-
	spl_db( test_734, Spl ),
	test_data( test_734, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products735) :-
	spl_db( test_735, Spl ),
	test_data( test_735, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products736) :-
	spl_db( test_736, Spl ),
	test_data( test_736, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products737) :-
	spl_db( test_737, Spl ),
	test_data( test_737, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products738) :-
	spl_db( test_738, Spl ),
	test_data( test_738, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products739) :-
	spl_db( test_739, Spl ),
	test_data( test_739, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products740) :-
	spl_db( test_740, Spl ),
	test_data( test_740, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products741) :-
	spl_db( test_741, Spl ),
	test_data( test_741, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products742) :-
	spl_db( test_742, Spl ),
	test_data( test_742, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products743) :-
	spl_db( test_743, Spl ),
	test_data( test_743, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products744) :-
	spl_db( test_744, Spl ),
	test_data( test_744, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products745) :-
	spl_db( test_745, Spl ),
	test_data( test_745, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products746) :-
	spl_db( test_746, Spl ),
	test_data( test_746, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products747) :-
	spl_db( test_747, Spl ),
	test_data( test_747, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products748) :-
	spl_db( test_748, Spl ),
	test_data( test_748, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products749) :-
	spl_db( test_749, Spl ),
	test_data( test_749, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products750) :-
	spl_db( test_750, Spl ),
	test_data( test_750, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products751) :-
	spl_db( test_751, Spl ),
	test_data( test_751, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products752) :-
	spl_db( test_752, Spl ),
	test_data( test_752, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products753) :-
	spl_db( test_753, Spl ),
	test_data( test_753, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products754) :-
	spl_db( test_754, Spl ),
	test_data( test_754, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products755) :-
	spl_db( test_755, Spl ),
	test_data( test_755, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products756) :-
	spl_db( test_756, Spl ),
	test_data( test_756, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products757) :-
	spl_db( test_757, Spl ),
	test_data( test_757, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products758) :-
	spl_db( test_758, Spl ),
	test_data( test_758, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products759) :-
	spl_db( test_759, Spl ),
	test_data( test_759, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products760) :-
	spl_db( test_760, Spl ),
	test_data( test_760, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products761) :-
	spl_db( test_761, Spl ),
	test_data( test_761, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products762) :-
	spl_db( test_762, Spl ),
	test_data( test_762, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products763) :-
	spl_db( test_763, Spl ),
	test_data( test_763, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products764) :-
	spl_db( test_764, Spl ),
	test_data( test_764, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products765) :-
	spl_db( test_765, Spl ),
	test_data( test_765, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products766) :-
	spl_db( test_766, Spl ),
	test_data( test_766, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products767) :-
	spl_db( test_767, Spl ),
	test_data( test_767, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products768) :-
	spl_db( test_768, Spl ),
	test_data( test_768, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products769) :-
	spl_db( test_769, Spl ),
	test_data( test_769, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products770) :-
	spl_db( test_770, Spl ),
	test_data( test_770, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products771) :-
	spl_db( test_771, Spl ),
	test_data( test_771, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products772) :-
	spl_db( test_772, Spl ),
	test_data( test_772, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products773) :-
	spl_db( test_773, Spl ),
	test_data( test_773, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products774) :-
	spl_db( test_774, Spl ),
	test_data( test_774, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products775) :-
	spl_db( test_775, Spl ),
	test_data( test_775, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products776) :-
	spl_db( test_776, Spl ),
	test_data( test_776, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products777) :-
	spl_db( test_777, Spl ),
	test_data( test_777, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products778) :-
	spl_db( test_778, Spl ),
	test_data( test_778, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products779) :-
	spl_db( test_779, Spl ),
	test_data( test_779, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products780) :-
	spl_db( test_780, Spl ),
	test_data( test_780, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products781) :-
	spl_db( test_781, Spl ),
	test_data( test_781, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products782) :-
	spl_db( test_782, Spl ),
	test_data( test_782, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products783) :-
	spl_db( test_783, Spl ),
	test_data( test_783, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products784) :-
	spl_db( test_784, Spl ),
	test_data( test_784, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products785) :-
	spl_db( test_785, Spl ),
	test_data( test_785, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products786) :-
	spl_db( test_786, Spl ),
	test_data( test_786, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products787) :-
	spl_db( test_787, Spl ),
	test_data( test_787, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products788) :-
	spl_db( test_788, Spl ),
	test_data( test_788, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products789) :-
	spl_db( test_789, Spl ),
	test_data( test_789, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products790) :-
	spl_db( test_790, Spl ),
	test_data( test_790, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products791) :-
	spl_db( test_791, Spl ),
	test_data( test_791, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products792) :-
	spl_db( test_792, Spl ),
	test_data( test_792, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products793) :-
	spl_db( test_793, Spl ),
	test_data( test_793, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products794) :-
	spl_db( test_794, Spl ),
	test_data( test_794, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products795) :-
	spl_db( test_795, Spl ),
	test_data( test_795, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products796) :-
	spl_db( test_796, Spl ),
	test_data( test_796, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products797) :-
	spl_db( test_797, Spl ),
	test_data( test_797, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products798) :-
	spl_db( test_798, Spl ),
	test_data( test_798, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products799) :-
	spl_db( test_799, Spl ),
	test_data( test_799, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products800) :-
	spl_db( test_800, Spl ),
	test_data( test_800, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products801) :-
	spl_db( test_801, Spl ),
	test_data( test_801, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products802) :-
	spl_db( test_802, Spl ),
	test_data( test_802, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products803) :-
	spl_db( test_803, Spl ),
	test_data( test_803, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products804) :-
	spl_db( test_804, Spl ),
	test_data( test_804, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products805) :-
	spl_db( test_805, Spl ),
	test_data( test_805, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products806) :-
	spl_db( test_806, Spl ),
	test_data( test_806, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products807) :-
	spl_db( test_807, Spl ),
	test_data( test_807, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products808) :-
	spl_db( test_808, Spl ),
	test_data( test_808, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products809) :-
	spl_db( test_809, Spl ),
	test_data( test_809, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products810) :-
	spl_db( test_810, Spl ),
	test_data( test_810, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products811) :-
	spl_db( test_811, Spl ),
	test_data( test_811, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products812) :-
	spl_db( test_812, Spl ),
	test_data( test_812, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products813) :-
	spl_db( test_813, Spl ),
	test_data( test_813, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products814) :-
	spl_db( test_814, Spl ),
	test_data( test_814, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products815) :-
	spl_db( test_815, Spl ),
	test_data( test_815, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products816) :-
	spl_db( test_816, Spl ),
	test_data( test_816, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products817) :-
	spl_db( test_817, Spl ),
	test_data( test_817, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products818) :-
	spl_db( test_818, Spl ),
	test_data( test_818, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products819) :-
	spl_db( test_819, Spl ),
	test_data( test_819, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products820) :-
	spl_db( test_820, Spl ),
	test_data( test_820, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products821) :-
	spl_db( test_821, Spl ),
	test_data( test_821, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products822) :-
	spl_db( test_822, Spl ),
	test_data( test_822, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products823) :-
	spl_db( test_823, Spl ),
	test_data( test_823, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products824) :-
	spl_db( test_824, Spl ),
	test_data( test_824, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products825) :-
	spl_db( test_825, Spl ),
	test_data( test_825, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products826) :-
	spl_db( test_826, Spl ),
	test_data( test_826, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products827) :-
	spl_db( test_827, Spl ),
	test_data( test_827, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products828) :-
	spl_db( test_828, Spl ),
	test_data( test_828, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products829) :-
	spl_db( test_829, Spl ),
	test_data( test_829, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products830) :-
	spl_db( test_830, Spl ),
	test_data( test_830, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products831) :-
	spl_db( test_831, Spl ),
	test_data( test_831, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products832) :-
	spl_db( test_832, Spl ),
	test_data( test_832, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products833) :-
	spl_db( test_833, Spl ),
	test_data( test_833, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products834) :-
	spl_db( test_834, Spl ),
	test_data( test_834, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products835) :-
	spl_db( test_835, Spl ),
	test_data( test_835, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products836) :-
	spl_db( test_836, Spl ),
	test_data( test_836, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products837) :-
	spl_db( test_837, Spl ),
	test_data( test_837, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products838) :-
	spl_db( test_838, Spl ),
	test_data( test_838, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products839) :-
	spl_db( test_839, Spl ),
	test_data( test_839, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products840) :-
	spl_db( test_840, Spl ),
	test_data( test_840, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products841) :-
	spl_db( test_841, Spl ),
	test_data( test_841, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products842) :-
	spl_db( test_842, Spl ),
	test_data( test_842, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products843) :-
	spl_db( test_843, Spl ),
	test_data( test_843, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products844) :-
	spl_db( test_844, Spl ),
	test_data( test_844, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products845) :-
	spl_db( test_845, Spl ),
	test_data( test_845, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products846) :-
	spl_db( test_846, Spl ),
	test_data( test_846, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products847) :-
	spl_db( test_847, Spl ),
	test_data( test_847, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products848) :-
	spl_db( test_848, Spl ),
	test_data( test_848, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products849) :-
	spl_db( test_849, Spl ),
	test_data( test_849, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products850) :-
	spl_db( test_850, Spl ),
	test_data( test_850, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products851) :-
	spl_db( test_851, Spl ),
	test_data( test_851, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products852) :-
	spl_db( test_852, Spl ),
	test_data( test_852, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products853) :-
	spl_db( test_853, Spl ),
	test_data( test_853, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products854) :-
	spl_db( test_854, Spl ),
	test_data( test_854, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products855) :-
	spl_db( test_855, Spl ),
	test_data( test_855, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products856) :-
	spl_db( test_856, Spl ),
	test_data( test_856, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products857) :-
	spl_db( test_857, Spl ),
	test_data( test_857, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products858) :-
	spl_db( test_858, Spl ),
	test_data( test_858, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products859) :-
	spl_db( test_859, Spl ),
	test_data( test_859, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products860) :-
	spl_db( test_860, Spl ),
	test_data( test_860, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products861) :-
	spl_db( test_861, Spl ),
	test_data( test_861, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products862) :-
	spl_db( test_862, Spl ),
	test_data( test_862, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products863) :-
	spl_db( test_863, Spl ),
	test_data( test_863, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products864) :-
	spl_db( test_864, Spl ),
	test_data( test_864, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products865) :-
	spl_db( test_865, Spl ),
	test_data( test_865, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products866) :-
	spl_db( test_866, Spl ),
	test_data( test_866, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products867) :-
	spl_db( test_867, Spl ),
	test_data( test_867, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products868) :-
	spl_db( test_868, Spl ),
	test_data( test_868, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products869) :-
	spl_db( test_869, Spl ),
	test_data( test_869, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products870) :-
	spl_db( test_870, Spl ),
	test_data( test_870, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products871) :-
	spl_db( test_871, Spl ),
	test_data( test_871, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products872) :-
	spl_db( test_872, Spl ),
	test_data( test_872, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products873) :-
	spl_db( test_873, Spl ),
	test_data( test_873, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products874) :-
	spl_db( test_874, Spl ),
	test_data( test_874, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products875) :-
	spl_db( test_875, Spl ),
	test_data( test_875, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products876) :-
	spl_db( test_876, Spl ),
	test_data( test_876, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products877) :-
	spl_db( test_877, Spl ),
	test_data( test_877, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products878) :-
	spl_db( test_878, Spl ),
	test_data( test_878, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products879) :-
	spl_db( test_879, Spl ),
	test_data( test_879, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products880) :-
	spl_db( test_880, Spl ),
	test_data( test_880, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products881) :-
	spl_db( test_881, Spl ),
	test_data( test_881, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products882) :-
	spl_db( test_882, Spl ),
	test_data( test_882, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products883) :-
	spl_db( test_883, Spl ),
	test_data( test_883, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products884) :-
	spl_db( test_884, Spl ),
	test_data( test_884, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products885) :-
	spl_db( test_885, Spl ),
	test_data( test_885, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products886) :-
	spl_db( test_886, Spl ),
	test_data( test_886, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products887) :-
	spl_db( test_887, Spl ),
	test_data( test_887, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products888) :-
	spl_db( test_888, Spl ),
	test_data( test_888, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products889) :-
	spl_db( test_889, Spl ),
	test_data( test_889, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products890) :-
	spl_db( test_890, Spl ),
	test_data( test_890, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products891) :-
	spl_db( test_891, Spl ),
	test_data( test_891, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products892) :-
	spl_db( test_892, Spl ),
	test_data( test_892, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products893) :-
	spl_db( test_893, Spl ),
	test_data( test_893, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products894) :-
	spl_db( test_894, Spl ),
	test_data( test_894, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products895) :-
	spl_db( test_895, Spl ),
	test_data( test_895, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products896) :-
	spl_db( test_896, Spl ),
	test_data( test_896, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products897) :-
	spl_db( test_897, Spl ),
	test_data( test_897, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products898) :-
	spl_db( test_898, Spl ),
	test_data( test_898, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products899) :-
	spl_db( test_899, Spl ),
	test_data( test_899, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products900) :-
	spl_db( test_900, Spl ),
	test_data( test_900, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products901) :-
	spl_db( test_901, Spl ),
	test_data( test_901, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products902) :-
	spl_db( test_902, Spl ),
	test_data( test_902, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products903) :-
	spl_db( test_903, Spl ),
	test_data( test_903, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products904) :-
	spl_db( test_904, Spl ),
	test_data( test_904, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products905) :-
	spl_db( test_905, Spl ),
	test_data( test_905, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products906) :-
	spl_db( test_906, Spl ),
	test_data( test_906, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products907) :-
	spl_db( test_907, Spl ),
	test_data( test_907, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products908) :-
	spl_db( test_908, Spl ),
	test_data( test_908, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products909) :-
	spl_db( test_909, Spl ),
	test_data( test_909, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products910) :-
	spl_db( test_910, Spl ),
	test_data( test_910, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products911) :-
	spl_db( test_911, Spl ),
	test_data( test_911, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products912) :-
	spl_db( test_912, Spl ),
	test_data( test_912, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products913) :-
	spl_db( test_913, Spl ),
	test_data( test_913, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products914) :-
	spl_db( test_914, Spl ),
	test_data( test_914, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products915) :-
	spl_db( test_915, Spl ),
	test_data( test_915, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products916) :-
	spl_db( test_916, Spl ),
	test_data( test_916, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products917) :-
	spl_db( test_917, Spl ),
	test_data( test_917, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products918) :-
	spl_db( test_918, Spl ),
	test_data( test_918, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products919) :-
	spl_db( test_919, Spl ),
	test_data( test_919, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products920) :-
	spl_db( test_920, Spl ),
	test_data( test_920, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products921) :-
	spl_db( test_921, Spl ),
	test_data( test_921, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products922) :-
	spl_db( test_922, Spl ),
	test_data( test_922, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products923) :-
	spl_db( test_923, Spl ),
	test_data( test_923, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products924) :-
	spl_db( test_924, Spl ),
	test_data( test_924, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products925) :-
	spl_db( test_925, Spl ),
	test_data( test_925, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products926) :-
	spl_db( test_926, Spl ),
	test_data( test_926, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products927) :-
	spl_db( test_927, Spl ),
	test_data( test_927, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products928) :-
	spl_db( test_928, Spl ),
	test_data( test_928, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products929) :-
	spl_db( test_929, Spl ),
	test_data( test_929, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products930) :-
	spl_db( test_930, Spl ),
	test_data( test_930, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products931) :-
	spl_db( test_931, Spl ),
	test_data( test_931, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products932) :-
	spl_db( test_932, Spl ),
	test_data( test_932, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products933) :-
	spl_db( test_933, Spl ),
	test_data( test_933, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products934) :-
	spl_db( test_934, Spl ),
	test_data( test_934, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products935) :-
	spl_db( test_935, Spl ),
	test_data( test_935, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products936) :-
	spl_db( test_936, Spl ),
	test_data( test_936, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products937) :-
	spl_db( test_937, Spl ),
	test_data( test_937, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products938) :-
	spl_db( test_938, Spl ),
	test_data( test_938, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products939) :-
	spl_db( test_939, Spl ),
	test_data( test_939, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products940) :-
	spl_db( test_940, Spl ),
	test_data( test_940, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products941) :-
	spl_db( test_941, Spl ),
	test_data( test_941, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products942) :-
	spl_db( test_942, Spl ),
	test_data( test_942, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products943) :-
	spl_db( test_943, Spl ),
	test_data( test_943, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products944) :-
	spl_db( test_944, Spl ),
	test_data( test_944, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products945) :-
	spl_db( test_945, Spl ),
	test_data( test_945, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products946) :-
	spl_db( test_946, Spl ),
	test_data( test_946, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products947) :-
	spl_db( test_947, Spl ),
	test_data( test_947, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products948) :-
	spl_db( test_948, Spl ),
	test_data( test_948, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products949) :-
	spl_db( test_949, Spl ),
	test_data( test_949, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products950) :-
	spl_db( test_950, Spl ),
	test_data( test_950, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products951) :-
	spl_db( test_951, Spl ),
	test_data( test_951, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products952) :-
	spl_db( test_952, Spl ),
	test_data( test_952, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products953) :-
	spl_db( test_953, Spl ),
	test_data( test_953, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products954) :-
	spl_db( test_954, Spl ),
	test_data( test_954, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products955) :-
	spl_db( test_955, Spl ),
	test_data( test_955, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products956) :-
	spl_db( test_956, Spl ),
	test_data( test_956, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products957) :-
	spl_db( test_957, Spl ),
	test_data( test_957, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products958) :-
	spl_db( test_958, Spl ),
	test_data( test_958, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products959) :-
	spl_db( test_959, Spl ),
	test_data( test_959, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products960) :-
	spl_db( test_960, Spl ),
	test_data( test_960, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products961) :-
	spl_db( test_961, Spl ),
	test_data( test_961, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products962) :-
	spl_db( test_962, Spl ),
	test_data( test_962, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products963) :-
	spl_db( test_963, Spl ),
	test_data( test_963, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products964) :-
	spl_db( test_964, Spl ),
	test_data( test_964, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products965) :-
	spl_db( test_965, Spl ),
	test_data( test_965, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products966) :-
	spl_db( test_966, Spl ),
	test_data( test_966, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products967) :-
	spl_db( test_967, Spl ),
	test_data( test_967, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products968) :-
	spl_db( test_968, Spl ),
	test_data( test_968, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products969) :-
	spl_db( test_969, Spl ),
	test_data( test_969, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products970) :-
	spl_db( test_970, Spl ),
	test_data( test_970, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products971) :-
	spl_db( test_971, Spl ),
	test_data( test_971, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products972) :-
	spl_db( test_972, Spl ),
	test_data( test_972, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products973) :-
	spl_db( test_973, Spl ),
	test_data( test_973, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products974) :-
	spl_db( test_974, Spl ),
	test_data( test_974, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products975) :-
	spl_db( test_975, Spl ),
	test_data( test_975, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products976) :-
	spl_db( test_976, Spl ),
	test_data( test_976, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products977) :-
	spl_db( test_977, Spl ),
	test_data( test_977, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products978) :-
	spl_db( test_978, Spl ),
	test_data( test_978, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products979) :-
	spl_db( test_979, Spl ),
	test_data( test_979, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products980) :-
	spl_db( test_980, Spl ),
	test_data( test_980, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products981) :-
	spl_db( test_981, Spl ),
	test_data( test_981, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products982) :-
	spl_db( test_982, Spl ),
	test_data( test_982, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products983) :-
	spl_db( test_983, Spl ),
	test_data( test_983, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products984) :-
	spl_db( test_984, Spl ),
	test_data( test_984, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products985) :-
	spl_db( test_985, Spl ),
	test_data( test_985, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products986) :-
	spl_db( test_986, Spl ),
	test_data( test_986, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products987) :-
	spl_db( test_987, Spl ),
	test_data( test_987, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products988) :-
	spl_db( test_988, Spl ),
	test_data( test_988, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products989) :-
	spl_db( test_989, Spl ),
	test_data( test_989, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products990) :-
	spl_db( test_990, Spl ),
	test_data( test_990, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products991) :-
	spl_db( test_991, Spl ),
	test_data( test_991, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products992) :-
	spl_db( test_992, Spl ),
	test_data( test_992, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products993) :-
	spl_db( test_993, Spl ),
	test_data( test_993, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products994) :-
	spl_db( test_994, Spl ),
	test_data( test_994, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products995) :-
	spl_db( test_995, Spl ),
	test_data( test_995, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products996) :-
	spl_db( test_996, Spl ),
	test_data( test_996, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products997) :-
	spl_db( test_997, Spl ),
	test_data( test_997, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products998) :-
	spl_db( test_998, Spl ),
	test_data( test_998, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

test(valid_products999) :-
	spl_db( test_999, Spl ),
	test_data( test_999, valid_products, Input_Product, Expected_result),
	isValidProduct(Input_Product,Spl,Expected_result), !.

:- end_tests(valid_products).