% ---------------
% Auxiliary predicates to support true/false as a parameter.
% ---------------
isValidConfiguration(configuration(SS,SR),Spl,true) :- !, valid_c(configuration(SS,SR),Spl).
isValidConfiguration(configuration(SS,SR),Spl,false) :-  !, not(valid_c(configuration(SS,SR),Spl)).
% ---------------
spl_db( test_0,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_0,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_1,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_1,valid_configuration,configuration([f9,root,f4,f5],[f3,f7,f1,f6,f8]),false).


% ---------------
spl_db( test_2,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_2,valid_configuration,configuration([f2,f7,f3,f6],[f8,f9]),false).


% ---------------
spl_db( test_3,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_3,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_4,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_4,valid_configuration,configuration([f7,f9,f5,f8,f1],[f6]),false).


% ---------------
spl_db( test_5,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(test_5,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_6,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(test_6,valid_configuration,configuration([f9,f6,f1,f7,f5,f2,root,f8],[]),false).


% ---------------
spl_db( test_7,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_7,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7,f8],[]),true).


% ---------------
spl_db( test_8,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f6, [] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_8,valid_configuration,configuration([f6,root,f7,f4],[f3,f9,f8]),true).


% ---------------
spl_db( test_9,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_9,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_10,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

test_data(test_10,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_11,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_11,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_12,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_12,valid_configuration,configuration([root,f2,f3,f4],[]),true).


% ---------------
spl_db( test_13,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_13,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_14,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(test_14,valid_configuration,configuration([root,f1,f2,f3,f4,f6,f8],[]),true).


% ---------------
spl_db( test_15,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
						optional( feature( f5, [
							mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
								only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_15,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_16,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_16,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_17,
	 spl( [ root, f1, f2, f5, f8, f6, f7, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_17,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_18,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_18,valid_configuration,configuration([root,f1,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_19,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(test_19,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_20,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
						optional( feature( f8, [] ) ) ] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_20,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_21,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(test_21,valid_configuration,configuration([f2,f6,f7,f9,f3],[f4,f5,root]),false).


% ---------------
spl_db( test_22,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f4 , f3 ), excludes( f5 , f1 ) ]
		)
	)
).

test_data(test_22,valid_configuration,configuration([root,f2,f3,f4,f5,f6,f9],[]),true).


% ---------------
spl_db( test_23,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_23,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_24,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f4 , f7 ), requires( f9 , f1 ) ]
		)
	)
).

test_data(test_24,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_25,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_25,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_26,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f2 ), excludes( f8 , f5 ), requires( f6 , f8 ) ]
		)
	)
).

test_data(test_26,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7],[]),true).


% ---------------
spl_db( test_27,
	 spl( [ root, f1, f2, f4, f7, f9, f8, f5, f6, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f1 , f2 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_27,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_28,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_28,valid_configuration,configuration([f1,f5,f2,f7,f6,root],[f8]),false).


% ---------------
spl_db( test_29,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_29,valid_configuration,configuration([f2,f9,f1],[f5,f8,f3,f4,root,f6]),false).


% ---------------
spl_db( test_30,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f5 , f6 ), requires( f4 , f6 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(test_30,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_31,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f9 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(test_31,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_32,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_32,valid_configuration,configuration([],[]),true).


% ---------------
spl_db( test_33,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_33,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_34,
	 spl( [ root, f1, f6, f9, f7, f2, f3, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f4 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(test_34,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_35,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_35,valid_configuration,configuration([f4,root,f5,f1,f2,f9,f7],[f8]),true).


% ---------------
spl_db( test_36,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f7, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(test_36,valid_configuration,configuration([root,f3],[]),true).


% ---------------
spl_db( test_37,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_37,valid_configuration,configuration([root,f1,f6,f7,f9],[]),true).


% ---------------
spl_db( test_38,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(test_38,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_39,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_39,valid_configuration,configuration([root,f3,f5],[]),true).


% ---------------
spl_db( test_40,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_40,valid_configuration,configuration([f8,f5,f2,f7,f9,f6,f3,root,f1],[]),false).


% ---------------
spl_db( test_41,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_41,valid_configuration,configuration([root,f1,f3,f4,f6],[]),true).


% ---------------
spl_db( test_42,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f3 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(test_42,valid_configuration,configuration([root,f1,f2,f4,f6,f8],[]),true).


% ---------------
spl_db( test_43,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(test_43,valid_configuration,configuration([f2,f3,f4,f1,f8,f6,f7],[]),true).


% ---------------
spl_db( test_44,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_44,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_45,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_45,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_46,
	 spl( [ root, f1, f2, f3, f8, f4, f7, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
						optional( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_46,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_47,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_47,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_48,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_48,valid_configuration,configuration([root,f1,f2,f4,f5],[]),true).


% ---------------
spl_db( test_49,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f6 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(test_49,valid_configuration,configuration([root,f2,f3,f6],[]),true).


% ---------------
spl_db( test_50,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(test_50,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_51,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f8 , f3 ) ]
		)
	)
).

test_data(test_51,valid_configuration,configuration([root,f1,f2,f3,f4,f6],[]),true).


% ---------------
spl_db( test_52,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_52,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f8,f9],[]),true).


% ---------------
spl_db( test_53,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_53,valid_configuration,configuration([root,f1,f3,f4,f6,f7,f8],[]),true).


% ---------------
spl_db( test_54,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_54,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_55,
	 spl( [ root, f1, f4, f7, f9, f8, f5, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f7 , f8 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(test_55,valid_configuration,configuration([root,f3],[]),true).


% ---------------
spl_db( test_56,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ), requires( f1 , f8 ) ]
		)
	)
).

test_data(test_56,valid_configuration,configuration([root,f2,f6,f7,f8],[]),true).


% ---------------
spl_db( test_57,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(test_57,valid_configuration,configuration([root,f3,f4],[]),true).


% ---------------
spl_db( test_58,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_58,valid_configuration,configuration([root,f1,f2,f3,f4,f7,f9],[]),true).


% ---------------
spl_db( test_59,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_59,valid_configuration,configuration([root,f1,f2,f5,f7],[]),true).


% ---------------
spl_db( test_60,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_60,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_61,
	 spl( [ root, f1, f2, f7, f9, f3, f6, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f6 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_61,valid_configuration,configuration([root,f1,f2,f4,f7],[]),true).


% ---------------
spl_db( test_62,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_62,valid_configuration,configuration([f4,f1,f3,f2,f9,f5],[]),true).


% ---------------
spl_db( test_63,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f3 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(test_63,valid_configuration,configuration([f9,f3,f2,f7,f4,f1,root,f5],[f8]),false).


% ---------------
spl_db( test_64,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f9, [] ) ) ] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_64,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_65,
	 spl( [ root, f1, f6, f8, f2, f3, f4, f5, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_65,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_66,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_66,valid_configuration,configuration([f2,f6,f7,f1,root,f5,f4,f3,f9],[]),false).


% ---------------
spl_db( test_67,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_67,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_68,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_68,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_69,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_69,valid_configuration,configuration([f5,f6,f8,f1,f4,f2,root],[]),true).


% ---------------
spl_db( test_70,
	 spl( [ root, f1, f6, f2, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(test_70,valid_configuration,configuration([f2,f3,f8,f7],[f9,f1]),false).


% ---------------
spl_db( test_71,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

test_data(test_71,valid_configuration,configuration([root,f1,f2,f3,f6],[]),true).


% ---------------
spl_db( test_72,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f2 ), requires( f6 , f8 ) ]
		)
	)
).

test_data(test_72,valid_configuration,configuration([root,f1,f2,f3,f5,f9],[]),true).


% ---------------
spl_db( test_73,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f5, [
							optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
								mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f1 , f6 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(test_73,valid_configuration,configuration([f4,f8,f6,f5,root,f1,f7],[f3]),false).


% ---------------
spl_db( test_74,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f2 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_74,valid_configuration,configuration([f1,f2,f5,f6,f8,root,f4],[f9,f7]),false).


% ---------------
spl_db( test_75,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f1 ) ]
		)
	)
).

test_data(test_75,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_76,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					only_one( [ feature( f5, [
						mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f2 , f7 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(test_76,valid_configuration,configuration([f7,f9,f4,f1,f3,f6,f5,f8],[]),false).


% ---------------
spl_db( test_77,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_77,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_78,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f5, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f8 , f3 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(test_78,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_79,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(test_79,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_80,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f6 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(test_80,valid_configuration,configuration([root,f1,f2,f4,f5,f7,f8],[]),true).


% ---------------
spl_db( test_81,
	 spl( [ root, f1, f7, f9, f2, f3, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_81,valid_configuration,configuration([root,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_82,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_82,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_83,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_83,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_84,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f5 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_84,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_85,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f4 , f8 ), excludes( f5 , f2 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(test_85,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_86,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_86,valid_configuration,configuration([root,f1,f2,f5,f6],[]),true).


% ---------------
spl_db( test_87,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_87,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7,f9],[]),true).


% ---------------
spl_db( test_88,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_88,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_89,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

test_data(test_89,valid_configuration,configuration([root,f1,f2,f4,f8],[]),true).


% ---------------
spl_db( test_90,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_90,valid_configuration,configuration([root,f2,f4],[]),true).


% ---------------
spl_db( test_91,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f9 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(test_91,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_92,
	 spl( [ root, f1, f3, f9, f4, f6, f7, f8, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_92,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_93,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_93,valid_configuration,configuration([root,f8,f6,f3,f1,f7,f4,f9,f2],[]),false).


% ---------------
spl_db( test_94,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_94,valid_configuration,configuration([root,f2,f3,f5],[]),true).


% ---------------
spl_db( test_95,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

test_data(test_95,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f9],[]),true).


% ---------------
spl_db( test_96,
	 spl( [ root, f1, f4, f5, f7, f8, f9, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_96,valid_configuration,configuration([],[f3,f4,f9]),false).


% ---------------
spl_db( test_97,
	 spl( [ root, f1, f3, f4, f5, f8, f9, f6, f2, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f4 ), requires( f3 , f2 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(test_97,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_98,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(test_98,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_99,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f4 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(test_99,valid_configuration,configuration([f4,f1,f3],[f9]),true).


% ---------------
spl_db( test_100,
	 spl( [ root, f1, f3, f8, f4, f9, f5, f7, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f5 , f3 ), excludes( f7 , f8 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(test_100,valid_configuration,configuration([f3,f7,root],[f1,f4,f2]),false).


% ---------------
spl_db( test_101,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_101,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f8,f9],[]),true).


% ---------------
spl_db( test_102,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f5 , f7 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(test_102,valid_configuration,configuration([root,f7,f2,f1,f4,f5,f9,f6],[f8]),false).


% ---------------
spl_db( test_103,
	 spl( [ root, f1, f2, f4, f5, f8, f6, f7, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_103,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_104,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f5, f4, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_104,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_105,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_105,valid_configuration,configuration([root,f4],[f8,f9]),false).


% ---------------
spl_db( test_106,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_106,valid_configuration,configuration([f7,root],[f4,f5,f8]),true).


% ---------------
spl_db( test_107,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_107,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_108,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

test_data(test_108,valid_configuration,configuration([f1,f7,f4],[f3,root,f6,f9,f2]),false).


% ---------------
spl_db( test_109,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [
							optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(test_109,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_110,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

test_data(test_110,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_111,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(test_111,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_112,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_112,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_113,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_113,valid_configuration,configuration([root,f1,f5,f8],[]),true).


% ---------------
spl_db( test_114,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_114,valid_configuration,configuration([root,f1,f2,f3,f6,f8],[]),true).


% ---------------
spl_db( test_115,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_115,valid_configuration,configuration([root,f1,f3,f7,f8],[]),true).


% ---------------
spl_db( test_116,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_116,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_117,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_117,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_118,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(test_118,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_119,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [
						optional( feature( f7, [] ) ), optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f4, [
					optional( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_119,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_120,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_120,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_121,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f5 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(test_121,valid_configuration,configuration([root,f2,f4,f5,f6,f8],[]),true).


% ---------------
spl_db( test_122,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_122,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_123,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_123,valid_configuration,configuration([root,f1,f3,f4,f6,f7],[]),true).


% ---------------
spl_db( test_124,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f1 ), excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_124,valid_configuration,configuration([root,f4,f5,f6],[]),true).


% ---------------
spl_db( test_125,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f8 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_125,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_126,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f4 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_126,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_127,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_127,valid_configuration,configuration([root,f1,f3,f4,f5,f6,f9],[]),true).


% ---------------
spl_db( test_128,
	 spl( [ root, f1, f2, f5, f7, f6, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ) ] ), feature( f6, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_128,valid_configuration,configuration([f4,f6,f7,f8,root],[f9]),true).


% ---------------
spl_db( test_129,
	 spl( [ root, f1, f4, f6, f5, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(test_129,valid_configuration,configuration([f2,f8],[f7,f3,f6,f9,f1,f4]),false).


% ---------------
spl_db( test_130,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f1 ), requires( f1 , f6 ) ]
		)
	)
).

test_data(test_130,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_131,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_131,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_132,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_132,valid_configuration,configuration([f6,f3,f2,f4,f8,f1,f9,root],[]),false).


% ---------------
spl_db( test_133,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_133,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_134,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_134,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_135,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f4 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_135,valid_configuration,configuration([f8,f1],[f7,f6,f5,f3,f4,root]),false).


% ---------------
spl_db( test_136,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(test_136,valid_configuration,configuration([root,f2,f3,f4,f5,f6,f7,f8],[]),true).


% ---------------
spl_db( test_137,
	 spl( [ root, f1, f8, f9, f2, f5, f6, f7, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_137,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_138,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f5 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_138,valid_configuration,configuration([f8,f1,root],[f4,f3,f6]),true).


% ---------------
spl_db( test_139,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_139,valid_configuration,configuration([f7,f2,f8,f9,f4,f6],[f5]),false).


% ---------------
spl_db( test_140,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_140,valid_configuration,configuration([root,f1,f3,f5],[]),true).


% ---------------
spl_db( test_141,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_141,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_142,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_142,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_143,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(test_143,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_144,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_144,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_145,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f3 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_145,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_146,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(test_146,valid_configuration,configuration([root,f1,f2,f3,f4,f8],[]),true).


% ---------------
spl_db( test_147,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_147,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_148,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f4 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_148,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_149,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_149,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_150,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_150,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_151,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
						one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_151,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_152,
	 spl( [ root, f1, f4, f8, f2, f5, f6, f7, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_152,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_153,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(test_153,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_154,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_154,valid_configuration,configuration([root,f4],[]),true).


% ---------------
spl_db( test_155,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_155,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_156,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f6 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_156,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_157,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f1 , f6 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_157,valid_configuration,configuration([root,f2,f4],[]),true).


% ---------------
spl_db( test_158,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_158,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_159,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_159,valid_configuration,configuration([f5,f8,f2,f1,root,f3,f7],[f6]),false).


% ---------------
spl_db( test_160,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f3 , f7 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_160,valid_configuration,configuration([f7,f9,f8,f6,f2,f1,f5,f3],[root]),false).


% ---------------
spl_db( test_161,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_161,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_162,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_162,valid_configuration,configuration([f4,f3,f2],[]),false).


% ---------------
spl_db( test_163,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

test_data(test_163,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_164,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_164,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_165,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_165,valid_configuration,configuration([f9,f5,f4,f8,f1,root],[f7,f3]),false).


% ---------------
spl_db( test_166,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f8 ), requires( f6 , f5 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(test_166,valid_configuration,configuration([f3,f4,f9,f8,root,f1,f5],[f2]),false).


% ---------------
spl_db( test_167,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_167,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_168,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_168,valid_configuration,configuration([f9,f4,f7,f5,f3,root],[f8]),false).


% ---------------
spl_db( test_169,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_169,valid_configuration,configuration([root,f1,f5,f6],[]),true).


% ---------------
spl_db( test_170,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f2 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(test_170,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_171,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(test_171,valid_configuration,configuration([root,f1,f2,f3,f6,f7,f8,f9],[]),true).


% ---------------
spl_db( test_172,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_172,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7,f8],[]),true).


% ---------------
spl_db( test_173,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f2 ), requires( f1 , f9 ) ]
		)
	)
).

test_data(test_173,valid_configuration,configuration([root,f4,f8,f3,f7,f9],[f6]),false).


% ---------------
spl_db( test_174,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_174,valid_configuration,configuration([f7,f8,f4,f6,f3,f2],[]),false).


% ---------------
spl_db( test_175,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_175,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_176,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_176,valid_configuration,configuration([root,f1,f3,f4,f5],[]),true).


% ---------------
spl_db( test_177,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_177,valid_configuration,configuration([root,f1,f3,f5,f7,f9],[]),true).


% ---------------
spl_db( test_178,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_178,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_179,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f9 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_179,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_180,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_180,valid_configuration,configuration([f8,f3,f6,f1,f5,f4],[f9]),true).


% ---------------
spl_db( test_181,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_181,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_182,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_182,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_183,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(test_183,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_184,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f5 ), excludes( f5 , f7 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(test_184,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_185,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

test_data(test_185,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_186,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_186,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_187,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_187,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_188,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_188,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_189,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_189,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7,f9],[]),true).


% ---------------
spl_db( test_190,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

test_data(test_190,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_191,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_191,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_192,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(test_192,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_193,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_193,valid_configuration,configuration([f9,f3,f7,f6,root,f1,f4,f8],[f2]),false).


% ---------------
spl_db( test_194,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f2, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_194,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_195,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f6, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f3 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(test_195,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_196,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_196,valid_configuration,configuration([root,f4,f5],[]),true).


% ---------------
spl_db( test_197,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f5 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_197,valid_configuration,configuration([root,f1,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_198,
	 spl( [ root, f1, f8, f2, f9, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_198,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_199,
	 spl( [ root, f1, f2, f4, f9, f5, f3, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_199,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_200,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f8 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(test_200,valid_configuration,configuration([f3,f7,f8,f4,f2,f6,f5,root],[]),false).


% ---------------
spl_db( test_201,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_201,valid_configuration,configuration([f6,f5,f4,f3,f2,f9],[f8]),true).


% ---------------
spl_db( test_202,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_202,valid_configuration,configuration([root,f1,f2,f3,f5,f7],[]),true).


% ---------------
spl_db( test_203,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_203,valid_configuration,configuration([f9,f3,f1,f8,f7,f5],[f2,f6]),false).


% ---------------
spl_db( test_204,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(test_204,valid_configuration,configuration([f6,f5],[root,f4,f3,f1,f8,f7,f9]),false).


% ---------------
spl_db( test_205,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f3 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_205,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_206,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f4 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_206,valid_configuration,configuration([f4,f2,root,f5,f1,f6,f9],[f8]),false).


% ---------------
spl_db( test_207,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

test_data(test_207,valid_configuration,configuration([root,f3,f9,f8,f4,f5,f1,f7,f6],[]),false).


% ---------------
spl_db( test_208,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_208,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_209,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f1 , f4 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(test_209,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7,f9],[]),true).


% ---------------
spl_db( test_210,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f4, f6, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f5 ), excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_210,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_211,
	 spl( [ root, f1, f2, f3, f6, f8, f9, f7, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_211,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_212,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(test_212,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_213,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

test_data(test_213,valid_configuration,configuration([f8,f7,f9,f6,f1,f4,f5,f3],[root]),false).


% ---------------
spl_db( test_214,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_214,valid_configuration,configuration([root,f2,f4,f7],[]),true).


% ---------------
spl_db( test_215,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_215,valid_configuration,configuration([root,f1,f3,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_216,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_216,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_217,
	 spl( [ root, f1, f4, f8, f9, f5, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f8 , f9 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(test_217,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_218,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f1 , f4 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(test_218,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_219,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_219,valid_configuration,configuration([root,f1,f3,f4,f5,f6,f7,f8],[]),true).


% ---------------
spl_db( test_220,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

test_data(test_220,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_221,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_221,valid_configuration,configuration([root,f2,f3,f4,f5,f8,f9],[]),true).


% ---------------
spl_db( test_222,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f3 , f8 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_222,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_223,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_223,valid_configuration,configuration([root,f1,f2,f5,f6],[]),true).


% ---------------
spl_db( test_224,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(test_224,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_225,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f5 ), requires( f2 , f8 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_225,valid_configuration,configuration([root,f2,f4,f5,f6],[]),true).


% ---------------
spl_db( test_226,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f5 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_226,valid_configuration,configuration([f2,f1,f8,f3,f5,f6,f9,f7,root],[]),false).


% ---------------
spl_db( test_227,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_227,valid_configuration,configuration([f7],[f9,f5,f1,f2]),true).


% ---------------
spl_db( test_228,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f6 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_228,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_229,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_229,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_230,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f8 , f7 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(test_230,valid_configuration,configuration([f1,f4],[]),true).


% ---------------
spl_db( test_231,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_231,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_232,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_232,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_233,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f5 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_233,valid_configuration,configuration([],[f5,f8,f4,f6,root]),false).


% ---------------
spl_db( test_234,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(test_234,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_235,
	 spl( [ root, f1, f4, f5, f7, f8, f9, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_235,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_236,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_236,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_237,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f6 , f2 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_237,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_238,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_238,valid_configuration,configuration([f6,f5],[f7,f2,f9,root]),false).


% ---------------
spl_db( test_239,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f7 ), requires( f9 , f1 ) ]
		)
	)
).

test_data(test_239,valid_configuration,configuration([root,f1,f4],[]),true).


% ---------------
spl_db( test_240,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_240,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_241,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f8 , f6 ), requires( f9 , f6 ) ]
		)
	)
).

test_data(test_241,valid_configuration,configuration([root,f5,f3,f6,f8,f4,f9],[f2]),false).


% ---------------
spl_db( test_242,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(test_242,valid_configuration,configuration([f6,root,f9,f1,f2,f5,f4],[f8,f7]),false).


% ---------------
spl_db( test_243,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_243,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_244,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(test_244,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_245,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f1 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_245,valid_configuration,configuration([],[f2,f1,f4,f3,root,f9,f7,f5]),false).


% ---------------
spl_db( test_246,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f1 ) ]
		)
	)
).

test_data(test_246,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_247,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_247,valid_configuration,configuration([root,f1,f3,f4,f5],[]),true).


% ---------------
spl_db( test_248,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), requires( f5 , f7 ) ]
		)
	)
).

test_data(test_248,valid_configuration,configuration([],[f3]),false).


% ---------------
spl_db( test_249,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f7 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(test_249,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_250,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_250,valid_configuration,configuration([root,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_251,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_251,valid_configuration,configuration([root,f2,f4,f6,f7],[]),true).


% ---------------
spl_db( test_252,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f5 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(test_252,valid_configuration,configuration([root,f1,f2,f4,f6,f9],[]),true).


% ---------------
spl_db( test_253,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_253,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_254,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(test_254,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_255,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_255,valid_configuration,configuration([root,f1,f2,f3,f5,f6],[]),true).


% ---------------
spl_db( test_256,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_256,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_257,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(test_257,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_258,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
						mandatory( feature( f7, [
							optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f2 ) ]
		)
	)
).

test_data(test_258,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_259,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f7 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_259,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_260,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f9 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_260,valid_configuration,configuration([root,f1,f2,f4,f5],[]),true).


% ---------------
spl_db( test_261,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f5 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(test_261,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_262,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f9 , f8 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_262,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_263,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_263,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_264,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [
				optional( feature( f3, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(test_264,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_265,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f3 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_265,valid_configuration,configuration([f5],[f7,f9,f4]),true).


% ---------------
spl_db( test_266,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_266,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_267,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f3 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(test_267,valid_configuration,configuration([root,f4],[]),true).


% ---------------
spl_db( test_268,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f7 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_268,valid_configuration,configuration([f3,f2],[]),true).


% ---------------
spl_db( test_269,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f7 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_269,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_270,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_270,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_271,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f5 , f2 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_271,valid_configuration,configuration([f8,f9,f7,f1,root],[f6,f2,f4,f3]),false).


% ---------------
spl_db( test_272,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f3 ) ]
		)
	)
).

test_data(test_272,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_273,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_273,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_274,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(test_274,valid_configuration,configuration([f8],[root]),false).


% ---------------
spl_db( test_275,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_275,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f8],[]),true).


% ---------------
spl_db( test_276,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f1 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_276,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_277,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_277,valid_configuration,configuration([f7,f5,f2,f6],[f9,root,f3,f1,f4]),false).


% ---------------
spl_db( test_278,
	 spl( [ root, f1, f2, f3, f7, f4, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(test_278,valid_configuration,configuration([f4,f1,f5,f6],[f8,f2]),false).


% ---------------
spl_db( test_279,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_279,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_280,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_280,valid_configuration,configuration([root,f4,f6,f7],[]),true).


% ---------------
spl_db( test_281,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_281,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_282,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f5 , f6 ), excludes( f3 , f7 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(test_282,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_283,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f6 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(test_283,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_284,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f7 ), requires( f7 , f2 ) ]
		)
	)
).

test_data(test_284,valid_configuration,configuration([root,f2,f3,f6],[]),true).


% ---------------
spl_db( test_285,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_285,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_286,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f2, f3, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_286,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_287,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_287,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f9],[]),true).


% ---------------
spl_db( test_288,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_288,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_289,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

test_data(test_289,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_290,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_290,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_291,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f9 , f6 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(test_291,valid_configuration,configuration([root,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_292,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_292,valid_configuration,configuration([root,f1,f3,f4,f5],[]),true).


% ---------------
spl_db( test_293,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_293,valid_configuration,configuration([root,f1,f2,f3,f6,f7,f9],[]),true).


% ---------------
spl_db( test_294,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f9 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(test_294,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_295,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_295,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_296,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_296,valid_configuration,configuration([root,f1,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_297,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f4, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_297,valid_configuration,configuration([f6,f2,f9,f3,f5,f4,root,f7],[f8]),false).


% ---------------
spl_db( test_298,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_298,valid_configuration,configuration([f7,f5,f3,f4,f9],[f8]),true).


% ---------------
spl_db( test_299,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_299,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_300,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_300,valid_configuration,configuration([f7,f8,f5,f1,f2,f9],[]),false).


% ---------------
spl_db( test_301,
	 spl( [ root, f1, f5, f6, f7, f9, f2, f3, f4, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f4 , f5 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_301,valid_configuration,configuration([f3,f2,f7],[]),true).


% ---------------
spl_db( test_302,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f2 , f7 ) ]
		)
	)
).

test_data(test_302,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_303,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_303,valid_configuration,configuration([root,f1,f3,f4,f5],[]),true).


% ---------------
spl_db( test_304,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_304,valid_configuration,configuration([root,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_305,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f5 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(test_305,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_306,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(test_306,valid_configuration,configuration([f6,f3],[f9,root,f4,f5,f7]),false).


% ---------------
spl_db( test_307,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_307,valid_configuration,configuration([f1,f5,f8,root,f4],[f9]),true).


% ---------------
spl_db( test_308,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

test_data(test_308,valid_configuration,configuration([root,f2,f3,f5,f6],[]),true).


% ---------------
spl_db( test_309,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_309,valid_configuration,configuration([],[f7]),true).


% ---------------
spl_db( test_310,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_310,valid_configuration,configuration([root,f1,f2,f4,f7],[]),true).


% ---------------
spl_db( test_311,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_311,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_312,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f9 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(test_312,valid_configuration,configuration([f8,f2,root,f5,f7,f1],[f3,f4]),false).


% ---------------
spl_db( test_313,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f2 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(test_313,valid_configuration,configuration([root,f3,f1],[]),true).


% ---------------
spl_db( test_314,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(test_314,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_315,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_315,valid_configuration,configuration([root,f1,f5,f7,f9],[]),true).


% ---------------
spl_db( test_316,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [
						optional( feature( f5, [
							only_one( [ feature( f6, [
								mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

test_data(test_316,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_317,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f7 , f3 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(test_317,valid_configuration,configuration([root,f1,f3,f5,f9],[]),true).


% ---------------
spl_db( test_318,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

test_data(test_318,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_319,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f8 , f2 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_319,valid_configuration,configuration([f8,f4,f6,f1,f5,f7,f9],[root]),false).


% ---------------
spl_db( test_320,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_320,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_321,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_321,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_322,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_322,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_323,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_323,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_324,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_324,valid_configuration,configuration([root,f1,f2,f3,f4,f6,f7],[]),true).


% ---------------
spl_db( test_325,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [
							mandatory( feature( f5, [] ) ), optional( feature( f6, [
								optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(test_325,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_326,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_326,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_327,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_327,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_328,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f4 , f6 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(test_328,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_329,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f6 ), requires( f6 , f7 ), excludes( f5 , f9 ) ]
		)
	)
).

test_data(test_329,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_330,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_330,valid_configuration,configuration([root,f1,f3,f6],[]),true).


% ---------------
spl_db( test_331,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), requires( f8 , f1 ) ]
		)
	)
).

test_data(test_331,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_332,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_332,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_333,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_333,valid_configuration,configuration([f5,f8,f6,f7,root],[]),false).


% ---------------
spl_db( test_334,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(test_334,valid_configuration,configuration([root,f1,f2,f6,f9],[]),true).


% ---------------
spl_db( test_335,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f4 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_335,valid_configuration,configuration([root,f1,f2,f4,f5,f6],[]),true).


% ---------------
spl_db( test_336,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_336,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_337,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f7 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_337,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_338,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f4 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(test_338,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_339,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f9 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(test_339,valid_configuration,configuration([root,f5,f7,f2,f6,f4,f3,f1,f9],[]),false).


% ---------------
spl_db( test_340,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f4 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_340,valid_configuration,configuration([f7,f2,f4,root,f5,f3,f9,f1,f8],[]),false).


% ---------------
spl_db( test_341,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_341,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_342,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f9 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_342,valid_configuration,configuration([f4,root,f5,f6],[f2,f8,f1,f9,f7]),false).


% ---------------
spl_db( test_343,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_343,valid_configuration,configuration([root,f2,f3,f6,f8],[]),true).


% ---------------
spl_db( test_344,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_344,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_345,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f6 ), requires( f2 , f3 ) ]
		)
	)
).

test_data(test_345,valid_configuration,configuration([f6,f4,f2,f1,root,f9,f3],[]),false).


% ---------------
spl_db( test_346,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_346,valid_configuration,configuration([f7,root,f8,f6,f3,f9,f5],[f1]),false).


% ---------------
spl_db( test_347,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_347,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_348,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(test_348,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_349,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_349,valid_configuration,configuration([root,f2,f4],[]),true).


% ---------------
spl_db( test_350,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

test_data(test_350,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_351,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(test_351,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f8],[]),true).


% ---------------
spl_db( test_352,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_352,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_353,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_353,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_354,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f1 , f2 ), requires( f2 , f4 ) ]
		)
	)
).

test_data(test_354,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_355,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f1 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_355,valid_configuration,configuration([f2,f3,f6,f1,f4],[f5,f8]),false).


% ---------------
spl_db( test_356,
	 spl( [ root, f1, f2, f4, f3, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(test_356,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f8],[]),true).


% ---------------
spl_db( test_357,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(test_357,valid_configuration,configuration([root,f1,f2,f4,f5],[]),true).


% ---------------
spl_db( test_358,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_358,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_359,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_359,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f8],[]),true).


% ---------------
spl_db( test_360,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_360,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7,f8],[]),true).


% ---------------
spl_db( test_361,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(test_361,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_362,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f5, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_362,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_363,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(test_363,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_364,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_364,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_365,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_365,valid_configuration,configuration([f7,f6,root,f8,f1,f3,f5,f4,f2],[]),false).


% ---------------
spl_db( test_366,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), excludes( f5 , f2 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(test_366,valid_configuration,configuration([f3,f5,f4,root,f9,f7,f6,f8,f1],[]),false).


% ---------------
spl_db( test_367,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f9 , f2 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(test_367,valid_configuration,configuration([root,f1,f2,f3,f4,f6],[]),true).


% ---------------
spl_db( test_368,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(test_368,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_369,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_369,valid_configuration,configuration([root,f1,f3,f5,f6,f7,f8],[]),true).


% ---------------
spl_db( test_370,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f5, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f5 , f1 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(test_370,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_371,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f6 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(test_371,valid_configuration,configuration([f3],[f7]),false).


% ---------------
spl_db( test_372,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f9 , f6 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(test_372,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_373,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_373,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_374,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f4 ), requires( f4 , f1 ) ]
		)
	)
).

test_data(test_374,valid_configuration,configuration([f3,f2,f4,f6],[f9]),false).


% ---------------
spl_db( test_375,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_375,valid_configuration,configuration([f5,root,f6,f7,f2,f3,f9],[f4,f8]),false).


% ---------------
spl_db( test_376,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_376,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_377,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_377,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_378,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f8 , f4 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(test_378,valid_configuration,configuration([f5,root,f6,f7,f9,f8,f4],[f2]),false).


% ---------------
spl_db( test_379,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f5 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_379,valid_configuration,configuration([root,f2,f6],[]),true).


% ---------------
spl_db( test_380,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f6 , f7 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_380,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_381,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f7 ), requires( f9 , f2 ) ]
		)
	)
).

test_data(test_381,valid_configuration,configuration([f6,f5,f2,f4,f3],[]),true).


% ---------------
spl_db( test_382,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_382,valid_configuration,configuration([root,f1,f3,f5],[]),true).


% ---------------
spl_db( test_383,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f6 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(test_383,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_384,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_384,valid_configuration,configuration([f4],[f5,f1,f9,f6,f7]),true).


% ---------------
spl_db( test_385,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_385,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_386,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_386,valid_configuration,configuration([root,f1,f2,f5,f7],[]),true).


% ---------------
spl_db( test_387,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_387,valid_configuration,configuration([f9,f1,f3,root,f5,f2,f7,f6,f4],[]),false).


% ---------------
spl_db( test_388,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [
						mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_388,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_389,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f3 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_389,valid_configuration,configuration([root,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_390,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(test_390,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_391,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_391,valid_configuration,configuration([root,f6,f7],[]),true).


% ---------------
spl_db( test_392,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_392,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_393,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_393,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_394,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(test_394,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_395,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_395,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_396,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(test_396,valid_configuration,configuration([root,f1,f2,f3,f4,f6],[]),true).


% ---------------
spl_db( test_397,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_397,valid_configuration,configuration([root,f1,f2,f3,f4,f6],[]),true).


% ---------------
spl_db( test_398,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(test_398,valid_configuration,configuration([root,f1,f3,f4,f6,f9],[]),true).


% ---------------
spl_db( test_399,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_399,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_400,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_400,valid_configuration,configuration([root,f1,f4],[]),true).


% ---------------
spl_db( test_401,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_401,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_402,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_402,valid_configuration,configuration([root,f1,f2,f6,f7],[]),true).


% ---------------
spl_db( test_403,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_403,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_404,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_404,valid_configuration,configuration([f2,root],[f9,f5,f3,f8,f4]),true).


% ---------------
spl_db( test_405,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f1 , f7 ) ]
		)
	)
).

test_data(test_405,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_406,
	 spl( [ root, f1, f8, f9, f2, f6, f7, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_406,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_407,
	 spl( [ root, f1, f2, f4, f5, f8, f6, f7, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

test_data(test_407,valid_configuration,configuration([],[f1,root,f7,f6,f2,f4,f3]),false).


% ---------------
spl_db( test_408,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f9 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(test_408,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_409,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(test_409,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_410,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

test_data(test_410,valid_configuration,configuration([f3],[f5]),true).


% ---------------
spl_db( test_411,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [
				optional( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f9 ), requires( f5 , f3 ) ]
		)
	)
).

test_data(test_411,valid_configuration,configuration([f2],[f6,f5,f3,f7,root]),false).


% ---------------
spl_db( test_412,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_412,valid_configuration,configuration([root],[f9]),true).


% ---------------
spl_db( test_413,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(test_413,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_414,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f9 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(test_414,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_415,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f6 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(test_415,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_416,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_416,valid_configuration,configuration([root,f2,f4,f7,f8],[]),true).


% ---------------
spl_db( test_417,
	 spl( [ root, f1, f4, f5, f7, f8, f9, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_417,valid_configuration,configuration([],[f2]),true).


% ---------------
spl_db( test_418,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(test_418,valid_configuration,configuration([],[f6,f4,f8,f1,f9,f2,f5,f3,root]),false).


% ---------------
spl_db( test_419,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_419,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_420,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f9 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(test_420,valid_configuration,configuration([root,f2,f3,f4,f6,f7,f8],[]),true).


% ---------------
spl_db( test_421,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_421,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_422,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f3 , f6 ), excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_422,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_423,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_423,valid_configuration,configuration([root,f1,f2,f6,f9],[]),true).


% ---------------
spl_db( test_424,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(test_424,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f9],[]),true).


% ---------------
spl_db( test_425,
	 spl( [ root, f1, f5, f6, f7, f9, f2, f3, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f9 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_425,valid_configuration,configuration([root,f1,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_426,
	 spl( [ root, f1, f2, f5, f8, f6, f7, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_426,valid_configuration,configuration([root,f1,f2,f3,f5,f7,f9],[]),true).


% ---------------
spl_db( test_427,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_427,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_428,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_428,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7],[]),true).


% ---------------
spl_db( test_429,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(test_429,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_430,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(test_430,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_431,
	 spl( [ root, f1, f8, f2, f3, f4, f7, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f5 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(test_431,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7,f8,f9],[]),true).


% ---------------
spl_db( test_432,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_432,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_433,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(test_433,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_434,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f5, f6, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_434,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_435,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_435,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_436,
	 spl( [ root, f1, f4, f5, f2, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f6 , f8 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(test_436,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7,f8,f9],[]),true).


% ---------------
spl_db( test_437,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_437,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_438,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_438,valid_configuration,configuration([root,f2,f4],[]),true).


% ---------------
spl_db( test_439,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f3 , f6 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_439,valid_configuration,configuration([f8,f3],[f2,f1]),false).


% ---------------
spl_db( test_440,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f7, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(test_440,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_441,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_441,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_442,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_442,valid_configuration,configuration([root,f2,f5,f7],[]),true).


% ---------------
spl_db( test_443,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), requires( f8 , f5 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_443,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_444,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(test_444,valid_configuration,configuration([root,f1,f2,f3,f4,f6,f8,f9],[]),true).


% ---------------
spl_db( test_445,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_445,valid_configuration,configuration([f4],[]),true).


% ---------------
spl_db( test_446,
	 spl( [ root, f1, f2, f4, f8, f9, f5, f7, f6, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [
					mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_446,valid_configuration,configuration([f2],[f4,f6,f9,f3,f5]),false).


% ---------------
spl_db( test_447,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_447,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_448,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_448,valid_configuration,configuration([f6],[f4,root,f8,f7,f9,f1,f2,f3]),false).


% ---------------
spl_db( test_449,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(test_449,valid_configuration,configuration([f3,f4,f1,f6,f8],[f7,root,f9,f2]),false).


% ---------------
spl_db( test_450,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_450,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_451,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

test_data(test_451,valid_configuration,configuration([f7,f8,f6,f4],[f2,root]),false).


% ---------------
spl_db( test_452,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_452,valid_configuration,configuration([f4,f9,f8,f6],[f1,f3]),true).


% ---------------
spl_db( test_453,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_453,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_454,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f1 ), excludes( f5 , f1 ) ]
		)
	)
).

test_data(test_454,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_455,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_455,valid_configuration,configuration([f8],[f5,f2,f3,f6,f9,root,f4]),false).


% ---------------
spl_db( test_456,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_456,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_457,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

test_data(test_457,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_458,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_458,valid_configuration,configuration([root,f1,f3,f5,f6],[]),true).


% ---------------
spl_db( test_459,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), requires( f1 , f2 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(test_459,valid_configuration,configuration([f6,f2,f1],[f8,f3,f7,root,f4,f5]),false).


% ---------------
spl_db( test_460,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(test_460,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_461,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_461,valid_configuration,configuration([root,f2,f3,f5],[]),true).


% ---------------
spl_db( test_462,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(test_462,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_463,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_463,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_464,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f8 , f7 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_464,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_465,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(test_465,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_466,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_466,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_467,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_467,valid_configuration,configuration([root,f3,f4,f6,f9],[]),true).


% ---------------
spl_db( test_468,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_468,valid_configuration,configuration([root,f1,f2,f3,f4,f6],[]),true).


% ---------------
spl_db( test_469,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					one_or_more( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

test_data(test_469,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_470,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_470,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_471,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(test_471,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_472,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					one_or_more( [ feature( f4, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(test_472,valid_configuration,configuration([f2,f3,root,f9,f7,f1],[]),true).


% ---------------
spl_db( test_473,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f1 ), excludes( f5 , f1 ), excludes( f1 , f7 ) ]
		)
	)
).

test_data(test_473,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_474,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f8 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_474,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_475,
	 spl( [ root, f1, f2, f7, f3, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(test_475,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_476,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_476,valid_configuration,configuration([root,f4,f8,f3,f9,f5,f1],[]),true).


% ---------------
spl_db( test_477,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_477,valid_configuration,configuration([root,f1,f5,f8],[]),true).


% ---------------
spl_db( test_478,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_478,valid_configuration,configuration([root,f1,f4],[]),true).


% ---------------
spl_db( test_479,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_479,valid_configuration,configuration([f4,f8,f2,f5],[f7,f9]),true).


% ---------------
spl_db( test_480,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_480,valid_configuration,configuration([root,f2,f3,f5,f7],[]),true).


% ---------------
spl_db( test_481,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f2 ), excludes( f6 , f9 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(test_481,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_482,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f3 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_482,valid_configuration,configuration([f3,f1,f6,f9,f2,f8],[f4,f7,root]),false).


% ---------------
spl_db( test_483,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f1 ), excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_483,valid_configuration,configuration([f2,f8,f9,root,f6,f1,f4,f7],[]),false).


% ---------------
spl_db( test_484,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_484,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_485,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(test_485,valid_configuration,configuration([f1,f6,root],[f3,f4,f5]),false).


% ---------------
spl_db( test_486,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_486,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_487,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f5 , f9 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_487,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_488,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_488,valid_configuration,configuration([root,f2,f3,f4,f5,f8,f9],[]),true).


% ---------------
spl_db( test_489,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_489,valid_configuration,configuration([root,f4],[]),true).


% ---------------
spl_db( test_490,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_490,valid_configuration,configuration([root,f1,f2,f4,f5],[]),true).


% ---------------
spl_db( test_491,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_491,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_492,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_492,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_493,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_493,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_494,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_494,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_495,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f4, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_495,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_496,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), excludes( f3 , f9 ), requires( f2 , f5 ) ]
		)
	)
).

test_data(test_496,valid_configuration,configuration([root,f1,f4,f6,f7],[]),true).


% ---------------
spl_db( test_497,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f8, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f7 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(test_497,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_498,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_498,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_499,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), requires( f8 , f5 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(test_499,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_500,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_500,valid_configuration,configuration([root,f4],[]),true).


% ---------------
spl_db( test_501,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_501,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_502,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_502,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7,f9],[]),true).


% ---------------
spl_db( test_503,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(test_503,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_504,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f8 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_504,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_505,
	 spl( [ root, f1, f2, f3, f5, f6, f4, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_505,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_506,
	 spl( [ root, f1, f8, f9, f2, f7, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

test_data(test_506,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_507,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_507,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_508,
	 spl( [ root, f1, f2, f4, f5, f6, f3, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_508,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_509,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f9 , f3 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_509,valid_configuration,configuration([root,f1,f2,f3,f6,f7,f8,f9],[]),true).


% ---------------
spl_db( test_510,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

test_data(test_510,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_511,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_511,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_512,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_512,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_513,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f9 ), excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_513,valid_configuration,configuration([f4,f7,f5,f2,f6],[f1,f8]),false).


% ---------------
spl_db( test_514,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(test_514,valid_configuration,configuration([f4,root,f5,f6,f9],[f2,f1,f3]),false).


% ---------------
spl_db( test_515,
	 spl( [ root, f1, f7, f8, f9, f2, f4, f5, f6, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_515,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_516,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_516,valid_configuration,configuration([root,f1,f2,f5],[]),true).


% ---------------
spl_db( test_517,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(test_517,valid_configuration,configuration([f9,f2,root,f1,f6,f4,f3,f8],[f5]),true).


% ---------------
spl_db( test_518,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_518,valid_configuration,configuration([root,f3,f2,f7,f6],[f1,f9,f4,f5]),false).


% ---------------
spl_db( test_519,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_519,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_520,
	 spl( [ root, f1, f7, f2, f4, f8, f9, f5, f6, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				only_one( [ feature( f4, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f1 , f3 ), excludes( f4 , f3 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(test_520,valid_configuration,configuration([f8,f4,f5,root,f7],[f6]),false).


% ---------------
spl_db( test_521,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_521,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_522,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(test_522,valid_configuration,configuration([root,f2,f3,f7],[]),true).


% ---------------
spl_db( test_523,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_523,valid_configuration,configuration([f4,root,f7,f2,f9,f5,f6,f3,f1],[]),true).


% ---------------
spl_db( test_524,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(test_524,valid_configuration,configuration([f2,f4,f1,f8,f5,f3,f9,f7,f6],[]),false).


% ---------------
spl_db( test_525,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f5 , f8 ), requires( f8 , f4 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_525,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_526,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f8 ), excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_526,valid_configuration,configuration([root,f2,f5],[]),true).


% ---------------
spl_db( test_527,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_527,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_528,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f5 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_528,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_529,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f5 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(test_529,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_530,
	 spl( [ root, f1, f2, f6, f3, f9, f4, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_530,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_531,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_531,valid_configuration,configuration([root,f1,f4,f5,f8,f9],[]),true).


% ---------------
spl_db( test_532,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_532,valid_configuration,configuration([root,f3,f4,f5,f7,f8],[]),true).


% ---------------
spl_db( test_533,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

test_data(test_533,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_534,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_534,valid_configuration,configuration([root,f1,f2,f5,f6,f7],[]),true).


% ---------------
spl_db( test_535,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f5 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_535,valid_configuration,configuration([root,f1,f3,f4,f6,f7,f8],[]),true).


% ---------------
spl_db( test_536,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f6 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(test_536,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_537,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f6 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(test_537,valid_configuration,configuration([root,f1,f2,f3,f6,f7,f8],[]),true).


% ---------------
spl_db( test_538,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_538,valid_configuration,configuration([root,f3,f5,f6],[]),true).


% ---------------
spl_db( test_539,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_539,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_540,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

test_data(test_540,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_541,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_541,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_542,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f7 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(test_542,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_543,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_543,valid_configuration,configuration([root,f1,f2,f3,f5,f6],[]),true).


% ---------------
spl_db( test_544,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_544,valid_configuration,configuration([root],[f3,f5,f7,f4,f1,f9,f2]),false).


% ---------------
spl_db( test_545,
	 spl( [ root, f1, f6, f7, f2, f3, f4, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(test_545,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_546,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(test_546,valid_configuration,configuration([root,f3],[]),true).


% ---------------
spl_db( test_547,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_547,valid_configuration,configuration([f5,f8,f2,root,f1,f9,f6,f3],[]),true).


% ---------------
spl_db( test_548,
	 spl( [ root, f1, f3, f6, f7, f9, f8, f2, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f9 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(test_548,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_549,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_549,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_550,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f3 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_550,valid_configuration,configuration([f9,f2,f3,f4,f7,f8,f6,f1,f5],[]),false).


% ---------------
spl_db( test_551,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(test_551,valid_configuration,configuration([f3,root],[f4,f5,f1]),false).


% ---------------
spl_db( test_552,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_552,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_553,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f9 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(test_553,valid_configuration,configuration([f7,f5,f4,f3,f1,root,f2],[f6,f9]),false).


% ---------------
spl_db( test_554,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f3 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_554,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_555,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_555,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_556,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f8 ), requires( f2 , f5 ) ]
		)
	)
).

test_data(test_556,valid_configuration,configuration([f1,f3,f9],[]),false).


% ---------------
spl_db( test_557,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_557,valid_configuration,configuration([],[f7,f3]),false).


% ---------------
spl_db( test_558,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f4 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_558,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_559,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_559,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_560,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_560,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_561,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_561,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_562,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f9 ), requires( f9 , f2 ) ]
		)
	)
).

test_data(test_562,valid_configuration,configuration([root,f1,f2,f3,f5,f8,f9],[]),true).


% ---------------
spl_db( test_563,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(test_563,valid_configuration,configuration([root,f1,f3,f5],[]),true).


% ---------------
spl_db( test_564,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(test_564,valid_configuration,configuration([root,f1,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_565,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f5 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(test_565,valid_configuration,configuration([f5,f3,f1,f4,f9,f2,root],[]),true).


% ---------------
spl_db( test_566,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_566,valid_configuration,configuration([root,f1,f3,f5,f7],[]),true).


% ---------------
spl_db( test_567,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f1 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_567,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_568,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f6 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_568,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_569,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f5, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f4 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(test_569,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_570,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

test_data(test_570,valid_configuration,configuration([root,f1,f3,f5,f6],[]),true).


% ---------------
spl_db( test_571,
	 spl( [ root, f1, f2, f4, f5, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_571,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_572,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f5, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				optional( feature( f5, [] ) ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_572,valid_configuration,configuration([root,f3],[]),true).


% ---------------
spl_db( test_573,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(test_573,valid_configuration,configuration([root,f3,f4,f5],[]),true).


% ---------------
spl_db( test_574,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_574,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_575,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f7 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_575,valid_configuration,configuration([root,f1,f3,f5,f6,f7,f8],[]),true).


% ---------------
spl_db( test_576,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_576,valid_configuration,configuration([root,f4,f7,f9],[]),true).


% ---------------
spl_db( test_577,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_577,valid_configuration,configuration([root,f1,f2,f4,f5,f7],[]),true).


% ---------------
spl_db( test_578,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

test_data(test_578,valid_configuration,configuration([],[f9,f7]),false).


% ---------------
spl_db( test_579,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_579,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_580,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(test_580,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_581,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(test_581,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_582,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f6 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(test_582,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_583,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f3 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_583,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_584,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f7, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f9 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(test_584,valid_configuration,configuration([root,f1,f3,f4,f5,f6,f8],[]),true).


% ---------------
spl_db( test_585,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_585,valid_configuration,configuration([f4,f3,f6,root,f2,f9,f7,f5],[f1]),false).


% ---------------
spl_db( test_586,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_586,valid_configuration,configuration([f2,f6,f8,f4,f5,f1,root,f3],[]),true).


% ---------------
spl_db( test_587,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f6, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_587,valid_configuration,configuration([root,f1,f2,f5],[]),true).


% ---------------
spl_db( test_588,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(test_588,valid_configuration,configuration([f9,f4,f5,f3,f7,f1,root,f2,f6],[]),false).


% ---------------
spl_db( test_589,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

test_data(test_589,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_590,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f8 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_590,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_591,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_591,valid_configuration,configuration([f5,f8],[]),true).


% ---------------
spl_db( test_592,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_592,valid_configuration,configuration([f5,f1,f9],[f8]),true).


% ---------------
spl_db( test_593,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f6 , f3 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_593,valid_configuration,configuration([root,f1,f6,f7],[]),true).


% ---------------
spl_db( test_594,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f3 ), excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_594,valid_configuration,configuration([root,f1,f2,f3,f7,f9],[]),true).


% ---------------
spl_db( test_595,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f8 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(test_595,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_596,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_596,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_597,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(test_597,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_598,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_598,valid_configuration,configuration([f4],[f9,f2,f8,f7]),false).


% ---------------
spl_db( test_599,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f5 ), excludes( f6 , f8 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_599,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_600,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(test_600,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_601,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f5 , f6 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(test_601,valid_configuration,configuration([f2,f9,f4,root,f3,f5,f1,f6],[f7]),false).


% ---------------
spl_db( test_602,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_602,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_603,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f2 , f8 ), excludes( f7 , f1 ) ]
		)
	)
).

test_data(test_603,valid_configuration,configuration([root,f2,f5],[]),true).


% ---------------
spl_db( test_604,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

test_data(test_604,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_605,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f6, [
							mandatory( feature( f7, [
								mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_605,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_606,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(test_606,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_607,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f5 , f6 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(test_607,valid_configuration,configuration([root,f6,f8,f1,f5,f4,f9,f7],[]),false).


% ---------------
spl_db( test_608,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(test_608,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_609,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f6 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_609,valid_configuration,configuration([root,f1,f2,f5,f7],[]),true).


% ---------------
spl_db( test_610,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_610,valid_configuration,configuration([root,f1,f3,f5,f7,f8,f9],[]),true).


% ---------------
spl_db( test_611,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_611,valid_configuration,configuration([f6,f9,f8,f1],[f2,f4]),true).


% ---------------
spl_db( test_612,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_612,valid_configuration,configuration([f8,f1,f4,f9],[f6]),false).


% ---------------
spl_db( test_613,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(test_613,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_614,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f7 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(test_614,valid_configuration,configuration([root,f4],[]),true).


% ---------------
spl_db( test_615,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_615,valid_configuration,configuration([f3,f7,f1,f6,f9,root,f8],[f4]),false).


% ---------------
spl_db( test_616,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(test_616,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_617,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_617,valid_configuration,configuration([f1,f4],[f8,f3,f9,root,f6,f2,f7]),false).


% ---------------
spl_db( test_618,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_618,valid_configuration,configuration([f9,f8],[f6,f2,root]),false).


% ---------------
spl_db( test_619,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(test_619,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_620,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_620,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_621,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ), requires( f1 , f5 ) ]
		)
	)
).

test_data(test_621,valid_configuration,configuration([root,f4,f1,f8,f3,f5],[f6]),false).


% ---------------
spl_db( test_622,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_622,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_623,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(test_623,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_624,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_624,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_625,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

test_data(test_625,valid_configuration,configuration([f2],[f8,f7,root]),false).


% ---------------
spl_db( test_626,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(test_626,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_627,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

test_data(test_627,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_628,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(test_628,valid_configuration,configuration([root,f1,f2,f3,f4,f6,f8,f9],[]),true).


% ---------------
spl_db( test_629,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_629,valid_configuration,configuration([root,f1,f2,f4,f5],[]),true).


% ---------------
spl_db( test_630,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f3 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_630,valid_configuration,configuration([f7],[root,f9,f5,f3,f2]),false).


% ---------------
spl_db( test_631,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(test_631,valid_configuration,configuration([f3,f7,f8],[f2,f9]),false).


% ---------------
spl_db( test_632,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f5 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(test_632,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_633,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f4, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f1 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(test_633,valid_configuration,configuration([f3,f8,f7,f9,f4,f6,f1,f5],[f2]),false).


% ---------------
spl_db( test_634,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f2 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(test_634,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_635,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f7 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(test_635,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_636,
	 spl( [ root, f1, f2, f8, f9, f3, f5, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(test_636,valid_configuration,configuration([root,f1,f4],[]),true).


% ---------------
spl_db( test_637,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f4, f5, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f6 , f1 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(test_637,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_638,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f8 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(test_638,valid_configuration,configuration([root,f2,f4],[]),true).


% ---------------
spl_db( test_639,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_639,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_640,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

test_data(test_640,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_641,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_641,valid_configuration,configuration([root,f1,f4],[]),true).


% ---------------
spl_db( test_642,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_642,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_643,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f3 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(test_643,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_644,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_644,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_645,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f1 ), requires( f1 , f8 ) ]
		)
	)
).

test_data(test_645,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_646,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f5 ), excludes( f2 , f8 ), excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_646,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_647,
	 spl( [ root, f1, f4, f8, f9, f5, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(test_647,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_648,
	 spl( [ root, f1, f6, f7, f2, f3, f4, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

test_data(test_648,valid_configuration,configuration([root,f1,f3,f4,f6],[]),true).


% ---------------
spl_db( test_649,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(test_649,valid_configuration,configuration([f5,f4,f2,f3,root],[]),false).


% ---------------
spl_db( test_650,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(test_650,valid_configuration,configuration([f7,f3],[f6]),false).


% ---------------
spl_db( test_651,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_651,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_652,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(test_652,valid_configuration,configuration([root,f4],[]),true).


% ---------------
spl_db( test_653,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_653,valid_configuration,configuration([],[f8]),true).


% ---------------
spl_db( test_654,
	 spl( [ root, f1, f2, f8, f9, f3, f7, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_654,valid_configuration,configuration([root,f2,f3,f6,f8,f9],[]),true).


% ---------------
spl_db( test_655,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f6 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_655,valid_configuration,configuration([root,f2,f3,f4,f5,f7,f8],[]),true).


% ---------------
spl_db( test_656,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(test_656,valid_configuration,configuration([f9,f6,f7,f4,f2,f1],[f8,f3]),false).


% ---------------
spl_db( test_657,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_657,valid_configuration,configuration([f5,f7,f2,f8],[]),false).


% ---------------
spl_db( test_658,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_658,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_659,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f9 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(test_659,valid_configuration,configuration([root,f2,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_660,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_660,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_661,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_661,valid_configuration,configuration([root,f1,f2,f5],[]),true).


% ---------------
spl_db( test_662,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(test_662,valid_configuration,configuration([f9,f8,f3,f2,f5],[]),true).


% ---------------
spl_db( test_663,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_663,valid_configuration,configuration([f2,f5,f4,f9,f1,f6,f3],[]),false).


% ---------------
spl_db( test_664,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_664,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_665,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f3 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_665,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_666,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(test_666,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_667,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_667,valid_configuration,configuration([root,f4,f6],[]),true).


% ---------------
spl_db( test_668,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(test_668,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_669,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_669,valid_configuration,configuration([root,f1,f2,f4,f6,f7],[]),true).


% ---------------
spl_db( test_670,
	 spl( [ root, f1, f5, f6, f8, f9, f2, f3, f7, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(test_670,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_671,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f8 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(test_671,valid_configuration,configuration([root,f4],[]),true).


% ---------------
spl_db( test_672,
	 spl( [ root, f1, f5, f8, f9, f2, f4, f3, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_672,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f7,f8,f9],[]),true).


% ---------------
spl_db( test_673,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_673,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_674,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f8 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_674,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_675,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(test_675,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_676,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_676,valid_configuration,configuration([root,f1,f2,f3,f6],[]),true).


% ---------------
spl_db( test_677,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(test_677,valid_configuration,configuration([root,f2,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_678,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_678,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_679,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f6 , f2 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(test_679,valid_configuration,configuration([root,f1,f2,f6],[]),true).


% ---------------
spl_db( test_680,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_680,valid_configuration,configuration([root,f3],[]),true).


% ---------------
spl_db( test_681,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_681,valid_configuration,configuration([root,f1,f2,f4,f5,f8,f9],[]),true).


% ---------------
spl_db( test_682,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(test_682,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_683,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f8 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_683,valid_configuration,configuration([root,f2,f3,f8,f7,f1,f9,f4,f6],[]),false).


% ---------------
spl_db( test_684,
	 spl( [ root, f1, f2, f4, f3, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(test_684,valid_configuration,configuration([root,f3,f5,f6],[]),true).


% ---------------
spl_db( test_685,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_685,valid_configuration,configuration([root,f1,f2,f4,f5,f6],[]),true).


% ---------------
spl_db( test_686,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f8 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(test_686,valid_configuration,configuration([f5,f3,root,f2],[f1]),false).


% ---------------
spl_db( test_687,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_687,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_688,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f2 , f4 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(test_688,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_689,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f2 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_689,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_690,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_690,valid_configuration,configuration([f3,f7,f6,f2,root],[f1,f9,f8,f4]),false).


% ---------------
spl_db( test_691,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(test_691,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_692,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_692,valid_configuration,configuration([root,f3,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_693,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f1 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_693,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_694,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_694,valid_configuration,configuration([root,f1,f2,f3,f5,f6],[]),true).


% ---------------
spl_db( test_695,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), requires( f1 , f8 ) ]
		)
	)
).

test_data(test_695,valid_configuration,configuration([f3,f8,f5,f7,f4,root,f9,f2,f6],[]),false).


% ---------------
spl_db( test_696,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_696,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_697,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f7 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_697,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_698,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(test_698,valid_configuration,configuration([f3,f4,f6,f7],[root,f9,f5,f1]),false).


% ---------------
spl_db( test_699,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f5 , f2 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(test_699,valid_configuration,configuration([root,f1,f2,f3,f7,f8],[]),true).


% ---------------
spl_db( test_700,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_700,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_701,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(test_701,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_702,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_702,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_703,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_703,valid_configuration,configuration([],[root,f6,f9,f5,f7]),false).


% ---------------
spl_db( test_704,
	 spl( [ root, f1, f3, f8, f4, f5, f6, f7, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f2 , f1 ), requires( f7 , f3 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(test_704,valid_configuration,configuration([f8,f7,root,f5,f3,f4,f2,f6],[f1]),false).


% ---------------
spl_db( test_705,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f4 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(test_705,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_706,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_706,valid_configuration,configuration([root,f1,f4,f5,f6],[]),true).


% ---------------
spl_db( test_707,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(test_707,valid_configuration,configuration([root,f1,f4,f5,f8],[]),true).


% ---------------
spl_db( test_708,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_708,valid_configuration,configuration([f6,f8,f4,f9,f7],[root]),false).


% ---------------
spl_db( test_709,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f3 , f4 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(test_709,valid_configuration,configuration([],[f6,f4,f9,f5,f1,root,f3]),false).


% ---------------
spl_db( test_710,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_710,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_711,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_711,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_712,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(test_712,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_713,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(test_713,valid_configuration,configuration([f6,root,f1],[f5,f7,f8,f3,f4]),false).


% ---------------
spl_db( test_714,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f3 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_714,valid_configuration,configuration([],[f6,f2]),false).


% ---------------
spl_db( test_715,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(test_715,valid_configuration,configuration([f6,f5,f1,root],[f8,f9,f2]),false).


% ---------------
spl_db( test_716,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f3 ), excludes( f9 , f1 ) ]
		)
	)
).

test_data(test_716,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_717,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(test_717,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_718,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_718,valid_configuration,configuration([f6,f8,f3,f4,root,f7],[]),true).


% ---------------
spl_db( test_719,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_719,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_720,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f1 ), requires( f6 , f1 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(test_720,valid_configuration,configuration([root,f1,f2,f3,f6,f8],[]),true).


% ---------------
spl_db( test_721,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_721,valid_configuration,configuration([root,f1,f4,f5,f6],[]),true).


% ---------------
spl_db( test_722,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_722,valid_configuration,configuration([root,f1,f2,f6,f7,f9],[]),true).


% ---------------
spl_db( test_723,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_723,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_724,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

test_data(test_724,valid_configuration,configuration([f8,f4,f1,f5,f3,f2,f6,f7,root],[]),true).


% ---------------
spl_db( test_725,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_725,valid_configuration,configuration([f7,f4,f1,f3,f5,root,f9],[f6]),false).


% ---------------
spl_db( test_726,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(test_726,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_727,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_727,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_728,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f8 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_728,valid_configuration,configuration([f7,f5,f8],[f6,f4,f3,f9,root,f2]),false).


% ---------------
spl_db( test_729,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(test_729,valid_configuration,configuration([root,f2,f3,f4],[]),true).


% ---------------
spl_db( test_730,
	 spl( [ root, f1, f3, f6, f8, f2, f4, f5, f7, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ), feature( f2, [
				optional( feature( f4, [
					optional( feature( f5, [
						mandatory( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_730,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_731,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_731,valid_configuration,configuration([f1,f5,f4,f2,f7,f9,f6,root],[f8]),true).


% ---------------
spl_db( test_732,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_732,valid_configuration,configuration([root,f6,f4,f5,f2,f9,f8],[f1,f7]),false).


% ---------------
spl_db( test_733,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(test_733,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_734,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_734,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_735,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_735,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_736,
	 spl( [ root, f1, f3, f9, f2, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(test_736,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_737,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_737,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_738,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f2 , f1 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_738,valid_configuration,configuration([root,f2,f3,f4],[]),true).


% ---------------
spl_db( test_739,
	 spl( [ root, f1, f8, f9, f2, f6, f7, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_739,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_740,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_740,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_741,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(test_741,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_742,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(test_742,valid_configuration,configuration([root,f2,f3,f4],[]),true).


% ---------------
spl_db( test_743,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f7 ), excludes( f4 , f5 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(test_743,valid_configuration,configuration([root,f1,f2,f3,f4,f6,f7],[]),true).


% ---------------
spl_db( test_744,
	 spl( [ root, f1, f7, f2, f3, f4, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f6 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(test_744,valid_configuration,configuration([root,f1,f2,f3,f5,f6],[]),true).


% ---------------
spl_db( test_745,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_745,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_746,
	 spl( [ root, f1, f2, f7, f8, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_746,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_747,
	 spl( [ root, f1, f4, f5, f6, f9, f2, f3, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f2 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_747,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_748,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f7 , f5 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(test_748,valid_configuration,configuration([root,f2,f5,f6],[]),true).


% ---------------
spl_db( test_749,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(test_749,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_750,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(test_750,valid_configuration,configuration([],[f1,f3,f9,f5,root]),false).


% ---------------
spl_db( test_751,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f2 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(test_751,valid_configuration,configuration([f9,f6],[f2,f3,f1,root,f7,f5]),false).


% ---------------
spl_db( test_752,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f5 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(test_752,valid_configuration,configuration([],[f4,f8,f6,f2,f5,f3,root]),false).


% ---------------
spl_db( test_753,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(test_753,valid_configuration,configuration([root,f1,f2,f3,f5,f7],[]),true).


% ---------------
spl_db( test_754,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(test_754,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_755,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_755,valid_configuration,configuration([f6,root,f4],[f9,f8,f2,f5,f7,f3]),false).


% ---------------
spl_db( test_756,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ requires( f6 , f5 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(test_756,valid_configuration,configuration([f9,f8,f2],[f3,f5,f6,f4,f7,f1]),false).


% ---------------
spl_db( test_757,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f6 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(test_757,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_758,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(test_758,valid_configuration,configuration([f3,f4,f8,f7,f1,f9,f6,root],[f5]),false).


% ---------------
spl_db( test_759,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_759,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_760,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_760,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_761,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(test_761,valid_configuration,configuration([root,f3,f5,f7,f9],[]),true).


% ---------------
spl_db( test_762,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_762,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_763,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_763,valid_configuration,configuration([f3,f9,f6],[f7]),true).


% ---------------
spl_db( test_764,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_764,valid_configuration,configuration([root,f2,f4,f5,f6],[]),true).


% ---------------
spl_db( test_765,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f3 ), requires( f5 , f3 ) ]
		)
	)
).

test_data(test_765,valid_configuration,configuration([f3,f4,f9,f6,f7,f8,f1,f5],[]),true).


% ---------------
spl_db( test_766,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_766,valid_configuration,configuration([f1,root,f6,f8,f2,f4,f7,f3],[]),false).


% ---------------
spl_db( test_767,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(test_767,valid_configuration,configuration([root,f1,f3,f4,f5,f7,f9],[]),true).


% ---------------
spl_db( test_768,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_768,valid_configuration,configuration([root,f1,f2,f3,f5,f6],[]),true).


% ---------------
spl_db( test_769,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f2 ), requires( f8 , f3 ) ]
		)
	)
).

test_data(test_769,valid_configuration,configuration([f2,f5],[]),true).


% ---------------
spl_db( test_770,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_770,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_771,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(test_771,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_772,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(test_772,valid_configuration,configuration([f3],[f2,f6,f9,f7,f1]),false).


% ---------------
spl_db( test_773,
	 spl( [ root, f1, f3, f9, f4, f2, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				only_one( [ feature( f3, [
					mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(test_773,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_774,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_774,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_775,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f9 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(test_775,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_776,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_776,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_777,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_777,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_778,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(test_778,valid_configuration,configuration([root,f1,f3,f4,f5,f7],[]),true).


% ---------------
spl_db( test_779,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_779,valid_configuration,configuration([root,f1,f2,f5],[]),true).


% ---------------
spl_db( test_780,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_780,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_781,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
				one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_781,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7],[]),true).


% ---------------
spl_db( test_782,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(test_782,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6,f8],[]),true).


% ---------------
spl_db( test_783,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f8 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(test_783,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_784,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(test_784,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_785,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_785,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_786,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_786,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_787,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_787,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_788,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_788,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_789,
	 spl( [ root, f1, f4, f5, f2, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(test_789,valid_configuration,configuration([f3,f1,f6],[f9,f7,f2,f8,f5,f4]),false).


% ---------------
spl_db( test_790,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f2, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ), feature( f2, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_790,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_791,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f6 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(test_791,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_792,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_792,valid_configuration,configuration([f1,f4,f9],[f2]),true).


% ---------------
spl_db( test_793,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f5, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
					optional( feature( f5, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f2 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(test_793,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_794,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_794,valid_configuration,configuration([root,f1,f3,f4,f7],[]),true).


% ---------------
spl_db( test_795,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(test_795,valid_configuration,configuration([root,f3,f5,f6,f7],[]),true).


% ---------------
spl_db( test_796,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(test_796,valid_configuration,configuration([f7,f2,f5,root],[]),true).


% ---------------
spl_db( test_797,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_797,valid_configuration,configuration([f4],[root,f5,f2,f3,f8,f7,f6]),false).


% ---------------
spl_db( test_798,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_798,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_799,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f6 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(test_799,valid_configuration,configuration([f3],[f1,root,f7,f6]),false).


% ---------------
spl_db( test_800,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f4 , f8 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(test_800,valid_configuration,configuration([root,f2,f3,f5],[]),true).


% ---------------
spl_db( test_801,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(test_801,valid_configuration,configuration([f2,f8,f1,f6,f7,root,f3,f4,f5],[]),false).


% ---------------
spl_db( test_802,
	 spl( [ root, f1, f4, f5, f7, f9, f6, f2, f3, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f6 , f8 ) ]
		)
	)
).

test_data(test_802,valid_configuration,configuration([f9,f4],[]),true).


% ---------------
spl_db( test_803,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(test_803,valid_configuration,configuration([root,f9,f6,f7,f8],[f5,f4,f2]),false).


% ---------------
spl_db( test_804,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_804,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_805,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_805,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_806,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(test_806,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_807,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_807,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_808,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f7 , f8 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_808,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_809,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f1 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_809,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_810,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f1 ) ]
		)
	)
).

test_data(test_810,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_811,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_811,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_812,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_812,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_813,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(test_813,valid_configuration,configuration([root,f1,f2,f3,f6,f7],[]),true).


% ---------------
spl_db( test_814,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_814,valid_configuration,configuration([root,f2,f3,f4],[]),true).


% ---------------
spl_db( test_815,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f5, [] ) ), mandatory( feature( f6, [
							mandatory( feature( f7, [
								optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(test_815,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_816,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

test_data(test_816,valid_configuration,configuration([f4,f3,f7,root,f9,f6],[]),false).


% ---------------
spl_db( test_817,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_817,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_818,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_818,valid_configuration,configuration([root,f1,f2,f3,f4],[]),true).


% ---------------
spl_db( test_819,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f4 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(test_819,valid_configuration,configuration([root,f1,f3,f6,f7,f8,f9],[]),true).


% ---------------
spl_db( test_820,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f8 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(test_820,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_821,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f5 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(test_821,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_822,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

test_data(test_822,valid_configuration,configuration([f3,f1,f9,f4],[f7]),true).


% ---------------
spl_db( test_823,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f4 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(test_823,valid_configuration,configuration([f6,f7,f9,root,f5,f3,f8],[f2]),false).


% ---------------
spl_db( test_824,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_824,valid_configuration,configuration([root,f1,f3,f4,f6],[]),true).


% ---------------
spl_db( test_825,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_825,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_826,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_826,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% ---------------
spl_db( test_827,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f2 , f6 ), requires( f4 , f7 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_827,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_828,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_828,valid_configuration,configuration([root,f1,f2,f4,f6],[]),true).


% ---------------
spl_db( test_829,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f4 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(test_829,valid_configuration,configuration([root,f1,f3,f6,f7,f9],[]),true).


% ---------------
spl_db( test_830,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_830,valid_configuration,configuration([f8,f6,f9,f4],[f5,root,f2,f1]),false).


% ---------------
spl_db( test_831,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f8 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(test_831,valid_configuration,configuration([f4,f1,f7,root,f3,f6],[]),false).


% ---------------
spl_db( test_832,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(test_832,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_833,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), requires( f8 , f9 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(test_833,valid_configuration,configuration([f3,f5],[f6]),false).


% ---------------
spl_db( test_834,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_834,valid_configuration,configuration([root,f1,f2,f4,f6,f7],[]),true).


% ---------------
spl_db( test_835,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(test_835,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_836,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f4 ), excludes( f4 , f5 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(test_836,valid_configuration,configuration([f7,f2,f4,f8,f5,f1,f6],[f9,f3]),false).


% ---------------
spl_db( test_837,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f7 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(test_837,valid_configuration,configuration([f2,f3,f7,f4,f6],[]),false).


% ---------------
spl_db( test_838,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(test_838,valid_configuration,configuration([f8,root],[]),true).


% ---------------
spl_db( test_839,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(test_839,valid_configuration,configuration([root,f1,f2,f4,f5,f7],[]),true).


% ---------------
spl_db( test_840,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_840,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_841,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_841,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_842,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_842,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_843,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_843,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_844,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_844,valid_configuration,configuration([f1,f5,f2,f8,f4,f3],[f9]),true).


% ---------------
spl_db( test_845,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_845,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_846,
	 spl( [ root, f1, f3, f4, f7, f8, f5, f6, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(test_846,valid_configuration,configuration([root,f1,f3,f4,f6,f7],[]),true).


% ---------------
spl_db( test_847,
	 spl( [ root, f1, f2, f7, f3, f6, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f4, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_847,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f6],[]),true).


% ---------------
spl_db( test_848,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(test_848,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_849,
	 spl( [ root, f1, f9, f2, f5, f3, f8, f4, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(test_849,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_850,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

test_data(test_850,valid_configuration,configuration([root,f1,f3,f4],[]),true).


% ---------------
spl_db( test_851,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_851,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_852,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_852,valid_configuration,configuration([root,f2,f3,f4],[]),true).


% ---------------
spl_db( test_853,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_853,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_854,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f1 ), excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_854,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_855,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(test_855,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_856,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_856,valid_configuration,configuration([root,f1,f3,f4,f6],[]),true).


% ---------------
spl_db( test_857,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_857,valid_configuration,configuration([f8,f3,f5,root,f2,f6],[]),false).


% ---------------
spl_db( test_858,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f5 , f2 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(test_858,valid_configuration,configuration([root,f1,f2,f3,f5,f6],[]),true).


% ---------------
spl_db( test_859,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
						optional( feature( f7, [
							mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f5 ), excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_859,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_860,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [
				optional( feature( f3, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(test_860,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_861,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f2 ) ]
		)
	)
).

test_data(test_861,valid_configuration,configuration([f9,f3,f4,f7,f2,f5,f1],[f8,f6]),false).


% ---------------
spl_db( test_862,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_862,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_863,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f4 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_863,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_864,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_864,valid_configuration,configuration([f8,f5,f3,f9,f4,f1,f7],[f2,root]),false).


% ---------------
spl_db( test_865,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f7 , f1 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(test_865,valid_configuration,configuration([f1,f9,f7,f4],[f8]),false).


% ---------------
spl_db( test_866,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_866,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_867,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_867,valid_configuration,configuration([f9],[f1,f6]),false).


% ---------------
spl_db( test_868,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_868,valid_configuration,configuration([],[f2,f8,f1,f4,f7,f5,f9]),true).


% ---------------
spl_db( test_869,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_869,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_870,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f7 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(test_870,valid_configuration,configuration([f6,f1,f4,f7,f3,root],[f5,f2,f8]),false).


% ---------------
spl_db( test_871,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f2 , f9 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(test_871,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_872,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_872,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_873,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(test_873,valid_configuration,configuration([root,f1,f2,f4,f5],[]),true).


% ---------------
spl_db( test_874,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_874,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_875,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f5 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_875,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_876,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_876,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_877,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(test_877,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_878,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_878,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_879,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_879,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_880,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f3 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_880,valid_configuration,configuration([root,f2,f4,f6],[]),true).


% ---------------
spl_db( test_881,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(test_881,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_882,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f2, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_882,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7],[]),true).


% ---------------
spl_db( test_883,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f3 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_883,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_884,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(test_884,valid_configuration,configuration([root,f1,f3,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_885,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_885,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_886,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f4 , f2 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(test_886,valid_configuration,configuration([root,f8,f2],[f9,f3,f5,f4]),false).


% ---------------
spl_db( test_887,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(test_887,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_888,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_888,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_889,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_889,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_890,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f4 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(test_890,valid_configuration,configuration([f3,f7,f5,f9,f6,root,f1],[f8,f4]),false).


% ---------------
spl_db( test_891,
	 spl( [ root, f1, f2, f6, f7, f3, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_891,valid_configuration,configuration([],[]),true).


% ---------------
spl_db( test_892,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_892,valid_configuration,configuration([root,f1,f2,f3,f4,f6],[]),true).


% ---------------
spl_db( test_893,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(test_893,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_894,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f4 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_894,valid_configuration,configuration([root,f1,f3,f4,f5],[]),true).


% ---------------
spl_db( test_895,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

test_data(test_895,valid_configuration,configuration([root,f1,f2,f3,f4,f7],[]),true).


% ---------------
spl_db( test_896,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_896,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_897,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_897,valid_configuration,configuration([root,f1,f3],[]),true).


% ---------------
spl_db( test_898,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f8 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(test_898,valid_configuration,configuration([f2,f7,f1,f6,f5],[f3,root,f8,f9]),false).


% ---------------
spl_db( test_899,
	 spl( [ root, f1, f8, f9, f2, f5, f3, f4, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f5, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(test_899,valid_configuration,configuration([f1,root,f5,f2,f8,f6,f7,f3],[]),true).


% ---------------
spl_db( test_900,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(test_900,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_901,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f9 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(test_901,valid_configuration,configuration([root,f1,f2,f3,f4,f7],[]),true).


% ---------------
spl_db( test_902,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(test_902,valid_configuration,configuration([f7,root,f8,f5,f4,f2],[f1,f6]),false).


% ---------------
spl_db( test_903,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_903,valid_configuration,configuration([f7,f1,f9,root,f5,f6,f2,f3],[]),true).


% ---------------
spl_db( test_904,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(test_904,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_905,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_905,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_906,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f6 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(test_906,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_907,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f5 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_907,valid_configuration,configuration([root,f3],[]),true).


% ---------------
spl_db( test_908,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(test_908,valid_configuration,configuration([f5,f6,f9,f7,f4,f3,root,f8,f1],[]),false).


% ---------------
spl_db( test_909,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

test_data(test_909,valid_configuration,configuration([f7,f8,f2,f5,f3,f9,f1],[f4]),false).


% ---------------
spl_db( test_910,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_910,valid_configuration,configuration([root,f3,f5,f6,f8,f9],[]),true).


% ---------------
spl_db( test_911,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f2 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_911,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_912,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_912,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_913,
	 spl( [ root, f1, f5, f6, f7, f2, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(test_913,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_914,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_914,valid_configuration,configuration([root,f2],[]),true).


% ---------------
spl_db( test_915,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_915,valid_configuration,configuration([root,f2,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_916,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

test_data(test_916,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_917,
	 spl( [ root, f1, f2, f5, f6, f8, f9, f3, f7, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_917,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_918,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(test_918,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_919,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(test_919,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_920,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f3 ), requires( f8 , f1 ) ]
		)
	)
).

test_data(test_920,valid_configuration,configuration([f1,f2,f8,f4,f3],[root,f9,f6,f7]),false).


% ---------------
spl_db( test_921,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(test_921,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_922,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f1 ), requires( f5 , f1 ) ]
		)
	)
).

test_data(test_922,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_923,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_923,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_924,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_924,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_925,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(test_925,valid_configuration,configuration([root,f3],[]),true).


% ---------------
spl_db( test_926,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_926,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_927,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

test_data(test_927,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_928,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f9 , f2 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(test_928,valid_configuration,configuration([root,f1,f4,f5,f7,f9],[]),true).


% ---------------
spl_db( test_929,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

test_data(test_929,valid_configuration,configuration([f2,f7,f6,f8,root,f5,f9,f4,f1],[]),false).


% ---------------
spl_db( test_930,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ), excludes( f7 , f4 ) ]
		)
	)
).

test_data(test_930,valid_configuration,configuration([root,f1,f3,f5,f6,f7,f9],[]),true).


% ---------------
spl_db( test_931,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_931,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_932,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

test_data(test_932,valid_configuration,configuration([f4,f5,f7,f2,f3,f6,f9,root],[f1]),false).


% ---------------
spl_db( test_933,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(test_933,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_934,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_934,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_935,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(test_935,valid_configuration,configuration([f6,f2],[f7,f3,root,f9,f8,f5,f1]),false).


% ---------------
spl_db( test_936,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

test_data(test_936,valid_configuration,configuration([f7,f8],[]),false).


% ---------------
spl_db( test_937,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f6 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(test_937,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_938,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(test_938,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_939,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_939,valid_configuration,configuration([root,f5],[]),true).


% ---------------
spl_db( test_940,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f9 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(test_940,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_941,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f7 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(test_941,valid_configuration,configuration([f3],[f5]),false).


% ---------------
spl_db( test_942,
	 spl( [ root, f1, f4, f2, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f1 , f3 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(test_942,valid_configuration,configuration([root],[f9,f7,f1,f6]),true).


% ---------------
spl_db( test_943,
	 spl( [ root, f1, f4, f5, f6, f8, f9, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f3 ), requires( f2 , f4 ) ]
		)
	)
).

test_data(test_943,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7],[]),true).


% ---------------
spl_db( test_944,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_944,valid_configuration,configuration([root,f5,f7,f8],[]),true).


% ---------------
spl_db( test_945,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f2 , f7 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(test_945,valid_configuration,configuration([root,f1,f2,f4,f5,f8,f9],[]),true).


% ---------------
spl_db( test_946,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f7 , f5 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(test_946,valid_configuration,configuration([root,f1,f2,f3,f4,f5],[]),true).


% ---------------
spl_db( test_947,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_947,valid_configuration,configuration([root,f2,f3,f4],[]),true).


% ---------------
spl_db( test_948,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f6 , f5 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(test_948,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_949,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(test_949,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_950,
	 spl( [ root, f1, f7, f2, f3, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f1 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(test_950,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_951,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_951,valid_configuration,configuration([root,f1,f3,f4,f5,f6,f8],[]),true).


% ---------------
spl_db( test_952,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f2 ), requires( f9 , f5 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(test_952,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_953,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
						optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(test_953,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_954,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_954,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_955,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(test_955,valid_configuration,configuration([f4,f1,f3,f2],[]),true).


% ---------------
spl_db( test_956,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f4 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(test_956,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_957,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(test_957,valid_configuration,configuration([root,f1,f2,f4,f5,f6,f7,f8],[]),true).


% ---------------
spl_db( test_958,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(test_958,valid_configuration,configuration([root,f1,f3,f4,f8],[]),true).


% ---------------
spl_db( test_959,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [
						mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(test_959,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_960,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(test_960,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_961,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f5 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(test_961,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_962,
	 spl( [ root, f1, f5, f6, f8, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_962,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_963,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f6 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(test_963,valid_configuration,configuration([f2,f7,f8],[f4,f1,root,f5,f9]),false).


% ---------------
spl_db( test_964,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(test_964,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_965,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f2 ) ]
		)
	)
).

test_data(test_965,valid_configuration,configuration([root,f2,f3],[]),true).


% ---------------
spl_db( test_966,
	 spl( [ root, f1, f2, f4, f5, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ) ] ) ) ] ), feature( f3, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_966,valid_configuration,configuration([root,f2,f4],[]),true).


% ---------------
spl_db( test_967,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f7, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_967,valid_configuration,configuration([root,f1,f2,f3,f4,f5,f7,f9],[]),true).


% ---------------
spl_db( test_968,
	 spl( [ root, f1, f3, f4, f5, f7, f6, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f7, [] ) ) ] ) ), optional( feature( f6, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f7 , f8 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(test_968,valid_configuration,configuration([root,f1,f3,f4,f5],[]),true).


% ---------------
spl_db( test_969,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(test_969,valid_configuration,configuration([root,f2,f3,f4,f5,f8],[]),true).


% ---------------
spl_db( test_970,
	 spl( [ root, f1, f2, f7, f3, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_970,valid_configuration,configuration([f2,root,f7,f9,f4,f5,f8,f6,f1],[]),false).


% ---------------
spl_db( test_971,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f7, [] ) ) ] ), feature( f6, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f7 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(test_971,valid_configuration,configuration([f8,root],[f5,f2,f9,f7,f4,f6,f3]),false).


% ---------------
spl_db( test_972,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_972,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_973,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_973,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_974,
	 spl( [ root, f1, f2, f4, f5, f6, f8, f7, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(test_974,valid_configuration,configuration([f1,root,f9],[f2]),false).


% ---------------
spl_db( test_975,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_975,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_976,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(test_976,valid_configuration,configuration([f7,f8,f1],[]),false).


% ---------------
spl_db( test_977,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ), feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(test_977,valid_configuration,configuration([f8],[f9,f1,f3]),false).


% ---------------
spl_db( test_978,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_978,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_979,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(test_979,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_980,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f6, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f6 ), excludes( f1 , f3 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(test_980,valid_configuration,configuration([root,f2,f4,f5,f6],[]),true).


% ---------------
spl_db( test_981,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_981,valid_configuration,configuration([root,f5,f8],[]),true).


% ---------------
spl_db( test_982,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f5 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(test_982,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_983,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(test_983,valid_configuration,configuration([root,f1,f4,f9],[]),true).


% ---------------
spl_db( test_984,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(test_984,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_985,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(test_985,valid_configuration,configuration([root,f1,f2,f3,f5],[]),true).


% ---------------
spl_db( test_986,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(test_986,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_987,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_987,valid_configuration,configuration([root,f1,f2,f4,f5,f6],[]),true).


% ---------------
spl_db( test_988,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_988,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_989,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(test_989,valid_configuration,configuration([root,f1,f2,f7,f8,f9],[]),true).


% ---------------
spl_db( test_990,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_990,valid_configuration,configuration([root,f1,f2,f6],[]),true).


% ---------------
spl_db( test_991,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_991,valid_configuration,configuration([root,f1,f2,f6,f9],[]),true).


% ---------------
spl_db( test_992,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(test_992,valid_configuration,configuration([root,f1],[]),true).


% ---------------
spl_db( test_993,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(test_993,valid_configuration,configuration([root],[]),true).


% ---------------
spl_db( test_994,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f9 ) ]
		)
	)
).

test_data(test_994,valid_configuration,configuration([root,f1,f3,f4,f5,f9],[]),true).


% ---------------
spl_db( test_995,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(test_995,valid_configuration,configuration([root,f1,f2],[]),true).


% ---------------
spl_db( test_996,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f3 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(test_996,valid_configuration,configuration([f2,f3,f9,f4],[]),false).


% ---------------
spl_db( test_997,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(test_997,valid_configuration,configuration([f4,f5],[root,f3,f2,f9,f1]),false).


% ---------------
spl_db( test_998,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(test_998,valid_configuration,configuration([root,f1,f2,f3],[]),true).


% ---------------
spl_db( test_999,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f2 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(test_999,valid_configuration,configuration([root,f1,f2,f4],[]),true).


% --------------- Test cases % ---------------
:- begin_tests(valid_configuration).

test(valid_configuration0) :-
	spl_db( test_0, Spl ),
	test_data( test_0, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration1) :-
	spl_db( test_1, Spl ),
	test_data( test_1, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration2) :-
	spl_db( test_2, Spl ),
	test_data( test_2, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration3) :-
	spl_db( test_3, Spl ),
	test_data( test_3, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration4) :-
	spl_db( test_4, Spl ),
	test_data( test_4, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration5) :-
	spl_db( test_5, Spl ),
	test_data( test_5, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration6) :-
	spl_db( test_6, Spl ),
	test_data( test_6, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration7) :-
	spl_db( test_7, Spl ),
	test_data( test_7, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration8) :-
	spl_db( test_8, Spl ),
	test_data( test_8, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration9) :-
	spl_db( test_9, Spl ),
	test_data( test_9, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration10) :-
	spl_db( test_10, Spl ),
	test_data( test_10, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration11) :-
	spl_db( test_11, Spl ),
	test_data( test_11, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration12) :-
	spl_db( test_12, Spl ),
	test_data( test_12, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration13) :-
	spl_db( test_13, Spl ),
	test_data( test_13, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration14) :-
	spl_db( test_14, Spl ),
	test_data( test_14, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration15) :-
	spl_db( test_15, Spl ),
	test_data( test_15, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration16) :-
	spl_db( test_16, Spl ),
	test_data( test_16, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration17) :-
	spl_db( test_17, Spl ),
	test_data( test_17, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration18) :-
	spl_db( test_18, Spl ),
	test_data( test_18, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration19) :-
	spl_db( test_19, Spl ),
	test_data( test_19, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration20) :-
	spl_db( test_20, Spl ),
	test_data( test_20, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration21) :-
	spl_db( test_21, Spl ),
	test_data( test_21, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration22) :-
	spl_db( test_22, Spl ),
	test_data( test_22, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration23) :-
	spl_db( test_23, Spl ),
	test_data( test_23, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration24) :-
	spl_db( test_24, Spl ),
	test_data( test_24, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration25) :-
	spl_db( test_25, Spl ),
	test_data( test_25, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration26) :-
	spl_db( test_26, Spl ),
	test_data( test_26, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration27) :-
	spl_db( test_27, Spl ),
	test_data( test_27, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration28) :-
	spl_db( test_28, Spl ),
	test_data( test_28, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration29) :-
	spl_db( test_29, Spl ),
	test_data( test_29, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration30) :-
	spl_db( test_30, Spl ),
	test_data( test_30, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration31) :-
	spl_db( test_31, Spl ),
	test_data( test_31, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration32) :-
	spl_db( test_32, Spl ),
	test_data( test_32, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration33) :-
	spl_db( test_33, Spl ),
	test_data( test_33, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration34) :-
	spl_db( test_34, Spl ),
	test_data( test_34, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration35) :-
	spl_db( test_35, Spl ),
	test_data( test_35, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration36) :-
	spl_db( test_36, Spl ),
	test_data( test_36, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration37) :-
	spl_db( test_37, Spl ),
	test_data( test_37, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration38) :-
	spl_db( test_38, Spl ),
	test_data( test_38, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration39) :-
	spl_db( test_39, Spl ),
	test_data( test_39, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration40) :-
	spl_db( test_40, Spl ),
	test_data( test_40, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration41) :-
	spl_db( test_41, Spl ),
	test_data( test_41, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration42) :-
	spl_db( test_42, Spl ),
	test_data( test_42, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration43) :-
	spl_db( test_43, Spl ),
	test_data( test_43, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration44) :-
	spl_db( test_44, Spl ),
	test_data( test_44, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration45) :-
	spl_db( test_45, Spl ),
	test_data( test_45, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration46) :-
	spl_db( test_46, Spl ),
	test_data( test_46, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration47) :-
	spl_db( test_47, Spl ),
	test_data( test_47, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration48) :-
	spl_db( test_48, Spl ),
	test_data( test_48, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration49) :-
	spl_db( test_49, Spl ),
	test_data( test_49, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration50) :-
	spl_db( test_50, Spl ),
	test_data( test_50, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration51) :-
	spl_db( test_51, Spl ),
	test_data( test_51, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration52) :-
	spl_db( test_52, Spl ),
	test_data( test_52, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration53) :-
	spl_db( test_53, Spl ),
	test_data( test_53, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration54) :-
	spl_db( test_54, Spl ),
	test_data( test_54, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration55) :-
	spl_db( test_55, Spl ),
	test_data( test_55, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration56) :-
	spl_db( test_56, Spl ),
	test_data( test_56, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration57) :-
	spl_db( test_57, Spl ),
	test_data( test_57, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration58) :-
	spl_db( test_58, Spl ),
	test_data( test_58, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration59) :-
	spl_db( test_59, Spl ),
	test_data( test_59, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration60) :-
	spl_db( test_60, Spl ),
	test_data( test_60, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration61) :-
	spl_db( test_61, Spl ),
	test_data( test_61, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration62) :-
	spl_db( test_62, Spl ),
	test_data( test_62, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration63) :-
	spl_db( test_63, Spl ),
	test_data( test_63, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration64) :-
	spl_db( test_64, Spl ),
	test_data( test_64, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration65) :-
	spl_db( test_65, Spl ),
	test_data( test_65, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration66) :-
	spl_db( test_66, Spl ),
	test_data( test_66, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration67) :-
	spl_db( test_67, Spl ),
	test_data( test_67, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration68) :-
	spl_db( test_68, Spl ),
	test_data( test_68, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration69) :-
	spl_db( test_69, Spl ),
	test_data( test_69, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration70) :-
	spl_db( test_70, Spl ),
	test_data( test_70, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration71) :-
	spl_db( test_71, Spl ),
	test_data( test_71, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration72) :-
	spl_db( test_72, Spl ),
	test_data( test_72, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration73) :-
	spl_db( test_73, Spl ),
	test_data( test_73, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration74) :-
	spl_db( test_74, Spl ),
	test_data( test_74, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration75) :-
	spl_db( test_75, Spl ),
	test_data( test_75, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration76) :-
	spl_db( test_76, Spl ),
	test_data( test_76, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration77) :-
	spl_db( test_77, Spl ),
	test_data( test_77, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration78) :-
	spl_db( test_78, Spl ),
	test_data( test_78, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration79) :-
	spl_db( test_79, Spl ),
	test_data( test_79, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration80) :-
	spl_db( test_80, Spl ),
	test_data( test_80, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration81) :-
	spl_db( test_81, Spl ),
	test_data( test_81, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration82) :-
	spl_db( test_82, Spl ),
	test_data( test_82, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration83) :-
	spl_db( test_83, Spl ),
	test_data( test_83, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration84) :-
	spl_db( test_84, Spl ),
	test_data( test_84, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration85) :-
	spl_db( test_85, Spl ),
	test_data( test_85, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration86) :-
	spl_db( test_86, Spl ),
	test_data( test_86, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration87) :-
	spl_db( test_87, Spl ),
	test_data( test_87, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration88) :-
	spl_db( test_88, Spl ),
	test_data( test_88, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration89) :-
	spl_db( test_89, Spl ),
	test_data( test_89, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration90) :-
	spl_db( test_90, Spl ),
	test_data( test_90, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration91) :-
	spl_db( test_91, Spl ),
	test_data( test_91, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration92) :-
	spl_db( test_92, Spl ),
	test_data( test_92, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration93) :-
	spl_db( test_93, Spl ),
	test_data( test_93, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration94) :-
	spl_db( test_94, Spl ),
	test_data( test_94, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration95) :-
	spl_db( test_95, Spl ),
	test_data( test_95, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration96) :-
	spl_db( test_96, Spl ),
	test_data( test_96, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration97) :-
	spl_db( test_97, Spl ),
	test_data( test_97, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration98) :-
	spl_db( test_98, Spl ),
	test_data( test_98, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration99) :-
	spl_db( test_99, Spl ),
	test_data( test_99, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration100) :-
	spl_db( test_100, Spl ),
	test_data( test_100, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration101) :-
	spl_db( test_101, Spl ),
	test_data( test_101, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration102) :-
	spl_db( test_102, Spl ),
	test_data( test_102, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration103) :-
	spl_db( test_103, Spl ),
	test_data( test_103, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration104) :-
	spl_db( test_104, Spl ),
	test_data( test_104, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration105) :-
	spl_db( test_105, Spl ),
	test_data( test_105, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration106) :-
	spl_db( test_106, Spl ),
	test_data( test_106, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration107) :-
	spl_db( test_107, Spl ),
	test_data( test_107, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration108) :-
	spl_db( test_108, Spl ),
	test_data( test_108, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration109) :-
	spl_db( test_109, Spl ),
	test_data( test_109, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration110) :-
	spl_db( test_110, Spl ),
	test_data( test_110, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration111) :-
	spl_db( test_111, Spl ),
	test_data( test_111, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration112) :-
	spl_db( test_112, Spl ),
	test_data( test_112, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration113) :-
	spl_db( test_113, Spl ),
	test_data( test_113, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration114) :-
	spl_db( test_114, Spl ),
	test_data( test_114, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration115) :-
	spl_db( test_115, Spl ),
	test_data( test_115, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration116) :-
	spl_db( test_116, Spl ),
	test_data( test_116, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration117) :-
	spl_db( test_117, Spl ),
	test_data( test_117, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration118) :-
	spl_db( test_118, Spl ),
	test_data( test_118, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration119) :-
	spl_db( test_119, Spl ),
	test_data( test_119, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration120) :-
	spl_db( test_120, Spl ),
	test_data( test_120, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration121) :-
	spl_db( test_121, Spl ),
	test_data( test_121, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration122) :-
	spl_db( test_122, Spl ),
	test_data( test_122, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration123) :-
	spl_db( test_123, Spl ),
	test_data( test_123, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration124) :-
	spl_db( test_124, Spl ),
	test_data( test_124, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration125) :-
	spl_db( test_125, Spl ),
	test_data( test_125, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration126) :-
	spl_db( test_126, Spl ),
	test_data( test_126, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration127) :-
	spl_db( test_127, Spl ),
	test_data( test_127, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration128) :-
	spl_db( test_128, Spl ),
	test_data( test_128, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration129) :-
	spl_db( test_129, Spl ),
	test_data( test_129, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration130) :-
	spl_db( test_130, Spl ),
	test_data( test_130, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration131) :-
	spl_db( test_131, Spl ),
	test_data( test_131, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration132) :-
	spl_db( test_132, Spl ),
	test_data( test_132, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration133) :-
	spl_db( test_133, Spl ),
	test_data( test_133, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration134) :-
	spl_db( test_134, Spl ),
	test_data( test_134, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration135) :-
	spl_db( test_135, Spl ),
	test_data( test_135, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration136) :-
	spl_db( test_136, Spl ),
	test_data( test_136, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration137) :-
	spl_db( test_137, Spl ),
	test_data( test_137, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration138) :-
	spl_db( test_138, Spl ),
	test_data( test_138, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration139) :-
	spl_db( test_139, Spl ),
	test_data( test_139, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration140) :-
	spl_db( test_140, Spl ),
	test_data( test_140, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration141) :-
	spl_db( test_141, Spl ),
	test_data( test_141, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration142) :-
	spl_db( test_142, Spl ),
	test_data( test_142, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration143) :-
	spl_db( test_143, Spl ),
	test_data( test_143, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration144) :-
	spl_db( test_144, Spl ),
	test_data( test_144, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration145) :-
	spl_db( test_145, Spl ),
	test_data( test_145, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration146) :-
	spl_db( test_146, Spl ),
	test_data( test_146, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration147) :-
	spl_db( test_147, Spl ),
	test_data( test_147, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration148) :-
	spl_db( test_148, Spl ),
	test_data( test_148, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration149) :-
	spl_db( test_149, Spl ),
	test_data( test_149, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration150) :-
	spl_db( test_150, Spl ),
	test_data( test_150, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration151) :-
	spl_db( test_151, Spl ),
	test_data( test_151, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration152) :-
	spl_db( test_152, Spl ),
	test_data( test_152, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration153) :-
	spl_db( test_153, Spl ),
	test_data( test_153, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration154) :-
	spl_db( test_154, Spl ),
	test_data( test_154, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration155) :-
	spl_db( test_155, Spl ),
	test_data( test_155, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration156) :-
	spl_db( test_156, Spl ),
	test_data( test_156, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration157) :-
	spl_db( test_157, Spl ),
	test_data( test_157, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration158) :-
	spl_db( test_158, Spl ),
	test_data( test_158, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration159) :-
	spl_db( test_159, Spl ),
	test_data( test_159, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration160) :-
	spl_db( test_160, Spl ),
	test_data( test_160, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration161) :-
	spl_db( test_161, Spl ),
	test_data( test_161, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration162) :-
	spl_db( test_162, Spl ),
	test_data( test_162, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration163) :-
	spl_db( test_163, Spl ),
	test_data( test_163, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration164) :-
	spl_db( test_164, Spl ),
	test_data( test_164, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration165) :-
	spl_db( test_165, Spl ),
	test_data( test_165, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration166) :-
	spl_db( test_166, Spl ),
	test_data( test_166, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration167) :-
	spl_db( test_167, Spl ),
	test_data( test_167, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration168) :-
	spl_db( test_168, Spl ),
	test_data( test_168, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration169) :-
	spl_db( test_169, Spl ),
	test_data( test_169, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration170) :-
	spl_db( test_170, Spl ),
	test_data( test_170, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration171) :-
	spl_db( test_171, Spl ),
	test_data( test_171, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration172) :-
	spl_db( test_172, Spl ),
	test_data( test_172, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration173) :-
	spl_db( test_173, Spl ),
	test_data( test_173, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration174) :-
	spl_db( test_174, Spl ),
	test_data( test_174, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration175) :-
	spl_db( test_175, Spl ),
	test_data( test_175, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration176) :-
	spl_db( test_176, Spl ),
	test_data( test_176, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration177) :-
	spl_db( test_177, Spl ),
	test_data( test_177, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration178) :-
	spl_db( test_178, Spl ),
	test_data( test_178, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration179) :-
	spl_db( test_179, Spl ),
	test_data( test_179, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration180) :-
	spl_db( test_180, Spl ),
	test_data( test_180, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration181) :-
	spl_db( test_181, Spl ),
	test_data( test_181, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration182) :-
	spl_db( test_182, Spl ),
	test_data( test_182, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration183) :-
	spl_db( test_183, Spl ),
	test_data( test_183, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration184) :-
	spl_db( test_184, Spl ),
	test_data( test_184, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration185) :-
	spl_db( test_185, Spl ),
	test_data( test_185, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration186) :-
	spl_db( test_186, Spl ),
	test_data( test_186, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration187) :-
	spl_db( test_187, Spl ),
	test_data( test_187, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration188) :-
	spl_db( test_188, Spl ),
	test_data( test_188, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration189) :-
	spl_db( test_189, Spl ),
	test_data( test_189, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration190) :-
	spl_db( test_190, Spl ),
	test_data( test_190, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration191) :-
	spl_db( test_191, Spl ),
	test_data( test_191, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration192) :-
	spl_db( test_192, Spl ),
	test_data( test_192, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration193) :-
	spl_db( test_193, Spl ),
	test_data( test_193, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration194) :-
	spl_db( test_194, Spl ),
	test_data( test_194, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration195) :-
	spl_db( test_195, Spl ),
	test_data( test_195, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration196) :-
	spl_db( test_196, Spl ),
	test_data( test_196, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration197) :-
	spl_db( test_197, Spl ),
	test_data( test_197, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration198) :-
	spl_db( test_198, Spl ),
	test_data( test_198, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration199) :-
	spl_db( test_199, Spl ),
	test_data( test_199, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration200) :-
	spl_db( test_200, Spl ),
	test_data( test_200, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration201) :-
	spl_db( test_201, Spl ),
	test_data( test_201, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration202) :-
	spl_db( test_202, Spl ),
	test_data( test_202, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration203) :-
	spl_db( test_203, Spl ),
	test_data( test_203, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration204) :-
	spl_db( test_204, Spl ),
	test_data( test_204, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration205) :-
	spl_db( test_205, Spl ),
	test_data( test_205, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration206) :-
	spl_db( test_206, Spl ),
	test_data( test_206, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration207) :-
	spl_db( test_207, Spl ),
	test_data( test_207, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration208) :-
	spl_db( test_208, Spl ),
	test_data( test_208, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration209) :-
	spl_db( test_209, Spl ),
	test_data( test_209, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration210) :-
	spl_db( test_210, Spl ),
	test_data( test_210, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration211) :-
	spl_db( test_211, Spl ),
	test_data( test_211, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration212) :-
	spl_db( test_212, Spl ),
	test_data( test_212, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration213) :-
	spl_db( test_213, Spl ),
	test_data( test_213, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration214) :-
	spl_db( test_214, Spl ),
	test_data( test_214, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration215) :-
	spl_db( test_215, Spl ),
	test_data( test_215, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration216) :-
	spl_db( test_216, Spl ),
	test_data( test_216, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration217) :-
	spl_db( test_217, Spl ),
	test_data( test_217, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration218) :-
	spl_db( test_218, Spl ),
	test_data( test_218, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration219) :-
	spl_db( test_219, Spl ),
	test_data( test_219, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration220) :-
	spl_db( test_220, Spl ),
	test_data( test_220, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration221) :-
	spl_db( test_221, Spl ),
	test_data( test_221, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration222) :-
	spl_db( test_222, Spl ),
	test_data( test_222, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration223) :-
	spl_db( test_223, Spl ),
	test_data( test_223, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration224) :-
	spl_db( test_224, Spl ),
	test_data( test_224, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration225) :-
	spl_db( test_225, Spl ),
	test_data( test_225, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration226) :-
	spl_db( test_226, Spl ),
	test_data( test_226, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration227) :-
	spl_db( test_227, Spl ),
	test_data( test_227, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration228) :-
	spl_db( test_228, Spl ),
	test_data( test_228, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration229) :-
	spl_db( test_229, Spl ),
	test_data( test_229, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration230) :-
	spl_db( test_230, Spl ),
	test_data( test_230, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration231) :-
	spl_db( test_231, Spl ),
	test_data( test_231, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration232) :-
	spl_db( test_232, Spl ),
	test_data( test_232, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration233) :-
	spl_db( test_233, Spl ),
	test_data( test_233, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration234) :-
	spl_db( test_234, Spl ),
	test_data( test_234, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration235) :-
	spl_db( test_235, Spl ),
	test_data( test_235, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration236) :-
	spl_db( test_236, Spl ),
	test_data( test_236, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration237) :-
	spl_db( test_237, Spl ),
	test_data( test_237, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration238) :-
	spl_db( test_238, Spl ),
	test_data( test_238, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration239) :-
	spl_db( test_239, Spl ),
	test_data( test_239, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration240) :-
	spl_db( test_240, Spl ),
	test_data( test_240, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration241) :-
	spl_db( test_241, Spl ),
	test_data( test_241, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration242) :-
	spl_db( test_242, Spl ),
	test_data( test_242, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration243) :-
	spl_db( test_243, Spl ),
	test_data( test_243, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration244) :-
	spl_db( test_244, Spl ),
	test_data( test_244, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration245) :-
	spl_db( test_245, Spl ),
	test_data( test_245, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration246) :-
	spl_db( test_246, Spl ),
	test_data( test_246, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration247) :-
	spl_db( test_247, Spl ),
	test_data( test_247, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration248) :-
	spl_db( test_248, Spl ),
	test_data( test_248, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration249) :-
	spl_db( test_249, Spl ),
	test_data( test_249, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration250) :-
	spl_db( test_250, Spl ),
	test_data( test_250, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration251) :-
	spl_db( test_251, Spl ),
	test_data( test_251, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration252) :-
	spl_db( test_252, Spl ),
	test_data( test_252, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration253) :-
	spl_db( test_253, Spl ),
	test_data( test_253, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration254) :-
	spl_db( test_254, Spl ),
	test_data( test_254, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration255) :-
	spl_db( test_255, Spl ),
	test_data( test_255, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration256) :-
	spl_db( test_256, Spl ),
	test_data( test_256, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration257) :-
	spl_db( test_257, Spl ),
	test_data( test_257, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration258) :-
	spl_db( test_258, Spl ),
	test_data( test_258, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration259) :-
	spl_db( test_259, Spl ),
	test_data( test_259, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration260) :-
	spl_db( test_260, Spl ),
	test_data( test_260, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration261) :-
	spl_db( test_261, Spl ),
	test_data( test_261, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration262) :-
	spl_db( test_262, Spl ),
	test_data( test_262, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration263) :-
	spl_db( test_263, Spl ),
	test_data( test_263, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration264) :-
	spl_db( test_264, Spl ),
	test_data( test_264, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration265) :-
	spl_db( test_265, Spl ),
	test_data( test_265, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration266) :-
	spl_db( test_266, Spl ),
	test_data( test_266, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration267) :-
	spl_db( test_267, Spl ),
	test_data( test_267, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration268) :-
	spl_db( test_268, Spl ),
	test_data( test_268, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration269) :-
	spl_db( test_269, Spl ),
	test_data( test_269, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration270) :-
	spl_db( test_270, Spl ),
	test_data( test_270, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration271) :-
	spl_db( test_271, Spl ),
	test_data( test_271, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration272) :-
	spl_db( test_272, Spl ),
	test_data( test_272, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration273) :-
	spl_db( test_273, Spl ),
	test_data( test_273, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration274) :-
	spl_db( test_274, Spl ),
	test_data( test_274, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration275) :-
	spl_db( test_275, Spl ),
	test_data( test_275, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration276) :-
	spl_db( test_276, Spl ),
	test_data( test_276, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration277) :-
	spl_db( test_277, Spl ),
	test_data( test_277, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration278) :-
	spl_db( test_278, Spl ),
	test_data( test_278, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration279) :-
	spl_db( test_279, Spl ),
	test_data( test_279, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration280) :-
	spl_db( test_280, Spl ),
	test_data( test_280, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration281) :-
	spl_db( test_281, Spl ),
	test_data( test_281, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration282) :-
	spl_db( test_282, Spl ),
	test_data( test_282, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration283) :-
	spl_db( test_283, Spl ),
	test_data( test_283, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration284) :-
	spl_db( test_284, Spl ),
	test_data( test_284, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration285) :-
	spl_db( test_285, Spl ),
	test_data( test_285, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration286) :-
	spl_db( test_286, Spl ),
	test_data( test_286, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration287) :-
	spl_db( test_287, Spl ),
	test_data( test_287, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration288) :-
	spl_db( test_288, Spl ),
	test_data( test_288, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration289) :-
	spl_db( test_289, Spl ),
	test_data( test_289, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration290) :-
	spl_db( test_290, Spl ),
	test_data( test_290, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration291) :-
	spl_db( test_291, Spl ),
	test_data( test_291, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration292) :-
	spl_db( test_292, Spl ),
	test_data( test_292, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration293) :-
	spl_db( test_293, Spl ),
	test_data( test_293, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration294) :-
	spl_db( test_294, Spl ),
	test_data( test_294, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration295) :-
	spl_db( test_295, Spl ),
	test_data( test_295, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration296) :-
	spl_db( test_296, Spl ),
	test_data( test_296, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration297) :-
	spl_db( test_297, Spl ),
	test_data( test_297, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration298) :-
	spl_db( test_298, Spl ),
	test_data( test_298, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration299) :-
	spl_db( test_299, Spl ),
	test_data( test_299, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration300) :-
	spl_db( test_300, Spl ),
	test_data( test_300, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration301) :-
	spl_db( test_301, Spl ),
	test_data( test_301, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration302) :-
	spl_db( test_302, Spl ),
	test_data( test_302, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration303) :-
	spl_db( test_303, Spl ),
	test_data( test_303, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration304) :-
	spl_db( test_304, Spl ),
	test_data( test_304, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration305) :-
	spl_db( test_305, Spl ),
	test_data( test_305, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration306) :-
	spl_db( test_306, Spl ),
	test_data( test_306, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration307) :-
	spl_db( test_307, Spl ),
	test_data( test_307, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration308) :-
	spl_db( test_308, Spl ),
	test_data( test_308, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration309) :-
	spl_db( test_309, Spl ),
	test_data( test_309, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration310) :-
	spl_db( test_310, Spl ),
	test_data( test_310, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration311) :-
	spl_db( test_311, Spl ),
	test_data( test_311, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration312) :-
	spl_db( test_312, Spl ),
	test_data( test_312, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration313) :-
	spl_db( test_313, Spl ),
	test_data( test_313, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration314) :-
	spl_db( test_314, Spl ),
	test_data( test_314, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration315) :-
	spl_db( test_315, Spl ),
	test_data( test_315, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration316) :-
	spl_db( test_316, Spl ),
	test_data( test_316, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration317) :-
	spl_db( test_317, Spl ),
	test_data( test_317, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration318) :-
	spl_db( test_318, Spl ),
	test_data( test_318, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration319) :-
	spl_db( test_319, Spl ),
	test_data( test_319, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration320) :-
	spl_db( test_320, Spl ),
	test_data( test_320, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration321) :-
	spl_db( test_321, Spl ),
	test_data( test_321, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration322) :-
	spl_db( test_322, Spl ),
	test_data( test_322, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration323) :-
	spl_db( test_323, Spl ),
	test_data( test_323, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration324) :-
	spl_db( test_324, Spl ),
	test_data( test_324, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration325) :-
	spl_db( test_325, Spl ),
	test_data( test_325, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration326) :-
	spl_db( test_326, Spl ),
	test_data( test_326, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration327) :-
	spl_db( test_327, Spl ),
	test_data( test_327, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration328) :-
	spl_db( test_328, Spl ),
	test_data( test_328, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration329) :-
	spl_db( test_329, Spl ),
	test_data( test_329, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration330) :-
	spl_db( test_330, Spl ),
	test_data( test_330, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration331) :-
	spl_db( test_331, Spl ),
	test_data( test_331, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration332) :-
	spl_db( test_332, Spl ),
	test_data( test_332, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration333) :-
	spl_db( test_333, Spl ),
	test_data( test_333, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration334) :-
	spl_db( test_334, Spl ),
	test_data( test_334, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration335) :-
	spl_db( test_335, Spl ),
	test_data( test_335, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration336) :-
	spl_db( test_336, Spl ),
	test_data( test_336, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration337) :-
	spl_db( test_337, Spl ),
	test_data( test_337, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration338) :-
	spl_db( test_338, Spl ),
	test_data( test_338, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration339) :-
	spl_db( test_339, Spl ),
	test_data( test_339, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration340) :-
	spl_db( test_340, Spl ),
	test_data( test_340, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration341) :-
	spl_db( test_341, Spl ),
	test_data( test_341, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration342) :-
	spl_db( test_342, Spl ),
	test_data( test_342, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration343) :-
	spl_db( test_343, Spl ),
	test_data( test_343, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration344) :-
	spl_db( test_344, Spl ),
	test_data( test_344, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration345) :-
	spl_db( test_345, Spl ),
	test_data( test_345, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration346) :-
	spl_db( test_346, Spl ),
	test_data( test_346, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration347) :-
	spl_db( test_347, Spl ),
	test_data( test_347, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration348) :-
	spl_db( test_348, Spl ),
	test_data( test_348, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration349) :-
	spl_db( test_349, Spl ),
	test_data( test_349, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration350) :-
	spl_db( test_350, Spl ),
	test_data( test_350, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration351) :-
	spl_db( test_351, Spl ),
	test_data( test_351, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration352) :-
	spl_db( test_352, Spl ),
	test_data( test_352, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration353) :-
	spl_db( test_353, Spl ),
	test_data( test_353, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration354) :-
	spl_db( test_354, Spl ),
	test_data( test_354, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration355) :-
	spl_db( test_355, Spl ),
	test_data( test_355, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration356) :-
	spl_db( test_356, Spl ),
	test_data( test_356, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration357) :-
	spl_db( test_357, Spl ),
	test_data( test_357, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration358) :-
	spl_db( test_358, Spl ),
	test_data( test_358, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration359) :-
	spl_db( test_359, Spl ),
	test_data( test_359, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration360) :-
	spl_db( test_360, Spl ),
	test_data( test_360, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration361) :-
	spl_db( test_361, Spl ),
	test_data( test_361, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration362) :-
	spl_db( test_362, Spl ),
	test_data( test_362, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration363) :-
	spl_db( test_363, Spl ),
	test_data( test_363, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration364) :-
	spl_db( test_364, Spl ),
	test_data( test_364, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration365) :-
	spl_db( test_365, Spl ),
	test_data( test_365, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration366) :-
	spl_db( test_366, Spl ),
	test_data( test_366, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration367) :-
	spl_db( test_367, Spl ),
	test_data( test_367, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration368) :-
	spl_db( test_368, Spl ),
	test_data( test_368, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration369) :-
	spl_db( test_369, Spl ),
	test_data( test_369, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration370) :-
	spl_db( test_370, Spl ),
	test_data( test_370, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration371) :-
	spl_db( test_371, Spl ),
	test_data( test_371, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration372) :-
	spl_db( test_372, Spl ),
	test_data( test_372, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration373) :-
	spl_db( test_373, Spl ),
	test_data( test_373, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration374) :-
	spl_db( test_374, Spl ),
	test_data( test_374, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration375) :-
	spl_db( test_375, Spl ),
	test_data( test_375, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration376) :-
	spl_db( test_376, Spl ),
	test_data( test_376, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration377) :-
	spl_db( test_377, Spl ),
	test_data( test_377, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration378) :-
	spl_db( test_378, Spl ),
	test_data( test_378, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration379) :-
	spl_db( test_379, Spl ),
	test_data( test_379, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration380) :-
	spl_db( test_380, Spl ),
	test_data( test_380, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration381) :-
	spl_db( test_381, Spl ),
	test_data( test_381, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration382) :-
	spl_db( test_382, Spl ),
	test_data( test_382, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration383) :-
	spl_db( test_383, Spl ),
	test_data( test_383, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration384) :-
	spl_db( test_384, Spl ),
	test_data( test_384, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration385) :-
	spl_db( test_385, Spl ),
	test_data( test_385, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration386) :-
	spl_db( test_386, Spl ),
	test_data( test_386, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration387) :-
	spl_db( test_387, Spl ),
	test_data( test_387, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration388) :-
	spl_db( test_388, Spl ),
	test_data( test_388, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration389) :-
	spl_db( test_389, Spl ),
	test_data( test_389, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration390) :-
	spl_db( test_390, Spl ),
	test_data( test_390, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration391) :-
	spl_db( test_391, Spl ),
	test_data( test_391, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration392) :-
	spl_db( test_392, Spl ),
	test_data( test_392, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration393) :-
	spl_db( test_393, Spl ),
	test_data( test_393, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration394) :-
	spl_db( test_394, Spl ),
	test_data( test_394, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration395) :-
	spl_db( test_395, Spl ),
	test_data( test_395, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration396) :-
	spl_db( test_396, Spl ),
	test_data( test_396, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration397) :-
	spl_db( test_397, Spl ),
	test_data( test_397, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration398) :-
	spl_db( test_398, Spl ),
	test_data( test_398, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration399) :-
	spl_db( test_399, Spl ),
	test_data( test_399, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration400) :-
	spl_db( test_400, Spl ),
	test_data( test_400, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration401) :-
	spl_db( test_401, Spl ),
	test_data( test_401, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration402) :-
	spl_db( test_402, Spl ),
	test_data( test_402, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration403) :-
	spl_db( test_403, Spl ),
	test_data( test_403, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration404) :-
	spl_db( test_404, Spl ),
	test_data( test_404, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration405) :-
	spl_db( test_405, Spl ),
	test_data( test_405, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration406) :-
	spl_db( test_406, Spl ),
	test_data( test_406, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration407) :-
	spl_db( test_407, Spl ),
	test_data( test_407, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration408) :-
	spl_db( test_408, Spl ),
	test_data( test_408, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration409) :-
	spl_db( test_409, Spl ),
	test_data( test_409, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration410) :-
	spl_db( test_410, Spl ),
	test_data( test_410, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration411) :-
	spl_db( test_411, Spl ),
	test_data( test_411, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration412) :-
	spl_db( test_412, Spl ),
	test_data( test_412, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration413) :-
	spl_db( test_413, Spl ),
	test_data( test_413, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration414) :-
	spl_db( test_414, Spl ),
	test_data( test_414, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration415) :-
	spl_db( test_415, Spl ),
	test_data( test_415, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration416) :-
	spl_db( test_416, Spl ),
	test_data( test_416, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration417) :-
	spl_db( test_417, Spl ),
	test_data( test_417, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration418) :-
	spl_db( test_418, Spl ),
	test_data( test_418, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration419) :-
	spl_db( test_419, Spl ),
	test_data( test_419, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration420) :-
	spl_db( test_420, Spl ),
	test_data( test_420, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration421) :-
	spl_db( test_421, Spl ),
	test_data( test_421, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration422) :-
	spl_db( test_422, Spl ),
	test_data( test_422, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration423) :-
	spl_db( test_423, Spl ),
	test_data( test_423, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration424) :-
	spl_db( test_424, Spl ),
	test_data( test_424, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration425) :-
	spl_db( test_425, Spl ),
	test_data( test_425, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration426) :-
	spl_db( test_426, Spl ),
	test_data( test_426, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration427) :-
	spl_db( test_427, Spl ),
	test_data( test_427, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration428) :-
	spl_db( test_428, Spl ),
	test_data( test_428, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration429) :-
	spl_db( test_429, Spl ),
	test_data( test_429, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration430) :-
	spl_db( test_430, Spl ),
	test_data( test_430, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration431) :-
	spl_db( test_431, Spl ),
	test_data( test_431, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration432) :-
	spl_db( test_432, Spl ),
	test_data( test_432, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration433) :-
	spl_db( test_433, Spl ),
	test_data( test_433, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration434) :-
	spl_db( test_434, Spl ),
	test_data( test_434, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration435) :-
	spl_db( test_435, Spl ),
	test_data( test_435, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration436) :-
	spl_db( test_436, Spl ),
	test_data( test_436, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration437) :-
	spl_db( test_437, Spl ),
	test_data( test_437, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration438) :-
	spl_db( test_438, Spl ),
	test_data( test_438, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration439) :-
	spl_db( test_439, Spl ),
	test_data( test_439, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration440) :-
	spl_db( test_440, Spl ),
	test_data( test_440, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration441) :-
	spl_db( test_441, Spl ),
	test_data( test_441, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration442) :-
	spl_db( test_442, Spl ),
	test_data( test_442, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration443) :-
	spl_db( test_443, Spl ),
	test_data( test_443, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration444) :-
	spl_db( test_444, Spl ),
	test_data( test_444, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration445) :-
	spl_db( test_445, Spl ),
	test_data( test_445, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration446) :-
	spl_db( test_446, Spl ),
	test_data( test_446, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration447) :-
	spl_db( test_447, Spl ),
	test_data( test_447, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration448) :-
	spl_db( test_448, Spl ),
	test_data( test_448, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration449) :-
	spl_db( test_449, Spl ),
	test_data( test_449, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration450) :-
	spl_db( test_450, Spl ),
	test_data( test_450, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration451) :-
	spl_db( test_451, Spl ),
	test_data( test_451, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration452) :-
	spl_db( test_452, Spl ),
	test_data( test_452, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration453) :-
	spl_db( test_453, Spl ),
	test_data( test_453, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration454) :-
	spl_db( test_454, Spl ),
	test_data( test_454, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration455) :-
	spl_db( test_455, Spl ),
	test_data( test_455, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration456) :-
	spl_db( test_456, Spl ),
	test_data( test_456, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration457) :-
	spl_db( test_457, Spl ),
	test_data( test_457, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration458) :-
	spl_db( test_458, Spl ),
	test_data( test_458, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration459) :-
	spl_db( test_459, Spl ),
	test_data( test_459, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration460) :-
	spl_db( test_460, Spl ),
	test_data( test_460, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration461) :-
	spl_db( test_461, Spl ),
	test_data( test_461, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration462) :-
	spl_db( test_462, Spl ),
	test_data( test_462, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration463) :-
	spl_db( test_463, Spl ),
	test_data( test_463, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration464) :-
	spl_db( test_464, Spl ),
	test_data( test_464, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration465) :-
	spl_db( test_465, Spl ),
	test_data( test_465, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration466) :-
	spl_db( test_466, Spl ),
	test_data( test_466, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration467) :-
	spl_db( test_467, Spl ),
	test_data( test_467, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration468) :-
	spl_db( test_468, Spl ),
	test_data( test_468, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration469) :-
	spl_db( test_469, Spl ),
	test_data( test_469, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration470) :-
	spl_db( test_470, Spl ),
	test_data( test_470, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration471) :-
	spl_db( test_471, Spl ),
	test_data( test_471, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration472) :-
	spl_db( test_472, Spl ),
	test_data( test_472, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration473) :-
	spl_db( test_473, Spl ),
	test_data( test_473, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration474) :-
	spl_db( test_474, Spl ),
	test_data( test_474, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration475) :-
	spl_db( test_475, Spl ),
	test_data( test_475, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration476) :-
	spl_db( test_476, Spl ),
	test_data( test_476, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration477) :-
	spl_db( test_477, Spl ),
	test_data( test_477, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration478) :-
	spl_db( test_478, Spl ),
	test_data( test_478, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration479) :-
	spl_db( test_479, Spl ),
	test_data( test_479, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration480) :-
	spl_db( test_480, Spl ),
	test_data( test_480, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration481) :-
	spl_db( test_481, Spl ),
	test_data( test_481, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration482) :-
	spl_db( test_482, Spl ),
	test_data( test_482, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration483) :-
	spl_db( test_483, Spl ),
	test_data( test_483, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration484) :-
	spl_db( test_484, Spl ),
	test_data( test_484, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration485) :-
	spl_db( test_485, Spl ),
	test_data( test_485, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration486) :-
	spl_db( test_486, Spl ),
	test_data( test_486, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration487) :-
	spl_db( test_487, Spl ),
	test_data( test_487, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration488) :-
	spl_db( test_488, Spl ),
	test_data( test_488, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration489) :-
	spl_db( test_489, Spl ),
	test_data( test_489, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration490) :-
	spl_db( test_490, Spl ),
	test_data( test_490, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration491) :-
	spl_db( test_491, Spl ),
	test_data( test_491, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration492) :-
	spl_db( test_492, Spl ),
	test_data( test_492, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration493) :-
	spl_db( test_493, Spl ),
	test_data( test_493, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration494) :-
	spl_db( test_494, Spl ),
	test_data( test_494, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration495) :-
	spl_db( test_495, Spl ),
	test_data( test_495, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration496) :-
	spl_db( test_496, Spl ),
	test_data( test_496, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration497) :-
	spl_db( test_497, Spl ),
	test_data( test_497, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration498) :-
	spl_db( test_498, Spl ),
	test_data( test_498, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration499) :-
	spl_db( test_499, Spl ),
	test_data( test_499, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration500) :-
	spl_db( test_500, Spl ),
	test_data( test_500, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration501) :-
	spl_db( test_501, Spl ),
	test_data( test_501, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration502) :-
	spl_db( test_502, Spl ),
	test_data( test_502, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration503) :-
	spl_db( test_503, Spl ),
	test_data( test_503, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration504) :-
	spl_db( test_504, Spl ),
	test_data( test_504, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration505) :-
	spl_db( test_505, Spl ),
	test_data( test_505, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration506) :-
	spl_db( test_506, Spl ),
	test_data( test_506, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration507) :-
	spl_db( test_507, Spl ),
	test_data( test_507, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration508) :-
	spl_db( test_508, Spl ),
	test_data( test_508, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration509) :-
	spl_db( test_509, Spl ),
	test_data( test_509, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration510) :-
	spl_db( test_510, Spl ),
	test_data( test_510, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration511) :-
	spl_db( test_511, Spl ),
	test_data( test_511, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration512) :-
	spl_db( test_512, Spl ),
	test_data( test_512, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration513) :-
	spl_db( test_513, Spl ),
	test_data( test_513, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration514) :-
	spl_db( test_514, Spl ),
	test_data( test_514, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration515) :-
	spl_db( test_515, Spl ),
	test_data( test_515, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration516) :-
	spl_db( test_516, Spl ),
	test_data( test_516, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration517) :-
	spl_db( test_517, Spl ),
	test_data( test_517, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration518) :-
	spl_db( test_518, Spl ),
	test_data( test_518, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration519) :-
	spl_db( test_519, Spl ),
	test_data( test_519, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration520) :-
	spl_db( test_520, Spl ),
	test_data( test_520, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration521) :-
	spl_db( test_521, Spl ),
	test_data( test_521, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration522) :-
	spl_db( test_522, Spl ),
	test_data( test_522, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration523) :-
	spl_db( test_523, Spl ),
	test_data( test_523, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration524) :-
	spl_db( test_524, Spl ),
	test_data( test_524, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration525) :-
	spl_db( test_525, Spl ),
	test_data( test_525, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration526) :-
	spl_db( test_526, Spl ),
	test_data( test_526, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration527) :-
	spl_db( test_527, Spl ),
	test_data( test_527, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration528) :-
	spl_db( test_528, Spl ),
	test_data( test_528, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration529) :-
	spl_db( test_529, Spl ),
	test_data( test_529, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration530) :-
	spl_db( test_530, Spl ),
	test_data( test_530, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration531) :-
	spl_db( test_531, Spl ),
	test_data( test_531, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration532) :-
	spl_db( test_532, Spl ),
	test_data( test_532, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration533) :-
	spl_db( test_533, Spl ),
	test_data( test_533, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration534) :-
	spl_db( test_534, Spl ),
	test_data( test_534, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration535) :-
	spl_db( test_535, Spl ),
	test_data( test_535, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration536) :-
	spl_db( test_536, Spl ),
	test_data( test_536, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration537) :-
	spl_db( test_537, Spl ),
	test_data( test_537, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration538) :-
	spl_db( test_538, Spl ),
	test_data( test_538, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration539) :-
	spl_db( test_539, Spl ),
	test_data( test_539, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration540) :-
	spl_db( test_540, Spl ),
	test_data( test_540, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration541) :-
	spl_db( test_541, Spl ),
	test_data( test_541, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration542) :-
	spl_db( test_542, Spl ),
	test_data( test_542, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration543) :-
	spl_db( test_543, Spl ),
	test_data( test_543, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration544) :-
	spl_db( test_544, Spl ),
	test_data( test_544, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration545) :-
	spl_db( test_545, Spl ),
	test_data( test_545, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration546) :-
	spl_db( test_546, Spl ),
	test_data( test_546, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration547) :-
	spl_db( test_547, Spl ),
	test_data( test_547, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration548) :-
	spl_db( test_548, Spl ),
	test_data( test_548, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration549) :-
	spl_db( test_549, Spl ),
	test_data( test_549, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration550) :-
	spl_db( test_550, Spl ),
	test_data( test_550, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration551) :-
	spl_db( test_551, Spl ),
	test_data( test_551, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration552) :-
	spl_db( test_552, Spl ),
	test_data( test_552, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration553) :-
	spl_db( test_553, Spl ),
	test_data( test_553, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration554) :-
	spl_db( test_554, Spl ),
	test_data( test_554, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration555) :-
	spl_db( test_555, Spl ),
	test_data( test_555, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration556) :-
	spl_db( test_556, Spl ),
	test_data( test_556, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration557) :-
	spl_db( test_557, Spl ),
	test_data( test_557, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration558) :-
	spl_db( test_558, Spl ),
	test_data( test_558, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration559) :-
	spl_db( test_559, Spl ),
	test_data( test_559, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration560) :-
	spl_db( test_560, Spl ),
	test_data( test_560, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration561) :-
	spl_db( test_561, Spl ),
	test_data( test_561, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration562) :-
	spl_db( test_562, Spl ),
	test_data( test_562, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration563) :-
	spl_db( test_563, Spl ),
	test_data( test_563, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration564) :-
	spl_db( test_564, Spl ),
	test_data( test_564, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration565) :-
	spl_db( test_565, Spl ),
	test_data( test_565, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration566) :-
	spl_db( test_566, Spl ),
	test_data( test_566, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration567) :-
	spl_db( test_567, Spl ),
	test_data( test_567, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration568) :-
	spl_db( test_568, Spl ),
	test_data( test_568, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration569) :-
	spl_db( test_569, Spl ),
	test_data( test_569, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration570) :-
	spl_db( test_570, Spl ),
	test_data( test_570, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration571) :-
	spl_db( test_571, Spl ),
	test_data( test_571, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration572) :-
	spl_db( test_572, Spl ),
	test_data( test_572, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration573) :-
	spl_db( test_573, Spl ),
	test_data( test_573, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration574) :-
	spl_db( test_574, Spl ),
	test_data( test_574, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration575) :-
	spl_db( test_575, Spl ),
	test_data( test_575, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration576) :-
	spl_db( test_576, Spl ),
	test_data( test_576, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration577) :-
	spl_db( test_577, Spl ),
	test_data( test_577, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration578) :-
	spl_db( test_578, Spl ),
	test_data( test_578, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration579) :-
	spl_db( test_579, Spl ),
	test_data( test_579, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration580) :-
	spl_db( test_580, Spl ),
	test_data( test_580, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration581) :-
	spl_db( test_581, Spl ),
	test_data( test_581, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration582) :-
	spl_db( test_582, Spl ),
	test_data( test_582, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration583) :-
	spl_db( test_583, Spl ),
	test_data( test_583, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration584) :-
	spl_db( test_584, Spl ),
	test_data( test_584, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration585) :-
	spl_db( test_585, Spl ),
	test_data( test_585, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration586) :-
	spl_db( test_586, Spl ),
	test_data( test_586, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration587) :-
	spl_db( test_587, Spl ),
	test_data( test_587, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration588) :-
	spl_db( test_588, Spl ),
	test_data( test_588, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration589) :-
	spl_db( test_589, Spl ),
	test_data( test_589, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration590) :-
	spl_db( test_590, Spl ),
	test_data( test_590, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration591) :-
	spl_db( test_591, Spl ),
	test_data( test_591, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration592) :-
	spl_db( test_592, Spl ),
	test_data( test_592, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration593) :-
	spl_db( test_593, Spl ),
	test_data( test_593, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration594) :-
	spl_db( test_594, Spl ),
	test_data( test_594, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration595) :-
	spl_db( test_595, Spl ),
	test_data( test_595, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration596) :-
	spl_db( test_596, Spl ),
	test_data( test_596, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration597) :-
	spl_db( test_597, Spl ),
	test_data( test_597, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration598) :-
	spl_db( test_598, Spl ),
	test_data( test_598, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration599) :-
	spl_db( test_599, Spl ),
	test_data( test_599, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration600) :-
	spl_db( test_600, Spl ),
	test_data( test_600, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration601) :-
	spl_db( test_601, Spl ),
	test_data( test_601, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration602) :-
	spl_db( test_602, Spl ),
	test_data( test_602, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration603) :-
	spl_db( test_603, Spl ),
	test_data( test_603, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration604) :-
	spl_db( test_604, Spl ),
	test_data( test_604, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration605) :-
	spl_db( test_605, Spl ),
	test_data( test_605, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration606) :-
	spl_db( test_606, Spl ),
	test_data( test_606, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration607) :-
	spl_db( test_607, Spl ),
	test_data( test_607, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration608) :-
	spl_db( test_608, Spl ),
	test_data( test_608, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration609) :-
	spl_db( test_609, Spl ),
	test_data( test_609, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration610) :-
	spl_db( test_610, Spl ),
	test_data( test_610, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration611) :-
	spl_db( test_611, Spl ),
	test_data( test_611, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration612) :-
	spl_db( test_612, Spl ),
	test_data( test_612, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration613) :-
	spl_db( test_613, Spl ),
	test_data( test_613, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration614) :-
	spl_db( test_614, Spl ),
	test_data( test_614, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration615) :-
	spl_db( test_615, Spl ),
	test_data( test_615, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration616) :-
	spl_db( test_616, Spl ),
	test_data( test_616, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration617) :-
	spl_db( test_617, Spl ),
	test_data( test_617, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration618) :-
	spl_db( test_618, Spl ),
	test_data( test_618, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration619) :-
	spl_db( test_619, Spl ),
	test_data( test_619, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration620) :-
	spl_db( test_620, Spl ),
	test_data( test_620, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration621) :-
	spl_db( test_621, Spl ),
	test_data( test_621, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration622) :-
	spl_db( test_622, Spl ),
	test_data( test_622, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration623) :-
	spl_db( test_623, Spl ),
	test_data( test_623, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration624) :-
	spl_db( test_624, Spl ),
	test_data( test_624, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration625) :-
	spl_db( test_625, Spl ),
	test_data( test_625, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration626) :-
	spl_db( test_626, Spl ),
	test_data( test_626, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration627) :-
	spl_db( test_627, Spl ),
	test_data( test_627, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration628) :-
	spl_db( test_628, Spl ),
	test_data( test_628, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration629) :-
	spl_db( test_629, Spl ),
	test_data( test_629, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration630) :-
	spl_db( test_630, Spl ),
	test_data( test_630, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration631) :-
	spl_db( test_631, Spl ),
	test_data( test_631, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration632) :-
	spl_db( test_632, Spl ),
	test_data( test_632, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration633) :-
	spl_db( test_633, Spl ),
	test_data( test_633, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration634) :-
	spl_db( test_634, Spl ),
	test_data( test_634, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration635) :-
	spl_db( test_635, Spl ),
	test_data( test_635, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration636) :-
	spl_db( test_636, Spl ),
	test_data( test_636, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration637) :-
	spl_db( test_637, Spl ),
	test_data( test_637, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration638) :-
	spl_db( test_638, Spl ),
	test_data( test_638, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration639) :-
	spl_db( test_639, Spl ),
	test_data( test_639, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration640) :-
	spl_db( test_640, Spl ),
	test_data( test_640, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration641) :-
	spl_db( test_641, Spl ),
	test_data( test_641, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration642) :-
	spl_db( test_642, Spl ),
	test_data( test_642, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration643) :-
	spl_db( test_643, Spl ),
	test_data( test_643, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration644) :-
	spl_db( test_644, Spl ),
	test_data( test_644, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration645) :-
	spl_db( test_645, Spl ),
	test_data( test_645, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration646) :-
	spl_db( test_646, Spl ),
	test_data( test_646, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration647) :-
	spl_db( test_647, Spl ),
	test_data( test_647, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration648) :-
	spl_db( test_648, Spl ),
	test_data( test_648, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration649) :-
	spl_db( test_649, Spl ),
	test_data( test_649, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration650) :-
	spl_db( test_650, Spl ),
	test_data( test_650, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration651) :-
	spl_db( test_651, Spl ),
	test_data( test_651, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration652) :-
	spl_db( test_652, Spl ),
	test_data( test_652, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration653) :-
	spl_db( test_653, Spl ),
	test_data( test_653, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration654) :-
	spl_db( test_654, Spl ),
	test_data( test_654, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration655) :-
	spl_db( test_655, Spl ),
	test_data( test_655, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration656) :-
	spl_db( test_656, Spl ),
	test_data( test_656, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration657) :-
	spl_db( test_657, Spl ),
	test_data( test_657, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration658) :-
	spl_db( test_658, Spl ),
	test_data( test_658, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration659) :-
	spl_db( test_659, Spl ),
	test_data( test_659, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration660) :-
	spl_db( test_660, Spl ),
	test_data( test_660, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration661) :-
	spl_db( test_661, Spl ),
	test_data( test_661, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration662) :-
	spl_db( test_662, Spl ),
	test_data( test_662, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration663) :-
	spl_db( test_663, Spl ),
	test_data( test_663, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration664) :-
	spl_db( test_664, Spl ),
	test_data( test_664, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration665) :-
	spl_db( test_665, Spl ),
	test_data( test_665, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration666) :-
	spl_db( test_666, Spl ),
	test_data( test_666, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration667) :-
	spl_db( test_667, Spl ),
	test_data( test_667, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration668) :-
	spl_db( test_668, Spl ),
	test_data( test_668, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration669) :-
	spl_db( test_669, Spl ),
	test_data( test_669, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration670) :-
	spl_db( test_670, Spl ),
	test_data( test_670, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration671) :-
	spl_db( test_671, Spl ),
	test_data( test_671, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration672) :-
	spl_db( test_672, Spl ),
	test_data( test_672, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration673) :-
	spl_db( test_673, Spl ),
	test_data( test_673, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration674) :-
	spl_db( test_674, Spl ),
	test_data( test_674, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration675) :-
	spl_db( test_675, Spl ),
	test_data( test_675, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration676) :-
	spl_db( test_676, Spl ),
	test_data( test_676, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration677) :-
	spl_db( test_677, Spl ),
	test_data( test_677, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration678) :-
	spl_db( test_678, Spl ),
	test_data( test_678, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration679) :-
	spl_db( test_679, Spl ),
	test_data( test_679, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration680) :-
	spl_db( test_680, Spl ),
	test_data( test_680, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration681) :-
	spl_db( test_681, Spl ),
	test_data( test_681, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration682) :-
	spl_db( test_682, Spl ),
	test_data( test_682, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration683) :-
	spl_db( test_683, Spl ),
	test_data( test_683, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration684) :-
	spl_db( test_684, Spl ),
	test_data( test_684, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration685) :-
	spl_db( test_685, Spl ),
	test_data( test_685, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration686) :-
	spl_db( test_686, Spl ),
	test_data( test_686, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration687) :-
	spl_db( test_687, Spl ),
	test_data( test_687, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration688) :-
	spl_db( test_688, Spl ),
	test_data( test_688, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration689) :-
	spl_db( test_689, Spl ),
	test_data( test_689, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration690) :-
	spl_db( test_690, Spl ),
	test_data( test_690, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration691) :-
	spl_db( test_691, Spl ),
	test_data( test_691, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration692) :-
	spl_db( test_692, Spl ),
	test_data( test_692, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration693) :-
	spl_db( test_693, Spl ),
	test_data( test_693, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration694) :-
	spl_db( test_694, Spl ),
	test_data( test_694, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration695) :-
	spl_db( test_695, Spl ),
	test_data( test_695, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration696) :-
	spl_db( test_696, Spl ),
	test_data( test_696, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration697) :-
	spl_db( test_697, Spl ),
	test_data( test_697, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration698) :-
	spl_db( test_698, Spl ),
	test_data( test_698, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration699) :-
	spl_db( test_699, Spl ),
	test_data( test_699, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration700) :-
	spl_db( test_700, Spl ),
	test_data( test_700, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration701) :-
	spl_db( test_701, Spl ),
	test_data( test_701, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration702) :-
	spl_db( test_702, Spl ),
	test_data( test_702, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration703) :-
	spl_db( test_703, Spl ),
	test_data( test_703, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration704) :-
	spl_db( test_704, Spl ),
	test_data( test_704, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration705) :-
	spl_db( test_705, Spl ),
	test_data( test_705, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration706) :-
	spl_db( test_706, Spl ),
	test_data( test_706, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration707) :-
	spl_db( test_707, Spl ),
	test_data( test_707, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration708) :-
	spl_db( test_708, Spl ),
	test_data( test_708, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration709) :-
	spl_db( test_709, Spl ),
	test_data( test_709, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration710) :-
	spl_db( test_710, Spl ),
	test_data( test_710, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration711) :-
	spl_db( test_711, Spl ),
	test_data( test_711, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration712) :-
	spl_db( test_712, Spl ),
	test_data( test_712, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration713) :-
	spl_db( test_713, Spl ),
	test_data( test_713, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration714) :-
	spl_db( test_714, Spl ),
	test_data( test_714, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration715) :-
	spl_db( test_715, Spl ),
	test_data( test_715, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration716) :-
	spl_db( test_716, Spl ),
	test_data( test_716, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration717) :-
	spl_db( test_717, Spl ),
	test_data( test_717, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration718) :-
	spl_db( test_718, Spl ),
	test_data( test_718, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration719) :-
	spl_db( test_719, Spl ),
	test_data( test_719, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration720) :-
	spl_db( test_720, Spl ),
	test_data( test_720, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration721) :-
	spl_db( test_721, Spl ),
	test_data( test_721, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration722) :-
	spl_db( test_722, Spl ),
	test_data( test_722, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration723) :-
	spl_db( test_723, Spl ),
	test_data( test_723, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration724) :-
	spl_db( test_724, Spl ),
	test_data( test_724, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration725) :-
	spl_db( test_725, Spl ),
	test_data( test_725, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration726) :-
	spl_db( test_726, Spl ),
	test_data( test_726, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration727) :-
	spl_db( test_727, Spl ),
	test_data( test_727, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration728) :-
	spl_db( test_728, Spl ),
	test_data( test_728, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration729) :-
	spl_db( test_729, Spl ),
	test_data( test_729, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration730) :-
	spl_db( test_730, Spl ),
	test_data( test_730, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration731) :-
	spl_db( test_731, Spl ),
	test_data( test_731, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration732) :-
	spl_db( test_732, Spl ),
	test_data( test_732, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration733) :-
	spl_db( test_733, Spl ),
	test_data( test_733, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration734) :-
	spl_db( test_734, Spl ),
	test_data( test_734, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration735) :-
	spl_db( test_735, Spl ),
	test_data( test_735, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration736) :-
	spl_db( test_736, Spl ),
	test_data( test_736, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration737) :-
	spl_db( test_737, Spl ),
	test_data( test_737, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration738) :-
	spl_db( test_738, Spl ),
	test_data( test_738, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration739) :-
	spl_db( test_739, Spl ),
	test_data( test_739, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration740) :-
	spl_db( test_740, Spl ),
	test_data( test_740, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration741) :-
	spl_db( test_741, Spl ),
	test_data( test_741, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration742) :-
	spl_db( test_742, Spl ),
	test_data( test_742, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration743) :-
	spl_db( test_743, Spl ),
	test_data( test_743, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration744) :-
	spl_db( test_744, Spl ),
	test_data( test_744, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration745) :-
	spl_db( test_745, Spl ),
	test_data( test_745, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration746) :-
	spl_db( test_746, Spl ),
	test_data( test_746, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration747) :-
	spl_db( test_747, Spl ),
	test_data( test_747, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration748) :-
	spl_db( test_748, Spl ),
	test_data( test_748, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration749) :-
	spl_db( test_749, Spl ),
	test_data( test_749, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration750) :-
	spl_db( test_750, Spl ),
	test_data( test_750, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration751) :-
	spl_db( test_751, Spl ),
	test_data( test_751, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration752) :-
	spl_db( test_752, Spl ),
	test_data( test_752, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration753) :-
	spl_db( test_753, Spl ),
	test_data( test_753, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration754) :-
	spl_db( test_754, Spl ),
	test_data( test_754, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration755) :-
	spl_db( test_755, Spl ),
	test_data( test_755, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration756) :-
	spl_db( test_756, Spl ),
	test_data( test_756, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration757) :-
	spl_db( test_757, Spl ),
	test_data( test_757, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration758) :-
	spl_db( test_758, Spl ),
	test_data( test_758, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration759) :-
	spl_db( test_759, Spl ),
	test_data( test_759, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration760) :-
	spl_db( test_760, Spl ),
	test_data( test_760, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration761) :-
	spl_db( test_761, Spl ),
	test_data( test_761, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration762) :-
	spl_db( test_762, Spl ),
	test_data( test_762, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration763) :-
	spl_db( test_763, Spl ),
	test_data( test_763, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration764) :-
	spl_db( test_764, Spl ),
	test_data( test_764, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration765) :-
	spl_db( test_765, Spl ),
	test_data( test_765, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration766) :-
	spl_db( test_766, Spl ),
	test_data( test_766, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration767) :-
	spl_db( test_767, Spl ),
	test_data( test_767, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration768) :-
	spl_db( test_768, Spl ),
	test_data( test_768, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration769) :-
	spl_db( test_769, Spl ),
	test_data( test_769, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration770) :-
	spl_db( test_770, Spl ),
	test_data( test_770, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration771) :-
	spl_db( test_771, Spl ),
	test_data( test_771, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration772) :-
	spl_db( test_772, Spl ),
	test_data( test_772, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration773) :-
	spl_db( test_773, Spl ),
	test_data( test_773, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration774) :-
	spl_db( test_774, Spl ),
	test_data( test_774, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration775) :-
	spl_db( test_775, Spl ),
	test_data( test_775, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration776) :-
	spl_db( test_776, Spl ),
	test_data( test_776, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration777) :-
	spl_db( test_777, Spl ),
	test_data( test_777, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration778) :-
	spl_db( test_778, Spl ),
	test_data( test_778, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration779) :-
	spl_db( test_779, Spl ),
	test_data( test_779, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration780) :-
	spl_db( test_780, Spl ),
	test_data( test_780, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration781) :-
	spl_db( test_781, Spl ),
	test_data( test_781, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration782) :-
	spl_db( test_782, Spl ),
	test_data( test_782, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration783) :-
	spl_db( test_783, Spl ),
	test_data( test_783, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration784) :-
	spl_db( test_784, Spl ),
	test_data( test_784, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration785) :-
	spl_db( test_785, Spl ),
	test_data( test_785, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration786) :-
	spl_db( test_786, Spl ),
	test_data( test_786, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration787) :-
	spl_db( test_787, Spl ),
	test_data( test_787, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration788) :-
	spl_db( test_788, Spl ),
	test_data( test_788, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration789) :-
	spl_db( test_789, Spl ),
	test_data( test_789, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration790) :-
	spl_db( test_790, Spl ),
	test_data( test_790, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration791) :-
	spl_db( test_791, Spl ),
	test_data( test_791, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration792) :-
	spl_db( test_792, Spl ),
	test_data( test_792, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration793) :-
	spl_db( test_793, Spl ),
	test_data( test_793, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration794) :-
	spl_db( test_794, Spl ),
	test_data( test_794, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration795) :-
	spl_db( test_795, Spl ),
	test_data( test_795, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration796) :-
	spl_db( test_796, Spl ),
	test_data( test_796, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration797) :-
	spl_db( test_797, Spl ),
	test_data( test_797, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration798) :-
	spl_db( test_798, Spl ),
	test_data( test_798, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration799) :-
	spl_db( test_799, Spl ),
	test_data( test_799, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration800) :-
	spl_db( test_800, Spl ),
	test_data( test_800, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration801) :-
	spl_db( test_801, Spl ),
	test_data( test_801, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration802) :-
	spl_db( test_802, Spl ),
	test_data( test_802, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration803) :-
	spl_db( test_803, Spl ),
	test_data( test_803, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration804) :-
	spl_db( test_804, Spl ),
	test_data( test_804, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration805) :-
	spl_db( test_805, Spl ),
	test_data( test_805, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration806) :-
	spl_db( test_806, Spl ),
	test_data( test_806, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration807) :-
	spl_db( test_807, Spl ),
	test_data( test_807, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration808) :-
	spl_db( test_808, Spl ),
	test_data( test_808, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration809) :-
	spl_db( test_809, Spl ),
	test_data( test_809, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration810) :-
	spl_db( test_810, Spl ),
	test_data( test_810, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration811) :-
	spl_db( test_811, Spl ),
	test_data( test_811, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration812) :-
	spl_db( test_812, Spl ),
	test_data( test_812, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration813) :-
	spl_db( test_813, Spl ),
	test_data( test_813, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration814) :-
	spl_db( test_814, Spl ),
	test_data( test_814, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration815) :-
	spl_db( test_815, Spl ),
	test_data( test_815, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration816) :-
	spl_db( test_816, Spl ),
	test_data( test_816, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration817) :-
	spl_db( test_817, Spl ),
	test_data( test_817, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration818) :-
	spl_db( test_818, Spl ),
	test_data( test_818, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration819) :-
	spl_db( test_819, Spl ),
	test_data( test_819, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration820) :-
	spl_db( test_820, Spl ),
	test_data( test_820, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration821) :-
	spl_db( test_821, Spl ),
	test_data( test_821, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration822) :-
	spl_db( test_822, Spl ),
	test_data( test_822, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration823) :-
	spl_db( test_823, Spl ),
	test_data( test_823, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration824) :-
	spl_db( test_824, Spl ),
	test_data( test_824, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration825) :-
	spl_db( test_825, Spl ),
	test_data( test_825, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration826) :-
	spl_db( test_826, Spl ),
	test_data( test_826, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration827) :-
	spl_db( test_827, Spl ),
	test_data( test_827, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration828) :-
	spl_db( test_828, Spl ),
	test_data( test_828, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration829) :-
	spl_db( test_829, Spl ),
	test_data( test_829, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration830) :-
	spl_db( test_830, Spl ),
	test_data( test_830, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration831) :-
	spl_db( test_831, Spl ),
	test_data( test_831, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration832) :-
	spl_db( test_832, Spl ),
	test_data( test_832, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration833) :-
	spl_db( test_833, Spl ),
	test_data( test_833, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration834) :-
	spl_db( test_834, Spl ),
	test_data( test_834, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration835) :-
	spl_db( test_835, Spl ),
	test_data( test_835, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration836) :-
	spl_db( test_836, Spl ),
	test_data( test_836, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration837) :-
	spl_db( test_837, Spl ),
	test_data( test_837, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration838) :-
	spl_db( test_838, Spl ),
	test_data( test_838, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration839) :-
	spl_db( test_839, Spl ),
	test_data( test_839, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration840) :-
	spl_db( test_840, Spl ),
	test_data( test_840, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration841) :-
	spl_db( test_841, Spl ),
	test_data( test_841, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration842) :-
	spl_db( test_842, Spl ),
	test_data( test_842, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration843) :-
	spl_db( test_843, Spl ),
	test_data( test_843, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration844) :-
	spl_db( test_844, Spl ),
	test_data( test_844, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration845) :-
	spl_db( test_845, Spl ),
	test_data( test_845, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration846) :-
	spl_db( test_846, Spl ),
	test_data( test_846, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration847) :-
	spl_db( test_847, Spl ),
	test_data( test_847, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration848) :-
	spl_db( test_848, Spl ),
	test_data( test_848, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration849) :-
	spl_db( test_849, Spl ),
	test_data( test_849, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration850) :-
	spl_db( test_850, Spl ),
	test_data( test_850, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration851) :-
	spl_db( test_851, Spl ),
	test_data( test_851, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration852) :-
	spl_db( test_852, Spl ),
	test_data( test_852, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration853) :-
	spl_db( test_853, Spl ),
	test_data( test_853, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration854) :-
	spl_db( test_854, Spl ),
	test_data( test_854, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration855) :-
	spl_db( test_855, Spl ),
	test_data( test_855, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration856) :-
	spl_db( test_856, Spl ),
	test_data( test_856, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration857) :-
	spl_db( test_857, Spl ),
	test_data( test_857, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration858) :-
	spl_db( test_858, Spl ),
	test_data( test_858, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration859) :-
	spl_db( test_859, Spl ),
	test_data( test_859, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration860) :-
	spl_db( test_860, Spl ),
	test_data( test_860, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration861) :-
	spl_db( test_861, Spl ),
	test_data( test_861, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration862) :-
	spl_db( test_862, Spl ),
	test_data( test_862, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration863) :-
	spl_db( test_863, Spl ),
	test_data( test_863, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration864) :-
	spl_db( test_864, Spl ),
	test_data( test_864, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration865) :-
	spl_db( test_865, Spl ),
	test_data( test_865, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration866) :-
	spl_db( test_866, Spl ),
	test_data( test_866, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration867) :-
	spl_db( test_867, Spl ),
	test_data( test_867, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration868) :-
	spl_db( test_868, Spl ),
	test_data( test_868, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration869) :-
	spl_db( test_869, Spl ),
	test_data( test_869, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration870) :-
	spl_db( test_870, Spl ),
	test_data( test_870, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration871) :-
	spl_db( test_871, Spl ),
	test_data( test_871, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration872) :-
	spl_db( test_872, Spl ),
	test_data( test_872, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration873) :-
	spl_db( test_873, Spl ),
	test_data( test_873, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration874) :-
	spl_db( test_874, Spl ),
	test_data( test_874, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration875) :-
	spl_db( test_875, Spl ),
	test_data( test_875, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration876) :-
	spl_db( test_876, Spl ),
	test_data( test_876, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration877) :-
	spl_db( test_877, Spl ),
	test_data( test_877, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration878) :-
	spl_db( test_878, Spl ),
	test_data( test_878, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration879) :-
	spl_db( test_879, Spl ),
	test_data( test_879, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration880) :-
	spl_db( test_880, Spl ),
	test_data( test_880, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration881) :-
	spl_db( test_881, Spl ),
	test_data( test_881, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration882) :-
	spl_db( test_882, Spl ),
	test_data( test_882, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration883) :-
	spl_db( test_883, Spl ),
	test_data( test_883, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration884) :-
	spl_db( test_884, Spl ),
	test_data( test_884, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration885) :-
	spl_db( test_885, Spl ),
	test_data( test_885, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration886) :-
	spl_db( test_886, Spl ),
	test_data( test_886, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration887) :-
	spl_db( test_887, Spl ),
	test_data( test_887, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration888) :-
	spl_db( test_888, Spl ),
	test_data( test_888, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration889) :-
	spl_db( test_889, Spl ),
	test_data( test_889, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration890) :-
	spl_db( test_890, Spl ),
	test_data( test_890, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration891) :-
	spl_db( test_891, Spl ),
	test_data( test_891, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration892) :-
	spl_db( test_892, Spl ),
	test_data( test_892, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration893) :-
	spl_db( test_893, Spl ),
	test_data( test_893, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration894) :-
	spl_db( test_894, Spl ),
	test_data( test_894, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration895) :-
	spl_db( test_895, Spl ),
	test_data( test_895, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration896) :-
	spl_db( test_896, Spl ),
	test_data( test_896, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration897) :-
	spl_db( test_897, Spl ),
	test_data( test_897, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration898) :-
	spl_db( test_898, Spl ),
	test_data( test_898, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration899) :-
	spl_db( test_899, Spl ),
	test_data( test_899, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration900) :-
	spl_db( test_900, Spl ),
	test_data( test_900, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration901) :-
	spl_db( test_901, Spl ),
	test_data( test_901, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration902) :-
	spl_db( test_902, Spl ),
	test_data( test_902, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration903) :-
	spl_db( test_903, Spl ),
	test_data( test_903, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration904) :-
	spl_db( test_904, Spl ),
	test_data( test_904, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration905) :-
	spl_db( test_905, Spl ),
	test_data( test_905, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration906) :-
	spl_db( test_906, Spl ),
	test_data( test_906, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration907) :-
	spl_db( test_907, Spl ),
	test_data( test_907, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration908) :-
	spl_db( test_908, Spl ),
	test_data( test_908, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration909) :-
	spl_db( test_909, Spl ),
	test_data( test_909, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration910) :-
	spl_db( test_910, Spl ),
	test_data( test_910, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration911) :-
	spl_db( test_911, Spl ),
	test_data( test_911, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration912) :-
	spl_db( test_912, Spl ),
	test_data( test_912, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration913) :-
	spl_db( test_913, Spl ),
	test_data( test_913, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration914) :-
	spl_db( test_914, Spl ),
	test_data( test_914, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration915) :-
	spl_db( test_915, Spl ),
	test_data( test_915, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration916) :-
	spl_db( test_916, Spl ),
	test_data( test_916, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration917) :-
	spl_db( test_917, Spl ),
	test_data( test_917, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration918) :-
	spl_db( test_918, Spl ),
	test_data( test_918, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration919) :-
	spl_db( test_919, Spl ),
	test_data( test_919, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration920) :-
	spl_db( test_920, Spl ),
	test_data( test_920, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration921) :-
	spl_db( test_921, Spl ),
	test_data( test_921, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration922) :-
	spl_db( test_922, Spl ),
	test_data( test_922, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration923) :-
	spl_db( test_923, Spl ),
	test_data( test_923, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration924) :-
	spl_db( test_924, Spl ),
	test_data( test_924, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration925) :-
	spl_db( test_925, Spl ),
	test_data( test_925, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration926) :-
	spl_db( test_926, Spl ),
	test_data( test_926, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration927) :-
	spl_db( test_927, Spl ),
	test_data( test_927, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration928) :-
	spl_db( test_928, Spl ),
	test_data( test_928, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration929) :-
	spl_db( test_929, Spl ),
	test_data( test_929, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration930) :-
	spl_db( test_930, Spl ),
	test_data( test_930, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration931) :-
	spl_db( test_931, Spl ),
	test_data( test_931, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration932) :-
	spl_db( test_932, Spl ),
	test_data( test_932, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration933) :-
	spl_db( test_933, Spl ),
	test_data( test_933, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration934) :-
	spl_db( test_934, Spl ),
	test_data( test_934, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration935) :-
	spl_db( test_935, Spl ),
	test_data( test_935, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration936) :-
	spl_db( test_936, Spl ),
	test_data( test_936, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration937) :-
	spl_db( test_937, Spl ),
	test_data( test_937, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration938) :-
	spl_db( test_938, Spl ),
	test_data( test_938, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration939) :-
	spl_db( test_939, Spl ),
	test_data( test_939, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration940) :-
	spl_db( test_940, Spl ),
	test_data( test_940, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration941) :-
	spl_db( test_941, Spl ),
	test_data( test_941, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration942) :-
	spl_db( test_942, Spl ),
	test_data( test_942, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration943) :-
	spl_db( test_943, Spl ),
	test_data( test_943, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration944) :-
	spl_db( test_944, Spl ),
	test_data( test_944, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration945) :-
	spl_db( test_945, Spl ),
	test_data( test_945, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration946) :-
	spl_db( test_946, Spl ),
	test_data( test_946, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration947) :-
	spl_db( test_947, Spl ),
	test_data( test_947, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration948) :-
	spl_db( test_948, Spl ),
	test_data( test_948, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration949) :-
	spl_db( test_949, Spl ),
	test_data( test_949, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration950) :-
	spl_db( test_950, Spl ),
	test_data( test_950, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration951) :-
	spl_db( test_951, Spl ),
	test_data( test_951, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration952) :-
	spl_db( test_952, Spl ),
	test_data( test_952, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration953) :-
	spl_db( test_953, Spl ),
	test_data( test_953, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration954) :-
	spl_db( test_954, Spl ),
	test_data( test_954, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration955) :-
	spl_db( test_955, Spl ),
	test_data( test_955, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration956) :-
	spl_db( test_956, Spl ),
	test_data( test_956, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration957) :-
	spl_db( test_957, Spl ),
	test_data( test_957, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration958) :-
	spl_db( test_958, Spl ),
	test_data( test_958, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration959) :-
	spl_db( test_959, Spl ),
	test_data( test_959, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration960) :-
	spl_db( test_960, Spl ),
	test_data( test_960, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration961) :-
	spl_db( test_961, Spl ),
	test_data( test_961, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration962) :-
	spl_db( test_962, Spl ),
	test_data( test_962, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration963) :-
	spl_db( test_963, Spl ),
	test_data( test_963, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration964) :-
	spl_db( test_964, Spl ),
	test_data( test_964, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration965) :-
	spl_db( test_965, Spl ),
	test_data( test_965, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration966) :-
	spl_db( test_966, Spl ),
	test_data( test_966, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration967) :-
	spl_db( test_967, Spl ),
	test_data( test_967, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration968) :-
	spl_db( test_968, Spl ),
	test_data( test_968, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration969) :-
	spl_db( test_969, Spl ),
	test_data( test_969, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration970) :-
	spl_db( test_970, Spl ),
	test_data( test_970, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration971) :-
	spl_db( test_971, Spl ),
	test_data( test_971, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration972) :-
	spl_db( test_972, Spl ),
	test_data( test_972, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration973) :-
	spl_db( test_973, Spl ),
	test_data( test_973, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration974) :-
	spl_db( test_974, Spl ),
	test_data( test_974, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration975) :-
	spl_db( test_975, Spl ),
	test_data( test_975, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration976) :-
	spl_db( test_976, Spl ),
	test_data( test_976, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration977) :-
	spl_db( test_977, Spl ),
	test_data( test_977, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration978) :-
	spl_db( test_978, Spl ),
	test_data( test_978, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration979) :-
	spl_db( test_979, Spl ),
	test_data( test_979, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration980) :-
	spl_db( test_980, Spl ),
	test_data( test_980, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration981) :-
	spl_db( test_981, Spl ),
	test_data( test_981, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration982) :-
	spl_db( test_982, Spl ),
	test_data( test_982, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration983) :-
	spl_db( test_983, Spl ),
	test_data( test_983, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration984) :-
	spl_db( test_984, Spl ),
	test_data( test_984, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration985) :-
	spl_db( test_985, Spl ),
	test_data( test_985, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration986) :-
	spl_db( test_986, Spl ),
	test_data( test_986, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration987) :-
	spl_db( test_987, Spl ),
	test_data( test_987, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration988) :-
	spl_db( test_988, Spl ),
	test_data( test_988, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration989) :-
	spl_db( test_989, Spl ),
	test_data( test_989, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration990) :-
	spl_db( test_990, Spl ),
	test_data( test_990, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration991) :-
	spl_db( test_991, Spl ),
	test_data( test_991, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration992) :-
	spl_db( test_992, Spl ),
	test_data( test_992, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration993) :-
	spl_db( test_993, Spl ),
	test_data( test_993, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration994) :-
	spl_db( test_994, Spl ),
	test_data( test_994, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration995) :-
	spl_db( test_995, Spl ),
	test_data( test_995, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration996) :-
	spl_db( test_996, Spl ),
	test_data( test_996, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration997) :-
	spl_db( test_997, Spl ),
	test_data( test_997, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration998) :-
	spl_db( test_998, Spl ),
	test_data( test_998, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

test(valid_configuration999) :-
	spl_db( test_999, Spl ),
	test_data( test_999, valid_configuration, Input_Product, Expected_result),
	isValidConfiguration(Input_Product,Spl,Expected_result), !.

:- end_tests(valid_configuration).