% ---------------
% Auxiliary predicates to support true/false as a parameter.
% ---------------
isEquivalentSpl(Spl1,Spl2,true) :- !, equivalent(Spl1,Spl2).
isEquivalentSpl(Spl1,Spl2,false) :-  !, not(equivalent(Spl1,Spl2)).



% ---------------
spl_db( equiv0_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

spl_db( equiv0_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(equiv0,equivalent,equiv0_b, false).


% ---------------
spl_db( equiv1_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv1_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv1,equivalent,equiv1_b, false).


% ---------------
spl_db( equiv2_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv2_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv2,equivalent,equiv2_b, false).


% ---------------
spl_db( equiv3_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv3_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv3,equivalent,equiv3_b, true).


% ---------------
spl_db( equiv4_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv4_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv4,equivalent,equiv4_b, false).


% ---------------
spl_db( equiv5_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv5_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv5,equivalent,equiv5_b, false).


% ---------------
spl_db( equiv6_a,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv6_b,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv6,equivalent,equiv6_b, false).


% ---------------
spl_db( equiv7_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv7_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv7,equivalent,equiv7_b, false).


% ---------------
spl_db( equiv8_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
							mandatory( feature( f7, [
								optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv8_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv8,equivalent,equiv8_b, false).


% ---------------
spl_db( equiv9_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv9_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [] ), feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f5, [] ) ), optional( feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv9,equivalent,equiv9_b, false).


% ---------------
spl_db( equiv10_a,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv10_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv10,equivalent,equiv10_b, false).


% ---------------
spl_db( equiv11_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv11_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv11,equivalent,equiv11_b, false).


% ---------------
spl_db( equiv12_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv12_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv12,equivalent,equiv12_b, false).


% ---------------
spl_db( equiv13_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv13_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv13,equivalent,equiv13_b, true).


% ---------------
spl_db( equiv14_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [
						optional( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv14_b,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					optional( feature( f9, [] ) ) ] ), feature( f4, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv14,equivalent,equiv14_b, false).


% ---------------
spl_db( equiv15_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv15_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv15,equivalent,equiv15_b, false).


% ---------------
spl_db( equiv16_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv16_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv16,equivalent,equiv16_b, false).


% ---------------
spl_db( equiv17_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv17_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv17,equivalent,equiv17_b, false).


% ---------------
spl_db( equiv18_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv18_b,
	 spl( [ root, f1, f4, f9, f2, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv18,equivalent,equiv18_b, false).


% ---------------
spl_db( equiv19_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv19_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv19,equivalent,equiv19_b, false).


% ---------------
spl_db( equiv20_a,
	 spl( [ root, f1, f2, f3, f7, f4, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv20_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv20,equivalent,equiv20_b, false).


% ---------------
spl_db( equiv21_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv21_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv21,equivalent,equiv21_b, false).


% ---------------
spl_db( equiv22_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv22_b,
	 spl( [ root, f1, f7, f8, f9, f2, f5, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv22,equivalent,equiv22_b, false).


% ---------------
spl_db( equiv23_a,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv23_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv23,equivalent,equiv23_b, false).


% ---------------
spl_db( equiv24_a,
	 spl( [ root, f1, f6, f7, f2, f3, f4, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv24_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv24,equivalent,equiv24_b, false).


% ---------------
spl_db( equiv25_a,
	 spl( [ root, f1, f2, f6, f8, f7, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv25_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f5, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f6, [
						optional( feature( f7, [
							mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [
					mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv25,equivalent,equiv25_b, false).


% ---------------
spl_db( equiv26_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv26_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv26,equivalent,equiv26_b, false).


% ---------------
spl_db( equiv27_a,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv27_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv27,equivalent,equiv27_b, false).


% ---------------
spl_db( equiv28_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv28_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv28,equivalent,equiv28_b, true).


% ---------------
spl_db( equiv29_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv29_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv29,equivalent,equiv29_b, false).


% ---------------
spl_db( equiv30_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv30_b,
	 spl( [ root, f1, f6, f9, f7, f2, f4, f5, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv30,equivalent,equiv30_b, false).


% ---------------
spl_db( equiv31_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv31_b,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv31,equivalent,equiv31_b, false).


% ---------------
spl_db( equiv32_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv32_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv32,equivalent,equiv32_b, false).


% ---------------
spl_db( equiv33_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv33_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv33,equivalent,equiv33_b, false).


% ---------------
spl_db( equiv34_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

spl_db( equiv34_b,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(equiv34,equivalent,equiv34_b, false).


% ---------------
spl_db( equiv35_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv35_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv35,equivalent,equiv35_b, true).


% ---------------
spl_db( equiv36_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv36_b,
	 spl( [ root, f1, f4, f6, f7, f9, f8, f5, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv36,equivalent,equiv36_b, false).


% ---------------
spl_db( equiv37_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv37_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv37,equivalent,equiv37_b, false).


% ---------------
spl_db( equiv38_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv38_b,
	 spl( [ root, f1, f4, f9, f2, f3, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv38,equivalent,equiv38_b, false).


% ---------------
spl_db( equiv39_a,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv39_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv39,equivalent,equiv39_b, false).


% ---------------
spl_db( equiv40_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv40_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv40,equivalent,equiv40_b, false).


% ---------------
spl_db( equiv41_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv41_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv41,equivalent,equiv41_b, false).


% ---------------
spl_db( equiv42_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv42_b,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv42,equivalent,equiv42_b, false).


% ---------------
spl_db( equiv43_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv43_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv43,equivalent,equiv43_b, true).


% ---------------
spl_db( equiv44_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv44_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv44,equivalent,equiv44_b, false).


% ---------------
spl_db( equiv45_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

spl_db( equiv45_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(equiv45,equivalent,equiv45_b, false).


% ---------------
spl_db( equiv46_a,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv46_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv46,equivalent,equiv46_b, false).


% ---------------
spl_db( equiv47_a,
	 spl( [ root, f1, f7, f2, f3, f4, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

spl_db( equiv47_b,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

test_data(equiv47,equivalent,equiv47_b, false).


% ---------------
spl_db( equiv48_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv48_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv48,equivalent,equiv48_b, false).


% ---------------
spl_db( equiv49_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [
							mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
								optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv49_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv49,equivalent,equiv49_b, false).


% ---------------
spl_db( equiv50_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv50_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv50,equivalent,equiv50_b, false).


% ---------------
spl_db( equiv51_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv51_b,
	 spl( [ root, f1, f9, f2, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv51,equivalent,equiv51_b, false).


% ---------------
spl_db( equiv52_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv52_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv52,equivalent,equiv52_b, false).


% ---------------
spl_db( equiv53_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv53_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv53,equivalent,equiv53_b, false).


% ---------------
spl_db( equiv54_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv54_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				one_or_more( [ feature( f3, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv54,equivalent,equiv54_b, false).


% ---------------
spl_db( equiv55_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv55_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv55,equivalent,equiv55_b, false).


% ---------------
spl_db( equiv56_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv56_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv56,equivalent,equiv56_b, false).


% ---------------
spl_db( equiv57_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv57_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv57,equivalent,equiv57_b, false).


% ---------------
spl_db( equiv58_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

spl_db( equiv58_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

test_data(equiv58,equivalent,equiv58_b, false).


% ---------------
spl_db( equiv59_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv59_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv59,equivalent,equiv59_b, false).


% ---------------
spl_db( equiv60_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv60_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv60,equivalent,equiv60_b, false).


% ---------------
spl_db( equiv61_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv61_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv61,equivalent,equiv61_b, false).


% ---------------
spl_db( equiv62_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv62_b,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv62,equivalent,equiv62_b, false).


% ---------------
spl_db( equiv63_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f4, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv63_b,
	 spl( [ root, f1, f9, f2, f4, f8, f5, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv63,equivalent,equiv63_b, false).


% ---------------
spl_db( equiv64_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv64_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv64,equivalent,equiv64_b, false).


% ---------------
spl_db( equiv65_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv65_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv65,equivalent,equiv65_b, false).


% ---------------
spl_db( equiv66_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv66_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv66,equivalent,equiv66_b, true).


% ---------------
spl_db( equiv67_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv67_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv67,equivalent,equiv67_b, true).


% ---------------
spl_db( equiv68_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv68_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv68,equivalent,equiv68_b, true).


% ---------------
spl_db( equiv69_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv69_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv69,equivalent,equiv69_b, false).


% ---------------
spl_db( equiv70_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv70_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv70,equivalent,equiv70_b, true).


% ---------------
spl_db( equiv71_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( equiv71_b,
	 spl( [ root, f1, f2, f5, f8, f6, f9, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [
						mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(equiv71,equivalent,equiv71_b, false).


% ---------------
spl_db( equiv72_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv72_b,
	 spl( [ root, f1, f2, f3, f5, f7, f8, f6, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [
					only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv72,equivalent,equiv72_b, false).


% ---------------
spl_db( equiv73_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv73_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv73,equivalent,equiv73_b, false).


% ---------------
spl_db( equiv74_a,
	 spl( [ root, f1, f8, f9, f2, f3, f6, f7, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv74_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv74,equivalent,equiv74_b, false).


% ---------------
spl_db( equiv75_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv75_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv75,equivalent,equiv75_b, false).


% ---------------
spl_db( equiv76_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv76_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv76,equivalent,equiv76_b, false).


% ---------------
spl_db( equiv77_a,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
					optional( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv77_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv77,equivalent,equiv77_b, false).


% ---------------
spl_db( equiv78_a,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv78_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv78,equivalent,equiv78_b, false).


% ---------------
spl_db( equiv79_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv79_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv79,equivalent,equiv79_b, true).


% ---------------
spl_db( equiv80_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv80_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv80,equivalent,equiv80_b, false).


% ---------------
spl_db( equiv81_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv81_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv81,equivalent,equiv81_b, false).


% ---------------
spl_db( equiv82_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv82_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv82,equivalent,equiv82_b, false).


% ---------------
spl_db( equiv83_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv83_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv83,equivalent,equiv83_b, false).


% ---------------
spl_db( equiv84_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv84_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv84,equivalent,equiv84_b, true).


% ---------------
spl_db( equiv85_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv85_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv85,equivalent,equiv85_b, false).


% ---------------
spl_db( equiv86_a,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv86_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv86,equivalent,equiv86_b, false).


% ---------------
spl_db( equiv87_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv87_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv87,equivalent,equiv87_b, false).


% ---------------
spl_db( equiv88_a,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv88_b,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv88,equivalent,equiv88_b, false).


% ---------------
spl_db( equiv89_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv89_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv89,equivalent,equiv89_b, false).


% ---------------
spl_db( equiv90_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( equiv90_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(equiv90,equivalent,equiv90_b, false).


% ---------------
spl_db( equiv91_a,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv91_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f8, [] ) ) ] ), feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv91,equivalent,equiv91_b, false).


% ---------------
spl_db( equiv92_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv92_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv92,equivalent,equiv92_b, false).


% ---------------
spl_db( equiv93_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv93_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv93,equivalent,equiv93_b, false).


% ---------------
spl_db( equiv94_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv94_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv94,equivalent,equiv94_b, false).


% ---------------
spl_db( equiv95_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv95_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv95,equivalent,equiv95_b, false).


% ---------------
spl_db( equiv96_a,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f8, f7, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv96_b,
	 spl( [ root, f1, f6, f2, f4, f5, f7, f8, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f5, [
						only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv96,equivalent,equiv96_b, false).


% ---------------
spl_db( equiv97_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv97_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv97,equivalent,equiv97_b, true).


% ---------------
spl_db( equiv98_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv98_b,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv98,equivalent,equiv98_b, false).


% ---------------
spl_db( equiv99_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv99_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv99,equivalent,equiv99_b, false).


% ---------------
spl_db( equiv100_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv100_b,
	 spl( [ root, f1, f2, f3, f5, f6, f8, f7, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv100,equivalent,equiv100_b, false).


% ---------------
spl_db( equiv101_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv101_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv101,equivalent,equiv101_b, false).


% ---------------
spl_db( equiv102_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv102_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv102,equivalent,equiv102_b, false).


% ---------------
spl_db( equiv103_a,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv103_b,
	 spl( [ root, f1, f3, f2, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv103,equivalent,equiv103_b, false).


% ---------------
spl_db( equiv104_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

spl_db( equiv104_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [] ), feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(equiv104,equivalent,equiv104_b, true).


% ---------------
spl_db( equiv105_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( equiv105_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(equiv105,equivalent,equiv105_b, false).


% ---------------
spl_db( equiv106_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

spl_db( equiv106_b,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f4, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(equiv106,equivalent,equiv106_b, false).


% ---------------
spl_db( equiv107_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv107_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv107,equivalent,equiv107_b, true).


% ---------------
spl_db( equiv108_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv108_b,
	 spl( [ root, f1, f2, f7, f3, f5, f6, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv108,equivalent,equiv108_b, false).


% ---------------
spl_db( equiv109_a,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv109_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv109,equivalent,equiv109_b, false).


% ---------------
spl_db( equiv110_a,
	 spl( [ root, f1, f3, f4, f5, f6, f2, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv110_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv110,equivalent,equiv110_b, false).


% ---------------
spl_db( equiv111_a,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

spl_db( equiv111_b,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(equiv111,equivalent,equiv111_b, false).


% ---------------
spl_db( equiv112_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv112_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				one_or_more( [ feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv112,equivalent,equiv112_b, false).


% ---------------
spl_db( equiv113_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv113_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv113,equivalent,equiv113_b, true).


% ---------------
spl_db( equiv114_a,
	 spl( [ root, f1, f4, f9, f2, f5, f8, f6, f7, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

spl_db( equiv114_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(equiv114,equivalent,equiv114_b, false).


% ---------------
spl_db( equiv115_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv115_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv115,equivalent,equiv115_b, false).


% ---------------
spl_db( equiv116_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv116_b,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv116,equivalent,equiv116_b, false).


% ---------------
spl_db( equiv117_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv117_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv117,equivalent,equiv117_b, false).


% ---------------
spl_db( equiv118_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv118_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv118,equivalent,equiv118_b, false).


% ---------------
spl_db( equiv119_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv119_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv119,equivalent,equiv119_b, false).


% ---------------
spl_db( equiv120_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv120_b,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv120,equivalent,equiv120_b, false).


% ---------------
spl_db( equiv121_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv121_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv121,equivalent,equiv121_b, false).


% ---------------
spl_db( equiv122_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv122_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv122,equivalent,equiv122_b, false).


% ---------------
spl_db( equiv123_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f5, f6, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv123_b,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv123,equivalent,equiv123_b, false).


% ---------------
spl_db( equiv124_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv124_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv124,equivalent,equiv124_b, false).


% ---------------
spl_db( equiv125_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv125_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
						only_one( [ feature( f7, [
							optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv125,equivalent,equiv125_b, false).


% ---------------
spl_db( equiv126_a,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f6, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv126_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv126,equivalent,equiv126_b, false).


% ---------------
spl_db( equiv127_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv127_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv127,equivalent,equiv127_b, false).


% ---------------
spl_db( equiv128_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv128_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv128,equivalent,equiv128_b, false).


% ---------------
spl_db( equiv129_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv129_b,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv129,equivalent,equiv129_b, false).


% ---------------
spl_db( equiv130_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

spl_db( equiv130_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(equiv130,equivalent,equiv130_b, false).


% ---------------
spl_db( equiv131_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv131_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv131,equivalent,equiv131_b, false).


% ---------------
spl_db( equiv132_a,
	 spl( [ root, f1, f7, f2, f3, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

spl_db( equiv132_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f6, [
							mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

test_data(equiv132,equivalent,equiv132_b, false).


% ---------------
spl_db( equiv133_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv133_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv133,equivalent,equiv133_b, false).


% ---------------
spl_db( equiv134_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv134_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv134,equivalent,equiv134_b, false).


% ---------------
spl_db( equiv135_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv135_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv135,equivalent,equiv135_b, false).


% ---------------
spl_db( equiv136_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv136_b,
	 spl( [ root, f1, f2, f4, f7, f8, f9, f5, f6, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f4, [
						optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv136,equivalent,equiv136_b, false).


% ---------------
spl_db( equiv137_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv137_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv137,equivalent,equiv137_b, false).


% ---------------
spl_db( equiv138_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv138_b,
	 spl( [ root, f1, f5, f2, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv138,equivalent,equiv138_b, false).


% ---------------
spl_db( equiv139_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv139_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv139,equivalent,equiv139_b, false).


% ---------------
spl_db( equiv140_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv140_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv140,equivalent,equiv140_b, false).


% ---------------
spl_db( equiv141_a,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

spl_db( equiv141_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(equiv141,equivalent,equiv141_b, false).


% ---------------
spl_db( equiv142_a,
	 spl( [ root, f1, f3, f6, f7, f4, f8, f9, f5, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f6, [
						optional( feature( f7, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv142_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv142,equivalent,equiv142_b, false).


% ---------------
spl_db( equiv143_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv143_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv143,equivalent,equiv143_b, false).


% ---------------
spl_db( equiv144_a,
	 spl( [ root, f1, f4, f2, f3, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv144_b,
	 spl( [ root, f1, f9, f2, f3, f7, f4, f5, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv144,equivalent,equiv144_b, false).


% ---------------
spl_db( equiv145_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv145_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv145,equivalent,equiv145_b, false).


% ---------------
spl_db( equiv146_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv146_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv146,equivalent,equiv146_b, true).


% ---------------
spl_db( equiv147_a,
	 spl( [ root, f1, f2, f3, f8, f4, f6, f9, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv147_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv147,equivalent,equiv147_b, false).


% ---------------
spl_db( equiv148_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv148_b,
	 spl( [ root, f1, f6, f2, f3, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f4, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv148,equivalent,equiv148_b, false).


% ---------------
spl_db( equiv149_a,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv149_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv149,equivalent,equiv149_b, false).


% ---------------
spl_db( equiv150_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv150_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv150,equivalent,equiv150_b, false).


% ---------------
spl_db( equiv151_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv151_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv151,equivalent,equiv151_b, true).


% ---------------
spl_db( equiv152_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv152_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv152,equivalent,equiv152_b, true).


% ---------------
spl_db( equiv153_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv153_b,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv153,equivalent,equiv153_b, false).


% ---------------
spl_db( equiv154_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv154_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv154,equivalent,equiv154_b, false).


% ---------------
spl_db( equiv155_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv155_b,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv155,equivalent,equiv155_b, false).


% ---------------
spl_db( equiv156_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv156_b,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [
						only_one( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f5, [
						mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv156,equivalent,equiv156_b, false).


% ---------------
spl_db( equiv157_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv157_b,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv157,equivalent,equiv157_b, false).


% ---------------
spl_db( equiv158_a,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv158_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv158,equivalent,equiv158_b, false).


% ---------------
spl_db( equiv159_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

spl_db( equiv159_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(equiv159,equivalent,equiv159_b, false).


% ---------------
spl_db( equiv160_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv160_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv160,equivalent,equiv160_b, false).


% ---------------
spl_db( equiv161_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv161_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv161,equivalent,equiv161_b, false).


% ---------------
spl_db( equiv162_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv162_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv162,equivalent,equiv162_b, false).


% ---------------
spl_db( equiv163_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv163_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv163,equivalent,equiv163_b, false).


% ---------------
spl_db( equiv164_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv164_b,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv164,equivalent,equiv164_b, false).


% ---------------
spl_db( equiv165_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv165_b,
	 spl( [ root, f1, f2, f7, f8, f3, f5, f9, f6, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv165,equivalent,equiv165_b, false).


% ---------------
spl_db( equiv166_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

spl_db( equiv166_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(equiv166,equivalent,equiv166_b, false).


% ---------------
spl_db( equiv167_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

spl_db( equiv167_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(equiv167,equivalent,equiv167_b, false).


% ---------------
spl_db( equiv168_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv168_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv168,equivalent,equiv168_b, false).


% ---------------
spl_db( equiv169_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv169_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv169,equivalent,equiv169_b, false).


% ---------------
spl_db( equiv170_a,
	 spl( [ root, f1, f7, f8, f2, f3, f5, f6, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv170_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv170,equivalent,equiv170_b, false).


% ---------------
spl_db( equiv171_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv171_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv171,equivalent,equiv171_b, true).


% ---------------
spl_db( equiv172_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv172_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv172,equivalent,equiv172_b, true).


% ---------------
spl_db( equiv173_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv173_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv173,equivalent,equiv173_b, false).


% ---------------
spl_db( equiv174_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv174_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv174,equivalent,equiv174_b, false).


% ---------------
spl_db( equiv175_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					optional( feature( f7, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv175_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv175,equivalent,equiv175_b, false).


% ---------------
spl_db( equiv176_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv176_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv176,equivalent,equiv176_b, true).


% ---------------
spl_db( equiv177_a,
	 spl( [ root, f1, f7, f9, f2, f3, f4, f5, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv177_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv177,equivalent,equiv177_b, false).


% ---------------
spl_db( equiv178_a,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [
					mandatory( feature( f5, [
						optional( feature( f6, [
							mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv178_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv178,equivalent,equiv178_b, false).


% ---------------
spl_db( equiv179_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv179_b,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv179,equivalent,equiv179_b, true).


% ---------------
spl_db( equiv180_a,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv180_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv180,equivalent,equiv180_b, false).


% ---------------
spl_db( equiv181_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv181_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv181,equivalent,equiv181_b, false).


% ---------------
spl_db( equiv182_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv182_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv182,equivalent,equiv182_b, false).


% ---------------
spl_db( equiv183_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
						optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv183_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv183,equivalent,equiv183_b, false).


% ---------------
spl_db( equiv184_a,
	 spl( [ root, f1, f2, f4, f9, f5, f3, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv184_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv184,equivalent,equiv184_b, false).


% ---------------
spl_db( equiv185_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

spl_db( equiv185_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(equiv185,equivalent,equiv185_b, false).


% ---------------
spl_db( equiv186_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv186_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv186,equivalent,equiv186_b, false).


% ---------------
spl_db( equiv187_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv187_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv187,equivalent,equiv187_b, false).


% ---------------
spl_db( equiv188_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv188_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv188,equivalent,equiv188_b, false).


% ---------------
spl_db( equiv189_a,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv189_b,
	 spl( [ root, f1, f2, f3, f6, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv189,equivalent,equiv189_b, false).


% ---------------
spl_db( equiv190_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv190_b,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv190,equivalent,equiv190_b, false).


% ---------------
spl_db( equiv191_a,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( equiv191_b,
	 spl( [ root, f1, f8, f9, f2, f5, f6, f3, f7, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(equiv191,equivalent,equiv191_b, false).


% ---------------
spl_db( equiv192_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv192_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv192,equivalent,equiv192_b, false).


% ---------------
spl_db( equiv193_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv193_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv193,equivalent,equiv193_b, false).


% ---------------
spl_db( equiv194_a,
	 spl( [ root, f1, f2, f4, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv194_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv194,equivalent,equiv194_b, false).


% ---------------
spl_db( equiv195_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv195_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv195,equivalent,equiv195_b, false).


% ---------------
spl_db( equiv196_a,
	 spl( [ root, f1, f4, f9, f2, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv196_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv196,equivalent,equiv196_b, false).


% ---------------
spl_db( equiv197_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( equiv197_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(equiv197,equivalent,equiv197_b, false).


% ---------------
spl_db( equiv198_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv198_b,
	 spl( [ root, f1, f2, f3, f7, f9, f4, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv198,equivalent,equiv198_b, false).


% ---------------
spl_db( equiv199_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv199_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv199,equivalent,equiv199_b, false).


% ---------------
spl_db( equiv200_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv200_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f6, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv200,equivalent,equiv200_b, false).


% ---------------
spl_db( equiv201_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv201_b,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv201,equivalent,equiv201_b, false).


% ---------------
spl_db( equiv202_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv202_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv202,equivalent,equiv202_b, false).


% ---------------
spl_db( equiv203_a,
	 spl( [ root, f1, f5, f6, f2, f3, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv203_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv203,equivalent,equiv203_b, false).


% ---------------
spl_db( equiv204_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
							optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv204_b,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv204,equivalent,equiv204_b, false).


% ---------------
spl_db( equiv205_a,
	 spl( [ root, f1, f7, f9, f2, f8, f3, f6, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv205_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv205,equivalent,equiv205_b, false).


% ---------------
spl_db( equiv206_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv206_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				one_or_more( [ feature( f4, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv206,equivalent,equiv206_b, false).


% ---------------
spl_db( equiv207_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv207_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv207,equivalent,equiv207_b, false).


% ---------------
spl_db( equiv208_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv208_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv208,equivalent,equiv208_b, false).


% ---------------
spl_db( equiv209_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv209_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv209,equivalent,equiv209_b, false).


% ---------------
spl_db( equiv210_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv210_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv210,equivalent,equiv210_b, true).


% ---------------
spl_db( equiv211_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv211_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv211,equivalent,equiv211_b, false).


% ---------------
spl_db( equiv212_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv212_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv212,equivalent,equiv212_b, false).


% ---------------
spl_db( equiv213_a,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

spl_db( equiv213_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(equiv213,equivalent,equiv213_b, false).


% ---------------
spl_db( equiv214_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv214_b,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv214,equivalent,equiv214_b, false).


% ---------------
spl_db( equiv215_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv215_b,
	 spl( [ root, f1, f2, f7, f8, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv215,equivalent,equiv215_b, false).


% ---------------
spl_db( equiv216_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv216_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv216,equivalent,equiv216_b, false).


% ---------------
spl_db( equiv217_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv217_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv217,equivalent,equiv217_b, false).


% ---------------
spl_db( equiv218_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv218_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv218,equivalent,equiv218_b, false).


% ---------------
spl_db( equiv219_a,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv219_b,
	 spl( [ root, f1, f6, f9, f7, f2, f3, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv219,equivalent,equiv219_b, false).


% ---------------
spl_db( equiv220_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv220_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv220,equivalent,equiv220_b, false).


% ---------------
spl_db( equiv221_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv221_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv221,equivalent,equiv221_b, false).


% ---------------
spl_db( equiv222_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv222_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv222,equivalent,equiv222_b, false).


% ---------------
spl_db( equiv223_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv223_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv223,equivalent,equiv223_b, false).


% ---------------
spl_db( equiv224_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv224_b,
	 spl( [ root, f1, f8, f9, f2, f5, f3, f6, f7, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv224,equivalent,equiv224_b, false).


% ---------------
spl_db( equiv225_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv225_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv225,equivalent,equiv225_b, false).


% ---------------
spl_db( equiv226_a,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv226_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv226,equivalent,equiv226_b, false).


% ---------------
spl_db( equiv227_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

spl_db( equiv227_b,
	 spl( [ root, f1, f5, f8, f9, f6, f7, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(equiv227,equivalent,equiv227_b, false).


% ---------------
spl_db( equiv228_a,
	 spl( [ root, f1, f3, f4, f6, f7, f8, f9, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f6, [
							optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv228_b,
	 spl( [ root, f1, f6, f2, f3, f7, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f7, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv228,equivalent,equiv228_b, false).


% ---------------
spl_db( equiv229_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

spl_db( equiv229_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(equiv229,equivalent,equiv229_b, false).


% ---------------
spl_db( equiv230_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f6, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
					optional( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv230_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv230,equivalent,equiv230_b, false).


% ---------------
spl_db( equiv231_a,
	 spl( [ root, f1, f5, f9, f6, f2, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv231_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv231,equivalent,equiv231_b, false).


% ---------------
spl_db( equiv232_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv232_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv232,equivalent,equiv232_b, false).


% ---------------
spl_db( equiv233_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv233_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv233,equivalent,equiv233_b, false).


% ---------------
spl_db( equiv234_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv234_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv234,equivalent,equiv234_b, false).


% ---------------
spl_db( equiv235_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv235_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv235,equivalent,equiv235_b, false).


% ---------------
spl_db( equiv236_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv236_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv236,equivalent,equiv236_b, false).


% ---------------
spl_db( equiv237_a,
	 spl( [ root, f1, f4, f9, f2, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv237_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv237,equivalent,equiv237_b, false).


% ---------------
spl_db( equiv238_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv238_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv238,equivalent,equiv238_b, false).


% ---------------
spl_db( equiv239_a,
	 spl( [ root, f1, f5, f6, f7, f2, f8, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv239_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv239,equivalent,equiv239_b, false).


% ---------------
spl_db( equiv240_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv240_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv240,equivalent,equiv240_b, false).


% ---------------
spl_db( equiv241_a,
	 spl( [ root, f1, f2, f6, f8, f9, f7, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv241_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv241,equivalent,equiv241_b, false).


% ---------------
spl_db( equiv242_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv242_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv242,equivalent,equiv242_b, true).


% ---------------
spl_db( equiv243_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv243_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv243,equivalent,equiv243_b, false).


% ---------------
spl_db( equiv244_a,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv244_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv244,equivalent,equiv244_b, false).


% ---------------
spl_db( equiv245_a,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv245_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv245,equivalent,equiv245_b, false).


% ---------------
spl_db( equiv246_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv246_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv246,equivalent,equiv246_b, false).


% ---------------
spl_db( equiv247_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

spl_db( equiv247_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(equiv247,equivalent,equiv247_b, false).


% ---------------
spl_db( equiv248_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv248_b,
	 spl( [ root, f1, f2, f8, f3, f4, f7, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv248,equivalent,equiv248_b, false).


% ---------------
spl_db( equiv249_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [
						mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv249_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv249,equivalent,equiv249_b, false).


% ---------------
spl_db( equiv250_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv250_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv250,equivalent,equiv250_b, false).


% ---------------
spl_db( equiv251_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv251_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv251,equivalent,equiv251_b, true).


% ---------------
spl_db( equiv252_a,
	 spl( [ root, f1, f3, f2, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv252_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv252,equivalent,equiv252_b, false).


% ---------------
spl_db( equiv253_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv253_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv253,equivalent,equiv253_b, false).


% ---------------
spl_db( equiv254_a,
	 spl( [ root, f1, f2, f4, f8, f5, f9, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv254_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv254,equivalent,equiv254_b, false).


% ---------------
spl_db( equiv255_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [
					only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv255_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv255,equivalent,equiv255_b, false).


% ---------------
spl_db( equiv256_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv256_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv256,equivalent,equiv256_b, false).


% ---------------
spl_db( equiv257_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

spl_db( equiv257_b,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(equiv257,equivalent,equiv257_b, false).


% ---------------
spl_db( equiv258_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv258_b,
	 spl( [ root, f1, f2, f4, f6, f7, f8, f9, f5, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv258,equivalent,equiv258_b, false).


% ---------------
spl_db( equiv259_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv259_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv259,equivalent,equiv259_b, true).


% ---------------
spl_db( equiv260_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv260_b,
	 spl( [ root, f1, f2, f3, f6, f8, f9, f4, f7, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f6, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv260,equivalent,equiv260_b, false).


% ---------------
spl_db( equiv261_a,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv261_b,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv261,equivalent,equiv261_b, false).


% ---------------
spl_db( equiv262_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv262_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv262,equivalent,equiv262_b, false).


% ---------------
spl_db( equiv263_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv263_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv263,equivalent,equiv263_b, true).


% ---------------
spl_db( equiv264_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv264_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv264,equivalent,equiv264_b, true).


% ---------------
spl_db( equiv265_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv265_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv265,equivalent,equiv265_b, false).


% ---------------
spl_db( equiv266_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv266_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv266,equivalent,equiv266_b, true).


% ---------------
spl_db( equiv267_a,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv267_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv267,equivalent,equiv267_b, false).


% ---------------
spl_db( equiv268_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv268_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv268,equivalent,equiv268_b, false).


% ---------------
spl_db( equiv269_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv269_b,
	 spl( [ root, f1, f3, f5, f6, f9, f7, f8, f4, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv269,equivalent,equiv269_b, false).


% ---------------
spl_db( equiv270_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv270_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv270,equivalent,equiv270_b, false).


% ---------------
spl_db( equiv271_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv271_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv271,equivalent,equiv271_b, false).


% ---------------
spl_db( equiv272_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv272_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv272,equivalent,equiv272_b, false).


% ---------------
spl_db( equiv273_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv273_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv273,equivalent,equiv273_b, false).


% ---------------
spl_db( equiv274_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( equiv274_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [
							mandatory( feature( f5, [
								mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(equiv274,equivalent,equiv274_b, false).


% ---------------
spl_db( equiv275_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv275_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv275,equivalent,equiv275_b, true).


% ---------------
spl_db( equiv276_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv276_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv276,equivalent,equiv276_b, false).


% ---------------
spl_db( equiv277_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv277_b,
	 spl( [ root, f1, f5, f2, f7, f9, f8, f3, f6, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [
				optional( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv277,equivalent,equiv277_b, false).


% ---------------
spl_db( equiv278_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv278_b,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv278,equivalent,equiv278_b, false).


% ---------------
spl_db( equiv279_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv279_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv279,equivalent,equiv279_b, false).


% ---------------
spl_db( equiv280_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

spl_db( equiv280_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(equiv280,equivalent,equiv280_b, false).


% ---------------
spl_db( equiv281_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv281_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv281,equivalent,equiv281_b, false).


% ---------------
spl_db( equiv282_a,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv282_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv282,equivalent,equiv282_b, false).


% ---------------
spl_db( equiv283_a,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f2, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv283_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [
				only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv283,equivalent,equiv283_b, false).


% ---------------
spl_db( equiv284_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv284_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv284,equivalent,equiv284_b, false).


% ---------------
spl_db( equiv285_a,
	 spl( [ root, f1, f2, f4, f3, f5, f8, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv285_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv285,equivalent,equiv285_b, false).


% ---------------
spl_db( equiv286_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv286_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv286,equivalent,equiv286_b, false).


% ---------------
spl_db( equiv287_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv287_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv287,equivalent,equiv287_b, false).


% ---------------
spl_db( equiv288_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv288_b,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv288,equivalent,equiv288_b, false).


% ---------------
spl_db( equiv289_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( equiv289_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(equiv289,equivalent,equiv289_b, false).


% ---------------
spl_db( equiv290_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv290_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv290,equivalent,equiv290_b, false).


% ---------------
spl_db( equiv291_a,
	 spl( [ root, f1, f2, f3, f5, f6, f8, f9, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv291_b,
	 spl( [ root, f1, f8, f9, f2, f7, f3, f6, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv291,equivalent,equiv291_b, false).


% ---------------
spl_db( equiv292_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv292_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv292,equivalent,equiv292_b, false).


% ---------------
spl_db( equiv293_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv293_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv293,equivalent,equiv293_b, false).


% ---------------
spl_db( equiv294_a,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv294_b,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv294,equivalent,equiv294_b, false).


% ---------------
spl_db( equiv295_a,
	 spl( [ root, f1, f3, f7, f8, f9, f4, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv295_b,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv295,equivalent,equiv295_b, false).


% ---------------
spl_db( equiv296_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv296_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv296,equivalent,equiv296_b, false).


% ---------------
spl_db( equiv297_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv297_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv297,equivalent,equiv297_b, false).


% ---------------
spl_db( equiv298_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv298_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv298,equivalent,equiv298_b, false).


% ---------------
spl_db( equiv299_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv299_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv299,equivalent,equiv299_b, false).


% ---------------
spl_db( equiv300_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv300_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv300,equivalent,equiv300_b, false).


% ---------------
spl_db( equiv301_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv301_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv301,equivalent,equiv301_b, false).


% ---------------
spl_db( equiv302_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
							optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv302_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv302,equivalent,equiv302_b, false).


% ---------------
spl_db( equiv303_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv303_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv303,equivalent,equiv303_b, false).


% ---------------
spl_db( equiv304_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv304_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv304,equivalent,equiv304_b, false).


% ---------------
spl_db( equiv305_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv305_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv305,equivalent,equiv305_b, false).


% ---------------
spl_db( equiv306_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv306_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv306,equivalent,equiv306_b, false).


% ---------------
spl_db( equiv307_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv307_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv307,equivalent,equiv307_b, false).


% ---------------
spl_db( equiv308_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv308_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv308,equivalent,equiv308_b, false).


% ---------------
spl_db( equiv309_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv309_b,
	 spl( [ root, f1, f2, f3, f7, f9, f4, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv309,equivalent,equiv309_b, false).


% ---------------
spl_db( equiv310_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv310_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv310,equivalent,equiv310_b, false).


% ---------------
spl_db( equiv311_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv311_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv311,equivalent,equiv311_b, false).


% ---------------
spl_db( equiv312_a,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f4, f5, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv312_b,
	 spl( [ root, f1, f2, f7, f9, f3, f4, f5, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv312,equivalent,equiv312_b, false).


% ---------------
spl_db( equiv313_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv313_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv313,equivalent,equiv313_b, false).


% ---------------
spl_db( equiv314_a,
	 spl( [ root, f1, f2, f7, f3, f4, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv314_b,
	 spl( [ root, f1, f5, f7, f8, f9, f6, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv314,equivalent,equiv314_b, false).


% ---------------
spl_db( equiv315_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv315_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv315,equivalent,equiv315_b, false).


% ---------------
spl_db( equiv316_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv316_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv316,equivalent,equiv316_b, true).


% ---------------
spl_db( equiv317_a,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv317_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv317,equivalent,equiv317_b, false).


% ---------------
spl_db( equiv318_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv318_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv318,equivalent,equiv318_b, false).


% ---------------
spl_db( equiv319_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv319_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv319,equivalent,equiv319_b, false).


% ---------------
spl_db( equiv320_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv320_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv320,equivalent,equiv320_b, false).


% ---------------
spl_db( equiv321_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv321_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv321,equivalent,equiv321_b, true).


% ---------------
spl_db( equiv322_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv322_b,
	 spl( [ root, f1, f2, f7, f8, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv322,equivalent,equiv322_b, false).


% ---------------
spl_db( equiv323_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv323_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv323,equivalent,equiv323_b, false).


% ---------------
spl_db( equiv324_a,
	 spl( [ root, f1, f2, f3, f5, f6, f4, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv324_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv324,equivalent,equiv324_b, false).


% ---------------
spl_db( equiv325_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv325_b,
	 spl( [ root, f1, f4, f5, f7, f9, f8, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv325,equivalent,equiv325_b, false).


% ---------------
spl_db( equiv326_a,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv326_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv326,equivalent,equiv326_b, false).


% ---------------
spl_db( equiv327_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv327_b,
	 spl( [ root, f1, f2, f3, f5, f8, f9, f6, f4, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						one_or_more( [ feature( f5, [
							mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f4, [
						mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv327,equivalent,equiv327_b, false).


% ---------------
spl_db( equiv328_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv328_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv328,equivalent,equiv328_b, true).


% ---------------
spl_db( equiv329_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv329_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv329,equivalent,equiv329_b, false).


% ---------------
spl_db( equiv330_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv330_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv330,equivalent,equiv330_b, false).


% ---------------
spl_db( equiv331_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv331_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv331,equivalent,equiv331_b, false).


% ---------------
spl_db( equiv332_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv332_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv332,equivalent,equiv332_b, false).


% ---------------
spl_db( equiv333_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv333_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv333,equivalent,equiv333_b, false).


% ---------------
spl_db( equiv334_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv334_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv334,equivalent,equiv334_b, false).


% ---------------
spl_db( equiv335_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv335_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f7, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv335,equivalent,equiv335_b, false).


% ---------------
spl_db( equiv336_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv336_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv336,equivalent,equiv336_b, false).


% ---------------
spl_db( equiv337_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv337_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv337,equivalent,equiv337_b, false).


% ---------------
spl_db( equiv338_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv338_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv338,equivalent,equiv338_b, true).


% ---------------
spl_db( equiv339_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv339_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv339,equivalent,equiv339_b, false).


% ---------------
spl_db( equiv340_a,
	 spl( [ root, f1, f2, f7, f8, f3, f6, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv340_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv340,equivalent,equiv340_b, false).


% ---------------
spl_db( equiv341_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv341_b,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv341,equivalent,equiv341_b, false).


% ---------------
spl_db( equiv342_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv342_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv342,equivalent,equiv342_b, false).


% ---------------
spl_db( equiv343_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv343_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv343,equivalent,equiv343_b, true).


% ---------------
spl_db( equiv344_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv344_b,
	 spl( [ root, f1, f7, f9, f8, f2, f4, f5, f6, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv344,equivalent,equiv344_b, false).


% ---------------
spl_db( equiv345_a,
	 spl( [ root, f1, f4, f5, f7, f8, f6, f2, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ), feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv345_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv345,equivalent,equiv345_b, false).


% ---------------
spl_db( equiv346_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv346_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv346,equivalent,equiv346_b, false).


% ---------------
spl_db( equiv347_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv347_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv347,equivalent,equiv347_b, false).


% ---------------
spl_db( equiv348_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv348_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv348,equivalent,equiv348_b, false).


% ---------------
spl_db( equiv349_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv349_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv349,equivalent,equiv349_b, true).


% ---------------
spl_db( equiv350_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv350_b,
	 spl( [ root, f1, f5, f2, f6, f3, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv350,equivalent,equiv350_b, false).


% ---------------
spl_db( equiv351_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv351_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv351,equivalent,equiv351_b, false).


% ---------------
spl_db( equiv352_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv352_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv352,equivalent,equiv352_b, false).


% ---------------
spl_db( equiv353_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv353_b,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv353,equivalent,equiv353_b, false).


% ---------------
spl_db( equiv354_a,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

spl_db( equiv354_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(equiv354,equivalent,equiv354_b, false).


% ---------------
spl_db( equiv355_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv355_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv355,equivalent,equiv355_b, false).


% ---------------
spl_db( equiv356_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv356_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv356,equivalent,equiv356_b, false).


% ---------------
spl_db( equiv357_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv357_b,
	 spl( [ root, f1, f4, f5, f2, f6, f7, f3, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv357,equivalent,equiv357_b, false).


% ---------------
spl_db( equiv358_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv358_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv358,equivalent,equiv358_b, false).


% ---------------
spl_db( equiv359_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv359_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv359,equivalent,equiv359_b, false).


% ---------------
spl_db( equiv360_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv360_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv360,equivalent,equiv360_b, false).


% ---------------
spl_db( equiv361_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv361_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f2, [] ), feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv361,equivalent,equiv361_b, false).


% ---------------
spl_db( equiv362_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv362_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv362,equivalent,equiv362_b, false).


% ---------------
spl_db( equiv363_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv363_b,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv363,equivalent,equiv363_b, false).


% ---------------
spl_db( equiv364_a,
	 spl( [ root, f1, f4, f2, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv364_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv364,equivalent,equiv364_b, false).


% ---------------
spl_db( equiv365_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv365_b,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [
							optional( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv365,equivalent,equiv365_b, false).


% ---------------
spl_db( equiv366_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv366_b,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv366,equivalent,equiv366_b, false).


% ---------------
spl_db( equiv367_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv367_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv367,equivalent,equiv367_b, false).


% ---------------
spl_db( equiv368_a,
	 spl( [ root, f1, f3, f4, f7, f5, f6, f2, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ), feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv368_b,
	 spl( [ root, f1, f2, f3, f6, f8, f7, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv368,equivalent,equiv368_b, false).


% ---------------
spl_db( equiv369_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv369_b,
	 spl( [ root, f1, f4, f5, f6, f8, f9, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv369,equivalent,equiv369_b, false).


% ---------------
spl_db( equiv370_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv370_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv370,equivalent,equiv370_b, false).


% ---------------
spl_db( equiv371_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( equiv371_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(equiv371,equivalent,equiv371_b, false).


% ---------------
spl_db( equiv372_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv372_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv372,equivalent,equiv372_b, false).


% ---------------
spl_db( equiv373_a,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv373_b,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv373,equivalent,equiv373_b, false).


% ---------------
spl_db( equiv374_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv374_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv374,equivalent,equiv374_b, false).


% ---------------
spl_db( equiv375_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv375_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv375,equivalent,equiv375_b, false).


% ---------------
spl_db( equiv376_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv376_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv376,equivalent,equiv376_b, false).


% ---------------
spl_db( equiv377_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv377_b,
	 spl( [ root, f1, f2, f6, f3, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv377,equivalent,equiv377_b, false).


% ---------------
spl_db( equiv378_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

spl_db( equiv378_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(equiv378,equivalent,equiv378_b, false).


% ---------------
spl_db( equiv379_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f4, f5, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv379_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv379,equivalent,equiv379_b, false).


% ---------------
spl_db( equiv380_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv380_b,
	 spl( [ root, f1, f3, f4, f8, f9, f5, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
						optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv380,equivalent,equiv380_b, false).


% ---------------
spl_db( equiv381_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv381_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv381,equivalent,equiv381_b, false).


% ---------------
spl_db( equiv382_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv382_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv382,equivalent,equiv382_b, false).


% ---------------
spl_db( equiv383_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv383_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv383,equivalent,equiv383_b, false).


% ---------------
spl_db( equiv384_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv384_b,
	 spl( [ root, f1, f3, f8, f4, f5, f6, f7, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv384,equivalent,equiv384_b, false).


% ---------------
spl_db( equiv385_a,
	 spl( [ root, f1, f2, f7, f3, f9, f4, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv385_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv385,equivalent,equiv385_b, false).


% ---------------
spl_db( equiv386_a,
	 spl( [ root, f1, f2, f9, f3, f5, f8, f6, f7, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv386_b,
	 spl( [ root, f1, f7, f2, f3, f4, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv386,equivalent,equiv386_b, false).


% ---------------
spl_db( equiv387_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv387_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv387,equivalent,equiv387_b, false).


% ---------------
spl_db( equiv388_a,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv388_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv388,equivalent,equiv388_b, false).


% ---------------
spl_db( equiv389_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv389_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv389,equivalent,equiv389_b, false).


% ---------------
spl_db( equiv390_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv390_b,
	 spl( [ root, f1, f2, f3, f6, f7, f4, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv390,equivalent,equiv390_b, false).


% ---------------
spl_db( equiv391_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv391_b,
	 spl( [ root, f1, f5, f6, f2, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv391,equivalent,equiv391_b, false).


% ---------------
spl_db( equiv392_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv392_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv392,equivalent,equiv392_b, false).


% ---------------
spl_db( equiv393_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv393_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv393,equivalent,equiv393_b, true).


% ---------------
spl_db( equiv394_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv394_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv394,equivalent,equiv394_b, false).


% ---------------
spl_db( equiv395_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv395_b,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv395,equivalent,equiv395_b, false).


% ---------------
spl_db( equiv396_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( equiv396_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(equiv396,equivalent,equiv396_b, false).


% ---------------
spl_db( equiv397_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv397_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv397,equivalent,equiv397_b, false).


% ---------------
spl_db( equiv398_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv398_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv398,equivalent,equiv398_b, false).


% ---------------
spl_db( equiv399_a,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv399_b,
	 spl( [ root, f1, f6, f2, f3, f4, f8, f5, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv399,equivalent,equiv399_b, false).


% ---------------
spl_db( equiv400_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv400_b,
	 spl( [ root, f1, f5, f6, f8, f7, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv400,equivalent,equiv400_b, false).


% ---------------
spl_db( equiv401_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv401_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv401,equivalent,equiv401_b, false).


% ---------------
spl_db( equiv402_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv402_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv402,equivalent,equiv402_b, false).


% ---------------
spl_db( equiv403_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv403_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv403,equivalent,equiv403_b, false).


% ---------------
spl_db( equiv404_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
						mandatory( feature( f8, [] ) ) ] ), feature( f6, [
						optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv404_b,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f3, f4, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv404,equivalent,equiv404_b, false).


% ---------------
spl_db( equiv405_a,
	 spl( [ root, f1, f8, f9, f2, f4, f5, f6, f7, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv405_b,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f2, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv405,equivalent,equiv405_b, false).


% ---------------
spl_db( equiv406_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv406_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv406,equivalent,equiv406_b, true).


% ---------------
spl_db( equiv407_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv407_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv407,equivalent,equiv407_b, false).


% ---------------
spl_db( equiv408_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv408_b,
	 spl( [ root, f1, f2, f3, f6, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv408,equivalent,equiv408_b, false).


% ---------------
spl_db( equiv409_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv409_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv409,equivalent,equiv409_b, false).


% ---------------
spl_db( equiv410_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv410_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv410,equivalent,equiv410_b, false).


% ---------------
spl_db( equiv411_a,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv411_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv411,equivalent,equiv411_b, false).


% ---------------
spl_db( equiv412_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv412_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv412,equivalent,equiv412_b, true).


% ---------------
spl_db( equiv413_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv413_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv413,equivalent,equiv413_b, true).


% ---------------
spl_db( equiv414_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv414_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv414,equivalent,equiv414_b, true).


% ---------------
spl_db( equiv415_a,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv415_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [
						mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv415,equivalent,equiv415_b, false).


% ---------------
spl_db( equiv416_a,
	 spl( [ root, f1, f3, f8, f9, f4, f2, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f3, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv416_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv416,equivalent,equiv416_b, false).


% ---------------
spl_db( equiv417_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv417_b,
	 spl( [ root, f1, f5, f6, f7, f2, f3, f4, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv417,equivalent,equiv417_b, false).


% ---------------
spl_db( equiv418_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv418_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv418,equivalent,equiv418_b, false).


% ---------------
spl_db( equiv419_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv419_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv419,equivalent,equiv419_b, false).


% ---------------
spl_db( equiv420_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv420_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv420,equivalent,equiv420_b, false).


% ---------------
spl_db( equiv421_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv421_b,
	 spl( [ root, f1, f6, f7, f8, f2, f4, f5, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv421,equivalent,equiv421_b, false).


% ---------------
spl_db( equiv422_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv422_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv422,equivalent,equiv422_b, false).


% ---------------
spl_db( equiv423_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv423_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv423,equivalent,equiv423_b, false).


% ---------------
spl_db( equiv424_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv424_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv424,equivalent,equiv424_b, false).


% ---------------
spl_db( equiv425_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv425_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv425,equivalent,equiv425_b, false).


% ---------------
spl_db( equiv426_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv426_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv426,equivalent,equiv426_b, false).


% ---------------
spl_db( equiv427_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv427_b,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv427,equivalent,equiv427_b, false).


% ---------------
spl_db( equiv428_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv428_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv428,equivalent,equiv428_b, false).


% ---------------
spl_db( equiv429_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv429_b,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv429,equivalent,equiv429_b, false).


% ---------------
spl_db( equiv430_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f5, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f5, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv430_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv430,equivalent,equiv430_b, false).


% ---------------
spl_db( equiv431_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

spl_db( equiv431_b,
	 spl( [ root, f1, f5, f8, f9, f6, f7, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(equiv431,equivalent,equiv431_b, false).


% ---------------
spl_db( equiv432_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [
					optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv432_b,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv432,equivalent,equiv432_b, false).


% ---------------
spl_db( equiv433_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv433_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv433,equivalent,equiv433_b, false).


% ---------------
spl_db( equiv434_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv434_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv434,equivalent,equiv434_b, true).


% ---------------
spl_db( equiv435_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv435_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv435,equivalent,equiv435_b, false).


% ---------------
spl_db( equiv436_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv436_b,
	 spl( [ root, f1, f6, f8, f9, f7, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv436,equivalent,equiv436_b, false).


% ---------------
spl_db( equiv437_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv437_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv437,equivalent,equiv437_b, false).


% ---------------
spl_db( equiv438_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv438_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv438,equivalent,equiv438_b, false).


% ---------------
spl_db( equiv439_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv439_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv439,equivalent,equiv439_b, false).


% ---------------
spl_db( equiv440_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv440_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv440,equivalent,equiv440_b, false).


% ---------------
spl_db( equiv441_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv441_b,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f6, [
							optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv441,equivalent,equiv441_b, false).


% ---------------
spl_db( equiv442_a,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f6, [
						mandatory( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv442_b,
	 spl( [ root, f1, f9, f2, f6, f3, f4, f5, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv442,equivalent,equiv442_b, false).


% ---------------
spl_db( equiv443_a,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv443_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv443,equivalent,equiv443_b, false).


% ---------------
spl_db( equiv444_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv444_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv444,equivalent,equiv444_b, false).


% ---------------
spl_db( equiv445_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv445_b,
	 spl( [ root, f1, f2, f5, f9, f6, f3, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f5, [
						mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), only_one( [ feature( f3, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv445,equivalent,equiv445_b, false).


% ---------------
spl_db( equiv446_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv446_b,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv446,equivalent,equiv446_b, false).


% ---------------
spl_db( equiv447_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv447_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv447,equivalent,equiv447_b, true).


% ---------------
spl_db( equiv448_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv448_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv448,equivalent,equiv448_b, false).


% ---------------
spl_db( equiv449_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv449_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv449,equivalent,equiv449_b, true).


% ---------------
spl_db( equiv450_a,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv450_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f5, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv450,equivalent,equiv450_b, false).


% ---------------
spl_db( equiv451_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv451_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv451,equivalent,equiv451_b, false).


% ---------------
spl_db( equiv452_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv452_b,
	 spl( [ root, f1, f2, f6, f7, f9, f3, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv452,equivalent,equiv452_b, false).


% ---------------
spl_db( equiv453_a,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv453_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv453,equivalent,equiv453_b, false).


% ---------------
spl_db( equiv454_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv454_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv454,equivalent,equiv454_b, false).


% ---------------
spl_db( equiv455_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv455_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv455,equivalent,equiv455_b, false).


% ---------------
spl_db( equiv456_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

spl_db( equiv456_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(equiv456,equivalent,equiv456_b, false).


% ---------------
spl_db( equiv457_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv457_b,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv457,equivalent,equiv457_b, false).


% ---------------
spl_db( equiv458_a,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv458_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv458,equivalent,equiv458_b, false).


% ---------------
spl_db( equiv459_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv459_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv459,equivalent,equiv459_b, false).


% ---------------
spl_db( equiv460_a,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv460_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv460,equivalent,equiv460_b, false).


% ---------------
spl_db( equiv461_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv461_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv461,equivalent,equiv461_b, true).


% ---------------
spl_db( equiv462_a,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f4, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv462_b,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv462,equivalent,equiv462_b, false).


% ---------------
spl_db( equiv463_a,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv463_b,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv463,equivalent,equiv463_b, false).


% ---------------
spl_db( equiv464_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv464_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv464,equivalent,equiv464_b, false).


% ---------------
spl_db( equiv465_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv465_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv465,equivalent,equiv465_b, false).


% ---------------
spl_db( equiv466_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f3, [
					mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv466_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv466,equivalent,equiv466_b, false).


% ---------------
spl_db( equiv467_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv467_b,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv467,equivalent,equiv467_b, false).


% ---------------
spl_db( equiv468_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv468_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv468,equivalent,equiv468_b, false).


% ---------------
spl_db( equiv469_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv469_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv469,equivalent,equiv469_b, false).


% ---------------
spl_db( equiv470_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv470_b,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv470,equivalent,equiv470_b, false).


% ---------------
spl_db( equiv471_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [
						optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv471_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv471,equivalent,equiv471_b, false).


% ---------------
spl_db( equiv472_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv472_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv472,equivalent,equiv472_b, false).


% ---------------
spl_db( equiv473_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv473_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
						mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv473,equivalent,equiv473_b, false).


% ---------------
spl_db( equiv474_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv474_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv474,equivalent,equiv474_b, false).


% ---------------
spl_db( equiv475_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv475_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv475,equivalent,equiv475_b, true).


% ---------------
spl_db( equiv476_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv476_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv476,equivalent,equiv476_b, true).


% ---------------
spl_db( equiv477_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv477_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv477,equivalent,equiv477_b, false).


% ---------------
spl_db( equiv478_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv478_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv478,equivalent,equiv478_b, false).


% ---------------
spl_db( equiv479_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv479_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv479,equivalent,equiv479_b, false).


% ---------------
spl_db( equiv480_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv480_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv480,equivalent,equiv480_b, false).


% ---------------
spl_db( equiv481_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv481_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv481,equivalent,equiv481_b, false).


% ---------------
spl_db( equiv482_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv482_b,
	 spl( [ root, f1, f8, f2, f4, f9, f5, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv482,equivalent,equiv482_b, false).


% ---------------
spl_db( equiv483_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv483_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv483,equivalent,equiv483_b, false).


% ---------------
spl_db( equiv484_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

spl_db( equiv484_b,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(equiv484,equivalent,equiv484_b, false).


% ---------------
spl_db( equiv485_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv485_b,
	 spl( [ root, f1, f2, f4, f9, f5, f7, f8, f6, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv485,equivalent,equiv485_b, false).


% ---------------
spl_db( equiv486_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f4, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv486_b,
	 spl( [ root, f1, f2, f3, f5, f7, f6, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv486,equivalent,equiv486_b, false).


% ---------------
spl_db( equiv487_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv487_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv487,equivalent,equiv487_b, false).


% ---------------
spl_db( equiv488_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv488_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv488,equivalent,equiv488_b, false).


% ---------------
spl_db( equiv489_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv489_b,
	 spl( [ root, f1, f5, f6, f7, f2, f3, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv489,equivalent,equiv489_b, false).


% ---------------
spl_db( equiv490_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv490_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv490,equivalent,equiv490_b, false).


% ---------------
spl_db( equiv491_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv491_b,
	 spl( [ root, f1, f2, f4, f7, f8, f9, f5, f6, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv491,equivalent,equiv491_b, false).


% ---------------
spl_db( equiv492_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv492_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv492,equivalent,equiv492_b, false).


% ---------------
spl_db( equiv493_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv493_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv493,equivalent,equiv493_b, true).


% ---------------
spl_db( equiv494_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv494_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv494,equivalent,equiv494_b, false).


% ---------------
spl_db( equiv495_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv495_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv495,equivalent,equiv495_b, false).


% ---------------
spl_db( equiv496_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv496_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv496,equivalent,equiv496_b, false).


% ---------------
spl_db( equiv497_a,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

spl_db( equiv497_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

test_data(equiv497,equivalent,equiv497_b, false).


% ---------------
spl_db( equiv498_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv498_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv498,equivalent,equiv498_b, true).


% ---------------
spl_db( equiv499_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv499_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f9, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv499,equivalent,equiv499_b, false).


% ---------------
spl_db( equiv500_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv500_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv500,equivalent,equiv500_b, false).


% ---------------
spl_db( equiv501_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

spl_db( equiv501_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(equiv501,equivalent,equiv501_b, false).


% ---------------
spl_db( equiv502_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv502_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv502,equivalent,equiv502_b, false).


% ---------------
spl_db( equiv503_a,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv503_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv503,equivalent,equiv503_b, false).


% ---------------
spl_db( equiv504_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv504_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv504,equivalent,equiv504_b, false).


% ---------------
spl_db( equiv505_a,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv505_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv505,equivalent,equiv505_b, false).


% ---------------
spl_db( equiv506_a,
	 spl( [ root, f1, f9, f2, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv506_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv506,equivalent,equiv506_b, false).


% ---------------
spl_db( equiv507_a,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv507_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv507,equivalent,equiv507_b, false).


% ---------------
spl_db( equiv508_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv508_b,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv508,equivalent,equiv508_b, false).


% ---------------
spl_db( equiv509_a,
	 spl( [ root, f1, f2, f3, f7, f4, f9, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv509_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv509,equivalent,equiv509_b, false).


% ---------------
spl_db( equiv510_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv510_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv510,equivalent,equiv510_b, false).


% ---------------
spl_db( equiv511_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv511_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv511,equivalent,equiv511_b, true).


% ---------------
spl_db( equiv512_a,
	 spl( [ root, f1, f5, f6, f2, f9, f3, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv512_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv512,equivalent,equiv512_b, false).


% ---------------
spl_db( equiv513_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv513_b,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv513,equivalent,equiv513_b, false).


% ---------------
spl_db( equiv514_a,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv514_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv514,equivalent,equiv514_b, false).


% ---------------
spl_db( equiv515_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				optional( feature( f3, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv515_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv515,equivalent,equiv515_b, false).


% ---------------
spl_db( equiv516_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( equiv516_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(equiv516,equivalent,equiv516_b, false).


% ---------------
spl_db( equiv517_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv517_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv517,equivalent,equiv517_b, false).


% ---------------
spl_db( equiv518_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

spl_db( equiv518_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(equiv518,equivalent,equiv518_b, false).


% ---------------
spl_db( equiv519_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv519_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv519,equivalent,equiv519_b, true).


% ---------------
spl_db( equiv520_a,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

spl_db( equiv520_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

test_data(equiv520,equivalent,equiv520_b, false).


% ---------------
spl_db( equiv521_a,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv521_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv521,equivalent,equiv521_b, false).


% ---------------
spl_db( equiv522_a,
	 spl( [ root, f1, f3, f4, f5, f7, f8, f9, f2, f6 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [
						optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ), feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv522_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv522,equivalent,equiv522_b, false).


% ---------------
spl_db( equiv523_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv523_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv523,equivalent,equiv523_b, false).


% ---------------
spl_db( equiv524_a,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv524_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv524,equivalent,equiv524_b, false).


% ---------------
spl_db( equiv525_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv525_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv525,equivalent,equiv525_b, false).


% ---------------
spl_db( equiv526_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv526_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv526,equivalent,equiv526_b, false).


% ---------------
spl_db( equiv527_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv527_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv527,equivalent,equiv527_b, true).


% ---------------
spl_db( equiv528_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv528_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv528,equivalent,equiv528_b, false).


% ---------------
spl_db( equiv529_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv529_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv529,equivalent,equiv529_b, false).


% ---------------
spl_db( equiv530_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv530_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv530,equivalent,equiv530_b, false).


% ---------------
spl_db( equiv531_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv531_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv531,equivalent,equiv531_b, false).


% ---------------
spl_db( equiv532_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv532_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv532,equivalent,equiv532_b, false).


% ---------------
spl_db( equiv533_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv533_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv533,equivalent,equiv533_b, true).


% ---------------
spl_db( equiv534_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv534_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv534,equivalent,equiv534_b, false).


% ---------------
spl_db( equiv535_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv535_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv535,equivalent,equiv535_b, true).


% ---------------
spl_db( equiv536_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv536_b,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv536,equivalent,equiv536_b, false).


% ---------------
spl_db( equiv537_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv537_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv537,equivalent,equiv537_b, false).


% ---------------
spl_db( equiv538_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv538_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv538,equivalent,equiv538_b, false).


% ---------------
spl_db( equiv539_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv539_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv539,equivalent,equiv539_b, false).


% ---------------
spl_db( equiv540_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv540_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv540,equivalent,equiv540_b, false).


% ---------------
spl_db( equiv541_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv541_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv541,equivalent,equiv541_b, false).


% ---------------
spl_db( equiv542_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

spl_db( equiv542_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

test_data(equiv542,equivalent,equiv542_b, false).


% ---------------
spl_db( equiv543_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( equiv543_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(equiv543,equivalent,equiv543_b, false).


% ---------------
spl_db( equiv544_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv544_b,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv544,equivalent,equiv544_b, false).


% ---------------
spl_db( equiv545_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv545_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [
						mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
							mandatory( feature( f8, [
								mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv545,equivalent,equiv545_b, false).


% ---------------
spl_db( equiv546_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv546_b,
	 spl( [ root, f1, f2, f3, f7, f9, f4, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv546,equivalent,equiv546_b, false).


% ---------------
spl_db( equiv547_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv547_b,
	 spl( [ root, f1, f5, f2, f3, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv547,equivalent,equiv547_b, false).


% ---------------
spl_db( equiv548_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv548_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv548,equivalent,equiv548_b, false).


% ---------------
spl_db( equiv549_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv549_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv549,equivalent,equiv549_b, false).


% ---------------
spl_db( equiv550_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv550_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv550,equivalent,equiv550_b, false).


% ---------------
spl_db( equiv551_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv551_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv551,equivalent,equiv551_b, false).


% ---------------
spl_db( equiv552_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [
					mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv552_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv552,equivalent,equiv552_b, false).


% ---------------
spl_db( equiv553_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv553_b,
	 spl( [ root, f1, f2, f3, f5, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv553,equivalent,equiv553_b, false).


% ---------------
spl_db( equiv554_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv554_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv554,equivalent,equiv554_b, false).


% ---------------
spl_db( equiv555_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv555_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv555,equivalent,equiv555_b, false).


% ---------------
spl_db( equiv556_a,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv556_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv556,equivalent,equiv556_b, false).


% ---------------
spl_db( equiv557_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv557_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv557,equivalent,equiv557_b, false).


% ---------------
spl_db( equiv558_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

spl_db( equiv558_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(equiv558,equivalent,equiv558_b, false).


% ---------------
spl_db( equiv559_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv559_b,
	 spl( [ root, f1, f2, f6, f7, f9, f3, f4, f5, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv559,equivalent,equiv559_b, false).


% ---------------
spl_db( equiv560_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv560_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv560,equivalent,equiv560_b, true).


% ---------------
spl_db( equiv561_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv561_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv561,equivalent,equiv561_b, false).


% ---------------
spl_db( equiv562_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv562_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv562,equivalent,equiv562_b, false).


% ---------------
spl_db( equiv563_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

spl_db( equiv563_b,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(equiv563,equivalent,equiv563_b, false).


% ---------------
spl_db( equiv564_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv564_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv564,equivalent,equiv564_b, false).


% ---------------
spl_db( equiv565_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv565_b,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv565,equivalent,equiv565_b, false).


% ---------------
spl_db( equiv566_a,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv566_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv566,equivalent,equiv566_b, false).


% ---------------
spl_db( equiv567_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv567_b,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv567,equivalent,equiv567_b, false).


% ---------------
spl_db( equiv568_a,
	 spl( [ root, f1, f2, f6, f7, f9, f3, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv568_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv568,equivalent,equiv568_b, false).


% ---------------
spl_db( equiv569_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv569_b,
	 spl( [ root, f1, f2, f8, f3, f4, f6, f7, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv569,equivalent,equiv569_b, false).


% ---------------
spl_db( equiv570_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv570_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv570,equivalent,equiv570_b, false).


% ---------------
spl_db( equiv571_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv571_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv571,equivalent,equiv571_b, false).


% ---------------
spl_db( equiv572_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv572_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv572,equivalent,equiv572_b, false).


% ---------------
spl_db( equiv573_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv573_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv573,equivalent,equiv573_b, false).


% ---------------
spl_db( equiv574_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv574_b,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv574,equivalent,equiv574_b, false).


% ---------------
spl_db( equiv575_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv575_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv575,equivalent,equiv575_b, false).


% ---------------
spl_db( equiv576_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv576_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv576,equivalent,equiv576_b, false).


% ---------------
spl_db( equiv577_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv577_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv577,equivalent,equiv577_b, false).


% ---------------
spl_db( equiv578_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv578_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv578,equivalent,equiv578_b, false).


% ---------------
spl_db( equiv579_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv579_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv579,equivalent,equiv579_b, false).


% ---------------
spl_db( equiv580_a,
	 spl( [ root, f1, f2, f8, f9, f3, f7, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv580_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv580,equivalent,equiv580_b, false).


% ---------------
spl_db( equiv581_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

spl_db( equiv581_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(equiv581,equivalent,equiv581_b, false).


% ---------------
spl_db( equiv582_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv582_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv582,equivalent,equiv582_b, false).


% ---------------
spl_db( equiv583_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv583_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv583,equivalent,equiv583_b, false).


% ---------------
spl_db( equiv584_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv584_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv584,equivalent,equiv584_b, false).


% ---------------
spl_db( equiv585_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv585_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv585,equivalent,equiv585_b, true).


% ---------------
spl_db( equiv586_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv586_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv586,equivalent,equiv586_b, true).


% ---------------
spl_db( equiv587_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv587_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv587,equivalent,equiv587_b, false).


% ---------------
spl_db( equiv588_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

spl_db( equiv588_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(equiv588,equivalent,equiv588_b, false).


% ---------------
spl_db( equiv589_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv589_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv589,equivalent,equiv589_b, false).


% ---------------
spl_db( equiv590_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

spl_db( equiv590_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

test_data(equiv590,equivalent,equiv590_b, false).


% ---------------
spl_db( equiv591_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv591_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv591,equivalent,equiv591_b, false).


% ---------------
spl_db( equiv592_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv592_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv592,equivalent,equiv592_b, false).


% ---------------
spl_db( equiv593_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv593_b,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv593,equivalent,equiv593_b, false).


% ---------------
spl_db( equiv594_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv594_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv594,equivalent,equiv594_b, false).


% ---------------
spl_db( equiv595_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

spl_db( equiv595_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(equiv595,equivalent,equiv595_b, false).


% ---------------
spl_db( equiv596_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( equiv596_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(equiv596,equivalent,equiv596_b, false).


% ---------------
spl_db( equiv597_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv597_b,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f9, [] ) ) ] ), feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv597,equivalent,equiv597_b, false).


% ---------------
spl_db( equiv598_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv598_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv598,equivalent,equiv598_b, false).


% ---------------
spl_db( equiv599_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv599_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv599,equivalent,equiv599_b, false).


% ---------------
spl_db( equiv600_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv600_b,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f9, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv600,equivalent,equiv600_b, false).


% ---------------
spl_db( equiv601_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv601_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv601,equivalent,equiv601_b, false).


% ---------------
spl_db( equiv602_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

spl_db( equiv602_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(equiv602,equivalent,equiv602_b, false).


% ---------------
spl_db( equiv603_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv603_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv603,equivalent,equiv603_b, false).


% ---------------
spl_db( equiv604_a,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f6, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv604_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv604,equivalent,equiv604_b, false).


% ---------------
spl_db( equiv605_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
						mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv605_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv605,equivalent,equiv605_b, false).


% ---------------
spl_db( equiv606_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [] ) ), optional( feature( f5, [
							optional( feature( f8, [
								optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv606_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv606,equivalent,equiv606_b, false).


% ---------------
spl_db( equiv607_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv607_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv607,equivalent,equiv607_b, false).


% ---------------
spl_db( equiv608_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv608_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv608,equivalent,equiv608_b, true).


% ---------------
spl_db( equiv609_a,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv609_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv609,equivalent,equiv609_b, false).


% ---------------
spl_db( equiv610_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
							mandatory( feature( f8, [
								optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv610_b,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv610,equivalent,equiv610_b, false).


% ---------------
spl_db( equiv611_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv611_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv611,equivalent,equiv611_b, false).


% ---------------
spl_db( equiv612_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv612_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv612,equivalent,equiv612_b, false).


% ---------------
spl_db( equiv613_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv613_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv613,equivalent,equiv613_b, false).


% ---------------
spl_db( equiv614_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv614_b,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv614,equivalent,equiv614_b, false).


% ---------------
spl_db( equiv615_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv615_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv615,equivalent,equiv615_b, false).


% ---------------
spl_db( equiv616_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv616_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv616,equivalent,equiv616_b, false).


% ---------------
spl_db( equiv617_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv617_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv617,equivalent,equiv617_b, false).


% ---------------
spl_db( equiv618_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv618_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv618,equivalent,equiv618_b, false).


% ---------------
spl_db( equiv619_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv619_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv619,equivalent,equiv619_b, false).


% ---------------
spl_db( equiv620_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv620_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv620,equivalent,equiv620_b, false).


% ---------------
spl_db( equiv621_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv621_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv621,equivalent,equiv621_b, false).


% ---------------
spl_db( equiv622_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv622_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv622,equivalent,equiv622_b, false).


% ---------------
spl_db( equiv623_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f9, [] ) ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv623_b,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv623,equivalent,equiv623_b, false).


% ---------------
spl_db( equiv624_a,
	 spl( [ root, f1, f8, f9, f2, f3, f5, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv624_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv624,equivalent,equiv624_b, false).


% ---------------
spl_db( equiv625_a,
	 spl( [ root, f1, f5, f8, f6, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv625_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv625,equivalent,equiv625_b, false).


% ---------------
spl_db( equiv626_a,
	 spl( [ root, f1, f4, f5, f6, f8, f9, f7, f2, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv626_b,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv626,equivalent,equiv626_b, false).


% ---------------
spl_db( equiv627_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv627_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv627,equivalent,equiv627_b, true).


% ---------------
spl_db( equiv628_a,
	 spl( [ root, f1, f2, f4, f5, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv628_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv628,equivalent,equiv628_b, false).


% ---------------
spl_db( equiv629_a,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv629_b,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv629,equivalent,equiv629_b, false).


% ---------------
spl_db( equiv630_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv630_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv630,equivalent,equiv630_b, false).


% ---------------
spl_db( equiv631_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv631_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv631,equivalent,equiv631_b, false).


% ---------------
spl_db( equiv632_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv632_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv632,equivalent,equiv632_b, false).


% ---------------
spl_db( equiv633_a,
	 spl( [ root, f1, f2, f5, f9, f3, f4, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv633_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv633,equivalent,equiv633_b, false).


% ---------------
spl_db( equiv634_a,
	 spl( [ root, f1, f2, f4, f7, f5, f8, f9, f6, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv634_b,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv634,equivalent,equiv634_b, false).


% ---------------
spl_db( equiv635_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv635_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv635,equivalent,equiv635_b, false).


% ---------------
spl_db( equiv636_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
							optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [
							mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv636_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv636,equivalent,equiv636_b, false).


% ---------------
spl_db( equiv637_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv637_b,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f8, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ) ] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv637,equivalent,equiv637_b, false).


% ---------------
spl_db( equiv638_a,
	 spl( [ root, f1, f4, f6, f2, f8, f3, f5, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv638_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv638,equivalent,equiv638_b, false).


% ---------------
spl_db( equiv639_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f7, [
							mandatory( feature( f8, [
								mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv639_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv639,equivalent,equiv639_b, false).


% ---------------
spl_db( equiv640_a,
	 spl( [ root, f1, f2, f7, f3, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv640_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv640,equivalent,equiv640_b, false).


% ---------------
spl_db( equiv641_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv641_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv641,equivalent,equiv641_b, false).


% ---------------
spl_db( equiv642_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv642_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv642,equivalent,equiv642_b, true).


% ---------------
spl_db( equiv643_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv643_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv643,equivalent,equiv643_b, false).


% ---------------
spl_db( equiv644_a,
	 spl( [ root, f1, f6, f7, f2, f9, f3, f5, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv644_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv644,equivalent,equiv644_b, false).


% ---------------
spl_db( equiv645_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv645_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv645,equivalent,equiv645_b, false).


% ---------------
spl_db( equiv646_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv646_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv646,equivalent,equiv646_b, false).


% ---------------
spl_db( equiv647_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv647_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv647,equivalent,equiv647_b, false).


% ---------------
spl_db( equiv648_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv648_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv648,equivalent,equiv648_b, false).


% ---------------
spl_db( equiv649_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv649_b,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv649,equivalent,equiv649_b, false).


% ---------------
spl_db( equiv650_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv650_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv650,equivalent,equiv650_b, false).


% ---------------
spl_db( equiv651_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [
						one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( equiv651_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(equiv651,equivalent,equiv651_b, false).


% ---------------
spl_db( equiv652_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv652_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv652,equivalent,equiv652_b, false).


% ---------------
spl_db( equiv653_a,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv653_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv653,equivalent,equiv653_b, false).


% ---------------
spl_db( equiv654_a,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv654_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ), feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv654,equivalent,equiv654_b, false).


% ---------------
spl_db( equiv655_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv655_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv655,equivalent,equiv655_b, false).


% ---------------
spl_db( equiv656_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv656_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv656,equivalent,equiv656_b, false).


% ---------------
spl_db( equiv657_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv657_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv657,equivalent,equiv657_b, false).


% ---------------
spl_db( equiv658_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv658_b,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv658,equivalent,equiv658_b, false).


% ---------------
spl_db( equiv659_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv659_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv659,equivalent,equiv659_b, false).


% ---------------
spl_db( equiv660_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv660_b,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv660,equivalent,equiv660_b, false).


% ---------------
spl_db( equiv661_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv661_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv661,equivalent,equiv661_b, false).


% ---------------
spl_db( equiv662_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

spl_db( equiv662_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(equiv662,equivalent,equiv662_b, false).


% ---------------
spl_db( equiv663_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv663_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv663,equivalent,equiv663_b, false).


% ---------------
spl_db( equiv664_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv664_b,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv664,equivalent,equiv664_b, false).


% ---------------
spl_db( equiv665_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv665_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f6, [
							mandatory( feature( f7, [
								optional( feature( f8, [
									optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f4, [
						mandatory( feature( f5, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv665,equivalent,equiv665_b, false).


% ---------------
spl_db( equiv666_a,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f7, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv666_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv666,equivalent,equiv666_b, false).


% ---------------
spl_db( equiv667_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

spl_db( equiv667_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(equiv667,equivalent,equiv667_b, false).


% ---------------
spl_db( equiv668_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv668_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv668,equivalent,equiv668_b, false).


% ---------------
spl_db( equiv669_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv669_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv669,equivalent,equiv669_b, false).


% ---------------
spl_db( equiv670_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv670_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv670,equivalent,equiv670_b, false).


% ---------------
spl_db( equiv671_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv671_b,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv671,equivalent,equiv671_b, false).


% ---------------
spl_db( equiv672_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv672_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv672,equivalent,equiv672_b, false).


% ---------------
spl_db( equiv673_a,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv673_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv673,equivalent,equiv673_b, false).


% ---------------
spl_db( equiv674_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv674_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv674,equivalent,equiv674_b, false).


% ---------------
spl_db( equiv675_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv675_b,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv675,equivalent,equiv675_b, false).


% ---------------
spl_db( equiv676_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv676_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv676,equivalent,equiv676_b, true).


% ---------------
spl_db( equiv677_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv677_b,
	 spl( [ root, f1, f3, f4, f8, f5, f6, f9, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv677,equivalent,equiv677_b, false).


% ---------------
spl_db( equiv678_a,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv678_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv678,equivalent,equiv678_b, false).


% ---------------
spl_db( equiv679_a,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv679_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv679,equivalent,equiv679_b, true).


% ---------------
spl_db( equiv680_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv680_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv680,equivalent,equiv680_b, false).


% ---------------
spl_db( equiv681_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv681_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv681,equivalent,equiv681_b, false).


% ---------------
spl_db( equiv682_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv682_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv682,equivalent,equiv682_b, false).


% ---------------
spl_db( equiv683_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv683_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv683,equivalent,equiv683_b, false).


% ---------------
spl_db( equiv684_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv684_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv684,equivalent,equiv684_b, false).


% ---------------
spl_db( equiv685_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv685_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv685,equivalent,equiv685_b, false).


% ---------------
spl_db( equiv686_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv686_b,
	 spl( [ root, f1, f4, f5, f6, f9, f2, f3, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv686,equivalent,equiv686_b, false).


% ---------------
spl_db( equiv687_a,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv687_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv687,equivalent,equiv687_b, false).


% ---------------
spl_db( equiv688_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv688_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv688,equivalent,equiv688_b, false).


% ---------------
spl_db( equiv689_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

spl_db( equiv689_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(equiv689,equivalent,equiv689_b, false).


% ---------------
spl_db( equiv690_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv690_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv690,equivalent,equiv690_b, true).


% ---------------
spl_db( equiv691_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv691_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv691,equivalent,equiv691_b, false).


% ---------------
spl_db( equiv692_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv692_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv692,equivalent,equiv692_b, false).


% ---------------
spl_db( equiv693_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv693_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv693,equivalent,equiv693_b, false).


% ---------------
spl_db( equiv694_a,
	 spl( [ root, f1, f2, f8, f9, f3, f5, f7, f6, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv694_b,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv694,equivalent,equiv694_b, false).


% ---------------
spl_db( equiv695_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv695_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv695,equivalent,equiv695_b, false).


% ---------------
spl_db( equiv696_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv696_b,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv696,equivalent,equiv696_b, false).


% ---------------
spl_db( equiv697_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv697_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv697,equivalent,equiv697_b, false).


% ---------------
spl_db( equiv698_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv698_b,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f8, [] ) ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv698,equivalent,equiv698_b, false).


% ---------------
spl_db( equiv699_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv699_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv699,equivalent,equiv699_b, true).


% ---------------
spl_db( equiv700_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv700_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv700,equivalent,equiv700_b, false).


% ---------------
spl_db( equiv701_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv701_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv701,equivalent,equiv701_b, false).


% ---------------
spl_db( equiv702_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv702_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv702,equivalent,equiv702_b, false).


% ---------------
spl_db( equiv703_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv703_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv703,equivalent,equiv703_b, false).


% ---------------
spl_db( equiv704_a,
	 spl( [ root, f1, f4, f2, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv704_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv704,equivalent,equiv704_b, false).


% ---------------
spl_db( equiv705_a,
	 spl( [ root, f1, f2, f3, f5, f7, f8, f9, f4, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv705_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv705,equivalent,equiv705_b, false).


% ---------------
spl_db( equiv706_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( equiv706_b,
	 spl( [ root, f1, f2, f8, f3, f4, f6, f9, f7, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

test_data(equiv706,equivalent,equiv706_b, false).


% ---------------
spl_db( equiv707_a,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv707_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f4, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv707,equivalent,equiv707_b, false).


% ---------------
spl_db( equiv708_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv708_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv708,equivalent,equiv708_b, false).


% ---------------
spl_db( equiv709_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv709_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv709,equivalent,equiv709_b, true).


% ---------------
spl_db( equiv710_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f5, f6, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv710_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv710,equivalent,equiv710_b, false).


% ---------------
spl_db( equiv711_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv711_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv711,equivalent,equiv711_b, false).


% ---------------
spl_db( equiv712_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv712_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv712,equivalent,equiv712_b, true).


% ---------------
spl_db( equiv713_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv713_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv713,equivalent,equiv713_b, false).


% ---------------
spl_db( equiv714_a,
	 spl( [ root, f1, f5, f8, f9, f6, f2, f3, f4, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv714_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv714,equivalent,equiv714_b, false).


% ---------------
spl_db( equiv715_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv715_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv715,equivalent,equiv715_b, false).


% ---------------
spl_db( equiv716_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv716_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv716,equivalent,equiv716_b, false).


% ---------------
spl_db( equiv717_a,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

spl_db( equiv717_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(equiv717,equivalent,equiv717_b, false).


% ---------------
spl_db( equiv718_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv718_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv718,equivalent,equiv718_b, true).


% ---------------
spl_db( equiv719_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv719_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv719,equivalent,equiv719_b, true).


% ---------------
spl_db( equiv720_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

spl_db( equiv720_b,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(equiv720,equivalent,equiv720_b, false).


% ---------------
spl_db( equiv721_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv721_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv721,equivalent,equiv721_b, true).


% ---------------
spl_db( equiv722_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv722_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv722,equivalent,equiv722_b, false).


% ---------------
spl_db( equiv723_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv723_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv723,equivalent,equiv723_b, false).


% ---------------
spl_db( equiv724_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv724_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [
							optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv724,equivalent,equiv724_b, false).


% ---------------
spl_db( equiv725_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv725_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv725,equivalent,equiv725_b, true).


% ---------------
spl_db( equiv726_a,
	 spl( [ root, f1, f4, f7, f8, f9, f5, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv726_b,
	 spl( [ root, f1, f4, f6, f7, f8, f2, f3, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv726,equivalent,equiv726_b, false).


% ---------------
spl_db( equiv727_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv727_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv727,equivalent,equiv727_b, false).


% ---------------
spl_db( equiv728_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv728_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv728,equivalent,equiv728_b, true).


% ---------------
spl_db( equiv729_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv729_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv729,equivalent,equiv729_b, false).


% ---------------
spl_db( equiv730_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv730_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv730,equivalent,equiv730_b, false).


% ---------------
spl_db( equiv731_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv731_b,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv731,equivalent,equiv731_b, false).


% ---------------
spl_db( equiv732_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv732_b,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv732,equivalent,equiv732_b, false).


% ---------------
spl_db( equiv733_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv733_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv733,equivalent,equiv733_b, false).


% ---------------
spl_db( equiv734_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv734_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv734,equivalent,equiv734_b, false).


% ---------------
spl_db( equiv735_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv735_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv735,equivalent,equiv735_b, true).


% ---------------
spl_db( equiv736_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv736_b,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv736,equivalent,equiv736_b, false).


% ---------------
spl_db( equiv737_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv737_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv737,equivalent,equiv737_b, false).


% ---------------
spl_db( equiv738_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv738_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv738,equivalent,equiv738_b, false).


% ---------------
spl_db( equiv739_a,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv739_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv739,equivalent,equiv739_b, false).


% ---------------
spl_db( equiv740_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv740_b,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv740,equivalent,equiv740_b, false).


% ---------------
spl_db( equiv741_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv741_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv741,equivalent,equiv741_b, false).


% ---------------
spl_db( equiv742_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv742_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv742,equivalent,equiv742_b, false).


% ---------------
spl_db( equiv743_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv743_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv743,equivalent,equiv743_b, true).


% ---------------
spl_db( equiv744_a,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv744_b,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv744,equivalent,equiv744_b, false).


% ---------------
spl_db( equiv745_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [
							mandatory( feature( f6, [
								optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv745_b,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv745,equivalent,equiv745_b, false).


% ---------------
spl_db( equiv746_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv746_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv746,equivalent,equiv746_b, false).


% ---------------
spl_db( equiv747_a,
	 spl( [ root, f1, f2, f4, f5, f8, f6, f9, f7, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [
						optional( feature( f5, [
							optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv747_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv747,equivalent,equiv747_b, false).


% ---------------
spl_db( equiv748_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv748_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv748,equivalent,equiv748_b, false).


% ---------------
spl_db( equiv749_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv749_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv749,equivalent,equiv749_b, false).


% ---------------
spl_db( equiv750_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv750_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv750,equivalent,equiv750_b, false).


% ---------------
spl_db( equiv751_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv751_b,
	 spl( [ root, f1, f2, f3, f5, f7, f9, f8, f6, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					only_one( [ feature( f5, [
						optional( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv751,equivalent,equiv751_b, false).


% ---------------
spl_db( equiv752_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv752_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv752,equivalent,equiv752_b, false).


% ---------------
spl_db( equiv753_a,
	 spl( [ root, f1, f2, f6, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv753_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv753,equivalent,equiv753_b, false).


% ---------------
spl_db( equiv754_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv754_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv754,equivalent,equiv754_b, true).


% ---------------
spl_db( equiv755_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv755_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv755,equivalent,equiv755_b, false).


% ---------------
spl_db( equiv756_a,
	 spl( [ root, f1, f2, f3, f6, f7, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv756_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [] ) ), optional( feature( f5, [
							mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv756,equivalent,equiv756_b, false).


% ---------------
spl_db( equiv757_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv757_b,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv757,equivalent,equiv757_b, false).


% ---------------
spl_db( equiv758_a,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv758_b,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv758,equivalent,equiv758_b, false).


% ---------------
spl_db( equiv759_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv759_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv759,equivalent,equiv759_b, false).


% ---------------
spl_db( equiv760_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv760_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv760,equivalent,equiv760_b, false).


% ---------------
spl_db( equiv761_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv761_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv761,equivalent,equiv761_b, false).


% ---------------
spl_db( equiv762_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv762_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv762,equivalent,equiv762_b, false).


% ---------------
spl_db( equiv763_a,
	 spl( [ root, f1, f3, f5, f6, f7, f8, f4, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv763_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv763,equivalent,equiv763_b, false).


% ---------------
spl_db( equiv764_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv764_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv764,equivalent,equiv764_b, false).


% ---------------
spl_db( equiv765_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv765_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv765,equivalent,equiv765_b, false).


% ---------------
spl_db( equiv766_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv766_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv766,equivalent,equiv766_b, false).


% ---------------
spl_db( equiv767_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv767_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [
							optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv767,equivalent,equiv767_b, false).


% ---------------
spl_db( equiv768_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [
							optional( feature( f5, [
								mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv768_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv768,equivalent,equiv768_b, false).


% ---------------
spl_db( equiv769_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [
							optional( feature( f5, [
								optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
								mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv769_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv769,equivalent,equiv769_b, false).


% ---------------
spl_db( equiv770_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv770_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv770,equivalent,equiv770_b, true).


% ---------------
spl_db( equiv771_a,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv771_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv771,equivalent,equiv771_b, false).


% ---------------
spl_db( equiv772_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( equiv772_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(equiv772,equivalent,equiv772_b, true).


% ---------------
spl_db( equiv773_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

spl_db( equiv773_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

test_data(equiv773,equivalent,equiv773_b, false).


% ---------------
spl_db( equiv774_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv774_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv774,equivalent,equiv774_b, false).


% ---------------
spl_db( equiv775_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv775_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv775,equivalent,equiv775_b, false).


% ---------------
spl_db( equiv776_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv776_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv776,equivalent,equiv776_b, false).


% ---------------
spl_db( equiv777_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv777_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv777,equivalent,equiv777_b, false).


% ---------------
spl_db( equiv778_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv778_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv778,equivalent,equiv778_b, false).


% ---------------
spl_db( equiv779_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f2, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv779_b,
	 spl( [ root, f1, f5, f6, f7, f2, f3, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv779,equivalent,equiv779_b, false).


% ---------------
spl_db( equiv780_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv780_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv780,equivalent,equiv780_b, false).


% ---------------
spl_db( equiv781_a,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv781_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv781,equivalent,equiv781_b, false).


% ---------------
spl_db( equiv782_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv782_b,
	 spl( [ root, f1, f9, f2, f7, f3, f4, f5, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f7, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv782,equivalent,equiv782_b, false).


% ---------------
spl_db( equiv783_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv783_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
						one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv783,equivalent,equiv783_b, false).


% ---------------
spl_db( equiv784_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv784_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv784,equivalent,equiv784_b, true).


% ---------------
spl_db( equiv785_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv785_b,
	 spl( [ root, f1, f2, f3, f6, f7, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv785,equivalent,equiv785_b, false).


% ---------------
spl_db( equiv786_a,
	 spl( [ root, f1, f2, f5, f6, f8, f7, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv786_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv786,equivalent,equiv786_b, false).


% ---------------
spl_db( equiv787_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv787_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv787,equivalent,equiv787_b, false).


% ---------------
spl_db( equiv788_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv788_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv788,equivalent,equiv788_b, false).


% ---------------
spl_db( equiv789_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv789_b,
	 spl( [ root, f1, f2, f3, f5, f9, f4, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv789,equivalent,equiv789_b, false).


% ---------------
spl_db( equiv790_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv790_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv790,equivalent,equiv790_b, false).


% ---------------
spl_db( equiv791_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv791_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv791,equivalent,equiv791_b, false).


% ---------------
spl_db( equiv792_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

spl_db( equiv792_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(equiv792,equivalent,equiv792_b, false).


% ---------------
spl_db( equiv793_a,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv793_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv793,equivalent,equiv793_b, false).


% ---------------
spl_db( equiv794_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv794_b,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv794,equivalent,equiv794_b, false).


% ---------------
spl_db( equiv795_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv795_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv795,equivalent,equiv795_b, false).


% ---------------
spl_db( equiv796_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv796_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv796,equivalent,equiv796_b, false).


% ---------------
spl_db( equiv797_a,
	 spl( [ root, f1, f2, f8, f3, f5, f6, f9, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f8, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv797_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv797,equivalent,equiv797_b, false).


% ---------------
spl_db( equiv798_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv798_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv798,equivalent,equiv798_b, false).


% ---------------
spl_db( equiv799_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

spl_db( equiv799_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(equiv799,equivalent,equiv799_b, false).


% ---------------
spl_db( equiv800_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv800_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv800,equivalent,equiv800_b, false).


% ---------------
spl_db( equiv801_a,
	 spl( [ root, f1, f2, f4, f6, f7, f8, f5, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv801_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv801,equivalent,equiv801_b, false).


% ---------------
spl_db( equiv802_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv802_b,
	 spl( [ root, f1, f6, f7, f2, f3, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv802,equivalent,equiv802_b, false).


% ---------------
spl_db( equiv803_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv803_b,
	 spl( [ root, f1, f2, f3, f8, f4, f6, f7, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv803,equivalent,equiv803_b, false).


% ---------------
spl_db( equiv804_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv804_b,
	 spl( [ root, f1, f6, f2, f3, f7, f4, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv804,equivalent,equiv804_b, false).


% ---------------
spl_db( equiv805_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv805_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv805,equivalent,equiv805_b, false).


% ---------------
spl_db( equiv806_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv806_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv806,equivalent,equiv806_b, false).


% ---------------
spl_db( equiv807_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv807_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv807,equivalent,equiv807_b, false).


% ---------------
spl_db( equiv808_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv808_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv808,equivalent,equiv808_b, false).


% ---------------
spl_db( equiv809_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv809_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv809,equivalent,equiv809_b, true).


% ---------------
spl_db( equiv810_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( equiv810_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(equiv810,equivalent,equiv810_b, false).


% ---------------
spl_db( equiv811_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv811_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv811,equivalent,equiv811_b, false).


% ---------------
spl_db( equiv812_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv812_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv812,equivalent,equiv812_b, false).


% ---------------
spl_db( equiv813_a,
	 spl( [ root, f1, f3, f8, f4, f5, f6, f7, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv813_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv813,equivalent,equiv813_b, false).


% ---------------
spl_db( equiv814_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv814_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv814,equivalent,equiv814_b, false).


% ---------------
spl_db( equiv815_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv815_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv815,equivalent,equiv815_b, true).


% ---------------
spl_db( equiv816_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv816_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv816,equivalent,equiv816_b, false).


% ---------------
spl_db( equiv817_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv817_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv817,equivalent,equiv817_b, false).


% ---------------
spl_db( equiv818_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv818_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv818,equivalent,equiv818_b, false).


% ---------------
spl_db( equiv819_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv819_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv819,equivalent,equiv819_b, false).


% ---------------
spl_db( equiv820_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv820_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv820,equivalent,equiv820_b, false).


% ---------------
spl_db( equiv821_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv821_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv821,equivalent,equiv821_b, false).


% ---------------
spl_db( equiv822_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv822_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv822,equivalent,equiv822_b, false).


% ---------------
spl_db( equiv823_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv823_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv823,equivalent,equiv823_b, false).


% ---------------
spl_db( equiv824_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv824_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv824,equivalent,equiv824_b, false).


% ---------------
spl_db( equiv825_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv825_b,
	 spl( [ root, f1, f2, f6, f3, f5, f4, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f5, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv825,equivalent,equiv825_b, false).


% ---------------
spl_db( equiv826_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv826_b,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv826,equivalent,equiv826_b, false).


% ---------------
spl_db( equiv827_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv827_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv827,equivalent,equiv827_b, false).


% ---------------
spl_db( equiv828_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv828_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv828,equivalent,equiv828_b, false).


% ---------------
spl_db( equiv829_a,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv829_b,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv829,equivalent,equiv829_b, false).


% ---------------
spl_db( equiv830_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv830_b,
	 spl( [ root, f1, f2, f5, f3, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv830,equivalent,equiv830_b, false).


% ---------------
spl_db( equiv831_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

spl_db( equiv831_b,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

test_data(equiv831,equivalent,equiv831_b, false).


% ---------------
spl_db( equiv832_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv832_b,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv832,equivalent,equiv832_b, false).


% ---------------
spl_db( equiv833_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv833_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv833,equivalent,equiv833_b, false).


% ---------------
spl_db( equiv834_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv834_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv834,equivalent,equiv834_b, false).


% ---------------
spl_db( equiv835_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv835_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv835,equivalent,equiv835_b, false).


% ---------------
spl_db( equiv836_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

spl_db( equiv836_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(equiv836,equivalent,equiv836_b, false).


% ---------------
spl_db( equiv837_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv837_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv837,equivalent,equiv837_b, false).


% ---------------
spl_db( equiv838_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv838_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv838,equivalent,equiv838_b, false).


% ---------------
spl_db( equiv839_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv839_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv839,equivalent,equiv839_b, false).


% ---------------
spl_db( equiv840_a,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv840_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv840,equivalent,equiv840_b, false).


% ---------------
spl_db( equiv841_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv841_b,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv841,equivalent,equiv841_b, false).


% ---------------
spl_db( equiv842_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f2, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv842_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv842,equivalent,equiv842_b, false).


% ---------------
spl_db( equiv843_a,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv843_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv843,equivalent,equiv843_b, false).


% ---------------
spl_db( equiv844_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv844_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv844,equivalent,equiv844_b, true).


% ---------------
spl_db( equiv845_a,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv845_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv845,equivalent,equiv845_b, false).


% ---------------
spl_db( equiv846_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv846_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv846,equivalent,equiv846_b, true).


% ---------------
spl_db( equiv847_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

spl_db( equiv847_b,
	 spl( [ root, f1, f9, f2, f5, f7, f8, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(equiv847,equivalent,equiv847_b, false).


% ---------------
spl_db( equiv848_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv848_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv848,equivalent,equiv848_b, false).


% ---------------
spl_db( equiv849_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( equiv849_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(equiv849,equivalent,equiv849_b, false).


% ---------------
spl_db( equiv850_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv850_b,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv850,equivalent,equiv850_b, false).


% ---------------
spl_db( equiv851_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv851_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv851,equivalent,equiv851_b, true).


% ---------------
spl_db( equiv852_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv852_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv852,equivalent,equiv852_b, true).


% ---------------
spl_db( equiv853_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv853_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv853,equivalent,equiv853_b, false).


% ---------------
spl_db( equiv854_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv854_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv854,equivalent,equiv854_b, false).


% ---------------
spl_db( equiv855_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv855_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv855,equivalent,equiv855_b, false).


% ---------------
spl_db( equiv856_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv856_b,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv856,equivalent,equiv856_b, false).


% ---------------
spl_db( equiv857_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv857_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv857,equivalent,equiv857_b, false).


% ---------------
spl_db( equiv858_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
							mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

spl_db( equiv858_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

test_data(equiv858,equivalent,equiv858_b, false).


% ---------------
spl_db( equiv859_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv859_b,
	 spl( [ root, f1, f3, f6, f7, f4, f9, f5, f2, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv859,equivalent,equiv859_b, false).


% ---------------
spl_db( equiv860_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv860_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv860,equivalent,equiv860_b, false).


% ---------------
spl_db( equiv861_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv861_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv861,equivalent,equiv861_b, false).


% ---------------
spl_db( equiv862_a,
	 spl( [ root, f1, f2, f7, f3, f4, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv862_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv862,equivalent,equiv862_b, false).


% ---------------
spl_db( equiv863_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv863_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv863,equivalent,equiv863_b, false).


% ---------------
spl_db( equiv864_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv864_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv864,equivalent,equiv864_b, false).


% ---------------
spl_db( equiv865_a,
	 spl( [ root, f1, f2, f6, f8, f9, f7, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv865_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv865,equivalent,equiv865_b, false).


% ---------------
spl_db( equiv866_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv866_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv866,equivalent,equiv866_b, false).


% ---------------
spl_db( equiv867_a,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv867_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv867,equivalent,equiv867_b, false).


% ---------------
spl_db( equiv868_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv868_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv868,equivalent,equiv868_b, false).


% ---------------
spl_db( equiv869_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv869_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv869,equivalent,equiv869_b, false).


% ---------------
spl_db( equiv870_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv870_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv870,equivalent,equiv870_b, false).


% ---------------
spl_db( equiv871_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv871_b,
	 spl( [ root, f1, f6, f2, f5, f9, f3, f4, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv871,equivalent,equiv871_b, false).


% ---------------
spl_db( equiv872_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv872_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv872,equivalent,equiv872_b, false).


% ---------------
spl_db( equiv873_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv873_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv873,equivalent,equiv873_b, false).


% ---------------
spl_db( equiv874_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv874_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv874,equivalent,equiv874_b, false).


% ---------------
spl_db( equiv875_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv875_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv875,equivalent,equiv875_b, false).


% ---------------
spl_db( equiv876_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv876_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f2, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv876,equivalent,equiv876_b, false).


% ---------------
spl_db( equiv877_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv877_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv877,equivalent,equiv877_b, false).


% ---------------
spl_db( equiv878_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv878_b,
	 spl( [ root, f1, f8, f2, f3, f6, f7, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [
					optional( feature( f6, [
						mandatory( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f4, [
					optional( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv878,equivalent,equiv878_b, false).


% ---------------
spl_db( equiv879_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv879_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv879,equivalent,equiv879_b, false).


% ---------------
spl_db( equiv880_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv880_b,
	 spl( [ root, f1, f8, f2, f5, f9, f6, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv880,equivalent,equiv880_b, false).


% ---------------
spl_db( equiv881_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv881_b,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv881,equivalent,equiv881_b, false).


% ---------------
spl_db( equiv882_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv882_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv882,equivalent,equiv882_b, false).


% ---------------
spl_db( equiv883_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv883_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv883,equivalent,equiv883_b, true).


% ---------------
spl_db( equiv884_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv884_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv884,equivalent,equiv884_b, true).


% ---------------
spl_db( equiv885_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv885_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv885,equivalent,equiv885_b, false).


% ---------------
spl_db( equiv886_a,
	 spl( [ root, f1, f2, f6, f7, f3, f9, f4, f5, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv886_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv886,equivalent,equiv886_b, false).


% ---------------
spl_db( equiv887_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv887_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv887,equivalent,equiv887_b, false).


% ---------------
spl_db( equiv888_a,
	 spl( [ root, f1, f6, f7, f2, f4, f8, f9, f5, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv888_b,
	 spl( [ root, f1, f5, f6, f2, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv888,equivalent,equiv888_b, false).


% ---------------
spl_db( equiv889_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv889_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv889,equivalent,equiv889_b, true).


% ---------------
spl_db( equiv890_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv890_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv890,equivalent,equiv890_b, false).


% ---------------
spl_db( equiv891_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv891_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv891,equivalent,equiv891_b, false).


% ---------------
spl_db( equiv892_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv892_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv892,equivalent,equiv892_b, false).


% ---------------
spl_db( equiv893_a,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv893_b,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f6, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv893,equivalent,equiv893_b, false).


% ---------------
spl_db( equiv894_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv894_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv894,equivalent,equiv894_b, false).


% ---------------
spl_db( equiv895_a,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f5, [] ) ), optional( feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv895_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv895,equivalent,equiv895_b, false).


% ---------------
spl_db( equiv896_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv896_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv896,equivalent,equiv896_b, true).


% ---------------
spl_db( equiv897_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv897_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv897,equivalent,equiv897_b, true).


% ---------------
spl_db( equiv898_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv898_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv898,equivalent,equiv898_b, false).


% ---------------
spl_db( equiv899_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv899_b,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv899,equivalent,equiv899_b, false).


% ---------------
spl_db( equiv900_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv900_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv900,equivalent,equiv900_b, false).


% ---------------
spl_db( equiv901_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv901_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv901,equivalent,equiv901_b, false).


% ---------------
spl_db( equiv902_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f4, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv902_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv902,equivalent,equiv902_b, false).


% ---------------
spl_db( equiv903_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv903_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv903,equivalent,equiv903_b, false).


% ---------------
spl_db( equiv904_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv904_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv904,equivalent,equiv904_b, false).


% ---------------
spl_db( equiv905_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv905_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv905,equivalent,equiv905_b, true).


% ---------------
spl_db( equiv906_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv906_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv906,equivalent,equiv906_b, false).


% ---------------
spl_db( equiv907_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv907_b,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv907,equivalent,equiv907_b, false).


% ---------------
spl_db( equiv908_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv908_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv908,equivalent,equiv908_b, true).


% ---------------
spl_db( equiv909_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv909_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv909,equivalent,equiv909_b, false).


% ---------------
spl_db( equiv910_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv910_b,
	 spl( [ root, f1, f2, f8, f9, f3, f5, f6, f7, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv910,equivalent,equiv910_b, false).


% ---------------
spl_db( equiv911_a,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv911_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv911,equivalent,equiv911_b, false).


% ---------------
spl_db( equiv912_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv912_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv912,equivalent,equiv912_b, false).


% ---------------
spl_db( equiv913_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv913_b,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv913,equivalent,equiv913_b, false).


% ---------------
spl_db( equiv914_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv914_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv914,equivalent,equiv914_b, false).


% ---------------
spl_db( equiv915_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv915_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv915,equivalent,equiv915_b, false).


% ---------------
spl_db( equiv916_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv916_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv916,equivalent,equiv916_b, false).


% ---------------
spl_db( equiv917_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv917_b,
	 spl( [ root, f1, f4, f6, f5, f2, f8, f9, f3, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv917,equivalent,equiv917_b, false).


% ---------------
spl_db( equiv918_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv918_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv918,equivalent,equiv918_b, false).


% ---------------
spl_db( equiv919_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv919_b,
	 spl( [ root, f1, f8, f2, f3, f4, f7, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv919,equivalent,equiv919_b, false).


% ---------------
spl_db( equiv920_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv920_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv920,equivalent,equiv920_b, false).


% ---------------
spl_db( equiv921_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv921_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv921,equivalent,equiv921_b, false).


% ---------------
spl_db( equiv922_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv922_b,
	 spl( [ root, f1, f7, f8, f9, f2, f6, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv922,equivalent,equiv922_b, false).


% ---------------
spl_db( equiv923_a,
	 spl( [ root, f1, f6, f2, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv923_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv923,equivalent,equiv923_b, false).


% ---------------
spl_db( equiv924_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv924_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv924,equivalent,equiv924_b, false).


% ---------------
spl_db( equiv925_a,
	 spl( [ root, f1, f2, f4, f6, f7, f9, f8, f5, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f7, [
							optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv925_b,
	 spl( [ root, f1, f7, f8, f2, f5, f6, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv925,equivalent,equiv925_b, false).


% ---------------
spl_db( equiv926_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [
						optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv926_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv926,equivalent,equiv926_b, false).


% ---------------
spl_db( equiv927_a,
	 spl( [ root, f1, f5, f6, f7, f9, f2, f3, f4, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

spl_db( equiv927_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

test_data(equiv927,equivalent,equiv927_b, false).


% ---------------
spl_db( equiv928_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv928_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv928,equivalent,equiv928_b, true).


% ---------------
spl_db( equiv929_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv929_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv929,equivalent,equiv929_b, true).


% ---------------
spl_db( equiv930_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f7, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv930_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv930,equivalent,equiv930_b, false).


% ---------------
spl_db( equiv931_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv931_b,
	 spl( [ root, f1, f5, f8, f9, f6, f7, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv931,equivalent,equiv931_b, false).


% ---------------
spl_db( equiv932_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv932_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv932,equivalent,equiv932_b, true).


% ---------------
spl_db( equiv933_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv933_b,
	 spl( [ root, f1, f5, f2, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv933,equivalent,equiv933_b, false).


% ---------------
spl_db( equiv934_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv934_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv934,equivalent,equiv934_b, false).


% ---------------
spl_db( equiv935_a,
	 spl( [ root, f1, f6, f2, f3, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv935_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv935,equivalent,equiv935_b, false).


% ---------------
spl_db( equiv936_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( equiv936_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

test_data(equiv936,equivalent,equiv936_b, false).


% ---------------
spl_db( equiv937_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv937_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv937,equivalent,equiv937_b, false).


% ---------------
spl_db( equiv938_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv938_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv938,equivalent,equiv938_b, false).


% ---------------
spl_db( equiv939_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv939_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv939,equivalent,equiv939_b, true).


% ---------------
spl_db( equiv940_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv940_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv940,equivalent,equiv940_b, true).


% ---------------
spl_db( equiv941_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv941_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv941,equivalent,equiv941_b, false).


% ---------------
spl_db( equiv942_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv942_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [
						mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv942,equivalent,equiv942_b, false).


% ---------------
spl_db( equiv943_a,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv943_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv943,equivalent,equiv943_b, false).


% ---------------
spl_db( equiv944_a,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv944_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv944,equivalent,equiv944_b, false).


% ---------------
spl_db( equiv945_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv945_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv945,equivalent,equiv945_b, false).


% ---------------
spl_db( equiv946_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv946_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv946,equivalent,equiv946_b, false).


% ---------------
spl_db( equiv947_a,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f8, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ), feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv947_b,
	 spl( [ root, f1, f2, f6, f3, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv947,equivalent,equiv947_b, false).


% ---------------
spl_db( equiv948_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv948_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv948,equivalent,equiv948_b, false).


% ---------------
spl_db( equiv949_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv949_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv949,equivalent,equiv949_b, false).


% ---------------
spl_db( equiv950_a,
	 spl( [ root, f1, f4, f2, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv950_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv950,equivalent,equiv950_b, false).


% ---------------
spl_db( equiv951_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv951_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv951,equivalent,equiv951_b, false).


% ---------------
spl_db( equiv952_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv952_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv952,equivalent,equiv952_b, false).


% ---------------
spl_db( equiv953_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv953_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f5, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [
				optional( feature( f5, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv953,equivalent,equiv953_b, false).


% ---------------
spl_db( equiv954_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv954_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv954,equivalent,equiv954_b, false).


% ---------------
spl_db( equiv955_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv955_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv955,equivalent,equiv955_b, false).


% ---------------
spl_db( equiv956_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv956_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv956,equivalent,equiv956_b, false).


% ---------------
spl_db( equiv957_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv957_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv957,equivalent,equiv957_b, true).


% ---------------
spl_db( equiv958_a,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv958_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv958,equivalent,equiv958_b, true).


% ---------------
spl_db( equiv959_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv959_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv959,equivalent,equiv959_b, false).


% ---------------
spl_db( equiv960_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv960_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv960,equivalent,equiv960_b, true).


% ---------------
spl_db( equiv961_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv961_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv961,equivalent,equiv961_b, true).


% ---------------
spl_db( equiv962_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv962_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv962,equivalent,equiv962_b, true).


% ---------------
spl_db( equiv963_a,
	 spl( [ root, f1, f8, f2, f3, f7, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv963_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv963,equivalent,equiv963_b, false).


% ---------------
spl_db( equiv964_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv964_b,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv964,equivalent,equiv964_b, false).


% ---------------
spl_db( equiv965_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv965_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f5, [
						optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv965,equivalent,equiv965_b, false).


% ---------------
spl_db( equiv966_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv966_b,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv966,equivalent,equiv966_b, false).


% ---------------
spl_db( equiv967_a,
	 spl( [ root, f1, f2, f6, f3, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv967_b,
	 spl( [ root, f1, f2, f5, f6, f9, f3, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv967,equivalent,equiv967_b, false).


% ---------------
spl_db( equiv968_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv968_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv968,equivalent,equiv968_b, false).


% ---------------
spl_db( equiv969_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv969_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					optional( feature( f7, [] ) ) ] ), feature( f6, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv969,equivalent,equiv969_b, false).


% ---------------
spl_db( equiv970_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv970_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv970,equivalent,equiv970_b, false).


% ---------------
spl_db( equiv971_a,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv971_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv971,equivalent,equiv971_b, false).


% ---------------
spl_db( equiv972_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv972_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv972,equivalent,equiv972_b, false).


% ---------------
spl_db( equiv973_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

spl_db( equiv973_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(equiv973,equivalent,equiv973_b, false).


% ---------------
spl_db( equiv974_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv974_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv974,equivalent,equiv974_b, false).


% ---------------
spl_db( equiv975_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv975_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv975,equivalent,equiv975_b, false).


% ---------------
spl_db( equiv976_a,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ) ] ), feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv976_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv976,equivalent,equiv976_b, false).


% ---------------
spl_db( equiv977_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv977_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv977,equivalent,equiv977_b, false).


% ---------------
spl_db( equiv978_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv978_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv978,equivalent,equiv978_b, true).


% ---------------
spl_db( equiv979_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

spl_db( equiv979_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(equiv979,equivalent,equiv979_b, false).


% ---------------
spl_db( equiv980_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

spl_db( equiv980_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f9 ) ]
		)
	)
).

test_data(equiv980,equivalent,equiv980_b, false).


% ---------------
spl_db( equiv981_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv981_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv981,equivalent,equiv981_b, false).


% ---------------
spl_db( equiv982_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

spl_db( equiv982_b,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(equiv982,equivalent,equiv982_b, false).


% ---------------
spl_db( equiv983_a,
	 spl( [ root, f1, f8, f9, f2, f3, f7, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv983_b,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [
						mandatory( feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv983,equivalent,equiv983_b, false).


% ---------------
spl_db( equiv984_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv984_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv984,equivalent,equiv984_b, false).


% ---------------
spl_db( equiv985_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv985_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv985,equivalent,equiv985_b, false).


% ---------------
spl_db( equiv986_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv986_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv986,equivalent,equiv986_b, false).


% ---------------
spl_db( equiv987_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv987_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv987,equivalent,equiv987_b, true).


% ---------------
spl_db( equiv988_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv988_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv988,equivalent,equiv988_b, false).


% ---------------
spl_db( equiv989_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [
					one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv989_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv989,equivalent,equiv989_b, false).


% ---------------
spl_db( equiv990_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv990_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv990,equivalent,equiv990_b, false).


% ---------------
spl_db( equiv991_a,
	 spl( [ root, f1, f4, f5, f9, f6, f2, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv991_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv991,equivalent,equiv991_b, false).


% ---------------
spl_db( equiv992_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv992_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv992,equivalent,equiv992_b, false).


% ---------------
spl_db( equiv993_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv993_b,
	 spl( [ root, f1, f2, f6, f3, f4, f9, f5, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv993,equivalent,equiv993_b, false).


% ---------------
spl_db( equiv994_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv994_b,
	 spl( [ root, f1, f4, f5, f9, f2, f3, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv994,equivalent,equiv994_b, false).


% ---------------
spl_db( equiv995_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv995_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv995,equivalent,equiv995_b, false).


% ---------------
spl_db( equiv996_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv996_b,
	 spl( [ root, f1, f2, f5, f3, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv996,equivalent,equiv996_b, true).


% ---------------
spl_db( equiv997_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( equiv997_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(equiv997,equivalent,equiv997_b, false).


% ---------------
spl_db( equiv998_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv998_b,
	 spl( [ root, f1, f2, f7, f3, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv998,equivalent,equiv998_b, false).


% ---------------
spl_db( equiv999_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( equiv999_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(equiv999,equivalent,equiv999_b, false).


% --------------- Test cases % ---------------
:- begin_tests(equivalent).
test(equivalent0) :-
	spl_db( equiv0_a, Spl1 ),
	test_data( equiv0, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent1) :-
	spl_db( equiv1_a, Spl1 ),
	test_data( equiv1, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent2) :-
	spl_db( equiv2_a, Spl1 ),
	test_data( equiv2, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent3) :-
	spl_db( equiv3_a, Spl1 ),
	test_data( equiv3, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent4) :-
	spl_db( equiv4_a, Spl1 ),
	test_data( equiv4, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent5) :-
	spl_db( equiv5_a, Spl1 ),
	test_data( equiv5, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent6) :-
	spl_db( equiv6_a, Spl1 ),
	test_data( equiv6, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent7) :-
	spl_db( equiv7_a, Spl1 ),
	test_data( equiv7, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent8) :-
	spl_db( equiv8_a, Spl1 ),
	test_data( equiv8, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent9) :-
	spl_db( equiv9_a, Spl1 ),
	test_data( equiv9, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent10) :-
	spl_db( equiv10_a, Spl1 ),
	test_data( equiv10, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent11) :-
	spl_db( equiv11_a, Spl1 ),
	test_data( equiv11, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent12) :-
	spl_db( equiv12_a, Spl1 ),
	test_data( equiv12, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent13) :-
	spl_db( equiv13_a, Spl1 ),
	test_data( equiv13, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent14) :-
	spl_db( equiv14_a, Spl1 ),
	test_data( equiv14, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent15) :-
	spl_db( equiv15_a, Spl1 ),
	test_data( equiv15, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent16) :-
	spl_db( equiv16_a, Spl1 ),
	test_data( equiv16, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent17) :-
	spl_db( equiv17_a, Spl1 ),
	test_data( equiv17, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent18) :-
	spl_db( equiv18_a, Spl1 ),
	test_data( equiv18, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent19) :-
	spl_db( equiv19_a, Spl1 ),
	test_data( equiv19, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent20) :-
	spl_db( equiv20_a, Spl1 ),
	test_data( equiv20, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent21) :-
	spl_db( equiv21_a, Spl1 ),
	test_data( equiv21, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent22) :-
	spl_db( equiv22_a, Spl1 ),
	test_data( equiv22, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent23) :-
	spl_db( equiv23_a, Spl1 ),
	test_data( equiv23, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent24) :-
	spl_db( equiv24_a, Spl1 ),
	test_data( equiv24, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent25) :-
	spl_db( equiv25_a, Spl1 ),
	test_data( equiv25, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent26) :-
	spl_db( equiv26_a, Spl1 ),
	test_data( equiv26, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent27) :-
	spl_db( equiv27_a, Spl1 ),
	test_data( equiv27, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent28) :-
	spl_db( equiv28_a, Spl1 ),
	test_data( equiv28, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent29) :-
	spl_db( equiv29_a, Spl1 ),
	test_data( equiv29, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent30) :-
	spl_db( equiv30_a, Spl1 ),
	test_data( equiv30, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent31) :-
	spl_db( equiv31_a, Spl1 ),
	test_data( equiv31, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent32) :-
	spl_db( equiv32_a, Spl1 ),
	test_data( equiv32, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent33) :-
	spl_db( equiv33_a, Spl1 ),
	test_data( equiv33, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent34) :-
	spl_db( equiv34_a, Spl1 ),
	test_data( equiv34, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent35) :-
	spl_db( equiv35_a, Spl1 ),
	test_data( equiv35, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent36) :-
	spl_db( equiv36_a, Spl1 ),
	test_data( equiv36, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent37) :-
	spl_db( equiv37_a, Spl1 ),
	test_data( equiv37, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent38) :-
	spl_db( equiv38_a, Spl1 ),
	test_data( equiv38, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent39) :-
	spl_db( equiv39_a, Spl1 ),
	test_data( equiv39, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent40) :-
	spl_db( equiv40_a, Spl1 ),
	test_data( equiv40, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent41) :-
	spl_db( equiv41_a, Spl1 ),
	test_data( equiv41, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent42) :-
	spl_db( equiv42_a, Spl1 ),
	test_data( equiv42, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent43) :-
	spl_db( equiv43_a, Spl1 ),
	test_data( equiv43, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent44) :-
	spl_db( equiv44_a, Spl1 ),
	test_data( equiv44, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent45) :-
	spl_db( equiv45_a, Spl1 ),
	test_data( equiv45, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent46) :-
	spl_db( equiv46_a, Spl1 ),
	test_data( equiv46, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent47) :-
	spl_db( equiv47_a, Spl1 ),
	test_data( equiv47, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent48) :-
	spl_db( equiv48_a, Spl1 ),
	test_data( equiv48, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent49) :-
	spl_db( equiv49_a, Spl1 ),
	test_data( equiv49, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent50) :-
	spl_db( equiv50_a, Spl1 ),
	test_data( equiv50, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent51) :-
	spl_db( equiv51_a, Spl1 ),
	test_data( equiv51, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent52) :-
	spl_db( equiv52_a, Spl1 ),
	test_data( equiv52, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent53) :-
	spl_db( equiv53_a, Spl1 ),
	test_data( equiv53, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent54) :-
	spl_db( equiv54_a, Spl1 ),
	test_data( equiv54, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent55) :-
	spl_db( equiv55_a, Spl1 ),
	test_data( equiv55, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent56) :-
	spl_db( equiv56_a, Spl1 ),
	test_data( equiv56, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent57) :-
	spl_db( equiv57_a, Spl1 ),
	test_data( equiv57, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent58) :-
	spl_db( equiv58_a, Spl1 ),
	test_data( equiv58, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent59) :-
	spl_db( equiv59_a, Spl1 ),
	test_data( equiv59, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent60) :-
	spl_db( equiv60_a, Spl1 ),
	test_data( equiv60, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent61) :-
	spl_db( equiv61_a, Spl1 ),
	test_data( equiv61, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent62) :-
	spl_db( equiv62_a, Spl1 ),
	test_data( equiv62, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent63) :-
	spl_db( equiv63_a, Spl1 ),
	test_data( equiv63, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent64) :-
	spl_db( equiv64_a, Spl1 ),
	test_data( equiv64, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent65) :-
	spl_db( equiv65_a, Spl1 ),
	test_data( equiv65, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent66) :-
	spl_db( equiv66_a, Spl1 ),
	test_data( equiv66, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent67) :-
	spl_db( equiv67_a, Spl1 ),
	test_data( equiv67, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent68) :-
	spl_db( equiv68_a, Spl1 ),
	test_data( equiv68, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent69) :-
	spl_db( equiv69_a, Spl1 ),
	test_data( equiv69, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent70) :-
	spl_db( equiv70_a, Spl1 ),
	test_data( equiv70, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent71) :-
	spl_db( equiv71_a, Spl1 ),
	test_data( equiv71, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent72) :-
	spl_db( equiv72_a, Spl1 ),
	test_data( equiv72, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent73) :-
	spl_db( equiv73_a, Spl1 ),
	test_data( equiv73, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent74) :-
	spl_db( equiv74_a, Spl1 ),
	test_data( equiv74, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent75) :-
	spl_db( equiv75_a, Spl1 ),
	test_data( equiv75, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent76) :-
	spl_db( equiv76_a, Spl1 ),
	test_data( equiv76, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent77) :-
	spl_db( equiv77_a, Spl1 ),
	test_data( equiv77, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent78) :-
	spl_db( equiv78_a, Spl1 ),
	test_data( equiv78, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent79) :-
	spl_db( equiv79_a, Spl1 ),
	test_data( equiv79, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent80) :-
	spl_db( equiv80_a, Spl1 ),
	test_data( equiv80, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent81) :-
	spl_db( equiv81_a, Spl1 ),
	test_data( equiv81, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent82) :-
	spl_db( equiv82_a, Spl1 ),
	test_data( equiv82, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent83) :-
	spl_db( equiv83_a, Spl1 ),
	test_data( equiv83, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent84) :-
	spl_db( equiv84_a, Spl1 ),
	test_data( equiv84, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent85) :-
	spl_db( equiv85_a, Spl1 ),
	test_data( equiv85, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent86) :-
	spl_db( equiv86_a, Spl1 ),
	test_data( equiv86, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent87) :-
	spl_db( equiv87_a, Spl1 ),
	test_data( equiv87, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent88) :-
	spl_db( equiv88_a, Spl1 ),
	test_data( equiv88, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent89) :-
	spl_db( equiv89_a, Spl1 ),
	test_data( equiv89, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent90) :-
	spl_db( equiv90_a, Spl1 ),
	test_data( equiv90, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent91) :-
	spl_db( equiv91_a, Spl1 ),
	test_data( equiv91, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent92) :-
	spl_db( equiv92_a, Spl1 ),
	test_data( equiv92, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent93) :-
	spl_db( equiv93_a, Spl1 ),
	test_data( equiv93, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent94) :-
	spl_db( equiv94_a, Spl1 ),
	test_data( equiv94, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent95) :-
	spl_db( equiv95_a, Spl1 ),
	test_data( equiv95, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent96) :-
	spl_db( equiv96_a, Spl1 ),
	test_data( equiv96, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent97) :-
	spl_db( equiv97_a, Spl1 ),
	test_data( equiv97, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent98) :-
	spl_db( equiv98_a, Spl1 ),
	test_data( equiv98, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent99) :-
	spl_db( equiv99_a, Spl1 ),
	test_data( equiv99, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent100) :-
	spl_db( equiv100_a, Spl1 ),
	test_data( equiv100, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent101) :-
	spl_db( equiv101_a, Spl1 ),
	test_data( equiv101, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent102) :-
	spl_db( equiv102_a, Spl1 ),
	test_data( equiv102, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent103) :-
	spl_db( equiv103_a, Spl1 ),
	test_data( equiv103, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent104) :-
	spl_db( equiv104_a, Spl1 ),
	test_data( equiv104, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent105) :-
	spl_db( equiv105_a, Spl1 ),
	test_data( equiv105, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent106) :-
	spl_db( equiv106_a, Spl1 ),
	test_data( equiv106, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent107) :-
	spl_db( equiv107_a, Spl1 ),
	test_data( equiv107, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent108) :-
	spl_db( equiv108_a, Spl1 ),
	test_data( equiv108, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent109) :-
	spl_db( equiv109_a, Spl1 ),
	test_data( equiv109, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent110) :-
	spl_db( equiv110_a, Spl1 ),
	test_data( equiv110, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent111) :-
	spl_db( equiv111_a, Spl1 ),
	test_data( equiv111, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent112) :-
	spl_db( equiv112_a, Spl1 ),
	test_data( equiv112, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent113) :-
	spl_db( equiv113_a, Spl1 ),
	test_data( equiv113, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent114) :-
	spl_db( equiv114_a, Spl1 ),
	test_data( equiv114, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent115) :-
	spl_db( equiv115_a, Spl1 ),
	test_data( equiv115, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent116) :-
	spl_db( equiv116_a, Spl1 ),
	test_data( equiv116, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent117) :-
	spl_db( equiv117_a, Spl1 ),
	test_data( equiv117, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent118) :-
	spl_db( equiv118_a, Spl1 ),
	test_data( equiv118, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent119) :-
	spl_db( equiv119_a, Spl1 ),
	test_data( equiv119, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent120) :-
	spl_db( equiv120_a, Spl1 ),
	test_data( equiv120, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent121) :-
	spl_db( equiv121_a, Spl1 ),
	test_data( equiv121, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent122) :-
	spl_db( equiv122_a, Spl1 ),
	test_data( equiv122, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent123) :-
	spl_db( equiv123_a, Spl1 ),
	test_data( equiv123, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent124) :-
	spl_db( equiv124_a, Spl1 ),
	test_data( equiv124, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent125) :-
	spl_db( equiv125_a, Spl1 ),
	test_data( equiv125, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent126) :-
	spl_db( equiv126_a, Spl1 ),
	test_data( equiv126, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent127) :-
	spl_db( equiv127_a, Spl1 ),
	test_data( equiv127, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent128) :-
	spl_db( equiv128_a, Spl1 ),
	test_data( equiv128, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent129) :-
	spl_db( equiv129_a, Spl1 ),
	test_data( equiv129, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent130) :-
	spl_db( equiv130_a, Spl1 ),
	test_data( equiv130, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent131) :-
	spl_db( equiv131_a, Spl1 ),
	test_data( equiv131, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent132) :-
	spl_db( equiv132_a, Spl1 ),
	test_data( equiv132, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent133) :-
	spl_db( equiv133_a, Spl1 ),
	test_data( equiv133, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent134) :-
	spl_db( equiv134_a, Spl1 ),
	test_data( equiv134, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent135) :-
	spl_db( equiv135_a, Spl1 ),
	test_data( equiv135, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent136) :-
	spl_db( equiv136_a, Spl1 ),
	test_data( equiv136, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent137) :-
	spl_db( equiv137_a, Spl1 ),
	test_data( equiv137, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent138) :-
	spl_db( equiv138_a, Spl1 ),
	test_data( equiv138, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent139) :-
	spl_db( equiv139_a, Spl1 ),
	test_data( equiv139, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent140) :-
	spl_db( equiv140_a, Spl1 ),
	test_data( equiv140, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent141) :-
	spl_db( equiv141_a, Spl1 ),
	test_data( equiv141, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent142) :-
	spl_db( equiv142_a, Spl1 ),
	test_data( equiv142, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent143) :-
	spl_db( equiv143_a, Spl1 ),
	test_data( equiv143, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent144) :-
	spl_db( equiv144_a, Spl1 ),
	test_data( equiv144, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent145) :-
	spl_db( equiv145_a, Spl1 ),
	test_data( equiv145, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent146) :-
	spl_db( equiv146_a, Spl1 ),
	test_data( equiv146, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent147) :-
	spl_db( equiv147_a, Spl1 ),
	test_data( equiv147, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent148) :-
	spl_db( equiv148_a, Spl1 ),
	test_data( equiv148, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent149) :-
	spl_db( equiv149_a, Spl1 ),
	test_data( equiv149, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent150) :-
	spl_db( equiv150_a, Spl1 ),
	test_data( equiv150, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent151) :-
	spl_db( equiv151_a, Spl1 ),
	test_data( equiv151, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent152) :-
	spl_db( equiv152_a, Spl1 ),
	test_data( equiv152, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent153) :-
	spl_db( equiv153_a, Spl1 ),
	test_data( equiv153, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent154) :-
	spl_db( equiv154_a, Spl1 ),
	test_data( equiv154, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent155) :-
	spl_db( equiv155_a, Spl1 ),
	test_data( equiv155, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent156) :-
	spl_db( equiv156_a, Spl1 ),
	test_data( equiv156, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent157) :-
	spl_db( equiv157_a, Spl1 ),
	test_data( equiv157, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent158) :-
	spl_db( equiv158_a, Spl1 ),
	test_data( equiv158, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent159) :-
	spl_db( equiv159_a, Spl1 ),
	test_data( equiv159, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent160) :-
	spl_db( equiv160_a, Spl1 ),
	test_data( equiv160, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent161) :-
	spl_db( equiv161_a, Spl1 ),
	test_data( equiv161, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent162) :-
	spl_db( equiv162_a, Spl1 ),
	test_data( equiv162, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent163) :-
	spl_db( equiv163_a, Spl1 ),
	test_data( equiv163, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent164) :-
	spl_db( equiv164_a, Spl1 ),
	test_data( equiv164, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent165) :-
	spl_db( equiv165_a, Spl1 ),
	test_data( equiv165, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent166) :-
	spl_db( equiv166_a, Spl1 ),
	test_data( equiv166, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent167) :-
	spl_db( equiv167_a, Spl1 ),
	test_data( equiv167, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent168) :-
	spl_db( equiv168_a, Spl1 ),
	test_data( equiv168, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent169) :-
	spl_db( equiv169_a, Spl1 ),
	test_data( equiv169, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent170) :-
	spl_db( equiv170_a, Spl1 ),
	test_data( equiv170, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent171) :-
	spl_db( equiv171_a, Spl1 ),
	test_data( equiv171, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent172) :-
	spl_db( equiv172_a, Spl1 ),
	test_data( equiv172, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent173) :-
	spl_db( equiv173_a, Spl1 ),
	test_data( equiv173, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent174) :-
	spl_db( equiv174_a, Spl1 ),
	test_data( equiv174, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent175) :-
	spl_db( equiv175_a, Spl1 ),
	test_data( equiv175, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent176) :-
	spl_db( equiv176_a, Spl1 ),
	test_data( equiv176, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent177) :-
	spl_db( equiv177_a, Spl1 ),
	test_data( equiv177, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent178) :-
	spl_db( equiv178_a, Spl1 ),
	test_data( equiv178, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent179) :-
	spl_db( equiv179_a, Spl1 ),
	test_data( equiv179, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent180) :-
	spl_db( equiv180_a, Spl1 ),
	test_data( equiv180, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent181) :-
	spl_db( equiv181_a, Spl1 ),
	test_data( equiv181, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent182) :-
	spl_db( equiv182_a, Spl1 ),
	test_data( equiv182, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent183) :-
	spl_db( equiv183_a, Spl1 ),
	test_data( equiv183, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent184) :-
	spl_db( equiv184_a, Spl1 ),
	test_data( equiv184, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent185) :-
	spl_db( equiv185_a, Spl1 ),
	test_data( equiv185, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent186) :-
	spl_db( equiv186_a, Spl1 ),
	test_data( equiv186, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent187) :-
	spl_db( equiv187_a, Spl1 ),
	test_data( equiv187, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent188) :-
	spl_db( equiv188_a, Spl1 ),
	test_data( equiv188, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent189) :-
	spl_db( equiv189_a, Spl1 ),
	test_data( equiv189, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent190) :-
	spl_db( equiv190_a, Spl1 ),
	test_data( equiv190, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent191) :-
	spl_db( equiv191_a, Spl1 ),
	test_data( equiv191, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent192) :-
	spl_db( equiv192_a, Spl1 ),
	test_data( equiv192, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent193) :-
	spl_db( equiv193_a, Spl1 ),
	test_data( equiv193, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent194) :-
	spl_db( equiv194_a, Spl1 ),
	test_data( equiv194, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent195) :-
	spl_db( equiv195_a, Spl1 ),
	test_data( equiv195, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent196) :-
	spl_db( equiv196_a, Spl1 ),
	test_data( equiv196, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent197) :-
	spl_db( equiv197_a, Spl1 ),
	test_data( equiv197, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent198) :-
	spl_db( equiv198_a, Spl1 ),
	test_data( equiv198, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent199) :-
	spl_db( equiv199_a, Spl1 ),
	test_data( equiv199, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent200) :-
	spl_db( equiv200_a, Spl1 ),
	test_data( equiv200, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent201) :-
	spl_db( equiv201_a, Spl1 ),
	test_data( equiv201, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent202) :-
	spl_db( equiv202_a, Spl1 ),
	test_data( equiv202, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent203) :-
	spl_db( equiv203_a, Spl1 ),
	test_data( equiv203, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent204) :-
	spl_db( equiv204_a, Spl1 ),
	test_data( equiv204, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent205) :-
	spl_db( equiv205_a, Spl1 ),
	test_data( equiv205, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent206) :-
	spl_db( equiv206_a, Spl1 ),
	test_data( equiv206, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent207) :-
	spl_db( equiv207_a, Spl1 ),
	test_data( equiv207, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent208) :-
	spl_db( equiv208_a, Spl1 ),
	test_data( equiv208, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent209) :-
	spl_db( equiv209_a, Spl1 ),
	test_data( equiv209, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent210) :-
	spl_db( equiv210_a, Spl1 ),
	test_data( equiv210, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent211) :-
	spl_db( equiv211_a, Spl1 ),
	test_data( equiv211, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent212) :-
	spl_db( equiv212_a, Spl1 ),
	test_data( equiv212, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent213) :-
	spl_db( equiv213_a, Spl1 ),
	test_data( equiv213, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent214) :-
	spl_db( equiv214_a, Spl1 ),
	test_data( equiv214, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent215) :-
	spl_db( equiv215_a, Spl1 ),
	test_data( equiv215, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent216) :-
	spl_db( equiv216_a, Spl1 ),
	test_data( equiv216, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent217) :-
	spl_db( equiv217_a, Spl1 ),
	test_data( equiv217, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent218) :-
	spl_db( equiv218_a, Spl1 ),
	test_data( equiv218, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent219) :-
	spl_db( equiv219_a, Spl1 ),
	test_data( equiv219, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent220) :-
	spl_db( equiv220_a, Spl1 ),
	test_data( equiv220, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent221) :-
	spl_db( equiv221_a, Spl1 ),
	test_data( equiv221, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent222) :-
	spl_db( equiv222_a, Spl1 ),
	test_data( equiv222, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent223) :-
	spl_db( equiv223_a, Spl1 ),
	test_data( equiv223, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent224) :-
	spl_db( equiv224_a, Spl1 ),
	test_data( equiv224, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent225) :-
	spl_db( equiv225_a, Spl1 ),
	test_data( equiv225, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent226) :-
	spl_db( equiv226_a, Spl1 ),
	test_data( equiv226, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent227) :-
	spl_db( equiv227_a, Spl1 ),
	test_data( equiv227, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent228) :-
	spl_db( equiv228_a, Spl1 ),
	test_data( equiv228, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent229) :-
	spl_db( equiv229_a, Spl1 ),
	test_data( equiv229, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent230) :-
	spl_db( equiv230_a, Spl1 ),
	test_data( equiv230, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent231) :-
	spl_db( equiv231_a, Spl1 ),
	test_data( equiv231, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent232) :-
	spl_db( equiv232_a, Spl1 ),
	test_data( equiv232, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent233) :-
	spl_db( equiv233_a, Spl1 ),
	test_data( equiv233, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent234) :-
	spl_db( equiv234_a, Spl1 ),
	test_data( equiv234, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent235) :-
	spl_db( equiv235_a, Spl1 ),
	test_data( equiv235, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent236) :-
	spl_db( equiv236_a, Spl1 ),
	test_data( equiv236, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent237) :-
	spl_db( equiv237_a, Spl1 ),
	test_data( equiv237, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent238) :-
	spl_db( equiv238_a, Spl1 ),
	test_data( equiv238, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent239) :-
	spl_db( equiv239_a, Spl1 ),
	test_data( equiv239, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent240) :-
	spl_db( equiv240_a, Spl1 ),
	test_data( equiv240, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent241) :-
	spl_db( equiv241_a, Spl1 ),
	test_data( equiv241, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent242) :-
	spl_db( equiv242_a, Spl1 ),
	test_data( equiv242, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent243) :-
	spl_db( equiv243_a, Spl1 ),
	test_data( equiv243, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent244) :-
	spl_db( equiv244_a, Spl1 ),
	test_data( equiv244, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent245) :-
	spl_db( equiv245_a, Spl1 ),
	test_data( equiv245, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent246) :-
	spl_db( equiv246_a, Spl1 ),
	test_data( equiv246, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent247) :-
	spl_db( equiv247_a, Spl1 ),
	test_data( equiv247, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent248) :-
	spl_db( equiv248_a, Spl1 ),
	test_data( equiv248, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent249) :-
	spl_db( equiv249_a, Spl1 ),
	test_data( equiv249, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent250) :-
	spl_db( equiv250_a, Spl1 ),
	test_data( equiv250, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent251) :-
	spl_db( equiv251_a, Spl1 ),
	test_data( equiv251, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent252) :-
	spl_db( equiv252_a, Spl1 ),
	test_data( equiv252, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent253) :-
	spl_db( equiv253_a, Spl1 ),
	test_data( equiv253, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent254) :-
	spl_db( equiv254_a, Spl1 ),
	test_data( equiv254, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent255) :-
	spl_db( equiv255_a, Spl1 ),
	test_data( equiv255, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent256) :-
	spl_db( equiv256_a, Spl1 ),
	test_data( equiv256, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent257) :-
	spl_db( equiv257_a, Spl1 ),
	test_data( equiv257, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent258) :-
	spl_db( equiv258_a, Spl1 ),
	test_data( equiv258, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent259) :-
	spl_db( equiv259_a, Spl1 ),
	test_data( equiv259, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent260) :-
	spl_db( equiv260_a, Spl1 ),
	test_data( equiv260, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent261) :-
	spl_db( equiv261_a, Spl1 ),
	test_data( equiv261, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent262) :-
	spl_db( equiv262_a, Spl1 ),
	test_data( equiv262, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent263) :-
	spl_db( equiv263_a, Spl1 ),
	test_data( equiv263, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent264) :-
	spl_db( equiv264_a, Spl1 ),
	test_data( equiv264, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent265) :-
	spl_db( equiv265_a, Spl1 ),
	test_data( equiv265, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent266) :-
	spl_db( equiv266_a, Spl1 ),
	test_data( equiv266, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent267) :-
	spl_db( equiv267_a, Spl1 ),
	test_data( equiv267, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent268) :-
	spl_db( equiv268_a, Spl1 ),
	test_data( equiv268, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent269) :-
	spl_db( equiv269_a, Spl1 ),
	test_data( equiv269, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent270) :-
	spl_db( equiv270_a, Spl1 ),
	test_data( equiv270, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent271) :-
	spl_db( equiv271_a, Spl1 ),
	test_data( equiv271, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent272) :-
	spl_db( equiv272_a, Spl1 ),
	test_data( equiv272, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent273) :-
	spl_db( equiv273_a, Spl1 ),
	test_data( equiv273, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent274) :-
	spl_db( equiv274_a, Spl1 ),
	test_data( equiv274, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent275) :-
	spl_db( equiv275_a, Spl1 ),
	test_data( equiv275, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent276) :-
	spl_db( equiv276_a, Spl1 ),
	test_data( equiv276, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent277) :-
	spl_db( equiv277_a, Spl1 ),
	test_data( equiv277, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent278) :-
	spl_db( equiv278_a, Spl1 ),
	test_data( equiv278, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent279) :-
	spl_db( equiv279_a, Spl1 ),
	test_data( equiv279, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent280) :-
	spl_db( equiv280_a, Spl1 ),
	test_data( equiv280, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent281) :-
	spl_db( equiv281_a, Spl1 ),
	test_data( equiv281, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent282) :-
	spl_db( equiv282_a, Spl1 ),
	test_data( equiv282, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent283) :-
	spl_db( equiv283_a, Spl1 ),
	test_data( equiv283, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent284) :-
	spl_db( equiv284_a, Spl1 ),
	test_data( equiv284, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent285) :-
	spl_db( equiv285_a, Spl1 ),
	test_data( equiv285, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent286) :-
	spl_db( equiv286_a, Spl1 ),
	test_data( equiv286, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent287) :-
	spl_db( equiv287_a, Spl1 ),
	test_data( equiv287, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent288) :-
	spl_db( equiv288_a, Spl1 ),
	test_data( equiv288, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent289) :-
	spl_db( equiv289_a, Spl1 ),
	test_data( equiv289, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent290) :-
	spl_db( equiv290_a, Spl1 ),
	test_data( equiv290, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent291) :-
	spl_db( equiv291_a, Spl1 ),
	test_data( equiv291, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent292) :-
	spl_db( equiv292_a, Spl1 ),
	test_data( equiv292, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent293) :-
	spl_db( equiv293_a, Spl1 ),
	test_data( equiv293, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent294) :-
	spl_db( equiv294_a, Spl1 ),
	test_data( equiv294, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent295) :-
	spl_db( equiv295_a, Spl1 ),
	test_data( equiv295, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent296) :-
	spl_db( equiv296_a, Spl1 ),
	test_data( equiv296, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent297) :-
	spl_db( equiv297_a, Spl1 ),
	test_data( equiv297, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent298) :-
	spl_db( equiv298_a, Spl1 ),
	test_data( equiv298, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent299) :-
	spl_db( equiv299_a, Spl1 ),
	test_data( equiv299, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent300) :-
	spl_db( equiv300_a, Spl1 ),
	test_data( equiv300, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent301) :-
	spl_db( equiv301_a, Spl1 ),
	test_data( equiv301, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent302) :-
	spl_db( equiv302_a, Spl1 ),
	test_data( equiv302, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent303) :-
	spl_db( equiv303_a, Spl1 ),
	test_data( equiv303, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent304) :-
	spl_db( equiv304_a, Spl1 ),
	test_data( equiv304, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent305) :-
	spl_db( equiv305_a, Spl1 ),
	test_data( equiv305, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent306) :-
	spl_db( equiv306_a, Spl1 ),
	test_data( equiv306, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent307) :-
	spl_db( equiv307_a, Spl1 ),
	test_data( equiv307, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent308) :-
	spl_db( equiv308_a, Spl1 ),
	test_data( equiv308, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent309) :-
	spl_db( equiv309_a, Spl1 ),
	test_data( equiv309, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent310) :-
	spl_db( equiv310_a, Spl1 ),
	test_data( equiv310, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent311) :-
	spl_db( equiv311_a, Spl1 ),
	test_data( equiv311, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent312) :-
	spl_db( equiv312_a, Spl1 ),
	test_data( equiv312, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent313) :-
	spl_db( equiv313_a, Spl1 ),
	test_data( equiv313, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent314) :-
	spl_db( equiv314_a, Spl1 ),
	test_data( equiv314, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent315) :-
	spl_db( equiv315_a, Spl1 ),
	test_data( equiv315, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent316) :-
	spl_db( equiv316_a, Spl1 ),
	test_data( equiv316, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent317) :-
	spl_db( equiv317_a, Spl1 ),
	test_data( equiv317, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent318) :-
	spl_db( equiv318_a, Spl1 ),
	test_data( equiv318, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent319) :-
	spl_db( equiv319_a, Spl1 ),
	test_data( equiv319, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent320) :-
	spl_db( equiv320_a, Spl1 ),
	test_data( equiv320, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent321) :-
	spl_db( equiv321_a, Spl1 ),
	test_data( equiv321, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent322) :-
	spl_db( equiv322_a, Spl1 ),
	test_data( equiv322, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent323) :-
	spl_db( equiv323_a, Spl1 ),
	test_data( equiv323, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent324) :-
	spl_db( equiv324_a, Spl1 ),
	test_data( equiv324, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent325) :-
	spl_db( equiv325_a, Spl1 ),
	test_data( equiv325, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent326) :-
	spl_db( equiv326_a, Spl1 ),
	test_data( equiv326, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent327) :-
	spl_db( equiv327_a, Spl1 ),
	test_data( equiv327, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent328) :-
	spl_db( equiv328_a, Spl1 ),
	test_data( equiv328, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent329) :-
	spl_db( equiv329_a, Spl1 ),
	test_data( equiv329, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent330) :-
	spl_db( equiv330_a, Spl1 ),
	test_data( equiv330, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent331) :-
	spl_db( equiv331_a, Spl1 ),
	test_data( equiv331, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent332) :-
	spl_db( equiv332_a, Spl1 ),
	test_data( equiv332, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent333) :-
	spl_db( equiv333_a, Spl1 ),
	test_data( equiv333, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent334) :-
	spl_db( equiv334_a, Spl1 ),
	test_data( equiv334, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent335) :-
	spl_db( equiv335_a, Spl1 ),
	test_data( equiv335, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent336) :-
	spl_db( equiv336_a, Spl1 ),
	test_data( equiv336, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent337) :-
	spl_db( equiv337_a, Spl1 ),
	test_data( equiv337, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent338) :-
	spl_db( equiv338_a, Spl1 ),
	test_data( equiv338, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent339) :-
	spl_db( equiv339_a, Spl1 ),
	test_data( equiv339, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent340) :-
	spl_db( equiv340_a, Spl1 ),
	test_data( equiv340, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent341) :-
	spl_db( equiv341_a, Spl1 ),
	test_data( equiv341, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent342) :-
	spl_db( equiv342_a, Spl1 ),
	test_data( equiv342, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent343) :-
	spl_db( equiv343_a, Spl1 ),
	test_data( equiv343, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent344) :-
	spl_db( equiv344_a, Spl1 ),
	test_data( equiv344, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent345) :-
	spl_db( equiv345_a, Spl1 ),
	test_data( equiv345, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent346) :-
	spl_db( equiv346_a, Spl1 ),
	test_data( equiv346, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent347) :-
	spl_db( equiv347_a, Spl1 ),
	test_data( equiv347, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent348) :-
	spl_db( equiv348_a, Spl1 ),
	test_data( equiv348, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent349) :-
	spl_db( equiv349_a, Spl1 ),
	test_data( equiv349, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent350) :-
	spl_db( equiv350_a, Spl1 ),
	test_data( equiv350, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent351) :-
	spl_db( equiv351_a, Spl1 ),
	test_data( equiv351, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent352) :-
	spl_db( equiv352_a, Spl1 ),
	test_data( equiv352, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent353) :-
	spl_db( equiv353_a, Spl1 ),
	test_data( equiv353, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent354) :-
	spl_db( equiv354_a, Spl1 ),
	test_data( equiv354, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent355) :-
	spl_db( equiv355_a, Spl1 ),
	test_data( equiv355, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent356) :-
	spl_db( equiv356_a, Spl1 ),
	test_data( equiv356, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent357) :-
	spl_db( equiv357_a, Spl1 ),
	test_data( equiv357, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent358) :-
	spl_db( equiv358_a, Spl1 ),
	test_data( equiv358, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent359) :-
	spl_db( equiv359_a, Spl1 ),
	test_data( equiv359, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent360) :-
	spl_db( equiv360_a, Spl1 ),
	test_data( equiv360, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent361) :-
	spl_db( equiv361_a, Spl1 ),
	test_data( equiv361, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent362) :-
	spl_db( equiv362_a, Spl1 ),
	test_data( equiv362, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent363) :-
	spl_db( equiv363_a, Spl1 ),
	test_data( equiv363, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent364) :-
	spl_db( equiv364_a, Spl1 ),
	test_data( equiv364, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent365) :-
	spl_db( equiv365_a, Spl1 ),
	test_data( equiv365, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent366) :-
	spl_db( equiv366_a, Spl1 ),
	test_data( equiv366, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent367) :-
	spl_db( equiv367_a, Spl1 ),
	test_data( equiv367, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent368) :-
	spl_db( equiv368_a, Spl1 ),
	test_data( equiv368, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent369) :-
	spl_db( equiv369_a, Spl1 ),
	test_data( equiv369, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent370) :-
	spl_db( equiv370_a, Spl1 ),
	test_data( equiv370, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent371) :-
	spl_db( equiv371_a, Spl1 ),
	test_data( equiv371, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent372) :-
	spl_db( equiv372_a, Spl1 ),
	test_data( equiv372, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent373) :-
	spl_db( equiv373_a, Spl1 ),
	test_data( equiv373, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent374) :-
	spl_db( equiv374_a, Spl1 ),
	test_data( equiv374, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent375) :-
	spl_db( equiv375_a, Spl1 ),
	test_data( equiv375, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent376) :-
	spl_db( equiv376_a, Spl1 ),
	test_data( equiv376, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent377) :-
	spl_db( equiv377_a, Spl1 ),
	test_data( equiv377, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent378) :-
	spl_db( equiv378_a, Spl1 ),
	test_data( equiv378, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent379) :-
	spl_db( equiv379_a, Spl1 ),
	test_data( equiv379, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent380) :-
	spl_db( equiv380_a, Spl1 ),
	test_data( equiv380, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent381) :-
	spl_db( equiv381_a, Spl1 ),
	test_data( equiv381, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent382) :-
	spl_db( equiv382_a, Spl1 ),
	test_data( equiv382, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent383) :-
	spl_db( equiv383_a, Spl1 ),
	test_data( equiv383, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent384) :-
	spl_db( equiv384_a, Spl1 ),
	test_data( equiv384, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent385) :-
	spl_db( equiv385_a, Spl1 ),
	test_data( equiv385, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent386) :-
	spl_db( equiv386_a, Spl1 ),
	test_data( equiv386, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent387) :-
	spl_db( equiv387_a, Spl1 ),
	test_data( equiv387, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent388) :-
	spl_db( equiv388_a, Spl1 ),
	test_data( equiv388, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent389) :-
	spl_db( equiv389_a, Spl1 ),
	test_data( equiv389, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent390) :-
	spl_db( equiv390_a, Spl1 ),
	test_data( equiv390, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent391) :-
	spl_db( equiv391_a, Spl1 ),
	test_data( equiv391, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent392) :-
	spl_db( equiv392_a, Spl1 ),
	test_data( equiv392, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent393) :-
	spl_db( equiv393_a, Spl1 ),
	test_data( equiv393, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent394) :-
	spl_db( equiv394_a, Spl1 ),
	test_data( equiv394, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent395) :-
	spl_db( equiv395_a, Spl1 ),
	test_data( equiv395, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent396) :-
	spl_db( equiv396_a, Spl1 ),
	test_data( equiv396, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent397) :-
	spl_db( equiv397_a, Spl1 ),
	test_data( equiv397, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent398) :-
	spl_db( equiv398_a, Spl1 ),
	test_data( equiv398, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent399) :-
	spl_db( equiv399_a, Spl1 ),
	test_data( equiv399, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent400) :-
	spl_db( equiv400_a, Spl1 ),
	test_data( equiv400, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent401) :-
	spl_db( equiv401_a, Spl1 ),
	test_data( equiv401, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent402) :-
	spl_db( equiv402_a, Spl1 ),
	test_data( equiv402, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent403) :-
	spl_db( equiv403_a, Spl1 ),
	test_data( equiv403, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent404) :-
	spl_db( equiv404_a, Spl1 ),
	test_data( equiv404, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent405) :-
	spl_db( equiv405_a, Spl1 ),
	test_data( equiv405, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent406) :-
	spl_db( equiv406_a, Spl1 ),
	test_data( equiv406, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent407) :-
	spl_db( equiv407_a, Spl1 ),
	test_data( equiv407, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent408) :-
	spl_db( equiv408_a, Spl1 ),
	test_data( equiv408, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent409) :-
	spl_db( equiv409_a, Spl1 ),
	test_data( equiv409, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent410) :-
	spl_db( equiv410_a, Spl1 ),
	test_data( equiv410, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent411) :-
	spl_db( equiv411_a, Spl1 ),
	test_data( equiv411, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent412) :-
	spl_db( equiv412_a, Spl1 ),
	test_data( equiv412, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent413) :-
	spl_db( equiv413_a, Spl1 ),
	test_data( equiv413, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent414) :-
	spl_db( equiv414_a, Spl1 ),
	test_data( equiv414, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent415) :-
	spl_db( equiv415_a, Spl1 ),
	test_data( equiv415, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent416) :-
	spl_db( equiv416_a, Spl1 ),
	test_data( equiv416, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent417) :-
	spl_db( equiv417_a, Spl1 ),
	test_data( equiv417, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent418) :-
	spl_db( equiv418_a, Spl1 ),
	test_data( equiv418, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent419) :-
	spl_db( equiv419_a, Spl1 ),
	test_data( equiv419, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent420) :-
	spl_db( equiv420_a, Spl1 ),
	test_data( equiv420, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent421) :-
	spl_db( equiv421_a, Spl1 ),
	test_data( equiv421, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent422) :-
	spl_db( equiv422_a, Spl1 ),
	test_data( equiv422, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent423) :-
	spl_db( equiv423_a, Spl1 ),
	test_data( equiv423, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent424) :-
	spl_db( equiv424_a, Spl1 ),
	test_data( equiv424, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent425) :-
	spl_db( equiv425_a, Spl1 ),
	test_data( equiv425, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent426) :-
	spl_db( equiv426_a, Spl1 ),
	test_data( equiv426, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent427) :-
	spl_db( equiv427_a, Spl1 ),
	test_data( equiv427, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent428) :-
	spl_db( equiv428_a, Spl1 ),
	test_data( equiv428, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent429) :-
	spl_db( equiv429_a, Spl1 ),
	test_data( equiv429, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent430) :-
	spl_db( equiv430_a, Spl1 ),
	test_data( equiv430, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent431) :-
	spl_db( equiv431_a, Spl1 ),
	test_data( equiv431, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent432) :-
	spl_db( equiv432_a, Spl1 ),
	test_data( equiv432, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent433) :-
	spl_db( equiv433_a, Spl1 ),
	test_data( equiv433, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent434) :-
	spl_db( equiv434_a, Spl1 ),
	test_data( equiv434, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent435) :-
	spl_db( equiv435_a, Spl1 ),
	test_data( equiv435, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent436) :-
	spl_db( equiv436_a, Spl1 ),
	test_data( equiv436, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent437) :-
	spl_db( equiv437_a, Spl1 ),
	test_data( equiv437, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent438) :-
	spl_db( equiv438_a, Spl1 ),
	test_data( equiv438, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent439) :-
	spl_db( equiv439_a, Spl1 ),
	test_data( equiv439, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent440) :-
	spl_db( equiv440_a, Spl1 ),
	test_data( equiv440, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent441) :-
	spl_db( equiv441_a, Spl1 ),
	test_data( equiv441, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent442) :-
	spl_db( equiv442_a, Spl1 ),
	test_data( equiv442, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent443) :-
	spl_db( equiv443_a, Spl1 ),
	test_data( equiv443, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent444) :-
	spl_db( equiv444_a, Spl1 ),
	test_data( equiv444, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent445) :-
	spl_db( equiv445_a, Spl1 ),
	test_data( equiv445, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent446) :-
	spl_db( equiv446_a, Spl1 ),
	test_data( equiv446, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent447) :-
	spl_db( equiv447_a, Spl1 ),
	test_data( equiv447, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent448) :-
	spl_db( equiv448_a, Spl1 ),
	test_data( equiv448, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent449) :-
	spl_db( equiv449_a, Spl1 ),
	test_data( equiv449, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent450) :-
	spl_db( equiv450_a, Spl1 ),
	test_data( equiv450, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent451) :-
	spl_db( equiv451_a, Spl1 ),
	test_data( equiv451, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent452) :-
	spl_db( equiv452_a, Spl1 ),
	test_data( equiv452, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent453) :-
	spl_db( equiv453_a, Spl1 ),
	test_data( equiv453, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent454) :-
	spl_db( equiv454_a, Spl1 ),
	test_data( equiv454, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent455) :-
	spl_db( equiv455_a, Spl1 ),
	test_data( equiv455, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent456) :-
	spl_db( equiv456_a, Spl1 ),
	test_data( equiv456, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent457) :-
	spl_db( equiv457_a, Spl1 ),
	test_data( equiv457, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent458) :-
	spl_db( equiv458_a, Spl1 ),
	test_data( equiv458, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent459) :-
	spl_db( equiv459_a, Spl1 ),
	test_data( equiv459, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent460) :-
	spl_db( equiv460_a, Spl1 ),
	test_data( equiv460, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent461) :-
	spl_db( equiv461_a, Spl1 ),
	test_data( equiv461, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent462) :-
	spl_db( equiv462_a, Spl1 ),
	test_data( equiv462, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent463) :-
	spl_db( equiv463_a, Spl1 ),
	test_data( equiv463, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent464) :-
	spl_db( equiv464_a, Spl1 ),
	test_data( equiv464, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent465) :-
	spl_db( equiv465_a, Spl1 ),
	test_data( equiv465, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent466) :-
	spl_db( equiv466_a, Spl1 ),
	test_data( equiv466, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent467) :-
	spl_db( equiv467_a, Spl1 ),
	test_data( equiv467, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent468) :-
	spl_db( equiv468_a, Spl1 ),
	test_data( equiv468, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent469) :-
	spl_db( equiv469_a, Spl1 ),
	test_data( equiv469, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent470) :-
	spl_db( equiv470_a, Spl1 ),
	test_data( equiv470, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent471) :-
	spl_db( equiv471_a, Spl1 ),
	test_data( equiv471, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent472) :-
	spl_db( equiv472_a, Spl1 ),
	test_data( equiv472, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent473) :-
	spl_db( equiv473_a, Spl1 ),
	test_data( equiv473, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent474) :-
	spl_db( equiv474_a, Spl1 ),
	test_data( equiv474, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent475) :-
	spl_db( equiv475_a, Spl1 ),
	test_data( equiv475, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent476) :-
	spl_db( equiv476_a, Spl1 ),
	test_data( equiv476, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent477) :-
	spl_db( equiv477_a, Spl1 ),
	test_data( equiv477, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent478) :-
	spl_db( equiv478_a, Spl1 ),
	test_data( equiv478, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent479) :-
	spl_db( equiv479_a, Spl1 ),
	test_data( equiv479, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent480) :-
	spl_db( equiv480_a, Spl1 ),
	test_data( equiv480, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent481) :-
	spl_db( equiv481_a, Spl1 ),
	test_data( equiv481, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent482) :-
	spl_db( equiv482_a, Spl1 ),
	test_data( equiv482, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent483) :-
	spl_db( equiv483_a, Spl1 ),
	test_data( equiv483, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent484) :-
	spl_db( equiv484_a, Spl1 ),
	test_data( equiv484, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent485) :-
	spl_db( equiv485_a, Spl1 ),
	test_data( equiv485, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent486) :-
	spl_db( equiv486_a, Spl1 ),
	test_data( equiv486, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent487) :-
	spl_db( equiv487_a, Spl1 ),
	test_data( equiv487, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent488) :-
	spl_db( equiv488_a, Spl1 ),
	test_data( equiv488, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent489) :-
	spl_db( equiv489_a, Spl1 ),
	test_data( equiv489, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent490) :-
	spl_db( equiv490_a, Spl1 ),
	test_data( equiv490, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent491) :-
	spl_db( equiv491_a, Spl1 ),
	test_data( equiv491, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent492) :-
	spl_db( equiv492_a, Spl1 ),
	test_data( equiv492, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent493) :-
	spl_db( equiv493_a, Spl1 ),
	test_data( equiv493, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent494) :-
	spl_db( equiv494_a, Spl1 ),
	test_data( equiv494, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent495) :-
	spl_db( equiv495_a, Spl1 ),
	test_data( equiv495, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent496) :-
	spl_db( equiv496_a, Spl1 ),
	test_data( equiv496, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent497) :-
	spl_db( equiv497_a, Spl1 ),
	test_data( equiv497, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent498) :-
	spl_db( equiv498_a, Spl1 ),
	test_data( equiv498, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent499) :-
	spl_db( equiv499_a, Spl1 ),
	test_data( equiv499, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent500) :-
	spl_db( equiv500_a, Spl1 ),
	test_data( equiv500, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent501) :-
	spl_db( equiv501_a, Spl1 ),
	test_data( equiv501, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent502) :-
	spl_db( equiv502_a, Spl1 ),
	test_data( equiv502, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent503) :-
	spl_db( equiv503_a, Spl1 ),
	test_data( equiv503, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent504) :-
	spl_db( equiv504_a, Spl1 ),
	test_data( equiv504, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent505) :-
	spl_db( equiv505_a, Spl1 ),
	test_data( equiv505, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent506) :-
	spl_db( equiv506_a, Spl1 ),
	test_data( equiv506, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent507) :-
	spl_db( equiv507_a, Spl1 ),
	test_data( equiv507, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent508) :-
	spl_db( equiv508_a, Spl1 ),
	test_data( equiv508, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent509) :-
	spl_db( equiv509_a, Spl1 ),
	test_data( equiv509, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent510) :-
	spl_db( equiv510_a, Spl1 ),
	test_data( equiv510, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent511) :-
	spl_db( equiv511_a, Spl1 ),
	test_data( equiv511, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent512) :-
	spl_db( equiv512_a, Spl1 ),
	test_data( equiv512, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent513) :-
	spl_db( equiv513_a, Spl1 ),
	test_data( equiv513, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent514) :-
	spl_db( equiv514_a, Spl1 ),
	test_data( equiv514, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent515) :-
	spl_db( equiv515_a, Spl1 ),
	test_data( equiv515, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent516) :-
	spl_db( equiv516_a, Spl1 ),
	test_data( equiv516, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent517) :-
	spl_db( equiv517_a, Spl1 ),
	test_data( equiv517, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent518) :-
	spl_db( equiv518_a, Spl1 ),
	test_data( equiv518, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent519) :-
	spl_db( equiv519_a, Spl1 ),
	test_data( equiv519, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent520) :-
	spl_db( equiv520_a, Spl1 ),
	test_data( equiv520, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent521) :-
	spl_db( equiv521_a, Spl1 ),
	test_data( equiv521, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent522) :-
	spl_db( equiv522_a, Spl1 ),
	test_data( equiv522, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent523) :-
	spl_db( equiv523_a, Spl1 ),
	test_data( equiv523, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent524) :-
	spl_db( equiv524_a, Spl1 ),
	test_data( equiv524, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent525) :-
	spl_db( equiv525_a, Spl1 ),
	test_data( equiv525, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent526) :-
	spl_db( equiv526_a, Spl1 ),
	test_data( equiv526, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent527) :-
	spl_db( equiv527_a, Spl1 ),
	test_data( equiv527, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent528) :-
	spl_db( equiv528_a, Spl1 ),
	test_data( equiv528, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent529) :-
	spl_db( equiv529_a, Spl1 ),
	test_data( equiv529, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent530) :-
	spl_db( equiv530_a, Spl1 ),
	test_data( equiv530, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent531) :-
	spl_db( equiv531_a, Spl1 ),
	test_data( equiv531, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent532) :-
	spl_db( equiv532_a, Spl1 ),
	test_data( equiv532, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent533) :-
	spl_db( equiv533_a, Spl1 ),
	test_data( equiv533, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent534) :-
	spl_db( equiv534_a, Spl1 ),
	test_data( equiv534, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent535) :-
	spl_db( equiv535_a, Spl1 ),
	test_data( equiv535, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent536) :-
	spl_db( equiv536_a, Spl1 ),
	test_data( equiv536, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent537) :-
	spl_db( equiv537_a, Spl1 ),
	test_data( equiv537, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent538) :-
	spl_db( equiv538_a, Spl1 ),
	test_data( equiv538, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent539) :-
	spl_db( equiv539_a, Spl1 ),
	test_data( equiv539, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent540) :-
	spl_db( equiv540_a, Spl1 ),
	test_data( equiv540, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent541) :-
	spl_db( equiv541_a, Spl1 ),
	test_data( equiv541, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent542) :-
	spl_db( equiv542_a, Spl1 ),
	test_data( equiv542, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent543) :-
	spl_db( equiv543_a, Spl1 ),
	test_data( equiv543, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent544) :-
	spl_db( equiv544_a, Spl1 ),
	test_data( equiv544, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent545) :-
	spl_db( equiv545_a, Spl1 ),
	test_data( equiv545, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent546) :-
	spl_db( equiv546_a, Spl1 ),
	test_data( equiv546, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent547) :-
	spl_db( equiv547_a, Spl1 ),
	test_data( equiv547, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent548) :-
	spl_db( equiv548_a, Spl1 ),
	test_data( equiv548, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent549) :-
	spl_db( equiv549_a, Spl1 ),
	test_data( equiv549, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent550) :-
	spl_db( equiv550_a, Spl1 ),
	test_data( equiv550, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent551) :-
	spl_db( equiv551_a, Spl1 ),
	test_data( equiv551, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent552) :-
	spl_db( equiv552_a, Spl1 ),
	test_data( equiv552, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent553) :-
	spl_db( equiv553_a, Spl1 ),
	test_data( equiv553, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent554) :-
	spl_db( equiv554_a, Spl1 ),
	test_data( equiv554, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent555) :-
	spl_db( equiv555_a, Spl1 ),
	test_data( equiv555, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent556) :-
	spl_db( equiv556_a, Spl1 ),
	test_data( equiv556, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent557) :-
	spl_db( equiv557_a, Spl1 ),
	test_data( equiv557, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent558) :-
	spl_db( equiv558_a, Spl1 ),
	test_data( equiv558, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent559) :-
	spl_db( equiv559_a, Spl1 ),
	test_data( equiv559, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent560) :-
	spl_db( equiv560_a, Spl1 ),
	test_data( equiv560, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent561) :-
	spl_db( equiv561_a, Spl1 ),
	test_data( equiv561, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent562) :-
	spl_db( equiv562_a, Spl1 ),
	test_data( equiv562, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent563) :-
	spl_db( equiv563_a, Spl1 ),
	test_data( equiv563, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent564) :-
	spl_db( equiv564_a, Spl1 ),
	test_data( equiv564, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent565) :-
	spl_db( equiv565_a, Spl1 ),
	test_data( equiv565, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent566) :-
	spl_db( equiv566_a, Spl1 ),
	test_data( equiv566, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent567) :-
	spl_db( equiv567_a, Spl1 ),
	test_data( equiv567, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent568) :-
	spl_db( equiv568_a, Spl1 ),
	test_data( equiv568, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent569) :-
	spl_db( equiv569_a, Spl1 ),
	test_data( equiv569, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent570) :-
	spl_db( equiv570_a, Spl1 ),
	test_data( equiv570, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent571) :-
	spl_db( equiv571_a, Spl1 ),
	test_data( equiv571, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent572) :-
	spl_db( equiv572_a, Spl1 ),
	test_data( equiv572, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent573) :-
	spl_db( equiv573_a, Spl1 ),
	test_data( equiv573, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent574) :-
	spl_db( equiv574_a, Spl1 ),
	test_data( equiv574, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent575) :-
	spl_db( equiv575_a, Spl1 ),
	test_data( equiv575, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent576) :-
	spl_db( equiv576_a, Spl1 ),
	test_data( equiv576, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent577) :-
	spl_db( equiv577_a, Spl1 ),
	test_data( equiv577, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent578) :-
	spl_db( equiv578_a, Spl1 ),
	test_data( equiv578, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent579) :-
	spl_db( equiv579_a, Spl1 ),
	test_data( equiv579, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent580) :-
	spl_db( equiv580_a, Spl1 ),
	test_data( equiv580, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent581) :-
	spl_db( equiv581_a, Spl1 ),
	test_data( equiv581, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent582) :-
	spl_db( equiv582_a, Spl1 ),
	test_data( equiv582, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent583) :-
	spl_db( equiv583_a, Spl1 ),
	test_data( equiv583, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent584) :-
	spl_db( equiv584_a, Spl1 ),
	test_data( equiv584, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent585) :-
	spl_db( equiv585_a, Spl1 ),
	test_data( equiv585, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent586) :-
	spl_db( equiv586_a, Spl1 ),
	test_data( equiv586, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent587) :-
	spl_db( equiv587_a, Spl1 ),
	test_data( equiv587, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent588) :-
	spl_db( equiv588_a, Spl1 ),
	test_data( equiv588, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent589) :-
	spl_db( equiv589_a, Spl1 ),
	test_data( equiv589, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent590) :-
	spl_db( equiv590_a, Spl1 ),
	test_data( equiv590, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent591) :-
	spl_db( equiv591_a, Spl1 ),
	test_data( equiv591, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent592) :-
	spl_db( equiv592_a, Spl1 ),
	test_data( equiv592, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent593) :-
	spl_db( equiv593_a, Spl1 ),
	test_data( equiv593, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent594) :-
	spl_db( equiv594_a, Spl1 ),
	test_data( equiv594, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent595) :-
	spl_db( equiv595_a, Spl1 ),
	test_data( equiv595, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent596) :-
	spl_db( equiv596_a, Spl1 ),
	test_data( equiv596, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent597) :-
	spl_db( equiv597_a, Spl1 ),
	test_data( equiv597, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent598) :-
	spl_db( equiv598_a, Spl1 ),
	test_data( equiv598, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent599) :-
	spl_db( equiv599_a, Spl1 ),
	test_data( equiv599, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent600) :-
	spl_db( equiv600_a, Spl1 ),
	test_data( equiv600, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent601) :-
	spl_db( equiv601_a, Spl1 ),
	test_data( equiv601, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent602) :-
	spl_db( equiv602_a, Spl1 ),
	test_data( equiv602, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent603) :-
	spl_db( equiv603_a, Spl1 ),
	test_data( equiv603, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent604) :-
	spl_db( equiv604_a, Spl1 ),
	test_data( equiv604, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent605) :-
	spl_db( equiv605_a, Spl1 ),
	test_data( equiv605, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent606) :-
	spl_db( equiv606_a, Spl1 ),
	test_data( equiv606, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent607) :-
	spl_db( equiv607_a, Spl1 ),
	test_data( equiv607, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent608) :-
	spl_db( equiv608_a, Spl1 ),
	test_data( equiv608, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent609) :-
	spl_db( equiv609_a, Spl1 ),
	test_data( equiv609, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent610) :-
	spl_db( equiv610_a, Spl1 ),
	test_data( equiv610, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent611) :-
	spl_db( equiv611_a, Spl1 ),
	test_data( equiv611, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent612) :-
	spl_db( equiv612_a, Spl1 ),
	test_data( equiv612, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent613) :-
	spl_db( equiv613_a, Spl1 ),
	test_data( equiv613, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent614) :-
	spl_db( equiv614_a, Spl1 ),
	test_data( equiv614, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent615) :-
	spl_db( equiv615_a, Spl1 ),
	test_data( equiv615, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent616) :-
	spl_db( equiv616_a, Spl1 ),
	test_data( equiv616, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent617) :-
	spl_db( equiv617_a, Spl1 ),
	test_data( equiv617, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent618) :-
	spl_db( equiv618_a, Spl1 ),
	test_data( equiv618, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent619) :-
	spl_db( equiv619_a, Spl1 ),
	test_data( equiv619, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent620) :-
	spl_db( equiv620_a, Spl1 ),
	test_data( equiv620, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent621) :-
	spl_db( equiv621_a, Spl1 ),
	test_data( equiv621, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent622) :-
	spl_db( equiv622_a, Spl1 ),
	test_data( equiv622, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent623) :-
	spl_db( equiv623_a, Spl1 ),
	test_data( equiv623, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent624) :-
	spl_db( equiv624_a, Spl1 ),
	test_data( equiv624, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent625) :-
	spl_db( equiv625_a, Spl1 ),
	test_data( equiv625, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent626) :-
	spl_db( equiv626_a, Spl1 ),
	test_data( equiv626, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent627) :-
	spl_db( equiv627_a, Spl1 ),
	test_data( equiv627, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent628) :-
	spl_db( equiv628_a, Spl1 ),
	test_data( equiv628, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent629) :-
	spl_db( equiv629_a, Spl1 ),
	test_data( equiv629, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent630) :-
	spl_db( equiv630_a, Spl1 ),
	test_data( equiv630, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent631) :-
	spl_db( equiv631_a, Spl1 ),
	test_data( equiv631, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent632) :-
	spl_db( equiv632_a, Spl1 ),
	test_data( equiv632, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent633) :-
	spl_db( equiv633_a, Spl1 ),
	test_data( equiv633, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent634) :-
	spl_db( equiv634_a, Spl1 ),
	test_data( equiv634, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent635) :-
	spl_db( equiv635_a, Spl1 ),
	test_data( equiv635, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent636) :-
	spl_db( equiv636_a, Spl1 ),
	test_data( equiv636, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent637) :-
	spl_db( equiv637_a, Spl1 ),
	test_data( equiv637, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent638) :-
	spl_db( equiv638_a, Spl1 ),
	test_data( equiv638, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent639) :-
	spl_db( equiv639_a, Spl1 ),
	test_data( equiv639, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent640) :-
	spl_db( equiv640_a, Spl1 ),
	test_data( equiv640, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent641) :-
	spl_db( equiv641_a, Spl1 ),
	test_data( equiv641, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent642) :-
	spl_db( equiv642_a, Spl1 ),
	test_data( equiv642, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent643) :-
	spl_db( equiv643_a, Spl1 ),
	test_data( equiv643, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent644) :-
	spl_db( equiv644_a, Spl1 ),
	test_data( equiv644, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent645) :-
	spl_db( equiv645_a, Spl1 ),
	test_data( equiv645, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent646) :-
	spl_db( equiv646_a, Spl1 ),
	test_data( equiv646, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent647) :-
	spl_db( equiv647_a, Spl1 ),
	test_data( equiv647, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent648) :-
	spl_db( equiv648_a, Spl1 ),
	test_data( equiv648, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent649) :-
	spl_db( equiv649_a, Spl1 ),
	test_data( equiv649, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent650) :-
	spl_db( equiv650_a, Spl1 ),
	test_data( equiv650, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent651) :-
	spl_db( equiv651_a, Spl1 ),
	test_data( equiv651, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent652) :-
	spl_db( equiv652_a, Spl1 ),
	test_data( equiv652, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent653) :-
	spl_db( equiv653_a, Spl1 ),
	test_data( equiv653, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent654) :-
	spl_db( equiv654_a, Spl1 ),
	test_data( equiv654, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent655) :-
	spl_db( equiv655_a, Spl1 ),
	test_data( equiv655, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent656) :-
	spl_db( equiv656_a, Spl1 ),
	test_data( equiv656, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent657) :-
	spl_db( equiv657_a, Spl1 ),
	test_data( equiv657, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent658) :-
	spl_db( equiv658_a, Spl1 ),
	test_data( equiv658, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent659) :-
	spl_db( equiv659_a, Spl1 ),
	test_data( equiv659, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent660) :-
	spl_db( equiv660_a, Spl1 ),
	test_data( equiv660, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent661) :-
	spl_db( equiv661_a, Spl1 ),
	test_data( equiv661, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent662) :-
	spl_db( equiv662_a, Spl1 ),
	test_data( equiv662, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent663) :-
	spl_db( equiv663_a, Spl1 ),
	test_data( equiv663, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent664) :-
	spl_db( equiv664_a, Spl1 ),
	test_data( equiv664, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent665) :-
	spl_db( equiv665_a, Spl1 ),
	test_data( equiv665, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent666) :-
	spl_db( equiv666_a, Spl1 ),
	test_data( equiv666, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent667) :-
	spl_db( equiv667_a, Spl1 ),
	test_data( equiv667, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent668) :-
	spl_db( equiv668_a, Spl1 ),
	test_data( equiv668, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent669) :-
	spl_db( equiv669_a, Spl1 ),
	test_data( equiv669, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent670) :-
	spl_db( equiv670_a, Spl1 ),
	test_data( equiv670, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent671) :-
	spl_db( equiv671_a, Spl1 ),
	test_data( equiv671, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent672) :-
	spl_db( equiv672_a, Spl1 ),
	test_data( equiv672, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent673) :-
	spl_db( equiv673_a, Spl1 ),
	test_data( equiv673, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent674) :-
	spl_db( equiv674_a, Spl1 ),
	test_data( equiv674, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent675) :-
	spl_db( equiv675_a, Spl1 ),
	test_data( equiv675, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent676) :-
	spl_db( equiv676_a, Spl1 ),
	test_data( equiv676, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent677) :-
	spl_db( equiv677_a, Spl1 ),
	test_data( equiv677, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent678) :-
	spl_db( equiv678_a, Spl1 ),
	test_data( equiv678, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent679) :-
	spl_db( equiv679_a, Spl1 ),
	test_data( equiv679, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent680) :-
	spl_db( equiv680_a, Spl1 ),
	test_data( equiv680, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent681) :-
	spl_db( equiv681_a, Spl1 ),
	test_data( equiv681, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent682) :-
	spl_db( equiv682_a, Spl1 ),
	test_data( equiv682, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent683) :-
	spl_db( equiv683_a, Spl1 ),
	test_data( equiv683, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent684) :-
	spl_db( equiv684_a, Spl1 ),
	test_data( equiv684, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent685) :-
	spl_db( equiv685_a, Spl1 ),
	test_data( equiv685, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent686) :-
	spl_db( equiv686_a, Spl1 ),
	test_data( equiv686, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent687) :-
	spl_db( equiv687_a, Spl1 ),
	test_data( equiv687, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent688) :-
	spl_db( equiv688_a, Spl1 ),
	test_data( equiv688, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent689) :-
	spl_db( equiv689_a, Spl1 ),
	test_data( equiv689, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent690) :-
	spl_db( equiv690_a, Spl1 ),
	test_data( equiv690, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent691) :-
	spl_db( equiv691_a, Spl1 ),
	test_data( equiv691, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent692) :-
	spl_db( equiv692_a, Spl1 ),
	test_data( equiv692, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent693) :-
	spl_db( equiv693_a, Spl1 ),
	test_data( equiv693, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent694) :-
	spl_db( equiv694_a, Spl1 ),
	test_data( equiv694, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent695) :-
	spl_db( equiv695_a, Spl1 ),
	test_data( equiv695, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent696) :-
	spl_db( equiv696_a, Spl1 ),
	test_data( equiv696, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent697) :-
	spl_db( equiv697_a, Spl1 ),
	test_data( equiv697, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent698) :-
	spl_db( equiv698_a, Spl1 ),
	test_data( equiv698, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent699) :-
	spl_db( equiv699_a, Spl1 ),
	test_data( equiv699, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent700) :-
	spl_db( equiv700_a, Spl1 ),
	test_data( equiv700, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent701) :-
	spl_db( equiv701_a, Spl1 ),
	test_data( equiv701, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent702) :-
	spl_db( equiv702_a, Spl1 ),
	test_data( equiv702, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent703) :-
	spl_db( equiv703_a, Spl1 ),
	test_data( equiv703, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent704) :-
	spl_db( equiv704_a, Spl1 ),
	test_data( equiv704, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent705) :-
	spl_db( equiv705_a, Spl1 ),
	test_data( equiv705, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent706) :-
	spl_db( equiv706_a, Spl1 ),
	test_data( equiv706, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent707) :-
	spl_db( equiv707_a, Spl1 ),
	test_data( equiv707, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent708) :-
	spl_db( equiv708_a, Spl1 ),
	test_data( equiv708, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent709) :-
	spl_db( equiv709_a, Spl1 ),
	test_data( equiv709, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent710) :-
	spl_db( equiv710_a, Spl1 ),
	test_data( equiv710, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent711) :-
	spl_db( equiv711_a, Spl1 ),
	test_data( equiv711, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent712) :-
	spl_db( equiv712_a, Spl1 ),
	test_data( equiv712, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent713) :-
	spl_db( equiv713_a, Spl1 ),
	test_data( equiv713, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent714) :-
	spl_db( equiv714_a, Spl1 ),
	test_data( equiv714, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent715) :-
	spl_db( equiv715_a, Spl1 ),
	test_data( equiv715, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent716) :-
	spl_db( equiv716_a, Spl1 ),
	test_data( equiv716, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent717) :-
	spl_db( equiv717_a, Spl1 ),
	test_data( equiv717, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent718) :-
	spl_db( equiv718_a, Spl1 ),
	test_data( equiv718, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent719) :-
	spl_db( equiv719_a, Spl1 ),
	test_data( equiv719, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent720) :-
	spl_db( equiv720_a, Spl1 ),
	test_data( equiv720, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent721) :-
	spl_db( equiv721_a, Spl1 ),
	test_data( equiv721, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent722) :-
	spl_db( equiv722_a, Spl1 ),
	test_data( equiv722, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent723) :-
	spl_db( equiv723_a, Spl1 ),
	test_data( equiv723, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent724) :-
	spl_db( equiv724_a, Spl1 ),
	test_data( equiv724, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent725) :-
	spl_db( equiv725_a, Spl1 ),
	test_data( equiv725, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent726) :-
	spl_db( equiv726_a, Spl1 ),
	test_data( equiv726, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent727) :-
	spl_db( equiv727_a, Spl1 ),
	test_data( equiv727, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent728) :-
	spl_db( equiv728_a, Spl1 ),
	test_data( equiv728, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent729) :-
	spl_db( equiv729_a, Spl1 ),
	test_data( equiv729, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent730) :-
	spl_db( equiv730_a, Spl1 ),
	test_data( equiv730, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent731) :-
	spl_db( equiv731_a, Spl1 ),
	test_data( equiv731, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent732) :-
	spl_db( equiv732_a, Spl1 ),
	test_data( equiv732, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent733) :-
	spl_db( equiv733_a, Spl1 ),
	test_data( equiv733, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent734) :-
	spl_db( equiv734_a, Spl1 ),
	test_data( equiv734, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent735) :-
	spl_db( equiv735_a, Spl1 ),
	test_data( equiv735, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent736) :-
	spl_db( equiv736_a, Spl1 ),
	test_data( equiv736, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent737) :-
	spl_db( equiv737_a, Spl1 ),
	test_data( equiv737, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent738) :-
	spl_db( equiv738_a, Spl1 ),
	test_data( equiv738, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent739) :-
	spl_db( equiv739_a, Spl1 ),
	test_data( equiv739, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent740) :-
	spl_db( equiv740_a, Spl1 ),
	test_data( equiv740, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent741) :-
	spl_db( equiv741_a, Spl1 ),
	test_data( equiv741, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent742) :-
	spl_db( equiv742_a, Spl1 ),
	test_data( equiv742, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent743) :-
	spl_db( equiv743_a, Spl1 ),
	test_data( equiv743, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent744) :-
	spl_db( equiv744_a, Spl1 ),
	test_data( equiv744, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent745) :-
	spl_db( equiv745_a, Spl1 ),
	test_data( equiv745, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent746) :-
	spl_db( equiv746_a, Spl1 ),
	test_data( equiv746, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent747) :-
	spl_db( equiv747_a, Spl1 ),
	test_data( equiv747, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent748) :-
	spl_db( equiv748_a, Spl1 ),
	test_data( equiv748, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent749) :-
	spl_db( equiv749_a, Spl1 ),
	test_data( equiv749, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent750) :-
	spl_db( equiv750_a, Spl1 ),
	test_data( equiv750, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent751) :-
	spl_db( equiv751_a, Spl1 ),
	test_data( equiv751, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent752) :-
	spl_db( equiv752_a, Spl1 ),
	test_data( equiv752, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent753) :-
	spl_db( equiv753_a, Spl1 ),
	test_data( equiv753, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent754) :-
	spl_db( equiv754_a, Spl1 ),
	test_data( equiv754, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent755) :-
	spl_db( equiv755_a, Spl1 ),
	test_data( equiv755, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent756) :-
	spl_db( equiv756_a, Spl1 ),
	test_data( equiv756, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent757) :-
	spl_db( equiv757_a, Spl1 ),
	test_data( equiv757, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent758) :-
	spl_db( equiv758_a, Spl1 ),
	test_data( equiv758, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent759) :-
	spl_db( equiv759_a, Spl1 ),
	test_data( equiv759, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent760) :-
	spl_db( equiv760_a, Spl1 ),
	test_data( equiv760, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent761) :-
	spl_db( equiv761_a, Spl1 ),
	test_data( equiv761, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent762) :-
	spl_db( equiv762_a, Spl1 ),
	test_data( equiv762, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent763) :-
	spl_db( equiv763_a, Spl1 ),
	test_data( equiv763, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent764) :-
	spl_db( equiv764_a, Spl1 ),
	test_data( equiv764, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent765) :-
	spl_db( equiv765_a, Spl1 ),
	test_data( equiv765, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent766) :-
	spl_db( equiv766_a, Spl1 ),
	test_data( equiv766, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent767) :-
	spl_db( equiv767_a, Spl1 ),
	test_data( equiv767, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent768) :-
	spl_db( equiv768_a, Spl1 ),
	test_data( equiv768, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent769) :-
	spl_db( equiv769_a, Spl1 ),
	test_data( equiv769, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent770) :-
	spl_db( equiv770_a, Spl1 ),
	test_data( equiv770, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent771) :-
	spl_db( equiv771_a, Spl1 ),
	test_data( equiv771, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent772) :-
	spl_db( equiv772_a, Spl1 ),
	test_data( equiv772, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent773) :-
	spl_db( equiv773_a, Spl1 ),
	test_data( equiv773, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent774) :-
	spl_db( equiv774_a, Spl1 ),
	test_data( equiv774, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent775) :-
	spl_db( equiv775_a, Spl1 ),
	test_data( equiv775, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent776) :-
	spl_db( equiv776_a, Spl1 ),
	test_data( equiv776, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent777) :-
	spl_db( equiv777_a, Spl1 ),
	test_data( equiv777, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent778) :-
	spl_db( equiv778_a, Spl1 ),
	test_data( equiv778, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent779) :-
	spl_db( equiv779_a, Spl1 ),
	test_data( equiv779, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent780) :-
	spl_db( equiv780_a, Spl1 ),
	test_data( equiv780, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent781) :-
	spl_db( equiv781_a, Spl1 ),
	test_data( equiv781, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent782) :-
	spl_db( equiv782_a, Spl1 ),
	test_data( equiv782, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent783) :-
	spl_db( equiv783_a, Spl1 ),
	test_data( equiv783, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent784) :-
	spl_db( equiv784_a, Spl1 ),
	test_data( equiv784, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent785) :-
	spl_db( equiv785_a, Spl1 ),
	test_data( equiv785, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent786) :-
	spl_db( equiv786_a, Spl1 ),
	test_data( equiv786, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent787) :-
	spl_db( equiv787_a, Spl1 ),
	test_data( equiv787, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent788) :-
	spl_db( equiv788_a, Spl1 ),
	test_data( equiv788, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent789) :-
	spl_db( equiv789_a, Spl1 ),
	test_data( equiv789, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent790) :-
	spl_db( equiv790_a, Spl1 ),
	test_data( equiv790, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent791) :-
	spl_db( equiv791_a, Spl1 ),
	test_data( equiv791, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent792) :-
	spl_db( equiv792_a, Spl1 ),
	test_data( equiv792, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent793) :-
	spl_db( equiv793_a, Spl1 ),
	test_data( equiv793, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent794) :-
	spl_db( equiv794_a, Spl1 ),
	test_data( equiv794, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent795) :-
	spl_db( equiv795_a, Spl1 ),
	test_data( equiv795, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent796) :-
	spl_db( equiv796_a, Spl1 ),
	test_data( equiv796, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent797) :-
	spl_db( equiv797_a, Spl1 ),
	test_data( equiv797, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent798) :-
	spl_db( equiv798_a, Spl1 ),
	test_data( equiv798, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent799) :-
	spl_db( equiv799_a, Spl1 ),
	test_data( equiv799, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent800) :-
	spl_db( equiv800_a, Spl1 ),
	test_data( equiv800, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent801) :-
	spl_db( equiv801_a, Spl1 ),
	test_data( equiv801, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent802) :-
	spl_db( equiv802_a, Spl1 ),
	test_data( equiv802, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent803) :-
	spl_db( equiv803_a, Spl1 ),
	test_data( equiv803, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent804) :-
	spl_db( equiv804_a, Spl1 ),
	test_data( equiv804, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent805) :-
	spl_db( equiv805_a, Spl1 ),
	test_data( equiv805, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent806) :-
	spl_db( equiv806_a, Spl1 ),
	test_data( equiv806, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent807) :-
	spl_db( equiv807_a, Spl1 ),
	test_data( equiv807, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent808) :-
	spl_db( equiv808_a, Spl1 ),
	test_data( equiv808, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent809) :-
	spl_db( equiv809_a, Spl1 ),
	test_data( equiv809, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent810) :-
	spl_db( equiv810_a, Spl1 ),
	test_data( equiv810, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent811) :-
	spl_db( equiv811_a, Spl1 ),
	test_data( equiv811, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent812) :-
	spl_db( equiv812_a, Spl1 ),
	test_data( equiv812, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent813) :-
	spl_db( equiv813_a, Spl1 ),
	test_data( equiv813, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent814) :-
	spl_db( equiv814_a, Spl1 ),
	test_data( equiv814, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent815) :-
	spl_db( equiv815_a, Spl1 ),
	test_data( equiv815, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent816) :-
	spl_db( equiv816_a, Spl1 ),
	test_data( equiv816, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent817) :-
	spl_db( equiv817_a, Spl1 ),
	test_data( equiv817, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent818) :-
	spl_db( equiv818_a, Spl1 ),
	test_data( equiv818, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent819) :-
	spl_db( equiv819_a, Spl1 ),
	test_data( equiv819, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent820) :-
	spl_db( equiv820_a, Spl1 ),
	test_data( equiv820, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent821) :-
	spl_db( equiv821_a, Spl1 ),
	test_data( equiv821, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent822) :-
	spl_db( equiv822_a, Spl1 ),
	test_data( equiv822, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent823) :-
	spl_db( equiv823_a, Spl1 ),
	test_data( equiv823, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent824) :-
	spl_db( equiv824_a, Spl1 ),
	test_data( equiv824, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent825) :-
	spl_db( equiv825_a, Spl1 ),
	test_data( equiv825, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent826) :-
	spl_db( equiv826_a, Spl1 ),
	test_data( equiv826, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent827) :-
	spl_db( equiv827_a, Spl1 ),
	test_data( equiv827, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent828) :-
	spl_db( equiv828_a, Spl1 ),
	test_data( equiv828, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent829) :-
	spl_db( equiv829_a, Spl1 ),
	test_data( equiv829, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent830) :-
	spl_db( equiv830_a, Spl1 ),
	test_data( equiv830, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent831) :-
	spl_db( equiv831_a, Spl1 ),
	test_data( equiv831, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent832) :-
	spl_db( equiv832_a, Spl1 ),
	test_data( equiv832, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent833) :-
	spl_db( equiv833_a, Spl1 ),
	test_data( equiv833, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent834) :-
	spl_db( equiv834_a, Spl1 ),
	test_data( equiv834, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent835) :-
	spl_db( equiv835_a, Spl1 ),
	test_data( equiv835, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent836) :-
	spl_db( equiv836_a, Spl1 ),
	test_data( equiv836, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent837) :-
	spl_db( equiv837_a, Spl1 ),
	test_data( equiv837, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent838) :-
	spl_db( equiv838_a, Spl1 ),
	test_data( equiv838, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent839) :-
	spl_db( equiv839_a, Spl1 ),
	test_data( equiv839, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent840) :-
	spl_db( equiv840_a, Spl1 ),
	test_data( equiv840, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent841) :-
	spl_db( equiv841_a, Spl1 ),
	test_data( equiv841, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent842) :-
	spl_db( equiv842_a, Spl1 ),
	test_data( equiv842, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent843) :-
	spl_db( equiv843_a, Spl1 ),
	test_data( equiv843, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent844) :-
	spl_db( equiv844_a, Spl1 ),
	test_data( equiv844, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent845) :-
	spl_db( equiv845_a, Spl1 ),
	test_data( equiv845, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent846) :-
	spl_db( equiv846_a, Spl1 ),
	test_data( equiv846, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent847) :-
	spl_db( equiv847_a, Spl1 ),
	test_data( equiv847, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent848) :-
	spl_db( equiv848_a, Spl1 ),
	test_data( equiv848, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent849) :-
	spl_db( equiv849_a, Spl1 ),
	test_data( equiv849, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent850) :-
	spl_db( equiv850_a, Spl1 ),
	test_data( equiv850, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent851) :-
	spl_db( equiv851_a, Spl1 ),
	test_data( equiv851, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent852) :-
	spl_db( equiv852_a, Spl1 ),
	test_data( equiv852, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent853) :-
	spl_db( equiv853_a, Spl1 ),
	test_data( equiv853, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent854) :-
	spl_db( equiv854_a, Spl1 ),
	test_data( equiv854, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent855) :-
	spl_db( equiv855_a, Spl1 ),
	test_data( equiv855, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent856) :-
	spl_db( equiv856_a, Spl1 ),
	test_data( equiv856, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent857) :-
	spl_db( equiv857_a, Spl1 ),
	test_data( equiv857, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent858) :-
	spl_db( equiv858_a, Spl1 ),
	test_data( equiv858, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent859) :-
	spl_db( equiv859_a, Spl1 ),
	test_data( equiv859, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent860) :-
	spl_db( equiv860_a, Spl1 ),
	test_data( equiv860, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent861) :-
	spl_db( equiv861_a, Spl1 ),
	test_data( equiv861, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent862) :-
	spl_db( equiv862_a, Spl1 ),
	test_data( equiv862, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent863) :-
	spl_db( equiv863_a, Spl1 ),
	test_data( equiv863, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent864) :-
	spl_db( equiv864_a, Spl1 ),
	test_data( equiv864, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent865) :-
	spl_db( equiv865_a, Spl1 ),
	test_data( equiv865, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent866) :-
	spl_db( equiv866_a, Spl1 ),
	test_data( equiv866, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent867) :-
	spl_db( equiv867_a, Spl1 ),
	test_data( equiv867, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent868) :-
	spl_db( equiv868_a, Spl1 ),
	test_data( equiv868, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent869) :-
	spl_db( equiv869_a, Spl1 ),
	test_data( equiv869, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent870) :-
	spl_db( equiv870_a, Spl1 ),
	test_data( equiv870, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent871) :-
	spl_db( equiv871_a, Spl1 ),
	test_data( equiv871, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent872) :-
	spl_db( equiv872_a, Spl1 ),
	test_data( equiv872, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent873) :-
	spl_db( equiv873_a, Spl1 ),
	test_data( equiv873, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent874) :-
	spl_db( equiv874_a, Spl1 ),
	test_data( equiv874, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent875) :-
	spl_db( equiv875_a, Spl1 ),
	test_data( equiv875, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent876) :-
	spl_db( equiv876_a, Spl1 ),
	test_data( equiv876, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent877) :-
	spl_db( equiv877_a, Spl1 ),
	test_data( equiv877, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent878) :-
	spl_db( equiv878_a, Spl1 ),
	test_data( equiv878, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent879) :-
	spl_db( equiv879_a, Spl1 ),
	test_data( equiv879, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent880) :-
	spl_db( equiv880_a, Spl1 ),
	test_data( equiv880, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent881) :-
	spl_db( equiv881_a, Spl1 ),
	test_data( equiv881, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent882) :-
	spl_db( equiv882_a, Spl1 ),
	test_data( equiv882, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent883) :-
	spl_db( equiv883_a, Spl1 ),
	test_data( equiv883, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent884) :-
	spl_db( equiv884_a, Spl1 ),
	test_data( equiv884, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent885) :-
	spl_db( equiv885_a, Spl1 ),
	test_data( equiv885, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent886) :-
	spl_db( equiv886_a, Spl1 ),
	test_data( equiv886, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent887) :-
	spl_db( equiv887_a, Spl1 ),
	test_data( equiv887, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent888) :-
	spl_db( equiv888_a, Spl1 ),
	test_data( equiv888, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent889) :-
	spl_db( equiv889_a, Spl1 ),
	test_data( equiv889, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent890) :-
	spl_db( equiv890_a, Spl1 ),
	test_data( equiv890, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent891) :-
	spl_db( equiv891_a, Spl1 ),
	test_data( equiv891, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent892) :-
	spl_db( equiv892_a, Spl1 ),
	test_data( equiv892, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent893) :-
	spl_db( equiv893_a, Spl1 ),
	test_data( equiv893, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent894) :-
	spl_db( equiv894_a, Spl1 ),
	test_data( equiv894, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent895) :-
	spl_db( equiv895_a, Spl1 ),
	test_data( equiv895, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent896) :-
	spl_db( equiv896_a, Spl1 ),
	test_data( equiv896, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent897) :-
	spl_db( equiv897_a, Spl1 ),
	test_data( equiv897, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent898) :-
	spl_db( equiv898_a, Spl1 ),
	test_data( equiv898, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent899) :-
	spl_db( equiv899_a, Spl1 ),
	test_data( equiv899, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent900) :-
	spl_db( equiv900_a, Spl1 ),
	test_data( equiv900, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent901) :-
	spl_db( equiv901_a, Spl1 ),
	test_data( equiv901, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent902) :-
	spl_db( equiv902_a, Spl1 ),
	test_data( equiv902, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent903) :-
	spl_db( equiv903_a, Spl1 ),
	test_data( equiv903, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent904) :-
	spl_db( equiv904_a, Spl1 ),
	test_data( equiv904, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent905) :-
	spl_db( equiv905_a, Spl1 ),
	test_data( equiv905, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent906) :-
	spl_db( equiv906_a, Spl1 ),
	test_data( equiv906, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent907) :-
	spl_db( equiv907_a, Spl1 ),
	test_data( equiv907, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent908) :-
	spl_db( equiv908_a, Spl1 ),
	test_data( equiv908, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent909) :-
	spl_db( equiv909_a, Spl1 ),
	test_data( equiv909, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent910) :-
	spl_db( equiv910_a, Spl1 ),
	test_data( equiv910, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent911) :-
	spl_db( equiv911_a, Spl1 ),
	test_data( equiv911, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent912) :-
	spl_db( equiv912_a, Spl1 ),
	test_data( equiv912, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent913) :-
	spl_db( equiv913_a, Spl1 ),
	test_data( equiv913, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent914) :-
	spl_db( equiv914_a, Spl1 ),
	test_data( equiv914, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent915) :-
	spl_db( equiv915_a, Spl1 ),
	test_data( equiv915, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent916) :-
	spl_db( equiv916_a, Spl1 ),
	test_data( equiv916, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent917) :-
	spl_db( equiv917_a, Spl1 ),
	test_data( equiv917, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent918) :-
	spl_db( equiv918_a, Spl1 ),
	test_data( equiv918, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent919) :-
	spl_db( equiv919_a, Spl1 ),
	test_data( equiv919, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent920) :-
	spl_db( equiv920_a, Spl1 ),
	test_data( equiv920, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent921) :-
	spl_db( equiv921_a, Spl1 ),
	test_data( equiv921, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent922) :-
	spl_db( equiv922_a, Spl1 ),
	test_data( equiv922, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent923) :-
	spl_db( equiv923_a, Spl1 ),
	test_data( equiv923, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent924) :-
	spl_db( equiv924_a, Spl1 ),
	test_data( equiv924, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent925) :-
	spl_db( equiv925_a, Spl1 ),
	test_data( equiv925, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent926) :-
	spl_db( equiv926_a, Spl1 ),
	test_data( equiv926, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent927) :-
	spl_db( equiv927_a, Spl1 ),
	test_data( equiv927, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent928) :-
	spl_db( equiv928_a, Spl1 ),
	test_data( equiv928, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent929) :-
	spl_db( equiv929_a, Spl1 ),
	test_data( equiv929, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent930) :-
	spl_db( equiv930_a, Spl1 ),
	test_data( equiv930, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent931) :-
	spl_db( equiv931_a, Spl1 ),
	test_data( equiv931, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent932) :-
	spl_db( equiv932_a, Spl1 ),
	test_data( equiv932, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent933) :-
	spl_db( equiv933_a, Spl1 ),
	test_data( equiv933, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent934) :-
	spl_db( equiv934_a, Spl1 ),
	test_data( equiv934, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent935) :-
	spl_db( equiv935_a, Spl1 ),
	test_data( equiv935, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent936) :-
	spl_db( equiv936_a, Spl1 ),
	test_data( equiv936, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent937) :-
	spl_db( equiv937_a, Spl1 ),
	test_data( equiv937, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent938) :-
	spl_db( equiv938_a, Spl1 ),
	test_data( equiv938, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent939) :-
	spl_db( equiv939_a, Spl1 ),
	test_data( equiv939, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent940) :-
	spl_db( equiv940_a, Spl1 ),
	test_data( equiv940, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent941) :-
	spl_db( equiv941_a, Spl1 ),
	test_data( equiv941, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent942) :-
	spl_db( equiv942_a, Spl1 ),
	test_data( equiv942, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent943) :-
	spl_db( equiv943_a, Spl1 ),
	test_data( equiv943, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent944) :-
	spl_db( equiv944_a, Spl1 ),
	test_data( equiv944, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent945) :-
	spl_db( equiv945_a, Spl1 ),
	test_data( equiv945, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent946) :-
	spl_db( equiv946_a, Spl1 ),
	test_data( equiv946, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent947) :-
	spl_db( equiv947_a, Spl1 ),
	test_data( equiv947, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent948) :-
	spl_db( equiv948_a, Spl1 ),
	test_data( equiv948, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent949) :-
	spl_db( equiv949_a, Spl1 ),
	test_data( equiv949, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent950) :-
	spl_db( equiv950_a, Spl1 ),
	test_data( equiv950, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent951) :-
	spl_db( equiv951_a, Spl1 ),
	test_data( equiv951, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent952) :-
	spl_db( equiv952_a, Spl1 ),
	test_data( equiv952, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent953) :-
	spl_db( equiv953_a, Spl1 ),
	test_data( equiv953, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent954) :-
	spl_db( equiv954_a, Spl1 ),
	test_data( equiv954, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent955) :-
	spl_db( equiv955_a, Spl1 ),
	test_data( equiv955, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent956) :-
	spl_db( equiv956_a, Spl1 ),
	test_data( equiv956, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent957) :-
	spl_db( equiv957_a, Spl1 ),
	test_data( equiv957, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent958) :-
	spl_db( equiv958_a, Spl1 ),
	test_data( equiv958, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent959) :-
	spl_db( equiv959_a, Spl1 ),
	test_data( equiv959, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent960) :-
	spl_db( equiv960_a, Spl1 ),
	test_data( equiv960, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent961) :-
	spl_db( equiv961_a, Spl1 ),
	test_data( equiv961, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent962) :-
	spl_db( equiv962_a, Spl1 ),
	test_data( equiv962, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent963) :-
	spl_db( equiv963_a, Spl1 ),
	test_data( equiv963, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent964) :-
	spl_db( equiv964_a, Spl1 ),
	test_data( equiv964, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent965) :-
	spl_db( equiv965_a, Spl1 ),
	test_data( equiv965, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent966) :-
	spl_db( equiv966_a, Spl1 ),
	test_data( equiv966, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent967) :-
	spl_db( equiv967_a, Spl1 ),
	test_data( equiv967, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent968) :-
	spl_db( equiv968_a, Spl1 ),
	test_data( equiv968, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent969) :-
	spl_db( equiv969_a, Spl1 ),
	test_data( equiv969, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent970) :-
	spl_db( equiv970_a, Spl1 ),
	test_data( equiv970, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent971) :-
	spl_db( equiv971_a, Spl1 ),
	test_data( equiv971, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent972) :-
	spl_db( equiv972_a, Spl1 ),
	test_data( equiv972, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent973) :-
	spl_db( equiv973_a, Spl1 ),
	test_data( equiv973, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent974) :-
	spl_db( equiv974_a, Spl1 ),
	test_data( equiv974, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent975) :-
	spl_db( equiv975_a, Spl1 ),
	test_data( equiv975, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent976) :-
	spl_db( equiv976_a, Spl1 ),
	test_data( equiv976, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent977) :-
	spl_db( equiv977_a, Spl1 ),
	test_data( equiv977, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent978) :-
	spl_db( equiv978_a, Spl1 ),
	test_data( equiv978, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent979) :-
	spl_db( equiv979_a, Spl1 ),
	test_data( equiv979, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent980) :-
	spl_db( equiv980_a, Spl1 ),
	test_data( equiv980, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent981) :-
	spl_db( equiv981_a, Spl1 ),
	test_data( equiv981, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent982) :-
	spl_db( equiv982_a, Spl1 ),
	test_data( equiv982, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent983) :-
	spl_db( equiv983_a, Spl1 ),
	test_data( equiv983, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent984) :-
	spl_db( equiv984_a, Spl1 ),
	test_data( equiv984, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent985) :-
	spl_db( equiv985_a, Spl1 ),
	test_data( equiv985, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent986) :-
	spl_db( equiv986_a, Spl1 ),
	test_data( equiv986, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent987) :-
	spl_db( equiv987_a, Spl1 ),
	test_data( equiv987, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent988) :-
	spl_db( equiv988_a, Spl1 ),
	test_data( equiv988, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent989) :-
	spl_db( equiv989_a, Spl1 ),
	test_data( equiv989, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent990) :-
	spl_db( equiv990_a, Spl1 ),
	test_data( equiv990, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent991) :-
	spl_db( equiv991_a, Spl1 ),
	test_data( equiv991, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent992) :-
	spl_db( equiv992_a, Spl1 ),
	test_data( equiv992, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent993) :-
	spl_db( equiv993_a, Spl1 ),
	test_data( equiv993, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent994) :-
	spl_db( equiv994_a, Spl1 ),
	test_data( equiv994, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent995) :-
	spl_db( equiv995_a, Spl1 ),
	test_data( equiv995, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent996) :-
	spl_db( equiv996_a, Spl1 ),
	test_data( equiv996, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent997) :-
	spl_db( equiv997_a, Spl1 ),
	test_data( equiv997, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent998) :-
	spl_db( equiv998_a, Spl1 ),
	test_data( equiv998, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

test(equivalent999) :-
	spl_db( equiv999_a, Spl1 ),
	test_data( equiv999, equivalent, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isEquivalentSpl(Spl1,Spl2,Expected_result), !.

:- end_tests(equivalent).