% ---------------
% Auxiliary predicates to support true/false as a parameter.
% ---------------
isSpecialisedSpl(Spl1,Spl2,true) :- !, specialization(Spl1,Spl2).
isSpecialisedSpl(Spl1,Spl2,false) :-  !, not(specialization(Spl1,Spl2)).



% ---------------
spl_db( specialization0_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f4 ), requires( f3 , f5 ) ]
		)
	)
).

spl_db( specialization0_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(specialization0,specialization,specialization0_b, true).


% ---------------
spl_db( specialization1_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization1_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(specialization1,specialization,specialization1_b, false).


% ---------------
spl_db( specialization2_a,
	 spl( [ root, f1, f2, f3, f5, f7, f8, f6, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					one_or_more( [ feature( f5, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ), feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization2_b,
	 spl( [ root, f1, f2, f3, f5, f7, f8, f6, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					one_or_more( [ feature( f5, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ), feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization2,specialization,specialization2_b, false).


% ---------------
spl_db( specialization3_a,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f3 ), excludes( f2 , f3 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( specialization3_b,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization3,specialization,specialization3_b, true).


% ---------------
spl_db( specialization4_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

spl_db( specialization4_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization4,specialization,specialization4_b, true).


% ---------------
spl_db( specialization5_a,
	 spl( [ root, f1, f3, f4, f6, f7, f8, f9, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization5_b,
	 spl( [ root, f1, f3, f4, f6, f7, f8, f9, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(specialization5,specialization,specialization5_b, false).


% ---------------
spl_db( specialization6_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f3, f4, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f6 ), excludes( f5 , f1 ) ]
		)
	)
).

spl_db( specialization6_b,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f3, f4, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization6,specialization,specialization6_b, true).


% ---------------
spl_db( specialization7_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization7_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(specialization7,specialization,specialization7_b, false).


% ---------------
spl_db( specialization8_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f3 ), excludes( f9 , f7 ), excludes( f8 , f7 ) ]
		)
	)
).

spl_db( specialization8_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(specialization8,specialization,specialization8_b, true).


% ---------------
spl_db( specialization9_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization9_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f7 ), requires( f6 , f3 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization9,specialization,specialization9_b, false).


% ---------------
spl_db( specialization10_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization10_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(specialization10,specialization,specialization10_b, false).


% ---------------
spl_db( specialization11_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization11_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f5 ), requires( f6 , f8 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(specialization11,specialization,specialization11_b, false).


% ---------------
spl_db( specialization12_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization12_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f4 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(specialization12,specialization,specialization12_b, false).


% ---------------
spl_db( specialization13_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

spl_db( specialization13_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization13,specialization,specialization13_b, true).


% ---------------
spl_db( specialization14_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization14_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f6 ), excludes( f8 , f3 ) ]
		)
	)
).

test_data(specialization14,specialization,specialization14_b, false).


% ---------------
spl_db( specialization15_a,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f1 , f6 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( specialization15_b,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(specialization15,specialization,specialization15_b, true).


% ---------------
spl_db( specialization16_a,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

spl_db( specialization16_b,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization16,specialization,specialization16_b, true).


% ---------------
spl_db( specialization17_a,
	 spl( [ root, f1, f5, f7, f8, f6, f2, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

spl_db( specialization17_b,
	 spl( [ root, f1, f5, f7, f8, f6, f2, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization17,specialization,specialization17_b, true).


% ---------------
spl_db( specialization18_a,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

spl_db( specialization18_b,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f1 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(specialization18,specialization,specialization18_b, false).


% ---------------
spl_db( specialization19_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization19_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(specialization19,specialization,specialization19_b, false).


% ---------------
spl_db( specialization20_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

spl_db( specialization20_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization20,specialization,specialization20_b, true).


% ---------------
spl_db( specialization21_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization21_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

test_data(specialization21,specialization,specialization21_b, false).


% ---------------
spl_db( specialization22_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ), requires( f7 , f6 ) ]
		)
	)
).

spl_db( specialization22_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(specialization22,specialization,specialization22_b, true).


% ---------------
spl_db( specialization23_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization23_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(specialization23,specialization,specialization23_b, false).


% ---------------
spl_db( specialization24_a,
	 spl( [ root, f1, f2, f4, f5, f7, f8, f9, f6, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

spl_db( specialization24_b,
	 spl( [ root, f1, f2, f4, f5, f7, f8, f9, f6, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f4 , f1 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization24,specialization,specialization24_b, false).


% ---------------
spl_db( specialization25_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

spl_db( specialization25_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f1 ), requires( f6 , f7 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(specialization25,specialization,specialization25_b, false).


% ---------------
spl_db( specialization26_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

spl_db( specialization26_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization26,specialization,specialization26_b, false).


% ---------------
spl_db( specialization27_a,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f3 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( specialization27_b,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization27,specialization,specialization27_b, true).


% ---------------
spl_db( specialization28_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization28_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(specialization28,specialization,specialization28_b, false).


% ---------------
spl_db( specialization29_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization29_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization29,specialization,specialization29_b, true).


% ---------------
spl_db( specialization30_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

spl_db( specialization30_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ), excludes( f8 , f3 ) ]
		)
	)
).

test_data(specialization30,specialization,specialization30_b, false).


% ---------------
spl_db( specialization31_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

spl_db( specialization31_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization31,specialization,specialization31_b, true).


% ---------------
spl_db( specialization32_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

spl_db( specialization32_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization32,specialization,specialization32_b, true).


% ---------------
spl_db( specialization33_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

spl_db( specialization33_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(specialization33,specialization,specialization33_b, false).


% ---------------
spl_db( specialization34_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization34_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f3 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(specialization34,specialization,specialization34_b, false).


% ---------------
spl_db( specialization35_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

spl_db( specialization35_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f5 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(specialization35,specialization,specialization35_b, false).


% ---------------
spl_db( specialization36_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

spl_db( specialization36_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization36,specialization,specialization36_b, true).


% ---------------
spl_db( specialization37_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization37_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f6 , f8 ), excludes( f5 , f6 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(specialization37,specialization,specialization37_b, false).


% ---------------
spl_db( specialization38_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f1 , f4 ) ]
		)
	)
).

spl_db( specialization38_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization38,specialization,specialization38_b, true).


% ---------------
spl_db( specialization39_a,
	 spl( [ root, f1, f2, f8, f9, f3, f7, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization39_b,
	 spl( [ root, f1, f2, f8, f9, f3, f7, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f2 ), requires( f7 , f4 ) ]
		)
	)
).

test_data(specialization39,specialization,specialization39_b, false).


% ---------------
spl_db( specialization40_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization40_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f8 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(specialization40,specialization,specialization40_b, false).


% ---------------
spl_db( specialization41_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization41_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization41,specialization,specialization41_b, false).


% ---------------
spl_db( specialization42_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f7 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( specialization42_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization42,specialization,specialization42_b, true).


% ---------------
spl_db( specialization43_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

spl_db( specialization43_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization43,specialization,specialization43_b, true).


% ---------------
spl_db( specialization44_a,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f8 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization44_b,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization44,specialization,specialization44_b, true).


% ---------------
spl_db( specialization45_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

spl_db( specialization45_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f7 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(specialization45,specialization,specialization45_b, false).


% ---------------
spl_db( specialization46_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization46_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(specialization46,specialization,specialization46_b, false).


% ---------------
spl_db( specialization47_a,
	 spl( [ root, f1, f3, f9, f4, f5, f8, f6, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization47_b,
	 spl( [ root, f1, f3, f9, f4, f5, f8, f6, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f8 , f2 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(specialization47,specialization,specialization47_b, false).


% ---------------
spl_db( specialization48_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f4 ), excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization48_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(specialization48,specialization,specialization48_b, true).


% ---------------
spl_db( specialization49_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization49_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

test_data(specialization49,specialization,specialization49_b, false).


% ---------------
spl_db( specialization50_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
					mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f2 ), excludes( f4 , f5 ) ]
		)
	)
).

spl_db( specialization50_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
					mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization50,specialization,specialization50_b, true).


% ---------------
spl_db( specialization51_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization51_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(specialization51,specialization,specialization51_b, false).


% ---------------
spl_db( specialization52_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

spl_db( specialization52_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization52,specialization,specialization52_b, true).


% ---------------
spl_db( specialization53_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

spl_db( specialization53_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f1 , f2 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(specialization53,specialization,specialization53_b, false).


% ---------------
spl_db( specialization54_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization54_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization54,specialization,specialization54_b, true).


% ---------------
spl_db( specialization55_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization55_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(specialization55,specialization,specialization55_b, false).


% ---------------
spl_db( specialization56_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization56_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(specialization56,specialization,specialization56_b, false).


% ---------------
spl_db( specialization57_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization57_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f3 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(specialization57,specialization,specialization57_b, false).


% ---------------
spl_db( specialization58_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization58_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(specialization58,specialization,specialization58_b, true).


% ---------------
spl_db( specialization59_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					only_one( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization59_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					only_one( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(specialization59,specialization,specialization59_b, false).


% ---------------
spl_db( specialization60_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f5 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( specialization60_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization60,specialization,specialization60_b, true).


% ---------------
spl_db( specialization61_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization61_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(specialization61,specialization,specialization61_b, false).


% ---------------
spl_db( specialization62_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

spl_db( specialization62_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization62,specialization,specialization62_b, true).


% ---------------
spl_db( specialization63_a,
	 spl( [ root, f1, f3, f4, f6, f7, f8, f9, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization63_b,
	 spl( [ root, f1, f3, f4, f6, f7, f8, f9, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f5 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(specialization63,specialization,specialization63_b, false).


% ---------------
spl_db( specialization64_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

spl_db( specialization64_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f8 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(specialization64,specialization,specialization64_b, false).


% ---------------
spl_db( specialization65_a,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f5 , f4 ), requires( f4 , f2 ) ]
		)
	)
).

spl_db( specialization65_b,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization65,specialization,specialization65_b, true).


% ---------------
spl_db( specialization66_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f5 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization66_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(specialization66,specialization,specialization66_b, true).


% ---------------
spl_db( specialization67_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization67_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization67,specialization,specialization67_b, true).


% ---------------
spl_db( specialization68_a,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f8 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization68_b,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f8 ), excludes( f6 , f9 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization68,specialization,specialization68_b, false).


% ---------------
spl_db( specialization69_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization69_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f2 ) ]
		)
	)
).

test_data(specialization69,specialization,specialization69_b, false).


% ---------------
spl_db( specialization70_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

spl_db( specialization70_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization70,specialization,specialization70_b, true).


% ---------------
spl_db( specialization71_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

spl_db( specialization71_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization71,specialization,specialization71_b, true).


% ---------------
spl_db( specialization72_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization72_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f7 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization72,specialization,specialization72_b, false).


% ---------------
spl_db( specialization73_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

spl_db( specialization73_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(specialization73,specialization,specialization73_b, false).


% ---------------
spl_db( specialization74_a,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization74_b,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(specialization74,specialization,specialization74_b, false).


% ---------------
spl_db( specialization75_a,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f2 , f3 ) ]
		)
	)
).

spl_db( specialization75_b,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(specialization75,specialization,specialization75_b, true).


% ---------------
spl_db( specialization76_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization76_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(specialization76,specialization,specialization76_b, false).


% ---------------
spl_db( specialization77_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f6 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization77_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization77,specialization,specialization77_b, true).


% ---------------
spl_db( specialization78_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f6 ), excludes( f3 , f9 ) ]
		)
	)
).

spl_db( specialization78_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(specialization78,specialization,specialization78_b, true).


% ---------------
spl_db( specialization79_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization79_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(specialization79,specialization,specialization79_b, false).


% ---------------
spl_db( specialization80_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f3 , f9 ) ]
		)
	)
).

spl_db( specialization80_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization80,specialization,specialization80_b, true).


% ---------------
spl_db( specialization81_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f9 ), requires( f4 , f3 ) ]
		)
	)
).

spl_db( specialization81_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization81,specialization,specialization81_b, true).


% ---------------
spl_db( specialization82_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization82_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f2 ), requires( f1 , f9 ) ]
		)
	)
).

test_data(specialization82,specialization,specialization82_b, false).


% ---------------
spl_db( specialization83_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization83_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f1 ), excludes( f3 , f8 ) ]
		)
	)
).

test_data(specialization83,specialization,specialization83_b, false).


% ---------------
spl_db( specialization84_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f6, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization84_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f6, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(specialization84,specialization,specialization84_b, false).


% ---------------
spl_db( specialization85_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization85_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f3 ), excludes( f7 , f3 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(specialization85,specialization,specialization85_b, false).


% ---------------
spl_db( specialization86_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f6 ), requires( f8 , f9 ) ]
		)
	)
).

spl_db( specialization86_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization86,specialization,specialization86_b, true).


% ---------------
spl_db( specialization87_a,
	 spl( [ root, f1, f4, f5, f6, f8, f9, f7, f2, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

spl_db( specialization87_b,
	 spl( [ root, f1, f4, f5, f6, f8, f9, f7, f2, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization87,specialization,specialization87_b, true).


% ---------------
spl_db( specialization88_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

spl_db( specialization88_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization88,specialization,specialization88_b, true).


% ---------------
spl_db( specialization89_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization89_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(specialization89,specialization,specialization89_b, false).


% ---------------
spl_db( specialization90_a,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f5 ), requires( f7 , f8 ) ]
		)
	)
).

spl_db( specialization90_b,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization90,specialization,specialization90_b, true).


% ---------------
spl_db( specialization91_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization91_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization91,specialization,specialization91_b, true).


% ---------------
spl_db( specialization92_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f3 , f1 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( specialization92_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization92,specialization,specialization92_b, true).


% ---------------
spl_db( specialization93_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization93_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f3 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(specialization93,specialization,specialization93_b, false).


% ---------------
spl_db( specialization94_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( specialization94_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization94,specialization,specialization94_b, true).


% ---------------
spl_db( specialization95_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization95_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(specialization95,specialization,specialization95_b, false).


% ---------------
spl_db( specialization96_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

spl_db( specialization96_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization96,specialization,specialization96_b, true).


% ---------------
spl_db( specialization97_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ), requires( f8 , f5 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( specialization97_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization97,specialization,specialization97_b, true).


% ---------------
spl_db( specialization98_a,
	 spl( [ root, f1, f5, f7, f8, f9, f6, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization98_b,
	 spl( [ root, f1, f5, f7, f8, f9, f6, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(specialization98,specialization,specialization98_b, false).


% ---------------
spl_db( specialization99_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( specialization99_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(specialization99,specialization,specialization99_b, false).


% ---------------
spl_db( specialization100_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization100_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f7 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(specialization100,specialization,specialization100_b, false).


% ---------------
spl_db( specialization101_a,
	 spl( [ root, f1, f2, f3, f6, f7, f4, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f4 ), requires( f2 , f6 ) ]
		)
	)
).

spl_db( specialization101_b,
	 spl( [ root, f1, f2, f3, f6, f7, f4, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization101,specialization,specialization101_b, true).


% ---------------
spl_db( specialization102_a,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization102_b,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization102,specialization,specialization102_b, false).


% ---------------
spl_db( specialization103_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f5 ), excludes( f1 , f4 ) ]
		)
	)
).

spl_db( specialization103_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(specialization103,specialization,specialization103_b, true).


% ---------------
spl_db( specialization104_a,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f3 ), excludes( f1 , f9 ) ]
		)
	)
).

spl_db( specialization104_b,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization104,specialization,specialization104_b, true).


% ---------------
spl_db( specialization105_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f2 ), requires( f8 , f9 ) ]
		)
	)
).

spl_db( specialization105_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(specialization105,specialization,specialization105_b, true).


% ---------------
spl_db( specialization106_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( specialization106_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization106,specialization,specialization106_b, true).


% ---------------
spl_db( specialization107_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization107_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f8 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(specialization107,specialization,specialization107_b, false).


% ---------------
spl_db( specialization108_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization108_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f5 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(specialization108,specialization,specialization108_b, false).


% ---------------
spl_db( specialization109_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f3 ), excludes( f4 , f6 ) ]
		)
	)
).

spl_db( specialization109_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f3 ), excludes( f4 , f6 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization109,specialization,specialization109_b, false).


% ---------------
spl_db( specialization110_a,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [
						optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f8 , f2 ), requires( f8 , f7 ), requires( f8 , f6 ) ]
		)
	)
).

spl_db( specialization110_b,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [
						optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f8 , f2 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(specialization110,specialization,specialization110_b, true).


% ---------------
spl_db( specialization111_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ), excludes( f3 , f1 ) ]
		)
	)
).

spl_db( specialization111_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(specialization111,specialization,specialization111_b, true).


% ---------------
spl_db( specialization112_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization112_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(specialization112,specialization,specialization112_b, false).


% ---------------
spl_db( specialization113_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f8 , f3 ), excludes( f2 , f3 ) ]
		)
	)
).

spl_db( specialization113_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization113,specialization,specialization113_b, true).


% ---------------
spl_db( specialization114_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ),
 [ requires( f2 , f4 ), requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization114_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(specialization114,specialization,specialization114_b, true).


% ---------------
spl_db( specialization115_a,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization115_b,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(specialization115,specialization,specialization115_b, false).


% ---------------
spl_db( specialization116_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ), requires( f2 , f7 ) ]
		)
	)
).

spl_db( specialization116_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization116,specialization,specialization116_b, true).


% ---------------
spl_db( specialization117_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ), requires( f2 , f9 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( specialization117_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization117,specialization,specialization117_b, true).


% ---------------
spl_db( specialization118_a,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization118_b,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f9 ), requires( f3 , f4 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(specialization118,specialization,specialization118_b, false).


% ---------------
spl_db( specialization119_a,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

spl_db( specialization119_b,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization119,specialization,specialization119_b, true).


% ---------------
spl_db( specialization120_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization120_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f7 ), excludes( f5 , f8 ) ]
		)
	)
).

test_data(specialization120,specialization,specialization120_b, false).


% ---------------
spl_db( specialization121_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f9 ), requires( f7 , f6 ) ]
		)
	)
).

spl_db( specialization121_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization121,specialization,specialization121_b, true).


% ---------------
spl_db( specialization122_a,
	 spl( [ root, f1, f3, f8, f4, f9, f5, f6, f7, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f3 , f9 ) ]
		)
	)
).

spl_db( specialization122_b,
	 spl( [ root, f1, f3, f8, f4, f9, f5, f6, f7, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f3 , f9 ), requires( f5 , f7 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization122,specialization,specialization122_b, false).


% ---------------
spl_db( specialization123_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization123_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

test_data(specialization123,specialization,specialization123_b, false).


% ---------------
spl_db( specialization124_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization124_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(specialization124,specialization,specialization124_b, false).


% ---------------
spl_db( specialization125_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

spl_db( specialization125_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f8 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization125,specialization,specialization125_b, false).


% ---------------
spl_db( specialization126_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

spl_db( specialization126_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization126,specialization,specialization126_b, true).


% ---------------
spl_db( specialization127_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f8 , f9 ) ]
		)
	)
).

spl_db( specialization127_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f8 , f9 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(specialization127,specialization,specialization127_b, false).


% ---------------
spl_db( specialization128_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( specialization128_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f6 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(specialization128,specialization,specialization128_b, false).


% ---------------
spl_db( specialization129_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization129_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f1 ), excludes( f4 , f1 ) ]
		)
	)
).

test_data(specialization129,specialization,specialization129_b, false).


% ---------------
spl_db( specialization130_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f6 , f7 ), requires( f8 , f6 ) ]
		)
	)
).

spl_db( specialization130_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(specialization130,specialization,specialization130_b, true).


% ---------------
spl_db( specialization131_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

spl_db( specialization131_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization131,specialization,specialization131_b, true).


% ---------------
spl_db( specialization132_a,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization132_b,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), requires( f5 , f7 ) ]
		)
	)
).

test_data(specialization132,specialization,specialization132_b, false).


% ---------------
spl_db( specialization133_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

spl_db( specialization133_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization133,specialization,specialization133_b, true).


% ---------------
spl_db( specialization134_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f2 ), requires( f1 , f7 ) ]
		)
	)
).

spl_db( specialization134_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(specialization134,specialization,specialization134_b, true).


% ---------------
spl_db( specialization135_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization135_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f1 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization135,specialization,specialization135_b, false).


% ---------------
spl_db( specialization136_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization136_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f8 , f9 ), requires( f5 , f1 ) ]
		)
	)
).

test_data(specialization136,specialization,specialization136_b, false).


% ---------------
spl_db( specialization137_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization137_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization137,specialization,specialization137_b, false).


% ---------------
spl_db( specialization138_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization138_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(specialization138,specialization,specialization138_b, false).


% ---------------
spl_db( specialization139_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), requires( f5 , f8 ) ]
		)
	)
).

spl_db( specialization139_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization139,specialization,specialization139_b, true).


% ---------------
spl_db( specialization140_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f5 ), excludes( f5 , f7 ) ]
		)
	)
).

spl_db( specialization140_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(specialization140,specialization,specialization140_b, true).


% ---------------
spl_db( specialization141_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f3 ), requires( f5 , f8 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( specialization141_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(specialization141,specialization,specialization141_b, true).


% ---------------
spl_db( specialization142_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization142_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(specialization142,specialization,specialization142_b, false).


% ---------------
spl_db( specialization143_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization143_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f3 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(specialization143,specialization,specialization143_b, false).


% ---------------
spl_db( specialization144_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization144_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization144,specialization,specialization144_b, true).


% ---------------
spl_db( specialization145_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization145_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f8 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization145,specialization,specialization145_b, false).


% ---------------
spl_db( specialization146_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( specialization146_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization146,specialization,specialization146_b, true).


% ---------------
spl_db( specialization147_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization147_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(specialization147,specialization,specialization147_b, false).


% ---------------
spl_db( specialization148_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

spl_db( specialization148_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(specialization148,specialization,specialization148_b, false).


% ---------------
spl_db( specialization149_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization149_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f2 , f4 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(specialization149,specialization,specialization149_b, false).


% ---------------
spl_db( specialization150_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

spl_db( specialization150_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(specialization150,specialization,specialization150_b, false).


% ---------------
spl_db( specialization151_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

spl_db( specialization151_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization151,specialization,specialization151_b, true).


% ---------------
spl_db( specialization152_a,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( specialization152_b,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization152,specialization,specialization152_b, true).


% ---------------
spl_db( specialization153_a,
	 spl( [ root, f1, f6, f7, f2, f3, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f8 ), excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization153_b,
	 spl( [ root, f1, f6, f7, f2, f3, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization153,specialization,specialization153_b, true).


% ---------------
spl_db( specialization154_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization154_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(specialization154,specialization,specialization154_b, false).


% ---------------
spl_db( specialization155_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization155_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(specialization155,specialization,specialization155_b, false).


% ---------------
spl_db( specialization156_a,
	 spl( [ root, f1, f9, f2, f4, f3, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization156_b,
	 spl( [ root, f1, f9, f2, f4, f3, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(specialization156,specialization,specialization156_b, false).


% ---------------
spl_db( specialization157_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

spl_db( specialization157_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization157,specialization,specialization157_b, true).


% ---------------
spl_db( specialization158_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( specialization158_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(specialization158,specialization,specialization158_b, true).


% ---------------
spl_db( specialization159_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f3 ), excludes( f7 , f4 ) ]
		)
	)
).

spl_db( specialization159_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(specialization159,specialization,specialization159_b, true).


% ---------------
spl_db( specialization160_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization160_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(specialization160,specialization,specialization160_b, false).


% ---------------
spl_db( specialization161_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization161_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f1 ), requires( f7 , f4 ) ]
		)
	)
).

test_data(specialization161,specialization,specialization161_b, false).


% ---------------
spl_db( specialization162_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

spl_db( specialization162_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ), excludes( f1 , f6 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization162,specialization,specialization162_b, false).


% ---------------
spl_db( specialization163_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ), requires( f5 , f2 ), requires( f9 , f1 ) ]
		)
	)
).

spl_db( specialization163_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization163,specialization,specialization163_b, true).


% ---------------
spl_db( specialization164_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( specialization164_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization164,specialization,specialization164_b, true).


% ---------------
spl_db( specialization165_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization165_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization165,specialization,specialization165_b, true).


% ---------------
spl_db( specialization166_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

spl_db( specialization166_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization166,specialization,specialization166_b, true).


% ---------------
spl_db( specialization167_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ requires( f9 , f5 ), requires( f4 , f3 ) ]
		)
	)
).

spl_db( specialization167_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization167,specialization,specialization167_b, true).


% ---------------
spl_db( specialization168_a,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization168_b,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(specialization168,specialization,specialization168_b, false).


% ---------------
spl_db( specialization169_a,
	 spl( [ root, f1, f4, f9, f2, f3, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization169_b,
	 spl( [ root, f1, f4, f9, f2, f3, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(specialization169,specialization,specialization169_b, true).


% ---------------
spl_db( specialization170_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

spl_db( specialization170_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization170,specialization,specialization170_b, true).


% ---------------
spl_db( specialization171_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization171_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(specialization171,specialization,specialization171_b, false).


% ---------------
spl_db( specialization172_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f6 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( specialization172_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(specialization172,specialization,specialization172_b, true).


% ---------------
spl_db( specialization173_a,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f1 ), excludes( f4 , f7 ) ]
		)
	)
).

spl_db( specialization173_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(specialization173,specialization,specialization173_b, true).


% ---------------
spl_db( specialization174_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization174_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(specialization174,specialization,specialization174_b, false).


% ---------------
spl_db( specialization175_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization175_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f8 ), requires( f8 , f6 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(specialization175,specialization,specialization175_b, false).


% ---------------
spl_db( specialization176_a,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization176_b,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization176,specialization,specialization176_b, true).


% ---------------
spl_db( specialization177_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization177_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(specialization177,specialization,specialization177_b, false).


% ---------------
spl_db( specialization178_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization178_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f2 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(specialization178,specialization,specialization178_b, false).


% ---------------
spl_db( specialization179_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f1 ), requires( f8 , f4 ) ]
		)
	)
).

spl_db( specialization179_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization179,specialization,specialization179_b, true).


% ---------------
spl_db( specialization180_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f1 ), requires( f3 , f2 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization180_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(specialization180,specialization,specialization180_b, true).


% ---------------
spl_db( specialization181_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f4 ), requires( f7 , f6 ) ]
		)
	)
).

spl_db( specialization181_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization181,specialization,specialization181_b, true).


% ---------------
spl_db( specialization182_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( specialization182_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization182,specialization,specialization182_b, true).


% ---------------
spl_db( specialization183_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

spl_db( specialization183_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization183,specialization,specialization183_b, true).


% ---------------
spl_db( specialization184_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f3 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization184_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(specialization184,specialization,specialization184_b, true).


% ---------------
spl_db( specialization185_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f9 , f5 ) ]
		)
	)
).

spl_db( specialization185_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization185,specialization,specialization185_b, true).


% ---------------
spl_db( specialization186_a,
	 spl( [ root, f1, f7, f8, f2, f3, f5, f6, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f4 , f1 ) ]
		)
	)
).

spl_db( specialization186_b,
	 spl( [ root, f1, f7, f8, f2, f3, f5, f6, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization186,specialization,specialization186_b, true).


% ---------------
spl_db( specialization187_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization187_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(specialization187,specialization,specialization187_b, false).


% ---------------
spl_db( specialization188_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization188_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ), excludes( f4 , f8 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(specialization188,specialization,specialization188_b, false).


% ---------------
spl_db( specialization189_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

spl_db( specialization189_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization189,specialization,specialization189_b, true).


% ---------------
spl_db( specialization190_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization190_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f4 , f5 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(specialization190,specialization,specialization190_b, false).


% ---------------
spl_db( specialization191_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization191_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(specialization191,specialization,specialization191_b, false).


% ---------------
spl_db( specialization192_a,
	 spl( [ root, f1, f4, f8, f5, f6, f7, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

spl_db( specialization192_b,
	 spl( [ root, f1, f4, f8, f5, f6, f7, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization192,specialization,specialization192_b, false).


% ---------------
spl_db( specialization193_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
						optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

spl_db( specialization193_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
						optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization193,specialization,specialization193_b, true).


% ---------------
spl_db( specialization194_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

spl_db( specialization194_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization194,specialization,specialization194_b, true).


% ---------------
spl_db( specialization195_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f3 ), requires( f7 , f2 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( specialization195_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(specialization195,specialization,specialization195_b, true).


% ---------------
spl_db( specialization196_a,
	 spl( [ root, f1, f2, f6, f8, f9, f7, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization196_b,
	 spl( [ root, f1, f2, f6, f8, f9, f7, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(specialization196,specialization,specialization196_b, false).


% ---------------
spl_db( specialization197_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization197_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(specialization197,specialization,specialization197_b, false).


% ---------------
spl_db( specialization198_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

spl_db( specialization198_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization198,specialization,specialization198_b, true).


% ---------------
spl_db( specialization199_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization199_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f5 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(specialization199,specialization,specialization199_b, false).


% ---------------
spl_db( specialization200_a,
	 spl( [ root, f1, f2, f3, f5, f8, f9, f6, f4, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					optional( feature( f5, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [
					optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization200_b,
	 spl( [ root, f1, f2, f3, f5, f8, f9, f6, f4, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					optional( feature( f5, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [
					optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f3 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization200,specialization,specialization200_b, false).


% ---------------
spl_db( specialization201_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f6 , f8 ) ]
		)
	)
).

spl_db( specialization201_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization201,specialization,specialization201_b, true).


% ---------------
spl_db( specialization202_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f4 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( specialization202_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization202,specialization,specialization202_b, true).


% ---------------
spl_db( specialization203_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

spl_db( specialization203_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization203,specialization,specialization203_b, true).


% ---------------
spl_db( specialization204_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization204_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(specialization204,specialization,specialization204_b, false).


% ---------------
spl_db( specialization205_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization205_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization205,specialization,specialization205_b, false).


% ---------------
spl_db( specialization206_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f3 ), requires( f9 , f1 ) ]
		)
	)
).

spl_db( specialization206_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization206,specialization,specialization206_b, true).


% ---------------
spl_db( specialization207_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization207_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f5 ), requires( f5 , f7 ) ]
		)
	)
).

test_data(specialization207,specialization,specialization207_b, false).


% ---------------
spl_db( specialization208_a,
	 spl( [ root, f1, f3, f4, f7, f5, f6, f2, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization208_b,
	 spl( [ root, f1, f3, f4, f7, f5, f6, f2, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization208,specialization,specialization208_b, false).


% ---------------
spl_db( specialization209_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization209_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f2 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(specialization209,specialization,specialization209_b, false).


% ---------------
spl_db( specialization210_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

spl_db( specialization210_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization210,specialization,specialization210_b, true).


% ---------------
spl_db( specialization211_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization211_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization211,specialization,specialization211_b, true).


% ---------------
spl_db( specialization212_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization212_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f7 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization212,specialization,specialization212_b, false).


% ---------------
spl_db( specialization213_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

spl_db( specialization213_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization213,specialization,specialization213_b, true).


% ---------------
spl_db( specialization214_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f5 ), requires( f4 , f1 ) ]
		)
	)
).

spl_db( specialization214_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

test_data(specialization214,specialization,specialization214_b, true).


% ---------------
spl_db( specialization215_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f8 ), excludes( f7 , f5 ) ]
		)
	)
).

spl_db( specialization215_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization215,specialization,specialization215_b, true).


% ---------------
spl_db( specialization216_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization216_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(specialization216,specialization,specialization216_b, false).


% ---------------
spl_db( specialization217_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

spl_db( specialization217_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f2 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(specialization217,specialization,specialization217_b, false).


% ---------------
spl_db( specialization218_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization218_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(specialization218,specialization,specialization218_b, false).


% ---------------
spl_db( specialization219_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization219_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization219,specialization,specialization219_b, false).


% ---------------
spl_db( specialization220_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f2, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization220_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f2, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(specialization220,specialization,specialization220_b, false).


% ---------------
spl_db( specialization221_a,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization221_b,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f1 , f2 ) ]
		)
	)
).

test_data(specialization221,specialization,specialization221_b, false).


% ---------------
spl_db( specialization222_a,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				only_one( [ feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f9 , f8 ) ]
		)
	)
).

spl_db( specialization222_b,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				only_one( [ feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(specialization222,specialization,specialization222_b, true).


% ---------------
spl_db( specialization223_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f4 ), requires( f5 , f3 ) ]
		)
	)
).

spl_db( specialization223_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(specialization223,specialization,specialization223_b, true).


% ---------------
spl_db( specialization224_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

spl_db( specialization224_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization224,specialization,specialization224_b, true).


% ---------------
spl_db( specialization225_a,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f2 , f7 ) ]
		)
	)
).

spl_db( specialization225_b,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization225,specialization,specialization225_b, true).


% ---------------
spl_db( specialization226_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f1 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( specialization226_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization226,specialization,specialization226_b, true).


% ---------------
spl_db( specialization227_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization227_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(specialization227,specialization,specialization227_b, false).


% ---------------
spl_db( specialization228_a,
	 spl( [ root, f1, f7, f2, f4, f5, f6, f3, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

spl_db( specialization228_b,
	 spl( [ root, f1, f7, f2, f4, f5, f6, f3, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f8 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(specialization228,specialization,specialization228_b, false).


% ---------------
spl_db( specialization229_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

spl_db( specialization229_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization229,specialization,specialization229_b, true).


% ---------------
spl_db( specialization230_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization230_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization230,specialization,specialization230_b, false).


% ---------------
spl_db( specialization231_a,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization231_b,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization231,specialization,specialization231_b, true).


% ---------------
spl_db( specialization232_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

spl_db( specialization232_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization232,specialization,specialization232_b, true).


% ---------------
spl_db( specialization233_a,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f3 , f6 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( specialization233_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(specialization233,specialization,specialization233_b, true).


% ---------------
spl_db( specialization234_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( specialization234_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization234,specialization,specialization234_b, true).


% ---------------
spl_db( specialization235_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f8 ), requires( f3 , f1 ) ]
		)
	)
).

spl_db( specialization235_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization235,specialization,specialization235_b, true).


% ---------------
spl_db( specialization236_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization236_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(specialization236,specialization,specialization236_b, false).


% ---------------
spl_db( specialization237_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

spl_db( specialization237_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization237,specialization,specialization237_b, true).


% ---------------
spl_db( specialization238_a,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f2 , f8 ), excludes( f9 , f7 ), requires( f6 , f7 ) ]
		)
	)
).

spl_db( specialization238_b,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f2 , f8 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(specialization238,specialization,specialization238_b, true).


% ---------------
spl_db( specialization239_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization239_b,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(specialization239,specialization,specialization239_b, false).


% ---------------
spl_db( specialization240_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ), requires( f6 , f1 ) ]
		)
	)
).

spl_db( specialization240_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(specialization240,specialization,specialization240_b, true).


% ---------------
spl_db( specialization241_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( specialization241_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization241,specialization,specialization241_b, false).


% ---------------
spl_db( specialization242_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization242_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(specialization242,specialization,specialization242_b, false).


% ---------------
spl_db( specialization243_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization243_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f7 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(specialization243,specialization,specialization243_b, false).


% ---------------
spl_db( specialization244_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f8 ), requires( f9 , f2 ) ]
		)
	)
).

spl_db( specialization244_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization244,specialization,specialization244_b, true).


% ---------------
spl_db( specialization245_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f5 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( specialization245_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization245,specialization,specialization245_b, true).


% ---------------
spl_db( specialization246_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

spl_db( specialization246_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization246,specialization,specialization246_b, true).


% ---------------
spl_db( specialization247_a,
	 spl( [ root, f1, f6, f2, f3, f7, f4, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization247_b,
	 spl( [ root, f1, f6, f2, f3, f7, f4, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(specialization247,specialization,specialization247_b, false).


% ---------------
spl_db( specialization248_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( specialization248_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization248,specialization,specialization248_b, true).


% ---------------
spl_db( specialization249_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f2 ), excludes( f7 , f5 ) ]
		)
	)
).

spl_db( specialization249_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization249,specialization,specialization249_b, true).


% ---------------
spl_db( specialization250_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization250_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization250,specialization,specialization250_b, false).


% ---------------
spl_db( specialization251_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization251_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(specialization251,specialization,specialization251_b, false).


% ---------------
spl_db( specialization252_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f8 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( specialization252_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization252,specialization,specialization252_b, true).


% ---------------
spl_db( specialization253_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f5 ), requires( f6 , f7 ) ]
		)
	)
).

spl_db( specialization253_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization253,specialization,specialization253_b, true).


% ---------------
spl_db( specialization254_a,
	 spl( [ root, f1, f2, f8, f3, f5, f9, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f6 , f2 ), excludes( f7 , f5 ) ]
		)
	)
).

spl_db( specialization254_b,
	 spl( [ root, f1, f2, f8, f3, f5, f9, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization254,specialization,specialization254_b, true).


% ---------------
spl_db( specialization255_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

spl_db( specialization255_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization255,specialization,specialization255_b, true).


% ---------------
spl_db( specialization256_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization256_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization256,specialization,specialization256_b, true).


% ---------------
spl_db( specialization257_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( specialization257_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ), requires( f1 , f5 ) ]
		)
	)
).

test_data(specialization257,specialization,specialization257_b, false).


% ---------------
spl_db( specialization258_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization258_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization258,specialization,specialization258_b, false).


% ---------------
spl_db( specialization259_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization259_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(specialization259,specialization,specialization259_b, false).


% ---------------
spl_db( specialization260_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization260_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(specialization260,specialization,specialization260_b, false).


% ---------------
spl_db( specialization261_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization261_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization261,specialization,specialization261_b, true).


% ---------------
spl_db( specialization262_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f2 ), excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization262_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization262,specialization,specialization262_b, true).


% ---------------
spl_db( specialization263_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization263_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f9, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization263,specialization,specialization263_b, true).


% ---------------
spl_db( specialization264_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization264_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f9, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(specialization264,specialization,specialization264_b, false).


% ---------------
spl_db( specialization265_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization265_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f6 ), excludes( f3 , f8 ) ]
		)
	)
).

test_data(specialization265,specialization,specialization265_b, false).


% ---------------
spl_db( specialization266_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f1 , f5 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization266_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

test_data(specialization266,specialization,specialization266_b, true).


% ---------------
spl_db( specialization267_a,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( specialization267_b,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f2 , f5 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization267,specialization,specialization267_b, false).


% ---------------
spl_db( specialization268_a,
	 spl( [ root, f1, f4, f6, f7, f9, f8, f5, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f6, [
						optional( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f8 , f3 ), excludes( f2 , f4 ) ]
		)
	)
).

spl_db( specialization268_b,
	 spl( [ root, f1, f4, f6, f7, f9, f8, f5, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f6, [
						optional( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(specialization268,specialization,specialization268_b, true).


% ---------------
spl_db( specialization269_a,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization269_b,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

test_data(specialization269,specialization,specialization269_b, false).


% ---------------
spl_db( specialization270_a,
	 spl( [ root, f1, f5, f8, f9, f6, f7, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization270_b,
	 spl( [ root, f1, f5, f8, f9, f6, f7, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(specialization270,specialization,specialization270_b, false).


% ---------------
spl_db( specialization271_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f2 , f6 ), requires( f8 , f6 ) ]
		)
	)
).

spl_db( specialization271_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization271,specialization,specialization271_b, true).


% ---------------
spl_db( specialization272_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f7 , f1 ) ]
		)
	)
).

spl_db( specialization272_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(specialization272,specialization,specialization272_b, true).


% ---------------
spl_db( specialization273_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), excludes( f7 , f3 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( specialization273_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization273,specialization,specialization273_b, true).


% ---------------
spl_db( specialization274_a,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( specialization274_b,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization274,specialization,specialization274_b, true).


% ---------------
spl_db( specialization275_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f1 ), excludes( f9 , f1 ), requires( f3 , f2 ) ]
		)
	)
).

spl_db( specialization275_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(specialization275,specialization,specialization275_b, true).


% ---------------
spl_db( specialization276_a,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization276_b,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization276,specialization,specialization276_b, true).


% ---------------
spl_db( specialization277_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization277_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f9 ), excludes( f5 , f1 ) ]
		)
	)
).

test_data(specialization277,specialization,specialization277_b, false).


% ---------------
spl_db( specialization278_a,
	 spl( [ root, f1, f6, f2, f3, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization278_b,
	 spl( [ root, f1, f6, f2, f3, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

test_data(specialization278,specialization,specialization278_b, false).


% ---------------
spl_db( specialization279_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

spl_db( specialization279_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f9 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(specialization279,specialization,specialization279_b, false).


% ---------------
spl_db( specialization280_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f3 ), excludes( f9 , f8 ) ]
		)
	)
).

spl_db( specialization280_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(specialization280,specialization,specialization280_b, true).


% ---------------
spl_db( specialization281_a,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

spl_db( specialization281_b,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization281,specialization,specialization281_b, true).


% ---------------
spl_db( specialization282_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f6 ), excludes( f2 , f5 ), excludes( f4 , f9 ) ]
		)
	)
).

spl_db( specialization282_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization282,specialization,specialization282_b, true).


% ---------------
spl_db( specialization283_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f2 ), excludes( f6 , f4 ) ]
		)
	)
).

spl_db( specialization283_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

test_data(specialization283,specialization,specialization283_b, true).


% ---------------
spl_db( specialization284_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

spl_db( specialization284_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f4 , f2 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(specialization284,specialization,specialization284_b, false).


% ---------------
spl_db( specialization285_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( specialization285_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f5 ), excludes( f8 , f4 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(specialization285,specialization,specialization285_b, false).


% ---------------
spl_db( specialization286_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f5 ), requires( f4 , f5 ), excludes( f2 , f8 ) ]
		)
	)
).

spl_db( specialization286_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(specialization286,specialization,specialization286_b, true).


% ---------------
spl_db( specialization287_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization287_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization287,specialization,specialization287_b, true).


% ---------------
spl_db( specialization288_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization288_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f3 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(specialization288,specialization,specialization288_b, false).


% ---------------
spl_db( specialization289_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f3 ), excludes( f8 , f3 ) ]
		)
	)
).

spl_db( specialization289_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(specialization289,specialization,specialization289_b, true).


% ---------------
spl_db( specialization290_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization290_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f3 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(specialization290,specialization,specialization290_b, false).


% ---------------
spl_db( specialization291_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f7 ), requires( f8 , f4 ) ]
		)
	)
).

spl_db( specialization291_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(specialization291,specialization,specialization291_b, true).


% ---------------
spl_db( specialization292_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( specialization292_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization292,specialization,specialization292_b, true).


% ---------------
spl_db( specialization293_a,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f1 , f5 ), requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization293_b,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization293,specialization,specialization293_b, true).


% ---------------
spl_db( specialization294_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( specialization294_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization294,specialization,specialization294_b, true).


% ---------------
spl_db( specialization295_a,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

spl_db( specialization295_b,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(specialization295,specialization,specialization295_b, false).


% ---------------
spl_db( specialization296_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization296_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f5 , f4 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(specialization296,specialization,specialization296_b, false).


% ---------------
spl_db( specialization297_a,
	 spl( [ root, f1, f3, f8, f4, f2, f5, f6, f9, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ), feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization297_b,
	 spl( [ root, f1, f3, f8, f4, f2, f5, f6, f9, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ) ] ), feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f9 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(specialization297,specialization,specialization297_b, false).


% ---------------
spl_db( specialization298_a,
	 spl( [ root, f1, f7, f8, f9, f2, f6, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), excludes( f8 , f9 ) ]
		)
	)
).

spl_db( specialization298_b,
	 spl( [ root, f1, f7, f8, f9, f2, f6, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization298,specialization,specialization298_b, true).


% ---------------
spl_db( specialization299_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

spl_db( specialization299_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f5 , f3 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization299,specialization,specialization299_b, false).


% ---------------
spl_db( specialization300_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f1 ), excludes( f3 , f9 ) ]
		)
	)
).

spl_db( specialization300_b,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization300,specialization,specialization300_b, true).


% ---------------
spl_db( specialization301_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

spl_db( specialization301_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization301,specialization,specialization301_b, true).


% ---------------
spl_db( specialization302_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization302_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(specialization302,specialization,specialization302_b, false).


% ---------------
spl_db( specialization303_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization303_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

test_data(specialization303,specialization,specialization303_b, false).


% ---------------
spl_db( specialization304_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization304_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f6 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(specialization304,specialization,specialization304_b, false).


% ---------------
spl_db( specialization305_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization305_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f2 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(specialization305,specialization,specialization305_b, false).


% ---------------
spl_db( specialization306_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization306_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f7 ), requires( f9 , f6 ) ]
		)
	)
).

test_data(specialization306,specialization,specialization306_b, false).


% ---------------
spl_db( specialization307_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( specialization307_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization307,specialization,specialization307_b, true).


% ---------------
spl_db( specialization308_a,
	 spl( [ root, f1, f8, f2, f3, f7, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f4 ), excludes( f6 , f7 ) ]
		)
	)
).

spl_db( specialization308_b,
	 spl( [ root, f1, f8, f2, f3, f7, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(specialization308,specialization,specialization308_b, true).


% ---------------
spl_db( specialization309_a,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f3, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [
					optional( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f5 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( specialization309_b,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f3, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [
					optional( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization309,specialization,specialization309_b, true).


% ---------------
spl_db( specialization310_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					only_one( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization310_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					only_one( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(specialization310,specialization,specialization310_b, false).


% ---------------
spl_db( specialization311_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization311_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization311,specialization,specialization311_b, false).


% ---------------
spl_db( specialization312_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f1 ), requires( f6 , f9 ) ]
		)
	)
).

spl_db( specialization312_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization312,specialization,specialization312_b, true).


% ---------------
spl_db( specialization313_a,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f8 ), excludes( f2 , f9 ) ]
		)
	)
).

spl_db( specialization313_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization313,specialization,specialization313_b, true).


% ---------------
spl_db( specialization314_a,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization314_b,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f6 , f8 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(specialization314,specialization,specialization314_b, false).


% ---------------
spl_db( specialization315_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization315_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization315,specialization,specialization315_b, false).


% ---------------
spl_db( specialization316_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( specialization316_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization316,specialization,specialization316_b, true).


% ---------------
spl_db( specialization317_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f7 ), excludes( f5 , f1 ), requires( f3 , f1 ) ]
		)
	)
).

spl_db( specialization317_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization317,specialization,specialization317_b, true).


% ---------------
spl_db( specialization318_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization318_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f4 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(specialization318,specialization,specialization318_b, false).


% ---------------
spl_db( specialization319_a,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f4 , f5 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( specialization319_b,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization319,specialization,specialization319_b, true).


% ---------------
spl_db( specialization320_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization320_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(specialization320,specialization,specialization320_b, false).


% ---------------
spl_db( specialization321_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f5, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f5, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( specialization321_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f5, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [
				optional( feature( f5, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization321,specialization,specialization321_b, true).


% ---------------
spl_db( specialization322_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization322_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f1 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(specialization322,specialization,specialization322_b, false).


% ---------------
spl_db( specialization323_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

spl_db( specialization323_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f5 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(specialization323,specialization,specialization323_b, false).


% ---------------
spl_db( specialization324_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization324_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f5 ), excludes( f6 , f5 ) ]
		)
	)
).

test_data(specialization324,specialization,specialization324_b, false).


% ---------------
spl_db( specialization325_a,
	 spl( [ root, f1, f6, f7, f2, f3, f9, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( specialization325_b,
	 spl( [ root, f1, f6, f7, f2, f3, f9, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization325,specialization,specialization325_b, true).


% ---------------
spl_db( specialization326_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization326_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(specialization326,specialization,specialization326_b, false).


% ---------------
spl_db( specialization327_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization327_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization327,specialization,specialization327_b, true).


% ---------------
spl_db( specialization328_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization328_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f6 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(specialization328,specialization,specialization328_b, false).


% ---------------
spl_db( specialization329_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization329_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(specialization329,specialization,specialization329_b, false).


% ---------------
spl_db( specialization330_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization330_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(specialization330,specialization,specialization330_b, false).


% ---------------
spl_db( specialization331_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

spl_db( specialization331_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization331,specialization,specialization331_b, true).


% ---------------
spl_db( specialization332_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

spl_db( specialization332_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization332,specialization,specialization332_b, true).


% ---------------
spl_db( specialization333_a,
	 spl( [ root, f1, f2, f8, f3, f4, f6, f7, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization333_b,
	 spl( [ root, f1, f2, f8, f3, f4, f6, f7, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f6 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(specialization333,specialization,specialization333_b, false).


% ---------------
spl_db( specialization334_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

spl_db( specialization334_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f7 , f1 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(specialization334,specialization,specialization334_b, false).


% ---------------
spl_db( specialization335_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization335_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f4 , f6 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(specialization335,specialization,specialization335_b, false).


% ---------------
spl_db( specialization336_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

spl_db( specialization336_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(specialization336,specialization,specialization336_b, false).


% ---------------
spl_db( specialization337_a,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f9, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization337_b,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f9, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(specialization337,specialization,specialization337_b, false).


% ---------------
spl_db( specialization338_a,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( specialization338_b,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization338,specialization,specialization338_b, true).


% ---------------
spl_db( specialization339_a,
	 spl( [ root, f1, f6, f7, f2, f5, f3, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f5 , f1 ), excludes( f5 , f4 ) ]
		)
	)
).

spl_db( specialization339_b,
	 spl( [ root, f1, f6, f7, f2, f5, f3, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(specialization339,specialization,specialization339_b, true).


% ---------------
spl_db( specialization340_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f8 ), requires( f1 , f8 ) ]
		)
	)
).

spl_db( specialization340_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization340,specialization,specialization340_b, true).


% ---------------
spl_db( specialization341_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

spl_db( specialization341_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization341,specialization,specialization341_b, true).


% ---------------
spl_db( specialization342_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization342_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

test_data(specialization342,specialization,specialization342_b, false).


% ---------------
spl_db( specialization343_a,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization343_b,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f3 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization343,specialization,specialization343_b, false).


% ---------------
spl_db( specialization344_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f3 ), requires( f9 , f5 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization344_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f3 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(specialization344,specialization,specialization344_b, true).


% ---------------
spl_db( specialization345_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

spl_db( specialization345_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(specialization345,specialization,specialization345_b, false).


% ---------------
spl_db( specialization346_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization346_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f9 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization346,specialization,specialization346_b, false).


% ---------------
spl_db( specialization347_a,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization347_b,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f6 , f1 ) ]
		)
	)
).

test_data(specialization347,specialization,specialization347_b, false).


% ---------------
spl_db( specialization348_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization348_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f5 ), excludes( f9 , f4 ) ]
		)
	)
).

test_data(specialization348,specialization,specialization348_b, false).


% ---------------
spl_db( specialization349_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

spl_db( specialization349_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f9 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(specialization349,specialization,specialization349_b, false).


% ---------------
spl_db( specialization350_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

spl_db( specialization350_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization350,specialization,specialization350_b, true).


% ---------------
spl_db( specialization351_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization351_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(specialization351,specialization,specialization351_b, false).


% ---------------
spl_db( specialization352_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f8 , f4 ) ]
		)
	)
).

spl_db( specialization352_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(specialization352,specialization,specialization352_b, true).


% ---------------
spl_db( specialization353_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization353_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f2 ), excludes( f8 , f1 ) ]
		)
	)
).

test_data(specialization353,specialization,specialization353_b, false).


% ---------------
spl_db( specialization354_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f3 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( specialization354_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization354,specialization,specialization354_b, true).


% ---------------
spl_db( specialization355_a,
	 spl( [ root, f1, f8, f2, f3, f5, f6, f7, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization355_b,
	 spl( [ root, f1, f8, f2, f3, f5, f6, f7, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f4 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(specialization355,specialization,specialization355_b, false).


% ---------------
spl_db( specialization356_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization356_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [
						mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization356,specialization,specialization356_b, true).


% ---------------
spl_db( specialization357_a,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization357_b,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization357,specialization,specialization357_b, true).


% ---------------
spl_db( specialization358_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f9 , f8 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( specialization358_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization358,specialization,specialization358_b, true).


% ---------------
spl_db( specialization359_a,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

spl_db( specialization359_b,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization359,specialization,specialization359_b, true).


% ---------------
spl_db( specialization360_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

spl_db( specialization360_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization360,specialization,specialization360_b, true).


% ---------------
spl_db( specialization361_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization361_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization361,specialization,specialization361_b, true).


% ---------------
spl_db( specialization362_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization362_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization362,specialization,specialization362_b, false).


% ---------------
spl_db( specialization363_a,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization363_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization363,specialization,specialization363_b, false).


% ---------------
spl_db( specialization364_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization364_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f8 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(specialization364,specialization,specialization364_b, false).


% ---------------
spl_db( specialization365_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization365_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f1 , f7 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(specialization365,specialization,specialization365_b, false).


% ---------------
spl_db( specialization366_a,
	 spl( [ root, f1, f2, f3, f5, f6, f8, f9, f4, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					only_one( [ feature( f5, [] ), feature( f6, [
						mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [
					mandatory( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ), requires( f6 , f5 ) ]
		)
	)
).

spl_db( specialization366_b,
	 spl( [ root, f1, f2, f3, f5, f6, f8, f9, f4, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					only_one( [ feature( f5, [] ), feature( f6, [
						mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [
					mandatory( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(specialization366,specialization,specialization366_b, true).


% ---------------
spl_db( specialization367_a,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization367_b,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization367,specialization,specialization367_b, false).


% ---------------
spl_db( specialization368_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), excludes( f5 , f4 ), requires( f9 , f3 ) ]
		)
	)
).

spl_db( specialization368_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(specialization368,specialization,specialization368_b, true).


% ---------------
spl_db( specialization369_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

spl_db( specialization369_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f2 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(specialization369,specialization,specialization369_b, false).


% ---------------
spl_db( specialization370_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [
						optional( feature( f6, [
							mandatory( feature( f7, [
								mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

spl_db( specialization370_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [
						optional( feature( f6, [
							mandatory( feature( f7, [
								mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f5 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(specialization370,specialization,specialization370_b, false).


% ---------------
spl_db( specialization371_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization371_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization371,specialization,specialization371_b, false).


% ---------------
spl_db( specialization372_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ), requires( f7 , f3 ) ]
		)
	)
).

spl_db( specialization372_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization372,specialization,specialization372_b, true).


% ---------------
spl_db( specialization373_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization373_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f8 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(specialization373,specialization,specialization373_b, false).


% ---------------
spl_db( specialization374_a,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization374_b,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(specialization374,specialization,specialization374_b, false).


% ---------------
spl_db( specialization375_a,
	 spl( [ root, f1, f6, f7, f2, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f1 ), excludes( f6 , f3 ) ]
		)
	)
).

spl_db( specialization375_b,
	 spl( [ root, f1, f6, f7, f2, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

test_data(specialization375,specialization,specialization375_b, true).


% ---------------
spl_db( specialization376_a,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization376_b,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f1 , f3 ), excludes( f7 , f4 ) ]
		)
	)
).

test_data(specialization376,specialization,specialization376_b, false).


% ---------------
spl_db( specialization377_a,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization377_b,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f9 , f6 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(specialization377,specialization,specialization377_b, false).


% ---------------
spl_db( specialization378_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

spl_db( specialization378_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization378,specialization,specialization378_b, true).


% ---------------
spl_db( specialization379_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f5 , f8 ) ]
		)
	)
).

spl_db( specialization379_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization379,specialization,specialization379_b, true).


% ---------------
spl_db( specialization380_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization380_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f2 ) ]
		)
	)
).

test_data(specialization380,specialization,specialization380_b, false).


% ---------------
spl_db( specialization381_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
							mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization381_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
							mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(specialization381,specialization,specialization381_b, false).


% ---------------
spl_db( specialization382_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

spl_db( specialization382_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f1 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(specialization382,specialization,specialization382_b, false).


% ---------------
spl_db( specialization383_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization383_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization383,specialization,specialization383_b, false).


% ---------------
spl_db( specialization384_a,
	 spl( [ root, f1, f7, f8, f9, f2, f5, f3, f6, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization384_b,
	 spl( [ root, f1, f7, f8, f9, f2, f5, f3, f6, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization384,specialization,specialization384_b, true).


% ---------------
spl_db( specialization385_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

spl_db( specialization385_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f8 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(specialization385,specialization,specialization385_b, false).


% ---------------
spl_db( specialization386_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f2 , f7 ) ]
		)
	)
).

spl_db( specialization386_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization386,specialization,specialization386_b, true).


% ---------------
spl_db( specialization387_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( specialization387_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization387,specialization,specialization387_b, true).


% ---------------
spl_db( specialization388_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f7 ), excludes( f5 , f8 ), requires( f9 , f3 ) ]
		)
	)
).

spl_db( specialization388_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(specialization388,specialization,specialization388_b, true).


% ---------------
spl_db( specialization389_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization389_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization389,specialization,specialization389_b, false).


% ---------------
spl_db( specialization390_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f4 ), excludes( f7 , f9 ) ]
		)
	)
).

spl_db( specialization390_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(specialization390,specialization,specialization390_b, true).


% ---------------
spl_db( specialization391_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization391_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f6 ), excludes( f9 , f1 ) ]
		)
	)
).

test_data(specialization391,specialization,specialization391_b, false).


% ---------------
spl_db( specialization392_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( specialization392_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization392,specialization,specialization392_b, true).


% ---------------
spl_db( specialization393_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization393_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f3 , f8 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(specialization393,specialization,specialization393_b, false).


% ---------------
spl_db( specialization394_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

spl_db( specialization394_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f8 ), excludes( f8 , f3 ) ]
		)
	)
).

test_data(specialization394,specialization,specialization394_b, false).


% ---------------
spl_db( specialization395_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f8 , f5 ) ]
		)
	)
).

spl_db( specialization395_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization395,specialization,specialization395_b, true).


% ---------------
spl_db( specialization396_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization396_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

test_data(specialization396,specialization,specialization396_b, false).


% ---------------
spl_db( specialization397_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f5 ), excludes( f5 , f8 ) ]
		)
	)
).

spl_db( specialization397_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(specialization397,specialization,specialization397_b, true).


% ---------------
spl_db( specialization398_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f5, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization398_b,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f5, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(specialization398,specialization,specialization398_b, false).


% ---------------
spl_db( specialization399_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization399_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(specialization399,specialization,specialization399_b, false).


% ---------------
spl_db( specialization400_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), requires( f9 , f2 ), excludes( f6 , f4 ) ]
		)
	)
).

spl_db( specialization400_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization400,specialization,specialization400_b, true).


% ---------------
spl_db( specialization401_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f5 ), excludes( f6 , f5 ) ]
		)
	)
).

spl_db( specialization401_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(specialization401,specialization,specialization401_b, true).


% ---------------
spl_db( specialization402_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization402_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization402,specialization,specialization402_b, false).


% ---------------
spl_db( specialization403_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization403_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization403,specialization,specialization403_b, false).


% ---------------
spl_db( specialization404_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization404_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f9 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(specialization404,specialization,specialization404_b, false).


% ---------------
spl_db( specialization405_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization405_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

test_data(specialization405,specialization,specialization405_b, false).


% ---------------
spl_db( specialization406_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization406_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f5 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization406,specialization,specialization406_b, false).


% ---------------
spl_db( specialization407_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

spl_db( specialization407_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f1 ), requires( f1 , f9 ) ]
		)
	)
).

test_data(specialization407,specialization,specialization407_b, false).


% ---------------
spl_db( specialization408_a,
	 spl( [ root, f1, f2, f4, f6, f7, f5, f3, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [
						optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization408_b,
	 spl( [ root, f1, f2, f4, f6, f7, f5, f3, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [
						optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization408,specialization,specialization408_b, false).


% ---------------
spl_db( specialization409_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization409_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f8 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization409,specialization,specialization409_b, false).


% ---------------
spl_db( specialization410_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), excludes( f8 , f3 ), excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization410_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization410,specialization,specialization410_b, true).


% ---------------
spl_db( specialization411_a,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f4 ), excludes( f1 , f9 ) ]
		)
	)
).

spl_db( specialization411_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization411,specialization,specialization411_b, true).


% ---------------
spl_db( specialization412_a,
	 spl( [ root, f1, f2, f3, f6, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f7 , f3 ), excludes( f2 , f9 ) ]
		)
	)
).

spl_db( specialization412_b,
	 spl( [ root, f1, f2, f3, f6, f4, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(specialization412,specialization,specialization412_b, true).


% ---------------
spl_db( specialization413_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

spl_db( specialization413_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization413,specialization,specialization413_b, true).


% ---------------
spl_db( specialization414_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f9 , f6 ) ]
		)
	)
).

spl_db( specialization414_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization414,specialization,specialization414_b, true).


% ---------------
spl_db( specialization415_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f9 ), requires( f8 , f7 ) ]
		)
	)
).

spl_db( specialization415_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization415,specialization,specialization415_b, true).


% ---------------
spl_db( specialization416_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

spl_db( specialization416_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization416,specialization,specialization416_b, true).


% ---------------
spl_db( specialization417_a,
	 spl( [ root, f1, f7, f2, f3, f4, f9, f5, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

spl_db( specialization417_b,
	 spl( [ root, f1, f7, f2, f3, f4, f9, f5, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f7 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(specialization417,specialization,specialization417_b, false).


% ---------------
spl_db( specialization418_a,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization418_b,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization418,specialization,specialization418_b, true).


% ---------------
spl_db( specialization419_a,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f9, f4, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization419_b,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f9, f4, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f3 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization419,specialization,specialization419_b, false).


% ---------------
spl_db( specialization420_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization420_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f6 ), requires( f5 , f7 ) ]
		)
	)
).

test_data(specialization420,specialization,specialization420_b, false).


% ---------------
spl_db( specialization421_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f2 ), requires( f8 , f7 ), excludes( f9 , f6 ) ]
		)
	)
).

spl_db( specialization421_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization421,specialization,specialization421_b, true).


% ---------------
spl_db( specialization422_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization422_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(specialization422,specialization,specialization422_b, false).


% ---------------
spl_db( specialization423_a,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization423_b,
	 spl( [ root, f1, f3, f4, f7, f8, f9, f5, f6, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(specialization423,specialization,specialization423_b, false).


% ---------------
spl_db( specialization424_a,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f2 , f8 ), requires( f5 , f1 ), excludes( f8 , f1 ) ]
		)
	)
).

spl_db( specialization424_b,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

test_data(specialization424,specialization,specialization424_b, true).


% ---------------
spl_db( specialization425_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f3 ), requires( f7 , f4 ), requires( f7 , f3 ) ]
		)
	)
).

spl_db( specialization425_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f3 ), requires( f7 , f4 ) ]
		)
	)
).

test_data(specialization425,specialization,specialization425_b, true).


% ---------------
spl_db( specialization426_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), excludes( f3 , f9 ) ]
		)
	)
).

spl_db( specialization426_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization426,specialization,specialization426_b, true).


% ---------------
spl_db( specialization427_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization427_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f5 ), requires( f1 , f8 ) ]
		)
	)
).

test_data(specialization427,specialization,specialization427_b, false).


% ---------------
spl_db( specialization428_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f5 , f8 ) ]
		)
	)
).

spl_db( specialization428_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization428,specialization,specialization428_b, true).


% ---------------
spl_db( specialization429_a,
	 spl( [ root, f1, f7, f2, f5, f9, f6, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization429_b,
	 spl( [ root, f1, f7, f2, f5, f9, f6, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ) ] ) ) ] ),
 [ requires( f3 , f1 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(specialization429,specialization,specialization429_b, false).


% ---------------
spl_db( specialization430_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

spl_db( specialization430_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization430,specialization,specialization430_b, true).


% ---------------
spl_db( specialization431_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f1 ) ]
		)
	)
).

spl_db( specialization431_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f1 ), excludes( f1 , f5 ) ]
		)
	)
).

test_data(specialization431,specialization,specialization431_b, false).


% ---------------
spl_db( specialization432_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization432_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f9 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(specialization432,specialization,specialization432_b, false).


% ---------------
spl_db( specialization433_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

spl_db( specialization433_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f3 , f8 ), excludes( f7 , f1 ) ]
		)
	)
).

test_data(specialization433,specialization,specialization433_b, false).


% ---------------
spl_db( specialization434_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization434_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f1 , f6 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(specialization434,specialization,specialization434_b, false).


% ---------------
spl_db( specialization435_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f6 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( specialization435_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

test_data(specialization435,specialization,specialization435_b, true).


% ---------------
spl_db( specialization436_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

spl_db( specialization436_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization436,specialization,specialization436_b, true).


% ---------------
spl_db( specialization437_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

spl_db( specialization437_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f4 ), excludes( f3 , f4 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization437,specialization,specialization437_b, false).


% ---------------
spl_db( specialization438_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization438_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization438,specialization,specialization438_b, true).


% ---------------
spl_db( specialization439_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

spl_db( specialization439_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization439,specialization,specialization439_b, true).


% ---------------
spl_db( specialization440_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( specialization440_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f2 , f5 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(specialization440,specialization,specialization440_b, false).


% ---------------
spl_db( specialization441_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

spl_db( specialization441_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization441,specialization,specialization441_b, true).


% ---------------
spl_db( specialization442_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f3 , f9 ), requires( f6 , f4 ) ]
		)
	)
).

spl_db( specialization442_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization442,specialization,specialization442_b, true).


% ---------------
spl_db( specialization443_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f9 ), excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization443_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f9 ), excludes( f3 , f6 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(specialization443,specialization,specialization443_b, false).


% ---------------
spl_db( specialization444_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization444_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f4 ), excludes( f2 , f7 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization444,specialization,specialization444_b, false).


% ---------------
spl_db( specialization445_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization445_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(specialization445,specialization,specialization445_b, false).


% ---------------
spl_db( specialization446_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization446_b,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f6, [
							mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(specialization446,specialization,specialization446_b, false).


% ---------------
spl_db( specialization447_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

spl_db( specialization447_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f2 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(specialization447,specialization,specialization447_b, false).


% ---------------
spl_db( specialization448_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f1 , f4 ) ]
		)
	)
).

spl_db( specialization448_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization448,specialization,specialization448_b, true).


% ---------------
spl_db( specialization449_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization449_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(specialization449,specialization,specialization449_b, false).


% ---------------
spl_db( specialization450_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

spl_db( specialization450_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f7 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(specialization450,specialization,specialization450_b, false).


% ---------------
spl_db( specialization451_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f6 ), requires( f5 , f6 ) ]
		)
	)
).

spl_db( specialization451_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(specialization451,specialization,specialization451_b, true).


% ---------------
spl_db( specialization452_a,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ), excludes( f1 , f6 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( specialization452_b,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [
						optional( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(specialization452,specialization,specialization452_b, true).


% ---------------
spl_db( specialization453_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization453_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f1 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(specialization453,specialization,specialization453_b, false).


% ---------------
spl_db( specialization454_a,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization454_b,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(specialization454,specialization,specialization454_b, false).


% ---------------
spl_db( specialization455_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f4 ), excludes( f1 , f3 ) ]
		)
	)
).

spl_db( specialization455_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization455,specialization,specialization455_b, true).


% ---------------
spl_db( specialization456_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f5 ), excludes( f8 , f1 ) ]
		)
	)
).

spl_db( specialization456_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(specialization456,specialization,specialization456_b, true).


% ---------------
spl_db( specialization457_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization457_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(specialization457,specialization,specialization457_b, false).


% ---------------
spl_db( specialization458_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization458_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization458,specialization,specialization458_b, false).


% ---------------
spl_db( specialization459_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

spl_db( specialization459_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(specialization459,specialization,specialization459_b, false).


% ---------------
spl_db( specialization460_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f9 , f1 ) ]
		)
	)
).

spl_db( specialization460_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(specialization460,specialization,specialization460_b, true).


% ---------------
spl_db( specialization461_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization461_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(specialization461,specialization,specialization461_b, false).


% ---------------
spl_db( specialization462_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f5 , f3 ) ]
		)
	)
).

spl_db( specialization462_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization462,specialization,specialization462_b, true).


% ---------------
spl_db( specialization463_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization463_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f5 ), requires( f9 , f2 ) ]
		)
	)
).

test_data(specialization463,specialization,specialization463_b, false).


% ---------------
spl_db( specialization464_a,
	 spl( [ root, f1, f2, f3, f7, f4, f9, f5, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization464_b,
	 spl( [ root, f1, f2, f3, f7, f4, f9, f5, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

test_data(specialization464,specialization,specialization464_b, false).


% ---------------
spl_db( specialization465_a,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( specialization465_b,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization465,specialization,specialization465_b, false).


% ---------------
spl_db( specialization466_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f4 , f5 ), requires( f5 , f8 ), excludes( f6 , f7 ) ]
		)
	)
).

spl_db( specialization466_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f4 , f5 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(specialization466,specialization,specialization466_b, true).


% ---------------
spl_db( specialization467_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [
							optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
							optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization467_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f4, [
							optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
							optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f5 ), excludes( f6 , f9 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(specialization467,specialization,specialization467_b, false).


% ---------------
spl_db( specialization468_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f8 ), excludes( f5 , f6 ) ]
		)
	)
).

spl_db( specialization468_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization468,specialization,specialization468_b, true).


% ---------------
spl_db( specialization469_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

spl_db( specialization469_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization469,specialization,specialization469_b, true).


% ---------------
spl_db( specialization470_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization470_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

test_data(specialization470,specialization,specialization470_b, false).


% ---------------
spl_db( specialization471_a,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f3 , f8 ), requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization471_b,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(specialization471,specialization,specialization471_b, true).


% ---------------
spl_db( specialization472_a,
	 spl( [ root, f1, f2, f4, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization472_b,
	 spl( [ root, f1, f2, f4, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(specialization472,specialization,specialization472_b, false).


% ---------------
spl_db( specialization473_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ), excludes( f5 , f3 ) ]
		)
	)
).

spl_db( specialization473_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization473,specialization,specialization473_b, true).


% ---------------
spl_db( specialization474_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

spl_db( specialization474_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization474,specialization,specialization474_b, true).


% ---------------
spl_db( specialization475_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

spl_db( specialization475_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization475,specialization,specialization475_b, true).


% ---------------
spl_db( specialization476_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f4 ), requires( f8 , f2 ), excludes( f7 , f2 ) ]
		)
	)
).

spl_db( specialization476_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(specialization476,specialization,specialization476_b, true).


% ---------------
spl_db( specialization477_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f8 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization477_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(specialization477,specialization,specialization477_b, true).


% ---------------
spl_db( specialization478_a,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f7 ), requires( f6 , f9 ), excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization478_b,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(specialization478,specialization,specialization478_b, true).


% ---------------
spl_db( specialization479_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization479_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f8 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization479,specialization,specialization479_b, false).


% ---------------
spl_db( specialization480_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization480_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(specialization480,specialization,specialization480_b, false).


% ---------------
spl_db( specialization481_a,
	 spl( [ root, f1, f2, f8, f3, f4, f6, f7, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization481_b,
	 spl( [ root, f1, f2, f8, f3, f4, f6, f7, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization481,specialization,specialization481_b, false).


% ---------------
spl_db( specialization482_a,
	 spl( [ root, f1, f9, f2, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization482_b,
	 spl( [ root, f1, f9, f2, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ requires( f7 , f9 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization482,specialization,specialization482_b, false).


% ---------------
spl_db( specialization483_a,
	 spl( [ root, f1, f2, f3, f4, f6, f8, f7, f5, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization483_b,
	 spl( [ root, f1, f2, f3, f4, f6, f8, f7, f5, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f2 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(specialization483,specialization,specialization483_b, false).


% ---------------
spl_db( specialization484_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

spl_db( specialization484_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(specialization484,specialization,specialization484_b, false).


% ---------------
spl_db( specialization485_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization485_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(specialization485,specialization,specialization485_b, false).


% ---------------
spl_db( specialization486_a,
	 spl( [ root, f1, f7, f9, f2, f3, f4, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization486_b,
	 spl( [ root, f1, f7, f9, f2, f3, f4, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f8 , f2 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(specialization486,specialization,specialization486_b, false).


% ---------------
spl_db( specialization487_a,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f2 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization487_b,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(specialization487,specialization,specialization487_b, true).


% ---------------
spl_db( specialization488_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ), requires( f3 , f2 ) ]
		)
	)
).

spl_db( specialization488_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization488,specialization,specialization488_b, true).


% ---------------
spl_db( specialization489_a,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

spl_db( specialization489_b,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization489,specialization,specialization489_b, true).


% ---------------
spl_db( specialization490_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( specialization490_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization490,specialization,specialization490_b, true).


% ---------------
spl_db( specialization491_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization491_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization491,specialization,specialization491_b, true).


% ---------------
spl_db( specialization492_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), requires( f3 , f7 ) ]
		)
	)
).

spl_db( specialization492_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization492,specialization,specialization492_b, true).


% ---------------
spl_db( specialization493_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f6 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( specialization493_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization493,specialization,specialization493_b, true).


% ---------------
spl_db( specialization494_a,
	 spl( [ root, f1, f2, f3, f6, f4, f5, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization494_b,
	 spl( [ root, f1, f2, f3, f6, f4, f5, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f1 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(specialization494,specialization,specialization494_b, false).


% ---------------
spl_db( specialization495_a,
	 spl( [ root, f1, f5, f7, f8, f6, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

spl_db( specialization495_b,
	 spl( [ root, f1, f5, f7, f8, f6, f2, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f3 ), excludes( f2 , f6 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(specialization495,specialization,specialization495_b, false).


% ---------------
spl_db( specialization496_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization496_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(specialization496,specialization,specialization496_b, false).


% ---------------
spl_db( specialization497_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f4 , f7 ) ]
		)
	)
).

spl_db( specialization497_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization497,specialization,specialization497_b, true).


% ---------------
spl_db( specialization498_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

spl_db( specialization498_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization498,specialization,specialization498_b, true).


% ---------------
spl_db( specialization499_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), excludes( f4 , f9 ), requires( f8 , f2 ) ]
		)
	)
).

spl_db( specialization499_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization499,specialization,specialization499_b, true).


% ---------------
spl_db( specialization500_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ), excludes( f6 , f9 ), requires( f9 , f1 ) ]
		)
	)
).

spl_db( specialization500_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization500,specialization,specialization500_b, true).


% ---------------
spl_db( specialization501_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization501_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization501,specialization,specialization501_b, false).


% ---------------
spl_db( specialization502_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

spl_db( specialization502_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization502,specialization,specialization502_b, true).


% ---------------
spl_db( specialization503_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

spl_db( specialization503_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f5 ), requires( f2 , f6 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(specialization503,specialization,specialization503_b, false).


% ---------------
spl_db( specialization504_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f3 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization504_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization504,specialization,specialization504_b, true).


% ---------------
spl_db( specialization505_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f7 ), excludes( f9 , f1 ), requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization505_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization505,specialization,specialization505_b, true).


% ---------------
spl_db( specialization506_a,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

spl_db( specialization506_b,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization506,specialization,specialization506_b, true).


% ---------------
spl_db( specialization507_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization507_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), requires( f4 , f9 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization507,specialization,specialization507_b, false).


% ---------------
spl_db( specialization508_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), excludes( f2 , f1 ) ]
		)
	)
).

spl_db( specialization508_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

test_data(specialization508,specialization,specialization508_b, true).


% ---------------
spl_db( specialization509_a,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

spl_db( specialization509_b,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f8 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(specialization509,specialization,specialization509_b, false).


% ---------------
spl_db( specialization510_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

spl_db( specialization510_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f9 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(specialization510,specialization,specialization510_b, false).


% ---------------
spl_db( specialization511_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization511_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(specialization511,specialization,specialization511_b, false).


% ---------------
spl_db( specialization512_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization512_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(specialization512,specialization,specialization512_b, false).


% ---------------
spl_db( specialization513_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

spl_db( specialization513_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f7 ), excludes( f7 , f4 ) ]
		)
	)
).

test_data(specialization513,specialization,specialization513_b, false).


% ---------------
spl_db( specialization514_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

spl_db( specialization514_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f2 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(specialization514,specialization,specialization514_b, false).


% ---------------
spl_db( specialization515_a,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f3, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f5 ), requires( f8 , f6 ), excludes( f9 , f4 ) ]
		)
	)
).

spl_db( specialization515_b,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f3, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization515,specialization,specialization515_b, true).


% ---------------
spl_db( specialization516_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f6 ), excludes( f7 , f6 ), excludes( f6 , f4 ) ]
		)
	)
).

spl_db( specialization516_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f6 ), excludes( f7 , f6 ) ]
		)
	)
).

test_data(specialization516,specialization,specialization516_b, true).


% ---------------
spl_db( specialization517_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization517_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(specialization517,specialization,specialization517_b, false).


% ---------------
spl_db( specialization518_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization518_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f1 , f3 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(specialization518,specialization,specialization518_b, false).


% ---------------
spl_db( specialization519_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f3 ), requires( f1 , f6 ) ]
		)
	)
).

spl_db( specialization519_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(specialization519,specialization,specialization519_b, true).


% ---------------
spl_db( specialization520_a,
	 spl( [ root, f1, f5, f2, f3, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

spl_db( specialization520_b,
	 spl( [ root, f1, f5, f2, f3, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization520,specialization,specialization520_b, true).


% ---------------
spl_db( specialization521_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

spl_db( specialization521_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization521,specialization,specialization521_b, true).


% ---------------
spl_db( specialization522_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

spl_db( specialization522_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(specialization522,specialization,specialization522_b, false).


% ---------------
spl_db( specialization523_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f3 ), excludes( f6 , f5 ) ]
		)
	)
).

spl_db( specialization523_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization523,specialization,specialization523_b, true).


% ---------------
spl_db( specialization524_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ), excludes( f1 , f4 ), requires( f3 , f5 ) ]
		)
	)
).

spl_db( specialization524_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(specialization524,specialization,specialization524_b, true).


% ---------------
spl_db( specialization525_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f3 ), requires( f6 , f9 ) ]
		)
	)
).

spl_db( specialization525_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization525,specialization,specialization525_b, true).


% ---------------
spl_db( specialization526_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( specialization526_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(specialization526,specialization,specialization526_b, false).


% ---------------
spl_db( specialization527_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f9 ), requires( f1 , f4 ) ]
		)
	)
).

spl_db( specialization527_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(specialization527,specialization,specialization527_b, true).


% ---------------
spl_db( specialization528_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

spl_db( specialization528_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(specialization528,specialization,specialization528_b, false).


% ---------------
spl_db( specialization529_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization529_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

test_data(specialization529,specialization,specialization529_b, false).


% ---------------
spl_db( specialization530_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

spl_db( specialization530_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f1 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(specialization530,specialization,specialization530_b, false).


% ---------------
spl_db( specialization531_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization531_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

test_data(specialization531,specialization,specialization531_b, true).


% ---------------
spl_db( specialization532_a,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f2 ), requires( f9 , f7 ) ]
		)
	)
).

spl_db( specialization532_b,
	 spl( [ root, f1, f2, f3, f8, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(specialization532,specialization,specialization532_b, true).


% ---------------
spl_db( specialization533_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f9 ), excludes( f3 , f7 ), excludes( f1 , f3 ) ]
		)
	)
).

spl_db( specialization533_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(specialization533,specialization,specialization533_b, true).


% ---------------
spl_db( specialization534_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

spl_db( specialization534_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization534,specialization,specialization534_b, true).


% ---------------
spl_db( specialization535_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f2 ), excludes( f4 , f7 ) ]
		)
	)
).

spl_db( specialization535_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(specialization535,specialization,specialization535_b, true).


% ---------------
spl_db( specialization536_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f5 , f8 ) ]
		)
	)
).

spl_db( specialization536_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(specialization536,specialization,specialization536_b, true).


% ---------------
spl_db( specialization537_a,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

spl_db( specialization537_b,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization537,specialization,specialization537_b, true).


% ---------------
spl_db( specialization538_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ),
 [ excludes( f5 , f8 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( specialization538_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

test_data(specialization538,specialization,specialization538_b, true).


% ---------------
spl_db( specialization539_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization539_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(specialization539,specialization,specialization539_b, false).


% ---------------
spl_db( specialization540_a,
	 spl( [ root, f1, f6, f2, f5, f3, f9, f4, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f8 ), excludes( f9 , f4 ) ]
		)
	)
).

spl_db( specialization540_b,
	 spl( [ root, f1, f6, f2, f5, f3, f9, f4, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization540,specialization,specialization540_b, true).


% ---------------
spl_db( specialization541_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization541_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

test_data(specialization541,specialization,specialization541_b, false).


% ---------------
spl_db( specialization542_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization542_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(specialization542,specialization,specialization542_b, false).


% ---------------
spl_db( specialization543_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization543_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(specialization543,specialization,specialization543_b, false).


% ---------------
spl_db( specialization544_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f5, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization544_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f5, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization544,specialization,specialization544_b, false).


% ---------------
spl_db( specialization545_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization545_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(specialization545,specialization,specialization545_b, false).


% ---------------
spl_db( specialization546_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

spl_db( specialization546_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization546,specialization,specialization546_b, true).


% ---------------
spl_db( specialization547_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( specialization547_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), excludes( f4 , f1 ) ]
		)
	)
).

test_data(specialization547,specialization,specialization547_b, false).


% ---------------
spl_db( specialization548_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

spl_db( specialization548_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization548,specialization,specialization548_b, true).


% ---------------
spl_db( specialization549_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

spl_db( specialization549_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization549,specialization,specialization549_b, true).


% ---------------
spl_db( specialization550_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f8 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization550_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization550,specialization,specialization550_b, true).


% ---------------
spl_db( specialization551_a,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f4 , f8 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization551_b,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization551,specialization,specialization551_b, true).


% ---------------
spl_db( specialization552_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization552_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization552,specialization,specialization552_b, false).


% ---------------
spl_db( specialization553_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f7 ), excludes( f3 , f7 ) ]
		)
	)
).

spl_db( specialization553_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization553,specialization,specialization553_b, true).


% ---------------
spl_db( specialization554_a,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f4 , f9 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization554_b,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

test_data(specialization554,specialization,specialization554_b, true).


% ---------------
spl_db( specialization555_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization555_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f2 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(specialization555,specialization,specialization555_b, false).


% ---------------
spl_db( specialization556_a,
	 spl( [ root, f1, f7, f2, f3, f5, f6, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization556_b,
	 spl( [ root, f1, f7, f2, f3, f5, f6, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f6 , f5 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization556,specialization,specialization556_b, false).


% ---------------
spl_db( specialization557_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization557_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(specialization557,specialization,specialization557_b, false).


% ---------------
spl_db( specialization558_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization558_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization558,specialization,specialization558_b, true).


% ---------------
spl_db( specialization559_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

spl_db( specialization559_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization559,specialization,specialization559_b, true).


% ---------------
spl_db( specialization560_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

spl_db( specialization560_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization560,specialization,specialization560_b, true).


% ---------------
spl_db( specialization561_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ), requires( f1 , f2 ) ]
		)
	)
).

spl_db( specialization561_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(specialization561,specialization,specialization561_b, true).


% ---------------
spl_db( specialization562_a,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization562_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization562,specialization,specialization562_b, true).


% ---------------
spl_db( specialization563_a,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f2, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f4 , f8 ), requires( f4 , f3 ) ]
		)
	)
).

spl_db( specialization563_b,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f2, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization563,specialization,specialization563_b, true).


% ---------------
spl_db( specialization564_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization564_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f9 , f1 ) ]
		)
	)
).

test_data(specialization564,specialization,specialization564_b, false).


% ---------------
spl_db( specialization565_a,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization565_b,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(specialization565,specialization,specialization565_b, false).


% ---------------
spl_db( specialization566_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f8 ), requires( f6 , f8 ) ]
		)
	)
).

spl_db( specialization566_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization566,specialization,specialization566_b, true).


% ---------------
spl_db( specialization567_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

spl_db( specialization567_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization567,specialization,specialization567_b, true).


% ---------------
spl_db( specialization568_a,
	 spl( [ root, f1, f4, f8, f9, f2, f5, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [
				only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization568_b,
	 spl( [ root, f1, f4, f8, f9, f2, f5, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [
				only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(specialization568,specialization,specialization568_b, false).


% ---------------
spl_db( specialization569_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f5 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization569_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization569,specialization,specialization569_b, true).


% ---------------
spl_db( specialization570_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

spl_db( specialization570_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(specialization570,specialization,specialization570_b, false).


% ---------------
spl_db( specialization571_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ), excludes( f3 , f9 ) ]
		)
	)
).

spl_db( specialization571_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization571,specialization,specialization571_b, true).


% ---------------
spl_db( specialization572_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [
							optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
								optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization572_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [
							optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
								optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization572,specialization,specialization572_b, true).


% ---------------
spl_db( specialization573_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization573_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization573,specialization,specialization573_b, false).


% ---------------
spl_db( specialization574_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

spl_db( specialization574_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), excludes( f5 , f1 ) ]
		)
	)
).

test_data(specialization574,specialization,specialization574_b, false).


% ---------------
spl_db( specialization575_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

spl_db( specialization575_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f7 ), requires( f2 , f4 ) ]
		)
	)
).

test_data(specialization575,specialization,specialization575_b, false).


% ---------------
spl_db( specialization576_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization576_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization576,specialization,specialization576_b, false).


% ---------------
spl_db( specialization577_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

spl_db( specialization577_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f6 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(specialization577,specialization,specialization577_b, false).


% ---------------
spl_db( specialization578_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( specialization578_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization578,specialization,specialization578_b, true).


% ---------------
spl_db( specialization579_a,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( specialization579_b,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization579,specialization,specialization579_b, true).


% ---------------
spl_db( specialization580_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization580_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(specialization580,specialization,specialization580_b, false).


% ---------------
spl_db( specialization581_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization581_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

test_data(specialization581,specialization,specialization581_b, false).


% ---------------
spl_db( specialization582_a,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization582_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(specialization582,specialization,specialization582_b, false).


% ---------------
spl_db( specialization583_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

spl_db( specialization583_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization583,specialization,specialization583_b, true).


% ---------------
spl_db( specialization584_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [] ) ), mandatory( feature( f5, [
							optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f4 ), excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization584_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f4, [] ) ), mandatory( feature( f5, [
							optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization584,specialization,specialization584_b, true).


% ---------------
spl_db( specialization585_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f8 ), excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization585_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(specialization585,specialization,specialization585_b, true).


% ---------------
spl_db( specialization586_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization586_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f8 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization586,specialization,specialization586_b, false).


% ---------------
spl_db( specialization587_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization587_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f9 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(specialization587,specialization,specialization587_b, false).


% ---------------
spl_db( specialization588_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

spl_db( specialization588_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization588,specialization,specialization588_b, true).


% ---------------
spl_db( specialization589_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization589_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(specialization589,specialization,specialization589_b, false).


% ---------------
spl_db( specialization590_a,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization590_b,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f6 , f7 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(specialization590,specialization,specialization590_b, false).


% ---------------
spl_db( specialization591_a,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f2 , f1 ), excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization591_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization591,specialization,specialization591_b, true).


% ---------------
spl_db( specialization592_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( specialization592_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f5 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization592,specialization,specialization592_b, false).


% ---------------
spl_db( specialization593_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f6, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f8 ), requires( f8 , f6 ) ]
		)
	)
).

spl_db( specialization593_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f6, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization593,specialization,specialization593_b, true).


% ---------------
spl_db( specialization594_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f5 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( specialization594_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization594,specialization,specialization594_b, true).


% ---------------
spl_db( specialization595_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization595_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(specialization595,specialization,specialization595_b, false).


% ---------------
spl_db( specialization596_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

spl_db( specialization596_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f6 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization596,specialization,specialization596_b, false).


% ---------------
spl_db( specialization597_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), requires( f8 , f2 ) ]
		)
	)
).

spl_db( specialization597_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization597,specialization,specialization597_b, true).


% ---------------
spl_db( specialization598_a,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f5 , f6 ), excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization598_b,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(specialization598,specialization,specialization598_b, true).


% ---------------
spl_db( specialization599_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

spl_db( specialization599_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f4 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(specialization599,specialization,specialization599_b, false).


% ---------------
spl_db( specialization600_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f7 ), requires( f1 , f6 ) ]
		)
	)
).

spl_db( specialization600_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(specialization600,specialization,specialization600_b, true).


% ---------------
spl_db( specialization601_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ), requires( f7 , f6 ) ]
		)
	)
).

spl_db( specialization601_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization601,specialization,specialization601_b, true).


% ---------------
spl_db( specialization602_a,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f6 , f7 ), excludes( f4 , f5 ) ]
		)
	)
).

spl_db( specialization602_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(specialization602,specialization,specialization602_b, true).


% ---------------
spl_db( specialization603_a,
	 spl( [ root, f1, f4, f9, f5, f8, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f3 , f5 ), excludes( f9 , f6 ), requires( f9 , f7 ) ]
		)
	)
).

spl_db( specialization603_b,
	 spl( [ root, f1, f4, f9, f5, f8, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(specialization603,specialization,specialization603_b, true).


% ---------------
spl_db( specialization604_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization604_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), requires( f6 , f2 ) ]
		)
	)
).

test_data(specialization604,specialization,specialization604_b, false).


% ---------------
spl_db( specialization605_a,
	 spl( [ root, f1, f3, f4, f5, f8, f9, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f5 , f2 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( specialization605_b,
	 spl( [ root, f1, f3, f4, f5, f8, f9, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization605,specialization,specialization605_b, true).


% ---------------
spl_db( specialization606_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

spl_db( specialization606_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization606,specialization,specialization606_b, true).


% ---------------
spl_db( specialization607_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

spl_db( specialization607_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(specialization607,specialization,specialization607_b, false).


% ---------------
spl_db( specialization608_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f1 ), requires( f6 , f9 ) ]
		)
	)
).

spl_db( specialization608_b,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

test_data(specialization608,specialization,specialization608_b, true).


% ---------------
spl_db( specialization609_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization609_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(specialization609,specialization,specialization609_b, false).


% ---------------
spl_db( specialization610_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization610_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization610,specialization,specialization610_b, false).


% ---------------
spl_db( specialization611_a,
	 spl( [ root, f1, f7, f2, f4, f5, f8, f6, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization611_b,
	 spl( [ root, f1, f7, f2, f4, f5, f8, f6, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization611,specialization,specialization611_b, false).


% ---------------
spl_db( specialization612_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

spl_db( specialization612_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f4 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(specialization612,specialization,specialization612_b, false).


% ---------------
spl_db( specialization613_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f9 ), excludes( f1 , f5 ) ]
		)
	)
).

spl_db( specialization613_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(specialization613,specialization,specialization613_b, true).


% ---------------
spl_db( specialization614_a,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization614_b,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f3 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization614,specialization,specialization614_b, false).


% ---------------
spl_db( specialization615_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

spl_db( specialization615_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f9 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization615,specialization,specialization615_b, false).


% ---------------
spl_db( specialization616_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ), excludes( f7 , f3 ) ]
		)
	)
).

spl_db( specialization616_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(specialization616,specialization,specialization616_b, true).


% ---------------
spl_db( specialization617_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f7 ), requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization617_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization617,specialization,specialization617_b, true).


% ---------------
spl_db( specialization618_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

spl_db( specialization618_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f1 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(specialization618,specialization,specialization618_b, false).


% ---------------
spl_db( specialization619_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization619_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f6 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization619,specialization,specialization619_b, false).


% ---------------
spl_db( specialization620_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
							one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( specialization620_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
							one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f7 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(specialization620,specialization,specialization620_b, false).


% ---------------
spl_db( specialization621_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization621_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f7 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization621,specialization,specialization621_b, false).


% ---------------
spl_db( specialization622_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization622_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization622,specialization,specialization622_b, true).


% ---------------
spl_db( specialization623_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f2 ), excludes( f1 , f5 ) ]
		)
	)
).

spl_db( specialization623_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization623,specialization,specialization623_b, true).


% ---------------
spl_db( specialization624_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization624_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(specialization624,specialization,specialization624_b, false).


% ---------------
spl_db( specialization625_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f5 ), excludes( f9 , f8 ), excludes( f3 , f2 ) ]
		)
	)
).

spl_db( specialization625_b,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f5 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization625,specialization,specialization625_b, true).


% ---------------
spl_db( specialization626_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f6, f7, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ), requires( f1 , f9 ) ]
		)
	)
).

spl_db( specialization626_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f6, f7, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization626,specialization,specialization626_b, true).


% ---------------
spl_db( specialization627_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

spl_db( specialization627_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization627,specialization,specialization627_b, true).


% ---------------
spl_db( specialization628_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization628_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), requires( f9 , f4 ), requires( f5 , f1 ) ]
		)
	)
).

test_data(specialization628,specialization,specialization628_b, false).


% ---------------
spl_db( specialization629_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f8 ), excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization629_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization629,specialization,specialization629_b, true).


% ---------------
spl_db( specialization630_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					optional( feature( f4, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
						mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f2 ), excludes( f2 , f8 ), excludes( f7 , f9 ) ]
		)
	)
).

spl_db( specialization630_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					optional( feature( f4, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
						mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization630,specialization,specialization630_b, true).


% ---------------
spl_db( specialization631_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization631_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f9 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(specialization631,specialization,specialization631_b, false).


% ---------------
spl_db( specialization632_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f2 ), excludes( f3 , f2 ) ]
		)
	)
).

spl_db( specialization632_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(specialization632,specialization,specialization632_b, true).


% ---------------
spl_db( specialization633_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( specialization633_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(specialization633,specialization,specialization633_b, false).


% ---------------
spl_db( specialization634_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization634_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f2 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(specialization634,specialization,specialization634_b, false).


% ---------------
spl_db( specialization635_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization635_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

test_data(specialization635,specialization,specialization635_b, false).


% ---------------
spl_db( specialization636_a,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization636_b,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(specialization636,specialization,specialization636_b, false).


% ---------------
spl_db( specialization637_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( specialization637_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization637,specialization,specialization637_b, true).


% ---------------
spl_db( specialization638_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( specialization638_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f7 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(specialization638,specialization,specialization638_b, false).


% ---------------
spl_db( specialization639_a,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [
					mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

spl_db( specialization639_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f4, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [
					mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization639,specialization,specialization639_b, true).


% ---------------
spl_db( specialization640_a,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f4 , f9 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( specialization640_b,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization640,specialization,specialization640_b, true).


% ---------------
spl_db( specialization641_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( specialization641_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(specialization641,specialization,specialization641_b, true).


% ---------------
spl_db( specialization642_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization642_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f8 ), excludes( f1 , f7 ) ]
		)
	)
).

test_data(specialization642,specialization,specialization642_b, false).


% ---------------
spl_db( specialization643_a,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization643_b,
	 spl( [ root, f1, f6, f2, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(specialization643,specialization,specialization643_b, false).


% ---------------
spl_db( specialization644_a,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

spl_db( specialization644_b,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f1 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(specialization644,specialization,specialization644_b, false).


% ---------------
spl_db( specialization645_a,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization645_b,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f1 , f4 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(specialization645,specialization,specialization645_b, false).


% ---------------
spl_db( specialization646_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f6 ), excludes( f2 , f1 ) ]
		)
	)
).

spl_db( specialization646_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization646,specialization,specialization646_b, true).


% ---------------
spl_db( specialization647_a,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ), excludes( f3 , f8 ) ]
		)
	)
).

spl_db( specialization647_b,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(specialization647,specialization,specialization647_b, true).


% ---------------
spl_db( specialization648_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

spl_db( specialization648_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization648,specialization,specialization648_b, true).


% ---------------
spl_db( specialization649_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

spl_db( specialization649_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization649,specialization,specialization649_b, true).


% ---------------
spl_db( specialization650_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

spl_db( specialization650_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization650,specialization,specialization650_b, true).


% ---------------
spl_db( specialization651_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization651_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(specialization651,specialization,specialization651_b, false).


% ---------------
spl_db( specialization652_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization652_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(specialization652,specialization,specialization652_b, false).


% ---------------
spl_db( specialization653_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f8 ), requires( f6 , f4 ) ]
		)
	)
).

spl_db( specialization653_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization653,specialization,specialization653_b, true).


% ---------------
spl_db( specialization654_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f1 ), requires( f2 , f3 ), requires( f6 , f3 ) ]
		)
	)
).

spl_db( specialization654_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization654,specialization,specialization654_b, true).


% ---------------
spl_db( specialization655_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f5 ), excludes( f6 , f1 ) ]
		)
	)
).

spl_db( specialization655_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(specialization655,specialization,specialization655_b, true).


% ---------------
spl_db( specialization656_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization656_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f7 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization656,specialization,specialization656_b, false).


% ---------------
spl_db( specialization657_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ), requires( f9 , f5 ) ]
		)
	)
).

spl_db( specialization657_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(specialization657,specialization,specialization657_b, true).


% ---------------
spl_db( specialization658_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization658_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(specialization658,specialization,specialization658_b, false).


% ---------------
spl_db( specialization659_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f9 ), excludes( f8 , f7 ) ]
		)
	)
).

spl_db( specialization659_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(specialization659,specialization,specialization659_b, true).


% ---------------
spl_db( specialization660_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f3 ), excludes( f7 , f8 ) ]
		)
	)
).

spl_db( specialization660_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

test_data(specialization660,specialization,specialization660_b, true).


% ---------------
spl_db( specialization661_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization661_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization661,specialization,specialization661_b, true).


% ---------------
spl_db( specialization662_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization662_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f5 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(specialization662,specialization,specialization662_b, false).


% ---------------
spl_db( specialization663_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization663_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f8 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(specialization663,specialization,specialization663_b, false).


% ---------------
spl_db( specialization664_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

spl_db( specialization664_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f6 ), requires( f7 , f4 ) ]
		)
	)
).

test_data(specialization664,specialization,specialization664_b, false).


% ---------------
spl_db( specialization665_a,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f7 ), excludes( f7 , f9 ) ]
		)
	)
).

spl_db( specialization665_b,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(specialization665,specialization,specialization665_b, true).


% ---------------
spl_db( specialization666_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f4 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( specialization666_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization666,specialization,specialization666_b, true).


% ---------------
spl_db( specialization667_a,
	 spl( [ root, f1, f3, f6, f8, f7, f4, f5, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization667_b,
	 spl( [ root, f1, f3, f6, f8, f7, f4, f5, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f5 , f7 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(specialization667,specialization,specialization667_b, false).


% ---------------
spl_db( specialization668_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization668_b,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization668,specialization,specialization668_b, true).


% ---------------
spl_db( specialization669_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( specialization669_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization669,specialization,specialization669_b, true).


% ---------------
spl_db( specialization670_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( specialization670_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f7 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(specialization670,specialization,specialization670_b, false).


% ---------------
spl_db( specialization671_a,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), excludes( f3 , f1 ) ]
		)
	)
).

spl_db( specialization671_b,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization671,specialization,specialization671_b, true).


% ---------------
spl_db( specialization672_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization672_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(specialization672,specialization,specialization672_b, false).


% ---------------
spl_db( specialization673_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization673_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization673,specialization,specialization673_b, false).


% ---------------
spl_db( specialization674_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization674_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(specialization674,specialization,specialization674_b, false).


% ---------------
spl_db( specialization675_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization675_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f9 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization675,specialization,specialization675_b, false).


% ---------------
spl_db( specialization676_a,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), only_one( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization676_b,
	 spl( [ root, f1, f2, f5, f6, f9, f7, f8, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), only_one( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ requires( f7 , f8 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(specialization676,specialization,specialization676_b, false).


% ---------------
spl_db( specialization677_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization677_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(specialization677,specialization,specialization677_b, false).


% ---------------
spl_db( specialization678_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f8 ), requires( f2 , f4 ) ]
		)
	)
).

spl_db( specialization678_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization678,specialization,specialization678_b, true).


% ---------------
spl_db( specialization679_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization679_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f8 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(specialization679,specialization,specialization679_b, false).


% ---------------
spl_db( specialization680_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f3 ), requires( f8 , f4 ) ]
		)
	)
).

spl_db( specialization680_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization680,specialization,specialization680_b, true).


% ---------------
spl_db( specialization681_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

spl_db( specialization681_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization681,specialization,specialization681_b, true).


% ---------------
spl_db( specialization682_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f2 ), excludes( f2 , f4 ) ]
		)
	)
).

spl_db( specialization682_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization682,specialization,specialization682_b, true).


% ---------------
spl_db( specialization683_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

spl_db( specialization683_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization683,specialization,specialization683_b, true).


% ---------------
spl_db( specialization684_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization684_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(specialization684,specialization,specialization684_b, false).


% ---------------
spl_db( specialization685_a,
	 spl( [ root, f1, f2, f6, f7, f3, f9, f4, f5, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

spl_db( specialization685_b,
	 spl( [ root, f1, f2, f6, f7, f3, f9, f4, f5, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f8 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization685,specialization,specialization685_b, false).


% ---------------
spl_db( specialization686_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization686_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization686,specialization,specialization686_b, true).


% ---------------
spl_db( specialization687_a,
	 spl( [ root, f1, f2, f6, f7, f9, f3, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f6 ), excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization687_b,
	 spl( [ root, f1, f2, f6, f7, f9, f3, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization687,specialization,specialization687_b, true).


% ---------------
spl_db( specialization688_a,
	 spl( [ root, f1, f2, f3, f5, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization688_b,
	 spl( [ root, f1, f2, f3, f5, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f7 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(specialization688,specialization,specialization688_b, false).


% ---------------
spl_db( specialization689_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

spl_db( specialization689_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f1 , f4 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization689,specialization,specialization689_b, false).


% ---------------
spl_db( specialization690_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization690_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization690,specialization,specialization690_b, true).


% ---------------
spl_db( specialization691_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization691_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f3 ), requires( f4 , f3 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(specialization691,specialization,specialization691_b, false).


% ---------------
spl_db( specialization692_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization692_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization692,specialization,specialization692_b, true).


% ---------------
spl_db( specialization693_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( specialization693_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization693,specialization,specialization693_b, true).


% ---------------
spl_db( specialization694_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization694_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization694,specialization,specialization694_b, true).


% ---------------
spl_db( specialization695_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f6 ), requires( f3 , f7 ), requires( f1 , f4 ) ]
		)
	)
).

spl_db( specialization695_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f6 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(specialization695,specialization,specialization695_b, true).


% ---------------
spl_db( specialization696_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization696_b,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f6 , f3 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization696,specialization,specialization696_b, false).


% ---------------
spl_db( specialization697_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f1 , f9 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization697_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(specialization697,specialization,specialization697_b, true).


% ---------------
spl_db( specialization698_a,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f5, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization698_b,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f5, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

test_data(specialization698,specialization,specialization698_b, false).


% ---------------
spl_db( specialization699_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f6 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization699_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(specialization699,specialization,specialization699_b, true).


% ---------------
spl_db( specialization700_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f6 ), excludes( f1 , f8 ) ]
		)
	)
).

spl_db( specialization700_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization700,specialization,specialization700_b, true).


% ---------------
spl_db( specialization701_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ), requires( f6 , f2 ) ]
		)
	)
).

spl_db( specialization701_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization701,specialization,specialization701_b, true).


% ---------------
spl_db( specialization702_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization702_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(specialization702,specialization,specialization702_b, false).


% ---------------
spl_db( specialization703_a,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

spl_db( specialization703_b,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization703,specialization,specialization703_b, true).


% ---------------
spl_db( specialization704_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f6 , f1 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization704_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

test_data(specialization704,specialization,specialization704_b, true).


% ---------------
spl_db( specialization705_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f8 ), excludes( f2 , f1 ) ]
		)
	)
).

spl_db( specialization705_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(specialization705,specialization,specialization705_b, true).


% ---------------
spl_db( specialization706_a,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

spl_db( specialization706_b,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization706,specialization,specialization706_b, true).


% ---------------
spl_db( specialization707_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization707_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization707,specialization,specialization707_b, true).


% ---------------
spl_db( specialization708_a,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f4, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization708_b,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f4, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f3 , f4 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(specialization708,specialization,specialization708_b, false).


% ---------------
spl_db( specialization709_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization709_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f5 ), requires( f4 , f2 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(specialization709,specialization,specialization709_b, false).


% ---------------
spl_db( specialization710_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

spl_db( specialization710_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization710,specialization,specialization710_b, true).


% ---------------
spl_db( specialization711_a,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f5 , f8 ), requires( f2 , f1 ) ]
		)
	)
).

spl_db( specialization711_b,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization711,specialization,specialization711_b, true).


% ---------------
spl_db( specialization712_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization712_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f4 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization712,specialization,specialization712_b, false).


% ---------------
spl_db( specialization713_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization713_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization713,specialization,specialization713_b, true).


% ---------------
spl_db( specialization714_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization714_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(specialization714,specialization,specialization714_b, true).


% ---------------
spl_db( specialization715_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f8 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization715_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(specialization715,specialization,specialization715_b, true).


% ---------------
spl_db( specialization716_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization716_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f9 , f1 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(specialization716,specialization,specialization716_b, false).


% ---------------
spl_db( specialization717_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f5 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( specialization717_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization717,specialization,specialization717_b, true).


% ---------------
spl_db( specialization718_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization718_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(specialization718,specialization,specialization718_b, false).


% ---------------
spl_db( specialization719_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), requires( f4 , f2 ) ]
		)
	)
).

spl_db( specialization719_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(specialization719,specialization,specialization719_b, true).


% ---------------
spl_db( specialization720_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f9 ), excludes( f7 , f5 ) ]
		)
	)
).

spl_db( specialization720_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization720,specialization,specialization720_b, true).


% ---------------
spl_db( specialization721_a,
	 spl( [ root, f1, f5, f7, f6, f9, f2, f3, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization721_b,
	 spl( [ root, f1, f5, f7, f6, f9, f2, f3, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f1 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization721,specialization,specialization721_b, false).


% ---------------
spl_db( specialization722_a,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f4 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization722_b,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(specialization722,specialization,specialization722_b, true).


% ---------------
spl_db( specialization723_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f7 ), excludes( f3 , f2 ), excludes( f8 , f5 ) ]
		)
	)
).

spl_db( specialization723_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization723,specialization,specialization723_b, true).


% ---------------
spl_db( specialization724_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization724_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f8 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(specialization724,specialization,specialization724_b, false).


% ---------------
spl_db( specialization725_a,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), requires( f3 , f6 ), excludes( f5 , f3 ) ]
		)
	)
).

spl_db( specialization725_b,
	 spl( [ root, f1, f3, f4, f5, f6, f8, f9, f7, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(specialization725,specialization,specialization725_b, true).


% ---------------
spl_db( specialization726_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f9 , f7 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization726_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization726,specialization,specialization726_b, true).


% ---------------
spl_db( specialization727_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( specialization727_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization727,specialization,specialization727_b, true).


% ---------------
spl_db( specialization728_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization728_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(specialization728,specialization,specialization728_b, false).


% ---------------
spl_db( specialization729_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f3 ), excludes( f6 , f4 ) ]
		)
	)
).

spl_db( specialization729_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(specialization729,specialization,specialization729_b, true).


% ---------------
spl_db( specialization730_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization730_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f6 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(specialization730,specialization,specialization730_b, false).


% ---------------
spl_db( specialization731_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization731_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization731,specialization,specialization731_b, true).


% ---------------
spl_db( specialization732_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

spl_db( specialization732_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization732,specialization,specialization732_b, true).


% ---------------
spl_db( specialization733_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), requires( f3 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( specialization733_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization733,specialization,specialization733_b, true).


% ---------------
spl_db( specialization734_a,
	 spl( [ root, f1, f3, f4, f8, f9, f5, f6, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( specialization734_b,
	 spl( [ root, f1, f3, f4, f8, f9, f5, f6, f7, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization734,specialization,specialization734_b, true).


% ---------------
spl_db( specialization735_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f5 ), excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization735_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization735,specialization,specialization735_b, true).


% ---------------
spl_db( specialization736_a,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization736_b,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f1 , f7 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(specialization736,specialization,specialization736_b, false).


% ---------------
spl_db( specialization737_a,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f7 ), excludes( f2 , f9 ) ]
		)
	)
).

spl_db( specialization737_b,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization737,specialization,specialization737_b, true).


% ---------------
spl_db( specialization738_a,
	 spl( [ root, f1, f7, f8, f2, f3, f6, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ) ] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization738_b,
	 spl( [ root, f1, f7, f8, f2, f3, f6, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ) ] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), requires( f3 , f9 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(specialization738,specialization,specialization738_b, false).


% ---------------
spl_db( specialization739_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ), excludes( f7 , f4 ) ]
		)
	)
).

spl_db( specialization739_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization739,specialization,specialization739_b, true).


% ---------------
spl_db( specialization740_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

spl_db( specialization740_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f1 , f5 ) ]
		)
	)
).

test_data(specialization740,specialization,specialization740_b, false).


% ---------------
spl_db( specialization741_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f2 ), excludes( f2 , f4 ) ]
		)
	)
).

spl_db( specialization741_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization741,specialization,specialization741_b, true).


% ---------------
spl_db( specialization742_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( specialization742_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization742,specialization,specialization742_b, false).


% ---------------
spl_db( specialization743_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

spl_db( specialization743_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization743,specialization,specialization743_b, true).


% ---------------
spl_db( specialization744_a,
	 spl( [ root, f1, f6, f7, f2, f3, f9, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization744_b,
	 spl( [ root, f1, f6, f7, f2, f3, f9, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f9 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(specialization744,specialization,specialization744_b, false).


% ---------------
spl_db( specialization745_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

spl_db( specialization745_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization745,specialization,specialization745_b, true).


% ---------------
spl_db( specialization746_a,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( specialization746_b,
	 spl( [ root, f1, f2, f3, f7, f9, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), requires( f2 , f8 ) ]
		)
	)
).

test_data(specialization746,specialization,specialization746_b, false).


% ---------------
spl_db( specialization747_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

spl_db( specialization747_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(specialization747,specialization,specialization747_b, false).


% ---------------
spl_db( specialization748_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f3 ) ]
		)
	)
).

spl_db( specialization748_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization748,specialization,specialization748_b, true).


% ---------------
spl_db( specialization749_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

spl_db( specialization749_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f1 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(specialization749,specialization,specialization749_b, false).


% ---------------
spl_db( specialization750_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

spl_db( specialization750_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization750,specialization,specialization750_b, true).


% ---------------
spl_db( specialization751_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

spl_db( specialization751_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization751,specialization,specialization751_b, true).


% ---------------
spl_db( specialization752_a,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

spl_db( specialization752_b,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f5 , f3 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(specialization752,specialization,specialization752_b, false).


% ---------------
spl_db( specialization753_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

spl_db( specialization753_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization753,specialization,specialization753_b, true).


% ---------------
spl_db( specialization754_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

spl_db( specialization754_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization754,specialization,specialization754_b, true).


% ---------------
spl_db( specialization755_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization755_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f6 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(specialization755,specialization,specialization755_b, false).


% ---------------
spl_db( specialization756_a,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f8, [] ) ) ] ), feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization756_b,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f8, [] ) ) ] ), feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f6 ), excludes( f4 , f8 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(specialization756,specialization,specialization756_b, false).


% ---------------
spl_db( specialization757_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f6 ), excludes( f9 , f1 ) ]
		)
	)
).

spl_db( specialization757_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization757,specialization,specialization757_b, true).


% ---------------
spl_db( specialization758_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

spl_db( specialization758_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization758,specialization,specialization758_b, true).


% ---------------
spl_db( specialization759_a,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f7 ), requires( f9 , f1 ) ]
		)
	)
).

spl_db( specialization759_b,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization759,specialization,specialization759_b, true).


% ---------------
spl_db( specialization760_a,
	 spl( [ root, f1, f8, f9, f2, f3, f5, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( specialization760_b,
	 spl( [ root, f1, f8, f9, f2, f3, f5, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(specialization760,specialization,specialization760_b, true).


% ---------------
spl_db( specialization761_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization761_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(specialization761,specialization,specialization761_b, false).


% ---------------
spl_db( specialization762_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f6 ), excludes( f5 , f1 ) ]
		)
	)
).

spl_db( specialization762_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(specialization762,specialization,specialization762_b, true).


% ---------------
spl_db( specialization763_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

spl_db( specialization763_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization763,specialization,specialization763_b, false).


% ---------------
spl_db( specialization764_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), requires( f1 , f8 ) ]
		)
	)
).

spl_db( specialization764_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(specialization764,specialization,specialization764_b, true).


% ---------------
spl_db( specialization765_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

spl_db( specialization765_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f8 , f4 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(specialization765,specialization,specialization765_b, false).


% ---------------
spl_db( specialization766_a,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f5, f6, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization766_b,
	 spl( [ root, f1, f7, f8, f2, f9, f3, f5, f6, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

test_data(specialization766,specialization,specialization766_b, false).


% ---------------
spl_db( specialization767_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f2 , f3 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization767_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization767,specialization,specialization767_b, true).


% ---------------
spl_db( specialization768_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization768_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(specialization768,specialization,specialization768_b, false).


% ---------------
spl_db( specialization769_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization769_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f9 , f6 ) ]
		)
	)
).

test_data(specialization769,specialization,specialization769_b, false).


% ---------------
spl_db( specialization770_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization770_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(specialization770,specialization,specialization770_b, false).


% ---------------
spl_db( specialization771_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization771_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f1 , f7 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(specialization771,specialization,specialization771_b, false).


% ---------------
spl_db( specialization772_a,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization772_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f2 ), requires( f7 , f2 ) ]
		)
	)
).

test_data(specialization772,specialization,specialization772_b, false).


% ---------------
spl_db( specialization773_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization773_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f1 , f8 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(specialization773,specialization,specialization773_b, false).


% ---------------
spl_db( specialization774_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( specialization774_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization774,specialization,specialization774_b, true).


% ---------------
spl_db( specialization775_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization775_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f6 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization775,specialization,specialization775_b, false).


% ---------------
spl_db( specialization776_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

spl_db( specialization776_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f4 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(specialization776,specialization,specialization776_b, false).


% ---------------
spl_db( specialization777_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization777_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f2 ), requires( f9 , f2 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization777,specialization,specialization777_b, false).


% ---------------
spl_db( specialization778_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization778_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(specialization778,specialization,specialization778_b, false).


% ---------------
spl_db( specialization779_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization779_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f3 ), requires( f9 , f2 ) ]
		)
	)
).

test_data(specialization779,specialization,specialization779_b, false).


% ---------------
spl_db( specialization780_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

spl_db( specialization780_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization780,specialization,specialization780_b, true).


% ---------------
spl_db( specialization781_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization781_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(specialization781,specialization,specialization781_b, false).


% ---------------
spl_db( specialization782_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization782_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f3 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(specialization782,specialization,specialization782_b, false).


% ---------------
spl_db( specialization783_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization783_b,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f7 , f6 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(specialization783,specialization,specialization783_b, false).


% ---------------
spl_db( specialization784_a,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), excludes( f4 , f9 ) ]
		)
	)
).

spl_db( specialization784_b,
	 spl( [ root, f1, f9, f2, f5, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(specialization784,specialization,specialization784_b, true).


% ---------------
spl_db( specialization785_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f4 , f8 ), excludes( f5 , f1 ), excludes( f2 , f4 ) ]
		)
	)
).

spl_db( specialization785_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization785,specialization,specialization785_b, true).


% ---------------
spl_db( specialization786_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization786_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f3 , f2 ) ]
		)
	)
).

test_data(specialization786,specialization,specialization786_b, false).


% ---------------
spl_db( specialization787_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization787_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(specialization787,specialization,specialization787_b, true).


% ---------------
spl_db( specialization788_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), excludes( f8 , f2 ) ]
		)
	)
).

spl_db( specialization788_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

test_data(specialization788,specialization,specialization788_b, true).


% ---------------
spl_db( specialization789_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f3, [
						mandatory( feature( f8, [] ) ) ] ), feature( f4, [
						optional( feature( f5, [] ) ), only_one( [ feature( f6, [
							mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization789_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f3, [
						mandatory( feature( f8, [] ) ) ] ), feature( f4, [
						optional( feature( f5, [] ) ), only_one( [ feature( f6, [
							mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(specialization789,specialization,specialization789_b, false).


% ---------------
spl_db( specialization790_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ), requires( f9 , f3 ) ]
		)
	)
).

spl_db( specialization790_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

test_data(specialization790,specialization,specialization790_b, true).


% ---------------
spl_db( specialization791_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f5 ), excludes( f7 , f4 ) ]
		)
	)
).

spl_db( specialization791_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization791,specialization,specialization791_b, true).


% ---------------
spl_db( specialization792_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization792_b,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization792,specialization,specialization792_b, false).


% ---------------
spl_db( specialization793_a,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization793_b,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization793,specialization,specialization793_b, false).


% ---------------
spl_db( specialization794_a,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization794_b,
	 spl( [ root, f1, f9, f2, f6, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization794,specialization,specialization794_b, false).


% ---------------
spl_db( specialization795_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f8 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( specialization795_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization795,specialization,specialization795_b, true).


% ---------------
spl_db( specialization796_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization796_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(specialization796,specialization,specialization796_b, false).


% ---------------
spl_db( specialization797_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization797_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(specialization797,specialization,specialization797_b, false).


% ---------------
spl_db( specialization798_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization798_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f5 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(specialization798,specialization,specialization798_b, false).


% ---------------
spl_db( specialization799_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization799_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(specialization799,specialization,specialization799_b, false).


% ---------------
spl_db( specialization800_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f5 ), requires( f5 , f6 ) ]
		)
	)
).

spl_db( specialization800_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization800,specialization,specialization800_b, true).


% ---------------
spl_db( specialization801_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f3 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( specialization801_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization801,specialization,specialization801_b, true).


% ---------------
spl_db( specialization802_a,
	 spl( [ root, f1, f2, f4, f7, f8, f5, f6, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f8 ), excludes( f8 , f6 ), excludes( f1 , f8 ) ]
		)
	)
).

spl_db( specialization802_b,
	 spl( [ root, f1, f2, f4, f7, f8, f5, f6, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization802,specialization,specialization802_b, true).


% ---------------
spl_db( specialization803_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

spl_db( specialization803_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization803,specialization,specialization803_b, true).


% ---------------
spl_db( specialization804_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f9 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( specialization804_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization804,specialization,specialization804_b, true).


% ---------------
spl_db( specialization805_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

spl_db( specialization805_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization805,specialization,specialization805_b, true).


% ---------------
spl_db( specialization806_a,
	 spl( [ root, f1, f2, f6, f8, f7, f9, f3, f5, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), requires( f8 , f1 ), requires( f9 , f3 ) ]
		)
	)
).

spl_db( specialization806_b,
	 spl( [ root, f1, f2, f6, f8, f7, f9, f3, f5, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), requires( f8 , f1 ) ]
		)
	)
).

test_data(specialization806,specialization,specialization806_b, true).


% ---------------
spl_db( specialization807_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), requires( f6 , f9 ) ]
		)
	)
).

spl_db( specialization807_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization807,specialization,specialization807_b, true).


% ---------------
spl_db( specialization808_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

spl_db( specialization808_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization808,specialization,specialization808_b, true).


% ---------------
spl_db( specialization809_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization809_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f6 , f2 ), excludes( f4 , f2 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization809,specialization,specialization809_b, false).


% ---------------
spl_db( specialization810_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

spl_db( specialization810_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f9 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(specialization810,specialization,specialization810_b, false).


% ---------------
spl_db( specialization811_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

spl_db( specialization811_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization811,specialization,specialization811_b, true).


% ---------------
spl_db( specialization812_a,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization812_b,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(specialization812,specialization,specialization812_b, false).


% ---------------
spl_db( specialization813_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization813_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

test_data(specialization813,specialization,specialization813_b, false).


% ---------------
spl_db( specialization814_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( specialization814_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f5 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(specialization814,specialization,specialization814_b, false).


% ---------------
spl_db( specialization815_a,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f8 ), excludes( f4 , f9 ) ]
		)
	)
).

spl_db( specialization815_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization815,specialization,specialization815_b, true).


% ---------------
spl_db( specialization816_a,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization816_b,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), excludes( f6 , f1 ) ]
		)
	)
).

test_data(specialization816,specialization,specialization816_b, false).


% ---------------
spl_db( specialization817_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f7 , f9 ), requires( f2 , f8 ) ]
		)
	)
).

spl_db( specialization817_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization817,specialization,specialization817_b, true).


% ---------------
spl_db( specialization818_a,
	 spl( [ root, f1, f4, f9, f5, f7, f8, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization818_b,
	 spl( [ root, f1, f4, f9, f5, f7, f8, f6, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f2 , f1 ), requires( f3 , f5 ) ]
		)
	)
).

test_data(specialization818,specialization,specialization818_b, false).


% ---------------
spl_db( specialization819_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization819_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f9 ), excludes( f3 , f1 ) ]
		)
	)
).

test_data(specialization819,specialization,specialization819_b, false).


% ---------------
spl_db( specialization820_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f1 ), requires( f1 , f2 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization820_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f1 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization820,specialization,specialization820_b, true).


% ---------------
spl_db( specialization821_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

spl_db( specialization821_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f8 ), requires( f2 , f6 ) ]
		)
	)
).

test_data(specialization821,specialization,specialization821_b, false).


% ---------------
spl_db( specialization822_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization822_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(specialization822,specialization,specialization822_b, true).


% ---------------
spl_db( specialization823_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f8 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( specialization823_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization823,specialization,specialization823_b, true).


% ---------------
spl_db( specialization824_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization824_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization824,specialization,specialization824_b, true).


% ---------------
spl_db( specialization825_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization825_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization825,specialization,specialization825_b, false).


% ---------------
spl_db( specialization826_a,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f3 ), excludes( f2 , f8 ) ]
		)
	)
).

spl_db( specialization826_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f3 ), excludes( f2 , f8 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(specialization826,specialization,specialization826_b, false).


% ---------------
spl_db( specialization827_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization827_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization827,specialization,specialization827_b, false).


% ---------------
spl_db( specialization828_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization828_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(specialization828,specialization,specialization828_b, false).


% ---------------
spl_db( specialization829_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( specialization829_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization829,specialization,specialization829_b, true).


% ---------------
spl_db( specialization830_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

spl_db( specialization830_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(specialization830,specialization,specialization830_b, false).


% ---------------
spl_db( specialization831_a,
	 spl( [ root, f1, f7, f2, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

spl_db( specialization831_b,
	 spl( [ root, f1, f7, f2, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization831,specialization,specialization831_b, true).


% ---------------
spl_db( specialization832_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization832_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(specialization832,specialization,specialization832_b, false).


% ---------------
spl_db( specialization833_a,
	 spl( [ root, f1, f4, f2, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization833_b,
	 spl( [ root, f1, f4, f2, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization833,specialization,specialization833_b, false).


% ---------------
spl_db( specialization834_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization834_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization834,specialization,specialization834_b, true).


% ---------------
spl_db( specialization835_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), excludes( f4 , f1 ) ]
		)
	)
).

spl_db( specialization835_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization835,specialization,specialization835_b, true).


% ---------------
spl_db( specialization836_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f8 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization836_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(specialization836,specialization,specialization836_b, true).


% ---------------
spl_db( specialization837_a,
	 spl( [ root, f1, f2, f4, f8, f5, f6, f9, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [
					optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization837_b,
	 spl( [ root, f1, f2, f4, f8, f5, f6, f9, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [
					optional( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f4 , f6 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(specialization837,specialization,specialization837_b, false).


% ---------------
spl_db( specialization838_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

spl_db( specialization838_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization838,specialization,specialization838_b, true).


% ---------------
spl_db( specialization839_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f7 ), excludes( f6 , f3 ), excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization839_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization839,specialization,specialization839_b, true).


% ---------------
spl_db( specialization840_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization840_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization840,specialization,specialization840_b, true).


% ---------------
spl_db( specialization841_a,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization841_b,
	 spl( [ root, f1, f3, f4, f5, f9, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f8 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(specialization841,specialization,specialization841_b, false).


% ---------------
spl_db( specialization842_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f3 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization842_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization842,specialization,specialization842_b, true).


% ---------------
spl_db( specialization843_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization843_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), requires( f7 , f2 ) ]
		)
	)
).

test_data(specialization843,specialization,specialization843_b, false).


% ---------------
spl_db( specialization844_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization844_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f7 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(specialization844,specialization,specialization844_b, false).


% ---------------
spl_db( specialization845_a,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

spl_db( specialization845_b,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(specialization845,specialization,specialization845_b, false).


% ---------------
spl_db( specialization846_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f5 ), requires( f4 , f2 ) ]
		)
	)
).

spl_db( specialization846_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization846,specialization,specialization846_b, true).


% ---------------
spl_db( specialization847_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f9 ), requires( f6 , f2 ) ]
		)
	)
).

spl_db( specialization847_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f9 ), requires( f6 , f2 ), excludes( f1 , f5 ) ]
		)
	)
).

test_data(specialization847,specialization,specialization847_b, false).


% ---------------
spl_db( specialization848_a,
	 spl( [ root, f1, f8, f2, f3, f7, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization848_b,
	 spl( [ root, f1, f8, f2, f3, f7, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(specialization848,specialization,specialization848_b, false).


% ---------------
spl_db( specialization849_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization849_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f8 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(specialization849,specialization,specialization849_b, false).


% ---------------
spl_db( specialization850_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization850_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization850,specialization,specialization850_b, false).


% ---------------
spl_db( specialization851_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

spl_db( specialization851_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization851,specialization,specialization851_b, true).


% ---------------
spl_db( specialization852_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f4 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization852_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization852,specialization,specialization852_b, true).


% ---------------
spl_db( specialization853_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f3 ), excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization853_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization853,specialization,specialization853_b, true).


% ---------------
spl_db( specialization854_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f3 ), excludes( f3 , f1 ) ]
		)
	)
).

spl_db( specialization854_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(specialization854,specialization,specialization854_b, true).


% ---------------
spl_db( specialization855_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization855_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f1 ), requires( f2 , f3 ) ]
		)
	)
).

test_data(specialization855,specialization,specialization855_b, false).


% ---------------
spl_db( specialization856_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						one_or_more( [ feature( f4, [
							mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization856_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						one_or_more( [ feature( f4, [
							mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(specialization856,specialization,specialization856_b, false).


% ---------------
spl_db( specialization857_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization857_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(specialization857,specialization,specialization857_b, false).


% ---------------
spl_db( specialization858_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization858_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(specialization858,specialization,specialization858_b, false).


% ---------------
spl_db( specialization859_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f9 ), requires( f3 , f1 ) ]
		)
	)
).

spl_db( specialization859_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization859,specialization,specialization859_b, true).


% ---------------
spl_db( specialization860_a,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f5 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( specialization860_b,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization860,specialization,specialization860_b, true).


% ---------------
spl_db( specialization861_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f9 ), excludes( f7 , f8 ) ]
		)
	)
).

spl_db( specialization861_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

test_data(specialization861,specialization,specialization861_b, true).


% ---------------
spl_db( specialization862_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f8 ), excludes( f3 , f6 ) ]
		)
	)
).

spl_db( specialization862_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization862,specialization,specialization862_b, true).


% ---------------
spl_db( specialization863_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization863_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f4 , f8 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(specialization863,specialization,specialization863_b, false).


% ---------------
spl_db( specialization864_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

spl_db( specialization864_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization864,specialization,specialization864_b, true).


% ---------------
spl_db( specialization865_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f9 ), requires( f8 , f6 ) ]
		)
	)
).

spl_db( specialization865_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(specialization865,specialization,specialization865_b, true).


% ---------------
spl_db( specialization866_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

spl_db( specialization866_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f1 ), requires( f7 , f4 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(specialization866,specialization,specialization866_b, false).


% ---------------
spl_db( specialization867_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

spl_db( specialization867_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization867,specialization,specialization867_b, true).


% ---------------
spl_db( specialization868_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f4, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f5 , f2 ), requires( f5 , f3 ) ]
		)
	)
).

spl_db( specialization868_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f4, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

test_data(specialization868,specialization,specialization868_b, true).


% ---------------
spl_db( specialization869_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f6 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( specialization869_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization869,specialization,specialization869_b, true).


% ---------------
spl_db( specialization870_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( specialization870_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f7 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(specialization870,specialization,specialization870_b, false).


% ---------------
spl_db( specialization871_a,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f8, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

spl_db( specialization871_b,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f8, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f9 , f2 ), requires( f1 , f9 ) ]
		)
	)
).

test_data(specialization871,specialization,specialization871_b, false).


% ---------------
spl_db( specialization872_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization872_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization872,specialization,specialization872_b, false).


% ---------------
spl_db( specialization873_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

spl_db( specialization873_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ), requires( f4 , f8 ), requires( f8 , f3 ) ]
		)
	)
).

test_data(specialization873,specialization,specialization873_b, false).


% ---------------
spl_db( specialization874_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

spl_db( specialization874_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization874,specialization,specialization874_b, true).


% ---------------
spl_db( specialization875_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization875_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(specialization875,specialization,specialization875_b, false).


% ---------------
spl_db( specialization876_a,
	 spl( [ root, f1, f5, f2, f9, f3, f4, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization876_b,
	 spl( [ root, f1, f5, f2, f9, f3, f4, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f4 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(specialization876,specialization,specialization876_b, false).


% ---------------
spl_db( specialization877_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

spl_db( specialization877_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f3 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization877,specialization,specialization877_b, false).


% ---------------
spl_db( specialization878_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), excludes( f1 , f4 ) ]
		)
	)
).

spl_db( specialization878_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization878,specialization,specialization878_b, true).


% ---------------
spl_db( specialization879_a,
	 spl( [ root, f1, f7, f2, f3, f4, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization879_b,
	 spl( [ root, f1, f7, f2, f3, f4, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f7 , f2 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization879,specialization,specialization879_b, false).


% ---------------
spl_db( specialization880_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

spl_db( specialization880_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization880,specialization,specialization880_b, true).


% ---------------
spl_db( specialization881_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization881_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization881,specialization,specialization881_b, false).


% ---------------
spl_db( specialization882_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

spl_db( specialization882_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f5 ), excludes( f3 , f8 ) ]
		)
	)
).

test_data(specialization882,specialization,specialization882_b, false).


% ---------------
spl_db( specialization883_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( specialization883_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization883,specialization,specialization883_b, true).


% ---------------
spl_db( specialization884_a,
	 spl( [ root, f1, f3, f2, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [
					mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization884_b,
	 spl( [ root, f1, f3, f2, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [
					mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f5 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization884,specialization,specialization884_b, false).


% ---------------
spl_db( specialization885_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization885_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization885,specialization,specialization885_b, true).


% ---------------
spl_db( specialization886_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f2 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization886_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(specialization886,specialization,specialization886_b, true).


% ---------------
spl_db( specialization887_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

spl_db( specialization887_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization887,specialization,specialization887_b, true).


% ---------------
spl_db( specialization888_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( specialization888_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(specialization888,specialization,specialization888_b, false).


% ---------------
spl_db( specialization889_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

spl_db( specialization889_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f7 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(specialization889,specialization,specialization889_b, false).


% ---------------
spl_db( specialization890_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f6 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( specialization890_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(specialization890,specialization,specialization890_b, true).


% ---------------
spl_db( specialization891_a,
	 spl( [ root, f1, f2, f5, f6, f8, f9, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization891_b,
	 spl( [ root, f1, f2, f5, f6, f8, f9, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization891,specialization,specialization891_b, false).


% ---------------
spl_db( specialization892_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

spl_db( specialization892_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), excludes( f6 , f4 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization892,specialization,specialization892_b, false).


% ---------------
spl_db( specialization893_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( specialization893_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(specialization893,specialization,specialization893_b, false).


% ---------------
spl_db( specialization894_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

spl_db( specialization894_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f6 , f4 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(specialization894,specialization,specialization894_b, false).


% ---------------
spl_db( specialization895_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

spl_db( specialization895_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f9 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(specialization895,specialization,specialization895_b, false).


% ---------------
spl_db( specialization896_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization896_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f5 , f4 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(specialization896,specialization,specialization896_b, false).


% ---------------
spl_db( specialization897_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f4 ), requires( f3 , f2 ) ]
		)
	)
).

spl_db( specialization897_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization897,specialization,specialization897_b, true).


% ---------------
spl_db( specialization898_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

spl_db( specialization898_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization898,specialization,specialization898_b, true).


% ---------------
spl_db( specialization899_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization899_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(specialization899,specialization,specialization899_b, false).


% ---------------
spl_db( specialization900_a,
	 spl( [ root, f1, f3, f6, f7, f4, f5, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( specialization900_b,
	 spl( [ root, f1, f3, f6, f7, f4, f5, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization900,specialization,specialization900_b, true).


% ---------------
spl_db( specialization901_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( specialization901_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization901,specialization,specialization901_b, true).


% ---------------
spl_db( specialization902_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ requires( f1 , f8 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( specialization902_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization902,specialization,specialization902_b, true).


% ---------------
spl_db( specialization903_a,
	 spl( [ root, f1, f3, f4, f6, f9, f7, f8, f5, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f3 , f4 ), requires( f8 , f9 ) ]
		)
	)
).

spl_db( specialization903_b,
	 spl( [ root, f1, f3, f4, f6, f9, f7, f8, f5, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization903,specialization,specialization903_b, true).


% ---------------
spl_db( specialization904_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization904_b,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f5 , f4 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(specialization904,specialization,specialization904_b, false).


% ---------------
spl_db( specialization905_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( specialization905_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), excludes( f1 , f4 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(specialization905,specialization,specialization905_b, false).


% ---------------
spl_db( specialization906_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization906_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(specialization906,specialization,specialization906_b, false).


% ---------------
spl_db( specialization907_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f5, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization907_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f5, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ) ] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(specialization907,specialization,specialization907_b, false).


% ---------------
spl_db( specialization908_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f9 ) ]
		)
	)
).

spl_db( specialization908_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(specialization908,specialization,specialization908_b, false).


% ---------------
spl_db( specialization909_a,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f1 , f5 ), excludes( f4 , f2 ) ]
		)
	)
).

spl_db( specialization909_b,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

test_data(specialization909,specialization,specialization909_b, true).


% ---------------
spl_db( specialization910_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization910_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(specialization910,specialization,specialization910_b, true).


% ---------------
spl_db( specialization911_a,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization911_b,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f6 , f1 ), excludes( f5 , f1 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(specialization911,specialization,specialization911_b, false).


% ---------------
spl_db( specialization912_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization912_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f6 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(specialization912,specialization,specialization912_b, false).


% ---------------
spl_db( specialization913_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f3, [] ), feature( f4, [
						mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f8 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( specialization913_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					one_or_more( [ feature( f3, [] ), feature( f4, [
						mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

test_data(specialization913,specialization,specialization913_b, true).


% ---------------
spl_db( specialization914_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( specialization914_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(specialization914,specialization,specialization914_b, true).


% ---------------
spl_db( specialization915_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f3 ) ]
		)
	)
).

spl_db( specialization915_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f3 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(specialization915,specialization,specialization915_b, false).


% ---------------
spl_db( specialization916_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

spl_db( specialization916_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization916,specialization,specialization916_b, true).


% ---------------
spl_db( specialization917_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization917_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization917,specialization,specialization917_b, false).


% ---------------
spl_db( specialization918_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization918_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

test_data(specialization918,specialization,specialization918_b, false).


% ---------------
spl_db( specialization919_a,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

spl_db( specialization919_b,
	 spl( [ root, f1, f2, f9, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization919,specialization,specialization919_b, true).


% ---------------
spl_db( specialization920_a,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization920_b,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f7 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(specialization920,specialization,specialization920_b, false).


% ---------------
spl_db( specialization921_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f2 , f1 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( specialization921_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(specialization921,specialization,specialization921_b, true).


% ---------------
spl_db( specialization922_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

spl_db( specialization922_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f4 , f9 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(specialization922,specialization,specialization922_b, false).


% ---------------
spl_db( specialization923_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

spl_db( specialization923_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization923,specialization,specialization923_b, true).


% ---------------
spl_db( specialization924_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

spl_db( specialization924_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f4 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(specialization924,specialization,specialization924_b, false).


% ---------------
spl_db( specialization925_a,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization925_b,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f1 ), requires( f2 , f5 ) ]
		)
	)
).

test_data(specialization925,specialization,specialization925_b, false).


% ---------------
spl_db( specialization926_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization926_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(specialization926,specialization,specialization926_b, false).


% ---------------
spl_db( specialization927_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization927_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(specialization927,specialization,specialization927_b, false).


% ---------------
spl_db( specialization928_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

spl_db( specialization928_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f8 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(specialization928,specialization,specialization928_b, false).


% ---------------
spl_db( specialization929_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

spl_db( specialization929_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f8 ), excludes( f1 , f5 ) ]
		)
	)
).

test_data(specialization929,specialization,specialization929_b, false).


% ---------------
spl_db( specialization930_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f8 ), requires( f9 , f1 ) ]
		)
	)
).

spl_db( specialization930_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization930,specialization,specialization930_b, true).


% ---------------
spl_db( specialization931_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( specialization931_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization931,specialization,specialization931_b, true).


% ---------------
spl_db( specialization932_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization932_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f9 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(specialization932,specialization,specialization932_b, false).


% ---------------
spl_db( specialization933_a,
	 spl( [ root, f1, f6, f7, f2, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f8 ), excludes( f1 , f8 ) ]
		)
	)
).

spl_db( specialization933_b,
	 spl( [ root, f1, f6, f7, f2, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(specialization933,specialization,specialization933_b, true).


% ---------------
spl_db( specialization934_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f2 ), excludes( f7 , f3 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization934_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization934,specialization,specialization934_b, true).


% ---------------
spl_db( specialization935_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization935_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(specialization935,specialization,specialization935_b, false).


% ---------------
spl_db( specialization936_a,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f5 , f6 ) ]
		)
	)
).

spl_db( specialization936_b,
	 spl( [ root, f1, f4, f5, f6, f7, f9, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization936,specialization,specialization936_b, true).


% ---------------
spl_db( specialization937_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization937_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization937,specialization,specialization937_b, true).


% ---------------
spl_db( specialization938_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

spl_db( specialization938_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f2 , f1 ), requires( f9 , f5 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(specialization938,specialization,specialization938_b, false).


% ---------------
spl_db( specialization939_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( specialization939_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization939,specialization,specialization939_b, true).


% ---------------
spl_db( specialization940_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f4 , f1 ), excludes( f9 , f3 ), requires( f1 , f7 ) ]
		)
	)
).

spl_db( specialization940_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization940,specialization,specialization940_b, true).


% ---------------
spl_db( specialization941_a,
	 spl( [ root, f1, f4, f8, f5, f6, f9, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f3 , f8 ), requires( f9 , f3 ) ]
		)
	)
).

spl_db( specialization941_b,
	 spl( [ root, f1, f4, f8, f5, f6, f9, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(specialization941,specialization,specialization941_b, true).


% ---------------
spl_db( specialization942_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization942_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f6 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(specialization942,specialization,specialization942_b, false).


% ---------------
spl_db( specialization943_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization943_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f3 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(specialization943,specialization,specialization943_b, false).


% ---------------
spl_db( specialization944_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f2 , f3 ), excludes( f2 , f7 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( specialization944_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization944,specialization,specialization944_b, true).


% ---------------
spl_db( specialization945_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

spl_db( specialization945_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f4 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization945,specialization,specialization945_b, false).


% ---------------
spl_db( specialization946_a,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f5 ), requires( f7 , f3 ) ]
		)
	)
).

spl_db( specialization946_b,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization946,specialization,specialization946_b, true).


% ---------------
spl_db( specialization947_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f2 , f4 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization947_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization947,specialization,specialization947_b, true).


% ---------------
spl_db( specialization948_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( specialization948_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), excludes( f2 , f8 ) ]
		)
	)
).

test_data(specialization948,specialization,specialization948_b, false).


% ---------------
spl_db( specialization949_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( specialization949_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f6 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(specialization949,specialization,specialization949_b, false).


% ---------------
spl_db( specialization950_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization950_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(specialization950,specialization,specialization950_b, false).


% ---------------
spl_db( specialization951_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization951_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f4 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(specialization951,specialization,specialization951_b, false).


% ---------------
spl_db( specialization952_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization952_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f4 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(specialization952,specialization,specialization952_b, false).


% ---------------
spl_db( specialization953_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

spl_db( specialization953_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization953,specialization,specialization953_b, true).


% ---------------
spl_db( specialization954_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

spl_db( specialization954_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization954,specialization,specialization954_b, true).


% ---------------
spl_db( specialization955_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( specialization955_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization955,specialization,specialization955_b, true).


% ---------------
spl_db( specialization956_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

spl_db( specialization956_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization956,specialization,specialization956_b, true).


% ---------------
spl_db( specialization957_a,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [
					optional( feature( f7, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization957_b,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f6, [
					optional( feature( f7, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f9 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(specialization957,specialization,specialization957_b, false).


% ---------------
spl_db( specialization958_a,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization958_b,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(specialization958,specialization,specialization958_b, false).


% ---------------
spl_db( specialization959_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f1 ), requires( f7 , f8 ) ]
		)
	)
).

spl_db( specialization959_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization959,specialization,specialization959_b, true).


% ---------------
spl_db( specialization960_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( specialization960_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(specialization960,specialization,specialization960_b, false).


% ---------------
spl_db( specialization961_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ), requires( f9 , f5 ), excludes( f8 , f2 ) ]
		)
	)
).

spl_db( specialization961_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization961,specialization,specialization961_b, true).


% ---------------
spl_db( specialization962_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ), requires( f6 , f4 ) ]
		)
	)
).

spl_db( specialization962_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(specialization962,specialization,specialization962_b, true).


% ---------------
spl_db( specialization963_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

spl_db( specialization963_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization963,specialization,specialization963_b, true).


% ---------------
spl_db( specialization964_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f3 , f6 ), excludes( f6 , f1 ) ]
		)
	)
).

spl_db( specialization964_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization964,specialization,specialization964_b, true).


% ---------------
spl_db( specialization965_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f4 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( specialization965_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f4 ) ]
		)
	)
).

test_data(specialization965,specialization,specialization965_b, true).


% ---------------
spl_db( specialization966_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f5 , f4 ) ]
		)
	)
).

spl_db( specialization966_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization966,specialization,specialization966_b, true).


% ---------------
spl_db( specialization967_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization967_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(specialization967,specialization,specialization967_b, false).


% ---------------
spl_db( specialization968_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( specialization968_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), excludes( f3 , f8 ) ]
		)
	)
).

test_data(specialization968,specialization,specialization968_b, false).


% ---------------
spl_db( specialization969_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( specialization969_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(specialization969,specialization,specialization969_b, true).


% ---------------
spl_db( specialization970_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f3 , f7 ) ]
		)
	)
).

spl_db( specialization970_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(specialization970,specialization,specialization970_b, true).


% ---------------
spl_db( specialization971_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

spl_db( specialization971_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization971,specialization,specialization971_b, true).


% ---------------
spl_db( specialization972_a,
	 spl( [ root, f1, f5, f8, f6, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

spl_db( specialization972_b,
	 spl( [ root, f1, f5, f8, f6, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization972,specialization,specialization972_b, true).


% ---------------
spl_db( specialization973_a,
	 spl( [ root, f1, f4, f5, f7, f8, f6, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f2 ), requires( f2 , f8 ) ]
		)
	)
).

spl_db( specialization973_b,
	 spl( [ root, f1, f4, f5, f7, f8, f6, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization973,specialization,specialization973_b, true).


% ---------------
spl_db( specialization974_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f6 , f5 ), requires( f1 , f2 ) ]
		)
	)
).

spl_db( specialization974_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization974,specialization,specialization974_b, true).


% ---------------
spl_db( specialization975_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f3 ), requires( f6 , f8 ) ]
		)
	)
).

spl_db( specialization975_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(specialization975,specialization,specialization975_b, true).


% ---------------
spl_db( specialization976_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( specialization976_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization976,specialization,specialization976_b, true).


% ---------------
spl_db( specialization977_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

spl_db( specialization977_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ), requires( f2 , f8 ), excludes( f3 , f4 ) ]
		)
	)
).

test_data(specialization977,specialization,specialization977_b, false).


% ---------------
spl_db( specialization978_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

spl_db( specialization978_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ), requires( f1 , f9 ) ]
		)
	)
).

test_data(specialization978,specialization,specialization978_b, false).


% ---------------
spl_db( specialization979_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ), excludes( f1 , f3 ) ]
		)
	)
).

spl_db( specialization979_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization979,specialization,specialization979_b, true).


% ---------------
spl_db( specialization980_a,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f3 ), requires( f8 , f2 ) ]
		)
	)
).

spl_db( specialization980_b,
	 spl( [ root, f1, f4, f9, f5, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization980,specialization,specialization980_b, true).


% ---------------
spl_db( specialization981_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f9 , f3 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( specialization981_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(specialization981,specialization,specialization981_b, true).


% ---------------
spl_db( specialization982_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f4 ), excludes( f4 , f2 ) ]
		)
	)
).

spl_db( specialization982_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization982,specialization,specialization982_b, true).


% ---------------
spl_db( specialization983_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( specialization983_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization983,specialization,specialization983_b, true).


% ---------------
spl_db( specialization984_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), excludes( f9 , f1 ) ]
		)
	)
).

spl_db( specialization984_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

test_data(specialization984,specialization,specialization984_b, true).


% ---------------
spl_db( specialization985_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( specialization985_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(specialization985,specialization,specialization985_b, false).


% ---------------
spl_db( specialization986_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( specialization986_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(specialization986,specialization,specialization986_b, false).


% ---------------
spl_db( specialization987_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization987_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f4 , f8 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(specialization987,specialization,specialization987_b, false).


% ---------------
spl_db( specialization988_a,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f9 , f7 ), requires( f8 , f1 ) ]
		)
	)
).

spl_db( specialization988_b,
	 spl( [ root, f1, f2, f7, f3, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization988,specialization,specialization988_b, true).


% ---------------
spl_db( specialization989_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), requires( f1 , f2 ) ]
		)
	)
).

spl_db( specialization989_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization989,specialization,specialization989_b, true).


% ---------------
spl_db( specialization990_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( specialization990_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
						optional( feature( f7, [] ) ), mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(specialization990,specialization,specialization990_b, false).


% ---------------
spl_db( specialization991_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f5 ), excludes( f5 , f3 ) ]
		)
	)
).

spl_db( specialization991_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(specialization991,specialization,specialization991_b, true).


% ---------------
spl_db( specialization992_a,
	 spl( [ root, f1, f4, f9, f5, f8, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

spl_db( specialization992_b,
	 spl( [ root, f1, f4, f9, f5, f8, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization992,specialization,specialization992_b, true).


% ---------------
spl_db( specialization993_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f2 ), excludes( f9 , f1 ) ]
		)
	)
).

spl_db( specialization993_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization993,specialization,specialization993_b, true).


% ---------------
spl_db( specialization994_a,
	 spl( [ root, f1, f3, f4, f8, f9, f5, f6, f7, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

spl_db( specialization994_b,
	 spl( [ root, f1, f3, f4, f8, f9, f5, f6, f7, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f4, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization994,specialization,specialization994_b, true).


% ---------------
spl_db( specialization995_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f9 ), excludes( f7 , f9 ) ]
		)
	)
).

spl_db( specialization995_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(specialization995,specialization,specialization995_b, true).


% ---------------
spl_db( specialization996_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( specialization996_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f6 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(specialization996,specialization,specialization996_b, false).


% ---------------
spl_db( specialization997_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

spl_db( specialization997_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ),
 [ requires( f9 , f8 ), requires( f1 , f2 ) ]
		)
	)
).

test_data(specialization997,specialization,specialization997_b, false).


% ---------------
spl_db( specialization998_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f7 ), excludes( f8 , f1 ) ]
		)
	)
).

spl_db( specialization998_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(specialization998,specialization,specialization998_b, true).


% ---------------
spl_db( specialization999_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

spl_db( specialization999_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(specialization999,specialization,specialization999_b, false).


% --------------- Test cases % ---------------
:- begin_tests(specialization).
test(specialization0) :-
	spl_db( specialization0_a, Spl1 ),
	test_data( specialization0, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization1) :-
	spl_db( specialization1_a, Spl1 ),
	test_data( specialization1, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization2) :-
	spl_db( specialization2_a, Spl1 ),
	test_data( specialization2, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization3) :-
	spl_db( specialization3_a, Spl1 ),
	test_data( specialization3, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization4) :-
	spl_db( specialization4_a, Spl1 ),
	test_data( specialization4, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization5) :-
	spl_db( specialization5_a, Spl1 ),
	test_data( specialization5, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization6) :-
	spl_db( specialization6_a, Spl1 ),
	test_data( specialization6, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization7) :-
	spl_db( specialization7_a, Spl1 ),
	test_data( specialization7, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization8) :-
	spl_db( specialization8_a, Spl1 ),
	test_data( specialization8, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization9) :-
	spl_db( specialization9_a, Spl1 ),
	test_data( specialization9, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization10) :-
	spl_db( specialization10_a, Spl1 ),
	test_data( specialization10, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization11) :-
	spl_db( specialization11_a, Spl1 ),
	test_data( specialization11, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization12) :-
	spl_db( specialization12_a, Spl1 ),
	test_data( specialization12, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization13) :-
	spl_db( specialization13_a, Spl1 ),
	test_data( specialization13, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization14) :-
	spl_db( specialization14_a, Spl1 ),
	test_data( specialization14, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization15) :-
	spl_db( specialization15_a, Spl1 ),
	test_data( specialization15, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization16) :-
	spl_db( specialization16_a, Spl1 ),
	test_data( specialization16, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization17) :-
	spl_db( specialization17_a, Spl1 ),
	test_data( specialization17, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization18) :-
	spl_db( specialization18_a, Spl1 ),
	test_data( specialization18, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization19) :-
	spl_db( specialization19_a, Spl1 ),
	test_data( specialization19, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization20) :-
	spl_db( specialization20_a, Spl1 ),
	test_data( specialization20, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization21) :-
	spl_db( specialization21_a, Spl1 ),
	test_data( specialization21, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization22) :-
	spl_db( specialization22_a, Spl1 ),
	test_data( specialization22, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization23) :-
	spl_db( specialization23_a, Spl1 ),
	test_data( specialization23, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization24) :-
	spl_db( specialization24_a, Spl1 ),
	test_data( specialization24, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization25) :-
	spl_db( specialization25_a, Spl1 ),
	test_data( specialization25, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization26) :-
	spl_db( specialization26_a, Spl1 ),
	test_data( specialization26, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization27) :-
	spl_db( specialization27_a, Spl1 ),
	test_data( specialization27, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization28) :-
	spl_db( specialization28_a, Spl1 ),
	test_data( specialization28, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization29) :-
	spl_db( specialization29_a, Spl1 ),
	test_data( specialization29, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization30) :-
	spl_db( specialization30_a, Spl1 ),
	test_data( specialization30, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization31) :-
	spl_db( specialization31_a, Spl1 ),
	test_data( specialization31, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization32) :-
	spl_db( specialization32_a, Spl1 ),
	test_data( specialization32, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization33) :-
	spl_db( specialization33_a, Spl1 ),
	test_data( specialization33, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization34) :-
	spl_db( specialization34_a, Spl1 ),
	test_data( specialization34, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization35) :-
	spl_db( specialization35_a, Spl1 ),
	test_data( specialization35, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization36) :-
	spl_db( specialization36_a, Spl1 ),
	test_data( specialization36, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization37) :-
	spl_db( specialization37_a, Spl1 ),
	test_data( specialization37, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization38) :-
	spl_db( specialization38_a, Spl1 ),
	test_data( specialization38, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization39) :-
	spl_db( specialization39_a, Spl1 ),
	test_data( specialization39, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization40) :-
	spl_db( specialization40_a, Spl1 ),
	test_data( specialization40, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization41) :-
	spl_db( specialization41_a, Spl1 ),
	test_data( specialization41, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization42) :-
	spl_db( specialization42_a, Spl1 ),
	test_data( specialization42, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization43) :-
	spl_db( specialization43_a, Spl1 ),
	test_data( specialization43, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization44) :-
	spl_db( specialization44_a, Spl1 ),
	test_data( specialization44, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization45) :-
	spl_db( specialization45_a, Spl1 ),
	test_data( specialization45, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization46) :-
	spl_db( specialization46_a, Spl1 ),
	test_data( specialization46, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization47) :-
	spl_db( specialization47_a, Spl1 ),
	test_data( specialization47, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization48) :-
	spl_db( specialization48_a, Spl1 ),
	test_data( specialization48, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization49) :-
	spl_db( specialization49_a, Spl1 ),
	test_data( specialization49, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization50) :-
	spl_db( specialization50_a, Spl1 ),
	test_data( specialization50, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization51) :-
	spl_db( specialization51_a, Spl1 ),
	test_data( specialization51, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization52) :-
	spl_db( specialization52_a, Spl1 ),
	test_data( specialization52, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization53) :-
	spl_db( specialization53_a, Spl1 ),
	test_data( specialization53, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization54) :-
	spl_db( specialization54_a, Spl1 ),
	test_data( specialization54, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization55) :-
	spl_db( specialization55_a, Spl1 ),
	test_data( specialization55, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization56) :-
	spl_db( specialization56_a, Spl1 ),
	test_data( specialization56, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization57) :-
	spl_db( specialization57_a, Spl1 ),
	test_data( specialization57, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization58) :-
	spl_db( specialization58_a, Spl1 ),
	test_data( specialization58, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization59) :-
	spl_db( specialization59_a, Spl1 ),
	test_data( specialization59, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization60) :-
	spl_db( specialization60_a, Spl1 ),
	test_data( specialization60, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization61) :-
	spl_db( specialization61_a, Spl1 ),
	test_data( specialization61, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization62) :-
	spl_db( specialization62_a, Spl1 ),
	test_data( specialization62, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization63) :-
	spl_db( specialization63_a, Spl1 ),
	test_data( specialization63, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization64) :-
	spl_db( specialization64_a, Spl1 ),
	test_data( specialization64, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization65) :-
	spl_db( specialization65_a, Spl1 ),
	test_data( specialization65, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization66) :-
	spl_db( specialization66_a, Spl1 ),
	test_data( specialization66, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization67) :-
	spl_db( specialization67_a, Spl1 ),
	test_data( specialization67, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization68) :-
	spl_db( specialization68_a, Spl1 ),
	test_data( specialization68, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization69) :-
	spl_db( specialization69_a, Spl1 ),
	test_data( specialization69, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization70) :-
	spl_db( specialization70_a, Spl1 ),
	test_data( specialization70, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization71) :-
	spl_db( specialization71_a, Spl1 ),
	test_data( specialization71, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization72) :-
	spl_db( specialization72_a, Spl1 ),
	test_data( specialization72, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization73) :-
	spl_db( specialization73_a, Spl1 ),
	test_data( specialization73, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization74) :-
	spl_db( specialization74_a, Spl1 ),
	test_data( specialization74, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization75) :-
	spl_db( specialization75_a, Spl1 ),
	test_data( specialization75, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization76) :-
	spl_db( specialization76_a, Spl1 ),
	test_data( specialization76, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization77) :-
	spl_db( specialization77_a, Spl1 ),
	test_data( specialization77, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization78) :-
	spl_db( specialization78_a, Spl1 ),
	test_data( specialization78, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization79) :-
	spl_db( specialization79_a, Spl1 ),
	test_data( specialization79, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization80) :-
	spl_db( specialization80_a, Spl1 ),
	test_data( specialization80, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization81) :-
	spl_db( specialization81_a, Spl1 ),
	test_data( specialization81, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization82) :-
	spl_db( specialization82_a, Spl1 ),
	test_data( specialization82, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization83) :-
	spl_db( specialization83_a, Spl1 ),
	test_data( specialization83, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization84) :-
	spl_db( specialization84_a, Spl1 ),
	test_data( specialization84, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization85) :-
	spl_db( specialization85_a, Spl1 ),
	test_data( specialization85, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization86) :-
	spl_db( specialization86_a, Spl1 ),
	test_data( specialization86, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization87) :-
	spl_db( specialization87_a, Spl1 ),
	test_data( specialization87, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization88) :-
	spl_db( specialization88_a, Spl1 ),
	test_data( specialization88, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization89) :-
	spl_db( specialization89_a, Spl1 ),
	test_data( specialization89, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization90) :-
	spl_db( specialization90_a, Spl1 ),
	test_data( specialization90, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization91) :-
	spl_db( specialization91_a, Spl1 ),
	test_data( specialization91, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization92) :-
	spl_db( specialization92_a, Spl1 ),
	test_data( specialization92, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization93) :-
	spl_db( specialization93_a, Spl1 ),
	test_data( specialization93, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization94) :-
	spl_db( specialization94_a, Spl1 ),
	test_data( specialization94, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization95) :-
	spl_db( specialization95_a, Spl1 ),
	test_data( specialization95, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization96) :-
	spl_db( specialization96_a, Spl1 ),
	test_data( specialization96, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization97) :-
	spl_db( specialization97_a, Spl1 ),
	test_data( specialization97, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization98) :-
	spl_db( specialization98_a, Spl1 ),
	test_data( specialization98, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization99) :-
	spl_db( specialization99_a, Spl1 ),
	test_data( specialization99, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization100) :-
	spl_db( specialization100_a, Spl1 ),
	test_data( specialization100, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization101) :-
	spl_db( specialization101_a, Spl1 ),
	test_data( specialization101, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization102) :-
	spl_db( specialization102_a, Spl1 ),
	test_data( specialization102, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization103) :-
	spl_db( specialization103_a, Spl1 ),
	test_data( specialization103, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization104) :-
	spl_db( specialization104_a, Spl1 ),
	test_data( specialization104, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization105) :-
	spl_db( specialization105_a, Spl1 ),
	test_data( specialization105, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization106) :-
	spl_db( specialization106_a, Spl1 ),
	test_data( specialization106, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization107) :-
	spl_db( specialization107_a, Spl1 ),
	test_data( specialization107, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization108) :-
	spl_db( specialization108_a, Spl1 ),
	test_data( specialization108, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization109) :-
	spl_db( specialization109_a, Spl1 ),
	test_data( specialization109, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization110) :-
	spl_db( specialization110_a, Spl1 ),
	test_data( specialization110, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization111) :-
	spl_db( specialization111_a, Spl1 ),
	test_data( specialization111, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization112) :-
	spl_db( specialization112_a, Spl1 ),
	test_data( specialization112, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization113) :-
	spl_db( specialization113_a, Spl1 ),
	test_data( specialization113, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization114) :-
	spl_db( specialization114_a, Spl1 ),
	test_data( specialization114, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization115) :-
	spl_db( specialization115_a, Spl1 ),
	test_data( specialization115, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization116) :-
	spl_db( specialization116_a, Spl1 ),
	test_data( specialization116, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization117) :-
	spl_db( specialization117_a, Spl1 ),
	test_data( specialization117, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization118) :-
	spl_db( specialization118_a, Spl1 ),
	test_data( specialization118, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization119) :-
	spl_db( specialization119_a, Spl1 ),
	test_data( specialization119, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization120) :-
	spl_db( specialization120_a, Spl1 ),
	test_data( specialization120, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization121) :-
	spl_db( specialization121_a, Spl1 ),
	test_data( specialization121, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization122) :-
	spl_db( specialization122_a, Spl1 ),
	test_data( specialization122, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization123) :-
	spl_db( specialization123_a, Spl1 ),
	test_data( specialization123, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization124) :-
	spl_db( specialization124_a, Spl1 ),
	test_data( specialization124, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization125) :-
	spl_db( specialization125_a, Spl1 ),
	test_data( specialization125, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization126) :-
	spl_db( specialization126_a, Spl1 ),
	test_data( specialization126, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization127) :-
	spl_db( specialization127_a, Spl1 ),
	test_data( specialization127, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization128) :-
	spl_db( specialization128_a, Spl1 ),
	test_data( specialization128, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization129) :-
	spl_db( specialization129_a, Spl1 ),
	test_data( specialization129, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization130) :-
	spl_db( specialization130_a, Spl1 ),
	test_data( specialization130, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization131) :-
	spl_db( specialization131_a, Spl1 ),
	test_data( specialization131, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization132) :-
	spl_db( specialization132_a, Spl1 ),
	test_data( specialization132, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization133) :-
	spl_db( specialization133_a, Spl1 ),
	test_data( specialization133, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization134) :-
	spl_db( specialization134_a, Spl1 ),
	test_data( specialization134, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization135) :-
	spl_db( specialization135_a, Spl1 ),
	test_data( specialization135, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization136) :-
	spl_db( specialization136_a, Spl1 ),
	test_data( specialization136, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization137) :-
	spl_db( specialization137_a, Spl1 ),
	test_data( specialization137, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization138) :-
	spl_db( specialization138_a, Spl1 ),
	test_data( specialization138, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization139) :-
	spl_db( specialization139_a, Spl1 ),
	test_data( specialization139, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization140) :-
	spl_db( specialization140_a, Spl1 ),
	test_data( specialization140, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization141) :-
	spl_db( specialization141_a, Spl1 ),
	test_data( specialization141, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization142) :-
	spl_db( specialization142_a, Spl1 ),
	test_data( specialization142, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization143) :-
	spl_db( specialization143_a, Spl1 ),
	test_data( specialization143, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization144) :-
	spl_db( specialization144_a, Spl1 ),
	test_data( specialization144, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization145) :-
	spl_db( specialization145_a, Spl1 ),
	test_data( specialization145, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization146) :-
	spl_db( specialization146_a, Spl1 ),
	test_data( specialization146, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization147) :-
	spl_db( specialization147_a, Spl1 ),
	test_data( specialization147, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization148) :-
	spl_db( specialization148_a, Spl1 ),
	test_data( specialization148, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization149) :-
	spl_db( specialization149_a, Spl1 ),
	test_data( specialization149, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization150) :-
	spl_db( specialization150_a, Spl1 ),
	test_data( specialization150, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization151) :-
	spl_db( specialization151_a, Spl1 ),
	test_data( specialization151, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization152) :-
	spl_db( specialization152_a, Spl1 ),
	test_data( specialization152, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization153) :-
	spl_db( specialization153_a, Spl1 ),
	test_data( specialization153, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization154) :-
	spl_db( specialization154_a, Spl1 ),
	test_data( specialization154, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization155) :-
	spl_db( specialization155_a, Spl1 ),
	test_data( specialization155, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization156) :-
	spl_db( specialization156_a, Spl1 ),
	test_data( specialization156, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization157) :-
	spl_db( specialization157_a, Spl1 ),
	test_data( specialization157, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization158) :-
	spl_db( specialization158_a, Spl1 ),
	test_data( specialization158, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization159) :-
	spl_db( specialization159_a, Spl1 ),
	test_data( specialization159, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization160) :-
	spl_db( specialization160_a, Spl1 ),
	test_data( specialization160, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization161) :-
	spl_db( specialization161_a, Spl1 ),
	test_data( specialization161, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization162) :-
	spl_db( specialization162_a, Spl1 ),
	test_data( specialization162, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization163) :-
	spl_db( specialization163_a, Spl1 ),
	test_data( specialization163, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization164) :-
	spl_db( specialization164_a, Spl1 ),
	test_data( specialization164, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization165) :-
	spl_db( specialization165_a, Spl1 ),
	test_data( specialization165, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization166) :-
	spl_db( specialization166_a, Spl1 ),
	test_data( specialization166, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization167) :-
	spl_db( specialization167_a, Spl1 ),
	test_data( specialization167, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization168) :-
	spl_db( specialization168_a, Spl1 ),
	test_data( specialization168, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization169) :-
	spl_db( specialization169_a, Spl1 ),
	test_data( specialization169, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization170) :-
	spl_db( specialization170_a, Spl1 ),
	test_data( specialization170, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization171) :-
	spl_db( specialization171_a, Spl1 ),
	test_data( specialization171, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization172) :-
	spl_db( specialization172_a, Spl1 ),
	test_data( specialization172, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization173) :-
	spl_db( specialization173_a, Spl1 ),
	test_data( specialization173, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization174) :-
	spl_db( specialization174_a, Spl1 ),
	test_data( specialization174, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization175) :-
	spl_db( specialization175_a, Spl1 ),
	test_data( specialization175, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization176) :-
	spl_db( specialization176_a, Spl1 ),
	test_data( specialization176, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization177) :-
	spl_db( specialization177_a, Spl1 ),
	test_data( specialization177, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization178) :-
	spl_db( specialization178_a, Spl1 ),
	test_data( specialization178, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization179) :-
	spl_db( specialization179_a, Spl1 ),
	test_data( specialization179, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization180) :-
	spl_db( specialization180_a, Spl1 ),
	test_data( specialization180, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization181) :-
	spl_db( specialization181_a, Spl1 ),
	test_data( specialization181, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization182) :-
	spl_db( specialization182_a, Spl1 ),
	test_data( specialization182, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization183) :-
	spl_db( specialization183_a, Spl1 ),
	test_data( specialization183, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization184) :-
	spl_db( specialization184_a, Spl1 ),
	test_data( specialization184, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization185) :-
	spl_db( specialization185_a, Spl1 ),
	test_data( specialization185, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization186) :-
	spl_db( specialization186_a, Spl1 ),
	test_data( specialization186, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization187) :-
	spl_db( specialization187_a, Spl1 ),
	test_data( specialization187, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization188) :-
	spl_db( specialization188_a, Spl1 ),
	test_data( specialization188, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization189) :-
	spl_db( specialization189_a, Spl1 ),
	test_data( specialization189, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization190) :-
	spl_db( specialization190_a, Spl1 ),
	test_data( specialization190, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization191) :-
	spl_db( specialization191_a, Spl1 ),
	test_data( specialization191, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization192) :-
	spl_db( specialization192_a, Spl1 ),
	test_data( specialization192, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization193) :-
	spl_db( specialization193_a, Spl1 ),
	test_data( specialization193, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization194) :-
	spl_db( specialization194_a, Spl1 ),
	test_data( specialization194, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization195) :-
	spl_db( specialization195_a, Spl1 ),
	test_data( specialization195, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization196) :-
	spl_db( specialization196_a, Spl1 ),
	test_data( specialization196, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization197) :-
	spl_db( specialization197_a, Spl1 ),
	test_data( specialization197, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization198) :-
	spl_db( specialization198_a, Spl1 ),
	test_data( specialization198, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization199) :-
	spl_db( specialization199_a, Spl1 ),
	test_data( specialization199, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization200) :-
	spl_db( specialization200_a, Spl1 ),
	test_data( specialization200, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization201) :-
	spl_db( specialization201_a, Spl1 ),
	test_data( specialization201, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization202) :-
	spl_db( specialization202_a, Spl1 ),
	test_data( specialization202, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization203) :-
	spl_db( specialization203_a, Spl1 ),
	test_data( specialization203, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization204) :-
	spl_db( specialization204_a, Spl1 ),
	test_data( specialization204, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization205) :-
	spl_db( specialization205_a, Spl1 ),
	test_data( specialization205, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization206) :-
	spl_db( specialization206_a, Spl1 ),
	test_data( specialization206, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization207) :-
	spl_db( specialization207_a, Spl1 ),
	test_data( specialization207, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization208) :-
	spl_db( specialization208_a, Spl1 ),
	test_data( specialization208, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization209) :-
	spl_db( specialization209_a, Spl1 ),
	test_data( specialization209, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization210) :-
	spl_db( specialization210_a, Spl1 ),
	test_data( specialization210, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization211) :-
	spl_db( specialization211_a, Spl1 ),
	test_data( specialization211, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization212) :-
	spl_db( specialization212_a, Spl1 ),
	test_data( specialization212, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization213) :-
	spl_db( specialization213_a, Spl1 ),
	test_data( specialization213, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization214) :-
	spl_db( specialization214_a, Spl1 ),
	test_data( specialization214, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization215) :-
	spl_db( specialization215_a, Spl1 ),
	test_data( specialization215, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization216) :-
	spl_db( specialization216_a, Spl1 ),
	test_data( specialization216, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization217) :-
	spl_db( specialization217_a, Spl1 ),
	test_data( specialization217, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization218) :-
	spl_db( specialization218_a, Spl1 ),
	test_data( specialization218, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization219) :-
	spl_db( specialization219_a, Spl1 ),
	test_data( specialization219, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization220) :-
	spl_db( specialization220_a, Spl1 ),
	test_data( specialization220, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization221) :-
	spl_db( specialization221_a, Spl1 ),
	test_data( specialization221, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization222) :-
	spl_db( specialization222_a, Spl1 ),
	test_data( specialization222, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization223) :-
	spl_db( specialization223_a, Spl1 ),
	test_data( specialization223, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization224) :-
	spl_db( specialization224_a, Spl1 ),
	test_data( specialization224, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization225) :-
	spl_db( specialization225_a, Spl1 ),
	test_data( specialization225, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization226) :-
	spl_db( specialization226_a, Spl1 ),
	test_data( specialization226, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization227) :-
	spl_db( specialization227_a, Spl1 ),
	test_data( specialization227, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization228) :-
	spl_db( specialization228_a, Spl1 ),
	test_data( specialization228, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization229) :-
	spl_db( specialization229_a, Spl1 ),
	test_data( specialization229, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization230) :-
	spl_db( specialization230_a, Spl1 ),
	test_data( specialization230, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization231) :-
	spl_db( specialization231_a, Spl1 ),
	test_data( specialization231, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization232) :-
	spl_db( specialization232_a, Spl1 ),
	test_data( specialization232, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization233) :-
	spl_db( specialization233_a, Spl1 ),
	test_data( specialization233, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization234) :-
	spl_db( specialization234_a, Spl1 ),
	test_data( specialization234, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization235) :-
	spl_db( specialization235_a, Spl1 ),
	test_data( specialization235, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization236) :-
	spl_db( specialization236_a, Spl1 ),
	test_data( specialization236, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization237) :-
	spl_db( specialization237_a, Spl1 ),
	test_data( specialization237, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization238) :-
	spl_db( specialization238_a, Spl1 ),
	test_data( specialization238, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization239) :-
	spl_db( specialization239_a, Spl1 ),
	test_data( specialization239, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization240) :-
	spl_db( specialization240_a, Spl1 ),
	test_data( specialization240, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization241) :-
	spl_db( specialization241_a, Spl1 ),
	test_data( specialization241, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization242) :-
	spl_db( specialization242_a, Spl1 ),
	test_data( specialization242, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization243) :-
	spl_db( specialization243_a, Spl1 ),
	test_data( specialization243, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization244) :-
	spl_db( specialization244_a, Spl1 ),
	test_data( specialization244, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization245) :-
	spl_db( specialization245_a, Spl1 ),
	test_data( specialization245, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization246) :-
	spl_db( specialization246_a, Spl1 ),
	test_data( specialization246, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization247) :-
	spl_db( specialization247_a, Spl1 ),
	test_data( specialization247, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization248) :-
	spl_db( specialization248_a, Spl1 ),
	test_data( specialization248, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization249) :-
	spl_db( specialization249_a, Spl1 ),
	test_data( specialization249, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization250) :-
	spl_db( specialization250_a, Spl1 ),
	test_data( specialization250, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization251) :-
	spl_db( specialization251_a, Spl1 ),
	test_data( specialization251, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization252) :-
	spl_db( specialization252_a, Spl1 ),
	test_data( specialization252, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization253) :-
	spl_db( specialization253_a, Spl1 ),
	test_data( specialization253, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization254) :-
	spl_db( specialization254_a, Spl1 ),
	test_data( specialization254, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization255) :-
	spl_db( specialization255_a, Spl1 ),
	test_data( specialization255, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization256) :-
	spl_db( specialization256_a, Spl1 ),
	test_data( specialization256, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization257) :-
	spl_db( specialization257_a, Spl1 ),
	test_data( specialization257, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization258) :-
	spl_db( specialization258_a, Spl1 ),
	test_data( specialization258, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization259) :-
	spl_db( specialization259_a, Spl1 ),
	test_data( specialization259, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization260) :-
	spl_db( specialization260_a, Spl1 ),
	test_data( specialization260, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization261) :-
	spl_db( specialization261_a, Spl1 ),
	test_data( specialization261, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization262) :-
	spl_db( specialization262_a, Spl1 ),
	test_data( specialization262, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization263) :-
	spl_db( specialization263_a, Spl1 ),
	test_data( specialization263, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization264) :-
	spl_db( specialization264_a, Spl1 ),
	test_data( specialization264, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization265) :-
	spl_db( specialization265_a, Spl1 ),
	test_data( specialization265, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization266) :-
	spl_db( specialization266_a, Spl1 ),
	test_data( specialization266, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization267) :-
	spl_db( specialization267_a, Spl1 ),
	test_data( specialization267, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization268) :-
	spl_db( specialization268_a, Spl1 ),
	test_data( specialization268, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization269) :-
	spl_db( specialization269_a, Spl1 ),
	test_data( specialization269, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization270) :-
	spl_db( specialization270_a, Spl1 ),
	test_data( specialization270, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization271) :-
	spl_db( specialization271_a, Spl1 ),
	test_data( specialization271, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization272) :-
	spl_db( specialization272_a, Spl1 ),
	test_data( specialization272, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization273) :-
	spl_db( specialization273_a, Spl1 ),
	test_data( specialization273, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization274) :-
	spl_db( specialization274_a, Spl1 ),
	test_data( specialization274, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization275) :-
	spl_db( specialization275_a, Spl1 ),
	test_data( specialization275, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization276) :-
	spl_db( specialization276_a, Spl1 ),
	test_data( specialization276, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization277) :-
	spl_db( specialization277_a, Spl1 ),
	test_data( specialization277, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization278) :-
	spl_db( specialization278_a, Spl1 ),
	test_data( specialization278, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization279) :-
	spl_db( specialization279_a, Spl1 ),
	test_data( specialization279, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization280) :-
	spl_db( specialization280_a, Spl1 ),
	test_data( specialization280, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization281) :-
	spl_db( specialization281_a, Spl1 ),
	test_data( specialization281, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization282) :-
	spl_db( specialization282_a, Spl1 ),
	test_data( specialization282, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization283) :-
	spl_db( specialization283_a, Spl1 ),
	test_data( specialization283, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization284) :-
	spl_db( specialization284_a, Spl1 ),
	test_data( specialization284, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization285) :-
	spl_db( specialization285_a, Spl1 ),
	test_data( specialization285, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization286) :-
	spl_db( specialization286_a, Spl1 ),
	test_data( specialization286, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization287) :-
	spl_db( specialization287_a, Spl1 ),
	test_data( specialization287, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization288) :-
	spl_db( specialization288_a, Spl1 ),
	test_data( specialization288, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization289) :-
	spl_db( specialization289_a, Spl1 ),
	test_data( specialization289, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization290) :-
	spl_db( specialization290_a, Spl1 ),
	test_data( specialization290, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization291) :-
	spl_db( specialization291_a, Spl1 ),
	test_data( specialization291, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization292) :-
	spl_db( specialization292_a, Spl1 ),
	test_data( specialization292, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization293) :-
	spl_db( specialization293_a, Spl1 ),
	test_data( specialization293, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization294) :-
	spl_db( specialization294_a, Spl1 ),
	test_data( specialization294, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization295) :-
	spl_db( specialization295_a, Spl1 ),
	test_data( specialization295, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization296) :-
	spl_db( specialization296_a, Spl1 ),
	test_data( specialization296, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization297) :-
	spl_db( specialization297_a, Spl1 ),
	test_data( specialization297, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization298) :-
	spl_db( specialization298_a, Spl1 ),
	test_data( specialization298, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization299) :-
	spl_db( specialization299_a, Spl1 ),
	test_data( specialization299, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization300) :-
	spl_db( specialization300_a, Spl1 ),
	test_data( specialization300, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization301) :-
	spl_db( specialization301_a, Spl1 ),
	test_data( specialization301, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization302) :-
	spl_db( specialization302_a, Spl1 ),
	test_data( specialization302, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization303) :-
	spl_db( specialization303_a, Spl1 ),
	test_data( specialization303, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization304) :-
	spl_db( specialization304_a, Spl1 ),
	test_data( specialization304, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization305) :-
	spl_db( specialization305_a, Spl1 ),
	test_data( specialization305, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization306) :-
	spl_db( specialization306_a, Spl1 ),
	test_data( specialization306, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization307) :-
	spl_db( specialization307_a, Spl1 ),
	test_data( specialization307, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization308) :-
	spl_db( specialization308_a, Spl1 ),
	test_data( specialization308, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization309) :-
	spl_db( specialization309_a, Spl1 ),
	test_data( specialization309, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization310) :-
	spl_db( specialization310_a, Spl1 ),
	test_data( specialization310, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization311) :-
	spl_db( specialization311_a, Spl1 ),
	test_data( specialization311, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization312) :-
	spl_db( specialization312_a, Spl1 ),
	test_data( specialization312, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization313) :-
	spl_db( specialization313_a, Spl1 ),
	test_data( specialization313, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization314) :-
	spl_db( specialization314_a, Spl1 ),
	test_data( specialization314, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization315) :-
	spl_db( specialization315_a, Spl1 ),
	test_data( specialization315, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization316) :-
	spl_db( specialization316_a, Spl1 ),
	test_data( specialization316, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization317) :-
	spl_db( specialization317_a, Spl1 ),
	test_data( specialization317, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization318) :-
	spl_db( specialization318_a, Spl1 ),
	test_data( specialization318, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization319) :-
	spl_db( specialization319_a, Spl1 ),
	test_data( specialization319, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization320) :-
	spl_db( specialization320_a, Spl1 ),
	test_data( specialization320, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization321) :-
	spl_db( specialization321_a, Spl1 ),
	test_data( specialization321, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization322) :-
	spl_db( specialization322_a, Spl1 ),
	test_data( specialization322, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization323) :-
	spl_db( specialization323_a, Spl1 ),
	test_data( specialization323, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization324) :-
	spl_db( specialization324_a, Spl1 ),
	test_data( specialization324, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization325) :-
	spl_db( specialization325_a, Spl1 ),
	test_data( specialization325, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization326) :-
	spl_db( specialization326_a, Spl1 ),
	test_data( specialization326, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization327) :-
	spl_db( specialization327_a, Spl1 ),
	test_data( specialization327, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization328) :-
	spl_db( specialization328_a, Spl1 ),
	test_data( specialization328, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization329) :-
	spl_db( specialization329_a, Spl1 ),
	test_data( specialization329, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization330) :-
	spl_db( specialization330_a, Spl1 ),
	test_data( specialization330, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization331) :-
	spl_db( specialization331_a, Spl1 ),
	test_data( specialization331, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization332) :-
	spl_db( specialization332_a, Spl1 ),
	test_data( specialization332, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization333) :-
	spl_db( specialization333_a, Spl1 ),
	test_data( specialization333, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization334) :-
	spl_db( specialization334_a, Spl1 ),
	test_data( specialization334, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization335) :-
	spl_db( specialization335_a, Spl1 ),
	test_data( specialization335, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization336) :-
	spl_db( specialization336_a, Spl1 ),
	test_data( specialization336, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization337) :-
	spl_db( specialization337_a, Spl1 ),
	test_data( specialization337, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization338) :-
	spl_db( specialization338_a, Spl1 ),
	test_data( specialization338, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization339) :-
	spl_db( specialization339_a, Spl1 ),
	test_data( specialization339, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization340) :-
	spl_db( specialization340_a, Spl1 ),
	test_data( specialization340, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization341) :-
	spl_db( specialization341_a, Spl1 ),
	test_data( specialization341, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization342) :-
	spl_db( specialization342_a, Spl1 ),
	test_data( specialization342, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization343) :-
	spl_db( specialization343_a, Spl1 ),
	test_data( specialization343, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization344) :-
	spl_db( specialization344_a, Spl1 ),
	test_data( specialization344, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization345) :-
	spl_db( specialization345_a, Spl1 ),
	test_data( specialization345, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization346) :-
	spl_db( specialization346_a, Spl1 ),
	test_data( specialization346, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization347) :-
	spl_db( specialization347_a, Spl1 ),
	test_data( specialization347, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization348) :-
	spl_db( specialization348_a, Spl1 ),
	test_data( specialization348, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization349) :-
	spl_db( specialization349_a, Spl1 ),
	test_data( specialization349, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization350) :-
	spl_db( specialization350_a, Spl1 ),
	test_data( specialization350, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization351) :-
	spl_db( specialization351_a, Spl1 ),
	test_data( specialization351, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization352) :-
	spl_db( specialization352_a, Spl1 ),
	test_data( specialization352, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization353) :-
	spl_db( specialization353_a, Spl1 ),
	test_data( specialization353, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization354) :-
	spl_db( specialization354_a, Spl1 ),
	test_data( specialization354, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization355) :-
	spl_db( specialization355_a, Spl1 ),
	test_data( specialization355, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization356) :-
	spl_db( specialization356_a, Spl1 ),
	test_data( specialization356, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization357) :-
	spl_db( specialization357_a, Spl1 ),
	test_data( specialization357, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization358) :-
	spl_db( specialization358_a, Spl1 ),
	test_data( specialization358, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization359) :-
	spl_db( specialization359_a, Spl1 ),
	test_data( specialization359, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization360) :-
	spl_db( specialization360_a, Spl1 ),
	test_data( specialization360, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization361) :-
	spl_db( specialization361_a, Spl1 ),
	test_data( specialization361, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization362) :-
	spl_db( specialization362_a, Spl1 ),
	test_data( specialization362, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization363) :-
	spl_db( specialization363_a, Spl1 ),
	test_data( specialization363, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization364) :-
	spl_db( specialization364_a, Spl1 ),
	test_data( specialization364, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization365) :-
	spl_db( specialization365_a, Spl1 ),
	test_data( specialization365, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization366) :-
	spl_db( specialization366_a, Spl1 ),
	test_data( specialization366, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization367) :-
	spl_db( specialization367_a, Spl1 ),
	test_data( specialization367, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization368) :-
	spl_db( specialization368_a, Spl1 ),
	test_data( specialization368, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization369) :-
	spl_db( specialization369_a, Spl1 ),
	test_data( specialization369, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization370) :-
	spl_db( specialization370_a, Spl1 ),
	test_data( specialization370, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization371) :-
	spl_db( specialization371_a, Spl1 ),
	test_data( specialization371, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization372) :-
	spl_db( specialization372_a, Spl1 ),
	test_data( specialization372, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization373) :-
	spl_db( specialization373_a, Spl1 ),
	test_data( specialization373, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization374) :-
	spl_db( specialization374_a, Spl1 ),
	test_data( specialization374, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization375) :-
	spl_db( specialization375_a, Spl1 ),
	test_data( specialization375, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization376) :-
	spl_db( specialization376_a, Spl1 ),
	test_data( specialization376, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization377) :-
	spl_db( specialization377_a, Spl1 ),
	test_data( specialization377, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization378) :-
	spl_db( specialization378_a, Spl1 ),
	test_data( specialization378, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization379) :-
	spl_db( specialization379_a, Spl1 ),
	test_data( specialization379, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization380) :-
	spl_db( specialization380_a, Spl1 ),
	test_data( specialization380, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization381) :-
	spl_db( specialization381_a, Spl1 ),
	test_data( specialization381, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization382) :-
	spl_db( specialization382_a, Spl1 ),
	test_data( specialization382, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization383) :-
	spl_db( specialization383_a, Spl1 ),
	test_data( specialization383, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization384) :-
	spl_db( specialization384_a, Spl1 ),
	test_data( specialization384, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization385) :-
	spl_db( specialization385_a, Spl1 ),
	test_data( specialization385, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization386) :-
	spl_db( specialization386_a, Spl1 ),
	test_data( specialization386, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization387) :-
	spl_db( specialization387_a, Spl1 ),
	test_data( specialization387, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization388) :-
	spl_db( specialization388_a, Spl1 ),
	test_data( specialization388, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization389) :-
	spl_db( specialization389_a, Spl1 ),
	test_data( specialization389, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization390) :-
	spl_db( specialization390_a, Spl1 ),
	test_data( specialization390, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization391) :-
	spl_db( specialization391_a, Spl1 ),
	test_data( specialization391, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization392) :-
	spl_db( specialization392_a, Spl1 ),
	test_data( specialization392, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization393) :-
	spl_db( specialization393_a, Spl1 ),
	test_data( specialization393, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization394) :-
	spl_db( specialization394_a, Spl1 ),
	test_data( specialization394, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization395) :-
	spl_db( specialization395_a, Spl1 ),
	test_data( specialization395, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization396) :-
	spl_db( specialization396_a, Spl1 ),
	test_data( specialization396, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization397) :-
	spl_db( specialization397_a, Spl1 ),
	test_data( specialization397, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization398) :-
	spl_db( specialization398_a, Spl1 ),
	test_data( specialization398, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization399) :-
	spl_db( specialization399_a, Spl1 ),
	test_data( specialization399, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization400) :-
	spl_db( specialization400_a, Spl1 ),
	test_data( specialization400, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization401) :-
	spl_db( specialization401_a, Spl1 ),
	test_data( specialization401, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization402) :-
	spl_db( specialization402_a, Spl1 ),
	test_data( specialization402, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization403) :-
	spl_db( specialization403_a, Spl1 ),
	test_data( specialization403, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization404) :-
	spl_db( specialization404_a, Spl1 ),
	test_data( specialization404, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization405) :-
	spl_db( specialization405_a, Spl1 ),
	test_data( specialization405, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization406) :-
	spl_db( specialization406_a, Spl1 ),
	test_data( specialization406, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization407) :-
	spl_db( specialization407_a, Spl1 ),
	test_data( specialization407, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization408) :-
	spl_db( specialization408_a, Spl1 ),
	test_data( specialization408, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization409) :-
	spl_db( specialization409_a, Spl1 ),
	test_data( specialization409, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization410) :-
	spl_db( specialization410_a, Spl1 ),
	test_data( specialization410, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization411) :-
	spl_db( specialization411_a, Spl1 ),
	test_data( specialization411, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization412) :-
	spl_db( specialization412_a, Spl1 ),
	test_data( specialization412, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization413) :-
	spl_db( specialization413_a, Spl1 ),
	test_data( specialization413, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization414) :-
	spl_db( specialization414_a, Spl1 ),
	test_data( specialization414, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization415) :-
	spl_db( specialization415_a, Spl1 ),
	test_data( specialization415, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization416) :-
	spl_db( specialization416_a, Spl1 ),
	test_data( specialization416, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization417) :-
	spl_db( specialization417_a, Spl1 ),
	test_data( specialization417, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization418) :-
	spl_db( specialization418_a, Spl1 ),
	test_data( specialization418, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization419) :-
	spl_db( specialization419_a, Spl1 ),
	test_data( specialization419, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization420) :-
	spl_db( specialization420_a, Spl1 ),
	test_data( specialization420, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization421) :-
	spl_db( specialization421_a, Spl1 ),
	test_data( specialization421, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization422) :-
	spl_db( specialization422_a, Spl1 ),
	test_data( specialization422, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization423) :-
	spl_db( specialization423_a, Spl1 ),
	test_data( specialization423, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization424) :-
	spl_db( specialization424_a, Spl1 ),
	test_data( specialization424, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization425) :-
	spl_db( specialization425_a, Spl1 ),
	test_data( specialization425, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization426) :-
	spl_db( specialization426_a, Spl1 ),
	test_data( specialization426, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization427) :-
	spl_db( specialization427_a, Spl1 ),
	test_data( specialization427, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization428) :-
	spl_db( specialization428_a, Spl1 ),
	test_data( specialization428, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization429) :-
	spl_db( specialization429_a, Spl1 ),
	test_data( specialization429, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization430) :-
	spl_db( specialization430_a, Spl1 ),
	test_data( specialization430, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization431) :-
	spl_db( specialization431_a, Spl1 ),
	test_data( specialization431, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization432) :-
	spl_db( specialization432_a, Spl1 ),
	test_data( specialization432, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization433) :-
	spl_db( specialization433_a, Spl1 ),
	test_data( specialization433, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization434) :-
	spl_db( specialization434_a, Spl1 ),
	test_data( specialization434, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization435) :-
	spl_db( specialization435_a, Spl1 ),
	test_data( specialization435, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization436) :-
	spl_db( specialization436_a, Spl1 ),
	test_data( specialization436, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization437) :-
	spl_db( specialization437_a, Spl1 ),
	test_data( specialization437, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization438) :-
	spl_db( specialization438_a, Spl1 ),
	test_data( specialization438, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization439) :-
	spl_db( specialization439_a, Spl1 ),
	test_data( specialization439, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization440) :-
	spl_db( specialization440_a, Spl1 ),
	test_data( specialization440, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization441) :-
	spl_db( specialization441_a, Spl1 ),
	test_data( specialization441, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization442) :-
	spl_db( specialization442_a, Spl1 ),
	test_data( specialization442, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization443) :-
	spl_db( specialization443_a, Spl1 ),
	test_data( specialization443, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization444) :-
	spl_db( specialization444_a, Spl1 ),
	test_data( specialization444, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization445) :-
	spl_db( specialization445_a, Spl1 ),
	test_data( specialization445, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization446) :-
	spl_db( specialization446_a, Spl1 ),
	test_data( specialization446, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization447) :-
	spl_db( specialization447_a, Spl1 ),
	test_data( specialization447, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization448) :-
	spl_db( specialization448_a, Spl1 ),
	test_data( specialization448, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization449) :-
	spl_db( specialization449_a, Spl1 ),
	test_data( specialization449, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization450) :-
	spl_db( specialization450_a, Spl1 ),
	test_data( specialization450, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization451) :-
	spl_db( specialization451_a, Spl1 ),
	test_data( specialization451, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization452) :-
	spl_db( specialization452_a, Spl1 ),
	test_data( specialization452, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization453) :-
	spl_db( specialization453_a, Spl1 ),
	test_data( specialization453, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization454) :-
	spl_db( specialization454_a, Spl1 ),
	test_data( specialization454, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization455) :-
	spl_db( specialization455_a, Spl1 ),
	test_data( specialization455, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization456) :-
	spl_db( specialization456_a, Spl1 ),
	test_data( specialization456, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization457) :-
	spl_db( specialization457_a, Spl1 ),
	test_data( specialization457, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization458) :-
	spl_db( specialization458_a, Spl1 ),
	test_data( specialization458, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization459) :-
	spl_db( specialization459_a, Spl1 ),
	test_data( specialization459, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization460) :-
	spl_db( specialization460_a, Spl1 ),
	test_data( specialization460, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization461) :-
	spl_db( specialization461_a, Spl1 ),
	test_data( specialization461, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization462) :-
	spl_db( specialization462_a, Spl1 ),
	test_data( specialization462, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization463) :-
	spl_db( specialization463_a, Spl1 ),
	test_data( specialization463, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization464) :-
	spl_db( specialization464_a, Spl1 ),
	test_data( specialization464, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization465) :-
	spl_db( specialization465_a, Spl1 ),
	test_data( specialization465, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization466) :-
	spl_db( specialization466_a, Spl1 ),
	test_data( specialization466, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization467) :-
	spl_db( specialization467_a, Spl1 ),
	test_data( specialization467, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization468) :-
	spl_db( specialization468_a, Spl1 ),
	test_data( specialization468, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization469) :-
	spl_db( specialization469_a, Spl1 ),
	test_data( specialization469, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization470) :-
	spl_db( specialization470_a, Spl1 ),
	test_data( specialization470, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization471) :-
	spl_db( specialization471_a, Spl1 ),
	test_data( specialization471, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization472) :-
	spl_db( specialization472_a, Spl1 ),
	test_data( specialization472, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization473) :-
	spl_db( specialization473_a, Spl1 ),
	test_data( specialization473, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization474) :-
	spl_db( specialization474_a, Spl1 ),
	test_data( specialization474, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization475) :-
	spl_db( specialization475_a, Spl1 ),
	test_data( specialization475, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization476) :-
	spl_db( specialization476_a, Spl1 ),
	test_data( specialization476, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization477) :-
	spl_db( specialization477_a, Spl1 ),
	test_data( specialization477, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization478) :-
	spl_db( specialization478_a, Spl1 ),
	test_data( specialization478, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization479) :-
	spl_db( specialization479_a, Spl1 ),
	test_data( specialization479, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization480) :-
	spl_db( specialization480_a, Spl1 ),
	test_data( specialization480, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization481) :-
	spl_db( specialization481_a, Spl1 ),
	test_data( specialization481, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization482) :-
	spl_db( specialization482_a, Spl1 ),
	test_data( specialization482, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization483) :-
	spl_db( specialization483_a, Spl1 ),
	test_data( specialization483, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization484) :-
	spl_db( specialization484_a, Spl1 ),
	test_data( specialization484, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization485) :-
	spl_db( specialization485_a, Spl1 ),
	test_data( specialization485, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization486) :-
	spl_db( specialization486_a, Spl1 ),
	test_data( specialization486, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization487) :-
	spl_db( specialization487_a, Spl1 ),
	test_data( specialization487, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization488) :-
	spl_db( specialization488_a, Spl1 ),
	test_data( specialization488, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization489) :-
	spl_db( specialization489_a, Spl1 ),
	test_data( specialization489, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization490) :-
	spl_db( specialization490_a, Spl1 ),
	test_data( specialization490, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization491) :-
	spl_db( specialization491_a, Spl1 ),
	test_data( specialization491, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization492) :-
	spl_db( specialization492_a, Spl1 ),
	test_data( specialization492, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization493) :-
	spl_db( specialization493_a, Spl1 ),
	test_data( specialization493, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization494) :-
	spl_db( specialization494_a, Spl1 ),
	test_data( specialization494, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization495) :-
	spl_db( specialization495_a, Spl1 ),
	test_data( specialization495, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization496) :-
	spl_db( specialization496_a, Spl1 ),
	test_data( specialization496, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization497) :-
	spl_db( specialization497_a, Spl1 ),
	test_data( specialization497, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization498) :-
	spl_db( specialization498_a, Spl1 ),
	test_data( specialization498, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization499) :-
	spl_db( specialization499_a, Spl1 ),
	test_data( specialization499, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization500) :-
	spl_db( specialization500_a, Spl1 ),
	test_data( specialization500, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization501) :-
	spl_db( specialization501_a, Spl1 ),
	test_data( specialization501, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization502) :-
	spl_db( specialization502_a, Spl1 ),
	test_data( specialization502, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization503) :-
	spl_db( specialization503_a, Spl1 ),
	test_data( specialization503, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization504) :-
	spl_db( specialization504_a, Spl1 ),
	test_data( specialization504, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization505) :-
	spl_db( specialization505_a, Spl1 ),
	test_data( specialization505, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization506) :-
	spl_db( specialization506_a, Spl1 ),
	test_data( specialization506, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization507) :-
	spl_db( specialization507_a, Spl1 ),
	test_data( specialization507, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization508) :-
	spl_db( specialization508_a, Spl1 ),
	test_data( specialization508, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization509) :-
	spl_db( specialization509_a, Spl1 ),
	test_data( specialization509, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization510) :-
	spl_db( specialization510_a, Spl1 ),
	test_data( specialization510, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization511) :-
	spl_db( specialization511_a, Spl1 ),
	test_data( specialization511, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization512) :-
	spl_db( specialization512_a, Spl1 ),
	test_data( specialization512, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization513) :-
	spl_db( specialization513_a, Spl1 ),
	test_data( specialization513, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization514) :-
	spl_db( specialization514_a, Spl1 ),
	test_data( specialization514, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization515) :-
	spl_db( specialization515_a, Spl1 ),
	test_data( specialization515, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization516) :-
	spl_db( specialization516_a, Spl1 ),
	test_data( specialization516, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization517) :-
	spl_db( specialization517_a, Spl1 ),
	test_data( specialization517, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization518) :-
	spl_db( specialization518_a, Spl1 ),
	test_data( specialization518, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization519) :-
	spl_db( specialization519_a, Spl1 ),
	test_data( specialization519, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization520) :-
	spl_db( specialization520_a, Spl1 ),
	test_data( specialization520, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization521) :-
	spl_db( specialization521_a, Spl1 ),
	test_data( specialization521, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization522) :-
	spl_db( specialization522_a, Spl1 ),
	test_data( specialization522, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization523) :-
	spl_db( specialization523_a, Spl1 ),
	test_data( specialization523, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization524) :-
	spl_db( specialization524_a, Spl1 ),
	test_data( specialization524, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization525) :-
	spl_db( specialization525_a, Spl1 ),
	test_data( specialization525, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization526) :-
	spl_db( specialization526_a, Spl1 ),
	test_data( specialization526, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization527) :-
	spl_db( specialization527_a, Spl1 ),
	test_data( specialization527, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization528) :-
	spl_db( specialization528_a, Spl1 ),
	test_data( specialization528, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization529) :-
	spl_db( specialization529_a, Spl1 ),
	test_data( specialization529, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization530) :-
	spl_db( specialization530_a, Spl1 ),
	test_data( specialization530, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization531) :-
	spl_db( specialization531_a, Spl1 ),
	test_data( specialization531, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization532) :-
	spl_db( specialization532_a, Spl1 ),
	test_data( specialization532, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization533) :-
	spl_db( specialization533_a, Spl1 ),
	test_data( specialization533, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization534) :-
	spl_db( specialization534_a, Spl1 ),
	test_data( specialization534, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization535) :-
	spl_db( specialization535_a, Spl1 ),
	test_data( specialization535, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization536) :-
	spl_db( specialization536_a, Spl1 ),
	test_data( specialization536, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization537) :-
	spl_db( specialization537_a, Spl1 ),
	test_data( specialization537, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization538) :-
	spl_db( specialization538_a, Spl1 ),
	test_data( specialization538, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization539) :-
	spl_db( specialization539_a, Spl1 ),
	test_data( specialization539, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization540) :-
	spl_db( specialization540_a, Spl1 ),
	test_data( specialization540, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization541) :-
	spl_db( specialization541_a, Spl1 ),
	test_data( specialization541, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization542) :-
	spl_db( specialization542_a, Spl1 ),
	test_data( specialization542, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization543) :-
	spl_db( specialization543_a, Spl1 ),
	test_data( specialization543, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization544) :-
	spl_db( specialization544_a, Spl1 ),
	test_data( specialization544, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization545) :-
	spl_db( specialization545_a, Spl1 ),
	test_data( specialization545, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization546) :-
	spl_db( specialization546_a, Spl1 ),
	test_data( specialization546, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization547) :-
	spl_db( specialization547_a, Spl1 ),
	test_data( specialization547, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization548) :-
	spl_db( specialization548_a, Spl1 ),
	test_data( specialization548, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization549) :-
	spl_db( specialization549_a, Spl1 ),
	test_data( specialization549, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization550) :-
	spl_db( specialization550_a, Spl1 ),
	test_data( specialization550, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization551) :-
	spl_db( specialization551_a, Spl1 ),
	test_data( specialization551, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization552) :-
	spl_db( specialization552_a, Spl1 ),
	test_data( specialization552, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization553) :-
	spl_db( specialization553_a, Spl1 ),
	test_data( specialization553, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization554) :-
	spl_db( specialization554_a, Spl1 ),
	test_data( specialization554, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization555) :-
	spl_db( specialization555_a, Spl1 ),
	test_data( specialization555, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization556) :-
	spl_db( specialization556_a, Spl1 ),
	test_data( specialization556, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization557) :-
	spl_db( specialization557_a, Spl1 ),
	test_data( specialization557, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization558) :-
	spl_db( specialization558_a, Spl1 ),
	test_data( specialization558, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization559) :-
	spl_db( specialization559_a, Spl1 ),
	test_data( specialization559, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization560) :-
	spl_db( specialization560_a, Spl1 ),
	test_data( specialization560, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization561) :-
	spl_db( specialization561_a, Spl1 ),
	test_data( specialization561, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization562) :-
	spl_db( specialization562_a, Spl1 ),
	test_data( specialization562, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization563) :-
	spl_db( specialization563_a, Spl1 ),
	test_data( specialization563, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization564) :-
	spl_db( specialization564_a, Spl1 ),
	test_data( specialization564, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization565) :-
	spl_db( specialization565_a, Spl1 ),
	test_data( specialization565, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization566) :-
	spl_db( specialization566_a, Spl1 ),
	test_data( specialization566, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization567) :-
	spl_db( specialization567_a, Spl1 ),
	test_data( specialization567, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization568) :-
	spl_db( specialization568_a, Spl1 ),
	test_data( specialization568, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization569) :-
	spl_db( specialization569_a, Spl1 ),
	test_data( specialization569, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization570) :-
	spl_db( specialization570_a, Spl1 ),
	test_data( specialization570, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization571) :-
	spl_db( specialization571_a, Spl1 ),
	test_data( specialization571, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization572) :-
	spl_db( specialization572_a, Spl1 ),
	test_data( specialization572, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization573) :-
	spl_db( specialization573_a, Spl1 ),
	test_data( specialization573, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization574) :-
	spl_db( specialization574_a, Spl1 ),
	test_data( specialization574, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization575) :-
	spl_db( specialization575_a, Spl1 ),
	test_data( specialization575, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization576) :-
	spl_db( specialization576_a, Spl1 ),
	test_data( specialization576, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization577) :-
	spl_db( specialization577_a, Spl1 ),
	test_data( specialization577, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization578) :-
	spl_db( specialization578_a, Spl1 ),
	test_data( specialization578, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization579) :-
	spl_db( specialization579_a, Spl1 ),
	test_data( specialization579, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization580) :-
	spl_db( specialization580_a, Spl1 ),
	test_data( specialization580, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization581) :-
	spl_db( specialization581_a, Spl1 ),
	test_data( specialization581, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization582) :-
	spl_db( specialization582_a, Spl1 ),
	test_data( specialization582, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization583) :-
	spl_db( specialization583_a, Spl1 ),
	test_data( specialization583, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization584) :-
	spl_db( specialization584_a, Spl1 ),
	test_data( specialization584, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization585) :-
	spl_db( specialization585_a, Spl1 ),
	test_data( specialization585, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization586) :-
	spl_db( specialization586_a, Spl1 ),
	test_data( specialization586, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization587) :-
	spl_db( specialization587_a, Spl1 ),
	test_data( specialization587, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization588) :-
	spl_db( specialization588_a, Spl1 ),
	test_data( specialization588, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization589) :-
	spl_db( specialization589_a, Spl1 ),
	test_data( specialization589, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization590) :-
	spl_db( specialization590_a, Spl1 ),
	test_data( specialization590, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization591) :-
	spl_db( specialization591_a, Spl1 ),
	test_data( specialization591, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization592) :-
	spl_db( specialization592_a, Spl1 ),
	test_data( specialization592, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization593) :-
	spl_db( specialization593_a, Spl1 ),
	test_data( specialization593, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization594) :-
	spl_db( specialization594_a, Spl1 ),
	test_data( specialization594, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization595) :-
	spl_db( specialization595_a, Spl1 ),
	test_data( specialization595, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization596) :-
	spl_db( specialization596_a, Spl1 ),
	test_data( specialization596, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization597) :-
	spl_db( specialization597_a, Spl1 ),
	test_data( specialization597, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization598) :-
	spl_db( specialization598_a, Spl1 ),
	test_data( specialization598, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization599) :-
	spl_db( specialization599_a, Spl1 ),
	test_data( specialization599, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization600) :-
	spl_db( specialization600_a, Spl1 ),
	test_data( specialization600, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization601) :-
	spl_db( specialization601_a, Spl1 ),
	test_data( specialization601, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization602) :-
	spl_db( specialization602_a, Spl1 ),
	test_data( specialization602, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization603) :-
	spl_db( specialization603_a, Spl1 ),
	test_data( specialization603, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization604) :-
	spl_db( specialization604_a, Spl1 ),
	test_data( specialization604, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization605) :-
	spl_db( specialization605_a, Spl1 ),
	test_data( specialization605, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization606) :-
	spl_db( specialization606_a, Spl1 ),
	test_data( specialization606, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization607) :-
	spl_db( specialization607_a, Spl1 ),
	test_data( specialization607, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization608) :-
	spl_db( specialization608_a, Spl1 ),
	test_data( specialization608, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization609) :-
	spl_db( specialization609_a, Spl1 ),
	test_data( specialization609, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization610) :-
	spl_db( specialization610_a, Spl1 ),
	test_data( specialization610, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization611) :-
	spl_db( specialization611_a, Spl1 ),
	test_data( specialization611, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization612) :-
	spl_db( specialization612_a, Spl1 ),
	test_data( specialization612, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization613) :-
	spl_db( specialization613_a, Spl1 ),
	test_data( specialization613, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization614) :-
	spl_db( specialization614_a, Spl1 ),
	test_data( specialization614, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization615) :-
	spl_db( specialization615_a, Spl1 ),
	test_data( specialization615, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization616) :-
	spl_db( specialization616_a, Spl1 ),
	test_data( specialization616, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization617) :-
	spl_db( specialization617_a, Spl1 ),
	test_data( specialization617, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization618) :-
	spl_db( specialization618_a, Spl1 ),
	test_data( specialization618, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization619) :-
	spl_db( specialization619_a, Spl1 ),
	test_data( specialization619, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization620) :-
	spl_db( specialization620_a, Spl1 ),
	test_data( specialization620, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization621) :-
	spl_db( specialization621_a, Spl1 ),
	test_data( specialization621, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization622) :-
	spl_db( specialization622_a, Spl1 ),
	test_data( specialization622, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization623) :-
	spl_db( specialization623_a, Spl1 ),
	test_data( specialization623, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization624) :-
	spl_db( specialization624_a, Spl1 ),
	test_data( specialization624, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization625) :-
	spl_db( specialization625_a, Spl1 ),
	test_data( specialization625, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization626) :-
	spl_db( specialization626_a, Spl1 ),
	test_data( specialization626, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization627) :-
	spl_db( specialization627_a, Spl1 ),
	test_data( specialization627, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization628) :-
	spl_db( specialization628_a, Spl1 ),
	test_data( specialization628, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization629) :-
	spl_db( specialization629_a, Spl1 ),
	test_data( specialization629, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization630) :-
	spl_db( specialization630_a, Spl1 ),
	test_data( specialization630, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization631) :-
	spl_db( specialization631_a, Spl1 ),
	test_data( specialization631, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization632) :-
	spl_db( specialization632_a, Spl1 ),
	test_data( specialization632, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization633) :-
	spl_db( specialization633_a, Spl1 ),
	test_data( specialization633, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization634) :-
	spl_db( specialization634_a, Spl1 ),
	test_data( specialization634, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization635) :-
	spl_db( specialization635_a, Spl1 ),
	test_data( specialization635, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization636) :-
	spl_db( specialization636_a, Spl1 ),
	test_data( specialization636, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization637) :-
	spl_db( specialization637_a, Spl1 ),
	test_data( specialization637, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization638) :-
	spl_db( specialization638_a, Spl1 ),
	test_data( specialization638, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization639) :-
	spl_db( specialization639_a, Spl1 ),
	test_data( specialization639, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization640) :-
	spl_db( specialization640_a, Spl1 ),
	test_data( specialization640, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization641) :-
	spl_db( specialization641_a, Spl1 ),
	test_data( specialization641, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization642) :-
	spl_db( specialization642_a, Spl1 ),
	test_data( specialization642, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization643) :-
	spl_db( specialization643_a, Spl1 ),
	test_data( specialization643, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization644) :-
	spl_db( specialization644_a, Spl1 ),
	test_data( specialization644, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization645) :-
	spl_db( specialization645_a, Spl1 ),
	test_data( specialization645, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization646) :-
	spl_db( specialization646_a, Spl1 ),
	test_data( specialization646, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization647) :-
	spl_db( specialization647_a, Spl1 ),
	test_data( specialization647, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization648) :-
	spl_db( specialization648_a, Spl1 ),
	test_data( specialization648, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization649) :-
	spl_db( specialization649_a, Spl1 ),
	test_data( specialization649, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization650) :-
	spl_db( specialization650_a, Spl1 ),
	test_data( specialization650, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization651) :-
	spl_db( specialization651_a, Spl1 ),
	test_data( specialization651, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization652) :-
	spl_db( specialization652_a, Spl1 ),
	test_data( specialization652, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization653) :-
	spl_db( specialization653_a, Spl1 ),
	test_data( specialization653, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization654) :-
	spl_db( specialization654_a, Spl1 ),
	test_data( specialization654, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization655) :-
	spl_db( specialization655_a, Spl1 ),
	test_data( specialization655, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization656) :-
	spl_db( specialization656_a, Spl1 ),
	test_data( specialization656, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization657) :-
	spl_db( specialization657_a, Spl1 ),
	test_data( specialization657, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization658) :-
	spl_db( specialization658_a, Spl1 ),
	test_data( specialization658, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization659) :-
	spl_db( specialization659_a, Spl1 ),
	test_data( specialization659, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization660) :-
	spl_db( specialization660_a, Spl1 ),
	test_data( specialization660, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization661) :-
	spl_db( specialization661_a, Spl1 ),
	test_data( specialization661, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization662) :-
	spl_db( specialization662_a, Spl1 ),
	test_data( specialization662, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization663) :-
	spl_db( specialization663_a, Spl1 ),
	test_data( specialization663, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization664) :-
	spl_db( specialization664_a, Spl1 ),
	test_data( specialization664, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization665) :-
	spl_db( specialization665_a, Spl1 ),
	test_data( specialization665, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization666) :-
	spl_db( specialization666_a, Spl1 ),
	test_data( specialization666, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization667) :-
	spl_db( specialization667_a, Spl1 ),
	test_data( specialization667, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization668) :-
	spl_db( specialization668_a, Spl1 ),
	test_data( specialization668, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization669) :-
	spl_db( specialization669_a, Spl1 ),
	test_data( specialization669, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization670) :-
	spl_db( specialization670_a, Spl1 ),
	test_data( specialization670, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization671) :-
	spl_db( specialization671_a, Spl1 ),
	test_data( specialization671, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization672) :-
	spl_db( specialization672_a, Spl1 ),
	test_data( specialization672, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization673) :-
	spl_db( specialization673_a, Spl1 ),
	test_data( specialization673, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization674) :-
	spl_db( specialization674_a, Spl1 ),
	test_data( specialization674, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization675) :-
	spl_db( specialization675_a, Spl1 ),
	test_data( specialization675, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization676) :-
	spl_db( specialization676_a, Spl1 ),
	test_data( specialization676, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization677) :-
	spl_db( specialization677_a, Spl1 ),
	test_data( specialization677, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization678) :-
	spl_db( specialization678_a, Spl1 ),
	test_data( specialization678, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization679) :-
	spl_db( specialization679_a, Spl1 ),
	test_data( specialization679, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization680) :-
	spl_db( specialization680_a, Spl1 ),
	test_data( specialization680, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization681) :-
	spl_db( specialization681_a, Spl1 ),
	test_data( specialization681, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization682) :-
	spl_db( specialization682_a, Spl1 ),
	test_data( specialization682, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization683) :-
	spl_db( specialization683_a, Spl1 ),
	test_data( specialization683, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization684) :-
	spl_db( specialization684_a, Spl1 ),
	test_data( specialization684, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization685) :-
	spl_db( specialization685_a, Spl1 ),
	test_data( specialization685, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization686) :-
	spl_db( specialization686_a, Spl1 ),
	test_data( specialization686, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization687) :-
	spl_db( specialization687_a, Spl1 ),
	test_data( specialization687, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization688) :-
	spl_db( specialization688_a, Spl1 ),
	test_data( specialization688, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization689) :-
	spl_db( specialization689_a, Spl1 ),
	test_data( specialization689, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization690) :-
	spl_db( specialization690_a, Spl1 ),
	test_data( specialization690, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization691) :-
	spl_db( specialization691_a, Spl1 ),
	test_data( specialization691, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization692) :-
	spl_db( specialization692_a, Spl1 ),
	test_data( specialization692, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization693) :-
	spl_db( specialization693_a, Spl1 ),
	test_data( specialization693, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization694) :-
	spl_db( specialization694_a, Spl1 ),
	test_data( specialization694, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization695) :-
	spl_db( specialization695_a, Spl1 ),
	test_data( specialization695, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization696) :-
	spl_db( specialization696_a, Spl1 ),
	test_data( specialization696, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization697) :-
	spl_db( specialization697_a, Spl1 ),
	test_data( specialization697, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization698) :-
	spl_db( specialization698_a, Spl1 ),
	test_data( specialization698, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization699) :-
	spl_db( specialization699_a, Spl1 ),
	test_data( specialization699, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization700) :-
	spl_db( specialization700_a, Spl1 ),
	test_data( specialization700, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization701) :-
	spl_db( specialization701_a, Spl1 ),
	test_data( specialization701, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization702) :-
	spl_db( specialization702_a, Spl1 ),
	test_data( specialization702, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization703) :-
	spl_db( specialization703_a, Spl1 ),
	test_data( specialization703, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization704) :-
	spl_db( specialization704_a, Spl1 ),
	test_data( specialization704, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization705) :-
	spl_db( specialization705_a, Spl1 ),
	test_data( specialization705, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization706) :-
	spl_db( specialization706_a, Spl1 ),
	test_data( specialization706, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization707) :-
	spl_db( specialization707_a, Spl1 ),
	test_data( specialization707, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization708) :-
	spl_db( specialization708_a, Spl1 ),
	test_data( specialization708, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization709) :-
	spl_db( specialization709_a, Spl1 ),
	test_data( specialization709, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization710) :-
	spl_db( specialization710_a, Spl1 ),
	test_data( specialization710, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization711) :-
	spl_db( specialization711_a, Spl1 ),
	test_data( specialization711, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization712) :-
	spl_db( specialization712_a, Spl1 ),
	test_data( specialization712, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization713) :-
	spl_db( specialization713_a, Spl1 ),
	test_data( specialization713, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization714) :-
	spl_db( specialization714_a, Spl1 ),
	test_data( specialization714, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization715) :-
	spl_db( specialization715_a, Spl1 ),
	test_data( specialization715, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization716) :-
	spl_db( specialization716_a, Spl1 ),
	test_data( specialization716, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization717) :-
	spl_db( specialization717_a, Spl1 ),
	test_data( specialization717, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization718) :-
	spl_db( specialization718_a, Spl1 ),
	test_data( specialization718, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization719) :-
	spl_db( specialization719_a, Spl1 ),
	test_data( specialization719, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization720) :-
	spl_db( specialization720_a, Spl1 ),
	test_data( specialization720, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization721) :-
	spl_db( specialization721_a, Spl1 ),
	test_data( specialization721, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization722) :-
	spl_db( specialization722_a, Spl1 ),
	test_data( specialization722, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization723) :-
	spl_db( specialization723_a, Spl1 ),
	test_data( specialization723, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization724) :-
	spl_db( specialization724_a, Spl1 ),
	test_data( specialization724, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization725) :-
	spl_db( specialization725_a, Spl1 ),
	test_data( specialization725, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization726) :-
	spl_db( specialization726_a, Spl1 ),
	test_data( specialization726, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization727) :-
	spl_db( specialization727_a, Spl1 ),
	test_data( specialization727, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization728) :-
	spl_db( specialization728_a, Spl1 ),
	test_data( specialization728, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization729) :-
	spl_db( specialization729_a, Spl1 ),
	test_data( specialization729, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization730) :-
	spl_db( specialization730_a, Spl1 ),
	test_data( specialization730, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization731) :-
	spl_db( specialization731_a, Spl1 ),
	test_data( specialization731, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization732) :-
	spl_db( specialization732_a, Spl1 ),
	test_data( specialization732, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization733) :-
	spl_db( specialization733_a, Spl1 ),
	test_data( specialization733, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization734) :-
	spl_db( specialization734_a, Spl1 ),
	test_data( specialization734, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization735) :-
	spl_db( specialization735_a, Spl1 ),
	test_data( specialization735, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization736) :-
	spl_db( specialization736_a, Spl1 ),
	test_data( specialization736, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization737) :-
	spl_db( specialization737_a, Spl1 ),
	test_data( specialization737, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization738) :-
	spl_db( specialization738_a, Spl1 ),
	test_data( specialization738, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization739) :-
	spl_db( specialization739_a, Spl1 ),
	test_data( specialization739, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization740) :-
	spl_db( specialization740_a, Spl1 ),
	test_data( specialization740, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization741) :-
	spl_db( specialization741_a, Spl1 ),
	test_data( specialization741, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization742) :-
	spl_db( specialization742_a, Spl1 ),
	test_data( specialization742, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization743) :-
	spl_db( specialization743_a, Spl1 ),
	test_data( specialization743, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization744) :-
	spl_db( specialization744_a, Spl1 ),
	test_data( specialization744, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization745) :-
	spl_db( specialization745_a, Spl1 ),
	test_data( specialization745, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization746) :-
	spl_db( specialization746_a, Spl1 ),
	test_data( specialization746, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization747) :-
	spl_db( specialization747_a, Spl1 ),
	test_data( specialization747, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization748) :-
	spl_db( specialization748_a, Spl1 ),
	test_data( specialization748, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization749) :-
	spl_db( specialization749_a, Spl1 ),
	test_data( specialization749, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization750) :-
	spl_db( specialization750_a, Spl1 ),
	test_data( specialization750, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization751) :-
	spl_db( specialization751_a, Spl1 ),
	test_data( specialization751, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization752) :-
	spl_db( specialization752_a, Spl1 ),
	test_data( specialization752, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization753) :-
	spl_db( specialization753_a, Spl1 ),
	test_data( specialization753, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization754) :-
	spl_db( specialization754_a, Spl1 ),
	test_data( specialization754, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization755) :-
	spl_db( specialization755_a, Spl1 ),
	test_data( specialization755, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization756) :-
	spl_db( specialization756_a, Spl1 ),
	test_data( specialization756, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization757) :-
	spl_db( specialization757_a, Spl1 ),
	test_data( specialization757, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization758) :-
	spl_db( specialization758_a, Spl1 ),
	test_data( specialization758, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization759) :-
	spl_db( specialization759_a, Spl1 ),
	test_data( specialization759, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization760) :-
	spl_db( specialization760_a, Spl1 ),
	test_data( specialization760, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization761) :-
	spl_db( specialization761_a, Spl1 ),
	test_data( specialization761, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization762) :-
	spl_db( specialization762_a, Spl1 ),
	test_data( specialization762, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization763) :-
	spl_db( specialization763_a, Spl1 ),
	test_data( specialization763, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization764) :-
	spl_db( specialization764_a, Spl1 ),
	test_data( specialization764, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization765) :-
	spl_db( specialization765_a, Spl1 ),
	test_data( specialization765, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization766) :-
	spl_db( specialization766_a, Spl1 ),
	test_data( specialization766, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization767) :-
	spl_db( specialization767_a, Spl1 ),
	test_data( specialization767, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization768) :-
	spl_db( specialization768_a, Spl1 ),
	test_data( specialization768, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization769) :-
	spl_db( specialization769_a, Spl1 ),
	test_data( specialization769, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization770) :-
	spl_db( specialization770_a, Spl1 ),
	test_data( specialization770, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization771) :-
	spl_db( specialization771_a, Spl1 ),
	test_data( specialization771, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization772) :-
	spl_db( specialization772_a, Spl1 ),
	test_data( specialization772, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization773) :-
	spl_db( specialization773_a, Spl1 ),
	test_data( specialization773, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization774) :-
	spl_db( specialization774_a, Spl1 ),
	test_data( specialization774, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization775) :-
	spl_db( specialization775_a, Spl1 ),
	test_data( specialization775, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization776) :-
	spl_db( specialization776_a, Spl1 ),
	test_data( specialization776, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization777) :-
	spl_db( specialization777_a, Spl1 ),
	test_data( specialization777, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization778) :-
	spl_db( specialization778_a, Spl1 ),
	test_data( specialization778, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization779) :-
	spl_db( specialization779_a, Spl1 ),
	test_data( specialization779, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization780) :-
	spl_db( specialization780_a, Spl1 ),
	test_data( specialization780, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization781) :-
	spl_db( specialization781_a, Spl1 ),
	test_data( specialization781, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization782) :-
	spl_db( specialization782_a, Spl1 ),
	test_data( specialization782, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization783) :-
	spl_db( specialization783_a, Spl1 ),
	test_data( specialization783, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization784) :-
	spl_db( specialization784_a, Spl1 ),
	test_data( specialization784, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization785) :-
	spl_db( specialization785_a, Spl1 ),
	test_data( specialization785, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization786) :-
	spl_db( specialization786_a, Spl1 ),
	test_data( specialization786, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization787) :-
	spl_db( specialization787_a, Spl1 ),
	test_data( specialization787, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization788) :-
	spl_db( specialization788_a, Spl1 ),
	test_data( specialization788, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization789) :-
	spl_db( specialization789_a, Spl1 ),
	test_data( specialization789, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization790) :-
	spl_db( specialization790_a, Spl1 ),
	test_data( specialization790, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization791) :-
	spl_db( specialization791_a, Spl1 ),
	test_data( specialization791, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization792) :-
	spl_db( specialization792_a, Spl1 ),
	test_data( specialization792, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization793) :-
	spl_db( specialization793_a, Spl1 ),
	test_data( specialization793, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization794) :-
	spl_db( specialization794_a, Spl1 ),
	test_data( specialization794, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization795) :-
	spl_db( specialization795_a, Spl1 ),
	test_data( specialization795, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization796) :-
	spl_db( specialization796_a, Spl1 ),
	test_data( specialization796, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization797) :-
	spl_db( specialization797_a, Spl1 ),
	test_data( specialization797, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization798) :-
	spl_db( specialization798_a, Spl1 ),
	test_data( specialization798, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization799) :-
	spl_db( specialization799_a, Spl1 ),
	test_data( specialization799, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization800) :-
	spl_db( specialization800_a, Spl1 ),
	test_data( specialization800, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization801) :-
	spl_db( specialization801_a, Spl1 ),
	test_data( specialization801, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization802) :-
	spl_db( specialization802_a, Spl1 ),
	test_data( specialization802, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization803) :-
	spl_db( specialization803_a, Spl1 ),
	test_data( specialization803, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization804) :-
	spl_db( specialization804_a, Spl1 ),
	test_data( specialization804, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization805) :-
	spl_db( specialization805_a, Spl1 ),
	test_data( specialization805, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization806) :-
	spl_db( specialization806_a, Spl1 ),
	test_data( specialization806, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization807) :-
	spl_db( specialization807_a, Spl1 ),
	test_data( specialization807, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization808) :-
	spl_db( specialization808_a, Spl1 ),
	test_data( specialization808, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization809) :-
	spl_db( specialization809_a, Spl1 ),
	test_data( specialization809, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization810) :-
	spl_db( specialization810_a, Spl1 ),
	test_data( specialization810, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization811) :-
	spl_db( specialization811_a, Spl1 ),
	test_data( specialization811, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization812) :-
	spl_db( specialization812_a, Spl1 ),
	test_data( specialization812, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization813) :-
	spl_db( specialization813_a, Spl1 ),
	test_data( specialization813, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization814) :-
	spl_db( specialization814_a, Spl1 ),
	test_data( specialization814, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization815) :-
	spl_db( specialization815_a, Spl1 ),
	test_data( specialization815, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization816) :-
	spl_db( specialization816_a, Spl1 ),
	test_data( specialization816, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization817) :-
	spl_db( specialization817_a, Spl1 ),
	test_data( specialization817, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization818) :-
	spl_db( specialization818_a, Spl1 ),
	test_data( specialization818, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization819) :-
	spl_db( specialization819_a, Spl1 ),
	test_data( specialization819, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization820) :-
	spl_db( specialization820_a, Spl1 ),
	test_data( specialization820, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization821) :-
	spl_db( specialization821_a, Spl1 ),
	test_data( specialization821, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization822) :-
	spl_db( specialization822_a, Spl1 ),
	test_data( specialization822, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization823) :-
	spl_db( specialization823_a, Spl1 ),
	test_data( specialization823, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization824) :-
	spl_db( specialization824_a, Spl1 ),
	test_data( specialization824, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization825) :-
	spl_db( specialization825_a, Spl1 ),
	test_data( specialization825, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization826) :-
	spl_db( specialization826_a, Spl1 ),
	test_data( specialization826, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization827) :-
	spl_db( specialization827_a, Spl1 ),
	test_data( specialization827, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization828) :-
	spl_db( specialization828_a, Spl1 ),
	test_data( specialization828, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization829) :-
	spl_db( specialization829_a, Spl1 ),
	test_data( specialization829, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization830) :-
	spl_db( specialization830_a, Spl1 ),
	test_data( specialization830, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization831) :-
	spl_db( specialization831_a, Spl1 ),
	test_data( specialization831, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization832) :-
	spl_db( specialization832_a, Spl1 ),
	test_data( specialization832, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization833) :-
	spl_db( specialization833_a, Spl1 ),
	test_data( specialization833, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization834) :-
	spl_db( specialization834_a, Spl1 ),
	test_data( specialization834, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization835) :-
	spl_db( specialization835_a, Spl1 ),
	test_data( specialization835, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization836) :-
	spl_db( specialization836_a, Spl1 ),
	test_data( specialization836, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization837) :-
	spl_db( specialization837_a, Spl1 ),
	test_data( specialization837, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization838) :-
	spl_db( specialization838_a, Spl1 ),
	test_data( specialization838, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization839) :-
	spl_db( specialization839_a, Spl1 ),
	test_data( specialization839, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization840) :-
	spl_db( specialization840_a, Spl1 ),
	test_data( specialization840, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization841) :-
	spl_db( specialization841_a, Spl1 ),
	test_data( specialization841, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization842) :-
	spl_db( specialization842_a, Spl1 ),
	test_data( specialization842, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization843) :-
	spl_db( specialization843_a, Spl1 ),
	test_data( specialization843, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization844) :-
	spl_db( specialization844_a, Spl1 ),
	test_data( specialization844, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization845) :-
	spl_db( specialization845_a, Spl1 ),
	test_data( specialization845, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization846) :-
	spl_db( specialization846_a, Spl1 ),
	test_data( specialization846, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization847) :-
	spl_db( specialization847_a, Spl1 ),
	test_data( specialization847, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization848) :-
	spl_db( specialization848_a, Spl1 ),
	test_data( specialization848, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization849) :-
	spl_db( specialization849_a, Spl1 ),
	test_data( specialization849, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization850) :-
	spl_db( specialization850_a, Spl1 ),
	test_data( specialization850, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization851) :-
	spl_db( specialization851_a, Spl1 ),
	test_data( specialization851, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization852) :-
	spl_db( specialization852_a, Spl1 ),
	test_data( specialization852, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization853) :-
	spl_db( specialization853_a, Spl1 ),
	test_data( specialization853, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization854) :-
	spl_db( specialization854_a, Spl1 ),
	test_data( specialization854, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization855) :-
	spl_db( specialization855_a, Spl1 ),
	test_data( specialization855, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization856) :-
	spl_db( specialization856_a, Spl1 ),
	test_data( specialization856, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization857) :-
	spl_db( specialization857_a, Spl1 ),
	test_data( specialization857, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization858) :-
	spl_db( specialization858_a, Spl1 ),
	test_data( specialization858, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization859) :-
	spl_db( specialization859_a, Spl1 ),
	test_data( specialization859, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization860) :-
	spl_db( specialization860_a, Spl1 ),
	test_data( specialization860, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization861) :-
	spl_db( specialization861_a, Spl1 ),
	test_data( specialization861, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization862) :-
	spl_db( specialization862_a, Spl1 ),
	test_data( specialization862, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization863) :-
	spl_db( specialization863_a, Spl1 ),
	test_data( specialization863, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization864) :-
	spl_db( specialization864_a, Spl1 ),
	test_data( specialization864, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization865) :-
	spl_db( specialization865_a, Spl1 ),
	test_data( specialization865, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization866) :-
	spl_db( specialization866_a, Spl1 ),
	test_data( specialization866, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization867) :-
	spl_db( specialization867_a, Spl1 ),
	test_data( specialization867, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization868) :-
	spl_db( specialization868_a, Spl1 ),
	test_data( specialization868, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization869) :-
	spl_db( specialization869_a, Spl1 ),
	test_data( specialization869, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization870) :-
	spl_db( specialization870_a, Spl1 ),
	test_data( specialization870, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization871) :-
	spl_db( specialization871_a, Spl1 ),
	test_data( specialization871, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization872) :-
	spl_db( specialization872_a, Spl1 ),
	test_data( specialization872, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization873) :-
	spl_db( specialization873_a, Spl1 ),
	test_data( specialization873, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization874) :-
	spl_db( specialization874_a, Spl1 ),
	test_data( specialization874, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization875) :-
	spl_db( specialization875_a, Spl1 ),
	test_data( specialization875, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization876) :-
	spl_db( specialization876_a, Spl1 ),
	test_data( specialization876, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization877) :-
	spl_db( specialization877_a, Spl1 ),
	test_data( specialization877, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization878) :-
	spl_db( specialization878_a, Spl1 ),
	test_data( specialization878, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization879) :-
	spl_db( specialization879_a, Spl1 ),
	test_data( specialization879, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization880) :-
	spl_db( specialization880_a, Spl1 ),
	test_data( specialization880, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization881) :-
	spl_db( specialization881_a, Spl1 ),
	test_data( specialization881, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization882) :-
	spl_db( specialization882_a, Spl1 ),
	test_data( specialization882, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization883) :-
	spl_db( specialization883_a, Spl1 ),
	test_data( specialization883, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization884) :-
	spl_db( specialization884_a, Spl1 ),
	test_data( specialization884, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization885) :-
	spl_db( specialization885_a, Spl1 ),
	test_data( specialization885, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization886) :-
	spl_db( specialization886_a, Spl1 ),
	test_data( specialization886, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization887) :-
	spl_db( specialization887_a, Spl1 ),
	test_data( specialization887, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization888) :-
	spl_db( specialization888_a, Spl1 ),
	test_data( specialization888, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization889) :-
	spl_db( specialization889_a, Spl1 ),
	test_data( specialization889, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization890) :-
	spl_db( specialization890_a, Spl1 ),
	test_data( specialization890, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization891) :-
	spl_db( specialization891_a, Spl1 ),
	test_data( specialization891, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization892) :-
	spl_db( specialization892_a, Spl1 ),
	test_data( specialization892, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization893) :-
	spl_db( specialization893_a, Spl1 ),
	test_data( specialization893, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization894) :-
	spl_db( specialization894_a, Spl1 ),
	test_data( specialization894, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization895) :-
	spl_db( specialization895_a, Spl1 ),
	test_data( specialization895, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization896) :-
	spl_db( specialization896_a, Spl1 ),
	test_data( specialization896, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization897) :-
	spl_db( specialization897_a, Spl1 ),
	test_data( specialization897, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization898) :-
	spl_db( specialization898_a, Spl1 ),
	test_data( specialization898, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization899) :-
	spl_db( specialization899_a, Spl1 ),
	test_data( specialization899, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization900) :-
	spl_db( specialization900_a, Spl1 ),
	test_data( specialization900, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization901) :-
	spl_db( specialization901_a, Spl1 ),
	test_data( specialization901, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization902) :-
	spl_db( specialization902_a, Spl1 ),
	test_data( specialization902, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization903) :-
	spl_db( specialization903_a, Spl1 ),
	test_data( specialization903, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization904) :-
	spl_db( specialization904_a, Spl1 ),
	test_data( specialization904, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization905) :-
	spl_db( specialization905_a, Spl1 ),
	test_data( specialization905, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization906) :-
	spl_db( specialization906_a, Spl1 ),
	test_data( specialization906, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization907) :-
	spl_db( specialization907_a, Spl1 ),
	test_data( specialization907, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization908) :-
	spl_db( specialization908_a, Spl1 ),
	test_data( specialization908, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization909) :-
	spl_db( specialization909_a, Spl1 ),
	test_data( specialization909, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization910) :-
	spl_db( specialization910_a, Spl1 ),
	test_data( specialization910, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization911) :-
	spl_db( specialization911_a, Spl1 ),
	test_data( specialization911, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization912) :-
	spl_db( specialization912_a, Spl1 ),
	test_data( specialization912, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization913) :-
	spl_db( specialization913_a, Spl1 ),
	test_data( specialization913, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization914) :-
	spl_db( specialization914_a, Spl1 ),
	test_data( specialization914, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization915) :-
	spl_db( specialization915_a, Spl1 ),
	test_data( specialization915, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization916) :-
	spl_db( specialization916_a, Spl1 ),
	test_data( specialization916, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization917) :-
	spl_db( specialization917_a, Spl1 ),
	test_data( specialization917, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization918) :-
	spl_db( specialization918_a, Spl1 ),
	test_data( specialization918, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization919) :-
	spl_db( specialization919_a, Spl1 ),
	test_data( specialization919, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization920) :-
	spl_db( specialization920_a, Spl1 ),
	test_data( specialization920, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization921) :-
	spl_db( specialization921_a, Spl1 ),
	test_data( specialization921, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization922) :-
	spl_db( specialization922_a, Spl1 ),
	test_data( specialization922, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization923) :-
	spl_db( specialization923_a, Spl1 ),
	test_data( specialization923, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization924) :-
	spl_db( specialization924_a, Spl1 ),
	test_data( specialization924, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization925) :-
	spl_db( specialization925_a, Spl1 ),
	test_data( specialization925, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization926) :-
	spl_db( specialization926_a, Spl1 ),
	test_data( specialization926, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization927) :-
	spl_db( specialization927_a, Spl1 ),
	test_data( specialization927, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization928) :-
	spl_db( specialization928_a, Spl1 ),
	test_data( specialization928, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization929) :-
	spl_db( specialization929_a, Spl1 ),
	test_data( specialization929, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization930) :-
	spl_db( specialization930_a, Spl1 ),
	test_data( specialization930, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization931) :-
	spl_db( specialization931_a, Spl1 ),
	test_data( specialization931, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization932) :-
	spl_db( specialization932_a, Spl1 ),
	test_data( specialization932, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization933) :-
	spl_db( specialization933_a, Spl1 ),
	test_data( specialization933, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization934) :-
	spl_db( specialization934_a, Spl1 ),
	test_data( specialization934, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization935) :-
	spl_db( specialization935_a, Spl1 ),
	test_data( specialization935, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization936) :-
	spl_db( specialization936_a, Spl1 ),
	test_data( specialization936, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization937) :-
	spl_db( specialization937_a, Spl1 ),
	test_data( specialization937, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization938) :-
	spl_db( specialization938_a, Spl1 ),
	test_data( specialization938, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization939) :-
	spl_db( specialization939_a, Spl1 ),
	test_data( specialization939, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization940) :-
	spl_db( specialization940_a, Spl1 ),
	test_data( specialization940, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization941) :-
	spl_db( specialization941_a, Spl1 ),
	test_data( specialization941, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization942) :-
	spl_db( specialization942_a, Spl1 ),
	test_data( specialization942, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization943) :-
	spl_db( specialization943_a, Spl1 ),
	test_data( specialization943, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization944) :-
	spl_db( specialization944_a, Spl1 ),
	test_data( specialization944, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization945) :-
	spl_db( specialization945_a, Spl1 ),
	test_data( specialization945, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization946) :-
	spl_db( specialization946_a, Spl1 ),
	test_data( specialization946, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization947) :-
	spl_db( specialization947_a, Spl1 ),
	test_data( specialization947, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization948) :-
	spl_db( specialization948_a, Spl1 ),
	test_data( specialization948, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization949) :-
	spl_db( specialization949_a, Spl1 ),
	test_data( specialization949, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization950) :-
	spl_db( specialization950_a, Spl1 ),
	test_data( specialization950, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization951) :-
	spl_db( specialization951_a, Spl1 ),
	test_data( specialization951, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization952) :-
	spl_db( specialization952_a, Spl1 ),
	test_data( specialization952, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization953) :-
	spl_db( specialization953_a, Spl1 ),
	test_data( specialization953, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization954) :-
	spl_db( specialization954_a, Spl1 ),
	test_data( specialization954, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization955) :-
	spl_db( specialization955_a, Spl1 ),
	test_data( specialization955, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization956) :-
	spl_db( specialization956_a, Spl1 ),
	test_data( specialization956, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization957) :-
	spl_db( specialization957_a, Spl1 ),
	test_data( specialization957, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization958) :-
	spl_db( specialization958_a, Spl1 ),
	test_data( specialization958, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization959) :-
	spl_db( specialization959_a, Spl1 ),
	test_data( specialization959, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization960) :-
	spl_db( specialization960_a, Spl1 ),
	test_data( specialization960, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization961) :-
	spl_db( specialization961_a, Spl1 ),
	test_data( specialization961, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization962) :-
	spl_db( specialization962_a, Spl1 ),
	test_data( specialization962, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization963) :-
	spl_db( specialization963_a, Spl1 ),
	test_data( specialization963, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization964) :-
	spl_db( specialization964_a, Spl1 ),
	test_data( specialization964, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization965) :-
	spl_db( specialization965_a, Spl1 ),
	test_data( specialization965, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization966) :-
	spl_db( specialization966_a, Spl1 ),
	test_data( specialization966, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization967) :-
	spl_db( specialization967_a, Spl1 ),
	test_data( specialization967, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization968) :-
	spl_db( specialization968_a, Spl1 ),
	test_data( specialization968, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization969) :-
	spl_db( specialization969_a, Spl1 ),
	test_data( specialization969, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization970) :-
	spl_db( specialization970_a, Spl1 ),
	test_data( specialization970, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization971) :-
	spl_db( specialization971_a, Spl1 ),
	test_data( specialization971, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization972) :-
	spl_db( specialization972_a, Spl1 ),
	test_data( specialization972, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization973) :-
	spl_db( specialization973_a, Spl1 ),
	test_data( specialization973, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization974) :-
	spl_db( specialization974_a, Spl1 ),
	test_data( specialization974, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization975) :-
	spl_db( specialization975_a, Spl1 ),
	test_data( specialization975, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization976) :-
	spl_db( specialization976_a, Spl1 ),
	test_data( specialization976, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization977) :-
	spl_db( specialization977_a, Spl1 ),
	test_data( specialization977, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization978) :-
	spl_db( specialization978_a, Spl1 ),
	test_data( specialization978, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization979) :-
	spl_db( specialization979_a, Spl1 ),
	test_data( specialization979, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization980) :-
	spl_db( specialization980_a, Spl1 ),
	test_data( specialization980, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization981) :-
	spl_db( specialization981_a, Spl1 ),
	test_data( specialization981, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization982) :-
	spl_db( specialization982_a, Spl1 ),
	test_data( specialization982, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization983) :-
	spl_db( specialization983_a, Spl1 ),
	test_data( specialization983, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization984) :-
	spl_db( specialization984_a, Spl1 ),
	test_data( specialization984, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization985) :-
	spl_db( specialization985_a, Spl1 ),
	test_data( specialization985, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization986) :-
	spl_db( specialization986_a, Spl1 ),
	test_data( specialization986, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization987) :-
	spl_db( specialization987_a, Spl1 ),
	test_data( specialization987, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization988) :-
	spl_db( specialization988_a, Spl1 ),
	test_data( specialization988, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization989) :-
	spl_db( specialization989_a, Spl1 ),
	test_data( specialization989, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization990) :-
	spl_db( specialization990_a, Spl1 ),
	test_data( specialization990, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization991) :-
	spl_db( specialization991_a, Spl1 ),
	test_data( specialization991, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization992) :-
	spl_db( specialization992_a, Spl1 ),
	test_data( specialization992, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization993) :-
	spl_db( specialization993_a, Spl1 ),
	test_data( specialization993, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization994) :-
	spl_db( specialization994_a, Spl1 ),
	test_data( specialization994, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization995) :-
	spl_db( specialization995_a, Spl1 ),
	test_data( specialization995, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization996) :-
	spl_db( specialization996_a, Spl1 ),
	test_data( specialization996, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization997) :-
	spl_db( specialization997_a, Spl1 ),
	test_data( specialization997, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization998) :-
	spl_db( specialization998_a, Spl1 ),
	test_data( specialization998, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

test(specialization999) :-
	spl_db( specialization999_a, Spl1 ),
	test_data( specialization999, specialization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isSpecialisedSpl(Spl1,Spl2,Expected_result), !.

:- end_tests(specialization).