% ---------------
% Auxiliary predicates to support true/false as a parameter.
% ---------------
isGeneralisedSpl(Spl1,Spl2,true) :- !, generalization(Spl1,Spl2).
isGeneralisedSpl(Spl1,Spl2,false) :-  !, not(generalization(Spl1,Spl2)).



% ---------------
spl_db( generalization0_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization0_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f3 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(generalization0,generalization,generalization0_b, true).


% ---------------
spl_db( generalization1_a,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization1_b,
	 spl( [ root, f1, f4, f6, f7, f8, f9, f5, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization1,generalization,generalization1_b, false).


% ---------------
spl_db( generalization2_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization2_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f5 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization2,generalization,generalization2_b, true).


% ---------------
spl_db( generalization3_a,
	 spl( [ root, f1, f3, f4, f9, f5, f7, f8, f6, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

spl_db( generalization3_b,
	 spl( [ root, f1, f3, f4, f9, f5, f7, f8, f6, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization3,generalization,generalization3_b, false).


% ---------------
spl_db( generalization4_a,
	 spl( [ root, f1, f3, f7, f8, f9, f4, f5, f6, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f7, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization4_b,
	 spl( [ root, f1, f3, f7, f8, f9, f4, f5, f6, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f7, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(generalization4,generalization,generalization4_b, true).


% ---------------
spl_db( generalization5_a,
	 spl( [ root, f1, f7, f8, f9, f2, f5, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization5_b,
	 spl( [ root, f1, f7, f8, f9, f2, f5, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f8 , f9 ), excludes( f9 , f5 ) ]
		)
	)
).

test_data(generalization5,generalization,generalization5_b, true).


% ---------------
spl_db( generalization6_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ), excludes( f5 , f2 ), requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization6_b,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(generalization6,generalization,generalization6_b, false).


% ---------------
spl_db( generalization7_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f5 ), excludes( f7 , f3 ) ]
		)
	)
).

spl_db( generalization7_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(generalization7,generalization,generalization7_b, false).


% ---------------
spl_db( generalization8_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

spl_db( generalization8_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f4 ), excludes( f3 , f2 ) ]
		)
	)
).

test_data(generalization8,generalization,generalization8_b, true).


% ---------------
spl_db( generalization9_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f3 ), excludes( f8 , f3 ) ]
		)
	)
).

spl_db( generalization9_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(generalization9,generalization,generalization9_b, false).


% ---------------
spl_db( generalization10_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization10_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

test_data(generalization10,generalization,generalization10_b, true).


% ---------------
spl_db( generalization11_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

spl_db( generalization11_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(generalization11,generalization,generalization11_b, true).


% ---------------
spl_db( generalization12_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( generalization12_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization12,generalization,generalization12_b, false).


% ---------------
spl_db( generalization13_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f4 ), requires( f6 , f4 ) ]
		)
	)
).

spl_db( generalization13_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization13,generalization,generalization13_b, false).


% ---------------
spl_db( generalization14_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ), requires( f3 , f1 ) ]
		)
	)
).

spl_db( generalization14_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(generalization14,generalization,generalization14_b, false).


% ---------------
spl_db( generalization15_a,
	 spl( [ root, f1, f2, f3, f8, f4, f6, f7, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

spl_db( generalization15_b,
	 spl( [ root, f1, f2, f3, f8, f4, f6, f7, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization15,generalization,generalization15_b, false).


% ---------------
spl_db( generalization16_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), requires( f2 , f7 ) ]
		)
	)
).

spl_db( generalization16_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization16,generalization,generalization16_b, false).


% ---------------
spl_db( generalization17_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization17_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(generalization17,generalization,generalization17_b, false).


% ---------------
spl_db( generalization18_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f3 , f2 ) ]
		)
	)
).

spl_db( generalization18_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f3 , f2 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(generalization18,generalization,generalization18_b, true).


% ---------------
spl_db( generalization19_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( generalization19_b,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization19,generalization,generalization19_b, false).


% ---------------
spl_db( generalization20_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f4 , f6 ) ]
		)
	)
).

spl_db( generalization20_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization20,generalization,generalization20_b, false).


% ---------------
spl_db( generalization21_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f8 , f3 ), excludes( f6 , f8 ) ]
		)
	)
).

spl_db( generalization21_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

test_data(generalization21,generalization,generalization21_b, false).


% ---------------
spl_db( generalization22_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization22_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(generalization22,generalization,generalization22_b, true).


% ---------------
spl_db( generalization23_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization23_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f9 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(generalization23,generalization,generalization23_b, true).


% ---------------
spl_db( generalization24_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization24_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization24,generalization,generalization24_b, false).


% ---------------
spl_db( generalization25_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f4 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization25_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization25,generalization,generalization25_b, false).


% ---------------
spl_db( generalization26_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization26_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f8 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization26,generalization,generalization26_b, true).


% ---------------
spl_db( generalization27_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization27_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f2 , f1 ) ]
		)
	)
).

test_data(generalization27,generalization,generalization27_b, true).


% ---------------
spl_db( generalization28_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f7 , f4 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( generalization28_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(generalization28,generalization,generalization28_b, false).


% ---------------
spl_db( generalization29_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

spl_db( generalization29_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization29,generalization,generalization29_b, false).


% ---------------
spl_db( generalization30_a,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

spl_db( generalization30_b,
	 spl( [ root, f1, f2, f8, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f4 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(generalization30,generalization,generalization30_b, true).


% ---------------
spl_db( generalization31_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f5 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization31_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization31,generalization,generalization31_b, false).


% ---------------
spl_db( generalization32_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

spl_db( generalization32_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization32,generalization,generalization32_b, false).


% ---------------
spl_db( generalization33_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), requires( f5 , f6 ) ]
		)
	)
).

spl_db( generalization33_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(generalization33,generalization,generalization33_b, false).


% ---------------
spl_db( generalization34_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization34_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(generalization34,generalization,generalization34_b, true).


% ---------------
spl_db( generalization35_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), requires( f3 , f5 ) ]
		)
	)
).

spl_db( generalization35_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization35,generalization,generalization35_b, false).


% ---------------
spl_db( generalization36_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization36_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f4 ) ]
		)
	)
).

test_data(generalization36,generalization,generalization36_b, true).


% ---------------
spl_db( generalization37_a,
	 spl( [ root, f1, f7, f9, f8, f2, f5, f6, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization37_b,
	 spl( [ root, f1, f7, f9, f8, f2, f5, f6, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(generalization37,generalization,generalization37_b, true).


% ---------------
spl_db( generalization38_a,
	 spl( [ root, f1, f3, f5, f6, f7, f9, f8, f4, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization38_b,
	 spl( [ root, f1, f3, f5, f6, f7, f9, f8, f4, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(generalization38,generalization,generalization38_b, true).


% ---------------
spl_db( generalization39_a,
	 spl( [ root, f1, f2, f3, f6, f8, f7, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization39_b,
	 spl( [ root, f1, f2, f3, f6, f8, f7, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization39,generalization,generalization39_b, false).


% ---------------
spl_db( generalization40_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f6 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( generalization40_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization40,generalization,generalization40_b, false).


% ---------------
spl_db( generalization41_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( generalization41_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization41,generalization,generalization41_b, false).


% ---------------
spl_db( generalization42_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

spl_db( generalization42_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f7 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(generalization42,generalization,generalization42_b, true).


% ---------------
spl_db( generalization43_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization43_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(generalization43,generalization,generalization43_b, true).


% ---------------
spl_db( generalization44_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

spl_db( generalization44_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization44,generalization,generalization44_b, false).


% ---------------
spl_db( generalization45_a,
	 spl( [ root, f1, f2, f5, f6, f3, f4, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f6 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization45_b,
	 spl( [ root, f1, f2, f5, f6, f3, f4, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ), feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization45,generalization,generalization45_b, false).


% ---------------
spl_db( generalization46_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f3 ), excludes( f8 , f3 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization46_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f3 ), excludes( f8 , f3 ) ]
		)
	)
).

test_data(generalization46,generalization,generalization46_b, false).


% ---------------
spl_db( generalization47_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization47_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f5 ), requires( f2 , f9 ) ]
		)
	)
).

test_data(generalization47,generalization,generalization47_b, true).


% ---------------
spl_db( generalization48_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f5 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization48_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(generalization48,generalization,generalization48_b, false).


% ---------------
spl_db( generalization49_a,
	 spl( [ root, f1, f3, f4, f5, f8, f9, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

spl_db( generalization49_b,
	 spl( [ root, f1, f3, f4, f5, f8, f9, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization49,generalization,generalization49_b, false).


% ---------------
spl_db( generalization50_a,
	 spl( [ root, f1, f3, f2, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization50_b,
	 spl( [ root, f1, f3, f2, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

test_data(generalization50,generalization,generalization50_b, true).


% ---------------
spl_db( generalization51_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization51_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(generalization51,generalization,generalization51_b, true).


% ---------------
spl_db( generalization52_a,
	 spl( [ root, f1, f8, f9, f2, f5, f7, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

spl_db( generalization52_b,
	 spl( [ root, f1, f8, f9, f2, f5, f7, f6, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(generalization52,generalization,generalization52_b, true).


% ---------------
spl_db( generalization53_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization53_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f7 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(generalization53,generalization,generalization53_b, true).


% ---------------
spl_db( generalization54_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f7 ), excludes( f1 , f6 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( generalization54_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(generalization54,generalization,generalization54_b, false).


% ---------------
spl_db( generalization55_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f4 ), requires( f9 , f5 ), excludes( f6 , f1 ) ]
		)
	)
).

spl_db( generalization55_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization55,generalization,generalization55_b, false).


% ---------------
spl_db( generalization56_a,
	 spl( [ root, f1, f2, f5, f6, f3, f4, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization56_b,
	 spl( [ root, f1, f2, f5, f6, f3, f4, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(generalization56,generalization,generalization56_b, true).


% ---------------
spl_db( generalization57_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization57_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f5 ), excludes( f9 , f7 ) ]
		)
	)
).

test_data(generalization57,generalization,generalization57_b, true).


% ---------------
spl_db( generalization58_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization58_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f3 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization58,generalization,generalization58_b, true).


% ---------------
spl_db( generalization59_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f2 ), excludes( f5 , f6 ) ]
		)
	)
).

spl_db( generalization59_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization59,generalization,generalization59_b, false).


% ---------------
spl_db( generalization60_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization60_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f3 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(generalization60,generalization,generalization60_b, true).


% ---------------
spl_db( generalization61_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f2 ), excludes( f4 , f6 ) ]
		)
	)
).

spl_db( generalization61_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization61,generalization,generalization61_b, false).


% ---------------
spl_db( generalization62_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization62_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f4 ), requires( f6 , f3 ) ]
		)
	)
).

test_data(generalization62,generalization,generalization62_b, true).


% ---------------
spl_db( generalization63_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization63_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization63,generalization,generalization63_b, false).


% ---------------
spl_db( generalization64_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f8 , f7 ) ]
		)
	)
).

spl_db( generalization64_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

test_data(generalization64,generalization,generalization64_b, false).


% ---------------
spl_db( generalization65_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

spl_db( generalization65_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f7 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization65,generalization,generalization65_b, true).


% ---------------
spl_db( generalization66_a,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

spl_db( generalization66_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization66,generalization,generalization66_b, false).


% ---------------
spl_db( generalization67_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f7 , f6 ), excludes( f2 , f8 ) ]
		)
	)
).

spl_db( generalization67_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization67,generalization,generalization67_b, false).


% ---------------
spl_db( generalization68_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f9 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( generalization68_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization68,generalization,generalization68_b, false).


% ---------------
spl_db( generalization69_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization69_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f4 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization69,generalization,generalization69_b, true).


% ---------------
spl_db( generalization70_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization70_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(generalization70,generalization,generalization70_b, true).


% ---------------
spl_db( generalization71_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

spl_db( generalization71_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization71,generalization,generalization71_b, true).


% ---------------
spl_db( generalization72_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f6 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization72_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization72,generalization,generalization72_b, false).


% ---------------
spl_db( generalization73_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ), excludes( f8 , f9 ) ]
		)
	)
).

spl_db( generalization73_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization73,generalization,generalization73_b, false).


% ---------------
spl_db( generalization74_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f4 ), excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization74_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization74,generalization,generalization74_b, false).


% ---------------
spl_db( generalization75_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

spl_db( generalization75_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization75,generalization,generalization75_b, false).


% ---------------
spl_db( generalization76_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

spl_db( generalization76_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f7 ), excludes( f5 , f9 ) ]
		)
	)
).

test_data(generalization76,generalization,generalization76_b, true).


% ---------------
spl_db( generalization77_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization77_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f2 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization77,generalization,generalization77_b, true).


% ---------------
spl_db( generalization78_a,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f3, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization78_b,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f3, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(generalization78,generalization,generalization78_b, true).


% ---------------
spl_db( generalization79_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f5 , f7 ), requires( f4 , f1 ) ]
		)
	)
).

spl_db( generalization79_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization79,generalization,generalization79_b, false).


% ---------------
spl_db( generalization80_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization80_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization80,generalization,generalization80_b, false).


% ---------------
spl_db( generalization81_a,
	 spl( [ root, f1, f5, f6, f7, f2, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization81_b,
	 spl( [ root, f1, f5, f6, f7, f2, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

test_data(generalization81,generalization,generalization81_b, true).


% ---------------
spl_db( generalization82_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization82_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization82,generalization,generalization82_b, false).


% ---------------
spl_db( generalization83_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization83_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(generalization83,generalization,generalization83_b, true).


% ---------------
spl_db( generalization84_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

spl_db( generalization84_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f3 ), requires( f6 , f8 ) ]
		)
	)
).

test_data(generalization84,generalization,generalization84_b, true).


% ---------------
spl_db( generalization85_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization85_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f5 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(generalization85,generalization,generalization85_b, true).


% ---------------
spl_db( generalization86_a,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [
					mandatory( feature( f9, [] ) ) ] ), feature( f4, [
					mandatory( feature( f6, [
						one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

spl_db( generalization86_b,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [
					mandatory( feature( f9, [] ) ) ] ), feature( f4, [
					mandatory( feature( f6, [
						one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization86,generalization,generalization86_b, false).


% ---------------
spl_db( generalization87_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f3 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization87_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f3 ), requires( f3 , f8 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(generalization87,generalization,generalization87_b, true).


% ---------------
spl_db( generalization88_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f3 , f6 ) ]
		)
	)
).

spl_db( generalization88_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization88,generalization,generalization88_b, false).


% ---------------
spl_db( generalization89_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization89_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f6 ), excludes( f3 , f1 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization89,generalization,generalization89_b, true).


% ---------------
spl_db( generalization90_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( generalization90_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization90,generalization,generalization90_b, false).


% ---------------
spl_db( generalization91_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f3 , f2 ) ]
		)
	)
).

spl_db( generalization91_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization91,generalization,generalization91_b, false).


% ---------------
spl_db( generalization92_a,
	 spl( [ root, f1, f2, f8, f3, f6, f7, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

spl_db( generalization92_b,
	 spl( [ root, f1, f2, f8, f3, f6, f7, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization92,generalization,generalization92_b, false).


% ---------------
spl_db( generalization93_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

spl_db( generalization93_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(generalization93,generalization,generalization93_b, true).


% ---------------
spl_db( generalization94_a,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f9 , f6 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( generalization94_b,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization94,generalization,generalization94_b, false).


% ---------------
spl_db( generalization95_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

spl_db( generalization95_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(generalization95,generalization,generalization95_b, true).


% ---------------
spl_db( generalization96_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization96_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(generalization96,generalization,generalization96_b, true).


% ---------------
spl_db( generalization97_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization97_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization97,generalization,generalization97_b, true).


% ---------------
spl_db( generalization98_a,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f2 ) ]
		)
	)
).

spl_db( generalization98_b,
	 spl( [ root, f1, f2, f5, f6, f7, f3, f8, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f2 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization98,generalization,generalization98_b, true).


% ---------------
spl_db( generalization99_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

spl_db( generalization99_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), excludes( f8 , f5 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(generalization99,generalization,generalization99_b, true).


% ---------------
spl_db( generalization100_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

spl_db( generalization100_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f5 ), requires( f8 , f4 ), excludes( f8 , f3 ) ]
		)
	)
).

test_data(generalization100,generalization,generalization100_b, true).


% ---------------
spl_db( generalization101_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization101_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization101,generalization,generalization101_b, true).


% ---------------
spl_db( generalization102_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f9 ), excludes( f3 , f2 ) ]
		)
	)
).

spl_db( generalization102_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization102,generalization,generalization102_b, false).


% ---------------
spl_db( generalization103_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( generalization103_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(generalization103,generalization,generalization103_b, true).


% ---------------
spl_db( generalization104_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization104_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(generalization104,generalization,generalization104_b, true).


% ---------------
spl_db( generalization105_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization105_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(generalization105,generalization,generalization105_b, true).


% ---------------
spl_db( generalization106_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization106_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(generalization106,generalization,generalization106_b, true).


% ---------------
spl_db( generalization107_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization107_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(generalization107,generalization,generalization107_b, true).


% ---------------
spl_db( generalization108_a,
	 spl( [ root, f1, f2, f6, f9, f3, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f5 , f8 ) ]
		)
	)
).

spl_db( generalization108_b,
	 spl( [ root, f1, f2, f6, f9, f3, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f5 , f8 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(generalization108,generalization,generalization108_b, true).


% ---------------
spl_db( generalization109_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization109_b,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(generalization109,generalization,generalization109_b, true).


% ---------------
spl_db( generalization110_a,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization110_b,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(generalization110,generalization,generalization110_b, true).


% ---------------
spl_db( generalization111_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization111_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f7 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(generalization111,generalization,generalization111_b, true).


% ---------------
spl_db( generalization112_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f9 ), requires( f4 , f9 ) ]
		)
	)
).

spl_db( generalization112_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization112,generalization,generalization112_b, false).


% ---------------
spl_db( generalization113_a,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f2 , f5 ) ]
		)
	)
).

spl_db( generalization113_b,
	 spl( [ root, f1, f2, f7, f9, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization113,generalization,generalization113_b, false).


% ---------------
spl_db( generalization114_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization114_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(generalization114,generalization,generalization114_b, true).


% ---------------
spl_db( generalization115_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization115_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f5 , f8 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(generalization115,generalization,generalization115_b, true).


% ---------------
spl_db( generalization116_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( generalization116_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f4 ), requires( f6 , f8 ) ]
		)
	)
).

test_data(generalization116,generalization,generalization116_b, true).


% ---------------
spl_db( generalization117_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization117_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(generalization117,generalization,generalization117_b, true).


% ---------------
spl_db( generalization118_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

spl_db( generalization118_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f7 , f3 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(generalization118,generalization,generalization118_b, true).


% ---------------
spl_db( generalization119_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( generalization119_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(generalization119,generalization,generalization119_b, true).


% ---------------
spl_db( generalization120_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

spl_db( generalization120_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f1 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(generalization120,generalization,generalization120_b, true).


% ---------------
spl_db( generalization121_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ), requires( f4 , f3 ) ]
		)
	)
).

spl_db( generalization121_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization121,generalization,generalization121_b, false).


% ---------------
spl_db( generalization122_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization122_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f8 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(generalization122,generalization,generalization122_b, true).


% ---------------
spl_db( generalization123_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

spl_db( generalization123_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization123,generalization,generalization123_b, false).


% ---------------
spl_db( generalization124_a,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization124_b,
	 spl( [ root, f1, f2, f6, f7, f9, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f7 , f4 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(generalization124,generalization,generalization124_b, true).


% ---------------
spl_db( generalization125_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( generalization125_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization125,generalization,generalization125_b, true).


% ---------------
spl_db( generalization126_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization126_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f7 ), excludes( f9 , f4 ) ]
		)
	)
).

test_data(generalization126,generalization,generalization126_b, true).


% ---------------
spl_db( generalization127_a,
	 spl( [ root, f1, f3, f4, f5, f7, f8, f6, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

spl_db( generalization127_b,
	 spl( [ root, f1, f3, f4, f5, f7, f8, f6, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ), requires( f9 , f8 ), requires( f2 , f3 ) ]
		)
	)
).

test_data(generalization127,generalization,generalization127_b, true).


% ---------------
spl_db( generalization128_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f9 ), excludes( f4 , f1 ) ]
		)
	)
).

spl_db( generalization128_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

test_data(generalization128,generalization,generalization128_b, false).


% ---------------
spl_db( generalization129_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f2 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( generalization129_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization129,generalization,generalization129_b, false).


% ---------------
spl_db( generalization130_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f4 ), excludes( f3 , f9 ) ]
		)
	)
).

spl_db( generalization130_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(generalization130,generalization,generalization130_b, false).


% ---------------
spl_db( generalization131_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization131_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization131,generalization,generalization131_b, false).


% ---------------
spl_db( generalization132_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

spl_db( generalization132_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f9 ), excludes( f2 , f3 ) ]
		)
	)
).

test_data(generalization132,generalization,generalization132_b, true).


% ---------------
spl_db( generalization133_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f7 ), requires( f4 , f5 ), requires( f9 , f5 ) ]
		)
	)
).

spl_db( generalization133_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f7 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(generalization133,generalization,generalization133_b, false).


% ---------------
spl_db( generalization134_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization134_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(generalization134,generalization,generalization134_b, true).


% ---------------
spl_db( generalization135_a,
	 spl( [ root, f1, f5, f6, f9, f2, f3, f4, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( generalization135_b,
	 spl( [ root, f1, f5, f6, f9, f2, f3, f4, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization135,generalization,generalization135_b, false).


% ---------------
spl_db( generalization136_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( generalization136_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization136,generalization,generalization136_b, false).


% ---------------
spl_db( generalization137_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f5 , f7 ) ]
		)
	)
).

spl_db( generalization137_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f5 , f7 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization137,generalization,generalization137_b, true).


% ---------------
spl_db( generalization138_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization138_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(generalization138,generalization,generalization138_b, true).


% ---------------
spl_db( generalization139_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

spl_db( generalization139_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f2 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization139,generalization,generalization139_b, true).


% ---------------
spl_db( generalization140_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f1 ) ]
		)
	)
).

spl_db( generalization140_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f9 , f1 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(generalization140,generalization,generalization140_b, true).


% ---------------
spl_db( generalization141_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f6 ) ]
		)
	)
).

spl_db( generalization141_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(generalization141,generalization,generalization141_b, true).


% ---------------
spl_db( generalization142_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f2 ), requires( f2 , f8 ) ]
		)
	)
).

spl_db( generalization142_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(generalization142,generalization,generalization142_b, false).


% ---------------
spl_db( generalization143_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

spl_db( generalization143_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f2 ), excludes( f6 , f5 ) ]
		)
	)
).

test_data(generalization143,generalization,generalization143_b, true).


% ---------------
spl_db( generalization144_a,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f2 , f6 ), excludes( f6 , f8 ) ]
		)
	)
).

spl_db( generalization144_b,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(generalization144,generalization,generalization144_b, false).


% ---------------
spl_db( generalization145_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization145_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f3 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(generalization145,generalization,generalization145_b, true).


% ---------------
spl_db( generalization146_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization146_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

test_data(generalization146,generalization,generalization146_b, true).


% ---------------
spl_db( generalization147_a,
	 spl( [ root, f1, f4, f2, f3, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization147_b,
	 spl( [ root, f1, f4, f2, f3, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(generalization147,generalization,generalization147_b, true).


% ---------------
spl_db( generalization148_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization148_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(generalization148,generalization,generalization148_b, true).


% ---------------
spl_db( generalization149_a,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f9 ), requires( f2 , f1 ), excludes( f7 , f9 ) ]
		)
	)
).

spl_db( generalization149_b,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization149,generalization,generalization149_b, false).


% ---------------
spl_db( generalization150_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization150_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(generalization150,generalization,generalization150_b, true).


% ---------------
spl_db( generalization151_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( generalization151_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization151,generalization,generalization151_b, false).


% ---------------
spl_db( generalization152_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

spl_db( generalization152_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f5 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization152,generalization,generalization152_b, true).


% ---------------
spl_db( generalization153_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization153_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(generalization153,generalization,generalization153_b, false).


% ---------------
spl_db( generalization154_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization154_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f3 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(generalization154,generalization,generalization154_b, true).


% ---------------
spl_db( generalization155_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization155_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization155,generalization,generalization155_b, true).


% ---------------
spl_db( generalization156_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f9 ), excludes( f6 , f2 ) ]
		)
	)
).

spl_db( generalization156_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization156,generalization,generalization156_b, false).


% ---------------
spl_db( generalization157_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f9 ), requires( f7 , f5 ) ]
		)
	)
).

spl_db( generalization157_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization157,generalization,generalization157_b, false).


% ---------------
spl_db( generalization158_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization158_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(generalization158,generalization,generalization158_b, true).


% ---------------
spl_db( generalization159_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

spl_db( generalization159_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(generalization159,generalization,generalization159_b, true).


% ---------------
spl_db( generalization160_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization160_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization160,generalization,generalization160_b, true).


% ---------------
spl_db( generalization161_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization161_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization161,generalization,generalization161_b, false).


% ---------------
spl_db( generalization162_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f4 ), excludes( f5 , f6 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization162_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization162,generalization,generalization162_b, false).


% ---------------
spl_db( generalization163_a,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization163_b,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(generalization163,generalization,generalization163_b, true).


% ---------------
spl_db( generalization164_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization164_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization164,generalization,generalization164_b, false).


% ---------------
spl_db( generalization165_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f8 ), requires( f5 , f3 ) ]
		)
	)
).

spl_db( generalization165_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization165,generalization,generalization165_b, false).


% ---------------
spl_db( generalization166_a,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization166_b,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization166,generalization,generalization166_b, false).


% ---------------
spl_db( generalization167_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ), requires( f6 , f8 ) ]
		)
	)
).

spl_db( generalization167_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(generalization167,generalization,generalization167_b, false).


% ---------------
spl_db( generalization168_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f3 , f2 ), excludes( f5 , f7 ) ]
		)
	)
).

spl_db( generalization168_b,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(generalization168,generalization,generalization168_b, false).


% ---------------
spl_db( generalization169_a,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization169_b,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization169,generalization,generalization169_b, true).


% ---------------
spl_db( generalization170_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization170_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization170,generalization,generalization170_b, true).


% ---------------
spl_db( generalization171_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f3 , f2 ), excludes( f1 , f2 ) ]
		)
	)
).

spl_db( generalization171_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f3 , f2 ) ]
		)
	)
).

test_data(generalization171,generalization,generalization171_b, false).


% ---------------
spl_db( generalization172_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization172_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(generalization172,generalization,generalization172_b, true).


% ---------------
spl_db( generalization173_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization173_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f6 , f1 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization173,generalization,generalization173_b, true).


% ---------------
spl_db( generalization174_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f2 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( generalization174_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(generalization174,generalization,generalization174_b, false).


% ---------------
spl_db( generalization175_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

spl_db( generalization175_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization175,generalization,generalization175_b, false).


% ---------------
spl_db( generalization176_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization176_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

test_data(generalization176,generalization,generalization176_b, true).


% ---------------
spl_db( generalization177_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

spl_db( generalization177_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization177,generalization,generalization177_b, false).


% ---------------
spl_db( generalization178_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f3 ) ]
		)
	)
).

spl_db( generalization178_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f3 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(generalization178,generalization,generalization178_b, true).


% ---------------
spl_db( generalization179_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization179_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f7 ), excludes( f6 , f5 ) ]
		)
	)
).

test_data(generalization179,generalization,generalization179_b, true).


% ---------------
spl_db( generalization180_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization180_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f7 ), requires( f1 , f6 ) ]
		)
	)
).

test_data(generalization180,generalization,generalization180_b, true).


% ---------------
spl_db( generalization181_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization181_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f6 ), requires( f5 , f1 ) ]
		)
	)
).

test_data(generalization181,generalization,generalization181_b, true).


% ---------------
spl_db( generalization182_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f2 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization182_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

test_data(generalization182,generalization,generalization182_b, false).


% ---------------
spl_db( generalization183_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization183_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f2 , f4 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(generalization183,generalization,generalization183_b, true).


% ---------------
spl_db( generalization184_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f5 , f8 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization184_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(generalization184,generalization,generalization184_b, false).


% ---------------
spl_db( generalization185_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f3 ), excludes( f2 , f7 ) ]
		)
	)
).

spl_db( generalization185_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization185,generalization,generalization185_b, false).


% ---------------
spl_db( generalization186_a,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization186_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f9 , f1 ), requires( f4 , f9 ) ]
		)
	)
).

test_data(generalization186,generalization,generalization186_b, true).


% ---------------
spl_db( generalization187_a,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ), excludes( f1 , f5 ) ]
		)
	)
).

spl_db( generalization187_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(generalization187,generalization,generalization187_b, false).


% ---------------
spl_db( generalization188_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f5 ), excludes( f1 , f2 ) ]
		)
	)
).

spl_db( generalization188_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization188,generalization,generalization188_b, false).


% ---------------
spl_db( generalization189_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

spl_db( generalization189_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f6 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(generalization189,generalization,generalization189_b, true).


% ---------------
spl_db( generalization190_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f8 ), excludes( f5 , f4 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( generalization190_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization190,generalization,generalization190_b, false).


% ---------------
spl_db( generalization191_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f6 , f5 ) ]
		)
	)
).

spl_db( generalization191_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(generalization191,generalization,generalization191_b, false).


% ---------------
spl_db( generalization192_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

spl_db( generalization192_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization192,generalization,generalization192_b, false).


% ---------------
spl_db( generalization193_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

spl_db( generalization193_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization193,generalization,generalization193_b, false).


% ---------------
spl_db( generalization194_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f8 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization194_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization194,generalization,generalization194_b, false).


% ---------------
spl_db( generalization195_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( generalization195_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(generalization195,generalization,generalization195_b, false).


% ---------------
spl_db( generalization196_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization196_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f6 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization196,generalization,generalization196_b, true).


% ---------------
spl_db( generalization197_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization197_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(generalization197,generalization,generalization197_b, true).


% ---------------
spl_db( generalization198_a,
	 spl( [ root, f1, f7, f2, f3, f5, f6, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ), feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

spl_db( generalization198_b,
	 spl( [ root, f1, f7, f2, f3, f5, f6, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ), feature( f4, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization198,generalization,generalization198_b, false).


% ---------------
spl_db( generalization199_a,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( generalization199_b,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f6, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f7 , f1 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(generalization199,generalization,generalization199_b, true).


% ---------------
spl_db( generalization200_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f9 , f4 ), excludes( f7 , f6 ) ]
		)
	)
).

spl_db( generalization200_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization200,generalization,generalization200_b, false).


% ---------------
spl_db( generalization201_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f8 , f9 ) ]
		)
	)
).

spl_db( generalization201_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization201,generalization,generalization201_b, false).


% ---------------
spl_db( generalization202_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f9 ), excludes( f1 , f3 ) ]
		)
	)
).

spl_db( generalization202_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization202,generalization,generalization202_b, false).


% ---------------
spl_db( generalization203_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization203_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization203,generalization,generalization203_b, true).


% ---------------
spl_db( generalization204_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), requires( f6 , f8 ) ]
		)
	)
).

spl_db( generalization204_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization204,generalization,generalization204_b, false).


% ---------------
spl_db( generalization205_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization205_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f8 , f1 ) ]
		)
	)
).

test_data(generalization205,generalization,generalization205_b, true).


% ---------------
spl_db( generalization206_a,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f5 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization206_b,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization206,generalization,generalization206_b, false).


% ---------------
spl_db( generalization207_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization207_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f6 , f7 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(generalization207,generalization,generalization207_b, true).


% ---------------
spl_db( generalization208_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), requires( f9 , f1 ) ]
		)
	)
).

spl_db( generalization208_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization208,generalization,generalization208_b, false).


% ---------------
spl_db( generalization209_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization209_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization209,generalization,generalization209_b, false).


% ---------------
spl_db( generalization210_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization210_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), requires( f2 , f7 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(generalization210,generalization,generalization210_b, true).


% ---------------
spl_db( generalization211_a,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

spl_db( generalization211_b,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization211,generalization,generalization211_b, false).


% ---------------
spl_db( generalization212_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization212_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f7 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(generalization212,generalization,generalization212_b, true).


% ---------------
spl_db( generalization213_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f2 , f9 ), excludes( f2 , f4 ) ]
		)
	)
).

spl_db( generalization213_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization213,generalization,generalization213_b, false).


% ---------------
spl_db( generalization214_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f5 ), requires( f6 , f3 ) ]
		)
	)
).

spl_db( generalization214_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(generalization214,generalization,generalization214_b, false).


% ---------------
spl_db( generalization215_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization215_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

test_data(generalization215,generalization,generalization215_b, true).


% ---------------
spl_db( generalization216_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), excludes( f2 , f6 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( generalization216_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

test_data(generalization216,generalization,generalization216_b, false).


% ---------------
spl_db( generalization217_a,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization217_b,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), requires( f9 , f8 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization217,generalization,generalization217_b, true).


% ---------------
spl_db( generalization218_a,
	 spl( [ root, f1, f5, f8, f6, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

spl_db( generalization218_b,
	 spl( [ root, f1, f5, f8, f6, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization218,generalization,generalization218_b, false).


% ---------------
spl_db( generalization219_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f9, [] ) ) ] ), feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f4 , f1 ) ]
		)
	)
).

spl_db( generalization219_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f9, [] ) ) ] ), feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization219,generalization,generalization219_b, false).


% ---------------
spl_db( generalization220_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f5 , f7 ), excludes( f1 , f8 ) ]
		)
	)
).

spl_db( generalization220_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

test_data(generalization220,generalization,generalization220_b, false).


% ---------------
spl_db( generalization221_a,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f6 ), requires( f1 , f5 ) ]
		)
	)
).

spl_db( generalization221_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization221,generalization,generalization221_b, false).


% ---------------
spl_db( generalization222_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization222_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

test_data(generalization222,generalization,generalization222_b, true).


% ---------------
spl_db( generalization223_a,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization223_b,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(generalization223,generalization,generalization223_b, true).


% ---------------
spl_db( generalization224_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( generalization224_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f7 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(generalization224,generalization,generalization224_b, true).


% ---------------
spl_db( generalization225_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), excludes( f2 , f3 ) ]
		)
	)
).

spl_db( generalization225_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(generalization225,generalization,generalization225_b, false).


% ---------------
spl_db( generalization226_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f6 , f8 ) ]
		)
	)
).

spl_db( generalization226_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization226,generalization,generalization226_b, false).


% ---------------
spl_db( generalization227_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f4, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f7 , f8 ) ]
		)
	)
).

spl_db( generalization227_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f4, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(generalization227,generalization,generalization227_b, false).


% ---------------
spl_db( generalization228_a,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

spl_db( generalization228_b,
	 spl( [ root, f1, f2, f3, f9, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization228,generalization,generalization228_b, false).


% ---------------
spl_db( generalization229_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization229_b,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ requires( f1 , f5 ), requires( f2 , f5 ) ]
		)
	)
).

test_data(generalization229,generalization,generalization229_b, true).


% ---------------
spl_db( generalization230_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization230_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(generalization230,generalization,generalization230_b, true).


% ---------------
spl_db( generalization231_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

spl_db( generalization231_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization231,generalization,generalization231_b, false).


% ---------------
spl_db( generalization232_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f7 , f1 ) ]
		)
	)
).

spl_db( generalization232_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization232,generalization,generalization232_b, false).


% ---------------
spl_db( generalization233_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f1 ), excludes( f1 , f9 ) ]
		)
	)
).

spl_db( generalization233_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization233,generalization,generalization233_b, false).


% ---------------
spl_db( generalization234_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f9 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( generalization234_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization234,generalization,generalization234_b, false).


% ---------------
spl_db( generalization235_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization235_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(generalization235,generalization,generalization235_b, true).


% ---------------
spl_db( generalization236_a,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization236_b,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f6 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(generalization236,generalization,generalization236_b, true).


% ---------------
spl_db( generalization237_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f3 , f7 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( generalization237_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization237,generalization,generalization237_b, false).


% ---------------
spl_db( generalization238_a,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization238_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(generalization238,generalization,generalization238_b, true).


% ---------------
spl_db( generalization239_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [
						optional( feature( f5, [
							optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f9 ), excludes( f8 , f2 ) ]
		)
	)
).

spl_db( generalization239_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					optional( feature( f4, [
						optional( feature( f5, [
							optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization239,generalization,generalization239_b, false).


% ---------------
spl_db( generalization240_a,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization240_b,
	 spl( [ root, f1, f5, f2, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f1 , f2 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(generalization240,generalization,generalization240_b, true).


% ---------------
spl_db( generalization241_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( generalization241_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization241,generalization,generalization241_b, false).


% ---------------
spl_db( generalization242_a,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization242_b,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f3 ), requires( f7 , f9 ), excludes( f7 , f4 ) ]
		)
	)
).

test_data(generalization242,generalization,generalization242_b, true).


% ---------------
spl_db( generalization243_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f8 , f7 ), excludes( f5 , f6 ) ]
		)
	)
).

spl_db( generalization243_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(generalization243,generalization,generalization243_b, false).


% ---------------
spl_db( generalization244_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization244_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f1 ), requires( f6 , f9 ) ]
		)
	)
).

test_data(generalization244,generalization,generalization244_b, true).


% ---------------
spl_db( generalization245_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ requires( f7 , f3 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization245_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization245,generalization,generalization245_b, false).


% ---------------
spl_db( generalization246_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization246_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(generalization246,generalization,generalization246_b, true).


% ---------------
spl_db( generalization247_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ) ] ), feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization247_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [
					mandatory( feature( f7, [] ) ) ] ), feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f7 ), excludes( f2 , f8 ) ]
		)
	)
).

test_data(generalization247,generalization,generalization247_b, true).


% ---------------
spl_db( generalization248_a,
	 spl( [ root, f1, f8, f2, f3, f6, f7, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f7 ), excludes( f9 , f4 ) ]
		)
	)
).

spl_db( generalization248_b,
	 spl( [ root, f1, f8, f2, f3, f6, f7, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(generalization248,generalization,generalization248_b, false).


% ---------------
spl_db( generalization249_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization249_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ), requires( f8 , f3 ) ]
		)
	)
).

test_data(generalization249,generalization,generalization249_b, true).


% ---------------
spl_db( generalization250_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization250_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f2 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(generalization250,generalization,generalization250_b, true).


% ---------------
spl_db( generalization251_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization251_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f9 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(generalization251,generalization,generalization251_b, true).


% ---------------
spl_db( generalization252_a,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

spl_db( generalization252_b,
	 spl( [ root, f1, f8, f2, f3, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f9 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(generalization252,generalization,generalization252_b, true).


% ---------------
spl_db( generalization253_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( generalization253_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization253,generalization,generalization253_b, false).


% ---------------
spl_db( generalization254_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

spl_db( generalization254_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization254,generalization,generalization254_b, false).


% ---------------
spl_db( generalization255_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f2 ), excludes( f6 , f4 ) ]
		)
	)
).

spl_db( generalization255_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization255,generalization,generalization255_b, false).


% ---------------
spl_db( generalization256_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

spl_db( generalization256_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f3 , f5 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(generalization256,generalization,generalization256_b, true).


% ---------------
spl_db( generalization257_a,
	 spl( [ root, f1, f4, f8, f9, f5, f6, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

spl_db( generalization257_b,
	 spl( [ root, f1, f4, f8, f9, f5, f6, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization257,generalization,generalization257_b, false).


% ---------------
spl_db( generalization258_a,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f4 , f3 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization258_b,
	 spl( [ root, f1, f5, f6, f7, f9, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization258,generalization,generalization258_b, false).


% ---------------
spl_db( generalization259_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization259_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(generalization259,generalization,generalization259_b, true).


% ---------------
spl_db( generalization260_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f9 ), requires( f3 , f1 ) ]
		)
	)
).

spl_db( generalization260_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization260,generalization,generalization260_b, false).


% ---------------
spl_db( generalization261_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

spl_db( generalization261_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization261,generalization,generalization261_b, false).


% ---------------
spl_db( generalization262_a,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f3 , f5 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization262_b,
	 spl( [ root, f1, f3, f4, f5, f6, f9, f7, f8, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f6, [
						optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(generalization262,generalization,generalization262_b, false).


% ---------------
spl_db( generalization263_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
							mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f5 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization263_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [
							mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization263,generalization,generalization263_b, false).


% ---------------
spl_db( generalization264_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f1 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization264_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization264,generalization,generalization264_b, false).


% ---------------
spl_db( generalization265_a,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization265_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization265,generalization,generalization265_b, true).


% ---------------
spl_db( generalization266_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

spl_db( generalization266_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization266,generalization,generalization266_b, false).


% ---------------
spl_db( generalization267_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

spl_db( generalization267_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f2 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(generalization267,generalization,generalization267_b, true).


% ---------------
spl_db( generalization268_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

spl_db( generalization268_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization268,generalization,generalization268_b, false).


% ---------------
spl_db( generalization269_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f4 ), excludes( f4 , f7 ) ]
		)
	)
).

spl_db( generalization269_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(generalization269,generalization,generalization269_b, false).


% ---------------
spl_db( generalization270_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), requires( f3 , f2 ) ]
		)
	)
).

spl_db( generalization270_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization270,generalization,generalization270_b, false).


% ---------------
spl_db( generalization271_a,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization271_b,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f5 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization271,generalization,generalization271_b, true).


% ---------------
spl_db( generalization272_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization272_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(generalization272,generalization,generalization272_b, true).


% ---------------
spl_db( generalization273_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f3 ), requires( f4 , f6 ) ]
		)
	)
).

spl_db( generalization273_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(generalization273,generalization,generalization273_b, false).


% ---------------
spl_db( generalization274_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f8 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization274_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(generalization274,generalization,generalization274_b, false).


% ---------------
spl_db( generalization275_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization275_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(generalization275,generalization,generalization275_b, true).


% ---------------
spl_db( generalization276_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization276_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization276,generalization,generalization276_b, true).


% ---------------
spl_db( generalization277_a,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

spl_db( generalization277_b,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f1 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(generalization277,generalization,generalization277_b, true).


% ---------------
spl_db( generalization278_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f5 ), requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization278_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization278,generalization,generalization278_b, false).


% ---------------
spl_db( generalization279_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization279_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(generalization279,generalization,generalization279_b, true).


% ---------------
spl_db( generalization280_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization280_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f8 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(generalization280,generalization,generalization280_b, true).


% ---------------
spl_db( generalization281_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization281_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

test_data(generalization281,generalization,generalization281_b, true).


% ---------------
spl_db( generalization282_a,
	 spl( [ root, f1, f4, f5, f7, f8, f2, f6, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization282_b,
	 spl( [ root, f1, f4, f5, f7, f8, f2, f6, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

test_data(generalization282,generalization,generalization282_b, true).


% ---------------
spl_db( generalization283_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization283_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization283,generalization,generalization283_b, false).


% ---------------
spl_db( generalization284_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f1 , f4 ), requires( f9 , f2 ) ]
		)
	)
).

spl_db( generalization284_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization284,generalization,generalization284_b, false).


% ---------------
spl_db( generalization285_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization285_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f5 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization285,generalization,generalization285_b, true).


% ---------------
spl_db( generalization286_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f6 ), requires( f7 , f9 ), excludes( f1 , f4 ) ]
		)
	)
).

spl_db( generalization286_b,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

test_data(generalization286,generalization,generalization286_b, false).


% ---------------
spl_db( generalization287_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization287_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization287,generalization,generalization287_b, true).


% ---------------
spl_db( generalization288_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

spl_db( generalization288_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization288,generalization,generalization288_b, false).


% ---------------
spl_db( generalization289_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f2 ), requires( f6 , f3 ) ]
		)
	)
).

spl_db( generalization289_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(generalization289,generalization,generalization289_b, false).


% ---------------
spl_db( generalization290_a,
	 spl( [ root, f1, f4, f8, f5, f6, f9, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f2 , f4 ), requires( f3 , f4 ), excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization290_b,
	 spl( [ root, f1, f4, f8, f5, f6, f9, f7, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f2 , f4 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(generalization290,generalization,generalization290_b, false).


% ---------------
spl_db( generalization291_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization291_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(generalization291,generalization,generalization291_b, true).


% ---------------
spl_db( generalization292_a,
	 spl( [ root, f1, f2, f6, f7, f3, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

spl_db( generalization292_b,
	 spl( [ root, f1, f2, f6, f7, f3, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization292,generalization,generalization292_b, false).


% ---------------
spl_db( generalization293_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( generalization293_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization293,generalization,generalization293_b, false).


% ---------------
spl_db( generalization294_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization294_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f1 , f8 ) ]
		)
	)
).

test_data(generalization294,generalization,generalization294_b, true).


% ---------------
spl_db( generalization295_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization295_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f2 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(generalization295,generalization,generalization295_b, true).


% ---------------
spl_db( generalization296_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f8 , f1 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( generalization296_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization296,generalization,generalization296_b, false).


% ---------------
spl_db( generalization297_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f8 , f2 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( generalization297_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f8 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(generalization297,generalization,generalization297_b, false).


% ---------------
spl_db( generalization298_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization298_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization298,generalization,generalization298_b, false).


% ---------------
spl_db( generalization299_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

spl_db( generalization299_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization299,generalization,generalization299_b, false).


% ---------------
spl_db( generalization300_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization300_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(generalization300,generalization,generalization300_b, true).


% ---------------
spl_db( generalization301_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization301_b,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), requires( f1 , f3 ) ]
		)
	)
).

test_data(generalization301,generalization,generalization301_b, true).


% ---------------
spl_db( generalization302_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

spl_db( generalization302_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f6 ), requires( f4 , f8 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(generalization302,generalization,generalization302_b, true).


% ---------------
spl_db( generalization303_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization303_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f4 ) ]
		)
	)
).

test_data(generalization303,generalization,generalization303_b, true).


% ---------------
spl_db( generalization304_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization304_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(generalization304,generalization,generalization304_b, true).


% ---------------
spl_db( generalization305_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization305_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f8 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(generalization305,generalization,generalization305_b, true).


% ---------------
spl_db( generalization306_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

spl_db( generalization306_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization306,generalization,generalization306_b, false).


% ---------------
spl_db( generalization307_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f2 ) ]
		)
	)
).

spl_db( generalization307_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization307,generalization,generalization307_b, false).


% ---------------
spl_db( generalization308_a,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

spl_db( generalization308_b,
	 spl( [ root, f1, f9, f2, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization308,generalization,generalization308_b, false).


% ---------------
spl_db( generalization309_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f7 ), excludes( f4 , f9 ) ]
		)
	)
).

spl_db( generalization309_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f7, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

test_data(generalization309,generalization,generalization309_b, false).


% ---------------
spl_db( generalization310_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

spl_db( generalization310_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(generalization310,generalization,generalization310_b, true).


% ---------------
spl_db( generalization311_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f1 , f9 ), excludes( f4 , f7 ) ]
		)
	)
).

spl_db( generalization311_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f1 , f9 ), excludes( f4 , f7 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization311,generalization,generalization311_b, true).


% ---------------
spl_db( generalization312_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

spl_db( generalization312_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization312,generalization,generalization312_b, false).


% ---------------
spl_db( generalization313_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f9 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization313_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization313,generalization,generalization313_b, false).


% ---------------
spl_db( generalization314_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

spl_db( generalization314_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f1 ), requires( f1 , f8 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(generalization314,generalization,generalization314_b, true).


% ---------------
spl_db( generalization315_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f6 , f1 ) ]
		)
	)
).

spl_db( generalization315_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(generalization315,generalization,generalization315_b, false).


% ---------------
spl_db( generalization316_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f4 , f1 ), excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization316_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f4 , f1 ), excludes( f6 , f5 ), requires( f1 , f5 ) ]
		)
	)
).

test_data(generalization316,generalization,generalization316_b, true).


% ---------------
spl_db( generalization317_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f2, f8, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ), feature( f2, [
				mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f7 , f2 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( generalization317_b,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f2, f8, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ) ] ), feature( f2, [
				mandatory( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization317,generalization,generalization317_b, false).


% ---------------
spl_db( generalization318_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f3 ), excludes( f1 , f2 ), excludes( f1 , f3 ) ]
		)
	)
).

spl_db( generalization318_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f8, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(generalization318,generalization,generalization318_b, false).


% ---------------
spl_db( generalization319_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f4 , f7 ), excludes( f3 , f7 ), requires( f1 , f3 ) ]
		)
	)
).

spl_db( generalization319_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization319,generalization,generalization319_b, false).


% ---------------
spl_db( generalization320_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization320_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

test_data(generalization320,generalization,generalization320_b, true).


% ---------------
spl_db( generalization321_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f6 ), excludes( f9 , f4 ), excludes( f1 , f7 ) ]
		)
	)
).

spl_db( generalization321_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization321,generalization,generalization321_b, false).


% ---------------
spl_db( generalization322_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f6 ), excludes( f5 , f1 ) ]
		)
	)
).

spl_db( generalization322_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

test_data(generalization322,generalization,generalization322_b, false).


% ---------------
spl_db( generalization323_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f9 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( generalization323_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(generalization323,generalization,generalization323_b, false).


% ---------------
spl_db( generalization324_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f8 , f7 ) ]
		)
	)
).

spl_db( generalization324_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization324,generalization,generalization324_b, false).


% ---------------
spl_db( generalization325_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization325_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(generalization325,generalization,generalization325_b, true).


% ---------------
spl_db( generalization326_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization326_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f1 , f9 ), excludes( f7 , f1 ) ]
		)
	)
).

test_data(generalization326,generalization,generalization326_b, true).


% ---------------
spl_db( generalization327_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( generalization327_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization327,generalization,generalization327_b, false).


% ---------------
spl_db( generalization328_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization328_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization328,generalization,generalization328_b, true).


% ---------------
spl_db( generalization329_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization329_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f9 ), excludes( f6 , f5 ) ]
		)
	)
).

test_data(generalization329,generalization,generalization329_b, true).


% ---------------
spl_db( generalization330_a,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization330_b,
	 spl( [ root, f1, f5, f6, f9, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f8 ), excludes( f6 , f5 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(generalization330,generalization,generalization330_b, true).


% ---------------
spl_db( generalization331_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

spl_db( generalization331_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f3 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(generalization331,generalization,generalization331_b, true).


% ---------------
spl_db( generalization332_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization332_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f2 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(generalization332,generalization,generalization332_b, true).


% ---------------
spl_db( generalization333_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

spl_db( generalization333_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f3 ), excludes( f1 , f7 ) ]
		)
	)
).

test_data(generalization333,generalization,generalization333_b, true).


% ---------------
spl_db( generalization334_a,
	 spl( [ root, f1, f3, f4, f8, f5, f6, f9, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

spl_db( generalization334_b,
	 spl( [ root, f1, f3, f4, f8, f5, f6, f9, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f2 ), requires( f8 , f9 ) ]
		)
	)
).

test_data(generalization334,generalization,generalization334_b, true).


% ---------------
spl_db( generalization335_a,
	 spl( [ root, f1, f4, f5, f6, f2, f3, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f4 , f6 ) ]
		)
	)
).

spl_db( generalization335_b,
	 spl( [ root, f1, f4, f5, f6, f2, f3, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f4 , f6 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(generalization335,generalization,generalization335_b, true).


% ---------------
spl_db( generalization336_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization336_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization336,generalization,generalization336_b, false).


% ---------------
spl_db( generalization337_a,
	 spl( [ root, f1, f2, f5, f8, f9, f6, f3, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization337_b,
	 spl( [ root, f1, f2, f5, f8, f9, f6, f3, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ), only_one( [ feature( f3, [
				optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f1 , f7 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization337,generalization,generalization337_b, true).


% ---------------
spl_db( generalization338_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization338_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

test_data(generalization338,generalization,generalization338_b, true).


% ---------------
spl_db( generalization339_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

spl_db( generalization339_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f2 , f6 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization339,generalization,generalization339_b, true).


% ---------------
spl_db( generalization340_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f6 , f8 ), excludes( f4 , f1 ), excludes( f9 , f8 ) ]
		)
	)
).

spl_db( generalization340_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization340,generalization,generalization340_b, false).


% ---------------
spl_db( generalization341_a,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f9, [] ) ) ] ), feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f7 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization341_b,
	 spl( [ root, f1, f9, f2, f4, f5, f6, f7, f8, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f9, [] ) ) ] ), feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization341,generalization,generalization341_b, false).


% ---------------
spl_db( generalization342_a,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization342_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f3 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(generalization342,generalization,generalization342_b, true).


% ---------------
spl_db( generalization343_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

spl_db( generalization343_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(generalization343,generalization,generalization343_b, true).


% ---------------
spl_db( generalization344_a,
	 spl( [ root, f1, f2, f4, f5, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [
						mandatory( feature( f5, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization344_b,
	 spl( [ root, f1, f2, f4, f5, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f4, [
						mandatory( feature( f5, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
					one_or_more( [ feature( f6, [] ), feature( f7, [
						optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f3 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(generalization344,generalization,generalization344_b, true).


% ---------------
spl_db( generalization345_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [
				optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization345_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [
				optional( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization345,generalization,generalization345_b, false).


% ---------------
spl_db( generalization346_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization346_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f3 ), requires( f2 , f7 ) ]
		)
	)
).

test_data(generalization346,generalization,generalization346_b, true).


% ---------------
spl_db( generalization347_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f2 ), excludes( f8 , f2 ) ]
		)
	)
).

spl_db( generalization347_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization347,generalization,generalization347_b, false).


% ---------------
spl_db( generalization348_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization348_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f9 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization348,generalization,generalization348_b, true).


% ---------------
spl_db( generalization349_a,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

spl_db( generalization349_b,
	 spl( [ root, f1, f2, f5, f9, f6, f7, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f3 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization349,generalization,generalization349_b, true).


% ---------------
spl_db( generalization350_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f1 , f9 ) ]
		)
	)
).

spl_db( generalization350_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization350,generalization,generalization350_b, false).


% ---------------
spl_db( generalization351_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

spl_db( generalization351_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
					one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
						optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f8 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization351,generalization,generalization351_b, true).


% ---------------
spl_db( generalization352_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization352_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(generalization352,generalization,generalization352_b, true).


% ---------------
spl_db( generalization353_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization353_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f4 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(generalization353,generalization,generalization353_b, true).


% ---------------
spl_db( generalization354_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization354_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(generalization354,generalization,generalization354_b, true).


% ---------------
spl_db( generalization355_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization355_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(generalization355,generalization,generalization355_b, true).


% ---------------
spl_db( generalization356_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

spl_db( generalization356_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f8 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization356,generalization,generalization356_b, true).


% ---------------
spl_db( generalization357_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f5 ) ]
		)
	)
).

spl_db( generalization357_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization357,generalization,generalization357_b, false).


% ---------------
spl_db( generalization358_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization358_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f9 , f4 ) ]
		)
	)
).

test_data(generalization358,generalization,generalization358_b, true).


% ---------------
spl_db( generalization359_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization359_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f9 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(generalization359,generalization,generalization359_b, true).


% ---------------
spl_db( generalization360_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

spl_db( generalization360_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization360,generalization,generalization360_b, false).


% ---------------
spl_db( generalization361_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization361_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ), requires( f9 , f3 ) ]
		)
	)
).

test_data(generalization361,generalization,generalization361_b, true).


% ---------------
spl_db( generalization362_a,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization362_b,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

test_data(generalization362,generalization,generalization362_b, true).


% ---------------
spl_db( generalization363_a,
	 spl( [ root, f1, f2, f3, f7, f9, f4, f5, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization363_b,
	 spl( [ root, f1, f2, f3, f7, f9, f4, f5, f6, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f6 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization363,generalization,generalization363_b, true).


% ---------------
spl_db( generalization364_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization364_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f7 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization364,generalization,generalization364_b, true).


% ---------------
spl_db( generalization365_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f2 ), requires( f6 , f9 ) ]
		)
	)
).

spl_db( generalization365_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization365,generalization,generalization365_b, false).


% ---------------
spl_db( generalization366_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

spl_db( generalization366_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization366,generalization,generalization366_b, false).


% ---------------
spl_db( generalization367_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization367_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f8 , f9 ), excludes( f7 , f1 ) ]
		)
	)
).

test_data(generalization367,generalization,generalization367_b, true).


% ---------------
spl_db( generalization368_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f8 ), excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization368_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization368,generalization,generalization368_b, false).


% ---------------
spl_db( generalization369_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization369_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f6 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization369,generalization,generalization369_b, true).


% ---------------
spl_db( generalization370_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization370_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ), excludes( f9 , f6 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization370,generalization,generalization370_b, true).


% ---------------
spl_db( generalization371_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f8 , f1 ), excludes( f4 , f2 ), requires( f5 , f2 ) ]
		)
	)
).

spl_db( generalization371_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

test_data(generalization371,generalization,generalization371_b, false).


% ---------------
spl_db( generalization372_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ), requires( f2 , f8 ) ]
		)
	)
).

spl_db( generalization372_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization372,generalization,generalization372_b, false).


% ---------------
spl_db( generalization373_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization373_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f1 , f7 ) ]
		)
	)
).

test_data(generalization373,generalization,generalization373_b, true).


% ---------------
spl_db( generalization374_a,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f3, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f3, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization374_b,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f3, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				only_one( [ feature( f2, [
					optional( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ), feature( f3, [
					optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f6 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(generalization374,generalization,generalization374_b, true).


% ---------------
spl_db( generalization375_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization375_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization375,generalization,generalization375_b, true).


% ---------------
spl_db( generalization376_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization376_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(generalization376,generalization,generalization376_b, true).


% ---------------
spl_db( generalization377_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f2 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( generalization377_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(generalization377,generalization,generalization377_b, false).


% ---------------
spl_db( generalization378_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization378_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(generalization378,generalization,generalization378_b, true).


% ---------------
spl_db( generalization379_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f4 ), excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization379_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization379,generalization,generalization379_b, false).


% ---------------
spl_db( generalization380_a,
	 spl( [ root, f1, f2, f5, f9, f6, f8, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization380_b,
	 spl( [ root, f1, f2, f5, f9, f6, f8, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f5 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(generalization380,generalization,generalization380_b, true).


% ---------------
spl_db( generalization381_a,
	 spl( [ root, f1, f5, f2, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

spl_db( generalization381_b,
	 spl( [ root, f1, f5, f2, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f8 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(generalization381,generalization,generalization381_b, true).


% ---------------
spl_db( generalization382_a,
	 spl( [ root, f1, f9, f2, f3, f5, f4, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization382_b,
	 spl( [ root, f1, f9, f2, f3, f5, f4, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization382,generalization,generalization382_b, true).


% ---------------
spl_db( generalization383_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization383_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization383,generalization,generalization383_b, true).


% ---------------
spl_db( generalization384_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

spl_db( generalization384_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization384,generalization,generalization384_b, false).


% ---------------
spl_db( generalization385_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization385_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f7 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization385,generalization,generalization385_b, true).


% ---------------
spl_db( generalization386_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ), requires( f8 , f7 ) ]
		)
	)
).

spl_db( generalization386_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization386,generalization,generalization386_b, false).


% ---------------
spl_db( generalization387_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), requires( f4 , f2 ) ]
		)
	)
).

spl_db( generalization387_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), requires( f4 , f2 ), requires( f8 , f5 ) ]
		)
	)
).

test_data(generalization387,generalization,generalization387_b, true).


% ---------------
spl_db( generalization388_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f6 ), requires( f8 , f6 ) ]
		)
	)
).

spl_db( generalization388_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization388,generalization,generalization388_b, false).


% ---------------
spl_db( generalization389_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f7 ), requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization389_b,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization389,generalization,generalization389_b, false).


% ---------------
spl_db( generalization390_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization390_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

test_data(generalization390,generalization,generalization390_b, true).


% ---------------
spl_db( generalization391_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization391_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f8 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(generalization391,generalization,generalization391_b, true).


% ---------------
spl_db( generalization392_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

spl_db( generalization392_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization392,generalization,generalization392_b, false).


% ---------------
spl_db( generalization393_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization393_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f8 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(generalization393,generalization,generalization393_b, true).


% ---------------
spl_db( generalization394_a,
	 spl( [ root, f1, f2, f4, f5, f8, f6, f9, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

spl_db( generalization394_b,
	 spl( [ root, f1, f2, f4, f5, f8, f6, f9, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f1 , f7 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(generalization394,generalization,generalization394_b, true).


% ---------------
spl_db( generalization395_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [
				only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f6 ) ]
		)
	)
).

spl_db( generalization395_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [
				only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ] ) ] ),
 [ requires( f1 , f6 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(generalization395,generalization,generalization395_b, true).


% ---------------
spl_db( generalization396_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization396_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

test_data(generalization396,generalization,generalization396_b, false).


% ---------------
spl_db( generalization397_a,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization397_b,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f2, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f7 ), requires( f8 , f6 ) ]
		)
	)
).

test_data(generalization397,generalization,generalization397_b, true).


% ---------------
spl_db( generalization398_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

spl_db( generalization398_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization398,generalization,generalization398_b, false).


% ---------------
spl_db( generalization399_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization399_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(generalization399,generalization,generalization399_b, false).


% ---------------
spl_db( generalization400_a,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f7 ) ]
		)
	)
).

spl_db( generalization400_b,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f7 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(generalization400,generalization,generalization400_b, true).


% ---------------
spl_db( generalization401_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization401_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f7 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(generalization401,generalization,generalization401_b, true).


% ---------------
spl_db( generalization402_a,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization402_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization402,generalization,generalization402_b, true).


% ---------------
spl_db( generalization403_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization403_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(generalization403,generalization,generalization403_b, true).


% ---------------
spl_db( generalization404_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization404_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

test_data(generalization404,generalization,generalization404_b, true).


% ---------------
spl_db( generalization405_a,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

spl_db( generalization405_b,
	 spl( [ root, f1, f3, f8, f9, f4, f5, f6, f7, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f3 , f6 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(generalization405,generalization,generalization405_b, true).


% ---------------
spl_db( generalization406_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization406_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization406,generalization,generalization406_b, false).


% ---------------
spl_db( generalization407_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

spl_db( generalization407_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization407,generalization,generalization407_b, false).


% ---------------
spl_db( generalization408_a,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), requires( f4 , f9 ) ]
		)
	)
).

spl_db( generalization408_b,
	 spl( [ root, f1, f2, f9, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

test_data(generalization408,generalization,generalization408_b, false).


% ---------------
spl_db( generalization409_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

spl_db( generalization409_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(generalization409,generalization,generalization409_b, true).


% ---------------
spl_db( generalization410_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f9 , f1 ) ]
		)
	)
).

spl_db( generalization410_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization410,generalization,generalization410_b, false).


% ---------------
spl_db( generalization411_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization411_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization411,generalization,generalization411_b, false).


% ---------------
spl_db( generalization412_a,
	 spl( [ root, f1, f5, f6, f8, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

spl_db( generalization412_b,
	 spl( [ root, f1, f5, f6, f8, f9, f7, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization412,generalization,generalization412_b, false).


% ---------------
spl_db( generalization413_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization413_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(generalization413,generalization,generalization413_b, false).


% ---------------
spl_db( generalization414_a,
	 spl( [ root, f1, f4, f2, f3, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f8 ), requires( f5 , f2 ) ]
		)
	)
).

spl_db( generalization414_b,
	 spl( [ root, f1, f4, f2, f3, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization414,generalization,generalization414_b, false).


% ---------------
spl_db( generalization415_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f3 ), excludes( f3 , f6 ) ]
		)
	)
).

spl_db( generalization415_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization415,generalization,generalization415_b, false).


% ---------------
spl_db( generalization416_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f1 ), requires( f7 , f6 ) ]
		)
	)
).

spl_db( generalization416_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization416,generalization,generalization416_b, false).


% ---------------
spl_db( generalization417_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f4, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), excludes( f9 , f5 ) ]
		)
	)
).

spl_db( generalization417_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f4, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [
				optional( feature( f4, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization417,generalization,generalization417_b, false).


% ---------------
spl_db( generalization418_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization418_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f7 ) ]
		)
	)
).

test_data(generalization418,generalization,generalization418_b, true).


% ---------------
spl_db( generalization419_a,
	 spl( [ root, f1, f4, f8, f9, f5, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization419_b,
	 spl( [ root, f1, f4, f8, f9, f5, f6, f7, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [
					optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(generalization419,generalization,generalization419_b, true).


% ---------------
spl_db( generalization420_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization420_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization420,generalization,generalization420_b, false).


% ---------------
spl_db( generalization421_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization421_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ), excludes( f8 , f3 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(generalization421,generalization,generalization421_b, true).


% ---------------
spl_db( generalization422_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f8 ), requires( f3 , f5 ) ]
		)
	)
).

spl_db( generalization422_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

test_data(generalization422,generalization,generalization422_b, false).


% ---------------
spl_db( generalization423_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f1 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization423_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f1 ) ]
		)
	)
).

test_data(generalization423,generalization,generalization423_b, false).


% ---------------
spl_db( generalization424_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( generalization424_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization424,generalization,generalization424_b, false).


% ---------------
spl_db( generalization425_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

spl_db( generalization425_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization425,generalization,generalization425_b, false).


% ---------------
spl_db( generalization426_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f2 ), excludes( f5 , f9 ) ]
		)
	)
).

spl_db( generalization426_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
					mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization426,generalization,generalization426_b, false).


% ---------------
spl_db( generalization427_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f5 , f1 ), requires( f9 , f7 ) ]
		)
	)
).

spl_db( generalization427_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization427,generalization,generalization427_b, false).


% ---------------
spl_db( generalization428_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ), excludes( f8 , f7 ) ]
		)
	)
).

spl_db( generalization428_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization428,generalization,generalization428_b, false).


% ---------------
spl_db( generalization429_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( generalization429_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f6 ), excludes( f5 , f9 ) ]
		)
	)
).

test_data(generalization429,generalization,generalization429_b, true).


% ---------------
spl_db( generalization430_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization430_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(generalization430,generalization,generalization430_b, true).


% ---------------
spl_db( generalization431_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization431_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f5 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization431,generalization,generalization431_b, true).


% ---------------
spl_db( generalization432_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization432_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f8 ), excludes( f6 , f7 ), excludes( f9 , f2 ) ]
		)
	)
).

test_data(generalization432,generalization,generalization432_b, true).


% ---------------
spl_db( generalization433_a,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f4, f6, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization433_b,
	 spl( [ root, f1, f7, f9, f8, f2, f3, f4, f6, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f5 ) ]
		)
	)
).

test_data(generalization433,generalization,generalization433_b, true).


% ---------------
spl_db( generalization434_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ), excludes( f2 , f8 ) ]
		)
	)
).

spl_db( generalization434_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

test_data(generalization434,generalization,generalization434_b, false).


% ---------------
spl_db( generalization435_a,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

spl_db( generalization435_b,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization435,generalization,generalization435_b, false).


% ---------------
spl_db( generalization436_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), requires( f4 , f2 ) ]
		)
	)
).

spl_db( generalization436_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), requires( f4 , f2 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization436,generalization,generalization436_b, true).


% ---------------
spl_db( generalization437_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization437_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ), requires( f6 , f7 ) ]
		)
	)
).

test_data(generalization437,generalization,generalization437_b, true).


% ---------------
spl_db( generalization438_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization438_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f4 ), requires( f6 , f1 ) ]
		)
	)
).

test_data(generalization438,generalization,generalization438_b, true).


% ---------------
spl_db( generalization439_a,
	 spl( [ root, f1, f6, f7, f2, f3, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

spl_db( generalization439_b,
	 spl( [ root, f1, f6, f7, f2, f3, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization439,generalization,generalization439_b, false).


% ---------------
spl_db( generalization440_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

spl_db( generalization440_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization440,generalization,generalization440_b, false).


% ---------------
spl_db( generalization441_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization441_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f2 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization441,generalization,generalization441_b, true).


% ---------------
spl_db( generalization442_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

spl_db( generalization442_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f1 ), excludes( f4 , f8 ) ]
		)
	)
).

test_data(generalization442,generalization,generalization442_b, true).


% ---------------
spl_db( generalization443_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization443_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f7 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(generalization443,generalization,generalization443_b, true).


% ---------------
spl_db( generalization444_a,
	 spl( [ root, f1, f2, f3, f5, f8, f9, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( generalization444_b,
	 spl( [ root, f1, f2, f3, f5, f8, f9, f6, f7, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization444,generalization,generalization444_b, false).


% ---------------
spl_db( generalization445_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization445_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization445,generalization,generalization445_b, false).


% ---------------
spl_db( generalization446_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization446_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(generalization446,generalization,generalization446_b, true).


% ---------------
spl_db( generalization447_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization447_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f6 ), requires( f3 , f5 ), excludes( f2 , f4 ) ]
		)
	)
).

test_data(generalization447,generalization,generalization447_b, true).


% ---------------
spl_db( generalization448_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

spl_db( generalization448_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f9 , f5 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization448,generalization,generalization448_b, true).


% ---------------
spl_db( generalization449_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f3 ), excludes( f6 , f2 ), requires( f8 , f3 ) ]
		)
	)
).

spl_db( generalization449_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization449,generalization,generalization449_b, false).


% ---------------
spl_db( generalization450_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f8 ), requires( f6 , f9 ) ]
		)
	)
).

spl_db( generalization450_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(generalization450,generalization,generalization450_b, false).


% ---------------
spl_db( generalization451_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( generalization451_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f4 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization451,generalization,generalization451_b, true).


% ---------------
spl_db( generalization452_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

spl_db( generalization452_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization452,generalization,generalization452_b, false).


% ---------------
spl_db( generalization453_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

spl_db( generalization453_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization453,generalization,generalization453_b, false).


% ---------------
spl_db( generalization454_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization454_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization454,generalization,generalization454_b, false).


% ---------------
spl_db( generalization455_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f3 ), excludes( f1 , f6 ) ]
		)
	)
).

spl_db( generalization455_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(generalization455,generalization,generalization455_b, false).


% ---------------
spl_db( generalization456_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization456_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

test_data(generalization456,generalization,generalization456_b, true).


% ---------------
spl_db( generalization457_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization457_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(generalization457,generalization,generalization457_b, true).


% ---------------
spl_db( generalization458_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

spl_db( generalization458_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
							optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization458,generalization,generalization458_b, false).


% ---------------
spl_db( generalization459_a,
	 spl( [ root, f1, f3, f8, f4, f6, f7, f9, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

spl_db( generalization459_b,
	 spl( [ root, f1, f3, f8, f4, f6, f7, f9, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization459,generalization,generalization459_b, false).


% ---------------
spl_db( generalization460_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

spl_db( generalization460_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization460,generalization,generalization460_b, false).


% ---------------
spl_db( generalization461_a,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f7 , f4 ), excludes( f3 , f8 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( generalization461_b,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization461,generalization,generalization461_b, false).


% ---------------
spl_db( generalization462_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f4 ), requires( f1 , f6 ) ]
		)
	)
).

spl_db( generalization462_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization462,generalization,generalization462_b, false).


% ---------------
spl_db( generalization463_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ), excludes( f8 , f6 ), requires( f7 , f8 ) ]
		)
	)
).

spl_db( generalization463_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

test_data(generalization463,generalization,generalization463_b, false).


% ---------------
spl_db( generalization464_a,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

spl_db( generalization464_b,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization464,generalization,generalization464_b, false).


% ---------------
spl_db( generalization465_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

spl_db( generalization465_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization465,generalization,generalization465_b, false).


% ---------------
spl_db( generalization466_a,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization466_b,
	 spl( [ root, f1, f2, f3, f9, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [
					mandatory( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(generalization466,generalization,generalization466_b, true).


% ---------------
spl_db( generalization467_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f8 , f3 ) ]
		)
	)
).

spl_db( generalization467_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f8 , f3 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(generalization467,generalization,generalization467_b, true).


% ---------------
spl_db( generalization468_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [
						optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization468_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f4, [
						optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

test_data(generalization468,generalization,generalization468_b, true).


% ---------------
spl_db( generalization469_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization469_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

test_data(generalization469,generalization,generalization469_b, true).


% ---------------
spl_db( generalization470_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization470_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f9 ), excludes( f7 , f3 ) ]
		)
	)
).

test_data(generalization470,generalization,generalization470_b, true).


% ---------------
spl_db( generalization471_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization471_b,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization471,generalization,generalization471_b, true).


% ---------------
spl_db( generalization472_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( generalization472_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization472,generalization,generalization472_b, false).


% ---------------
spl_db( generalization473_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization473_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(generalization473,generalization,generalization473_b, true).


% ---------------
spl_db( generalization474_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization474_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization474,generalization,generalization474_b, false).


% ---------------
spl_db( generalization475_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), excludes( f9 , f1 ) ]
		)
	)
).

spl_db( generalization475_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization475,generalization,generalization475_b, false).


% ---------------
spl_db( generalization476_a,
	 spl( [ root, f1, f3, f9, f2, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f4 ), requires( f2 , f3 ) ]
		)
	)
).

spl_db( generalization476_b,
	 spl( [ root, f1, f3, f9, f2, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization476,generalization,generalization476_b, false).


% ---------------
spl_db( generalization477_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f8 , f2 ), excludes( f1 , f9 ) ]
		)
	)
).

spl_db( generalization477_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization477,generalization,generalization477_b, false).


% ---------------
spl_db( generalization478_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization478_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization478,generalization,generalization478_b, false).


% ---------------
spl_db( generalization479_a,
	 spl( [ root, f1, f2, f4, f5, f6, f8, f9, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization479_b,
	 spl( [ root, f1, f2, f4, f5, f6, f8, f9, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization479,generalization,generalization479_b, false).


% ---------------
spl_db( generalization480_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [
							optional( feature( f6, [] ) ), optional( feature( f7, [
								optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( generalization480_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f5, [
							optional( feature( f6, [] ) ), optional( feature( f7, [
								optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f6 ), requires( f7 , f2 ) ]
		)
	)
).

test_data(generalization480,generalization,generalization480_b, true).


% ---------------
spl_db( generalization481_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization481_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization481,generalization,generalization481_b, false).


% ---------------
spl_db( generalization482_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization482_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), requires( f2 , f3 ) ]
		)
	)
).

test_data(generalization482,generalization,generalization482_b, true).


% ---------------
spl_db( generalization483_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( generalization483_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization483,generalization,generalization483_b, false).


% ---------------
spl_db( generalization484_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization484_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ) ]
		)
	)
).

test_data(generalization484,generalization,generalization484_b, true).


% ---------------
spl_db( generalization485_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), excludes( f9 , f4 ) ]
		)
	)
).

spl_db( generalization485_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(generalization485,generalization,generalization485_b, false).


% ---------------
spl_db( generalization486_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization486_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

test_data(generalization486,generalization,generalization486_b, true).


% ---------------
spl_db( generalization487_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f1 , f8 ), excludes( f2 , f7 ) ]
		)
	)
).

spl_db( generalization487_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization487,generalization,generalization487_b, false).


% ---------------
spl_db( generalization488_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

spl_db( generalization488_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization488,generalization,generalization488_b, false).


% ---------------
spl_db( generalization489_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f2 ), excludes( f8 , f5 ) ]
		)
	)
).

spl_db( generalization489_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization489,generalization,generalization489_b, false).


% ---------------
spl_db( generalization490_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization490_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f9 , f4 ) ]
		)
	)
).

test_data(generalization490,generalization,generalization490_b, true).


% ---------------
spl_db( generalization491_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization491_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(generalization491,generalization,generalization491_b, true).


% ---------------
spl_db( generalization492_a,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization492_b,
	 spl( [ root, f1, f6, f9, f7, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f5 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(generalization492,generalization,generalization492_b, true).


% ---------------
spl_db( generalization493_a,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization493_b,
	 spl( [ root, f1, f9, f2, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(generalization493,generalization,generalization493_b, true).


% ---------------
spl_db( generalization494_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ requires( f9 , f3 ), excludes( f6 , f7 ) ]
		)
	)
).

spl_db( generalization494_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization494,generalization,generalization494_b, false).


% ---------------
spl_db( generalization495_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

spl_db( generalization495_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f6 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization495,generalization,generalization495_b, true).


% ---------------
spl_db( generalization496_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization496_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f2 , f6 ), excludes( f2 , f8 ) ]
		)
	)
).

test_data(generalization496,generalization,generalization496_b, true).


% ---------------
spl_db( generalization497_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f6 ), excludes( f2 , f8 ), requires( f9 , f3 ) ]
		)
	)
).

spl_db( generalization497_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

test_data(generalization497,generalization,generalization497_b, false).


% ---------------
spl_db( generalization498_a,
	 spl( [ root, f1, f9, f2, f3, f6, f4, f5, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization498_b,
	 spl( [ root, f1, f9, f2, f3, f6, f4, f5, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ) ] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization498,generalization,generalization498_b, false).


% ---------------
spl_db( generalization499_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization499_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(generalization499,generalization,generalization499_b, true).


% ---------------
spl_db( generalization500_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization500_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization500,generalization,generalization500_b, false).


% ---------------
spl_db( generalization501_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization501_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f4 ), requires( f6 , f1 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization501,generalization,generalization501_b, true).


% ---------------
spl_db( generalization502_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f3 ), requires( f3 , f2 ) ]
		)
	)
).

spl_db( generalization502_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization502,generalization,generalization502_b, false).


% ---------------
spl_db( generalization503_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f8 , f4 ) ]
		)
	)
).

spl_db( generalization503_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(generalization503,generalization,generalization503_b, false).


% ---------------
spl_db( generalization504_a,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization504_b,
	 spl( [ root, f1, f2, f9, f3, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization504,generalization,generalization504_b, true).


% ---------------
spl_db( generalization505_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ), requires( f5 , f2 ) ]
		)
	)
).

spl_db( generalization505_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization505,generalization,generalization505_b, false).


% ---------------
spl_db( generalization506_a,
	 spl( [ root, f1, f2, f7, f9, f3, f4, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f5 ), requires( f6 , f2 ), excludes( f8 , f2 ) ]
		)
	)
).

spl_db( generalization506_b,
	 spl( [ root, f1, f2, f7, f9, f3, f4, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ), optional( feature( f6, [
						mandatory( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization506,generalization,generalization506_b, false).


% ---------------
spl_db( generalization507_a,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization507_b,
	 spl( [ root, f1, f2, f4, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ requires( f2 , f1 ), requires( f7 , f8 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(generalization507,generalization,generalization507_b, true).


% ---------------
spl_db( generalization508_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f1 , f7 ), excludes( f5 , f4 ) ]
		)
	)
).

spl_db( generalization508_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization508,generalization,generalization508_b, false).


% ---------------
spl_db( generalization509_a,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f9 , f8 ), excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization509_b,
	 spl( [ root, f1, f6, f7, f9, f8, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization509,generalization,generalization509_b, false).


% ---------------
spl_db( generalization510_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

spl_db( generalization510_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization510,generalization,generalization510_b, false).


% ---------------
spl_db( generalization511_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization511_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f1 ), excludes( f3 , f5 ) ]
		)
	)
).

test_data(generalization511,generalization,generalization511_b, true).


% ---------------
spl_db( generalization512_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization512_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization512,generalization,generalization512_b, true).


% ---------------
spl_db( generalization513_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f6 ), requires( f6 , f3 ) ]
		)
	)
).

spl_db( generalization513_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

test_data(generalization513,generalization,generalization513_b, false).


% ---------------
spl_db( generalization514_a,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization514_b,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f4, f5, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f6, [] ) ), optional( feature( f7, [
						one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f8 , f6 ), excludes( f2 , f7 ) ]
		)
	)
).

test_data(generalization514,generalization,generalization514_b, true).


% ---------------
spl_db( generalization515_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f8 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization515_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization515,generalization,generalization515_b, false).


% ---------------
spl_db( generalization516_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f8 ), excludes( f5 , f7 ), requires( f4 , f1 ) ]
		)
	)
).

spl_db( generalization516_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization516,generalization,generalization516_b, false).


% ---------------
spl_db( generalization517_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f7 , f5 ) ]
		)
	)
).

spl_db( generalization517_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f1 ) ]
		)
	)
).

test_data(generalization517,generalization,generalization517_b, false).


% ---------------
spl_db( generalization518_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization518_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f2 , f3 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization518,generalization,generalization518_b, true).


% ---------------
spl_db( generalization519_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f2 ), excludes( f2 , f5 ) ]
		)
	)
).

spl_db( generalization519_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization519,generalization,generalization519_b, false).


% ---------------
spl_db( generalization520_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization520_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f8 ), requires( f1 , f6 ) ]
		)
	)
).

test_data(generalization520,generalization,generalization520_b, true).


% ---------------
spl_db( generalization521_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

spl_db( generalization521_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization521,generalization,generalization521_b, false).


% ---------------
spl_db( generalization522_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

spl_db( generalization522_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization522,generalization,generalization522_b, false).


% ---------------
spl_db( generalization523_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f3 ), excludes( f3 , f9 ) ]
		)
	)
).

spl_db( generalization523_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization523,generalization,generalization523_b, false).


% ---------------
spl_db( generalization524_a,
	 spl( [ root, f1, f2, f8, f9, f3, f6, f7, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), requires( f6 , f1 ) ]
		)
	)
).

spl_db( generalization524_b,
	 spl( [ root, f1, f2, f8, f9, f3, f6, f7, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f3 , f4 ) ]
		)
	)
).

test_data(generalization524,generalization,generalization524_b, false).


% ---------------
spl_db( generalization525_a,
	 spl( [ root, f1, f2, f3, f7, f9, f4, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f2 , f8 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( generalization525_b,
	 spl( [ root, f1, f2, f3, f7, f9, f4, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization525,generalization,generalization525_b, false).


% ---------------
spl_db( generalization526_a,
	 spl( [ root, f1, f3, f4, f5, f8, f6, f7, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f2 , f3 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization526_b,
	 spl( [ root, f1, f3, f4, f5, f8, f6, f7, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization526,generalization,generalization526_b, false).


% ---------------
spl_db( generalization527_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f8 ), excludes( f4 , f9 ), excludes( f3 , f1 ) ]
		)
	)
).

spl_db( generalization527_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(generalization527,generalization,generalization527_b, false).


% ---------------
spl_db( generalization528_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization528_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f7 ), excludes( f9 , f1 ) ]
		)
	)
).

test_data(generalization528,generalization,generalization528_b, true).


% ---------------
spl_db( generalization529_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization529_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f5 ), excludes( f6 , f3 ) ]
		)
	)
).

test_data(generalization529,generalization,generalization529_b, true).


% ---------------
spl_db( generalization530_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization530_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f4 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization530,generalization,generalization530_b, true).


% ---------------
spl_db( generalization531_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f8 ), excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization531_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(generalization531,generalization,generalization531_b, false).


% ---------------
spl_db( generalization532_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization532_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization532,generalization,generalization532_b, true).


% ---------------
spl_db( generalization533_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization533_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(generalization533,generalization,generalization533_b, true).


% ---------------
spl_db( generalization534_a,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization534_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization534,generalization,generalization534_b, true).


% ---------------
spl_db( generalization535_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization535_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ), requires( f8 , f3 ) ]
		)
	)
).

test_data(generalization535,generalization,generalization535_b, true).


% ---------------
spl_db( generalization536_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization536_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f6, [
					mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f3 ), excludes( f3 , f8 ) ]
		)
	)
).

test_data(generalization536,generalization,generalization536_b, true).


% ---------------
spl_db( generalization537_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ), excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization537_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(generalization537,generalization,generalization537_b, false).


% ---------------
spl_db( generalization538_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization538_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

test_data(generalization538,generalization,generalization538_b, true).


% ---------------
spl_db( generalization539_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f7 ), requires( f7 , f9 ) ]
		)
	)
).

spl_db( generalization539_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization539,generalization,generalization539_b, false).


% ---------------
spl_db( generalization540_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization540_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization540,generalization,generalization540_b, false).


% ---------------
spl_db( generalization541_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization541_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f4 , f3 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(generalization541,generalization,generalization541_b, true).


% ---------------
spl_db( generalization542_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( generalization542_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f9 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization542,generalization,generalization542_b, true).


% ---------------
spl_db( generalization543_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

spl_db( generalization543_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization543,generalization,generalization543_b, false).


% ---------------
spl_db( generalization544_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f3 ), excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization544_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization544,generalization,generalization544_b, false).


% ---------------
spl_db( generalization545_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f9 ), excludes( f9 , f3 ), excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization545_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization545,generalization,generalization545_b, false).


% ---------------
spl_db( generalization546_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f1 ) ]
		)
	)
).

spl_db( generalization546_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization546,generalization,generalization546_b, false).


% ---------------
spl_db( generalization547_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f9 ), requires( f6 , f5 ) ]
		)
	)
).

spl_db( generalization547_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(generalization547,generalization,generalization547_b, false).


% ---------------
spl_db( generalization548_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization548_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization548,generalization,generalization548_b, false).


% ---------------
spl_db( generalization549_a,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f6 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization549_b,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization549,generalization,generalization549_b, false).


% ---------------
spl_db( generalization550_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f9 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization550_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization550,generalization,generalization550_b, false).


% ---------------
spl_db( generalization551_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f9 ), requires( f2 , f8 ) ]
		)
	)
).

spl_db( generalization551_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization551,generalization,generalization551_b, false).


% ---------------
spl_db( generalization552_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

spl_db( generalization552_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f6 , f2 ), requires( f2 , f4 ) ]
		)
	)
).

test_data(generalization552,generalization,generalization552_b, true).


% ---------------
spl_db( generalization553_a,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

spl_db( generalization553_b,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f2 ), requires( f1 , f6 ) ]
		)
	)
).

test_data(generalization553,generalization,generalization553_b, true).


% ---------------
spl_db( generalization554_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
						optional( feature( f9, [] ) ) ] ), feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f5 ), excludes( f4 , f9 ), requires( f3 , f7 ) ]
		)
	)
).

spl_db( generalization554_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [
						optional( feature( f9, [] ) ) ] ), feature( f6, [
						mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f5 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization554,generalization,generalization554_b, false).


% ---------------
spl_db( generalization555_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f3 ), excludes( f1 , f6 ) ]
		)
	)
).

spl_db( generalization555_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization555,generalization,generalization555_b, false).


% ---------------
spl_db( generalization556_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f1 ), excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization556_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization556,generalization,generalization556_b, false).


% ---------------
spl_db( generalization557_a,
	 spl( [ root, f1, f4, f9, f5, f2, f3, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization557_b,
	 spl( [ root, f1, f4, f9, f5, f2, f3, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization557,generalization,generalization557_b, false).


% ---------------
spl_db( generalization558_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f5 ), requires( f2 , f7 ) ]
		)
	)
).

spl_db( generalization558_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization558,generalization,generalization558_b, false).


% ---------------
spl_db( generalization559_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f7 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( generalization559_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization559,generalization,generalization559_b, false).


% ---------------
spl_db( generalization560_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ) ]
		)
	)
).

spl_db( generalization560_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization560,generalization,generalization560_b, false).


% ---------------
spl_db( generalization561_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

spl_db( generalization561_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f1 ), excludes( f5 , f1 ) ]
		)
	)
).

test_data(generalization561,generalization,generalization561_b, true).


% ---------------
spl_db( generalization562_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f2 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( generalization562_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization562,generalization,generalization562_b, false).


% ---------------
spl_db( generalization563_a,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ) ] ) ) ] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization563_b,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f5, [] ) ) ] ) ) ] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization563,generalization,generalization563_b, true).


% ---------------
spl_db( generalization564_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization564_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(generalization564,generalization,generalization564_b, true).


% ---------------
spl_db( generalization565_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization565_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f2 , f8 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(generalization565,generalization,generalization565_b, true).


% ---------------
spl_db( generalization566_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f2 ) ]
		)
	)
).

spl_db( generalization566_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization566,generalization,generalization566_b, false).


% ---------------
spl_db( generalization567_a,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( generalization567_b,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f7 , f6 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization567,generalization,generalization567_b, true).


% ---------------
spl_db( generalization568_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization568_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

test_data(generalization568,generalization,generalization568_b, true).


% ---------------
spl_db( generalization569_a,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f9 ) ]
		)
	)
).

spl_db( generalization569_b,
	 spl( [ root, f1, f7, f2, f3, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization569,generalization,generalization569_b, false).


% ---------------
spl_db( generalization570_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f3 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( generalization570_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(generalization570,generalization,generalization570_b, false).


% ---------------
spl_db( generalization571_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f5 ), requires( f5 , f8 ) ]
		)
	)
).

spl_db( generalization571_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization571,generalization,generalization571_b, false).


% ---------------
spl_db( generalization572_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization572_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f2 , f9 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization572,generalization,generalization572_b, true).


% ---------------
spl_db( generalization573_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f6 ) ]
		)
	)
).

spl_db( generalization573_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization573,generalization,generalization573_b, false).


% ---------------
spl_db( generalization574_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f3 ) ]
		)
	)
).

spl_db( generalization574_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f8 , f3 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(generalization574,generalization,generalization574_b, true).


% ---------------
spl_db( generalization575_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

spl_db( generalization575_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [
				optional( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f1 ), excludes( f1 , f3 ) ]
		)
	)
).

test_data(generalization575,generalization,generalization575_b, true).


% ---------------
spl_db( generalization576_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization576_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

test_data(generalization576,generalization,generalization576_b, true).


% ---------------
spl_db( generalization577_a,
	 spl( [ root, f1, f4, f2, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f9 , f7 ), excludes( f6 , f8 ) ]
		)
	)
).

spl_db( generalization577_b,
	 spl( [ root, f1, f4, f2, f5, f6, f9, f7, f8, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization577,generalization,generalization577_b, false).


% ---------------
spl_db( generalization578_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization578_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f5 ), excludes( f4 , f8 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization578,generalization,generalization578_b, true).


% ---------------
spl_db( generalization579_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization579_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f9 , f6 ), requires( f4 , f1 ) ]
		)
	)
).

test_data(generalization579,generalization,generalization579_b, true).


% ---------------
spl_db( generalization580_a,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization580_b,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f1 ) ]
		)
	)
).

test_data(generalization580,generalization,generalization580_b, true).


% ---------------
spl_db( generalization581_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization581_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f7 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(generalization581,generalization,generalization581_b, true).


% ---------------
spl_db( generalization582_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization582_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization582,generalization,generalization582_b, false).


% ---------------
spl_db( generalization583_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

spl_db( generalization583_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization583,generalization,generalization583_b, false).


% ---------------
spl_db( generalization584_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization584_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f3 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(generalization584,generalization,generalization584_b, true).


% ---------------
spl_db( generalization585_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f2 ), excludes( f3 , f1 ) ]
		)
	)
).

spl_db( generalization585_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization585,generalization,generalization585_b, false).


% ---------------
spl_db( generalization586_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization586_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(generalization586,generalization,generalization586_b, true).


% ---------------
spl_db( generalization587_a,
	 spl( [ root, f1, f4, f7, f5, f2, f3, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f6 ), requires( f2 , f8 ) ]
		)
	)
).

spl_db( generalization587_b,
	 spl( [ root, f1, f4, f7, f5, f2, f3, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(generalization587,generalization,generalization587_b, false).


% ---------------
spl_db( generalization588_a,
	 spl( [ root, f1, f3, f8, f4, f5, f6, f7, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f3, [
					optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

spl_db( generalization588_b,
	 spl( [ root, f1, f3, f8, f4, f5, f6, f7, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f3, [
					optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [
					optional( feature( f7, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f2 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(generalization588,generalization,generalization588_b, true).


% ---------------
spl_db( generalization589_a,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

spl_db( generalization589_b,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f9 , f7 ), excludes( f9 , f3 ) ]
		)
	)
).

test_data(generalization589,generalization,generalization589_b, true).


% ---------------
spl_db( generalization590_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
						optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

spl_db( generalization590_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
						optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization590,generalization,generalization590_b, false).


% ---------------
spl_db( generalization591_a,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ) ] ), feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

spl_db( generalization591_b,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ) ] ), feature( f3, [] ), feature( f4, [
				one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization591,generalization,generalization591_b, false).


% ---------------
spl_db( generalization592_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

spl_db( generalization592_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization592,generalization,generalization592_b, false).


% ---------------
spl_db( generalization593_a,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), excludes( f8 , f1 ) ]
		)
	)
).

spl_db( generalization593_b,
	 spl( [ root, f1, f4, f5, f6, f2, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization593,generalization,generalization593_b, false).


% ---------------
spl_db( generalization594_a,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f1 ) ]
		)
	)
).

spl_db( generalization594_b,
	 spl( [ root, f1, f4, f5, f2, f3, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization594,generalization,generalization594_b, false).


% ---------------
spl_db( generalization595_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization595_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f4 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization595,generalization,generalization595_b, true).


% ---------------
spl_db( generalization596_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f9 , f7 ), requires( f3 , f7 ) ]
		)
	)
).

spl_db( generalization596_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization596,generalization,generalization596_b, false).


% ---------------
spl_db( generalization597_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ), excludes( f2 , f5 ) ]
		)
	)
).

spl_db( generalization597_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization597,generalization,generalization597_b, false).


% ---------------
spl_db( generalization598_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f8 ), requires( f6 , f4 ) ]
		)
	)
).

spl_db( generalization598_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f8 ), requires( f6 , f4 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(generalization598,generalization,generalization598_b, true).


% ---------------
spl_db( generalization599_a,
	 spl( [ root, f1, f2, f3, f5, f8, f6, f7, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ), excludes( f2 , f7 ) ]
		)
	)
).

spl_db( generalization599_b,
	 spl( [ root, f1, f2, f3, f5, f8, f6, f7, f4, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f8 , f4 ) ]
		)
	)
).

test_data(generalization599,generalization,generalization599_b, false).


% ---------------
spl_db( generalization600_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f6, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization600_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f6, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

test_data(generalization600,generalization,generalization600_b, true).


% ---------------
spl_db( generalization601_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f2 ), excludes( f4 , f3 ) ]
		)
	)
).

spl_db( generalization601_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f8 , f2 ), excludes( f4 , f3 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization601,generalization,generalization601_b, true).


% ---------------
spl_db( generalization602_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( generalization602_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f3, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f3 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization602,generalization,generalization602_b, true).


% ---------------
spl_db( generalization603_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization603_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f4 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization603,generalization,generalization603_b, true).


% ---------------
spl_db( generalization604_a,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization604_b,
	 spl( [ root, f1, f4, f5, f6, f9, f7, f8, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f2 , f4 ), excludes( f9 , f4 ), requires( f9 , f7 ) ]
		)
	)
).

test_data(generalization604,generalization,generalization604_b, true).


% ---------------
spl_db( generalization605_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f8 ) ]
		)
	)
).

spl_db( generalization605_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization605,generalization,generalization605_b, false).


% ---------------
spl_db( generalization606_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization606_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

test_data(generalization606,generalization,generalization606_b, true).


% ---------------
spl_db( generalization607_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f5 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization607_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

test_data(generalization607,generalization,generalization607_b, false).


% ---------------
spl_db( generalization608_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization608_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
					one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization608,generalization,generalization608_b, false).


% ---------------
spl_db( generalization609_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

spl_db( generalization609_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization609,generalization,generalization609_b, false).


% ---------------
spl_db( generalization610_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f4 , f5 ), excludes( f7 , f4 ) ]
		)
	)
).

spl_db( generalization610_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(generalization610,generalization,generalization610_b, false).


% ---------------
spl_db( generalization611_a,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f6 ) ]
		)
	)
).

spl_db( generalization611_b,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization611,generalization,generalization611_b, true).


% ---------------
spl_db( generalization612_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f9 ), requires( f6 , f8 ) ]
		)
	)
).

spl_db( generalization612_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization612,generalization,generalization612_b, false).


% ---------------
spl_db( generalization613_a,
	 spl( [ root, f1, f7, f8, f2, f5, f9, f3, f4, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f4 ), excludes( f3 , f9 ) ]
		)
	)
).

spl_db( generalization613_b,
	 spl( [ root, f1, f7, f8, f2, f5, f9, f3, f4, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f4 ) ]
		)
	)
).

test_data(generalization613,generalization,generalization613_b, false).


% ---------------
spl_db( generalization614_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization614_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(generalization614,generalization,generalization614_b, true).


% ---------------
spl_db( generalization615_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f4 ), excludes( f6 , f2 ) ]
		)
	)
).

spl_db( generalization615_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f4 ) ]
		)
	)
).

test_data(generalization615,generalization,generalization615_b, false).


% ---------------
spl_db( generalization616_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization616_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f2 ), excludes( f7 , f2 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization616,generalization,generalization616_b, true).


% ---------------
spl_db( generalization617_a,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f3 ), requires( f7 , f2 ) ]
		)
	)
).

spl_db( generalization617_b,
	 spl( [ root, f1, f6, f7, f8, f2, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization617,generalization,generalization617_b, false).


% ---------------
spl_db( generalization618_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

spl_db( generalization618_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization618,generalization,generalization618_b, false).


% ---------------
spl_db( generalization619_a,
	 spl( [ root, f1, f6, f9, f2, f3, f4, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ excludes( f2 , f5 ), excludes( f8 , f1 ) ]
		)
	)
).

spl_db( generalization619_b,
	 spl( [ root, f1, f6, f9, f2, f3, f4, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization619,generalization,generalization619_b, false).


% ---------------
spl_db( generalization620_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization620_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f7 ), requires( f1 , f7 ) ]
		)
	)
).

test_data(generalization620,generalization,generalization620_b, true).


% ---------------
spl_db( generalization621_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f4 ), excludes( f9 , f4 ) ]
		)
	)
).

spl_db( generalization621_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization621,generalization,generalization621_b, false).


% ---------------
spl_db( generalization622_a,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f7 , f3 ) ]
		)
	)
).

spl_db( generalization622_b,
	 spl( [ root, f1, f3, f9, f4, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [
				optional( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization622,generalization,generalization622_b, false).


% ---------------
spl_db( generalization623_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization623_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f1 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization623,generalization,generalization623_b, true).


% ---------------
spl_db( generalization624_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f9 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization624_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization624,generalization,generalization624_b, false).


% ---------------
spl_db( generalization625_a,
	 spl( [ root, f1, f3, f4, f5, f9, f2, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ), feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f3 ), requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization625_b,
	 spl( [ root, f1, f3, f4, f5, f9, f2, f6, f7, f8 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ), feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization625,generalization,generalization625_b, false).


% ---------------
spl_db( generalization626_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( generalization626_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization626,generalization,generalization626_b, false).


% ---------------
spl_db( generalization627_a,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f7 , f6 ), requires( f3 , f9 ) ]
		)
	)
).

spl_db( generalization627_b,
	 spl( [ root, f1, f4, f5, f9, f6, f7, f8, f2, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization627,generalization,generalization627_b, false).


% ---------------
spl_db( generalization628_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization628_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(generalization628,generalization,generalization628_b, true).


% ---------------
spl_db( generalization629_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization629_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f5 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization629,generalization,generalization629_b, true).


% ---------------
spl_db( generalization630_a,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f4 , f7 ), excludes( f7 , f3 ) ]
		)
	)
).

spl_db( generalization630_b,
	 spl( [ root, f1, f2, f3, f8, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization630,generalization,generalization630_b, false).


% ---------------
spl_db( generalization631_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f5 , f9 ) ]
		)
	)
).

spl_db( generalization631_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization631,generalization,generalization631_b, false).


% ---------------
spl_db( generalization632_a,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization632_b,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f4, [
				mandatory( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f5 , f7 ), excludes( f7 , f1 ) ]
		)
	)
).

test_data(generalization632,generalization,generalization632_b, true).


% ---------------
spl_db( generalization633_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization633_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
					mandatory( feature( f6, [
						mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f6 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(generalization633,generalization,generalization633_b, true).


% ---------------
spl_db( generalization634_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization634_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(generalization634,generalization,generalization634_b, true).


% ---------------
spl_db( generalization635_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization635_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(generalization635,generalization,generalization635_b, true).


% ---------------
spl_db( generalization636_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization636_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f4 , f6 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization636,generalization,generalization636_b, true).


% ---------------
spl_db( generalization637_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

spl_db( generalization637_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f1 , f8 ), requires( f6 , f4 ) ]
		)
	)
).

test_data(generalization637,generalization,generalization637_b, true).


% ---------------
spl_db( generalization638_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f6 ), requires( f9 , f6 ) ]
		)
	)
).

spl_db( generalization638_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization638,generalization,generalization638_b, false).


% ---------------
spl_db( generalization639_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f6 ), requires( f4 , f1 ) ]
		)
	)
).

spl_db( generalization639_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization639,generalization,generalization639_b, false).


% ---------------
spl_db( generalization640_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization640_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f7 , f5 ), excludes( f6 , f2 ) ]
		)
	)
).

test_data(generalization640,generalization,generalization640_b, true).


% ---------------
spl_db( generalization641_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization641_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ), excludes( f2 , f9 ) ]
		)
	)
).

test_data(generalization641,generalization,generalization641_b, true).


% ---------------
spl_db( generalization642_a,
	 spl( [ root, f1, f9, f2, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization642_b,
	 spl( [ root, f1, f9, f2, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f4 , f1 ), requires( f4 , f5 ) ]
		)
	)
).

test_data(generalization642,generalization,generalization642_b, true).


% ---------------
spl_db( generalization643_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f8 ), excludes( f4 , f1 ) ]
		)
	)
).

spl_db( generalization643_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization643,generalization,generalization643_b, false).


% ---------------
spl_db( generalization644_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization644_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(generalization644,generalization,generalization644_b, true).


% ---------------
spl_db( generalization645_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f8 ), excludes( f8 , f9 ) ]
		)
	)
).

spl_db( generalization645_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization645,generalization,generalization645_b, false).


% ---------------
spl_db( generalization646_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f6 , f2 ) ]
		)
	)
).

spl_db( generalization646_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization646,generalization,generalization646_b, false).


% ---------------
spl_db( generalization647_a,
	 spl( [ root, f1, f2, f3, f4, f6, f8, f9, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ requires( f5 , f8 ), requires( f4 , f5 ), requires( f7 , f2 ) ]
		)
	)
).

spl_db( generalization647_b,
	 spl( [ root, f1, f2, f3, f4, f6, f8, f9, f7, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f6, [
						mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization647,generalization,generalization647_b, false).


% ---------------
spl_db( generalization648_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization648_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f1 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization648,generalization,generalization648_b, true).


% ---------------
spl_db( generalization649_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ), requires( f7 , f3 ) ]
		)
	)
).

spl_db( generalization649_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f6 ) ]
		)
	)
).

test_data(generalization649,generalization,generalization649_b, false).


% ---------------
spl_db( generalization650_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization650_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f4 ), requires( f5 , f9 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization650,generalization,generalization650_b, true).


% ---------------
spl_db( generalization651_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization651_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization651,generalization,generalization651_b, true).


% ---------------
spl_db( generalization652_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f2 ), requires( f7 , f6 ) ]
		)
	)
).

spl_db( generalization652_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization652,generalization,generalization652_b, false).


% ---------------
spl_db( generalization653_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

spl_db( generalization653_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
					mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization653,generalization,generalization653_b, false).


% ---------------
spl_db( generalization654_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization654_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f6, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [
						optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization654,generalization,generalization654_b, false).


% ---------------
spl_db( generalization655_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

spl_db( generalization655_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f5, [
						mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ), requires( f3 , f5 ), requires( f8 , f2 ) ]
		)
	)
).

test_data(generalization655,generalization,generalization655_b, true).


% ---------------
spl_db( generalization656_a,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f5 ), requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization656_b,
	 spl( [ root, f1, f4, f2, f3, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization656,generalization,generalization656_b, false).


% ---------------
spl_db( generalization657_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

spl_db( generalization657_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization657,generalization,generalization657_b, false).


% ---------------
spl_db( generalization658_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization658_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization658,generalization,generalization658_b, true).


% ---------------
spl_db( generalization659_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ), requires( f9 , f6 ) ]
		)
	)
).

spl_db( generalization659_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [
					mandatory( feature( f6, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(generalization659,generalization,generalization659_b, false).


% ---------------
spl_db( generalization660_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f3 ) ]
		)
	)
).

spl_db( generalization660_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f3 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization660,generalization,generalization660_b, true).


% ---------------
spl_db( generalization661_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization661_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f8 , f6 ), excludes( f7 , f5 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(generalization661,generalization,generalization661_b, true).


% ---------------
spl_db( generalization662_a,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ), excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization662_b,
	 spl( [ root, f1, f2, f7, f8, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization662,generalization,generalization662_b, false).


% ---------------
spl_db( generalization663_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f7 ) ]
		)
	)
).

spl_db( generalization663_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization663,generalization,generalization663_b, false).


% ---------------
spl_db( generalization664_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f4 , f8 ), requires( f2 , f4 ) ]
		)
	)
).

spl_db( generalization664_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization664,generalization,generalization664_b, false).


% ---------------
spl_db( generalization665_a,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization665_b,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(generalization665,generalization,generalization665_b, true).


% ---------------
spl_db( generalization666_a,
	 spl( [ root, f1, f4, f8, f5, f6, f2, f7, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f2 , f3 ), requires( f5 , f9 ) ]
		)
	)
).

spl_db( generalization666_b,
	 spl( [ root, f1, f4, f8, f5, f6, f2, f7, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization666,generalization,generalization666_b, false).


% ---------------
spl_db( generalization667_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization667_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f9, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization667,generalization,generalization667_b, true).


% ---------------
spl_db( generalization668_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f4 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( generalization668_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization668,generalization,generalization668_b, false).


% ---------------
spl_db( generalization669_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization669_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ) ]
		)
	)
).

test_data(generalization669,generalization,generalization669_b, true).


% ---------------
spl_db( generalization670_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization670_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

test_data(generalization670,generalization,generalization670_b, true).


% ---------------
spl_db( generalization671_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

spl_db( generalization671_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(generalization671,generalization,generalization671_b, true).


% ---------------
spl_db( generalization672_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization672_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f1 ) ]
		)
	)
).

test_data(generalization672,generalization,generalization672_b, true).


% ---------------
spl_db( generalization673_a,
	 spl( [ root, f1, f9, f2, f6, f7, f3, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f5 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization673_b,
	 spl( [ root, f1, f9, f2, f6, f7, f3, f4, f5, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization673,generalization,generalization673_b, false).


% ---------------
spl_db( generalization674_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f6 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( generalization674_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization674,generalization,generalization674_b, false).


% ---------------
spl_db( generalization675_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization675_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization675,generalization,generalization675_b, true).


% ---------------
spl_db( generalization676_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f1 ), requires( f8 , f7 ) ]
		)
	)
).

spl_db( generalization676_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization676,generalization,generalization676_b, false).


% ---------------
spl_db( generalization677_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization677_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization677,generalization,generalization677_b, false).


% ---------------
spl_db( generalization678_a,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), requires( f2 , f7 ) ]
		)
	)
).

spl_db( generalization678_b,
	 spl( [ root, f1, f2, f9, f3, f7, f8, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
				only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization678,generalization,generalization678_b, false).


% ---------------
spl_db( generalization679_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

spl_db( generalization679_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization679,generalization,generalization679_b, false).


% ---------------
spl_db( generalization680_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f6 , f1 ), excludes( f4 , f9 ) ]
		)
	)
).

spl_db( generalization680_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization680,generalization,generalization680_b, false).


% ---------------
spl_db( generalization681_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ) ]
		)
	)
).

spl_db( generalization681_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f3 ), requires( f7 , f3 ), requires( f5 , f6 ) ]
		)
	)
).

test_data(generalization681,generalization,generalization681_b, true).


% ---------------
spl_db( generalization682_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f1 ), requires( f1 , f3 ) ]
		)
	)
).

spl_db( generalization682_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization682,generalization,generalization682_b, false).


% ---------------
spl_db( generalization683_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f4 ), requires( f7 , f3 ) ]
		)
	)
).

spl_db( generalization683_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization683,generalization,generalization683_b, false).


% ---------------
spl_db( generalization684_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ), excludes( f9 , f6 ) ]
		)
	)
).

spl_db( generalization684_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization684,generalization,generalization684_b, false).


% ---------------
spl_db( generalization685_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization685_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f5 ) ]
		)
	)
).

test_data(generalization685,generalization,generalization685_b, true).


% ---------------
spl_db( generalization686_a,
	 spl( [ root, f1, f2, f4, f5, f6, f3, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ), feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

spl_db( generalization686_b,
	 spl( [ root, f1, f2, f4, f5, f6, f3, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ), feature( f3, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f3 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(generalization686,generalization,generalization686_b, true).


% ---------------
spl_db( generalization687_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f9 ), requires( f3 , f7 ) ]
		)
	)
).

spl_db( generalization687_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization687,generalization,generalization687_b, false).


% ---------------
spl_db( generalization688_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), requires( f1 , f6 ) ]
		)
	)
).

spl_db( generalization688_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization688,generalization,generalization688_b, false).


% ---------------
spl_db( generalization689_a,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f1 , f4 ) ]
		)
	)
).

spl_db( generalization689_b,
	 spl( [ root, f1, f2, f3, f7, f4, f5, f6, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization689,generalization,generalization689_b, false).


% ---------------
spl_db( generalization690_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization690_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(generalization690,generalization,generalization690_b, true).


% ---------------
spl_db( generalization691_a,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( generalization691_b,
	 spl( [ root, f1, f2, f8, f9, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization691,generalization,generalization691_b, false).


% ---------------
spl_db( generalization692_a,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f1 ), requires( f7 , f6 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( generalization692_b,
	 spl( [ root, f1, f2, f6, f9, f7, f8, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				only_one( [ feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization692,generalization,generalization692_b, false).


% ---------------
spl_db( generalization693_a,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f4 ), excludes( f4 , f2 ) ]
		)
	)
).

spl_db( generalization693_b,
	 spl( [ root, f1, f2, f3, f5, f6, f9, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
					mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f4 ) ]
		)
	)
).

test_data(generalization693,generalization,generalization693_b, false).


% ---------------
spl_db( generalization694_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), excludes( f4 , f9 ), requires( f5 , f2 ) ]
		)
	)
).

spl_db( generalization694_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f8, [] ) ) ] ) ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization694,generalization,generalization694_b, false).


% ---------------
spl_db( generalization695_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization695_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(generalization695,generalization,generalization695_b, true).


% ---------------
spl_db( generalization696_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization696_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f7 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(generalization696,generalization,generalization696_b, true).


% ---------------
spl_db( generalization697_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f8 ), requires( f8 , f2 ) ]
		)
	)
).

spl_db( generalization697_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization697,generalization,generalization697_b, false).


% ---------------
spl_db( generalization698_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization698_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f8, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f3 , f6 ), requires( f7 , f3 ) ]
		)
	)
).

test_data(generalization698,generalization,generalization698_b, true).


% ---------------
spl_db( generalization699_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization699_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f8 ), excludes( f5 , f6 ) ]
		)
	)
).

test_data(generalization699,generalization,generalization699_b, true).


% ---------------
spl_db( generalization700_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f6 ), excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization700_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization700,generalization,generalization700_b, false).


% ---------------
spl_db( generalization701_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f2 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( generalization701_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f2 ) ]
		)
	)
).

test_data(generalization701,generalization,generalization701_b, false).


% ---------------
spl_db( generalization702_a,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f2 ) ]
		)
	)
).

spl_db( generalization702_b,
	 spl( [ root, f1, f9, f2, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f4 , f2 ), excludes( f5 , f2 ) ]
		)
	)
).

test_data(generalization702,generalization,generalization702_b, true).


% ---------------
spl_db( generalization703_a,
	 spl( [ root, f1, f2, f6, f8, f7, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization703_b,
	 spl( [ root, f1, f2, f6, f8, f7, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ excludes( f3 , f9 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(generalization703,generalization,generalization703_b, true).


% ---------------
spl_db( generalization704_a,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f3 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( generalization704_b,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f3 ) ]
		)
	)
).

test_data(generalization704,generalization,generalization704_b, false).


% ---------------
spl_db( generalization705_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f9 ) ]
		)
	)
).

spl_db( generalization705_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f9 ), requires( f4 , f1 ) ]
		)
	)
).

test_data(generalization705,generalization,generalization705_b, true).


% ---------------
spl_db( generalization706_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f5, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f9 ), excludes( f3 , f4 ) ]
		)
	)
).

spl_db( generalization706_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f5, [
							mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization706,generalization,generalization706_b, false).


% ---------------
spl_db( generalization707_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization707_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ) ] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f2 ) ]
		)
	)
).

test_data(generalization707,generalization,generalization707_b, true).


% ---------------
spl_db( generalization708_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization708_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(generalization708,generalization,generalization708_b, true).


% ---------------
spl_db( generalization709_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization709_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ), excludes( f5 , f9 ) ]
		)
	)
).

test_data(generalization709,generalization,generalization709_b, true).


% ---------------
spl_db( generalization710_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

spl_db( generalization710_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization710,generalization,generalization710_b, false).


% ---------------
spl_db( generalization711_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f7 ), excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization711_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization711,generalization,generalization711_b, false).


% ---------------
spl_db( generalization712_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ), excludes( f9 , f7 ), requires( f3 , f5 ) ]
		)
	)
).

spl_db( generalization712_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

test_data(generalization712,generalization,generalization712_b, false).


% ---------------
spl_db( generalization713_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

spl_db( generalization713_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f7 , f2 ), requires( f5 , f2 ) ]
		)
	)
).

test_data(generalization713,generalization,generalization713_b, true).


% ---------------
spl_db( generalization714_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f4 ), excludes( f9 , f5 ), requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization714_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization714,generalization,generalization714_b, false).


% ---------------
spl_db( generalization715_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ excludes( f2 , f3 ), requires( f4 , f5 ) ]
		)
	)
).

spl_db( generalization715_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization715,generalization,generalization715_b, false).


% ---------------
spl_db( generalization716_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f1 ), excludes( f1 , f7 ) ]
		)
	)
).

spl_db( generalization716_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization716,generalization,generalization716_b, false).


% ---------------
spl_db( generalization717_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization717_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f2 ) ]
		)
	)
).

test_data(generalization717,generalization,generalization717_b, true).


% ---------------
spl_db( generalization718_a,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f2, f4, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ), feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

spl_db( generalization718_b,
	 spl( [ root, f1, f3, f6, f7, f8, f9, f2, f4, f5 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), optional( feature( f7, [
						mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ), feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization718,generalization,generalization718_b, false).


% ---------------
spl_db( generalization719_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization719_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(generalization719,generalization,generalization719_b, true).


% ---------------
spl_db( generalization720_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization720_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

test_data(generalization720,generalization,generalization720_b, false).


% ---------------
spl_db( generalization721_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f1 , f5 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( generalization721_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization721,generalization,generalization721_b, false).


% ---------------
spl_db( generalization722_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ) ]
		)
	)
).

spl_db( generalization722_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f8 , f7 ), excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization722,generalization,generalization722_b, true).


% ---------------
spl_db( generalization723_a,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization723_b,
	 spl( [ root, f1, f8, f2, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization723,generalization,generalization723_b, true).


% ---------------
spl_db( generalization724_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization724_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f8 ), requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization724,generalization,generalization724_b, true).


% ---------------
spl_db( generalization725_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

spl_db( generalization725_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f4 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(generalization725,generalization,generalization725_b, true).


% ---------------
spl_db( generalization726_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f3 , f1 ), requires( f8 , f2 ) ]
		)
	)
).

spl_db( generalization726_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

test_data(generalization726,generalization,generalization726_b, false).


% ---------------
spl_db( generalization727_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f9 ), requires( f6 , f1 ) ]
		)
	)
).

spl_db( generalization727_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f1 , f9 ) ]
		)
	)
).

test_data(generalization727,generalization,generalization727_b, false).


% ---------------
spl_db( generalization728_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization728_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

test_data(generalization728,generalization,generalization728_b, true).


% ---------------
spl_db( generalization729_a,
	 spl( [ root, f1, f3, f4, f6, f7, f5, f2, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization729_b,
	 spl( [ root, f1, f3, f4, f6, f7, f5, f2, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ) ] ) ), optional( feature( f2, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f8 ), requires( f8 , f1 ) ]
		)
	)
).

test_data(generalization729,generalization,generalization729_b, true).


% ---------------
spl_db( generalization730_a,
	 spl( [ root, f1, f4, f5, f8, f6, f7, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f8 , f7 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization730_b,
	 spl( [ root, f1, f4, f5, f8, f6, f7, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization730,generalization,generalization730_b, false).


% ---------------
spl_db( generalization731_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization731_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f4 ), requires( f6 , f9 ), requires( f5 , f1 ) ]
		)
	)
).

test_data(generalization731,generalization,generalization731_b, true).


% ---------------
spl_db( generalization732_a,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization732_b,
	 spl( [ root, f1, f5, f9, f6, f7, f8, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f6 , f5 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(generalization732,generalization,generalization732_b, true).


% ---------------
spl_db( generalization733_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f7 , f1 ) ]
		)
	)
).

spl_db( generalization733_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization733,generalization,generalization733_b, false).


% ---------------
spl_db( generalization734_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

spl_db( generalization734_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization734,generalization,generalization734_b, false).


% ---------------
spl_db( generalization735_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f7 ), excludes( f1 , f2 ) ]
		)
	)
).

spl_db( generalization735_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization735,generalization,generalization735_b, false).


% ---------------
spl_db( generalization736_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f7 , f8 ), requires( f2 , f4 ) ]
		)
	)
).

spl_db( generalization736_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization736,generalization,generalization736_b, false).


% ---------------
spl_db( generalization737_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f7 ), requires( f2 , f8 ), requires( f4 , f3 ) ]
		)
	)
).

spl_db( generalization737_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization737,generalization,generalization737_b, false).


% ---------------
spl_db( generalization738_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f5 ), requires( f9 , f7 ) ]
		)
	)
).

spl_db( generalization738_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(generalization738,generalization,generalization738_b, false).


% ---------------
spl_db( generalization739_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

spl_db( generalization739_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f8 ), requires( f1 , f4 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(generalization739,generalization,generalization739_b, true).


% ---------------
spl_db( generalization740_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f6 , f3 ), requires( f6 , f9 ) ]
		)
	)
).

spl_db( generalization740_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

test_data(generalization740,generalization,generalization740_b, false).


% ---------------
spl_db( generalization741_a,
	 spl( [ root, f1, f2, f3, f6, f8, f9, f7, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f4 ), excludes( f1 , f6 ) ]
		)
	)
).

spl_db( generalization741_b,
	 spl( [ root, f1, f2, f3, f6, f8, f9, f7, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization741,generalization,generalization741_b, false).


% ---------------
spl_db( generalization742_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f7 ), requires( f6 , f8 ) ]
		)
	)
).

spl_db( generalization742_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f4 , f7 ), requires( f6 , f8 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(generalization742,generalization,generalization742_b, true).


% ---------------
spl_db( generalization743_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f4 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( generalization743_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization743,generalization,generalization743_b, false).


% ---------------
spl_db( generalization744_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization744_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f4 ) ]
		)
	)
).

test_data(generalization744,generalization,generalization744_b, true).


% ---------------
spl_db( generalization745_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f5 ), requires( f1 , f7 ) ]
		)
	)
).

spl_db( generalization745_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

test_data(generalization745,generalization,generalization745_b, false).


% ---------------
spl_db( generalization746_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), excludes( f9 , f8 ) ]
		)
	)
).

spl_db( generalization746_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), excludes( f9 , f8 ), excludes( f1 , f9 ) ]
		)
	)
).

test_data(generalization746,generalization,generalization746_b, true).


% ---------------
spl_db( generalization747_a,
	 spl( [ root, f1, f9, f2, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization747_b,
	 spl( [ root, f1, f9, f2, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(generalization747,generalization,generalization747_b, true).


% ---------------
spl_db( generalization748_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization748_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f3 , f5 ), requires( f5 , f9 ) ]
		)
	)
).

test_data(generalization748,generalization,generalization748_b, true).


% ---------------
spl_db( generalization749_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f2 ) ]
		)
	)
).

spl_db( generalization749_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f9 , f2 ), requires( f2 , f7 ) ]
		)
	)
).

test_data(generalization749,generalization,generalization749_b, true).


% ---------------
spl_db( generalization750_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f6 , f9 ), requires( f1 , f5 ) ]
		)
	)
).

spl_db( generalization750_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization750,generalization,generalization750_b, false).


% ---------------
spl_db( generalization751_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					optional( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization751_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f2, [] ), feature( f3, [
					optional( feature( f9, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [
					one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

test_data(generalization751,generalization,generalization751_b, true).


% ---------------
spl_db( generalization752_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f8 ), excludes( f3 , f5 ) ]
		)
	)
).

spl_db( generalization752_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f4 , f8 ) ]
		)
	)
).

test_data(generalization752,generalization,generalization752_b, false).


% ---------------
spl_db( generalization753_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization753_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f9 ) ]
		)
	)
).

test_data(generalization753,generalization,generalization753_b, true).


% ---------------
spl_db( generalization754_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
						one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f8 , f9 ) ]
		)
	)
).

spl_db( generalization754_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [
						one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(generalization754,generalization,generalization754_b, false).


% ---------------
spl_db( generalization755_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization755_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f4 , f5 ), requires( f4 , f2 ) ]
		)
	)
).

test_data(generalization755,generalization,generalization755_b, true).


% ---------------
spl_db( generalization756_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f4 ), requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization756_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization756,generalization,generalization756_b, false).


% ---------------
spl_db( generalization757_a,
	 spl( [ root, f1, f4, f9, f2, f3, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization757_b,
	 spl( [ root, f1, f4, f9, f2, f3, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization757,generalization,generalization757_b, true).


% ---------------
spl_db( generalization758_a,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization758_b,
	 spl( [ root, f1, f2, f3, f7, f8, f4, f9, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization758,generalization,generalization758_b, true).


% ---------------
spl_db( generalization759_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f9 ), excludes( f2 , f6 ) ]
		)
	)
).

spl_db( generalization759_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

test_data(generalization759,generalization,generalization759_b, false).


% ---------------
spl_db( generalization760_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization760_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f3 , f7 ), excludes( f8 , f7 ) ]
		)
	)
).

test_data(generalization760,generalization,generalization760_b, true).


% ---------------
spl_db( generalization761_a,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization761_b,
	 spl( [ root, f1, f2, f8, f3, f4, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization761,generalization,generalization761_b, false).


% ---------------
spl_db( generalization762_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization762_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(generalization762,generalization,generalization762_b, true).


% ---------------
spl_db( generalization763_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

spl_db( generalization763_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization763,generalization,generalization763_b, false).


% ---------------
spl_db( generalization764_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization764_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

test_data(generalization764,generalization,generalization764_b, false).


% ---------------
spl_db( generalization765_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization765_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

test_data(generalization765,generalization,generalization765_b, true).


% ---------------
spl_db( generalization766_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f3 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization766_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f3 ), requires( f9 , f4 ), excludes( f7 , f8 ) ]
		)
	)
).

test_data(generalization766,generalization,generalization766_b, true).


% ---------------
spl_db( generalization767_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization767_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f8 ), requires( f4 , f7 ) ]
		)
	)
).

test_data(generalization767,generalization,generalization767_b, true).


% ---------------
spl_db( generalization768_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f3 ) ]
		)
	)
).

spl_db( generalization768_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f6 , f3 ), excludes( f8 , f6 ) ]
		)
	)
).

test_data(generalization768,generalization,generalization768_b, true).


% ---------------
spl_db( generalization769_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

spl_db( generalization769_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization769,generalization,generalization769_b, false).


% ---------------
spl_db( generalization770_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization770_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization770,generalization,generalization770_b, false).


% ---------------
spl_db( generalization771_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization771_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

test_data(generalization771,generalization,generalization771_b, true).


% ---------------
spl_db( generalization772_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization772_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [
				optional( feature( f5, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f6 ), requires( f5 , f1 ) ]
		)
	)
).

test_data(generalization772,generalization,generalization772_b, true).


% ---------------
spl_db( generalization773_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f5 , f1 ), excludes( f4 , f9 ) ]
		)
	)
).

spl_db( generalization773_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(generalization773,generalization,generalization773_b, false).


% ---------------
spl_db( generalization774_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f8 ), excludes( f8 , f1 ) ]
		)
	)
).

spl_db( generalization774_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization774,generalization,generalization774_b, false).


% ---------------
spl_db( generalization775_a,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization775_b,
	 spl( [ root, f1, f2, f4, f9, f5, f6, f7, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				mandatory( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ), feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(generalization775,generalization,generalization775_b, true).


% ---------------
spl_db( generalization776_a,
	 spl( [ root, f1, f6, f9, f7, f2, f3, f5, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization776_b,
	 spl( [ root, f1, f6, f9, f7, f2, f3, f5, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f8 , f9 ), requires( f9 , f4 ) ]
		)
	)
).

test_data(generalization776,generalization,generalization776_b, true).


% ---------------
spl_db( generalization777_a,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f4 ) ]
		)
	)
).

spl_db( generalization777_b,
	 spl( [ root, f1, f8, f2, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f9 , f4 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization777,generalization,generalization777_b, true).


% ---------------
spl_db( generalization778_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f9 ), excludes( f6 , f2 ) ]
		)
	)
).

spl_db( generalization778_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

test_data(generalization778,generalization,generalization778_b, false).


% ---------------
spl_db( generalization779_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f3 ), excludes( f8 , f3 ) ]
		)
	)
).

spl_db( generalization779_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f3 ) ]
		)
	)
).

test_data(generalization779,generalization,generalization779_b, false).


% ---------------
spl_db( generalization780_a,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization780_b,
	 spl( [ root, f1, f2, f9, f3, f4, f8, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ),
 [ excludes( f9 , f6 ), excludes( f5 , f4 ), excludes( f2 , f5 ) ]
		)
	)
).

test_data(generalization780,generalization,generalization780_b, true).


% ---------------
spl_db( generalization781_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f9 ), excludes( f9 , f1 ), excludes( f8 , f3 ) ]
		)
	)
).

spl_db( generalization781_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f9 ), excludes( f9 , f1 ) ]
		)
	)
).

test_data(generalization781,generalization,generalization781_b, false).


% ---------------
spl_db( generalization782_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization782_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f7 , f8 ) ]
		)
	)
).

test_data(generalization782,generalization,generalization782_b, true).


% ---------------
spl_db( generalization783_a,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization783_b,
	 spl( [ root, f1, f6, f7, f8, f2, f3, f4, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

test_data(generalization783,generalization,generalization783_b, true).


% ---------------
spl_db( generalization784_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f8 ), requires( f7 , f3 ) ]
		)
	)
).

spl_db( generalization784_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f8 ), requires( f7 , f3 ), excludes( f7 , f1 ) ]
		)
	)
).

test_data(generalization784,generalization,generalization784_b, true).


% ---------------
spl_db( generalization785_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f7 ) ]
		)
	)
).

spl_db( generalization785_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				mandatory( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization785,generalization,generalization785_b, false).


% ---------------
spl_db( generalization786_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

spl_db( generalization786_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization786,generalization,generalization786_b, false).


% ---------------
spl_db( generalization787_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization787_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization787,generalization,generalization787_b, true).


% ---------------
spl_db( generalization788_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [
						mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f7 , f2 ), requires( f2 , f1 ) ]
		)
	)
).

spl_db( generalization788_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f5, [
						mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization788,generalization,generalization788_b, false).


% ---------------
spl_db( generalization789_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f5 ), requires( f5 , f4 ) ]
		)
	)
).

spl_db( generalization789_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f7, [
						optional( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization789,generalization,generalization789_b, false).


% ---------------
spl_db( generalization790_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f1 ) ]
		)
	)
).

spl_db( generalization790_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(generalization790,generalization,generalization790_b, true).


% ---------------
spl_db( generalization791_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f9 ) ]
		)
	)
).

spl_db( generalization791_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization791,generalization,generalization791_b, false).


% ---------------
spl_db( generalization792_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

spl_db( generalization792_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f7, f5, f6 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [
						mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f8 ), excludes( f5 , f7 ) ]
		)
	)
).

test_data(generalization792,generalization,generalization792_b, true).


% ---------------
spl_db( generalization793_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f8 ), excludes( f4 , f5 ) ]
		)
	)
).

spl_db( generalization793_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f2, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization793,generalization,generalization793_b, false).


% ---------------
spl_db( generalization794_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f9 ), excludes( f6 , f7 ), excludes( f9 , f7 ) ]
		)
	)
).

spl_db( generalization794_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f4 , f9 ) ]
		)
	)
).

test_data(generalization794,generalization,generalization794_b, false).


% ---------------
spl_db( generalization795_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization795_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

test_data(generalization795,generalization,generalization795_b, true).


% ---------------
spl_db( generalization796_a,
	 spl( [ root, f1, f3, f7, f8, f9, f2, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f1 ), excludes( f4 , f7 ), excludes( f5 , f3 ) ]
		)
	)
).

spl_db( generalization796_b,
	 spl( [ root, f1, f3, f7, f8, f9, f2, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f7, [
						optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f1 ), excludes( f4 , f7 ) ]
		)
	)
).

test_data(generalization796,generalization,generalization796_b, false).


% ---------------
spl_db( generalization797_a,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization797_b,
	 spl( [ root, f1, f9, f2, f8, f3, f4, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(generalization797,generalization,generalization797_b, true).


% ---------------
spl_db( generalization798_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization798_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), mandatory( feature( f4, [
						mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f3 ) ]
		)
	)
).

test_data(generalization798,generalization,generalization798_b, true).


% ---------------
spl_db( generalization799_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f6 , f8 ), requires( f2 , f8 ) ]
		)
	)
).

spl_db( generalization799_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f5, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization799,generalization,generalization799_b, false).


% ---------------
spl_db( generalization800_a,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization800_b,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization800,generalization,generalization800_b, false).


% ---------------
spl_db( generalization801_a,
	 spl( [ root, f1, f6, f8, f9, f2, f3, f7, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization801_b,
	 spl( [ root, f1, f6, f8, f9, f2, f3, f7, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f6, [
					optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f7, [] ) ) ] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), requires( f5 , f4 ) ]
		)
	)
).

test_data(generalization801,generalization,generalization801_b, true).


% ---------------
spl_db( generalization802_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ), excludes( f8 , f2 ) ]
		)
	)
).

spl_db( generalization802_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f9 ) ]
		)
	)
).

test_data(generalization802,generalization,generalization802_b, false).


% ---------------
spl_db( generalization803_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization803_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f7 , f6 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization803,generalization,generalization803_b, true).


% ---------------
spl_db( generalization804_a,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f7 , f8 ), excludes( f6 , f3 ) ]
		)
	)
).

spl_db( generalization804_b,
	 spl( [ root, f1, f2, f3, f4, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization804,generalization,generalization804_b, false).


% ---------------
spl_db( generalization805_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization805_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f2 ) ]
		)
	)
).

test_data(generalization805,generalization,generalization805_b, true).


% ---------------
spl_db( generalization806_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization806_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(generalization806,generalization,generalization806_b, true).


% ---------------
spl_db( generalization807_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f8 ), excludes( f5 , f4 ) ]
		)
	)
).

spl_db( generalization807_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization807,generalization,generalization807_b, false).


% ---------------
spl_db( generalization808_a,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization808_b,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f4 ), excludes( f1 , f5 ) ]
		)
	)
).

test_data(generalization808,generalization,generalization808_b, true).


% ---------------
spl_db( generalization809_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f5 ) ]
		)
	)
).

spl_db( generalization809_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [
					optional( feature( f8, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f9 , f5 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(generalization809,generalization,generalization809_b, true).


% ---------------
spl_db( generalization810_a,
	 spl( [ root, f1, f2, f4, f9, f5, f8, f6, f3, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					only_one( [ feature( f4, [
						optional( feature( f9, [] ) ) ] ), feature( f5, [
						optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ), feature( f3, [
					mandatory( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization810_b,
	 spl( [ root, f1, f2, f4, f9, f5, f8, f6, f3, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					only_one( [ feature( f4, [
						optional( feature( f9, [] ) ) ] ), feature( f5, [
						optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ), feature( f3, [
					mandatory( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

test_data(generalization810,generalization,generalization810_b, true).


% ---------------
spl_db( generalization811_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization811_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f3, f9, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(generalization811,generalization,generalization811_b, true).


% ---------------
spl_db( generalization812_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization812_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f5 , f7 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(generalization812,generalization,generalization812_b, true).


% ---------------
spl_db( generalization813_a,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization813_b,
	 spl( [ root, f1, f2, f6, f7, f8, f9, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f3 , f2 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(generalization813,generalization,generalization813_b, true).


% ---------------
spl_db( generalization814_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

spl_db( generalization814_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f9 , f5 ), requires( f6 , f5 ) ]
		)
	)
).

test_data(generalization814,generalization,generalization814_b, true).


% ---------------
spl_db( generalization815_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization815_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f8, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(generalization815,generalization,generalization815_b, true).


% ---------------
spl_db( generalization816_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f9 ) ]
		)
	)
).

spl_db( generalization816_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization816,generalization,generalization816_b, false).


% ---------------
spl_db( generalization817_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f1 ), excludes( f2 , f8 ) ]
		)
	)
).

spl_db( generalization817_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f1 ) ]
		)
	)
).

test_data(generalization817,generalization,generalization817_b, false).


% ---------------
spl_db( generalization818_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f5 ) ]
		)
	)
).

spl_db( generalization818_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization818,generalization,generalization818_b, false).


% ---------------
spl_db( generalization819_a,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f7 , f9 ), requires( f6 , f2 ) ]
		)
	)
).

spl_db( generalization819_b,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization819,generalization,generalization819_b, false).


% ---------------
spl_db( generalization820_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f4 ), excludes( f7 , f1 ) ]
		)
	)
).

spl_db( generalization820_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f5 , f4 ) ]
		)
	)
).

test_data(generalization820,generalization,generalization820_b, false).


% ---------------
spl_db( generalization821_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f2 , f9 ), excludes( f1 , f8 ) ]
		)
	)
).

spl_db( generalization821_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f7, f8, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f9, [] ) ) ] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization821,generalization,generalization821_b, false).


% ---------------
spl_db( generalization822_a,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f9 ), requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization822_b,
	 spl( [ root, f1, f2, f3, f4, f7, f9, f8, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f8, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(generalization822,generalization,generalization822_b, false).


% ---------------
spl_db( generalization823_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f7 ), requires( f7 , f1 ) ]
		)
	)
).

spl_db( generalization823_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(generalization823,generalization,generalization823_b, false).


% ---------------
spl_db( generalization824_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization824_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f5 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(generalization824,generalization,generalization824_b, true).


% ---------------
spl_db( generalization825_a,
	 spl( [ root, f1, f2, f3, f6, f8, f4, f7, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f6, [
							optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [
						mandatory( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization825_b,
	 spl( [ root, f1, f2, f3, f6, f8, f4, f7, f9, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						optional( feature( f6, [
							optional( feature( f8, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [
						mandatory( feature( f7, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f5, [] ) ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

test_data(generalization825,generalization,generalization825_b, true).


% ---------------
spl_db( generalization826_a,
	 spl( [ root, f1, f2, f6, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization826_b,
	 spl( [ root, f1, f2, f6, f3, f4, f5, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f6, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f7 ) ]
		)
	)
).

test_data(generalization826,generalization,generalization826_b, true).


% ---------------
spl_db( generalization827_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f5 , f8 ) ]
		)
	)
).

spl_db( generalization827_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization827,generalization,generalization827_b, false).


% ---------------
spl_db( generalization828_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization828_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f9 ), excludes( f7 , f5 ) ]
		)
	)
).

test_data(generalization828,generalization,generalization828_b, true).


% ---------------
spl_db( generalization829_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

spl_db( generalization829_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization829,generalization,generalization829_b, false).


% ---------------
spl_db( generalization830_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f4 , f3 ) ]
		)
	)
).

spl_db( generalization830_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization830,generalization,generalization830_b, false).


% ---------------
spl_db( generalization831_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization831_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

test_data(generalization831,generalization,generalization831_b, true).


% ---------------
spl_db( generalization832_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ), requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization832_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f4 ) ]
		)
	)
).

test_data(generalization832,generalization,generalization832_b, false).


% ---------------
spl_db( generalization833_a,
	 spl( [ root, f1, f8, f2, f3, f4, f7, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f2 , f3 ) ]
		)
	)
).

spl_db( generalization833_b,
	 spl( [ root, f1, f8, f2, f3, f4, f7, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization833,generalization,generalization833_b, false).


% ---------------
spl_db( generalization834_a,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f1 ), requires( f5 , f7 ) ]
		)
	)
).

spl_db( generalization834_b,
	 spl( [ root, f1, f2, f3, f4, f7, f5, f6, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

test_data(generalization834,generalization,generalization834_b, false).


% ---------------
spl_db( generalization835_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f3 ), requires( f9 , f5 ) ]
		)
	)
).

spl_db( generalization835_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization835,generalization,generalization835_b, false).


% ---------------
spl_db( generalization836_a,
	 spl( [ root, f1, f8, f9, f2, f5, f6, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ excludes( f4 , f7 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization836_b,
	 spl( [ root, f1, f8, f9, f2, f5, f6, f7, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization836,generalization,generalization836_b, false).


% ---------------
spl_db( generalization837_a,
	 spl( [ root, f1, f2, f3, f7, f4, f9, f5, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f3 ), excludes( f9 , f7 ) ]
		)
	)
).

spl_db( generalization837_b,
	 spl( [ root, f1, f2, f3, f7, f4, f9, f5, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [
						optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f4, [
						mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [
						mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization837,generalization,generalization837_b, false).


% ---------------
spl_db( generalization838_a,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f5, [] ) ) ] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization838_b,
	 spl( [ root, f1, f2, f5, f3, f4, f6, f7, f8, f9 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f5, [] ) ) ] ) ] ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ excludes( f4 , f2 ), requires( f1 , f4 ) ]
		)
	)
).

test_data(generalization838,generalization,generalization838_b, true).


% ---------------
spl_db( generalization839_a,
	 spl( [ root, f1, f3, f9, f4, f5, f8, f6, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization839_b,
	 spl( [ root, f1, f3, f9, f4, f5, f8, f6, f7, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization839,generalization,generalization839_b, true).


% ---------------
spl_db( generalization840_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f4 , f6 ), excludes( f4 , f2 ) ]
		)
	)
).

spl_db( generalization840_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f3 , f7 ), excludes( f4 , f6 ) ]
		)
	)
).

test_data(generalization840,generalization,generalization840_b, false).


% ---------------
spl_db( generalization841_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization841_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [
					optional( feature( f7, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f3 , f5 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(generalization841,generalization,generalization841_b, true).


% ---------------
spl_db( generalization842_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f5, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f3 ), requires( f8 , f7 ), requires( f9 , f4 ) ]
		)
	)
).

spl_db( generalization842_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f5, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f5, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f6 , f3 ), requires( f8 , f7 ) ]
		)
	)
).

test_data(generalization842,generalization,generalization842_b, false).


% ---------------
spl_db( generalization843_a,
	 spl( [ root, f1, f2, f3, f5, f6, f8, f7, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization843_b,
	 spl( [ root, f1, f2, f3, f5, f6, f8, f7, f9, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f1 , f2 ), excludes( f6 , f9 ) ]
		)
	)
).

test_data(generalization843,generalization,generalization843_b, true).


% ---------------
spl_db( generalization844_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f3 , f6 ) ]
		)
	)
).

spl_db( generalization844_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization844,generalization,generalization844_b, false).


% ---------------
spl_db( generalization845_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f5 ), requires( f2 , f1 ) ]
		)
	)
).

spl_db( generalization845_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization845,generalization,generalization845_b, false).


% ---------------
spl_db( generalization846_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization846_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f8 ) ]
		)
	)
).

test_data(generalization846,generalization,generalization846_b, true).


% ---------------
spl_db( generalization847_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization847_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
						mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f6 , f5 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization847,generalization,generalization847_b, true).


% ---------------
spl_db( generalization848_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization848_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f7 , f4 ), excludes( f9 , f1 ) ]
		)
	)
).

test_data(generalization848,generalization,generalization848_b, true).


% ---------------
spl_db( generalization849_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization849_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ), feature( f3, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

test_data(generalization849,generalization,generalization849_b, true).


% ---------------
spl_db( generalization850_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f3 , f2 ), excludes( f5 , f3 ) ]
		)
	)
).

spl_db( generalization850_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization850,generalization,generalization850_b, false).


% ---------------
spl_db( generalization851_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f8 , f6 ) ]
		)
	)
).

spl_db( generalization851_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization851,generalization,generalization851_b, false).


% ---------------
spl_db( generalization852_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization852_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f9 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(generalization852,generalization,generalization852_b, true).


% ---------------
spl_db( generalization853_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f5 ), requires( f7 , f9 ) ]
		)
	)
).

spl_db( generalization853_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f5 ) ]
		)
	)
).

test_data(generalization853,generalization,generalization853_b, false).


% ---------------
spl_db( generalization854_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f1 ), requires( f6 , f4 ) ]
		)
	)
).

spl_db( generalization854_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization854,generalization,generalization854_b, false).


% ---------------
spl_db( generalization855_a,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f9 , f8 ), excludes( f3 , f6 ) ]
		)
	)
).

spl_db( generalization855_b,
	 spl( [ root, f1, f9, f2, f7, f8, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f9 , f8 ) ]
		)
	)
).

test_data(generalization855,generalization,generalization855_b, false).


% ---------------
spl_db( generalization856_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f5 , f1 ), requires( f1 , f8 ) ]
		)
	)
).

spl_db( generalization856_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization856,generalization,generalization856_b, false).


% ---------------
spl_db( generalization857_a,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f6 , f2 ), requires( f4 , f6 ) ]
		)
	)
).

spl_db( generalization857_b,
	 spl( [ root, f1, f6, f7, f8, f9, f2, f3, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization857,generalization,generalization857_b, false).


% ---------------
spl_db( generalization858_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f3 ), excludes( f3 , f1 ) ]
		)
	)
).

spl_db( generalization858_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f7 , f3 ) ]
		)
	)
).

test_data(generalization858,generalization,generalization858_b, false).


% ---------------
spl_db( generalization859_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), requires( f4 , f8 ) ]
		)
	)
).

spl_db( generalization859_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization859,generalization,generalization859_b, false).


% ---------------
spl_db( generalization860_a,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization860_b,
	 spl( [ root, f1, f2, f3, f4, f6, f9, f7, f8, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), requires( f2 , f7 ) ]
		)
	)
).

test_data(generalization860,generalization,generalization860_b, true).


% ---------------
spl_db( generalization861_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ excludes( f5 , f3 ) ]
		)
	)
).

spl_db( generalization861_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization861,generalization,generalization861_b, false).


% ---------------
spl_db( generalization862_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f4 , f5 ), excludes( f9 , f1 ) ]
		)
	)
).

spl_db( generalization862_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(generalization862,generalization,generalization862_b, false).


% ---------------
spl_db( generalization863_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization863_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f9 , f4 ) ]
		)
	)
).

test_data(generalization863,generalization,generalization863_b, true).


% ---------------
spl_db( generalization864_a,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization864_b,
	 spl( [ root, f1, f2, f3, f5, f6, f7, f9, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ requires( f4 , f7 ), excludes( f6 , f5 ) ]
		)
	)
).

test_data(generalization864,generalization,generalization864_b, true).


% ---------------
spl_db( generalization865_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization865_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f2 , f8 ), requires( f3 , f7 ) ]
		)
	)
).

test_data(generalization865,generalization,generalization865_b, true).


% ---------------
spl_db( generalization866_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f5 , f1 ), excludes( f5 , f7 ) ]
		)
	)
).

spl_db( generalization866_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization866,generalization,generalization866_b, false).


% ---------------
spl_db( generalization867_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization867_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(generalization867,generalization,generalization867_b, true).


% ---------------
spl_db( generalization868_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization868_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				mandatory( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(generalization868,generalization,generalization868_b, true).


% ---------------
spl_db( generalization869_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

spl_db( generalization869_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization869,generalization,generalization869_b, false).


% ---------------
spl_db( generalization870_a,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f6 , f4 ), requires( f5 , f2 ) ]
		)
	)
).

spl_db( generalization870_b,
	 spl( [ root, f1, f2, f3, f5, f9, f6, f7, f8, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization870,generalization,generalization870_b, false).


% ---------------
spl_db( generalization871_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
							optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

spl_db( generalization871_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [
							optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization871,generalization,generalization871_b, false).


% ---------------
spl_db( generalization872_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f3 , f7 ) ]
		)
	)
).

spl_db( generalization872_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization872,generalization,generalization872_b, false).


% ---------------
spl_db( generalization873_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f2 ), requires( f1 , f4 ) ]
		)
	)
).

spl_db( generalization873_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f9, f8, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f3 , f2 ), requires( f1 , f4 ), requires( f4 , f3 ) ]
		)
	)
).

test_data(generalization873,generalization,generalization873_b, true).


% ---------------
spl_db( generalization874_a,
	 spl( [ root, f1, f2, f7, f3, f4, f9, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f3 , f2 ), excludes( f6 , f1 ) ]
		)
	)
).

spl_db( generalization874_b,
	 spl( [ root, f1, f2, f7, f3, f4, f9, f5, f6, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization874,generalization,generalization874_b, false).


% ---------------
spl_db( generalization875_a,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f9 , f2 ), requires( f1 , f4 ), excludes( f6 , f2 ) ]
		)
	)
).

spl_db( generalization875_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ) ] ),
 [ requires( f9 , f2 ) ]
		)
	)
).

test_data(generalization875,generalization,generalization875_b, false).


% ---------------
spl_db( generalization876_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f7 ) ]
		)
	)
).

spl_db( generalization876_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f7 ), excludes( f6 , f8 ), requires( f5 , f8 ) ]
		)
	)
).

test_data(generalization876,generalization,generalization876_b, true).


% ---------------
spl_db( generalization877_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization877_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f6 ), excludes( f4 , f3 ) ]
		)
	)
).

test_data(generalization877,generalization,generalization877_b, true).


% ---------------
spl_db( generalization878_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ), excludes( f9 , f7 ) ]
		)
	)
).

spl_db( generalization878_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization878,generalization,generalization878_b, false).


% ---------------
spl_db( generalization879_a,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f7 ), excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization879_b,
	 spl( [ root, f1, f2, f3, f8, f9, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

test_data(generalization879,generalization,generalization879_b, false).


% ---------------
spl_db( generalization880_a,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f2 ), requires( f8 , f1 ), requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization880_b,
	 spl( [ root, f1, f2, f6, f3, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f8 , f2 ), requires( f8 , f1 ) ]
		)
	)
).

test_data(generalization880,generalization,generalization880_b, false).


% ---------------
spl_db( generalization881_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f7 ) ]
		)
	)
).

spl_db( generalization881_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f4 , f7 ), excludes( f3 , f7 ) ]
		)
	)
).

test_data(generalization881,generalization,generalization881_b, true).


% ---------------
spl_db( generalization882_a,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f8 ) ]
		)
	)
).

spl_db( generalization882_b,
	 spl( [ root, f1, f2, f6, f7, f8, f3, f9, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [
				mandatory( feature( f9, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f7 , f8 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(generalization882,generalization,generalization882_b, true).


% ---------------
spl_db( generalization883_a,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f5 ) ]
		)
	)
).

spl_db( generalization883_b,
	 spl( [ root, f1, f2, f3, f6, f7, f9, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f5 ), excludes( f8 , f4 ) ]
		)
	)
).

test_data(generalization883,generalization,generalization883_b, true).


% ---------------
spl_db( generalization884_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization884_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization884,generalization,generalization884_b, false).


% ---------------
spl_db( generalization885_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( generalization885_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization885,generalization,generalization885_b, false).


% ---------------
spl_db( generalization886_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f6 ), excludes( f1 , f9 ) ]
		)
	)
).

spl_db( generalization886_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization886,generalization,generalization886_b, false).


% ---------------
spl_db( generalization887_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f2 , f4 ), excludes( f8 , f6 ) ]
		)
	)
).

spl_db( generalization887_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization887,generalization,generalization887_b, false).


% ---------------
spl_db( generalization888_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

spl_db( generalization888_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization888,generalization,generalization888_b, false).


% ---------------
spl_db( generalization889_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization889_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ),
 [ excludes( f1 , f9 ) ]
		)
	)
).

test_data(generalization889,generalization,generalization889_b, true).


% ---------------
spl_db( generalization890_a,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f9 ) ]
		)
	)
).

spl_db( generalization890_b,
	 spl( [ root, f1, f2, f3, f4, f7, f8, f5, f9, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f8 , f9 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization890,generalization,generalization890_b, true).


% ---------------
spl_db( generalization891_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f6 ), excludes( f5 , f6 ) ]
		)
	)
).

spl_db( generalization891_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization891,generalization,generalization891_b, false).


% ---------------
spl_db( generalization892_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization892_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f2, f9, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f2, [
				optional( feature( f9, [] ) ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f6 , f2 ), requires( f7 , f5 ) ]
		)
	)
).

test_data(generalization892,generalization,generalization892_b, true).


% ---------------
spl_db( generalization893_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization893_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(generalization893,generalization,generalization893_b, true).


% ---------------
spl_db( generalization894_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f2 , f9 ) ]
		)
	)
).

spl_db( generalization894_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [
				optional( feature( f8, [] ) ) ] ), feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization894,generalization,generalization894_b, false).


% ---------------
spl_db( generalization895_a,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f3 ), excludes( f1 , f2 ), excludes( f4 , f9 ) ]
		)
	)
).

spl_db( generalization895_b,
	 spl( [ root, f1, f7, f8, f2, f3, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [
				mandatory( feature( f3, [
					optional( feature( f9, [] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f3 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(generalization895,generalization,generalization895_b, false).


% ---------------
spl_db( generalization896_a,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f2 ), excludes( f9 , f3 ) ]
		)
	)
).

spl_db( generalization896_b,
	 spl( [ root, f1, f2, f3, f4, f8, f9, f5, f7, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), one_or_more( [ feature( f5, [
				mandatory( feature( f7, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f3 , f2 ) ]
		)
	)
).

test_data(generalization896,generalization,generalization896_b, false).


% ---------------
spl_db( generalization897_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f5 ), requires( f4 , f3 ) ]
		)
	)
).

spl_db( generalization897_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization897,generalization,generalization897_b, false).


% ---------------
spl_db( generalization898_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization898_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ), feature( f6, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f1 ), requires( f7 , f5 ), excludes( f1 , f2 ) ]
		)
	)
).

test_data(generalization898,generalization,generalization898_b, true).


% ---------------
spl_db( generalization899_a,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f6 , f1 ) ]
		)
	)
).

spl_db( generalization899_b,
	 spl( [ root, f1, f8, f9, f2, f3, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f6 , f1 ), excludes( f3 , f9 ) ]
		)
	)
).

test_data(generalization899,generalization,generalization899_b, true).


% ---------------
spl_db( generalization900_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization900_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f9, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [
				optional( feature( f7, [
					optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), excludes( f6 , f1 ) ]
		)
	)
).

test_data(generalization900,generalization,generalization900_b, true).


% ---------------
spl_db( generalization901_a,
	 spl( [ root, f1, f2, f4, f5, f8, f9, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f7 , f6 ) ]
		)
	)
).

spl_db( generalization901_b,
	 spl( [ root, f1, f2, f4, f5, f8, f9, f6, f7, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f4, [] ) ), optional( feature( f5, [
						mandatory( feature( f8, [
							mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization901,generalization,generalization901_b, false).


% ---------------
spl_db( generalization902_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization902_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ) ] ),
 [ excludes( f9 , f8 ), requires( f7 , f6 ) ]
		)
	)
).

test_data(generalization902,generalization,generalization902_b, true).


% ---------------
spl_db( generalization903_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

spl_db( generalization903_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f8 ), excludes( f8 , f2 ) ]
		)
	)
).

test_data(generalization903,generalization,generalization903_b, true).


% ---------------
spl_db( generalization904_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization904_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f4, [
				optional( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f1 , f3 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(generalization904,generalization,generalization904_b, true).


% ---------------
spl_db( generalization905_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization905_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				mandatory( feature( f7, [] ) ), optional( feature( f8, [
					optional( feature( f9, [] ) ) ] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(generalization905,generalization,generalization905_b, true).


% ---------------
spl_db( generalization906_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization906_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f7 ) ]
		)
	)
).

test_data(generalization906,generalization,generalization906_b, true).


% ---------------
spl_db( generalization907_a,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization907_b,
	 spl( [ root, f1, f4, f5, f6, f7, f8, f9, f2, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), optional( feature( f2, [
				optional( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f9 , f3 ) ]
		)
	)
).

test_data(generalization907,generalization,generalization907_b, true).


% ---------------
spl_db( generalization908_a,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization908_b,
	 spl( [ root, f1, f2, f8, f3, f4, f5, f6, f9, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f8, [] ) ) ] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ] ) ] ),
 [ requires( f4 , f2 ), requires( f3 , f9 ) ]
		)
	)
).

test_data(generalization908,generalization,generalization908_b, true).


% ---------------
spl_db( generalization909_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ requires( f4 , f9 ), excludes( f5 , f4 ) ]
		)
	)
).

spl_db( generalization909_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), optional( feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization909,generalization,generalization909_b, false).


% ---------------
spl_db( generalization910_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization910_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f3 ), requires( f4 , f8 ) ]
		)
	)
).

test_data(generalization910,generalization,generalization910_b, true).


% ---------------
spl_db( generalization911_a,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f3 , f8 ) ]
		)
	)
).

spl_db( generalization911_b,
	 spl( [ root, f1, f3, f4, f9, f5, f6, f7, f8, f2 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f3 , f8 ), requires( f8 , f4 ) ]
		)
	)
).

test_data(generalization911,generalization,generalization911_b, true).


% ---------------
spl_db( generalization912_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f8 ), excludes( f7 , f8 ), requires( f3 , f9 ) ]
		)
	)
).

spl_db( generalization912_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

test_data(generalization912,generalization,generalization912_b, false).


% ---------------
spl_db( generalization913_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization913_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f7 , f8 ), requires( f3 , f1 ) ]
		)
	)
).

test_data(generalization913,generalization,generalization913_b, true).


% ---------------
spl_db( generalization914_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ), excludes( f3 , f7 ) ]
		)
	)
).

spl_db( generalization914_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f8 , f2 ) ]
		)
	)
).

test_data(generalization914,generalization,generalization914_b, false).


% ---------------
spl_db( generalization915_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization915_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
					optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ), optional( feature( f2, [] ) ) ] ),
 [ requires( f8 , f7 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(generalization915,generalization,generalization915_b, true).


% ---------------
spl_db( generalization916_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f8 ), excludes( f4 , f7 ) ]
		)
	)
).

spl_db( generalization916_b,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

test_data(generalization916,generalization,generalization916_b, false).


% ---------------
spl_db( generalization917_a,
	 spl( [ root, f1, f2, f4, f5, f8, f6, f7, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f8 , f3 ), excludes( f1 , f8 ) ]
		)
	)
).

spl_db( generalization917_b,
	 spl( [ root, f1, f2, f4, f5, f8, f6, f7, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization917,generalization,generalization917_b, false).


% ---------------
spl_db( generalization918_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f4 ) ]
		)
	)
).

spl_db( generalization918_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f3 , f4 ), excludes( f6 , f7 ) ]
		)
	)
).

test_data(generalization918,generalization,generalization918_b, true).


% ---------------
spl_db( generalization919_a,
	 spl( [ root, f1, f8, f2, f3, f4, f6, f7, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f8 , f6 ) ]
		)
	)
).

spl_db( generalization919_b,
	 spl( [ root, f1, f8, f2, f3, f4, f6, f7, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), only_one( [ feature( f3, [] ), feature( f4, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [
					optional( feature( f9, [] ) ) ] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization919,generalization,generalization919_b, false).


% ---------------
spl_db( generalization920_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f1 ), excludes( f3 , f8 ) ]
		)
	)
).

spl_db( generalization920_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				mandatory( feature( f9, [] ) ) ] ), feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization920,generalization,generalization920_b, false).


% ---------------
spl_db( generalization921_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization921_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f9, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ), feature( f7, [] ) ] ) ] ),
 [ excludes( f9 , f4 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization921,generalization,generalization921_b, true).


% ---------------
spl_db( generalization922_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f1 , f8 ), excludes( f9 , f6 ), excludes( f5 , f8 ) ]
		)
	)
).

spl_db( generalization922_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization922,generalization,generalization922_b, false).


% ---------------
spl_db( generalization923_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization923_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [
					mandatory( feature( f4, [
						optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ) ) ] ),
 [ requires( f5 , f7 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(generalization923,generalization,generalization923_b, true).


% ---------------
spl_db( generalization924_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f6 ), requires( f2 , f3 ), excludes( f4 , f2 ) ]
		)
	)
).

spl_db( generalization924_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
					optional( feature( f9, [] ) ) ] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f6 ) ]
		)
	)
).

test_data(generalization924,generalization,generalization924_b, false).


% ---------------
spl_db( generalization925_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization925_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f8, [] ) ) ] ) ] ) ] ),
 [ requires( f9 , f8 ), excludes( f2 , f6 ) ]
		)
	)
).

test_data(generalization925,generalization,generalization925_b, true).


% ---------------
spl_db( generalization926_a,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f2 , f8 ) ]
		)
	)
).

spl_db( generalization926_b,
	 spl( [ root, f1, f9, f2, f3, f6, f7, f8, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), only_one( [ feature( f3, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization926,generalization,generalization926_b, false).


% ---------------
spl_db( generalization927_a,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f1 ) ]
		)
	)
).

spl_db( generalization927_b,
	 spl( [ root, f1, f2, f3, f4, f6, f7, f8, f9, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f5, [] ) ] ) ] ),
 [ requires( f2 , f1 ), excludes( f4 , f5 ) ]
		)
	)
).

test_data(generalization927,generalization,generalization927_b, true).


% ---------------
spl_db( generalization928_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f9 , f5 ), excludes( f1 , f3 ) ]
		)
	)
).

spl_db( generalization928_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), only_one( [ feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization928,generalization,generalization928_b, false).


% ---------------
spl_db( generalization929_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization929_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

test_data(generalization929,generalization,generalization929_b, true).


% ---------------
spl_db( generalization930_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

spl_db( generalization930_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [
				only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization930,generalization,generalization930_b, false).


% ---------------
spl_db( generalization931_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( generalization931_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), only_one( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f7 , f9 ), requires( f3 , f6 ) ]
		)
	)
).

test_data(generalization931,generalization,generalization931_b, true).


% ---------------
spl_db( generalization932_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f4 ), excludes( f9 , f5 ), excludes( f9 , f8 ) ]
		)
	)
).

spl_db( generalization932_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f4 ) ]
		)
	)
).

test_data(generalization932,generalization,generalization932_b, false).


% ---------------
spl_db( generalization933_a,
	 spl( [ root, f1, f4, f5, f6, f8, f7, f2, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization933_b,
	 spl( [ root, f1, f4, f5, f6, f8, f7, f2, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f6, [
						optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

test_data(generalization933,generalization,generalization933_b, true).


% ---------------
spl_db( generalization934_a,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f5 ) ]
		)
	)
).

spl_db( generalization934_b,
	 spl( [ root, f1, f5, f6, f7, f8, f9, f2, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f5, [] ) ), optional( feature( f6, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				optional( feature( f4, [] ) ) ] ) ] ) ] ),
 [ excludes( f3 , f5 ), excludes( f7 , f4 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(generalization934,generalization,generalization934_b, true).


% ---------------
spl_db( generalization935_a,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f6 , f3 ), requires( f7 , f4 ) ]
		)
	)
).

spl_db( generalization935_b,
	 spl( [ root, f1, f3, f4, f2, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization935,generalization,generalization935_b, false).


% ---------------
spl_db( generalization936_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

spl_db( generalization936_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), only_one( [ feature( f4, [
				optional( feature( f8, [] ) ) ] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization936,generalization,generalization936_b, false).


% ---------------
spl_db( generalization937_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f2 ) ]
		)
	)
).

spl_db( generalization937_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f1 , f2 ), excludes( f8 , f6 ), requires( f7 , f1 ) ]
		)
	)
).

test_data(generalization937,generalization,generalization937_b, true).


% ---------------
spl_db( generalization938_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

spl_db( generalization938_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [
					mandatory( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ) ] ),
 [ requires( f3 , f5 ), excludes( f5 , f1 ) ]
		)
	)
).

test_data(generalization938,generalization,generalization938_b, true).


% ---------------
spl_db( generalization939_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization939_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f5 , f9 ), requires( f6 , f2 ) ]
		)
	)
).

test_data(generalization939,generalization,generalization939_b, true).


% ---------------
spl_db( generalization940_a,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f6 ) ]
		)
	)
).

spl_db( generalization940_b,
	 spl( [ root, f1, f2, f3, f9, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [
						optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f4 , f6 ), requires( f9 , f8 ) ]
		)
	)
).

test_data(generalization940,generalization,generalization940_b, true).


% ---------------
spl_db( generalization941_a,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f7 ), excludes( f2 , f1 ) ]
		)
	)
).

spl_db( generalization941_b,
	 spl( [ root, f1, f9, f2, f3, f4, f5, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization941,generalization,generalization941_b, false).


% ---------------
spl_db( generalization942_a,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f1 ), requires( f3 , f7 ) ]
		)
	)
).

spl_db( generalization942_b,
	 spl( [ root, f1, f2, f4, f5, f9, f6, f7, f3, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
					optional( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [
					mandatory( feature( f7, [] ) ) ] ) ) ] ) ), mandatory( feature( f3, [
				mandatory( feature( f8, [] ) ) ] ) ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

test_data(generalization942,generalization,generalization942_b, false).


% ---------------
spl_db( generalization943_a,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f2 ), requires( f7 , f5 ) ]
		)
	)
).

spl_db( generalization943_b,
	 spl( [ root, f1, f2, f3, f6, f7, f8, f9, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f6 , f2 ) ]
		)
	)
).

test_data(generalization943,generalization,generalization943_b, false).


% ---------------
spl_db( generalization944_a,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization944_b,
	 spl( [ root, f1, f7, f8, f2, f3, f4, f9, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [
				optional( feature( f9, [] ) ) ] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f1 , f3 ) ]
		)
	)
).

test_data(generalization944,generalization,generalization944_b, true).


% ---------------
spl_db( generalization945_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f8 , f4 ), excludes( f6 , f7 ) ]
		)
	)
).

spl_db( generalization945_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization945,generalization,generalization945_b, false).


% ---------------
spl_db( generalization946_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						optional( feature( f8, [] ) ) ] ), feature( f7, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ), excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization946_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f8, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [
					mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
						optional( feature( f8, [] ) ) ] ), feature( f7, [
						optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f8 , f5 ) ]
		)
	)
).

test_data(generalization946,generalization,generalization946_b, false).


% ---------------
spl_db( generalization947_a,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f6, [] ) ), mandatory( feature( f7, [
							optional( feature( f8, [
								optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization947_b,
	 spl( [ root, f1, f3, f4, f5, f6, f7, f8, f9, f2 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f3, [
					optional( feature( f4, [] ) ), mandatory( feature( f5, [
						optional( feature( f6, [] ) ), mandatory( feature( f7, [
							optional( feature( f8, [
								optional( feature( f9, [] ) ) ] ) ) ] ) ) ] ) ) ] ) ) ] ) ), mandatory( feature( f2, [] ) ) ] ),
 [ requires( f6 , f8 ) ]
		)
	)
).

test_data(generalization947,generalization,generalization947_b, true).


% ---------------
spl_db( generalization948_a,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ excludes( f6 , f8 ) ]
		)
	)
).

spl_db( generalization948_b,
	 spl( [ root, f1, f2, f9, f3, f4, f7, f8, f5, f6 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization948,generalization,generalization948_b, false).


% ---------------
spl_db( generalization949_a,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

spl_db( generalization949_b,
	 spl( [ root, f1, f2, f9, f3, f8, f4, f5, f6, f7 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f3, [
				mandatory( feature( f8, [] ) ) ] ), feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization949,generalization,generalization949_b, false).


% ---------------
spl_db( generalization950_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f6 ), requires( f8 , f7 ) ]
		)
	)
).

spl_db( generalization950_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [
					optional( feature( f9, [] ) ) ] ) ), only_one( [ feature( f5, [
					optional( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization950,generalization,generalization950_b, false).


% ---------------
spl_db( generalization951_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization951_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f6, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f4 , f5 ), requires( f8 , f3 ) ]
		)
	)
).

test_data(generalization951,generalization,generalization951_b, true).


% ---------------
spl_db( generalization952_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ excludes( f2 , f5 ) ]
		)
	)
).

spl_db( generalization952_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [
					only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization952,generalization,generalization952_b, false).


% ---------------
spl_db( generalization953_a,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f7 , f9 ), excludes( f8 , f4 ) ]
		)
	)
).

spl_db( generalization953_b,
	 spl( [ root, f1, f9, f2, f3, f5, f6, f7, f8, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization953,generalization,generalization953_b, false).


% ---------------
spl_db( generalization954_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ) ]
		)
	)
).

spl_db( generalization954_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [
				optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f9 , f8 ), excludes( f1 , f6 ), excludes( f3 , f6 ) ]
		)
	)
).

test_data(generalization954,generalization,generalization954_b, true).


% ---------------
spl_db( generalization955_a,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization955_b,
	 spl( [ root, f1, f7, f8, f9, f2, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), only_one( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ),
 [ excludes( f8 , f5 ), requires( f2 , f1 ) ]
		)
	)
).

test_data(generalization955,generalization,generalization955_b, true).


% ---------------
spl_db( generalization956_a,
	 spl( [ root, f1, f2, f4, f3, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ) ]
		)
	)
).

spl_db( generalization956_b,
	 spl( [ root, f1, f2, f4, f3, f5, f8, f9, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				mandatory( feature( f4, [] ) ) ] ) ), optional( feature( f3, [
				optional( feature( f5, [
					mandatory( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ) ] ),
 [ excludes( f6 , f5 ), excludes( f1 , f6 ) ]
		)
	)
).

test_data(generalization956,generalization,generalization956_b, true).


% ---------------
spl_db( generalization957_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f5 ), excludes( f6 , f8 ) ]
		)
	)
).

spl_db( generalization957_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization957,generalization,generalization957_b, false).


% ---------------
spl_db( generalization958_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f9 ), excludes( f7 , f1 ) ]
		)
	)
).

spl_db( generalization958_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), one_or_more( [ feature( f7, [
				optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ excludes( f2 , f9 ) ]
		)
	)
).

test_data(generalization958,generalization,generalization958_b, false).


% ---------------
spl_db( generalization959_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ excludes( f4 , f8 ) ]
		)
	)
).

spl_db( generalization959_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization959,generalization,generalization959_b, false).


% ---------------
spl_db( generalization960_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f1 ), excludes( f9 , f4 ) ]
		)
	)
).

spl_db( generalization960_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f3 , f1 ) ]
		)
	)
).

test_data(generalization960,generalization,generalization960_b, false).


% ---------------
spl_db( generalization961_a,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization961_b,
	 spl( [ root, f1, f2, f5, f6, f7, f9, f8, f3, f4 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [
					optional( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ requires( f3 , f2 ), excludes( f9 , f6 ) ]
		)
	)
).

test_data(generalization961,generalization,generalization961_b, true).


% ---------------
spl_db( generalization962_a,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ requires( f9 , f6 ) ]
		)
	)
).

spl_db( generalization962_b,
	 spl( [ root, f1, f2, f3, f4, f5, f9, f6, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), one_or_more( [ feature( f5, [
				optional( feature( f9, [] ) ) ] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization962,generalization,generalization962_b, false).


% ---------------
spl_db( generalization963_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ requires( f2 , f7 ) ]
		)
	)
).

spl_db( generalization963_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [] ) ] ), only_one( [ feature( f3, [] ), feature( f4, [
				mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization963,generalization,generalization963_b, false).


% ---------------
spl_db( generalization964_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization964_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), mandatory( feature( f5, [
				optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [
					mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f2 , f7 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization964,generalization,generalization964_b, true).


% ---------------
spl_db( generalization965_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization965_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f3 , f8 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization965,generalization,generalization965_b, true).


% ---------------
spl_db( generalization966_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ excludes( f3 , f8 ) ]
		)
	)
).

spl_db( generalization966_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f2, [
					optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization966,generalization,generalization966_b, false).


% ---------------
spl_db( generalization967_a,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ excludes( f4 , f1 ) ]
		)
	)
).

spl_db( generalization967_b,
	 spl( [ root, f1, f2, f3, f9, f4, f6, f7, f8, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), mandatory( feature( f3, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f4, [
				optional( feature( f6, [] ) ), optional( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization967,generalization,generalization967_b, false).


% ---------------
spl_db( generalization968_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization968_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f9, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [] ) ), only_one( [ feature( f5, [] ), feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ), feature( f8, [] ) ] ) ] ),
 [ requires( f6 , f4 ), requires( f4 , f8 ), requires( f7 , f8 ) ]
		)
	)
).

test_data(generalization968,generalization,generalization968_b, true).


% ---------------
spl_db( generalization969_a,
	 spl( [ root, f1, f8, f9, f2, f5, f3, f4, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f6 , f8 ), excludes( f5 , f9 ), excludes( f2 , f3 ) ]
		)
	)
).

spl_db( generalization969_b,
	 spl( [ root, f1, f8, f9, f2, f5, f3, f4, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f8, [] ) ), mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [
				mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ) ] ),
 [ requires( f6 , f8 ), excludes( f5 , f9 ) ]
		)
	)
).

test_data(generalization969,generalization,generalization969_b, false).


% ---------------
spl_db( generalization970_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ requires( f7 , f3 ), excludes( f9 , f5 ) ]
		)
	)
).

spl_db( generalization970_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization970,generalization,generalization970_b, false).


% ---------------
spl_db( generalization971_a,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f7 , f1 ) ]
		)
	)
).

spl_db( generalization971_b,
	 spl( [ root, f1, f2, f5, f6, f7, f8, f9, f3, f4 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), only_one( [ feature( f3, [] ), feature( f4, [] ) ] ) ] ),
 [ excludes( f7 , f1 ), excludes( f4 , f2 ) ]
		)
	)
).

test_data(generalization971,generalization,generalization971_b, true).


% ---------------
spl_db( generalization972_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f6 ), requires( f3 , f5 ) ]
		)
	)
).

spl_db( generalization972_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [
				optional( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f5 , f6 ) ]
		)
	)
).

test_data(generalization972,generalization,generalization972_b, false).


% ---------------
spl_db( generalization973_a,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ), requires( f7 , f8 ) ]
		)
	)
).

spl_db( generalization973_b,
	 spl( [ root, f1, f2, f7, f8, f9, f3, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					optional( feature( f7, [] ) ), optional( feature( f8, [
						mandatory( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ) ] ) ] ) ) ] ),
 [ requires( f6 , f7 ) ]
		)
	)
).

test_data(generalization973,generalization,generalization973_b, false).


% ---------------
spl_db( generalization974_a,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ requires( f7 , f6 ) ]
		)
	)
).

spl_db( generalization974_b,
	 spl( [ root, f1, f2, f9, f3, f4, f5, f8, f6, f7 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f9, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), only_one( [ feature( f5, [
					mandatory( feature( f8, [] ) ) ] ), feature( f6, [] ), feature( f7, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization974,generalization,generalization974_b, false).


% ---------------
spl_db( generalization975_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ requires( f8 , f5 ), requires( f8 , f3 ) ]
		)
	)
).

spl_db( generalization975_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization975,generalization,generalization975_b, false).


% ---------------
spl_db( generalization976_a,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f7 ), excludes( f1 , f9 ) ]
		)
	)
).

spl_db( generalization976_b,
	 spl( [ root, f1, f2, f3, f4, f9, f5, f7, f8, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
				optional( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f5, [
				optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f6, [] ) ] ) ] ),
 [ requires( f9 , f7 ) ]
		)
	)
).

test_data(generalization976,generalization,generalization976_b, false).


% ---------------
spl_db( generalization977_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f9 ), excludes( f6 , f9 ) ]
		)
	)
).

spl_db( generalization977_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f3, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [
				mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ) ), optional( feature( f3, [
				mandatory( feature( f9, [] ) ) ] ) ) ] ),
 [ excludes( f1 , f9 ), excludes( f6 , f9 ), excludes( f6 , f8 ) ]
		)
	)
).

test_data(generalization977,generalization,generalization977_b, true).


% ---------------
spl_db( generalization978_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f7 , f5 ) ]
		)
	)
).

spl_db( generalization978_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [] ), feature( f2, [
				mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization978,generalization,generalization978_b, false).


% ---------------
spl_db( generalization979_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f4 ), requires( f6 , f5 ) ]
		)
	)
).

spl_db( generalization979_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [] ), feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f5 , f4 ) ]
		)
	)
).

test_data(generalization979,generalization,generalization979_b, false).


% ---------------
spl_db( generalization980_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

spl_db( generalization980_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization980,generalization,generalization980_b, false).


% ---------------
spl_db( generalization981_a,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ requires( f1 , f8 ), requires( f9 , f6 ) ]
		)
	)
).

spl_db( generalization981_b,
	 spl( [ root, f1, f2, f3, f4, f8, f5, f6, f7, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), optional( feature( f3, [] ) ), optional( feature( f4, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f5, [] ) ), only_one( [ feature( f6, [] ), feature( f7, [
				mandatory( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

test_data(generalization981,generalization,generalization981_b, false).


% ---------------
spl_db( generalization982_a,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ excludes( f5 , f9 ), requires( f6 , f3 ) ]
		)
	)
).

spl_db( generalization982_b,
	 spl( [ root, f1, f2, f3, f7, f8, f9, f4, f5, f6 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f3, [
						mandatory( feature( f7, [] ) ), mandatory( feature( f8, [
							optional( feature( f9, [] ) ) ] ) ) ] ) ), optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), optional( feature( f6, [] ) ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization982,generalization,generalization982_b, false).


% ---------------
spl_db( generalization983_a,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ requires( f3 , f5 ) ]
		)
	)
).

spl_db( generalization983_b,
	 spl( [ root, f1, f3, f2, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [
				optional( feature( f3, [] ) ) ] ) ), optional( feature( f2, [
				optional( feature( f4, [] ) ), one_or_more( [ feature( f5, [] ), feature( f6, [
					optional( feature( f9, [] ) ) ] ), feature( f7, [] ), feature( f8, [] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization983,generalization,generalization983_b, false).


% ---------------
spl_db( generalization984_a,
	 spl( [ root, f1, f8, f2, f3, f6, f7, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ ]
		)
	)
).

spl_db( generalization984_b,
	 spl( [ root, f1, f8, f2, f3, f6, f7, f4, f5, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f8, [] ) ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f3, [
					mandatory( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), only_one( [ feature( f4, [] ), feature( f5, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ) ) ] ),
 [ excludes( f1 , f7 ), requires( f4 , f6 ) ]
		)
	)
).

test_data(generalization984,generalization,generalization984_b, true).


% ---------------
spl_db( generalization985_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f1 ) ]
		)
	)
).

spl_db( generalization985_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			one_or_more( [ feature( f1, [] ), feature( f2, [
				optional( feature( f4, [] ) ), optional( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [
					optional( feature( f9, [] ) ) ] ) ] ) ] ), feature( f3, [] ) ] ) ] ),
 [ excludes( f5 , f1 ), requires( f1 , f6 ) ]
		)
	)
).

test_data(generalization985,generalization,generalization985_b, true).


% ---------------
spl_db( generalization986_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization986_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f6 , f9 ), requires( f4 , f1 ), requires( f3 , f8 ) ]
		)
	)
).

test_data(generalization986,generalization,generalization986_b, true).


% ---------------
spl_db( generalization987_a,
	 spl( [ root, f1, f7, f8, f9, f2, f6, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f1 ), requires( f8 , f5 ) ]
		)
	)
).

spl_db( generalization987_b,
	 spl( [ root, f1, f7, f8, f9, f2, f6, f3, f4, f5 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f7, [] ) ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f2, [
				mandatory( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), only_one( [ feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

test_data(generalization987,generalization,generalization987_b, false).


% ---------------
spl_db( generalization988_a,
	 spl( [ root, f1, f2, f5, f7, f6, f3, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [
						mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ requires( f7 , f4 ), requires( f9 , f8 ) ]
		)
	)
).

spl_db( generalization988_b,
	 spl( [ root, f1, f2, f5, f7, f6, f3, f4, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f5, [
						mandatory( feature( f7, [] ) ) ] ) ), optional( feature( f6, [] ) ) ] ) ), optional( feature( f3, [] ) ), mandatory( feature( f4, [
					one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization988,generalization,generalization988_b, false).


% ---------------
spl_db( generalization989_a,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ) ]
		)
	)
).

spl_db( generalization989_b,
	 spl( [ root, f1, f2, f6, f7, f3, f4, f5, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [
				optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ) ] ) ), mandatory( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				optional( feature( f8, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f5 , f1 ), excludes( f6 , f4 ) ]
		)
	)
).

test_data(generalization989,generalization,generalization989_b, true).


% ---------------
spl_db( generalization990_a,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f2 ), excludes( f3 , f1 ) ]
		)
	)
).

spl_db( generalization990_b,
	 spl( [ root, f1, f2, f3, f4, f5, f7, f8, f6, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [
				mandatory( feature( f7, [] ) ), mandatory( feature( f8, [] ) ) ] ), feature( f6, [
				optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f7 , f2 ) ]
		)
	)
).

test_data(generalization990,generalization,generalization990_b, false).


% ---------------
spl_db( generalization991_a,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization991_b,
	 spl( [ root, f1, f5, f6, f7, f8, f2, f3, f4, f9 ],
		bfm( feature( root, [
			only_one( [ feature( f1, [
				mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f2, [] ), feature( f3, [
				mandatory( feature( f4, [
					mandatory( feature( f9, [] ) ) ] ) ) ] ) ] ) ] ),
 [ requires( f2 , f6 ), excludes( f8 , f5 ) ]
		)
	)
).

test_data(generalization991,generalization,generalization991_b, true).


% ---------------
spl_db( generalization992_a,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f3, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization992_b,
	 spl( [ root, f1, f4, f5, f6, f7, f2, f3, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), mandatory( feature( f6, [] ) ), optional( feature( f7, [] ) ) ] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [
				mandatory( feature( f8, [] ) ), optional( feature( f9, [] ) ) ] ) ] ) ] ),
 [ excludes( f1 , f8 ) ]
		)
	)
).

test_data(generalization992,generalization,generalization992_b, true).


% ---------------
spl_db( generalization993_a,
	 spl( [ root, f1, f9, f2, f4, f6, f7, f8, f5, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f7 , f9 ), requires( f1 , f7 ) ]
		)
	)
).

spl_db( generalization993_b,
	 spl( [ root, f1, f9, f2, f4, f6, f7, f8, f5, f3 ],
		bfm( feature( root, [
			mandatory( feature( f1, [
				optional( feature( f9, [] ) ) ] ) ), optional( feature( f2, [
				only_one( [ feature( f4, [
					optional( feature( f6, [] ) ), mandatory( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ), feature( f5, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ),
 [ requires( f7 , f9 ) ]
		)
	)
).

test_data(generalization993,generalization,generalization993_b, false).


% ---------------
spl_db( generalization994_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization994_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [] ), feature( f4, [] ) ] ), only_one( [ feature( f5, [] ), feature( f6, [
				optional( feature( f7, [] ) ), one_or_more( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ) ] ) ] ),
 [ excludes( f2 , f3 ), excludes( f7 , f9 ) ]
		)
	)
).

test_data(generalization994,generalization,generalization994_b, true).


% ---------------
spl_db( generalization995_a,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization995_b,
	 spl( [ root, f1, f2, f3, f6, f9, f7, f8, f4, f5 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), optional( feature( f2, [] ) ), one_or_more( [ feature( f3, [
				optional( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), one_or_more( [ feature( f7, [] ), feature( f8, [] ) ] ) ] ), feature( f4, [] ), feature( f5, [] ) ] ) ] ),
 [ requires( f4 , f6 ), requires( f6 , f7 ), excludes( f5 , f3 ) ]
		)
	)
).

test_data(generalization995,generalization,generalization995_b, true).


% ---------------
spl_db( generalization996_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f3 ), requires( f3 , f1 ) ]
		)
	)
).

spl_db( generalization996_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f9, f7, f8 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), mandatory( feature( f2, [] ) ), optional( feature( f3, [] ) ), one_or_more( [ feature( f4, [] ), feature( f5, [
				mandatory( feature( f6, [
					mandatory( feature( f9, [] ) ) ] ) ), optional( feature( f7, [] ) ), optional( feature( f8, [] ) ) ] ) ] ) ] ),
 [ excludes( f6 , f3 ) ]
		)
	)
).

test_data(generalization996,generalization,generalization996_b, false).


% ---------------
spl_db( generalization997_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f9 ) ]
		)
	)
).

spl_db( generalization997_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			optional( feature( f1, [] ) ), one_or_more( [ feature( f2, [] ), feature( f3, [] ) ] ), one_or_more( [ feature( f4, [] ), feature( f5, [] ) ] ), only_one( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ excludes( f7 , f9 ), requires( f9 , f5 ) ]
		)
	)
).

test_data(generalization997,generalization,generalization997_b, true).


% ---------------
spl_db( generalization998_a,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ excludes( f5 , f8 ), requires( f9 , f6 ) ]
		)
	)
).

spl_db( generalization998_b,
	 spl( [ root, f1, f2, f4, f5, f6, f7, f8, f9, f3 ],
		bfm( feature( root, [
			optional( feature( f1, [
				mandatory( feature( f2, [
					mandatory( feature( f4, [] ) ), mandatory( feature( f5, [] ) ), optional( feature( f6, [] ) ), only_one( [ feature( f7, [] ), feature( f8, [] ), feature( f9, [] ) ] ) ] ) ), mandatory( feature( f3, [] ) ) ] ) ) ] ),
 [ ]
		)
	)
).

test_data(generalization998,generalization,generalization998_b, false).


% ---------------
spl_db( generalization999_a,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ ]
		)
	)
).

spl_db( generalization999_b,
	 spl( [ root, f1, f2, f3, f4, f5, f6, f7, f8, f9 ],
		bfm( feature( root, [
			mandatory( feature( f1, [] ) ), optional( feature( f2, [] ) ), mandatory( feature( f3, [] ) ), mandatory( feature( f4, [] ) ), optional( feature( f5, [] ) ), one_or_more( [ feature( f6, [] ), feature( f7, [] ) ] ), only_one( [ feature( f8, [] ), feature( f9, [] ) ] ) ] ),
 [ requires( f4 , f8 ), excludes( f7 , f2 ) ]
		)
	)
).

test_data(generalization999,generalization,generalization999_b, true).


% --------------- Test cases % ---------------
:- begin_tests(generalization).
test(generalization0) :-
	spl_db( generalization0_a, Spl1 ),
	test_data( generalization0, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization1) :-
	spl_db( generalization1_a, Spl1 ),
	test_data( generalization1, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization2) :-
	spl_db( generalization2_a, Spl1 ),
	test_data( generalization2, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization3) :-
	spl_db( generalization3_a, Spl1 ),
	test_data( generalization3, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization4) :-
	spl_db( generalization4_a, Spl1 ),
	test_data( generalization4, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization5) :-
	spl_db( generalization5_a, Spl1 ),
	test_data( generalization5, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization6) :-
	spl_db( generalization6_a, Spl1 ),
	test_data( generalization6, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization7) :-
	spl_db( generalization7_a, Spl1 ),
	test_data( generalization7, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization8) :-
	spl_db( generalization8_a, Spl1 ),
	test_data( generalization8, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization9) :-
	spl_db( generalization9_a, Spl1 ),
	test_data( generalization9, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization10) :-
	spl_db( generalization10_a, Spl1 ),
	test_data( generalization10, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization11) :-
	spl_db( generalization11_a, Spl1 ),
	test_data( generalization11, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization12) :-
	spl_db( generalization12_a, Spl1 ),
	test_data( generalization12, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization13) :-
	spl_db( generalization13_a, Spl1 ),
	test_data( generalization13, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization14) :-
	spl_db( generalization14_a, Spl1 ),
	test_data( generalization14, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization15) :-
	spl_db( generalization15_a, Spl1 ),
	test_data( generalization15, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization16) :-
	spl_db( generalization16_a, Spl1 ),
	test_data( generalization16, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization17) :-
	spl_db( generalization17_a, Spl1 ),
	test_data( generalization17, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization18) :-
	spl_db( generalization18_a, Spl1 ),
	test_data( generalization18, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization19) :-
	spl_db( generalization19_a, Spl1 ),
	test_data( generalization19, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization20) :-
	spl_db( generalization20_a, Spl1 ),
	test_data( generalization20, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization21) :-
	spl_db( generalization21_a, Spl1 ),
	test_data( generalization21, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization22) :-
	spl_db( generalization22_a, Spl1 ),
	test_data( generalization22, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization23) :-
	spl_db( generalization23_a, Spl1 ),
	test_data( generalization23, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization24) :-
	spl_db( generalization24_a, Spl1 ),
	test_data( generalization24, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization25) :-
	spl_db( generalization25_a, Spl1 ),
	test_data( generalization25, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization26) :-
	spl_db( generalization26_a, Spl1 ),
	test_data( generalization26, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization27) :-
	spl_db( generalization27_a, Spl1 ),
	test_data( generalization27, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization28) :-
	spl_db( generalization28_a, Spl1 ),
	test_data( generalization28, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization29) :-
	spl_db( generalization29_a, Spl1 ),
	test_data( generalization29, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization30) :-
	spl_db( generalization30_a, Spl1 ),
	test_data( generalization30, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization31) :-
	spl_db( generalization31_a, Spl1 ),
	test_data( generalization31, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization32) :-
	spl_db( generalization32_a, Spl1 ),
	test_data( generalization32, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization33) :-
	spl_db( generalization33_a, Spl1 ),
	test_data( generalization33, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization34) :-
	spl_db( generalization34_a, Spl1 ),
	test_data( generalization34, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization35) :-
	spl_db( generalization35_a, Spl1 ),
	test_data( generalization35, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization36) :-
	spl_db( generalization36_a, Spl1 ),
	test_data( generalization36, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization37) :-
	spl_db( generalization37_a, Spl1 ),
	test_data( generalization37, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization38) :-
	spl_db( generalization38_a, Spl1 ),
	test_data( generalization38, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization39) :-
	spl_db( generalization39_a, Spl1 ),
	test_data( generalization39, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization40) :-
	spl_db( generalization40_a, Spl1 ),
	test_data( generalization40, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization41) :-
	spl_db( generalization41_a, Spl1 ),
	test_data( generalization41, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization42) :-
	spl_db( generalization42_a, Spl1 ),
	test_data( generalization42, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization43) :-
	spl_db( generalization43_a, Spl1 ),
	test_data( generalization43, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization44) :-
	spl_db( generalization44_a, Spl1 ),
	test_data( generalization44, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization45) :-
	spl_db( generalization45_a, Spl1 ),
	test_data( generalization45, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization46) :-
	spl_db( generalization46_a, Spl1 ),
	test_data( generalization46, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization47) :-
	spl_db( generalization47_a, Spl1 ),
	test_data( generalization47, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization48) :-
	spl_db( generalization48_a, Spl1 ),
	test_data( generalization48, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization49) :-
	spl_db( generalization49_a, Spl1 ),
	test_data( generalization49, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization50) :-
	spl_db( generalization50_a, Spl1 ),
	test_data( generalization50, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization51) :-
	spl_db( generalization51_a, Spl1 ),
	test_data( generalization51, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization52) :-
	spl_db( generalization52_a, Spl1 ),
	test_data( generalization52, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization53) :-
	spl_db( generalization53_a, Spl1 ),
	test_data( generalization53, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization54) :-
	spl_db( generalization54_a, Spl1 ),
	test_data( generalization54, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization55) :-
	spl_db( generalization55_a, Spl1 ),
	test_data( generalization55, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization56) :-
	spl_db( generalization56_a, Spl1 ),
	test_data( generalization56, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization57) :-
	spl_db( generalization57_a, Spl1 ),
	test_data( generalization57, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization58) :-
	spl_db( generalization58_a, Spl1 ),
	test_data( generalization58, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization59) :-
	spl_db( generalization59_a, Spl1 ),
	test_data( generalization59, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization60) :-
	spl_db( generalization60_a, Spl1 ),
	test_data( generalization60, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization61) :-
	spl_db( generalization61_a, Spl1 ),
	test_data( generalization61, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization62) :-
	spl_db( generalization62_a, Spl1 ),
	test_data( generalization62, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization63) :-
	spl_db( generalization63_a, Spl1 ),
	test_data( generalization63, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization64) :-
	spl_db( generalization64_a, Spl1 ),
	test_data( generalization64, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization65) :-
	spl_db( generalization65_a, Spl1 ),
	test_data( generalization65, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization66) :-
	spl_db( generalization66_a, Spl1 ),
	test_data( generalization66, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization67) :-
	spl_db( generalization67_a, Spl1 ),
	test_data( generalization67, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization68) :-
	spl_db( generalization68_a, Spl1 ),
	test_data( generalization68, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization69) :-
	spl_db( generalization69_a, Spl1 ),
	test_data( generalization69, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization70) :-
	spl_db( generalization70_a, Spl1 ),
	test_data( generalization70, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization71) :-
	spl_db( generalization71_a, Spl1 ),
	test_data( generalization71, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization72) :-
	spl_db( generalization72_a, Spl1 ),
	test_data( generalization72, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization73) :-
	spl_db( generalization73_a, Spl1 ),
	test_data( generalization73, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization74) :-
	spl_db( generalization74_a, Spl1 ),
	test_data( generalization74, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization75) :-
	spl_db( generalization75_a, Spl1 ),
	test_data( generalization75, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization76) :-
	spl_db( generalization76_a, Spl1 ),
	test_data( generalization76, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization77) :-
	spl_db( generalization77_a, Spl1 ),
	test_data( generalization77, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization78) :-
	spl_db( generalization78_a, Spl1 ),
	test_data( generalization78, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization79) :-
	spl_db( generalization79_a, Spl1 ),
	test_data( generalization79, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization80) :-
	spl_db( generalization80_a, Spl1 ),
	test_data( generalization80, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization81) :-
	spl_db( generalization81_a, Spl1 ),
	test_data( generalization81, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization82) :-
	spl_db( generalization82_a, Spl1 ),
	test_data( generalization82, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization83) :-
	spl_db( generalization83_a, Spl1 ),
	test_data( generalization83, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization84) :-
	spl_db( generalization84_a, Spl1 ),
	test_data( generalization84, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization85) :-
	spl_db( generalization85_a, Spl1 ),
	test_data( generalization85, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization86) :-
	spl_db( generalization86_a, Spl1 ),
	test_data( generalization86, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization87) :-
	spl_db( generalization87_a, Spl1 ),
	test_data( generalization87, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization88) :-
	spl_db( generalization88_a, Spl1 ),
	test_data( generalization88, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization89) :-
	spl_db( generalization89_a, Spl1 ),
	test_data( generalization89, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization90) :-
	spl_db( generalization90_a, Spl1 ),
	test_data( generalization90, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization91) :-
	spl_db( generalization91_a, Spl1 ),
	test_data( generalization91, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization92) :-
	spl_db( generalization92_a, Spl1 ),
	test_data( generalization92, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization93) :-
	spl_db( generalization93_a, Spl1 ),
	test_data( generalization93, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization94) :-
	spl_db( generalization94_a, Spl1 ),
	test_data( generalization94, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization95) :-
	spl_db( generalization95_a, Spl1 ),
	test_data( generalization95, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization96) :-
	spl_db( generalization96_a, Spl1 ),
	test_data( generalization96, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization97) :-
	spl_db( generalization97_a, Spl1 ),
	test_data( generalization97, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization98) :-
	spl_db( generalization98_a, Spl1 ),
	test_data( generalization98, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization99) :-
	spl_db( generalization99_a, Spl1 ),
	test_data( generalization99, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization100) :-
	spl_db( generalization100_a, Spl1 ),
	test_data( generalization100, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization101) :-
	spl_db( generalization101_a, Spl1 ),
	test_data( generalization101, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization102) :-
	spl_db( generalization102_a, Spl1 ),
	test_data( generalization102, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization103) :-
	spl_db( generalization103_a, Spl1 ),
	test_data( generalization103, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization104) :-
	spl_db( generalization104_a, Spl1 ),
	test_data( generalization104, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization105) :-
	spl_db( generalization105_a, Spl1 ),
	test_data( generalization105, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization106) :-
	spl_db( generalization106_a, Spl1 ),
	test_data( generalization106, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization107) :-
	spl_db( generalization107_a, Spl1 ),
	test_data( generalization107, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization108) :-
	spl_db( generalization108_a, Spl1 ),
	test_data( generalization108, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization109) :-
	spl_db( generalization109_a, Spl1 ),
	test_data( generalization109, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization110) :-
	spl_db( generalization110_a, Spl1 ),
	test_data( generalization110, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization111) :-
	spl_db( generalization111_a, Spl1 ),
	test_data( generalization111, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization112) :-
	spl_db( generalization112_a, Spl1 ),
	test_data( generalization112, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization113) :-
	spl_db( generalization113_a, Spl1 ),
	test_data( generalization113, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization114) :-
	spl_db( generalization114_a, Spl1 ),
	test_data( generalization114, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization115) :-
	spl_db( generalization115_a, Spl1 ),
	test_data( generalization115, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization116) :-
	spl_db( generalization116_a, Spl1 ),
	test_data( generalization116, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization117) :-
	spl_db( generalization117_a, Spl1 ),
	test_data( generalization117, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization118) :-
	spl_db( generalization118_a, Spl1 ),
	test_data( generalization118, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization119) :-
	spl_db( generalization119_a, Spl1 ),
	test_data( generalization119, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization120) :-
	spl_db( generalization120_a, Spl1 ),
	test_data( generalization120, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization121) :-
	spl_db( generalization121_a, Spl1 ),
	test_data( generalization121, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization122) :-
	spl_db( generalization122_a, Spl1 ),
	test_data( generalization122, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization123) :-
	spl_db( generalization123_a, Spl1 ),
	test_data( generalization123, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization124) :-
	spl_db( generalization124_a, Spl1 ),
	test_data( generalization124, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization125) :-
	spl_db( generalization125_a, Spl1 ),
	test_data( generalization125, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization126) :-
	spl_db( generalization126_a, Spl1 ),
	test_data( generalization126, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization127) :-
	spl_db( generalization127_a, Spl1 ),
	test_data( generalization127, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization128) :-
	spl_db( generalization128_a, Spl1 ),
	test_data( generalization128, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization129) :-
	spl_db( generalization129_a, Spl1 ),
	test_data( generalization129, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization130) :-
	spl_db( generalization130_a, Spl1 ),
	test_data( generalization130, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization131) :-
	spl_db( generalization131_a, Spl1 ),
	test_data( generalization131, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization132) :-
	spl_db( generalization132_a, Spl1 ),
	test_data( generalization132, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization133) :-
	spl_db( generalization133_a, Spl1 ),
	test_data( generalization133, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization134) :-
	spl_db( generalization134_a, Spl1 ),
	test_data( generalization134, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization135) :-
	spl_db( generalization135_a, Spl1 ),
	test_data( generalization135, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization136) :-
	spl_db( generalization136_a, Spl1 ),
	test_data( generalization136, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization137) :-
	spl_db( generalization137_a, Spl1 ),
	test_data( generalization137, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization138) :-
	spl_db( generalization138_a, Spl1 ),
	test_data( generalization138, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization139) :-
	spl_db( generalization139_a, Spl1 ),
	test_data( generalization139, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization140) :-
	spl_db( generalization140_a, Spl1 ),
	test_data( generalization140, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization141) :-
	spl_db( generalization141_a, Spl1 ),
	test_data( generalization141, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization142) :-
	spl_db( generalization142_a, Spl1 ),
	test_data( generalization142, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization143) :-
	spl_db( generalization143_a, Spl1 ),
	test_data( generalization143, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization144) :-
	spl_db( generalization144_a, Spl1 ),
	test_data( generalization144, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization145) :-
	spl_db( generalization145_a, Spl1 ),
	test_data( generalization145, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization146) :-
	spl_db( generalization146_a, Spl1 ),
	test_data( generalization146, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization147) :-
	spl_db( generalization147_a, Spl1 ),
	test_data( generalization147, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization148) :-
	spl_db( generalization148_a, Spl1 ),
	test_data( generalization148, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization149) :-
	spl_db( generalization149_a, Spl1 ),
	test_data( generalization149, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization150) :-
	spl_db( generalization150_a, Spl1 ),
	test_data( generalization150, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization151) :-
	spl_db( generalization151_a, Spl1 ),
	test_data( generalization151, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization152) :-
	spl_db( generalization152_a, Spl1 ),
	test_data( generalization152, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization153) :-
	spl_db( generalization153_a, Spl1 ),
	test_data( generalization153, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization154) :-
	spl_db( generalization154_a, Spl1 ),
	test_data( generalization154, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization155) :-
	spl_db( generalization155_a, Spl1 ),
	test_data( generalization155, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization156) :-
	spl_db( generalization156_a, Spl1 ),
	test_data( generalization156, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization157) :-
	spl_db( generalization157_a, Spl1 ),
	test_data( generalization157, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization158) :-
	spl_db( generalization158_a, Spl1 ),
	test_data( generalization158, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization159) :-
	spl_db( generalization159_a, Spl1 ),
	test_data( generalization159, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization160) :-
	spl_db( generalization160_a, Spl1 ),
	test_data( generalization160, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization161) :-
	spl_db( generalization161_a, Spl1 ),
	test_data( generalization161, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization162) :-
	spl_db( generalization162_a, Spl1 ),
	test_data( generalization162, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization163) :-
	spl_db( generalization163_a, Spl1 ),
	test_data( generalization163, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization164) :-
	spl_db( generalization164_a, Spl1 ),
	test_data( generalization164, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization165) :-
	spl_db( generalization165_a, Spl1 ),
	test_data( generalization165, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization166) :-
	spl_db( generalization166_a, Spl1 ),
	test_data( generalization166, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization167) :-
	spl_db( generalization167_a, Spl1 ),
	test_data( generalization167, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization168) :-
	spl_db( generalization168_a, Spl1 ),
	test_data( generalization168, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization169) :-
	spl_db( generalization169_a, Spl1 ),
	test_data( generalization169, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization170) :-
	spl_db( generalization170_a, Spl1 ),
	test_data( generalization170, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization171) :-
	spl_db( generalization171_a, Spl1 ),
	test_data( generalization171, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization172) :-
	spl_db( generalization172_a, Spl1 ),
	test_data( generalization172, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization173) :-
	spl_db( generalization173_a, Spl1 ),
	test_data( generalization173, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization174) :-
	spl_db( generalization174_a, Spl1 ),
	test_data( generalization174, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization175) :-
	spl_db( generalization175_a, Spl1 ),
	test_data( generalization175, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization176) :-
	spl_db( generalization176_a, Spl1 ),
	test_data( generalization176, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization177) :-
	spl_db( generalization177_a, Spl1 ),
	test_data( generalization177, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization178) :-
	spl_db( generalization178_a, Spl1 ),
	test_data( generalization178, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization179) :-
	spl_db( generalization179_a, Spl1 ),
	test_data( generalization179, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization180) :-
	spl_db( generalization180_a, Spl1 ),
	test_data( generalization180, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization181) :-
	spl_db( generalization181_a, Spl1 ),
	test_data( generalization181, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization182) :-
	spl_db( generalization182_a, Spl1 ),
	test_data( generalization182, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization183) :-
	spl_db( generalization183_a, Spl1 ),
	test_data( generalization183, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization184) :-
	spl_db( generalization184_a, Spl1 ),
	test_data( generalization184, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization185) :-
	spl_db( generalization185_a, Spl1 ),
	test_data( generalization185, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization186) :-
	spl_db( generalization186_a, Spl1 ),
	test_data( generalization186, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization187) :-
	spl_db( generalization187_a, Spl1 ),
	test_data( generalization187, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization188) :-
	spl_db( generalization188_a, Spl1 ),
	test_data( generalization188, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization189) :-
	spl_db( generalization189_a, Spl1 ),
	test_data( generalization189, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization190) :-
	spl_db( generalization190_a, Spl1 ),
	test_data( generalization190, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization191) :-
	spl_db( generalization191_a, Spl1 ),
	test_data( generalization191, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization192) :-
	spl_db( generalization192_a, Spl1 ),
	test_data( generalization192, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization193) :-
	spl_db( generalization193_a, Spl1 ),
	test_data( generalization193, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization194) :-
	spl_db( generalization194_a, Spl1 ),
	test_data( generalization194, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization195) :-
	spl_db( generalization195_a, Spl1 ),
	test_data( generalization195, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization196) :-
	spl_db( generalization196_a, Spl1 ),
	test_data( generalization196, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization197) :-
	spl_db( generalization197_a, Spl1 ),
	test_data( generalization197, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization198) :-
	spl_db( generalization198_a, Spl1 ),
	test_data( generalization198, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization199) :-
	spl_db( generalization199_a, Spl1 ),
	test_data( generalization199, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization200) :-
	spl_db( generalization200_a, Spl1 ),
	test_data( generalization200, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization201) :-
	spl_db( generalization201_a, Spl1 ),
	test_data( generalization201, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization202) :-
	spl_db( generalization202_a, Spl1 ),
	test_data( generalization202, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization203) :-
	spl_db( generalization203_a, Spl1 ),
	test_data( generalization203, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization204) :-
	spl_db( generalization204_a, Spl1 ),
	test_data( generalization204, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization205) :-
	spl_db( generalization205_a, Spl1 ),
	test_data( generalization205, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization206) :-
	spl_db( generalization206_a, Spl1 ),
	test_data( generalization206, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization207) :-
	spl_db( generalization207_a, Spl1 ),
	test_data( generalization207, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization208) :-
	spl_db( generalization208_a, Spl1 ),
	test_data( generalization208, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization209) :-
	spl_db( generalization209_a, Spl1 ),
	test_data( generalization209, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization210) :-
	spl_db( generalization210_a, Spl1 ),
	test_data( generalization210, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization211) :-
	spl_db( generalization211_a, Spl1 ),
	test_data( generalization211, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization212) :-
	spl_db( generalization212_a, Spl1 ),
	test_data( generalization212, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization213) :-
	spl_db( generalization213_a, Spl1 ),
	test_data( generalization213, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization214) :-
	spl_db( generalization214_a, Spl1 ),
	test_data( generalization214, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization215) :-
	spl_db( generalization215_a, Spl1 ),
	test_data( generalization215, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization216) :-
	spl_db( generalization216_a, Spl1 ),
	test_data( generalization216, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization217) :-
	spl_db( generalization217_a, Spl1 ),
	test_data( generalization217, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization218) :-
	spl_db( generalization218_a, Spl1 ),
	test_data( generalization218, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization219) :-
	spl_db( generalization219_a, Spl1 ),
	test_data( generalization219, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization220) :-
	spl_db( generalization220_a, Spl1 ),
	test_data( generalization220, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization221) :-
	spl_db( generalization221_a, Spl1 ),
	test_data( generalization221, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization222) :-
	spl_db( generalization222_a, Spl1 ),
	test_data( generalization222, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization223) :-
	spl_db( generalization223_a, Spl1 ),
	test_data( generalization223, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization224) :-
	spl_db( generalization224_a, Spl1 ),
	test_data( generalization224, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization225) :-
	spl_db( generalization225_a, Spl1 ),
	test_data( generalization225, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization226) :-
	spl_db( generalization226_a, Spl1 ),
	test_data( generalization226, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization227) :-
	spl_db( generalization227_a, Spl1 ),
	test_data( generalization227, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization228) :-
	spl_db( generalization228_a, Spl1 ),
	test_data( generalization228, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization229) :-
	spl_db( generalization229_a, Spl1 ),
	test_data( generalization229, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization230) :-
	spl_db( generalization230_a, Spl1 ),
	test_data( generalization230, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization231) :-
	spl_db( generalization231_a, Spl1 ),
	test_data( generalization231, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization232) :-
	spl_db( generalization232_a, Spl1 ),
	test_data( generalization232, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization233) :-
	spl_db( generalization233_a, Spl1 ),
	test_data( generalization233, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization234) :-
	spl_db( generalization234_a, Spl1 ),
	test_data( generalization234, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization235) :-
	spl_db( generalization235_a, Spl1 ),
	test_data( generalization235, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization236) :-
	spl_db( generalization236_a, Spl1 ),
	test_data( generalization236, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization237) :-
	spl_db( generalization237_a, Spl1 ),
	test_data( generalization237, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization238) :-
	spl_db( generalization238_a, Spl1 ),
	test_data( generalization238, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization239) :-
	spl_db( generalization239_a, Spl1 ),
	test_data( generalization239, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization240) :-
	spl_db( generalization240_a, Spl1 ),
	test_data( generalization240, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization241) :-
	spl_db( generalization241_a, Spl1 ),
	test_data( generalization241, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization242) :-
	spl_db( generalization242_a, Spl1 ),
	test_data( generalization242, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization243) :-
	spl_db( generalization243_a, Spl1 ),
	test_data( generalization243, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization244) :-
	spl_db( generalization244_a, Spl1 ),
	test_data( generalization244, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization245) :-
	spl_db( generalization245_a, Spl1 ),
	test_data( generalization245, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization246) :-
	spl_db( generalization246_a, Spl1 ),
	test_data( generalization246, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization247) :-
	spl_db( generalization247_a, Spl1 ),
	test_data( generalization247, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization248) :-
	spl_db( generalization248_a, Spl1 ),
	test_data( generalization248, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization249) :-
	spl_db( generalization249_a, Spl1 ),
	test_data( generalization249, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization250) :-
	spl_db( generalization250_a, Spl1 ),
	test_data( generalization250, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization251) :-
	spl_db( generalization251_a, Spl1 ),
	test_data( generalization251, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization252) :-
	spl_db( generalization252_a, Spl1 ),
	test_data( generalization252, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization253) :-
	spl_db( generalization253_a, Spl1 ),
	test_data( generalization253, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization254) :-
	spl_db( generalization254_a, Spl1 ),
	test_data( generalization254, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization255) :-
	spl_db( generalization255_a, Spl1 ),
	test_data( generalization255, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization256) :-
	spl_db( generalization256_a, Spl1 ),
	test_data( generalization256, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization257) :-
	spl_db( generalization257_a, Spl1 ),
	test_data( generalization257, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization258) :-
	spl_db( generalization258_a, Spl1 ),
	test_data( generalization258, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization259) :-
	spl_db( generalization259_a, Spl1 ),
	test_data( generalization259, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization260) :-
	spl_db( generalization260_a, Spl1 ),
	test_data( generalization260, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization261) :-
	spl_db( generalization261_a, Spl1 ),
	test_data( generalization261, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization262) :-
	spl_db( generalization262_a, Spl1 ),
	test_data( generalization262, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization263) :-
	spl_db( generalization263_a, Spl1 ),
	test_data( generalization263, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization264) :-
	spl_db( generalization264_a, Spl1 ),
	test_data( generalization264, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization265) :-
	spl_db( generalization265_a, Spl1 ),
	test_data( generalization265, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization266) :-
	spl_db( generalization266_a, Spl1 ),
	test_data( generalization266, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization267) :-
	spl_db( generalization267_a, Spl1 ),
	test_data( generalization267, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization268) :-
	spl_db( generalization268_a, Spl1 ),
	test_data( generalization268, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization269) :-
	spl_db( generalization269_a, Spl1 ),
	test_data( generalization269, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization270) :-
	spl_db( generalization270_a, Spl1 ),
	test_data( generalization270, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization271) :-
	spl_db( generalization271_a, Spl1 ),
	test_data( generalization271, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization272) :-
	spl_db( generalization272_a, Spl1 ),
	test_data( generalization272, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization273) :-
	spl_db( generalization273_a, Spl1 ),
	test_data( generalization273, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization274) :-
	spl_db( generalization274_a, Spl1 ),
	test_data( generalization274, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization275) :-
	spl_db( generalization275_a, Spl1 ),
	test_data( generalization275, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization276) :-
	spl_db( generalization276_a, Spl1 ),
	test_data( generalization276, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization277) :-
	spl_db( generalization277_a, Spl1 ),
	test_data( generalization277, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization278) :-
	spl_db( generalization278_a, Spl1 ),
	test_data( generalization278, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization279) :-
	spl_db( generalization279_a, Spl1 ),
	test_data( generalization279, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization280) :-
	spl_db( generalization280_a, Spl1 ),
	test_data( generalization280, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization281) :-
	spl_db( generalization281_a, Spl1 ),
	test_data( generalization281, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization282) :-
	spl_db( generalization282_a, Spl1 ),
	test_data( generalization282, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization283) :-
	spl_db( generalization283_a, Spl1 ),
	test_data( generalization283, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization284) :-
	spl_db( generalization284_a, Spl1 ),
	test_data( generalization284, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization285) :-
	spl_db( generalization285_a, Spl1 ),
	test_data( generalization285, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization286) :-
	spl_db( generalization286_a, Spl1 ),
	test_data( generalization286, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization287) :-
	spl_db( generalization287_a, Spl1 ),
	test_data( generalization287, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization288) :-
	spl_db( generalization288_a, Spl1 ),
	test_data( generalization288, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization289) :-
	spl_db( generalization289_a, Spl1 ),
	test_data( generalization289, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization290) :-
	spl_db( generalization290_a, Spl1 ),
	test_data( generalization290, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization291) :-
	spl_db( generalization291_a, Spl1 ),
	test_data( generalization291, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization292) :-
	spl_db( generalization292_a, Spl1 ),
	test_data( generalization292, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization293) :-
	spl_db( generalization293_a, Spl1 ),
	test_data( generalization293, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization294) :-
	spl_db( generalization294_a, Spl1 ),
	test_data( generalization294, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization295) :-
	spl_db( generalization295_a, Spl1 ),
	test_data( generalization295, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization296) :-
	spl_db( generalization296_a, Spl1 ),
	test_data( generalization296, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization297) :-
	spl_db( generalization297_a, Spl1 ),
	test_data( generalization297, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization298) :-
	spl_db( generalization298_a, Spl1 ),
	test_data( generalization298, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization299) :-
	spl_db( generalization299_a, Spl1 ),
	test_data( generalization299, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization300) :-
	spl_db( generalization300_a, Spl1 ),
	test_data( generalization300, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization301) :-
	spl_db( generalization301_a, Spl1 ),
	test_data( generalization301, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization302) :-
	spl_db( generalization302_a, Spl1 ),
	test_data( generalization302, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization303) :-
	spl_db( generalization303_a, Spl1 ),
	test_data( generalization303, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization304) :-
	spl_db( generalization304_a, Spl1 ),
	test_data( generalization304, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization305) :-
	spl_db( generalization305_a, Spl1 ),
	test_data( generalization305, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization306) :-
	spl_db( generalization306_a, Spl1 ),
	test_data( generalization306, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization307) :-
	spl_db( generalization307_a, Spl1 ),
	test_data( generalization307, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization308) :-
	spl_db( generalization308_a, Spl1 ),
	test_data( generalization308, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization309) :-
	spl_db( generalization309_a, Spl1 ),
	test_data( generalization309, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization310) :-
	spl_db( generalization310_a, Spl1 ),
	test_data( generalization310, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization311) :-
	spl_db( generalization311_a, Spl1 ),
	test_data( generalization311, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization312) :-
	spl_db( generalization312_a, Spl1 ),
	test_data( generalization312, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization313) :-
	spl_db( generalization313_a, Spl1 ),
	test_data( generalization313, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization314) :-
	spl_db( generalization314_a, Spl1 ),
	test_data( generalization314, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization315) :-
	spl_db( generalization315_a, Spl1 ),
	test_data( generalization315, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization316) :-
	spl_db( generalization316_a, Spl1 ),
	test_data( generalization316, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization317) :-
	spl_db( generalization317_a, Spl1 ),
	test_data( generalization317, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization318) :-
	spl_db( generalization318_a, Spl1 ),
	test_data( generalization318, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization319) :-
	spl_db( generalization319_a, Spl1 ),
	test_data( generalization319, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization320) :-
	spl_db( generalization320_a, Spl1 ),
	test_data( generalization320, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization321) :-
	spl_db( generalization321_a, Spl1 ),
	test_data( generalization321, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization322) :-
	spl_db( generalization322_a, Spl1 ),
	test_data( generalization322, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization323) :-
	spl_db( generalization323_a, Spl1 ),
	test_data( generalization323, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization324) :-
	spl_db( generalization324_a, Spl1 ),
	test_data( generalization324, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization325) :-
	spl_db( generalization325_a, Spl1 ),
	test_data( generalization325, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization326) :-
	spl_db( generalization326_a, Spl1 ),
	test_data( generalization326, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization327) :-
	spl_db( generalization327_a, Spl1 ),
	test_data( generalization327, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization328) :-
	spl_db( generalization328_a, Spl1 ),
	test_data( generalization328, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization329) :-
	spl_db( generalization329_a, Spl1 ),
	test_data( generalization329, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization330) :-
	spl_db( generalization330_a, Spl1 ),
	test_data( generalization330, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization331) :-
	spl_db( generalization331_a, Spl1 ),
	test_data( generalization331, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization332) :-
	spl_db( generalization332_a, Spl1 ),
	test_data( generalization332, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization333) :-
	spl_db( generalization333_a, Spl1 ),
	test_data( generalization333, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization334) :-
	spl_db( generalization334_a, Spl1 ),
	test_data( generalization334, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization335) :-
	spl_db( generalization335_a, Spl1 ),
	test_data( generalization335, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization336) :-
	spl_db( generalization336_a, Spl1 ),
	test_data( generalization336, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization337) :-
	spl_db( generalization337_a, Spl1 ),
	test_data( generalization337, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization338) :-
	spl_db( generalization338_a, Spl1 ),
	test_data( generalization338, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization339) :-
	spl_db( generalization339_a, Spl1 ),
	test_data( generalization339, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization340) :-
	spl_db( generalization340_a, Spl1 ),
	test_data( generalization340, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization341) :-
	spl_db( generalization341_a, Spl1 ),
	test_data( generalization341, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization342) :-
	spl_db( generalization342_a, Spl1 ),
	test_data( generalization342, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization343) :-
	spl_db( generalization343_a, Spl1 ),
	test_data( generalization343, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization344) :-
	spl_db( generalization344_a, Spl1 ),
	test_data( generalization344, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization345) :-
	spl_db( generalization345_a, Spl1 ),
	test_data( generalization345, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization346) :-
	spl_db( generalization346_a, Spl1 ),
	test_data( generalization346, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization347) :-
	spl_db( generalization347_a, Spl1 ),
	test_data( generalization347, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization348) :-
	spl_db( generalization348_a, Spl1 ),
	test_data( generalization348, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization349) :-
	spl_db( generalization349_a, Spl1 ),
	test_data( generalization349, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization350) :-
	spl_db( generalization350_a, Spl1 ),
	test_data( generalization350, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization351) :-
	spl_db( generalization351_a, Spl1 ),
	test_data( generalization351, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization352) :-
	spl_db( generalization352_a, Spl1 ),
	test_data( generalization352, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization353) :-
	spl_db( generalization353_a, Spl1 ),
	test_data( generalization353, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization354) :-
	spl_db( generalization354_a, Spl1 ),
	test_data( generalization354, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization355) :-
	spl_db( generalization355_a, Spl1 ),
	test_data( generalization355, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization356) :-
	spl_db( generalization356_a, Spl1 ),
	test_data( generalization356, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization357) :-
	spl_db( generalization357_a, Spl1 ),
	test_data( generalization357, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization358) :-
	spl_db( generalization358_a, Spl1 ),
	test_data( generalization358, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization359) :-
	spl_db( generalization359_a, Spl1 ),
	test_data( generalization359, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization360) :-
	spl_db( generalization360_a, Spl1 ),
	test_data( generalization360, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization361) :-
	spl_db( generalization361_a, Spl1 ),
	test_data( generalization361, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization362) :-
	spl_db( generalization362_a, Spl1 ),
	test_data( generalization362, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization363) :-
	spl_db( generalization363_a, Spl1 ),
	test_data( generalization363, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization364) :-
	spl_db( generalization364_a, Spl1 ),
	test_data( generalization364, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization365) :-
	spl_db( generalization365_a, Spl1 ),
	test_data( generalization365, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization366) :-
	spl_db( generalization366_a, Spl1 ),
	test_data( generalization366, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization367) :-
	spl_db( generalization367_a, Spl1 ),
	test_data( generalization367, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization368) :-
	spl_db( generalization368_a, Spl1 ),
	test_data( generalization368, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization369) :-
	spl_db( generalization369_a, Spl1 ),
	test_data( generalization369, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization370) :-
	spl_db( generalization370_a, Spl1 ),
	test_data( generalization370, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization371) :-
	spl_db( generalization371_a, Spl1 ),
	test_data( generalization371, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization372) :-
	spl_db( generalization372_a, Spl1 ),
	test_data( generalization372, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization373) :-
	spl_db( generalization373_a, Spl1 ),
	test_data( generalization373, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization374) :-
	spl_db( generalization374_a, Spl1 ),
	test_data( generalization374, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization375) :-
	spl_db( generalization375_a, Spl1 ),
	test_data( generalization375, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization376) :-
	spl_db( generalization376_a, Spl1 ),
	test_data( generalization376, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization377) :-
	spl_db( generalization377_a, Spl1 ),
	test_data( generalization377, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization378) :-
	spl_db( generalization378_a, Spl1 ),
	test_data( generalization378, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization379) :-
	spl_db( generalization379_a, Spl1 ),
	test_data( generalization379, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization380) :-
	spl_db( generalization380_a, Spl1 ),
	test_data( generalization380, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization381) :-
	spl_db( generalization381_a, Spl1 ),
	test_data( generalization381, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization382) :-
	spl_db( generalization382_a, Spl1 ),
	test_data( generalization382, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization383) :-
	spl_db( generalization383_a, Spl1 ),
	test_data( generalization383, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization384) :-
	spl_db( generalization384_a, Spl1 ),
	test_data( generalization384, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization385) :-
	spl_db( generalization385_a, Spl1 ),
	test_data( generalization385, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization386) :-
	spl_db( generalization386_a, Spl1 ),
	test_data( generalization386, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization387) :-
	spl_db( generalization387_a, Spl1 ),
	test_data( generalization387, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization388) :-
	spl_db( generalization388_a, Spl1 ),
	test_data( generalization388, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization389) :-
	spl_db( generalization389_a, Spl1 ),
	test_data( generalization389, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization390) :-
	spl_db( generalization390_a, Spl1 ),
	test_data( generalization390, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization391) :-
	spl_db( generalization391_a, Spl1 ),
	test_data( generalization391, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization392) :-
	spl_db( generalization392_a, Spl1 ),
	test_data( generalization392, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization393) :-
	spl_db( generalization393_a, Spl1 ),
	test_data( generalization393, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization394) :-
	spl_db( generalization394_a, Spl1 ),
	test_data( generalization394, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization395) :-
	spl_db( generalization395_a, Spl1 ),
	test_data( generalization395, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization396) :-
	spl_db( generalization396_a, Spl1 ),
	test_data( generalization396, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization397) :-
	spl_db( generalization397_a, Spl1 ),
	test_data( generalization397, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization398) :-
	spl_db( generalization398_a, Spl1 ),
	test_data( generalization398, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization399) :-
	spl_db( generalization399_a, Spl1 ),
	test_data( generalization399, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization400) :-
	spl_db( generalization400_a, Spl1 ),
	test_data( generalization400, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization401) :-
	spl_db( generalization401_a, Spl1 ),
	test_data( generalization401, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization402) :-
	spl_db( generalization402_a, Spl1 ),
	test_data( generalization402, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization403) :-
	spl_db( generalization403_a, Spl1 ),
	test_data( generalization403, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization404) :-
	spl_db( generalization404_a, Spl1 ),
	test_data( generalization404, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization405) :-
	spl_db( generalization405_a, Spl1 ),
	test_data( generalization405, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization406) :-
	spl_db( generalization406_a, Spl1 ),
	test_data( generalization406, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization407) :-
	spl_db( generalization407_a, Spl1 ),
	test_data( generalization407, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization408) :-
	spl_db( generalization408_a, Spl1 ),
	test_data( generalization408, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization409) :-
	spl_db( generalization409_a, Spl1 ),
	test_data( generalization409, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization410) :-
	spl_db( generalization410_a, Spl1 ),
	test_data( generalization410, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization411) :-
	spl_db( generalization411_a, Spl1 ),
	test_data( generalization411, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization412) :-
	spl_db( generalization412_a, Spl1 ),
	test_data( generalization412, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization413) :-
	spl_db( generalization413_a, Spl1 ),
	test_data( generalization413, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization414) :-
	spl_db( generalization414_a, Spl1 ),
	test_data( generalization414, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization415) :-
	spl_db( generalization415_a, Spl1 ),
	test_data( generalization415, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization416) :-
	spl_db( generalization416_a, Spl1 ),
	test_data( generalization416, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization417) :-
	spl_db( generalization417_a, Spl1 ),
	test_data( generalization417, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization418) :-
	spl_db( generalization418_a, Spl1 ),
	test_data( generalization418, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization419) :-
	spl_db( generalization419_a, Spl1 ),
	test_data( generalization419, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization420) :-
	spl_db( generalization420_a, Spl1 ),
	test_data( generalization420, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization421) :-
	spl_db( generalization421_a, Spl1 ),
	test_data( generalization421, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization422) :-
	spl_db( generalization422_a, Spl1 ),
	test_data( generalization422, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization423) :-
	spl_db( generalization423_a, Spl1 ),
	test_data( generalization423, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization424) :-
	spl_db( generalization424_a, Spl1 ),
	test_data( generalization424, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization425) :-
	spl_db( generalization425_a, Spl1 ),
	test_data( generalization425, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization426) :-
	spl_db( generalization426_a, Spl1 ),
	test_data( generalization426, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization427) :-
	spl_db( generalization427_a, Spl1 ),
	test_data( generalization427, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization428) :-
	spl_db( generalization428_a, Spl1 ),
	test_data( generalization428, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization429) :-
	spl_db( generalization429_a, Spl1 ),
	test_data( generalization429, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization430) :-
	spl_db( generalization430_a, Spl1 ),
	test_data( generalization430, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization431) :-
	spl_db( generalization431_a, Spl1 ),
	test_data( generalization431, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization432) :-
	spl_db( generalization432_a, Spl1 ),
	test_data( generalization432, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization433) :-
	spl_db( generalization433_a, Spl1 ),
	test_data( generalization433, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization434) :-
	spl_db( generalization434_a, Spl1 ),
	test_data( generalization434, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization435) :-
	spl_db( generalization435_a, Spl1 ),
	test_data( generalization435, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization436) :-
	spl_db( generalization436_a, Spl1 ),
	test_data( generalization436, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization437) :-
	spl_db( generalization437_a, Spl1 ),
	test_data( generalization437, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization438) :-
	spl_db( generalization438_a, Spl1 ),
	test_data( generalization438, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization439) :-
	spl_db( generalization439_a, Spl1 ),
	test_data( generalization439, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization440) :-
	spl_db( generalization440_a, Spl1 ),
	test_data( generalization440, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization441) :-
	spl_db( generalization441_a, Spl1 ),
	test_data( generalization441, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization442) :-
	spl_db( generalization442_a, Spl1 ),
	test_data( generalization442, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization443) :-
	spl_db( generalization443_a, Spl1 ),
	test_data( generalization443, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization444) :-
	spl_db( generalization444_a, Spl1 ),
	test_data( generalization444, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization445) :-
	spl_db( generalization445_a, Spl1 ),
	test_data( generalization445, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization446) :-
	spl_db( generalization446_a, Spl1 ),
	test_data( generalization446, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization447) :-
	spl_db( generalization447_a, Spl1 ),
	test_data( generalization447, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization448) :-
	spl_db( generalization448_a, Spl1 ),
	test_data( generalization448, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization449) :-
	spl_db( generalization449_a, Spl1 ),
	test_data( generalization449, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization450) :-
	spl_db( generalization450_a, Spl1 ),
	test_data( generalization450, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization451) :-
	spl_db( generalization451_a, Spl1 ),
	test_data( generalization451, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization452) :-
	spl_db( generalization452_a, Spl1 ),
	test_data( generalization452, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization453) :-
	spl_db( generalization453_a, Spl1 ),
	test_data( generalization453, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization454) :-
	spl_db( generalization454_a, Spl1 ),
	test_data( generalization454, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization455) :-
	spl_db( generalization455_a, Spl1 ),
	test_data( generalization455, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization456) :-
	spl_db( generalization456_a, Spl1 ),
	test_data( generalization456, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization457) :-
	spl_db( generalization457_a, Spl1 ),
	test_data( generalization457, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization458) :-
	spl_db( generalization458_a, Spl1 ),
	test_data( generalization458, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization459) :-
	spl_db( generalization459_a, Spl1 ),
	test_data( generalization459, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization460) :-
	spl_db( generalization460_a, Spl1 ),
	test_data( generalization460, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization461) :-
	spl_db( generalization461_a, Spl1 ),
	test_data( generalization461, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization462) :-
	spl_db( generalization462_a, Spl1 ),
	test_data( generalization462, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization463) :-
	spl_db( generalization463_a, Spl1 ),
	test_data( generalization463, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization464) :-
	spl_db( generalization464_a, Spl1 ),
	test_data( generalization464, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization465) :-
	spl_db( generalization465_a, Spl1 ),
	test_data( generalization465, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization466) :-
	spl_db( generalization466_a, Spl1 ),
	test_data( generalization466, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization467) :-
	spl_db( generalization467_a, Spl1 ),
	test_data( generalization467, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization468) :-
	spl_db( generalization468_a, Spl1 ),
	test_data( generalization468, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization469) :-
	spl_db( generalization469_a, Spl1 ),
	test_data( generalization469, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization470) :-
	spl_db( generalization470_a, Spl1 ),
	test_data( generalization470, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization471) :-
	spl_db( generalization471_a, Spl1 ),
	test_data( generalization471, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization472) :-
	spl_db( generalization472_a, Spl1 ),
	test_data( generalization472, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization473) :-
	spl_db( generalization473_a, Spl1 ),
	test_data( generalization473, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization474) :-
	spl_db( generalization474_a, Spl1 ),
	test_data( generalization474, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization475) :-
	spl_db( generalization475_a, Spl1 ),
	test_data( generalization475, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization476) :-
	spl_db( generalization476_a, Spl1 ),
	test_data( generalization476, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization477) :-
	spl_db( generalization477_a, Spl1 ),
	test_data( generalization477, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization478) :-
	spl_db( generalization478_a, Spl1 ),
	test_data( generalization478, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization479) :-
	spl_db( generalization479_a, Spl1 ),
	test_data( generalization479, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization480) :-
	spl_db( generalization480_a, Spl1 ),
	test_data( generalization480, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization481) :-
	spl_db( generalization481_a, Spl1 ),
	test_data( generalization481, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization482) :-
	spl_db( generalization482_a, Spl1 ),
	test_data( generalization482, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization483) :-
	spl_db( generalization483_a, Spl1 ),
	test_data( generalization483, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization484) :-
	spl_db( generalization484_a, Spl1 ),
	test_data( generalization484, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization485) :-
	spl_db( generalization485_a, Spl1 ),
	test_data( generalization485, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization486) :-
	spl_db( generalization486_a, Spl1 ),
	test_data( generalization486, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization487) :-
	spl_db( generalization487_a, Spl1 ),
	test_data( generalization487, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization488) :-
	spl_db( generalization488_a, Spl1 ),
	test_data( generalization488, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization489) :-
	spl_db( generalization489_a, Spl1 ),
	test_data( generalization489, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization490) :-
	spl_db( generalization490_a, Spl1 ),
	test_data( generalization490, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization491) :-
	spl_db( generalization491_a, Spl1 ),
	test_data( generalization491, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization492) :-
	spl_db( generalization492_a, Spl1 ),
	test_data( generalization492, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization493) :-
	spl_db( generalization493_a, Spl1 ),
	test_data( generalization493, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization494) :-
	spl_db( generalization494_a, Spl1 ),
	test_data( generalization494, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization495) :-
	spl_db( generalization495_a, Spl1 ),
	test_data( generalization495, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization496) :-
	spl_db( generalization496_a, Spl1 ),
	test_data( generalization496, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization497) :-
	spl_db( generalization497_a, Spl1 ),
	test_data( generalization497, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization498) :-
	spl_db( generalization498_a, Spl1 ),
	test_data( generalization498, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization499) :-
	spl_db( generalization499_a, Spl1 ),
	test_data( generalization499, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization500) :-
	spl_db( generalization500_a, Spl1 ),
	test_data( generalization500, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization501) :-
	spl_db( generalization501_a, Spl1 ),
	test_data( generalization501, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization502) :-
	spl_db( generalization502_a, Spl1 ),
	test_data( generalization502, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization503) :-
	spl_db( generalization503_a, Spl1 ),
	test_data( generalization503, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization504) :-
	spl_db( generalization504_a, Spl1 ),
	test_data( generalization504, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization505) :-
	spl_db( generalization505_a, Spl1 ),
	test_data( generalization505, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization506) :-
	spl_db( generalization506_a, Spl1 ),
	test_data( generalization506, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization507) :-
	spl_db( generalization507_a, Spl1 ),
	test_data( generalization507, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization508) :-
	spl_db( generalization508_a, Spl1 ),
	test_data( generalization508, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization509) :-
	spl_db( generalization509_a, Spl1 ),
	test_data( generalization509, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization510) :-
	spl_db( generalization510_a, Spl1 ),
	test_data( generalization510, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization511) :-
	spl_db( generalization511_a, Spl1 ),
	test_data( generalization511, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization512) :-
	spl_db( generalization512_a, Spl1 ),
	test_data( generalization512, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization513) :-
	spl_db( generalization513_a, Spl1 ),
	test_data( generalization513, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization514) :-
	spl_db( generalization514_a, Spl1 ),
	test_data( generalization514, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization515) :-
	spl_db( generalization515_a, Spl1 ),
	test_data( generalization515, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization516) :-
	spl_db( generalization516_a, Spl1 ),
	test_data( generalization516, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization517) :-
	spl_db( generalization517_a, Spl1 ),
	test_data( generalization517, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization518) :-
	spl_db( generalization518_a, Spl1 ),
	test_data( generalization518, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization519) :-
	spl_db( generalization519_a, Spl1 ),
	test_data( generalization519, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization520) :-
	spl_db( generalization520_a, Spl1 ),
	test_data( generalization520, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization521) :-
	spl_db( generalization521_a, Spl1 ),
	test_data( generalization521, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization522) :-
	spl_db( generalization522_a, Spl1 ),
	test_data( generalization522, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization523) :-
	spl_db( generalization523_a, Spl1 ),
	test_data( generalization523, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization524) :-
	spl_db( generalization524_a, Spl1 ),
	test_data( generalization524, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization525) :-
	spl_db( generalization525_a, Spl1 ),
	test_data( generalization525, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization526) :-
	spl_db( generalization526_a, Spl1 ),
	test_data( generalization526, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization527) :-
	spl_db( generalization527_a, Spl1 ),
	test_data( generalization527, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization528) :-
	spl_db( generalization528_a, Spl1 ),
	test_data( generalization528, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization529) :-
	spl_db( generalization529_a, Spl1 ),
	test_data( generalization529, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization530) :-
	spl_db( generalization530_a, Spl1 ),
	test_data( generalization530, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization531) :-
	spl_db( generalization531_a, Spl1 ),
	test_data( generalization531, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization532) :-
	spl_db( generalization532_a, Spl1 ),
	test_data( generalization532, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization533) :-
	spl_db( generalization533_a, Spl1 ),
	test_data( generalization533, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization534) :-
	spl_db( generalization534_a, Spl1 ),
	test_data( generalization534, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization535) :-
	spl_db( generalization535_a, Spl1 ),
	test_data( generalization535, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization536) :-
	spl_db( generalization536_a, Spl1 ),
	test_data( generalization536, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization537) :-
	spl_db( generalization537_a, Spl1 ),
	test_data( generalization537, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization538) :-
	spl_db( generalization538_a, Spl1 ),
	test_data( generalization538, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization539) :-
	spl_db( generalization539_a, Spl1 ),
	test_data( generalization539, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization540) :-
	spl_db( generalization540_a, Spl1 ),
	test_data( generalization540, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization541) :-
	spl_db( generalization541_a, Spl1 ),
	test_data( generalization541, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization542) :-
	spl_db( generalization542_a, Spl1 ),
	test_data( generalization542, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization543) :-
	spl_db( generalization543_a, Spl1 ),
	test_data( generalization543, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization544) :-
	spl_db( generalization544_a, Spl1 ),
	test_data( generalization544, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization545) :-
	spl_db( generalization545_a, Spl1 ),
	test_data( generalization545, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization546) :-
	spl_db( generalization546_a, Spl1 ),
	test_data( generalization546, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization547) :-
	spl_db( generalization547_a, Spl1 ),
	test_data( generalization547, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization548) :-
	spl_db( generalization548_a, Spl1 ),
	test_data( generalization548, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization549) :-
	spl_db( generalization549_a, Spl1 ),
	test_data( generalization549, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization550) :-
	spl_db( generalization550_a, Spl1 ),
	test_data( generalization550, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization551) :-
	spl_db( generalization551_a, Spl1 ),
	test_data( generalization551, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization552) :-
	spl_db( generalization552_a, Spl1 ),
	test_data( generalization552, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization553) :-
	spl_db( generalization553_a, Spl1 ),
	test_data( generalization553, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization554) :-
	spl_db( generalization554_a, Spl1 ),
	test_data( generalization554, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization555) :-
	spl_db( generalization555_a, Spl1 ),
	test_data( generalization555, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization556) :-
	spl_db( generalization556_a, Spl1 ),
	test_data( generalization556, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization557) :-
	spl_db( generalization557_a, Spl1 ),
	test_data( generalization557, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization558) :-
	spl_db( generalization558_a, Spl1 ),
	test_data( generalization558, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization559) :-
	spl_db( generalization559_a, Spl1 ),
	test_data( generalization559, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization560) :-
	spl_db( generalization560_a, Spl1 ),
	test_data( generalization560, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization561) :-
	spl_db( generalization561_a, Spl1 ),
	test_data( generalization561, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization562) :-
	spl_db( generalization562_a, Spl1 ),
	test_data( generalization562, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization563) :-
	spl_db( generalization563_a, Spl1 ),
	test_data( generalization563, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization564) :-
	spl_db( generalization564_a, Spl1 ),
	test_data( generalization564, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization565) :-
	spl_db( generalization565_a, Spl1 ),
	test_data( generalization565, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization566) :-
	spl_db( generalization566_a, Spl1 ),
	test_data( generalization566, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization567) :-
	spl_db( generalization567_a, Spl1 ),
	test_data( generalization567, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization568) :-
	spl_db( generalization568_a, Spl1 ),
	test_data( generalization568, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization569) :-
	spl_db( generalization569_a, Spl1 ),
	test_data( generalization569, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization570) :-
	spl_db( generalization570_a, Spl1 ),
	test_data( generalization570, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization571) :-
	spl_db( generalization571_a, Spl1 ),
	test_data( generalization571, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization572) :-
	spl_db( generalization572_a, Spl1 ),
	test_data( generalization572, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization573) :-
	spl_db( generalization573_a, Spl1 ),
	test_data( generalization573, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization574) :-
	spl_db( generalization574_a, Spl1 ),
	test_data( generalization574, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization575) :-
	spl_db( generalization575_a, Spl1 ),
	test_data( generalization575, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization576) :-
	spl_db( generalization576_a, Spl1 ),
	test_data( generalization576, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization577) :-
	spl_db( generalization577_a, Spl1 ),
	test_data( generalization577, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization578) :-
	spl_db( generalization578_a, Spl1 ),
	test_data( generalization578, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization579) :-
	spl_db( generalization579_a, Spl1 ),
	test_data( generalization579, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization580) :-
	spl_db( generalization580_a, Spl1 ),
	test_data( generalization580, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization581) :-
	spl_db( generalization581_a, Spl1 ),
	test_data( generalization581, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization582) :-
	spl_db( generalization582_a, Spl1 ),
	test_data( generalization582, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization583) :-
	spl_db( generalization583_a, Spl1 ),
	test_data( generalization583, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization584) :-
	spl_db( generalization584_a, Spl1 ),
	test_data( generalization584, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization585) :-
	spl_db( generalization585_a, Spl1 ),
	test_data( generalization585, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization586) :-
	spl_db( generalization586_a, Spl1 ),
	test_data( generalization586, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization587) :-
	spl_db( generalization587_a, Spl1 ),
	test_data( generalization587, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization588) :-
	spl_db( generalization588_a, Spl1 ),
	test_data( generalization588, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization589) :-
	spl_db( generalization589_a, Spl1 ),
	test_data( generalization589, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization590) :-
	spl_db( generalization590_a, Spl1 ),
	test_data( generalization590, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization591) :-
	spl_db( generalization591_a, Spl1 ),
	test_data( generalization591, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization592) :-
	spl_db( generalization592_a, Spl1 ),
	test_data( generalization592, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization593) :-
	spl_db( generalization593_a, Spl1 ),
	test_data( generalization593, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization594) :-
	spl_db( generalization594_a, Spl1 ),
	test_data( generalization594, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization595) :-
	spl_db( generalization595_a, Spl1 ),
	test_data( generalization595, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization596) :-
	spl_db( generalization596_a, Spl1 ),
	test_data( generalization596, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization597) :-
	spl_db( generalization597_a, Spl1 ),
	test_data( generalization597, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization598) :-
	spl_db( generalization598_a, Spl1 ),
	test_data( generalization598, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization599) :-
	spl_db( generalization599_a, Spl1 ),
	test_data( generalization599, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization600) :-
	spl_db( generalization600_a, Spl1 ),
	test_data( generalization600, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization601) :-
	spl_db( generalization601_a, Spl1 ),
	test_data( generalization601, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization602) :-
	spl_db( generalization602_a, Spl1 ),
	test_data( generalization602, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization603) :-
	spl_db( generalization603_a, Spl1 ),
	test_data( generalization603, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization604) :-
	spl_db( generalization604_a, Spl1 ),
	test_data( generalization604, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization605) :-
	spl_db( generalization605_a, Spl1 ),
	test_data( generalization605, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization606) :-
	spl_db( generalization606_a, Spl1 ),
	test_data( generalization606, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization607) :-
	spl_db( generalization607_a, Spl1 ),
	test_data( generalization607, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization608) :-
	spl_db( generalization608_a, Spl1 ),
	test_data( generalization608, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization609) :-
	spl_db( generalization609_a, Spl1 ),
	test_data( generalization609, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization610) :-
	spl_db( generalization610_a, Spl1 ),
	test_data( generalization610, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization611) :-
	spl_db( generalization611_a, Spl1 ),
	test_data( generalization611, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization612) :-
	spl_db( generalization612_a, Spl1 ),
	test_data( generalization612, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization613) :-
	spl_db( generalization613_a, Spl1 ),
	test_data( generalization613, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization614) :-
	spl_db( generalization614_a, Spl1 ),
	test_data( generalization614, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization615) :-
	spl_db( generalization615_a, Spl1 ),
	test_data( generalization615, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization616) :-
	spl_db( generalization616_a, Spl1 ),
	test_data( generalization616, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization617) :-
	spl_db( generalization617_a, Spl1 ),
	test_data( generalization617, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization618) :-
	spl_db( generalization618_a, Spl1 ),
	test_data( generalization618, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization619) :-
	spl_db( generalization619_a, Spl1 ),
	test_data( generalization619, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization620) :-
	spl_db( generalization620_a, Spl1 ),
	test_data( generalization620, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization621) :-
	spl_db( generalization621_a, Spl1 ),
	test_data( generalization621, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization622) :-
	spl_db( generalization622_a, Spl1 ),
	test_data( generalization622, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization623) :-
	spl_db( generalization623_a, Spl1 ),
	test_data( generalization623, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization624) :-
	spl_db( generalization624_a, Spl1 ),
	test_data( generalization624, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization625) :-
	spl_db( generalization625_a, Spl1 ),
	test_data( generalization625, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization626) :-
	spl_db( generalization626_a, Spl1 ),
	test_data( generalization626, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization627) :-
	spl_db( generalization627_a, Spl1 ),
	test_data( generalization627, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization628) :-
	spl_db( generalization628_a, Spl1 ),
	test_data( generalization628, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization629) :-
	spl_db( generalization629_a, Spl1 ),
	test_data( generalization629, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization630) :-
	spl_db( generalization630_a, Spl1 ),
	test_data( generalization630, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization631) :-
	spl_db( generalization631_a, Spl1 ),
	test_data( generalization631, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization632) :-
	spl_db( generalization632_a, Spl1 ),
	test_data( generalization632, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization633) :-
	spl_db( generalization633_a, Spl1 ),
	test_data( generalization633, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization634) :-
	spl_db( generalization634_a, Spl1 ),
	test_data( generalization634, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization635) :-
	spl_db( generalization635_a, Spl1 ),
	test_data( generalization635, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization636) :-
	spl_db( generalization636_a, Spl1 ),
	test_data( generalization636, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization637) :-
	spl_db( generalization637_a, Spl1 ),
	test_data( generalization637, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization638) :-
	spl_db( generalization638_a, Spl1 ),
	test_data( generalization638, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization639) :-
	spl_db( generalization639_a, Spl1 ),
	test_data( generalization639, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization640) :-
	spl_db( generalization640_a, Spl1 ),
	test_data( generalization640, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization641) :-
	spl_db( generalization641_a, Spl1 ),
	test_data( generalization641, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization642) :-
	spl_db( generalization642_a, Spl1 ),
	test_data( generalization642, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization643) :-
	spl_db( generalization643_a, Spl1 ),
	test_data( generalization643, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization644) :-
	spl_db( generalization644_a, Spl1 ),
	test_data( generalization644, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization645) :-
	spl_db( generalization645_a, Spl1 ),
	test_data( generalization645, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization646) :-
	spl_db( generalization646_a, Spl1 ),
	test_data( generalization646, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization647) :-
	spl_db( generalization647_a, Spl1 ),
	test_data( generalization647, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization648) :-
	spl_db( generalization648_a, Spl1 ),
	test_data( generalization648, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization649) :-
	spl_db( generalization649_a, Spl1 ),
	test_data( generalization649, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization650) :-
	spl_db( generalization650_a, Spl1 ),
	test_data( generalization650, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization651) :-
	spl_db( generalization651_a, Spl1 ),
	test_data( generalization651, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization652) :-
	spl_db( generalization652_a, Spl1 ),
	test_data( generalization652, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization653) :-
	spl_db( generalization653_a, Spl1 ),
	test_data( generalization653, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization654) :-
	spl_db( generalization654_a, Spl1 ),
	test_data( generalization654, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization655) :-
	spl_db( generalization655_a, Spl1 ),
	test_data( generalization655, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization656) :-
	spl_db( generalization656_a, Spl1 ),
	test_data( generalization656, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization657) :-
	spl_db( generalization657_a, Spl1 ),
	test_data( generalization657, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization658) :-
	spl_db( generalization658_a, Spl1 ),
	test_data( generalization658, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization659) :-
	spl_db( generalization659_a, Spl1 ),
	test_data( generalization659, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization660) :-
	spl_db( generalization660_a, Spl1 ),
	test_data( generalization660, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization661) :-
	spl_db( generalization661_a, Spl1 ),
	test_data( generalization661, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization662) :-
	spl_db( generalization662_a, Spl1 ),
	test_data( generalization662, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization663) :-
	spl_db( generalization663_a, Spl1 ),
	test_data( generalization663, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization664) :-
	spl_db( generalization664_a, Spl1 ),
	test_data( generalization664, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization665) :-
	spl_db( generalization665_a, Spl1 ),
	test_data( generalization665, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization666) :-
	spl_db( generalization666_a, Spl1 ),
	test_data( generalization666, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization667) :-
	spl_db( generalization667_a, Spl1 ),
	test_data( generalization667, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization668) :-
	spl_db( generalization668_a, Spl1 ),
	test_data( generalization668, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization669) :-
	spl_db( generalization669_a, Spl1 ),
	test_data( generalization669, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization670) :-
	spl_db( generalization670_a, Spl1 ),
	test_data( generalization670, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization671) :-
	spl_db( generalization671_a, Spl1 ),
	test_data( generalization671, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization672) :-
	spl_db( generalization672_a, Spl1 ),
	test_data( generalization672, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization673) :-
	spl_db( generalization673_a, Spl1 ),
	test_data( generalization673, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization674) :-
	spl_db( generalization674_a, Spl1 ),
	test_data( generalization674, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization675) :-
	spl_db( generalization675_a, Spl1 ),
	test_data( generalization675, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization676) :-
	spl_db( generalization676_a, Spl1 ),
	test_data( generalization676, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization677) :-
	spl_db( generalization677_a, Spl1 ),
	test_data( generalization677, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization678) :-
	spl_db( generalization678_a, Spl1 ),
	test_data( generalization678, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization679) :-
	spl_db( generalization679_a, Spl1 ),
	test_data( generalization679, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization680) :-
	spl_db( generalization680_a, Spl1 ),
	test_data( generalization680, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization681) :-
	spl_db( generalization681_a, Spl1 ),
	test_data( generalization681, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization682) :-
	spl_db( generalization682_a, Spl1 ),
	test_data( generalization682, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization683) :-
	spl_db( generalization683_a, Spl1 ),
	test_data( generalization683, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization684) :-
	spl_db( generalization684_a, Spl1 ),
	test_data( generalization684, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization685) :-
	spl_db( generalization685_a, Spl1 ),
	test_data( generalization685, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization686) :-
	spl_db( generalization686_a, Spl1 ),
	test_data( generalization686, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization687) :-
	spl_db( generalization687_a, Spl1 ),
	test_data( generalization687, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization688) :-
	spl_db( generalization688_a, Spl1 ),
	test_data( generalization688, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization689) :-
	spl_db( generalization689_a, Spl1 ),
	test_data( generalization689, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization690) :-
	spl_db( generalization690_a, Spl1 ),
	test_data( generalization690, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization691) :-
	spl_db( generalization691_a, Spl1 ),
	test_data( generalization691, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization692) :-
	spl_db( generalization692_a, Spl1 ),
	test_data( generalization692, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization693) :-
	spl_db( generalization693_a, Spl1 ),
	test_data( generalization693, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization694) :-
	spl_db( generalization694_a, Spl1 ),
	test_data( generalization694, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization695) :-
	spl_db( generalization695_a, Spl1 ),
	test_data( generalization695, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization696) :-
	spl_db( generalization696_a, Spl1 ),
	test_data( generalization696, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization697) :-
	spl_db( generalization697_a, Spl1 ),
	test_data( generalization697, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization698) :-
	spl_db( generalization698_a, Spl1 ),
	test_data( generalization698, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization699) :-
	spl_db( generalization699_a, Spl1 ),
	test_data( generalization699, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization700) :-
	spl_db( generalization700_a, Spl1 ),
	test_data( generalization700, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization701) :-
	spl_db( generalization701_a, Spl1 ),
	test_data( generalization701, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization702) :-
	spl_db( generalization702_a, Spl1 ),
	test_data( generalization702, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization703) :-
	spl_db( generalization703_a, Spl1 ),
	test_data( generalization703, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization704) :-
	spl_db( generalization704_a, Spl1 ),
	test_data( generalization704, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization705) :-
	spl_db( generalization705_a, Spl1 ),
	test_data( generalization705, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization706) :-
	spl_db( generalization706_a, Spl1 ),
	test_data( generalization706, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization707) :-
	spl_db( generalization707_a, Spl1 ),
	test_data( generalization707, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization708) :-
	spl_db( generalization708_a, Spl1 ),
	test_data( generalization708, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization709) :-
	spl_db( generalization709_a, Spl1 ),
	test_data( generalization709, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization710) :-
	spl_db( generalization710_a, Spl1 ),
	test_data( generalization710, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization711) :-
	spl_db( generalization711_a, Spl1 ),
	test_data( generalization711, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization712) :-
	spl_db( generalization712_a, Spl1 ),
	test_data( generalization712, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization713) :-
	spl_db( generalization713_a, Spl1 ),
	test_data( generalization713, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization714) :-
	spl_db( generalization714_a, Spl1 ),
	test_data( generalization714, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization715) :-
	spl_db( generalization715_a, Spl1 ),
	test_data( generalization715, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization716) :-
	spl_db( generalization716_a, Spl1 ),
	test_data( generalization716, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization717) :-
	spl_db( generalization717_a, Spl1 ),
	test_data( generalization717, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization718) :-
	spl_db( generalization718_a, Spl1 ),
	test_data( generalization718, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization719) :-
	spl_db( generalization719_a, Spl1 ),
	test_data( generalization719, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization720) :-
	spl_db( generalization720_a, Spl1 ),
	test_data( generalization720, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization721) :-
	spl_db( generalization721_a, Spl1 ),
	test_data( generalization721, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization722) :-
	spl_db( generalization722_a, Spl1 ),
	test_data( generalization722, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization723) :-
	spl_db( generalization723_a, Spl1 ),
	test_data( generalization723, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization724) :-
	spl_db( generalization724_a, Spl1 ),
	test_data( generalization724, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization725) :-
	spl_db( generalization725_a, Spl1 ),
	test_data( generalization725, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization726) :-
	spl_db( generalization726_a, Spl1 ),
	test_data( generalization726, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization727) :-
	spl_db( generalization727_a, Spl1 ),
	test_data( generalization727, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization728) :-
	spl_db( generalization728_a, Spl1 ),
	test_data( generalization728, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization729) :-
	spl_db( generalization729_a, Spl1 ),
	test_data( generalization729, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization730) :-
	spl_db( generalization730_a, Spl1 ),
	test_data( generalization730, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization731) :-
	spl_db( generalization731_a, Spl1 ),
	test_data( generalization731, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization732) :-
	spl_db( generalization732_a, Spl1 ),
	test_data( generalization732, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization733) :-
	spl_db( generalization733_a, Spl1 ),
	test_data( generalization733, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization734) :-
	spl_db( generalization734_a, Spl1 ),
	test_data( generalization734, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization735) :-
	spl_db( generalization735_a, Spl1 ),
	test_data( generalization735, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization736) :-
	spl_db( generalization736_a, Spl1 ),
	test_data( generalization736, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization737) :-
	spl_db( generalization737_a, Spl1 ),
	test_data( generalization737, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization738) :-
	spl_db( generalization738_a, Spl1 ),
	test_data( generalization738, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization739) :-
	spl_db( generalization739_a, Spl1 ),
	test_data( generalization739, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization740) :-
	spl_db( generalization740_a, Spl1 ),
	test_data( generalization740, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization741) :-
	spl_db( generalization741_a, Spl1 ),
	test_data( generalization741, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization742) :-
	spl_db( generalization742_a, Spl1 ),
	test_data( generalization742, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization743) :-
	spl_db( generalization743_a, Spl1 ),
	test_data( generalization743, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization744) :-
	spl_db( generalization744_a, Spl1 ),
	test_data( generalization744, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization745) :-
	spl_db( generalization745_a, Spl1 ),
	test_data( generalization745, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization746) :-
	spl_db( generalization746_a, Spl1 ),
	test_data( generalization746, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization747) :-
	spl_db( generalization747_a, Spl1 ),
	test_data( generalization747, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization748) :-
	spl_db( generalization748_a, Spl1 ),
	test_data( generalization748, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization749) :-
	spl_db( generalization749_a, Spl1 ),
	test_data( generalization749, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization750) :-
	spl_db( generalization750_a, Spl1 ),
	test_data( generalization750, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization751) :-
	spl_db( generalization751_a, Spl1 ),
	test_data( generalization751, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization752) :-
	spl_db( generalization752_a, Spl1 ),
	test_data( generalization752, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization753) :-
	spl_db( generalization753_a, Spl1 ),
	test_data( generalization753, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization754) :-
	spl_db( generalization754_a, Spl1 ),
	test_data( generalization754, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization755) :-
	spl_db( generalization755_a, Spl1 ),
	test_data( generalization755, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization756) :-
	spl_db( generalization756_a, Spl1 ),
	test_data( generalization756, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization757) :-
	spl_db( generalization757_a, Spl1 ),
	test_data( generalization757, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization758) :-
	spl_db( generalization758_a, Spl1 ),
	test_data( generalization758, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization759) :-
	spl_db( generalization759_a, Spl1 ),
	test_data( generalization759, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization760) :-
	spl_db( generalization760_a, Spl1 ),
	test_data( generalization760, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization761) :-
	spl_db( generalization761_a, Spl1 ),
	test_data( generalization761, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization762) :-
	spl_db( generalization762_a, Spl1 ),
	test_data( generalization762, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization763) :-
	spl_db( generalization763_a, Spl1 ),
	test_data( generalization763, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization764) :-
	spl_db( generalization764_a, Spl1 ),
	test_data( generalization764, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization765) :-
	spl_db( generalization765_a, Spl1 ),
	test_data( generalization765, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization766) :-
	spl_db( generalization766_a, Spl1 ),
	test_data( generalization766, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization767) :-
	spl_db( generalization767_a, Spl1 ),
	test_data( generalization767, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization768) :-
	spl_db( generalization768_a, Spl1 ),
	test_data( generalization768, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization769) :-
	spl_db( generalization769_a, Spl1 ),
	test_data( generalization769, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization770) :-
	spl_db( generalization770_a, Spl1 ),
	test_data( generalization770, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization771) :-
	spl_db( generalization771_a, Spl1 ),
	test_data( generalization771, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization772) :-
	spl_db( generalization772_a, Spl1 ),
	test_data( generalization772, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization773) :-
	spl_db( generalization773_a, Spl1 ),
	test_data( generalization773, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization774) :-
	spl_db( generalization774_a, Spl1 ),
	test_data( generalization774, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization775) :-
	spl_db( generalization775_a, Spl1 ),
	test_data( generalization775, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization776) :-
	spl_db( generalization776_a, Spl1 ),
	test_data( generalization776, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization777) :-
	spl_db( generalization777_a, Spl1 ),
	test_data( generalization777, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization778) :-
	spl_db( generalization778_a, Spl1 ),
	test_data( generalization778, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization779) :-
	spl_db( generalization779_a, Spl1 ),
	test_data( generalization779, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization780) :-
	spl_db( generalization780_a, Spl1 ),
	test_data( generalization780, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization781) :-
	spl_db( generalization781_a, Spl1 ),
	test_data( generalization781, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization782) :-
	spl_db( generalization782_a, Spl1 ),
	test_data( generalization782, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization783) :-
	spl_db( generalization783_a, Spl1 ),
	test_data( generalization783, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization784) :-
	spl_db( generalization784_a, Spl1 ),
	test_data( generalization784, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization785) :-
	spl_db( generalization785_a, Spl1 ),
	test_data( generalization785, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization786) :-
	spl_db( generalization786_a, Spl1 ),
	test_data( generalization786, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization787) :-
	spl_db( generalization787_a, Spl1 ),
	test_data( generalization787, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization788) :-
	spl_db( generalization788_a, Spl1 ),
	test_data( generalization788, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization789) :-
	spl_db( generalization789_a, Spl1 ),
	test_data( generalization789, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization790) :-
	spl_db( generalization790_a, Spl1 ),
	test_data( generalization790, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization791) :-
	spl_db( generalization791_a, Spl1 ),
	test_data( generalization791, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization792) :-
	spl_db( generalization792_a, Spl1 ),
	test_data( generalization792, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization793) :-
	spl_db( generalization793_a, Spl1 ),
	test_data( generalization793, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization794) :-
	spl_db( generalization794_a, Spl1 ),
	test_data( generalization794, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization795) :-
	spl_db( generalization795_a, Spl1 ),
	test_data( generalization795, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization796) :-
	spl_db( generalization796_a, Spl1 ),
	test_data( generalization796, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization797) :-
	spl_db( generalization797_a, Spl1 ),
	test_data( generalization797, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization798) :-
	spl_db( generalization798_a, Spl1 ),
	test_data( generalization798, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization799) :-
	spl_db( generalization799_a, Spl1 ),
	test_data( generalization799, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization800) :-
	spl_db( generalization800_a, Spl1 ),
	test_data( generalization800, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization801) :-
	spl_db( generalization801_a, Spl1 ),
	test_data( generalization801, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization802) :-
	spl_db( generalization802_a, Spl1 ),
	test_data( generalization802, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization803) :-
	spl_db( generalization803_a, Spl1 ),
	test_data( generalization803, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization804) :-
	spl_db( generalization804_a, Spl1 ),
	test_data( generalization804, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization805) :-
	spl_db( generalization805_a, Spl1 ),
	test_data( generalization805, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization806) :-
	spl_db( generalization806_a, Spl1 ),
	test_data( generalization806, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization807) :-
	spl_db( generalization807_a, Spl1 ),
	test_data( generalization807, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization808) :-
	spl_db( generalization808_a, Spl1 ),
	test_data( generalization808, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization809) :-
	spl_db( generalization809_a, Spl1 ),
	test_data( generalization809, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization810) :-
	spl_db( generalization810_a, Spl1 ),
	test_data( generalization810, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization811) :-
	spl_db( generalization811_a, Spl1 ),
	test_data( generalization811, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization812) :-
	spl_db( generalization812_a, Spl1 ),
	test_data( generalization812, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization813) :-
	spl_db( generalization813_a, Spl1 ),
	test_data( generalization813, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization814) :-
	spl_db( generalization814_a, Spl1 ),
	test_data( generalization814, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization815) :-
	spl_db( generalization815_a, Spl1 ),
	test_data( generalization815, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization816) :-
	spl_db( generalization816_a, Spl1 ),
	test_data( generalization816, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization817) :-
	spl_db( generalization817_a, Spl1 ),
	test_data( generalization817, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization818) :-
	spl_db( generalization818_a, Spl1 ),
	test_data( generalization818, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization819) :-
	spl_db( generalization819_a, Spl1 ),
	test_data( generalization819, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization820) :-
	spl_db( generalization820_a, Spl1 ),
	test_data( generalization820, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization821) :-
	spl_db( generalization821_a, Spl1 ),
	test_data( generalization821, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization822) :-
	spl_db( generalization822_a, Spl1 ),
	test_data( generalization822, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization823) :-
	spl_db( generalization823_a, Spl1 ),
	test_data( generalization823, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization824) :-
	spl_db( generalization824_a, Spl1 ),
	test_data( generalization824, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization825) :-
	spl_db( generalization825_a, Spl1 ),
	test_data( generalization825, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization826) :-
	spl_db( generalization826_a, Spl1 ),
	test_data( generalization826, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization827) :-
	spl_db( generalization827_a, Spl1 ),
	test_data( generalization827, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization828) :-
	spl_db( generalization828_a, Spl1 ),
	test_data( generalization828, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization829) :-
	spl_db( generalization829_a, Spl1 ),
	test_data( generalization829, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization830) :-
	spl_db( generalization830_a, Spl1 ),
	test_data( generalization830, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization831) :-
	spl_db( generalization831_a, Spl1 ),
	test_data( generalization831, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization832) :-
	spl_db( generalization832_a, Spl1 ),
	test_data( generalization832, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization833) :-
	spl_db( generalization833_a, Spl1 ),
	test_data( generalization833, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization834) :-
	spl_db( generalization834_a, Spl1 ),
	test_data( generalization834, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization835) :-
	spl_db( generalization835_a, Spl1 ),
	test_data( generalization835, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization836) :-
	spl_db( generalization836_a, Spl1 ),
	test_data( generalization836, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization837) :-
	spl_db( generalization837_a, Spl1 ),
	test_data( generalization837, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization838) :-
	spl_db( generalization838_a, Spl1 ),
	test_data( generalization838, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization839) :-
	spl_db( generalization839_a, Spl1 ),
	test_data( generalization839, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization840) :-
	spl_db( generalization840_a, Spl1 ),
	test_data( generalization840, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization841) :-
	spl_db( generalization841_a, Spl1 ),
	test_data( generalization841, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization842) :-
	spl_db( generalization842_a, Spl1 ),
	test_data( generalization842, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization843) :-
	spl_db( generalization843_a, Spl1 ),
	test_data( generalization843, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization844) :-
	spl_db( generalization844_a, Spl1 ),
	test_data( generalization844, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization845) :-
	spl_db( generalization845_a, Spl1 ),
	test_data( generalization845, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization846) :-
	spl_db( generalization846_a, Spl1 ),
	test_data( generalization846, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization847) :-
	spl_db( generalization847_a, Spl1 ),
	test_data( generalization847, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization848) :-
	spl_db( generalization848_a, Spl1 ),
	test_data( generalization848, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization849) :-
	spl_db( generalization849_a, Spl1 ),
	test_data( generalization849, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization850) :-
	spl_db( generalization850_a, Spl1 ),
	test_data( generalization850, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization851) :-
	spl_db( generalization851_a, Spl1 ),
	test_data( generalization851, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization852) :-
	spl_db( generalization852_a, Spl1 ),
	test_data( generalization852, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization853) :-
	spl_db( generalization853_a, Spl1 ),
	test_data( generalization853, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization854) :-
	spl_db( generalization854_a, Spl1 ),
	test_data( generalization854, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization855) :-
	spl_db( generalization855_a, Spl1 ),
	test_data( generalization855, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization856) :-
	spl_db( generalization856_a, Spl1 ),
	test_data( generalization856, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization857) :-
	spl_db( generalization857_a, Spl1 ),
	test_data( generalization857, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization858) :-
	spl_db( generalization858_a, Spl1 ),
	test_data( generalization858, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization859) :-
	spl_db( generalization859_a, Spl1 ),
	test_data( generalization859, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization860) :-
	spl_db( generalization860_a, Spl1 ),
	test_data( generalization860, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization861) :-
	spl_db( generalization861_a, Spl1 ),
	test_data( generalization861, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization862) :-
	spl_db( generalization862_a, Spl1 ),
	test_data( generalization862, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization863) :-
	spl_db( generalization863_a, Spl1 ),
	test_data( generalization863, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization864) :-
	spl_db( generalization864_a, Spl1 ),
	test_data( generalization864, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization865) :-
	spl_db( generalization865_a, Spl1 ),
	test_data( generalization865, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization866) :-
	spl_db( generalization866_a, Spl1 ),
	test_data( generalization866, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization867) :-
	spl_db( generalization867_a, Spl1 ),
	test_data( generalization867, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization868) :-
	spl_db( generalization868_a, Spl1 ),
	test_data( generalization868, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization869) :-
	spl_db( generalization869_a, Spl1 ),
	test_data( generalization869, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization870) :-
	spl_db( generalization870_a, Spl1 ),
	test_data( generalization870, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization871) :-
	spl_db( generalization871_a, Spl1 ),
	test_data( generalization871, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization872) :-
	spl_db( generalization872_a, Spl1 ),
	test_data( generalization872, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization873) :-
	spl_db( generalization873_a, Spl1 ),
	test_data( generalization873, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization874) :-
	spl_db( generalization874_a, Spl1 ),
	test_data( generalization874, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization875) :-
	spl_db( generalization875_a, Spl1 ),
	test_data( generalization875, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization876) :-
	spl_db( generalization876_a, Spl1 ),
	test_data( generalization876, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization877) :-
	spl_db( generalization877_a, Spl1 ),
	test_data( generalization877, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization878) :-
	spl_db( generalization878_a, Spl1 ),
	test_data( generalization878, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization879) :-
	spl_db( generalization879_a, Spl1 ),
	test_data( generalization879, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization880) :-
	spl_db( generalization880_a, Spl1 ),
	test_data( generalization880, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization881) :-
	spl_db( generalization881_a, Spl1 ),
	test_data( generalization881, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization882) :-
	spl_db( generalization882_a, Spl1 ),
	test_data( generalization882, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization883) :-
	spl_db( generalization883_a, Spl1 ),
	test_data( generalization883, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization884) :-
	spl_db( generalization884_a, Spl1 ),
	test_data( generalization884, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization885) :-
	spl_db( generalization885_a, Spl1 ),
	test_data( generalization885, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization886) :-
	spl_db( generalization886_a, Spl1 ),
	test_data( generalization886, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization887) :-
	spl_db( generalization887_a, Spl1 ),
	test_data( generalization887, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization888) :-
	spl_db( generalization888_a, Spl1 ),
	test_data( generalization888, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization889) :-
	spl_db( generalization889_a, Spl1 ),
	test_data( generalization889, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization890) :-
	spl_db( generalization890_a, Spl1 ),
	test_data( generalization890, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization891) :-
	spl_db( generalization891_a, Spl1 ),
	test_data( generalization891, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization892) :-
	spl_db( generalization892_a, Spl1 ),
	test_data( generalization892, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization893) :-
	spl_db( generalization893_a, Spl1 ),
	test_data( generalization893, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization894) :-
	spl_db( generalization894_a, Spl1 ),
	test_data( generalization894, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization895) :-
	spl_db( generalization895_a, Spl1 ),
	test_data( generalization895, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization896) :-
	spl_db( generalization896_a, Spl1 ),
	test_data( generalization896, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization897) :-
	spl_db( generalization897_a, Spl1 ),
	test_data( generalization897, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization898) :-
	spl_db( generalization898_a, Spl1 ),
	test_data( generalization898, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization899) :-
	spl_db( generalization899_a, Spl1 ),
	test_data( generalization899, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization900) :-
	spl_db( generalization900_a, Spl1 ),
	test_data( generalization900, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization901) :-
	spl_db( generalization901_a, Spl1 ),
	test_data( generalization901, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization902) :-
	spl_db( generalization902_a, Spl1 ),
	test_data( generalization902, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization903) :-
	spl_db( generalization903_a, Spl1 ),
	test_data( generalization903, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization904) :-
	spl_db( generalization904_a, Spl1 ),
	test_data( generalization904, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization905) :-
	spl_db( generalization905_a, Spl1 ),
	test_data( generalization905, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization906) :-
	spl_db( generalization906_a, Spl1 ),
	test_data( generalization906, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization907) :-
	spl_db( generalization907_a, Spl1 ),
	test_data( generalization907, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization908) :-
	spl_db( generalization908_a, Spl1 ),
	test_data( generalization908, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization909) :-
	spl_db( generalization909_a, Spl1 ),
	test_data( generalization909, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization910) :-
	spl_db( generalization910_a, Spl1 ),
	test_data( generalization910, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization911) :-
	spl_db( generalization911_a, Spl1 ),
	test_data( generalization911, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization912) :-
	spl_db( generalization912_a, Spl1 ),
	test_data( generalization912, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization913) :-
	spl_db( generalization913_a, Spl1 ),
	test_data( generalization913, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization914) :-
	spl_db( generalization914_a, Spl1 ),
	test_data( generalization914, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization915) :-
	spl_db( generalization915_a, Spl1 ),
	test_data( generalization915, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization916) :-
	spl_db( generalization916_a, Spl1 ),
	test_data( generalization916, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization917) :-
	spl_db( generalization917_a, Spl1 ),
	test_data( generalization917, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization918) :-
	spl_db( generalization918_a, Spl1 ),
	test_data( generalization918, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization919) :-
	spl_db( generalization919_a, Spl1 ),
	test_data( generalization919, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization920) :-
	spl_db( generalization920_a, Spl1 ),
	test_data( generalization920, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization921) :-
	spl_db( generalization921_a, Spl1 ),
	test_data( generalization921, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization922) :-
	spl_db( generalization922_a, Spl1 ),
	test_data( generalization922, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization923) :-
	spl_db( generalization923_a, Spl1 ),
	test_data( generalization923, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization924) :-
	spl_db( generalization924_a, Spl1 ),
	test_data( generalization924, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization925) :-
	spl_db( generalization925_a, Spl1 ),
	test_data( generalization925, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization926) :-
	spl_db( generalization926_a, Spl1 ),
	test_data( generalization926, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization927) :-
	spl_db( generalization927_a, Spl1 ),
	test_data( generalization927, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization928) :-
	spl_db( generalization928_a, Spl1 ),
	test_data( generalization928, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization929) :-
	spl_db( generalization929_a, Spl1 ),
	test_data( generalization929, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization930) :-
	spl_db( generalization930_a, Spl1 ),
	test_data( generalization930, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization931) :-
	spl_db( generalization931_a, Spl1 ),
	test_data( generalization931, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization932) :-
	spl_db( generalization932_a, Spl1 ),
	test_data( generalization932, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization933) :-
	spl_db( generalization933_a, Spl1 ),
	test_data( generalization933, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization934) :-
	spl_db( generalization934_a, Spl1 ),
	test_data( generalization934, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization935) :-
	spl_db( generalization935_a, Spl1 ),
	test_data( generalization935, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization936) :-
	spl_db( generalization936_a, Spl1 ),
	test_data( generalization936, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization937) :-
	spl_db( generalization937_a, Spl1 ),
	test_data( generalization937, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization938) :-
	spl_db( generalization938_a, Spl1 ),
	test_data( generalization938, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization939) :-
	spl_db( generalization939_a, Spl1 ),
	test_data( generalization939, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization940) :-
	spl_db( generalization940_a, Spl1 ),
	test_data( generalization940, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization941) :-
	spl_db( generalization941_a, Spl1 ),
	test_data( generalization941, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization942) :-
	spl_db( generalization942_a, Spl1 ),
	test_data( generalization942, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization943) :-
	spl_db( generalization943_a, Spl1 ),
	test_data( generalization943, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization944) :-
	spl_db( generalization944_a, Spl1 ),
	test_data( generalization944, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization945) :-
	spl_db( generalization945_a, Spl1 ),
	test_data( generalization945, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization946) :-
	spl_db( generalization946_a, Spl1 ),
	test_data( generalization946, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization947) :-
	spl_db( generalization947_a, Spl1 ),
	test_data( generalization947, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization948) :-
	spl_db( generalization948_a, Spl1 ),
	test_data( generalization948, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization949) :-
	spl_db( generalization949_a, Spl1 ),
	test_data( generalization949, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization950) :-
	spl_db( generalization950_a, Spl1 ),
	test_data( generalization950, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization951) :-
	spl_db( generalization951_a, Spl1 ),
	test_data( generalization951, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization952) :-
	spl_db( generalization952_a, Spl1 ),
	test_data( generalization952, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization953) :-
	spl_db( generalization953_a, Spl1 ),
	test_data( generalization953, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization954) :-
	spl_db( generalization954_a, Spl1 ),
	test_data( generalization954, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization955) :-
	spl_db( generalization955_a, Spl1 ),
	test_data( generalization955, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization956) :-
	spl_db( generalization956_a, Spl1 ),
	test_data( generalization956, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization957) :-
	spl_db( generalization957_a, Spl1 ),
	test_data( generalization957, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization958) :-
	spl_db( generalization958_a, Spl1 ),
	test_data( generalization958, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization959) :-
	spl_db( generalization959_a, Spl1 ),
	test_data( generalization959, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization960) :-
	spl_db( generalization960_a, Spl1 ),
	test_data( generalization960, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization961) :-
	spl_db( generalization961_a, Spl1 ),
	test_data( generalization961, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization962) :-
	spl_db( generalization962_a, Spl1 ),
	test_data( generalization962, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization963) :-
	spl_db( generalization963_a, Spl1 ),
	test_data( generalization963, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization964) :-
	spl_db( generalization964_a, Spl1 ),
	test_data( generalization964, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization965) :-
	spl_db( generalization965_a, Spl1 ),
	test_data( generalization965, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization966) :-
	spl_db( generalization966_a, Spl1 ),
	test_data( generalization966, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization967) :-
	spl_db( generalization967_a, Spl1 ),
	test_data( generalization967, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization968) :-
	spl_db( generalization968_a, Spl1 ),
	test_data( generalization968, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization969) :-
	spl_db( generalization969_a, Spl1 ),
	test_data( generalization969, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization970) :-
	spl_db( generalization970_a, Spl1 ),
	test_data( generalization970, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization971) :-
	spl_db( generalization971_a, Spl1 ),
	test_data( generalization971, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization972) :-
	spl_db( generalization972_a, Spl1 ),
	test_data( generalization972, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization973) :-
	spl_db( generalization973_a, Spl1 ),
	test_data( generalization973, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization974) :-
	spl_db( generalization974_a, Spl1 ),
	test_data( generalization974, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization975) :-
	spl_db( generalization975_a, Spl1 ),
	test_data( generalization975, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization976) :-
	spl_db( generalization976_a, Spl1 ),
	test_data( generalization976, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization977) :-
	spl_db( generalization977_a, Spl1 ),
	test_data( generalization977, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization978) :-
	spl_db( generalization978_a, Spl1 ),
	test_data( generalization978, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization979) :-
	spl_db( generalization979_a, Spl1 ),
	test_data( generalization979, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization980) :-
	spl_db( generalization980_a, Spl1 ),
	test_data( generalization980, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization981) :-
	spl_db( generalization981_a, Spl1 ),
	test_data( generalization981, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization982) :-
	spl_db( generalization982_a, Spl1 ),
	test_data( generalization982, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization983) :-
	spl_db( generalization983_a, Spl1 ),
	test_data( generalization983, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization984) :-
	spl_db( generalization984_a, Spl1 ),
	test_data( generalization984, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization985) :-
	spl_db( generalization985_a, Spl1 ),
	test_data( generalization985, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization986) :-
	spl_db( generalization986_a, Spl1 ),
	test_data( generalization986, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization987) :-
	spl_db( generalization987_a, Spl1 ),
	test_data( generalization987, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization988) :-
	spl_db( generalization988_a, Spl1 ),
	test_data( generalization988, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization989) :-
	spl_db( generalization989_a, Spl1 ),
	test_data( generalization989, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization990) :-
	spl_db( generalization990_a, Spl1 ),
	test_data( generalization990, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization991) :-
	spl_db( generalization991_a, Spl1 ),
	test_data( generalization991, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization992) :-
	spl_db( generalization992_a, Spl1 ),
	test_data( generalization992, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization993) :-
	spl_db( generalization993_a, Spl1 ),
	test_data( generalization993, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization994) :-
	spl_db( generalization994_a, Spl1 ),
	test_data( generalization994, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization995) :-
	spl_db( generalization995_a, Spl1 ),
	test_data( generalization995, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization996) :-
	spl_db( generalization996_a, Spl1 ),
	test_data( generalization996, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization997) :-
	spl_db( generalization997_a, Spl1 ),
	test_data( generalization997, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization998) :-
	spl_db( generalization998_a, Spl1 ),
	test_data( generalization998, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

test(generalization999) :-
	spl_db( generalization999_a, Spl1 ),
	test_data( generalization999, generalization, Spl_Name, Expected_result),
	spl_db( Spl_Name, Spl2),
	isGeneralisedSpl(Spl1,Spl2,Expected_result), !.

:- end_tests(generalization).